import t from "@firebase/app";

import { Logger as e, LogLevel as s } from "@firebase/logger";

import { getUA as n, isMobileCordova as i, isReactNative as r, isElectron as o, isIE as h, isUWP as a, isBrowserExtension as u } from "@firebase/util";

import { Component as c } from "@firebase/component";

import { XhrIo as _, EventType as l, ErrorCode as d, createWebChannelTransport as f, WebChannel as T } from "@firebase/webchannel-wrapper";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** The semver (www.semver.org) version of the SDK. */ const m = t.SDK_VERSION;

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Simple wrapper around a nullable UID. Mostly exists to make code more
 * readable.
 */ class E {
    constructor(t) {
        this.uid = t;
    }
    t() {
        return null != this.uid;
    }
    /**
     * Returns a key representing this user, suitable for inclusion in a
     * dictionary.
     */    s() {
        return this.t() ? "uid:" + this.uid : "anonymous-user";
    }
    isEqual(t) {
        return t.uid === this.uid;
    }
}

/** A user with a null UID. */ E.UNAUTHENTICATED = new E(null), 
// TODO(mikelehen): Look into getting a proper uid-equivalent for
// non-FirebaseAuth providers.
E.i = new E("google-credentials-uid"), E.o = new E("first-party-uid");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const w = {
    // Causes are copied from:
    // https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
    /** Not an error; returned on success. */
    OK: "ok",
    /** The operation was cancelled (typically by the caller). */
    CANCELLED: "cancelled",
    /** Unknown error or an error from a different error domain. */
    UNKNOWN: "unknown",
    /**
     * Client specified an invalid argument. Note that this differs from
     * FAILED_PRECONDITION. INVALID_ARGUMENT indicates arguments that are
     * problematic regardless of the state of the system (e.g., a malformed file
     * name).
     */
    INVALID_ARGUMENT: "invalid-argument",
    /**
     * Deadline expired before operation could complete. For operations that
     * change the state of the system, this error may be returned even if the
     * operation has completed successfully. For example, a successful response
     * from a server could have been delayed long enough for the deadline to
     * expire.
     */
    DEADLINE_EXCEEDED: "deadline-exceeded",
    /** Some requested entity (e.g., file or directory) was not found. */
    NOT_FOUND: "not-found",
    /**
     * Some entity that we attempted to create (e.g., file or directory) already
     * exists.
     */
    ALREADY_EXISTS: "already-exists",
    /**
     * The caller does not have permission to execute the specified operation.
     * PERMISSION_DENIED must not be used for rejections caused by exhausting
     * some resource (use RESOURCE_EXHAUSTED instead for those errors).
     * PERMISSION_DENIED must not be used if the caller can not be identified
     * (use UNAUTHENTICATED instead for those errors).
     */
    PERMISSION_DENIED: "permission-denied",
    /**
     * The request does not have valid authentication credentials for the
     * operation.
     */
    UNAUTHENTICATED: "unauthenticated",
    /**
     * Some resource has been exhausted, perhaps a per-user quota, or perhaps the
     * entire file system is out of space.
     */
    RESOURCE_EXHAUSTED: "resource-exhausted",
    /**
     * Operation was rejected because the system is not in a state required for
     * the operation's execution. For example, directory to be deleted may be
     * non-empty, an rmdir operation is applied to a non-directory, etc.
     *
     * A litmus test that may help a service implementor in deciding
     * between FAILED_PRECONDITION, ABORTED, and UNAVAILABLE:
     *  (a) Use UNAVAILABLE if the client can retry just the failing call.
     *  (b) Use ABORTED if the client should retry at a higher-level
     *      (e.g., restarting a read-modify-write sequence).
     *  (c) Use FAILED_PRECONDITION if the client should not retry until
     *      the system state has been explicitly fixed. E.g., if an "rmdir"
     *      fails because the directory is non-empty, FAILED_PRECONDITION
     *      should be returned since the client should not retry unless
     *      they have first fixed up the directory by deleting files from it.
     *  (d) Use FAILED_PRECONDITION if the client performs conditional
     *      REST Get/Update/Delete on a resource and the resource on the
     *      server does not match the condition. E.g., conflicting
     *      read-modify-write on the same resource.
     */
    FAILED_PRECONDITION: "failed-precondition",
    /**
     * The operation was aborted, typically due to a concurrency issue like
     * sequencer check failures, transaction aborts, etc.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    ABORTED: "aborted",
    /**
     * Operation was attempted past the valid range. E.g., seeking or reading
     * past end of file.
     *
     * Unlike INVALID_ARGUMENT, this error indicates a problem that may be fixed
     * if the system state changes. For example, a 32-bit file system will
     * generate INVALID_ARGUMENT if asked to read at an offset that is not in the
     * range [0,2^32-1], but it will generate OUT_OF_RANGE if asked to read from
     * an offset past the current file size.
     *
     * There is a fair bit of overlap between FAILED_PRECONDITION and
     * OUT_OF_RANGE. We recommend using OUT_OF_RANGE (the more specific error)
     * when it applies so that callers who are iterating through a space can
     * easily look for an OUT_OF_RANGE error to detect when they are done.
     */
    OUT_OF_RANGE: "out-of-range",
    /** Operation is not implemented or not supported/enabled in this service. */
    UNIMPLEMENTED: "unimplemented",
    /**
     * Internal errors. Means some invariants expected by underlying System has
     * been broken. If you see one of these errors, Something is very broken.
     */
    INTERNAL: "internal",
    /**
     * The service is currently unavailable. This is a most likely a transient
     * condition and may be corrected by retrying with a backoff.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    UNAVAILABLE: "unavailable",
    /** Unrecoverable data loss or corruption. */
    DATA_LOSS: "data-loss"
};

/**
 * An error class used for Firestore-generated errors. Ideally we should be
 * using FirebaseError, but integrating with it is overly arduous at the moment,
 * so we define our own compatible error class (with a `name` of 'FirebaseError'
 * and compatible `code` and `message` fields.)
 */ class I extends Error {
    constructor(t, e) {
        super(e), this.code = t, this.message = e, this.name = "FirebaseError", 
        // HACK: We write a toString property directly because Error is not a real
        // class and so inheritance does not work correctly. We could alternatively
        // do the same "back-door inheritance" trick that FirebaseError does.
        this.toString = () => `${this.name}: [code=${this.code}]: ${this.message}`;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class R {
    constructor(t, e) {
        this.user = e, this.type = "OAuth", this.h = {}, 
        // Set the headers using Object Literal notation to avoid minification
        this.h.Authorization = `Bearer ${t}`;
    }
}

/** A CredentialsProvider that always yields an empty token. */ class A {
    constructor() {
        /**
         * Stores the listener registered with setChangeListener()
         * This isn't actually necessary since the UID never changes, but we use this
         * to verify the listen contract is adhered to in tests.
         */
        this.u = null;
    }
    getToken() {
        return Promise.resolve(null);
    }
    _() {}
    l(t) {
        this.u = t, 
        // Fire with initial user.
        t(E.UNAUTHENTICATED);
    }
    T() {
        this.u = null;
    }
}

class P {
    constructor(t) {
        /**
         * The auth token listener registered with FirebaseApp, retained here so we
         * can unregister it.
         */
        this.m = null, 
        /** Tracks the current User. */
        this.currentUser = E.UNAUTHENTICATED, this.I = !1, 
        /**
         * Counter used to detect if the token changed while a getToken request was
         * outstanding.
         */
        this.R = 0, 
        /** The listener registered with setChangeListener(). */
        this.u = null, this.forceRefresh = !1, this.m = () => {
            this.R++, this.currentUser = this.A(), this.I = !0, this.u && this.u(this.currentUser);
        }, this.R = 0, this.auth = t.getImmediate({
            optional: !0
        }), this.auth ? this.auth.addAuthTokenListener(this.m) : (
        // if auth is not available, invoke tokenListener once with null token
        this.m(null), t.get().then(t => {
            this.auth = t, this.m && 
            // tokenListener can be removed by removeChangeListener()
            this.auth.addAuthTokenListener(this.m);
        }, () => {}));
    }
    getToken() {
        // Take note of the current value of the tokenCounter so that this method
        // can fail (with an ABORTED error) if there is a token change while the
        // request is outstanding.
        const t = this.R, e = this.forceRefresh;
        return this.forceRefresh = !1, this.auth ? this.auth.getToken(e).then(e => {
            // Cancel the request since the token changed while the request was
            // outstanding so the response is potentially for a previous user (which
            // user, we can't be sure).
            if (this.R !== t) throw new I(w.ABORTED, "getToken aborted due to token change.");
            return e ? (Ce("string" == typeof e.accessToken, "Invalid tokenData returned from getToken():" + e), 
            new R(e.accessToken, this.currentUser)) : null;
        }) : Promise.resolve(null);
    }
    _() {
        this.forceRefresh = !0;
    }
    l(t) {
        this.u = t, 
        // Fire the initial event
        this.I && t(this.currentUser);
    }
    T() {
        this.auth && this.auth.removeAuthTokenListener(this.m), this.m = null, this.u = null;
    }
    // Auth.getUid() can return null even with a user logged in. It is because
    // getUid() is synchronous, but the auth code populating Uid is asynchronous.
    // This method should only be called in the AuthTokenListener callback
    // to guarantee to get the actual user.
    A() {
        const t = this.auth && this.auth.getUid();
        return Ce(null === t || "string" == typeof t, "Received invalid UID: " + t), new E(t);
    }
}

/*
 * FirstPartyToken provides a fresh token each time its value
 * is requested, because if the token is too old, requests will be rejected.
 * Technically this may no longer be necessary since the SDK should gracefully
 * recover from unauthenticated errors (see b/33147818 for context), but it's
 * safer to keep the implementation as-is.
 */ class V {
    constructor(t, e) {
        this.P = t, this.V = e, this.type = "FirstParty", this.user = E.o;
    }
    get h() {
        const t = {
            "X-Goog-AuthUser": this.V
        }, e = this.P.auth.g([]);
        return e && (t.Authorization = e), t;
    }
}

/*
 * Provides user credentials required for the Firestore JavaScript SDK
 * to authenticate the user, using technique that is only available
 * to applications hosted by Google.
 */ class g {
    constructor(t, e) {
        this.P = t, this.V = e;
    }
    getToken() {
        return Promise.resolve(new V(this.P, this.V));
    }
    l(t) {
        // Fire with initial uid.
        t(E.o);
    }
    T() {}
    _() {}
}

/**
 * Builds a CredentialsProvider depending on the type of
 * the credentials passed in.
 */ class p {
    constructor(t, e) {
        if (this.seconds = t, this.nanoseconds = e, e < 0) throw new I(w.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        if (e >= 1e9) throw new I(w.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        if (t < -62135596800) throw new I(w.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
        // This will break in the year 10,000.
                if (t >= 253402300800) throw new I(w.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
    }
    static now() {
        return p.fromMillis(Date.now());
    }
    static fromDate(t) {
        return p.fromMillis(t.getTime());
    }
    static fromMillis(t) {
        const e = Math.floor(t / 1e3);
        return new p(e, 1e6 * (t - 1e3 * e));
    }
    toDate() {
        return new Date(this.toMillis());
    }
    toMillis() {
        return 1e3 * this.seconds + this.nanoseconds / 1e6;
    }
    p(t) {
        return this.seconds === t.seconds ? Ne(this.nanoseconds, t.nanoseconds) : Ne(this.seconds, t.seconds);
    }
    isEqual(t) {
        return t.seconds === this.seconds && t.nanoseconds === this.nanoseconds;
    }
    toString() {
        return "Timestamp(seconds=" + this.seconds + ", nanoseconds=" + this.nanoseconds + ")";
    }
    valueOf() {
        // This method returns a string of the form <seconds>.<nanoseconds> where <seconds> is
        // translated to have a non-negative value and both <seconds> and <nanoseconds> are left-padded
        // with zeroes to be a consistent length. Strings with this format then have a lexiographical
        // ordering that matches the expected ordering. The <seconds> translation is done to avoid
        // having a leading negative sign (i.e. a leading '-' character) in its string representation,
        // which would affect its lexiographical ordering.
        const t = this.seconds - -62135596800;
        // Note: Up to 12 decimal digits are required to represent all valid 'seconds' values.
                return String(t).padStart(12, "0") + "." + String(this.nanoseconds).padStart(9, "0");
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A version of a document in Firestore. This corresponds to the version
 * timestamp, such as update_time or read_time.
 */ class y {
    constructor(t) {
        this.timestamp = t;
    }
    static v(t) {
        return new y(t);
    }
    static S() {
        return y.MIN;
    }
    D(t) {
        return this.timestamp.p(t.timestamp);
    }
    isEqual(t) {
        return this.timestamp.isEqual(t.timestamp);
    }
    /** Returns a number representation of the version for use in spec tests. */    C() {
        // Convert to microseconds.
        return 1e6 * this.timestamp.seconds + this.timestamp.nanoseconds / 1e3;
    }
    toString() {
        return "SnapshotVersion(" + this.timestamp.toString() + ")";
    }
    k() {
        return this.timestamp;
    }
}

y.MIN = new y(new p(0, 0));

/**
 * Path represents an ordered sequence of string segments.
 */
class b {
    constructor(t, e, s) {
        void 0 === e ? e = 0 : e > t.length && De("offset " + e + " out of range " + t.length), 
        void 0 === s ? s = t.length - e : s > t.length - e && De("length " + s + " out of range " + (t.length - e)), 
        this.segments = t, this.offset = e, this.N = s;
    }
    get length() {
        return this.N;
    }
    isEqual(t) {
        return 0 === b.F(this, t);
    }
    child(t) {
        const e = this.segments.slice(this.offset, this.limit());
        return t instanceof b ? t.forEach(t => {
            e.push(t);
        }) : e.push(t), this.$(e);
    }
    /** The index of one past the last segment of the path. */    limit() {
        return this.offset + this.length;
    }
    M(t) {
        return t = void 0 === t ? 1 : t, this.$(this.segments, this.offset + t, this.length - t);
    }
    L() {
        return this.$(this.segments, this.offset, this.length - 1);
    }
    O() {
        return this.segments[this.offset];
    }
    B() {
        return this.get(this.length - 1);
    }
    get(t) {
        return this.segments[this.offset + t];
    }
    U() {
        return 0 === this.length;
    }
    q(t) {
        if (t.length < this.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    W(t) {
        if (this.length + 1 !== t.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    forEach(t) {
        for (let e = this.offset, s = this.limit(); e < s; e++) t(this.segments[e]);
    }
    j() {
        return this.segments.slice(this.offset, this.limit());
    }
    static F(t, e) {
        const s = Math.min(t.length, e.length);
        for (let n = 0; n < s; n++) {
            const s = t.get(n), i = e.get(n);
            if (s < i) return -1;
            if (s > i) return 1;
        }
        return t.length < e.length ? -1 : t.length > e.length ? 1 : 0;
    }
}

/**
 * A slash-separated path for navigating resources (documents and collections)
 * within Firestore.
 */ class v extends b {
    $(t, e, s) {
        return new v(t, e, s);
    }
    K() {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        return this.j().join("/");
    }
    toString() {
        return this.K();
    }
    /**
     * Creates a resource path from the given slash-delimited string.
     */    static G(t) {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        if (t.indexOf("//") >= 0) throw new I(w.INVALID_ARGUMENT, `Invalid path (${t}). Paths must not contain // in them.`);
        // We may still have an empty segment at the beginning or end if they had a
        // leading or trailing slash (which we allow).
                const e = t.split("/").filter(t => t.length > 0);
        return new v(e);
    }
}

v.H = new v([]);

const S = /^[_a-zA-Z][_a-zA-Z0-9]*$/;

/** A dot-separated path for navigating sub-objects within a document. */ class D extends b {
    $(t, e, s) {
        return new D(t, e, s);
    }
    /**
     * Returns true if the string could be used as a segment in a field path
     * without escaping.
     */    static J(t) {
        return S.test(t);
    }
    K() {
        return this.j().map(t => (t = t.replace("\\", "\\\\").replace("`", "\\`"), D.J(t) || (t = "`" + t + "`"), 
        t)).join(".");
    }
    toString() {
        return this.K();
    }
    /**
     * Returns true if this field references the key of a document.
     */    Y() {
        return 1 === this.length && "__name__" === this.get(0);
    }
    /**
     * The field designating the key of a document.
     */    static X() {
        return new D([ "__name__" ]);
    }
    /**
     * Parses a field string from the given server-formatted string.
     *
     * - Splitting the empty string is not allowed (for now at least).
     * - Empty segments within the string (e.g. if there are two consecutive
     *   separators) are not allowed.
     *
     * TODO(b/37244157): we should make this more strict. Right now, it allows
     * non-identifier path components, even if they aren't escaped.
     */    static Z(t) {
        const e = [];
        let s = "", n = 0;
        const i = () => {
            if (0 === s.length) throw new I(w.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, begin ` + "with '.', end with '.', or contain '..'");
            e.push(s), s = "";
        };
        let r = !1;
        for (;n < t.length; ) {
            const e = t[n];
            if ("\\" === e) {
                if (n + 1 === t.length) throw new I(w.INVALID_ARGUMENT, "Path has trailing escape character: " + t);
                const e = t[n + 1];
                if ("\\" !== e && "." !== e && "`" !== e) throw new I(w.INVALID_ARGUMENT, "Path has invalid escape sequence: " + t);
                s += e, n += 2;
            } else "`" === e ? (r = !r, n++) : "." !== e || r ? (s += e, n++) : (i(), n++);
        }
        if (i(), r) throw new I(w.INVALID_ARGUMENT, "Unterminated ` in path: " + t);
        return new D(e);
    }
}

D.H = new D([]);

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class C {
    constructor(t) {
        this.path = t;
    }
    static tt(t) {
        return new C(v.G(t).M(5));
    }
    /** Returns true if the document is in the specified collectionId. */    et(t) {
        return this.path.length >= 2 && this.path.get(this.path.length - 2) === t;
    }
    isEqual(t) {
        return null !== t && 0 === v.F(this.path, t.path);
    }
    toString() {
        return this.path.toString();
    }
    static F(t, e) {
        return v.F(t.path, e.path);
    }
    static st(t) {
        return t.length % 2 == 0;
    }
    /**
     * Creates and returns a new document key with the given segments.
     *
     * @param segments The segments of the path to the document
     * @return A new instance of DocumentKey
     */    static nt(t) {
        return new C(new v(t.slice()));
    }
}

C.EMPTY = new C(new v([]));

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// An immutable sorted map implementation, based on a Left-leaning Red-Black
// tree.
class k {
    constructor(t, e) {
        this.F = t, this.root = e || F.EMPTY;
    }
    // Returns a copy of the map, with the specified key/value added or replaced.
    it(t, e) {
        return new k(this.F, this.root.it(t, e, this.F).rt(null, null, F.ot, null, null));
    }
    // Returns a copy of the map, with the specified key removed.
    remove(t) {
        return new k(this.F, this.root.remove(t, this.F).rt(null, null, F.ot, null, null));
    }
    // Returns the value of the node with the given key, or null.
    get(t) {
        let e = this.root;
        for (;!e.U(); ) {
            const s = this.F(t, e.key);
            if (0 === s) return e.value;
            s < 0 ? e = e.left : s > 0 && (e = e.right);
        }
        return null;
    }
    // Returns the index of the element in this sorted map, or -1 if it doesn't
    // exist.
    indexOf(t) {
        // Number of nodes that were pruned when descending right
        let e = 0, s = this.root;
        for (;!s.U(); ) {
            const n = this.F(t, s.key);
            if (0 === n) return e + s.left.size;
            n < 0 ? s = s.left : (
            // Count all nodes left of the node plus the node itself
            e += s.left.size + 1, s = s.right);
        }
        // Node not found
                return -1;
    }
    U() {
        return this.root.U();
    }
    // Returns the total number of nodes in the map.
    get size() {
        return this.root.size;
    }
    // Returns the minimum key in the map.
    ht() {
        return this.root.ht();
    }
    // Returns the maximum key in the map.
    at() {
        return this.root.at();
    }
    // Traverses the map in key order and calls the specified action function
    // for each key/value pair. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ut(t) {
        return this.root.ut(t);
    }
    forEach(t) {
        this.ut((e, s) => (t(e, s), !1));
    }
    toString() {
        const t = [];
        return this.ut((e, s) => (t.push(`${e}:${s}`), !1)), `{${t.join(", ")}}`;
    }
    // Traverses the map in reverse key order and calls the specified action
    // function for each key/value pair. If action returns true, traversal is
    // aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ct(t) {
        return this.root.ct(t);
    }
    // Returns an iterator over the SortedMap.
    _t() {
        return new N(this.root, null, this.F, !1);
    }
    lt(t) {
        return new N(this.root, t, this.F, !1);
    }
    dt() {
        return new N(this.root, null, this.F, !0);
    }
    ft(t) {
        return new N(this.root, t, this.F, !0);
    }
}

 // end SortedMap
// An iterator over an LLRBNode.
class N {
    constructor(t, e, s, n) {
        this.Tt = n, this.Et = [];
        let i = 1;
        for (;!t.U(); ) if (i = e ? s(t.key, e) : 1, 
        // flip the comparison if we're going in reverse
        n && (i *= -1), i < 0) 
        // This node is less than our start key. ignore it
        t = this.Tt ? t.left : t.right; else {
            if (0 === i) {
                // This node is exactly equal to our start key. Push it on the stack,
                // but stop iterating;
                this.Et.push(t);
                break;
            }
            // This node is greater than our start key, add it to the stack and move
            // to the next one
            this.Et.push(t), t = this.Tt ? t.right : t.left;
        }
    }
    wt() {
        let t = this.Et.pop();
        const e = {
            key: t.key,
            value: t.value
        };
        if (this.Tt) for (t = t.left; !t.U(); ) this.Et.push(t), t = t.right; else for (t = t.right; !t.U(); ) this.Et.push(t), 
        t = t.left;
        return e;
    }
    It() {
        return this.Et.length > 0;
    }
    Rt() {
        if (0 === this.Et.length) return null;
        const t = this.Et[this.Et.length - 1];
        return {
            key: t.key,
            value: t.value
        };
    }
}

 // end SortedMapIterator
// Represents a node in a Left-leaning Red-Black tree.
class F {
    constructor(t, e, s, n, i) {
        this.key = t, this.value = e, this.color = null != s ? s : F.RED, this.left = null != n ? n : F.EMPTY, 
        this.right = null != i ? i : F.EMPTY, this.size = this.left.size + 1 + this.right.size;
    }
    // Returns a copy of the current node, optionally replacing pieces of it.
    rt(t, e, s, n, i) {
        return new F(null != t ? t : this.key, null != e ? e : this.value, null != s ? s : this.color, null != n ? n : this.left, null != i ? i : this.right);
    }
    U() {
        return !1;
    }
    // Traverses the tree in key order and calls the specified action function
    // for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ut(t) {
        return this.left.ut(t) || t(this.key, this.value) || this.right.ut(t);
    }
    // Traverses the tree in reverse key order and calls the specified action
    // function for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ct(t) {
        return this.right.ct(t) || t(this.key, this.value) || this.left.ct(t);
    }
    // Returns the minimum node in the tree.
    min() {
        return this.left.U() ? this : this.left.min();
    }
    // Returns the maximum key in the tree.
    ht() {
        return this.min().key;
    }
    // Returns the maximum key in the tree.
    at() {
        return this.right.U() ? this.key : this.right.at();
    }
    // Returns new tree, with the key/value added.
    it(t, e, s) {
        let n = this;
        const i = s(t, n.key);
        return n = i < 0 ? n.rt(null, null, null, n.left.it(t, e, s), null) : 0 === i ? n.rt(null, e, null, null, null) : n.rt(null, null, null, null, n.right.it(t, e, s)), 
        n.At();
    }
    Pt() {
        if (this.left.U()) return F.EMPTY;
        let t = this;
        return t.left.Vt() || t.left.left.Vt() || (t = t.gt()), t = t.rt(null, null, null, t.left.Pt(), null), 
        t.At();
    }
    // Returns new tree, with the specified item removed.
    remove(t, e) {
        let s, n = this;
        if (e(t, n.key) < 0) n.left.U() || n.left.Vt() || n.left.left.Vt() || (n = n.gt()), 
        n = n.rt(null, null, null, n.left.remove(t, e), null); else {
            if (n.left.Vt() && (n = n.pt()), n.right.U() || n.right.Vt() || n.right.left.Vt() || (n = n.yt()), 
            0 === e(t, n.key)) {
                if (n.right.U()) return F.EMPTY;
                s = n.right.min(), n = n.rt(s.key, s.value, null, null, n.right.Pt());
            }
            n = n.rt(null, null, null, null, n.right.remove(t, e));
        }
        return n.At();
    }
    Vt() {
        return this.color;
    }
    // Returns new tree after performing any needed rotations.
    At() {
        let t = this;
        return t.right.Vt() && !t.left.Vt() && (t = t.bt()), t.left.Vt() && t.left.left.Vt() && (t = t.pt()), 
        t.left.Vt() && t.right.Vt() && (t = t.vt()), t;
    }
    gt() {
        let t = this.vt();
        return t.right.left.Vt() && (t = t.rt(null, null, null, null, t.right.pt()), t = t.bt(), 
        t = t.vt()), t;
    }
    yt() {
        let t = this.vt();
        return t.left.left.Vt() && (t = t.pt(), t = t.vt()), t;
    }
    bt() {
        const t = this.rt(null, null, F.RED, null, this.right.left);
        return this.right.rt(null, null, this.color, t, null);
    }
    pt() {
        const t = this.rt(null, null, F.RED, this.left.right, null);
        return this.left.rt(null, null, this.color, null, t);
    }
    vt() {
        const t = this.left.rt(null, null, !this.left.color, null, null), e = this.right.rt(null, null, !this.right.color, null, null);
        return this.rt(null, null, !this.color, t, e);
    }
    // For testing.
    St() {
        const t = this.Dt();
        return Math.pow(2, t) <= this.size + 1;
    }
    // In a balanced RB tree, the black-depth (number of black nodes) from root to
    // leaves is equal on both sides.  This function verifies that or asserts.
    Dt() {
        if (this.Vt() && this.left.Vt()) throw De("Red node has red child(" + this.key + "," + this.value + ")");
        if (this.right.Vt()) throw De("Right child of (" + this.key + "," + this.value + ") is red");
        const t = this.left.Dt();
        if (t !== this.right.Dt()) throw De("Black depths differ");
        return t + (this.Vt() ? 0 : 1);
    }
}

 // end LLRBNode
// Empty node is shared between all LLRB trees.
// eslint-disable-next-line @typescript-eslint/no-explicit-any
F.EMPTY = null, F.RED = !0, F.ot = !1;

// end LLRBEmptyNode
F.EMPTY = new 
// Represents an empty node (a leaf node in the Red-Black Tree).
class {
    constructor() {
        this.size = 0;
    }
    get key() {
        throw De("LLRBEmptyNode has no key.");
    }
    get value() {
        throw De("LLRBEmptyNode has no value.");
    }
    get color() {
        throw De("LLRBEmptyNode has no color.");
    }
    get left() {
        throw De("LLRBEmptyNode has no left child.");
    }
    get right() {
        throw De("LLRBEmptyNode has no right child.");
    }
    // Returns a copy of the current node.
    rt(t, e, s, n, i) {
        return this;
    }
    // Returns a copy of the tree, with the specified key/value added.
    it(t, e, s) {
        return new F(t, e);
    }
    // Returns a copy of the tree, with the specified key removed.
    remove(t, e) {
        return this;
    }
    U() {
        return !0;
    }
    ut(t) {
        return !1;
    }
    ct(t) {
        return !1;
    }
    ht() {
        return null;
    }
    at() {
        return null;
    }
    Vt() {
        return !1;
    }
    // For testing.
    St() {
        return !0;
    }
    Dt() {
        return 0;
    }
};

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * SortedSet is an immutable (copy-on-write) collection that holds elements
 * in order specified by the provided comparator.
 *
 * NOTE: if provided comparator returns 0 for two elements, we consider them to
 * be equal!
 */
class $ {
    constructor(t) {
        this.F = t, this.data = new k(this.F);
    }
    has(t) {
        return null !== this.data.get(t);
    }
    first() {
        return this.data.ht();
    }
    last() {
        return this.data.at();
    }
    get size() {
        return this.data.size;
    }
    indexOf(t) {
        return this.data.indexOf(t);
    }
    /** Iterates elements in order defined by "comparator" */    forEach(t) {
        this.data.ut((e, s) => (t(e), !1));
    }
    /** Iterates over `elem`s such that: range[0] <= elem < range[1]. */    Ct(t, e) {
        const s = this.data.lt(t[0]);
        for (;s.It(); ) {
            const n = s.wt();
            if (this.F(n.key, t[1]) >= 0) return;
            e(n.key);
        }
    }
    /**
     * Iterates over `elem`s such that: start <= elem until false is returned.
     */    kt(t, e) {
        let s;
        for (s = void 0 !== e ? this.data.lt(e) : this.data._t(); s.It(); ) {
            if (!t(s.wt().key)) return;
        }
    }
    /** Finds the least element greater than or equal to `elem`. */    Nt(t) {
        const e = this.data.lt(t);
        return e.It() ? e.wt().key : null;
    }
    _t() {
        return new M(this.data._t());
    }
    lt(t) {
        return new M(this.data.lt(t));
    }
    /** Inserts or updates an element */    add(t) {
        return this.rt(this.data.remove(t).it(t, !0));
    }
    /** Deletes an element */    delete(t) {
        return this.has(t) ? this.rt(this.data.remove(t)) : this;
    }
    U() {
        return this.data.U();
    }
    Ft(t) {
        let e = this;
        // Make sure `result` always refers to the larger one of the two sets.
                return e.size < t.size && (e = t, t = this), t.forEach(t => {
            e = e.add(t);
        }), e;
    }
    isEqual(t) {
        if (!(t instanceof $)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.data._t(), s = t.data._t();
        for (;e.It(); ) {
            const t = e.wt().key, n = s.wt().key;
            if (0 !== this.F(t, n)) return !1;
        }
        return !0;
    }
    j() {
        const t = [];
        return this.forEach(e => {
            t.push(e);
        }), t;
    }
    toString() {
        const t = [];
        return this.forEach(e => t.push(e)), "SortedSet(" + t.toString() + ")";
    }
    rt(t) {
        const e = new $(this.F);
        return e.data = t, e;
    }
}

class M {
    constructor(t) {
        this.$t = t;
    }
    wt() {
        return this.$t.wt().key;
    }
    It() {
        return this.$t.It();
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function L(t) {
    let e = 0;
    for (const s in t) Object.prototype.hasOwnProperty.call(t, s) && e++;
    return e;
}

function O(t, e) {
    for (const s in t) Object.prototype.hasOwnProperty.call(t, s) && e(s, t[s]);
}

function x(t) {
    for (const e in t) if (Object.prototype.hasOwnProperty.call(t, e)) return !1;
    return !0;
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class that represents a "proto" byte string.
 *
 * Proto byte strings can either be Base64-encoded strings or Uint8Arrays when
 * sent on the wire. This class abstracts away this differentiation by holding
 * the proto byte string in a common class that must be converted into a string
 * before being sent as a proto.
 */ class B {
    constructor(t) {
        this.Mt = t;
    }
    static fromBase64String(t) {
        const e = Ve.Lt().atob(t);
        return new B(e);
    }
    static fromUint8Array(t) {
        const e = 
        /**
 * Helper function to convert an Uint8array to a binary string.
 */
        function(t) {
            let e = "";
            for (let s = 0; s < t.length; ++s) e += String.fromCharCode(t[s]);
            return e;
        }
        /**
 * Helper function to convert a binary string to an Uint8Array.
 */ (t);
        return new B(e);
    }
    toBase64() {
        return Ve.Lt().btoa(this.Mt);
    }
    toUint8Array() {
        return function(t) {
            const e = new Uint8Array(t.length);
            for (let s = 0; s < t.length; s++) e[s] = t.charCodeAt(s);
            return e;
        }
        /**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
        /**
 * Returns whether a variable is either undefined or null.
 */ (this.Mt);
    }
    Ot() {
        return 2 * this.Mt.length;
    }
    D(t) {
        return Ne(this.Mt, t.Mt);
    }
    isEqual(t) {
        return this.Mt === t.Mt;
    }
}

function U(t) {
    return null == t;
}

/** Returns whether the value represents -0. */ function q(t) {
    // Detect if the value is -0.0. Based on polyfill from
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    return -0 === t && 1 / t == -1 / 0;
}

/**
 * Returns whether a value is an integer and in the safe integer range
 * @param value The value to test for being an integer and in the safe range
 */ function Q(t) {
    return "number" == typeof t && Number.isInteger(t) && !q(t) && t <= Number.MAX_SAFE_INTEGER && t >= Number.MIN_SAFE_INTEGER;
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents a locally-applied ServerTimestamp.
 *
 * Server Timestamps are backed by MapValues that contain an internal field
 * `__type__` with a value of `server_timestamp`. The previous value and local
 * write time are stored in its `__previous_value__` and `__local_write_time__`
 * fields respectively.
 *
 * Notes:
 * - ServerTimestampValue instances are created as the result of applying a
 *   TransformMutation (see TransformMutation.applyTo()). They can only exist in
 *   the local view of a document. Therefore they do not need to be parsed or
 *   serialized.
 * - When evaluated locally (e.g. for snapshot.data()), they by default
 *   evaluate to `null`. This behavior can be configured by passing custom
 *   FieldValueOptions to value().
 * - With respect to other ServerTimestampValues, they sort by their
 *   localWriteTime.
 */ B.xt = new B("");

function W(t) {
    var e, s;
    return "server_timestamp" === (null === (s = ((null === (e = null == t ? void 0 : t.mapValue) || void 0 === e ? void 0 : e.fields) || {}).__type__) || void 0 === s ? void 0 : s.stringValue);
}

/**
 * Creates a new ServerTimestamp proto value (using the internal format).
 */
/**
 * Returns the local time at which this timestamp was first set.
 */
function j(t) {
    const e = tt(t.mapValue.fields.__local_write_time__.timestampValue);
    return new p(e.seconds, e.nanos);
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// A RegExp matching ISO 8601 UTC timestamps with optional fraction.
const K = new RegExp(/^\d{4}-\d\d-\d\dT\d\d:\d\d:\d\d(?:\.(\d+))?Z$/);

/** Extracts the backend's type order for the provided value. */ function G(t) {
    return "nullValue" in t ? 0 /* NullValue */ : "booleanValue" in t ? 1 /* BooleanValue */ : "integerValue" in t || "doubleValue" in t ? 2 /* NumberValue */ : "timestampValue" in t ? 3 /* TimestampValue */ : "stringValue" in t ? 5 /* StringValue */ : "bytesValue" in t ? 6 /* BlobValue */ : "referenceValue" in t ? 7 /* RefValue */ : "geoPointValue" in t ? 8 /* GeoPointValue */ : "arrayValue" in t ? 9 /* ArrayValue */ : "mapValue" in t ? W(t) ? 4 /* ServerTimestampValue */ : 10 /* ObjectValue */ : De("Invalid value type: " + JSON.stringify(t));
}

/** Tests `left` and `right` for equality based on the backend semantics. */ function z(t, e) {
    const s = G(t);
    if (s !== G(e)) return !1;
    switch (s) {
      case 0 /* NullValue */ :
        return !0;

      case 1 /* BooleanValue */ :
        return t.booleanValue === e.booleanValue;

      case 4 /* ServerTimestampValue */ :
        return j(t).isEqual(j(e));

      case 3 /* TimestampValue */ :
        return function(t, e) {
            if ("string" == typeof t.timestampValue && "string" == typeof e.timestampValue && t.timestampValue.length === e.timestampValue.length) 
            // Use string equality for ISO 8601 timestamps
            return t.timestampValue === e.timestampValue;
            const s = tt(t.timestampValue), n = tt(e.timestampValue);
            return s.seconds === n.seconds && s.nanos === n.nanos;
        }(t, e);

      case 5 /* StringValue */ :
        return t.stringValue === e.stringValue;

      case 6 /* BlobValue */ :
        return function(t, e) {
            return st(t.bytesValue).isEqual(st(e.bytesValue));
        }(t, e);

      case 7 /* RefValue */ :
        return t.referenceValue === e.referenceValue;

      case 8 /* GeoPointValue */ :
        return function(t, e) {
            return et(t.geoPointValue.latitude) === et(e.geoPointValue.latitude) && et(t.geoPointValue.longitude) === et(e.geoPointValue.longitude);
        }(t, e);

      case 2 /* NumberValue */ :
        return function(t, e) {
            if ("integerValue" in t && "integerValue" in e) return et(t.integerValue) === et(e.integerValue);
            if ("doubleValue" in t && "doubleValue" in e) {
                const s = et(t.doubleValue), n = et(e.doubleValue);
                return s === n ? q(s) === q(n) : isNaN(s) && isNaN(n);
            }
            return !1;
        }(t, e);

      case 9 /* ArrayValue */ :
        return Fe(t.arrayValue.values || [], e.arrayValue.values || [], z);

      case 10 /* ObjectValue */ :
        return function(t, e) {
            const s = t.mapValue.fields || {}, n = e.mapValue.fields || {};
            if (L(s) !== L(n)) return !1;
            for (const t in s) if (s.hasOwnProperty(t) && (void 0 === n[t] || !z(s[t], n[t]))) return !1;
            return !0;
        }
        /** Returns true if the ArrayValue contains the specified element. */ (t, e);

      default:
        return De("Unexpected value type: " + JSON.stringify(t));
    }
}

function H(t, e) {
    return void 0 !== (t.values || []).find(t => z(t, e));
}

function J(t, e) {
    const s = G(t), n = G(e);
    if (s !== n) return Ne(s, n);
    switch (s) {
      case 0 /* NullValue */ :
        return 0;

      case 1 /* BooleanValue */ :
        return Ne(t.booleanValue, e.booleanValue);

      case 2 /* NumberValue */ :
        return function(t, e) {
            const s = et(t.integerValue || t.doubleValue), n = et(e.integerValue || e.doubleValue);
            return s < n ? -1 : s > n ? 1 : s === n ? 0 : 
            // one or both are NaN.
            isNaN(s) ? isNaN(n) ? 0 : -1 : 1;
        }(t, e);

      case 3 /* TimestampValue */ :
        return Y(t.timestampValue, e.timestampValue);

      case 4 /* ServerTimestampValue */ :
        return Y(j(t), j(e));

      case 5 /* StringValue */ :
        return Ne(t.stringValue, e.stringValue);

      case 6 /* BlobValue */ :
        return function(t, e) {
            const s = st(t), n = st(e);
            return s.D(n);
        }(t.bytesValue, e.bytesValue);

      case 7 /* RefValue */ :
        return function(t, e) {
            const s = t.split("/"), n = e.split("/");
            for (let t = 0; t < s.length && t < n.length; t++) {
                const e = Ne(s[t], n[t]);
                if (0 !== e) return e;
            }
            return Ne(s.length, n.length);
        }(t.referenceValue, e.referenceValue);

      case 8 /* GeoPointValue */ :
        return function(t, e) {
            const s = Ne(et(t.latitude), et(e.latitude));
            if (0 !== s) return s;
            return Ne(et(t.longitude), et(e.longitude));
        }(t.geoPointValue, e.geoPointValue);

      case 9 /* ArrayValue */ :
        return function(t, e) {
            const s = t.values || [], n = e.values || [];
            for (let t = 0; t < s.length && t < n.length; ++t) {
                const e = J(s[t], n[t]);
                if (e) return e;
            }
            return Ne(s.length, n.length);
        }(t.arrayValue, e.arrayValue);

      case 10 /* ObjectValue */ :
        return function(t, e) {
            const s = t.fields || {}, n = Object.keys(s), i = e.fields || {}, r = Object.keys(i);
            // Even though MapValues are likely sorted correctly based on their insertion
            // order (e.g. when received from the backend), local modifications can bring
            // elements out of order. We need to re-sort the elements to ensure that
            // canonical IDs are independent of insertion order.
            n.sort(), r.sort();
            for (let t = 0; t < n.length && t < r.length; ++t) {
                const e = Ne(n[t], r[t]);
                if (0 !== e) return e;
                const o = J(s[n[t]], i[r[t]]);
                if (0 !== o) return o;
            }
            return Ne(n.length, r.length);
        }
        /**
 * Generates the canonical ID for the provided field value (as used in Target
 * serialization).
 */ (t.mapValue, e.mapValue);

      default:
        throw De("Invalid value type: " + s);
    }
}

function Y(t, e) {
    if ("string" == typeof t && "string" == typeof e && t.length === e.length) return Ne(t, e);
    const s = tt(t), n = tt(e), i = Ne(s.seconds, n.seconds);
    return 0 !== i ? i : Ne(s.nanos, n.nanos);
}

function X(t) {
    return Z(t);
}

function Z(t) {
    return "nullValue" in t ? "null" : "booleanValue" in t ? "" + t.booleanValue : "integerValue" in t ? "" + t.integerValue : "doubleValue" in t ? "" + t.doubleValue : "timestampValue" in t ? function(t) {
        const e = tt(t);
        return `time(${e.seconds},${e.nanos})`;
    }(t.timestampValue) : "stringValue" in t ? t.stringValue : "bytesValue" in t ? st(t.bytesValue).toBase64() : "referenceValue" in t ? (s = t.referenceValue, 
    C.tt(s).toString()) : "geoPointValue" in t ? `geo(${(e = t.geoPointValue).latitude},${e.longitude})` : "arrayValue" in t ? function(t) {
        let e = "[", s = !0;
        for (const n of t.values || []) s ? s = !1 : e += ",", e += Z(n);
        return e + "]";
    }
    /**
 * Converts the possible Proto values for a timestamp value into a "seconds and
 * nanos" representation.
 */ (t.arrayValue) : "mapValue" in t ? function(t) {
        // Iteration order in JavaScript is not guaranteed. To ensure that we generate
        // matching canonical IDs for identical maps, we need to sort the keys.
        const e = Object.keys(t.fields || {}).sort();
        let s = "{", n = !0;
        for (const i of e) n ? n = !1 : s += ",", s += `${i}:${Z(t.fields[i])}`;
        return s + "}";
    }(t.mapValue) : De("Invalid value type: " + JSON.stringify(t));
    var e, s;
}

function tt(t) {
    // The json interface (for the browser) will return an iso timestamp string,
    // while the proto js library (for node) will return a
    // google.protobuf.Timestamp instance.
    if (Ce(!!t, "Cannot normalize null or undefined timestamp."), "string" == typeof t) {
        // The date string can have higher precision (nanos) than the Date class
        // (millis), so we do some custom parsing here.
        // Parse the nanos right out of the string.
        let e = 0;
        const s = K.exec(t);
        if (Ce(!!s, "invalid timestamp: " + t), s[1]) {
            // Pad the fraction out to 9 digits (nanos).
            let t = s[1];
            t = (t + "000000000").substr(0, 9), e = Number(t);
        }
        // Parse the date to get the seconds.
                const n = new Date(t);
        return {
            seconds: Math.floor(n.getTime() / 1e3),
            nanos: e
        };
    }
    return {
        seconds: et(t.seconds),
        nanos: et(t.nanos)
    };
}

/**
 * Converts the possible Proto types for numbers into a JavaScript number.
 * Returns 0 if the value is not numeric.
 */ function et(t) {
    // TODO(bjornick): Handle int64 greater than 53 bits.
    return "number" == typeof t ? t : "string" == typeof t ? Number(t) : 0;
}

/** Converts the possible Proto types for Blobs into a ByteString. */ function st(t) {
    return "string" == typeof t ? B.fromBase64String(t) : B.fromUint8Array(t);
}

/** Returns a reference value for the provided database and key. */ function nt(t, e) {
    return {
        referenceValue: `projects/${t.projectId}/databases/${t.database}/documents/${e.path.K()}`
    };
}

/** Returns true if `value` is an IntegerValue . */ function it(t) {
    return !!t && "integerValue" in t;
}

/** Returns true if `value` is a DoubleValue. */
/** Returns true if `value` is an ArrayValue. */
function rt(t) {
    return !!t && "arrayValue" in t;
}

/** Returns true if `value` is a NullValue. */ function ot(t) {
    return !!t && "nullValue" in t;
}

/** Returns true if `value` is NaN. */ function ht(t) {
    return !!t && "doubleValue" in t && isNaN(Number(t.doubleValue));
}

/** Returns true if `value` is a MapValue. */ function at(t) {
    return !!t && "mapValue" in t;
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Transforms a value into a server-generated timestamp. */ class ut {
    constructor() {}
    Bt(t, e) {
        return function(t, e) {
            const s = {
                fields: {
                    __type__: {
                        stringValue: "server_timestamp"
                    },
                    __local_write_time__: {
                        timestampValue: {
                            seconds: t.seconds,
                            nanos: t.nanoseconds
                        }
                    }
                }
            };
            return e && (s.fields.__previous_value__ = e), {
                mapValue: s
            };
        }
        /**
 * Returns the value of the field before this ServerTimestamp was set.
 *
 * Preserving the previous values allows the user to display the last resoled
 * value until the backend responds with the timestamp.
 */ (e, t);
    }
    Ut(t, e) {
        return e;
    }
    qt(t) {
        return null;
 // Server timestamps are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof ut;
    }
}

ut.instance = new ut;

/** Transforms an array value via a union operation. */
class ct {
    constructor(t) {
        this.elements = t;
    }
    Bt(t, e) {
        return this.apply(t);
    }
    Ut(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        const e = dt(t);
        for (const t of this.elements) e.some(e => z(e, t)) || e.push(t);
        return {
            arrayValue: {
                values: e
            }
        };
    }
    qt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof ct && Fe(this.elements, t.elements, z);
    }
}

/** Transforms an array value via a remove operation. */ class _t {
    constructor(t) {
        this.elements = t;
    }
    Bt(t, e) {
        return this.apply(t);
    }
    Ut(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        let e = dt(t);
        for (const t of this.elements) e = e.filter(e => !z(e, t));
        return {
            arrayValue: {
                values: e
            }
        };
    }
    qt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof _t && Fe(this.elements, t.elements, z);
    }
}

/**
 * Implements the backend semantics for locally computed NUMERIC_ADD (increment)
 * transforms. Converts all field values to integers or doubles, but unlike the
 * backend does not cap integer values at 2^63. Instead, JavaScript number
 * arithmetic is used and precision loss can occur for values greater than 2^53.
 */ class lt {
    constructor(t, e) {
        this.serializer = t, this.Qt = e;
    }
    Bt(t, e) {
        // PORTING NOTE: Since JavaScript's integer arithmetic is limited to 53 bit
        // precision and resolves overflows by reducing precision, we do not
        // manually cap overflows at 2^63.
        const s = this.qt(t), n = this.asNumber(s) + this.asNumber(this.Qt);
        return it(s) && it(this.Qt) ? this.serializer.Wt(n) : this.serializer.jt(n);
    }
    Ut(t, e) {
        return e;
    }
    /**
     * Inspects the provided value, returning the provided value if it is already
     * a NumberValue, otherwise returning a coerced value of 0.
     */    qt(t) {
        return it(e = t) || function(t) {
            return !!t && "doubleValue" in t;
        }
        /** Returns true if `value` is either an IntegerValue or a DoubleValue. */ (e) ? t : {
            integerValue: 0
        };
        var e;
    }
    isEqual(t) {
        return t instanceof lt && z(this.Qt, t.Qt);
    }
    asNumber(t) {
        return et(t.integerValue || t.doubleValue);
    }
}

function dt(t) {
    return rt(t) && t.arrayValue.values ? t.arrayValue.values.slice() : [];
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a set of fields that can be used to partially patch a document.
 * FieldMask is used in conjunction with ObjectValue.
 * Examples:
 *   foo - Overwrites foo entirely with the provided value. If foo is not
 *         present in the companion ObjectValue, the field is deleted.
 *   foo.bar - Overwrites only the field bar of the object foo.
 *             If foo is not an object, foo is replaced with an object
 *             containing foo
 */ class ft {
    constructor(t) {
        this.fields = t;
        // TODO(dimond): validation of FieldMask
        }
    static Kt(t) {
        return new ft(t);
    }
    static Gt(t) {
        let e = new $(D.F);
        return t.forEach(t => e = e.add(t)), new ft(e);
    }
    /**
     * Verifies that `fieldPath` is included by at least one field in this field
     * mask.
     *
     * This is an O(n) operation, where `n` is the size of the field mask.
     */    zt(t) {
        let e = !1;
        return this.fields.forEach(s => {
            s.q(t) && (e = !0);
        }), e;
    }
    isEqual(t) {
        return this.fields.isEqual(t.fields);
    }
}

/** A field path and the TransformOperation to perform upon it. */ class Tt {
    constructor(t, e) {
        this.field = t, this.transform = e;
    }
    isEqual(t) {
        return this.field.isEqual(t.field) && this.transform.isEqual(t.transform);
    }
}

/** The result of successfully applying a mutation to the backend. */ class mt {
    constructor(
    /**
     * The version at which the mutation was committed:
     *
     * - For most operations, this is the updateTime in the WriteResult.
     * - For deletes, the commitTime of the WriteResponse (because deletes are
     *   not stored and have no updateTime).
     *
     * Note that these versions can be different: No-op writes will not change
     * the updateTime even though the commitTime advances.
     */
    t, 
    /**
     * The resulting fields returned from the backend after a
     * TransformMutation has been committed. Contains one FieldValue for each
     * FieldTransform that was in the mutation.
     *
     * Will be null if the mutation was not a TransformMutation.
     */
    e) {
        this.version = t, this.transformResults = e;
    }
}

/**
 * Encodes a precondition for a mutation. This follows the model that the
 * backend accepts with the special case of an explicit "empty" precondition
 * (meaning no precondition).
 */ class Et {
    constructor(t, e) {
        this.updateTime = t, this.exists = e;
    }
    /** Creates a new Precondition with an exists flag. */    static exists(t) {
        return new Et(void 0, t);
    }
    /** Creates a new Precondition based on a version a document exists at. */    static updateTime(t) {
        return new Et(t);
    }
    /** Returns whether this Precondition is empty. */    get Ht() {
        return void 0 === this.updateTime && void 0 === this.exists;
    }
    /**
     * Returns true if the preconditions is valid for the given document
     * (or null if no document is available).
     */    Jt(t) {
        return void 0 !== this.updateTime ? t instanceof bt && t.version.isEqual(this.updateTime) : void 0 === this.exists || this.exists === t instanceof bt;
    }
    isEqual(t) {
        return this.exists === t.exists && (this.updateTime ? !!t.updateTime && this.updateTime.isEqual(t.updateTime) : !t.updateTime);
    }
}

Et.NONE = new Et;

/**
 * A mutation describes a self-contained change to a document. Mutations can
 * create, replace, delete, and update subsets of documents.
 *
 * Mutations not only act on the value of the document but also its version.
 *
 * For local mutations (mutations that haven't been committed yet), we preserve
 * the existing version for Set, Patch, and Transform mutations. For Delete
 * mutations, we reset the version to 0.
 *
 * Here's the expected transition table.
 *
 * MUTATION           APPLIED TO            RESULTS IN
 *
 * SetMutation        Document(v3)          Document(v3)
 * SetMutation        NoDocument(v3)        Document(v0)
 * SetMutation        null                  Document(v0)
 * PatchMutation      Document(v3)          Document(v3)
 * PatchMutation      NoDocument(v3)        NoDocument(v3)
 * PatchMutation      null                  null
 * TransformMutation  Document(v3)          Document(v3)
 * TransformMutation  NoDocument(v3)        NoDocument(v3)
 * TransformMutation  null                  null
 * DeleteMutation     Document(v3)          NoDocument(v0)
 * DeleteMutation     NoDocument(v3)        NoDocument(v0)
 * DeleteMutation     null                  NoDocument(v0)
 *
 * For acknowledged mutations, we use the updateTime of the WriteResponse as
 * the resulting version for Set, Patch, and Transform mutations. As deletes
 * have no explicit update time, we use the commitTime of the WriteResponse for
 * Delete mutations.
 *
 * If a mutation is acknowledged by the backend but fails the precondition check
 * locally, we return an `UnknownDocument` and rely on Watch to send us the
 * updated version.
 *
 * Note that TransformMutations don't create Documents (in the case of being
 * applied to a NoDocument), even though they would on the backend. This is
 * because the client always combines the TransformMutation with a SetMutation
 * or PatchMutation and we only want to apply the transform if the prior
 * mutation resulted in a Document (always true for a SetMutation, but not
 * necessarily for a PatchMutation).
 *
 * ## Subclassing Notes
 *
 * Subclasses of Mutation need to implement applyToRemoteDocument() and
 * applyToLocalView() to implement the actual behavior of applying the mutation
 * to some source document.
 */
class wt {
    Yt(t) {}
    /**
     * Returns the version from the given document for use as the result of a
     * mutation. Mutations are defined to return the version of the base document
     * only if it is an existing document. Deleted and unknown documents have a
     * post-mutation version of SnapshotVersion.MIN.
     */    static Xt(t) {
        return t instanceof bt ? t.version : y.MIN;
    }
}

/**
 * A mutation that creates or replaces the document at the given key with the
 * object value contents.
 */ class It extends wt {
    constructor(t, e, s) {
        super(), this.key = t, this.value = e, this.Zt = s, this.type = 0 /* Set */;
    }
    Ut(t, e) {
        this.Yt(t);
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        const s = e.version;
        return new bt(this.key, s, this.value, {
            hasCommittedMutations: !0
        });
    }
    Bt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const n = wt.Xt(t);
        return new bt(this.key, n, this.value, {
            te: !0
        });
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof It && this.key.isEqual(t.key) && this.value.isEqual(t.value) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * A mutation that modifies fields of the document at the given key with the
 * given values. The values are applied through a field mask:
 *
 *  * When a field is in both the mask and the values, the corresponding field
 *    is updated.
 *  * When a field is in neither the mask nor the values, the corresponding
 *    field is unmodified.
 *  * When a field is in the mask but not in the values, the corresponding field
 *    is deleted.
 *  * When a field is not in the mask but is in the values, the values map is
 *    ignored.
 */ class Rt extends wt {
    constructor(t, e, s, n) {
        super(), this.key = t, this.data = e, this.se = s, this.Zt = n, this.type = 1 /* Patch */;
    }
    Ut(t, e) {
        if (this.Yt(t), !this.Zt.Jt(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new St(this.key, e.version);
        const s = this.ne(t);
        return new bt(this.key, e.version, s, {
            hasCommittedMutations: !0
        });
    }
    Bt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const n = wt.Xt(t), i = this.ne(t);
        return new bt(this.key, n, i, {
            te: !0
        });
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Rt && this.key.isEqual(t.key) && this.se.isEqual(t.se) && this.Zt.isEqual(t.Zt);
    }
    /**
     * Patches the data of document if available or creates a new document. Note
     * that this does not check whether or not the precondition of this patch
     * holds.
     */    ne(t) {
        let e;
        return e = t instanceof bt ? t.data() : gt.EMPTY, this.ie(e);
    }
    ie(t) {
        const e = t.re();
        return this.se.fields.forEach(t => {
            if (!t.U()) {
                const s = this.data.field(t);
                null !== s ? e.set(t, s) : e.delete(t);
            }
        }), e.oe();
    }
}

/**
 * A mutation that modifies specific fields of the document with transform
 * operations. Currently the only supported transform is a server timestamp, but
 * IP Address, increment(n), etc. could be supported in the future.
 *
 * It is somewhat similar to a PatchMutation in that it patches specific fields
 * and has no effect when applied to a null or NoDocument (see comment on
 * Mutation for rationale).
 */ class At extends wt {
    constructor(t, e) {
        super(), this.key = t, this.fieldTransforms = e, this.type = 2 /* Transform */ , 
        // NOTE: We set a precondition of exists: true as a safety-check, since we
        // always combine TransformMutations with a SetMutation or PatchMutation which
        // (if successful) should end up with an existing document.
        this.Zt = Et.exists(!0);
    }
    Ut(t, e) {
        if (this.Yt(t), Ce(null != e.transformResults, "Transform results missing for TransformMutation."), 
        !this.Zt.Jt(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new St(this.key, e.version);
        const s = this.he(t), n = this.ae(t, e.transformResults), i = e.version, r = this.ue(s.data(), n);
        return new bt(this.key, i, r, {
            hasCommittedMutations: !0
        });
    }
    Bt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const n = this.he(t), i = this.ce(s, t, e), r = this.ue(n.data(), i);
        return new bt(this.key, n.version, r, {
            te: !0
        });
    }
    ee(t) {
        let e = null;
        for (const s of this.fieldTransforms) {
            const n = t instanceof bt ? t.field(s.field) : void 0, i = s.transform.qt(n || null);
            null != i && (e = null == e ? gt._e().set(s.field, i) : e.set(s.field, i));
        }
        return e ? e.oe() : null;
    }
    isEqual(t) {
        return t instanceof At && this.key.isEqual(t.key) && Fe(this.fieldTransforms, t.fieldTransforms, (t, e) => t.isEqual(e)) && this.Zt.isEqual(t.Zt);
    }
    /**
     * Asserts that the given MaybeDocument is actually a Document and verifies
     * that it matches the key for this mutation. Since we only support
     * transformations with precondition exists this method is guaranteed to be
     * safe.
     */    he(t) {
        return t;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use after a
     * TransformMutation has been acknowledged by the server.
     *
     * @param baseDoc The document prior to applying this mutation batch.
     * @param serverTransformResults The transform results received by the server.
     * @return The transform results list.
     */    ae(t, e) {
        const s = [];
        Ce(this.fieldTransforms.length === e.length, `server transform result count (${e.length}) ` + `should match field transform count (${this.fieldTransforms.length})`);
        for (let n = 0; n < e.length; n++) {
            const i = this.fieldTransforms[n], r = i.transform;
            let o = null;
            t instanceof bt && (o = t.field(i.field)), s.push(r.Ut(o, e[n]));
        }
        return s;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use when applying a
     * TransformMutation locally.
     *
     * @param localWriteTime The local time of the transform mutation (used to
     *     generate ServerTimestampValues).
     * @param maybeDoc The current state of the document after applying all
     *     previous mutations.
     * @param baseDoc The document prior to applying this mutation batch.
     * @return The transform results list.
     */    ce(t, e, s) {
        const n = [];
        for (const i of this.fieldTransforms) {
            const r = i.transform;
            let o = null;
            e instanceof bt && (o = e.field(i.field)), null === o && s instanceof bt && (
            // If the current document does not contain a value for the mutated
            // field, use the value that existed before applying this mutation
            // batch. This solves an edge case where a PatchMutation clears the
            // values in a nested map before the TransformMutation is applied.
            o = s.field(i.field)), n.push(r.Bt(o, t));
        }
        return n;
    }
    ue(t, e) {
        const s = t.re();
        for (let t = 0; t < this.fieldTransforms.length; t++) {
            const n = this.fieldTransforms[t].field;
            s.set(n, e[t]);
        }
        return s.oe();
    }
}

/** A mutation that deletes the document at the given key. */ class Pt extends wt {
    constructor(t, e) {
        super(), this.key = t, this.Zt = e, this.type = 3 /* Delete */;
    }
    Ut(t, e) {
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        return this.Yt(t), new vt(this.key, e.version, {
            hasCommittedMutations: !0
        });
    }
    Bt(t, e, s) {
        return this.Yt(t), this.Zt.Jt(t) ? new vt(this.key, y.S()) : t;
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Pt && this.key.isEqual(t.key) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * A mutation that verifies the existence of the document at the given key with
 * the provided precondition.
 *
 * The `verify` operation is only used in Transactions, and this class serves
 * primarily to facilitate serialization into protos.
 */ class Vt extends wt {
    constructor(t, e) {
        super(), this.key = t, this.Zt = e, this.type = 4 /* Verify */;
    }
    Ut(t, e) {
        De("VerifyMutation should only be used in Transactions.");
    }
    Bt(t, e, s) {
        De("VerifyMutation should only be used in Transactions.");
    }
    ee(t) {
        De("VerifyMutation should only be used in Transactions.");
    }
    isEqual(t) {
        return t instanceof Vt && this.key.isEqual(t.key) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An ObjectValue represents a MapValue in the Firestore Proto and offers the
 * ability to add and remove fields (via the ObjectValueBuilder).
 */ class gt {
    constructor(t) {
        this.proto = t;
    }
    /** Returns a new Builder instance that is based on an empty object. */    static _e() {
        return gt.EMPTY.re();
    }
    /**
     * Returns the value at the given path or null.
     *
     * @param path the path to search
     * @return The value at the path or if there it doesn't exist.
     */    field(t) {
        if (t.U()) return this.proto;
        {
            let e = this.proto;
            for (let s = 0; s < t.length - 1; ++s) {
                if (!e.mapValue.fields) return null;
                if (e = e.mapValue.fields[t.get(s)], !at(e)) return null;
            }
            return e = (e.mapValue.fields || {})[t.B()], e || null;
        }
    }
    /**
     * Returns a FieldMask built from all FieldPaths starting from this
     * ObjectValue, including paths from nested objects.
     */    se() {
        return this.le(this.proto.mapValue);
    }
    le(t) {
        let e = new $(D.F);
        return O(t.fields || {}, (t, s) => {
            const n = new D([ t ]);
            if (10 /* ObjectValue */ === G(s)) {
                const t = this.le(s.mapValue).fields;
                t.U() ? 
                // Preserve the empty map by adding it to the FieldMask.
                e = e.add(n) : 
                // For nested and non-empty ObjectValues, add the FieldPath of the
                // leaf nodes.
                t.forEach(t => {
                    e = e.add(n.child(t));
                });
            } else 
            // For nested and non-empty ObjectValues, add the FieldPath of the leaf
            // nodes.
            e = e.add(n);
        }), ft.Kt(e);
    }
    isEqual(t) {
        return z(this.proto, t.proto);
    }
    /** Creates a ObjectValueBuilder instance that is based on the current value. */    re() {
        return new pt(this);
    }
}

gt.EMPTY = new gt({
    mapValue: {}
});

/**
 * An ObjectValueBuilder provides APIs to set and delete fields from an
 * ObjectValue.
 */
class pt {
    /**
     * @param baseObject The object to mutate.
     */
    constructor(t) {
        this.de = t, 
        /** A map that contains the accumulated changes in this builder. */
        this.fe = new Map;
    }
    /**
     * Sets the field to the provided value.
     *
     * @param path The field path to set.
     * @param value The value to set.
     * @return The current Builder instance.
     */    set(t, e) {
        return this.Te(t, e), this;
    }
    /**
     * Removes the field at the specified path. If there is no field at the
     * specified path, nothing is changed.
     *
     * @param path The field path to remove.
     * @return The current Builder instance.
     */    delete(t) {
        return this.Te(t, null), this;
    }
    /**
     * Adds `value` to the overlay map at `path`. Creates nested map entries if
     * needed.
     */    Te(t, e) {
        let s = this.fe;
        for (let e = 0; e < t.length - 1; ++e) {
            const n = t.get(e);
            let i = s.get(n);
            i instanceof Map ? 
            // Re-use a previously created map
            s = i : i && 10 /* ObjectValue */ === G(i) ? (
            // Convert the existing Protobuf MapValue into a map
            i = new Map(Object.entries(i.mapValue.fields || {})), s.set(n, i), s = i) : (
            // Create an empty map to represent the current nesting level
            i = new Map, s.set(n, i), s = i);
        }
        s.set(t.B(), e);
    }
    /** Returns an ObjectValue with all mutations applied. */    oe() {
        const t = this.me(D.H, this.fe);
        return null != t ? new gt(t) : this.de;
    }
    /**
     * Applies any overlays from `currentOverlays` that exist at `currentPath`
     * and returns the merged data at `currentPath` (or null if there were no
     * changes).
     *
     * @param currentPath The path at the current nesting level. Can be set to
     * FieldValue.EMPTY_PATH to represent the root.
     * @param currentOverlays The overlays at the current nesting level in the
     * same format as `overlayMap`.
     * @return The merged data at `currentPath` or null if no modifications
     * were applied.
     */    me(t, e) {
        let s = !1;
        const n = this.de.field(t), i = at(n) ? // If there is already data at the current path, base our
        Object.assign({}, n.mapValue.fields) : {};
        return e.forEach((e, n) => {
            if (e instanceof Map) {
                const r = this.me(t.child(n), e);
                null != r && (i[n] = r, s = !0);
            } else null !== e ? (i[n] = e, s = !0) : i.hasOwnProperty(n) && (delete i[n], s = !0);
        }), s ? {
            mapValue: {
                fields: i
            }
        } : null;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * The result of a lookup for a given path may be an existing document or a
 * marker that this document does not exist at a given version.
 */ class yt {
    constructor(t, e) {
        this.key = t, this.version = e;
    }
    static Ee(t, e) {
        return C.F(t.key, e.key);
    }
}

/**
 * Represents a document in Firestore with a key, version, data and whether the
 * data has local mutations applied to it.
 */ class bt extends yt {
    constructor(t, e, s, n) {
        super(t, e), this.we = s, this.te = !!n.te, this.hasCommittedMutations = !!n.hasCommittedMutations;
    }
    field(t) {
        return this.we.field(t);
    }
    data() {
        return this.we;
    }
    Ie() {
        return this.we.proto;
    }
    isEqual(t) {
        return t instanceof bt && this.key.isEqual(t.key) && this.version.isEqual(t.version) && this.te === t.te && this.hasCommittedMutations === t.hasCommittedMutations && this.we.isEqual(t.we);
    }
    toString() {
        return `Document(${this.key}, ${this.version}, ${this.we.toString()}, ` + `{hasLocalMutations: ${this.te}}), ` + `{hasCommittedMutations: ${this.hasCommittedMutations}})`;
    }
    get hasPendingWrites() {
        return this.te || this.hasCommittedMutations;
    }
    static Re(t, e, s) {
        const n = e.field(t), i = s.field(t);
        return null !== n && null !== i ? J(n, i) : De("Trying to compare documents on fields that don't exist");
    }
}

/**
 * A class representing a deleted document.
 * Version is set to 0 if we don't point to any specific time, otherwise it
 * denotes time we know it didn't exist at.
 */ class vt extends yt {
    constructor(t, e, s) {
        super(t, e), this.hasCommittedMutations = !(!s || !s.hasCommittedMutations);
    }
    toString() {
        return `NoDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return this.hasCommittedMutations;
    }
    isEqual(t) {
        return t instanceof vt && t.hasCommittedMutations === this.hasCommittedMutations && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * A class representing an existing document whose data is unknown (e.g. a
 * document that was updated without a known base document).
 */ class St extends yt {
    toString() {
        return `UnknownDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return !0;
    }
    isEqual(t) {
        return t instanceof St && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A Target represents the WatchTarget representation of a Query, which is used
 * by the LocalStore and the RemoteStore to keep track of and to execute
 * backend queries. While a Query can represent multiple Targets, each Targets
 * maps to a single WatchTarget in RemoteStore and a single TargetData entry
 * in persistence.
 */ class Dt {
    /**
     * Initializes a Target with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     *
     * NOTE: you should always construct `Target` from `Query.toTarget` instead of
     * using this constructor, because `Query` provides an implicit `orderBy`
     * property.
     */
    constructor(t, e = null, s = [], n = [], i = null, r = null, o = null) {
        this.path = t, this.collectionGroup = e, this.orderBy = s, this.filters = n, this.limit = i, 
        this.startAt = r, this.endAt = o, this.Ae = null;
    }
    canonicalId() {
        if (null === this.Ae) {
            let t = this.path.K();
            null !== this.collectionGroup && (t += "|cg:" + this.collectionGroup), t += "|f:", 
            t += this.filters.map(t => t.canonicalId()).join(","), t += "|ob:", t += this.orderBy.map(t => t.canonicalId()).join(","), 
            U(this.limit) || (t += "|l:", t += this.limit), this.startAt && (t += "|lb:", t += this.startAt.canonicalId()), 
            this.endAt && (t += "|ub:", t += this.endAt.canonicalId()), this.Ae = t;
        }
        return this.Ae;
    }
    toString() {
        let t = this.path.K();
        return null !== this.collectionGroup && (t += " collectionGroup=" + this.collectionGroup), 
        this.filters.length > 0 && (t += `, filters: [${this.filters.join(", ")}]`), U(this.limit) || (t += ", limit: " + this.limit), 
        this.orderBy.length > 0 && (t += `, orderBy: [${this.orderBy.join(", ")}]`), this.startAt && (t += ", startAt: " + this.startAt.canonicalId()), 
        this.endAt && (t += ", endAt: " + this.endAt.canonicalId()), `Target(${t})`;
    }
    isEqual(t) {
        if (this.limit !== t.limit) return !1;
        if (this.orderBy.length !== t.orderBy.length) return !1;
        for (let e = 0; e < this.orderBy.length; e++) if (!this.orderBy[e].isEqual(t.orderBy[e])) return !1;
        if (this.filters.length !== t.filters.length) return !1;
        for (let e = 0; e < this.filters.length; e++) if (!this.filters[e].isEqual(t.filters[e])) return !1;
        return this.collectionGroup === t.collectionGroup && (!!this.path.isEqual(t.path) && (!!(null !== this.startAt ? this.startAt.isEqual(t.startAt) : null === t.startAt) && (null !== this.endAt ? this.endAt.isEqual(t.endAt) : null === t.endAt)));
    }
    Pe() {
        return C.st(this.path) && null === this.collectionGroup && 0 === this.filters.length;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Query encapsulates all the query attributes we support in the SDK. It can
 * be run against the LocalStore, as well as be converted to a `Target` to
 * query the RemoteStore results.
 */ class Ct {
    /**
     * Initializes a Query with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     */
    constructor(t, e = null, s = [], n = [], i = null, r = "F" /* First */ , o = null, h = null) {
        this.path = t, this.collectionGroup = e, this.Ve = s, this.filters = n, this.limit = i, 
        this.ge = r, this.startAt = o, this.endAt = h, this.pe = null, 
        // The corresponding `Target` of this `Query` instance.
        this.ye = null, this.startAt && this.be(this.startAt), this.endAt && this.be(this.endAt);
    }
    static ve(t) {
        return new Ct(t);
    }
    get orderBy() {
        if (null === this.pe) {
            const t = this.Se(), e = this.De();
            if (null !== t && null === e) 
            // In order to implicitly add key ordering, we must also add the
            // inequality filter field for it to be a valid query.
            // Note that the default inequality field and key ordering is ascending.
            t.Y() ? this.pe = [ qt ] : this.pe = [ new Ut(t), qt ]; else {
                this.pe = [];
                let t = !1;
                for (const e of this.Ve) this.pe.push(e), e.field.Y() && (t = !0);
                if (!t) {
                    // The order of the implicit key ordering always matches the last
                    // explicit order by
                    const t = this.Ve.length > 0 ? this.Ve[this.Ve.length - 1].dir : xt.ASCENDING;
                    this.pe.push(t === xt.ASCENDING ? qt : Qt);
                }
            }
        }
        return this.pe;
    }
    Ce(t) {
        const e = this.filters.concat([ t ]);
        return new Ct(this.path, this.collectionGroup, this.Ve.slice(), e, this.limit, this.ge, this.startAt, this.endAt);
    }
    ke(t) {
        // TODO(dimond): validate that orderBy does not list the same key twice.
        const e = this.Ve.concat([ t ]);
        return new Ct(this.path, this.collectionGroup, e, this.filters.slice(), this.limit, this.ge, this.startAt, this.endAt);
    }
    Ne(t) {
        return new Ct(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), t, "F" /* First */ , this.startAt, this.endAt);
    }
    Fe(t) {
        return new Ct(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), t, "L" /* Last */ , this.startAt, this.endAt);
    }
    $e(t) {
        return new Ct(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), this.limit, this.ge, t, this.endAt);
    }
    Me(t) {
        return new Ct(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), this.limit, this.ge, this.startAt, t);
    }
    /**
     * Helper to convert a collection group query into a collection query at a
     * specific path. This is used when executing collection group queries, since
     * we have to split the query into a set of collection queries at multiple
     * paths.
     */    Le(t) {
        return new Ct(t, 
        /*collectionGroup=*/ null, this.Ve.slice(), this.filters.slice(), this.limit, this.ge, this.startAt, this.endAt);
    }
    /**
     * Returns true if this query does not specify any query constraints that
     * could remove results.
     */    Oe() {
        return 0 === this.filters.length && null === this.limit && null == this.startAt && null == this.endAt && (0 === this.Ve.length || 1 === this.Ve.length && this.Ve[0].field.Y());
    }
    // TODO(b/29183165): This is used to get a unique string from a query to, for
    // example, use as a dictionary key, but the implementation is subject to
    // collisions. Make it collision-free.
    canonicalId() {
        return `${this.xe().canonicalId()}|lt:${this.ge}`;
    }
    toString() {
        return `Query(target=${this.xe().toString()}; limitType=${this.ge})`;
    }
    isEqual(t) {
        return this.xe().isEqual(t.xe()) && this.ge === t.ge;
    }
    Be(t, e) {
        let s = !1;
        for (const n of this.orderBy) {
            const i = n.compare(t, e);
            if (0 !== i) return i;
            s = s || n.field.Y();
        }
        return 0;
    }
    matches(t) {
        return this.Ue(t) && this.qe(t) && this.Qe(t) && this.We(t);
    }
    je() {
        return !U(this.limit) && "F" /* First */ === this.ge;
    }
    Ke() {
        return !U(this.limit) && "L" /* Last */ === this.ge;
    }
    De() {
        return this.Ve.length > 0 ? this.Ve[0].field : null;
    }
    Se() {
        for (const t of this.filters) if (t instanceof Nt && t.Ge()) return t.field;
        return null;
    }
    // Checks if any of the provided Operators are included in the query and
    // returns the first one that is, or null if none are.
    ze(t) {
        for (const e of this.filters) if (e instanceof Nt && t.indexOf(e.op) >= 0) return e.op;
        return null;
    }
    Pe() {
        return this.xe().Pe();
    }
    He() {
        return null !== this.collectionGroup;
    }
    /**
     * Converts this `Query` instance to it's corresponding `Target`
     * representation.
     */    xe() {
        if (!this.ye) if ("F" /* First */ === this.ge) this.ye = new Dt(this.path, this.collectionGroup, this.orderBy, this.filters, this.limit, this.startAt, this.endAt); else {
            // Flip the orderBy directions since we want the last results
            const t = [];
            for (const e of this.orderBy) {
                const s = e.dir === xt.DESCENDING ? xt.ASCENDING : xt.DESCENDING;
                t.push(new Ut(e.field, s));
            }
            // We need to swap the cursors to match the now-flipped query ordering.
                        const e = this.endAt ? new Bt(this.endAt.position, !this.endAt.before) : null, s = this.startAt ? new Bt(this.startAt.position, !this.startAt.before) : null;
            // Now return as a LimitType.First query.
            this.ye = new Dt(this.path, this.collectionGroup, t, this.filters, this.limit, e, s);
        }
        return this.ye;
    }
    Ue(t) {
        const e = t.key.path;
        return null !== this.collectionGroup ? t.key.et(this.collectionGroup) && this.path.q(e) : C.st(this.path) ? this.path.isEqual(e) : this.path.W(e);
    }
    /**
     * A document must have a value for every ordering clause in order to show up
     * in the results.
     */    qe(t) {
        for (const e of this.Ve) 
        // order by key always matches
        if (!e.field.Y() && null === t.field(e.field)) return !1;
        return !0;
    }
    Qe(t) {
        for (const e of this.filters) if (!e.matches(t)) return !1;
        return !0;
    }
    /**
     * Makes sure a document is within the bounds, if provided.
     */    We(t) {
        return !(this.startAt && !this.startAt.Je(this.orderBy, t)) && (!this.endAt || !this.endAt.Je(this.orderBy, t));
    }
    be(t) {}
}

class kt {
    constructor(t) {
        this.name = t;
    }
    static G(t) {
        switch (t) {
          case "<":
            return kt.LESS_THAN;

          case "<=":
            return kt.LESS_THAN_OR_EQUAL;

          case "==":
            return kt.EQUAL;

          case ">=":
            return kt.GREATER_THAN_OR_EQUAL;

          case ">":
            return kt.GREATER_THAN;

          case "array-contains":
            return kt.ARRAY_CONTAINS;

          case "in":
            return kt.IN;

          case "array-contains-any":
            return kt.ARRAY_CONTAINS_ANY;

          default:
            return De("Unknown FieldFilter operator: " + t);
        }
    }
    toString() {
        return this.name;
    }
    isEqual(t) {
        return this.name === t.name;
    }
}

kt.LESS_THAN = new kt("<"), kt.LESS_THAN_OR_EQUAL = new kt("<="), kt.EQUAL = new kt("=="), 
kt.GREATER_THAN = new kt(">"), kt.GREATER_THAN_OR_EQUAL = new kt(">="), kt.ARRAY_CONTAINS = new kt("array-contains"), 
kt.IN = new kt("in"), kt.ARRAY_CONTAINS_ANY = new kt("array-contains-any");

class Nt extends class {} {
    constructor(t, e, s) {
        super(), this.field = t, this.op = e, this.value = s;
    }
    /**
     * Creates a filter based on the provided arguments.
     */    static create(t, e, s) {
        if (t.Y()) return e === kt.IN ? new $t(t, s) : new Ft(t, e, s);
        if (ot(s)) {
            if (e !== kt.EQUAL) throw new I(w.INVALID_ARGUMENT, "Invalid query. Null supports only equality comparisons.");
            return new Nt(t, e, s);
        }
        if (ht(s)) {
            if (e !== kt.EQUAL) throw new I(w.INVALID_ARGUMENT, "Invalid query. NaN supports only equality comparisons.");
            return new Nt(t, e, s);
        }
        return e === kt.ARRAY_CONTAINS ? new Mt(t, s) : e === kt.IN ? new Lt(t, s) : e === kt.ARRAY_CONTAINS_ANY ? new Ot(t, s) : new Nt(t, e, s);
    }
    matches(t) {
        const e = t.field(this.field);
        // Only compare types with matching backend order (such as double and int).
                return null !== e && G(this.value) === G(e) && this.Ye(J(e, this.value));
    }
    Ye(t) {
        switch (this.op) {
          case kt.LESS_THAN:
            return t < 0;

          case kt.LESS_THAN_OR_EQUAL:
            return t <= 0;

          case kt.EQUAL:
            return 0 === t;

          case kt.GREATER_THAN:
            return t > 0;

          case kt.GREATER_THAN_OR_EQUAL:
            return t >= 0;

          default:
            return De("Unknown FieldFilter operator: " + this.op);
        }
    }
    Ge() {
        return [ kt.LESS_THAN, kt.LESS_THAN_OR_EQUAL, kt.GREATER_THAN, kt.GREATER_THAN_OR_EQUAL ].indexOf(this.op) >= 0;
    }
    canonicalId() {
        // TODO(b/29183165): Technically, this won't be unique if two values have
        // the same description, such as the int 3 and the string "3". So we should
        // add the types in here somehow, too.
        return this.field.K() + this.op.toString() + X(this.value);
    }
    isEqual(t) {
        return t instanceof Nt && (this.op.isEqual(t.op) && this.field.isEqual(t.field) && z(this.value, t.value));
    }
    toString() {
        return `${this.field.K()} ${this.op} ${X(this.value)}`;
    }
}

/** Filter that matches on key fields (i.e. '__name__'). */ class Ft extends Nt {
    constructor(t, e, s) {
        super(t, e, s), this.key = C.tt(s.referenceValue);
    }
    matches(t) {
        const e = C.F(t.key, this.key);
        return this.Ye(e);
    }
}

/** Filter that matches on key fields within an array. */ class $t extends Nt {
    constructor(t, e) {
        super(t, kt.IN, e), this.keys = (e.arrayValue.values || []).map(t => C.tt(t.referenceValue));
    }
    matches(t) {
        return this.keys.some(e => e.isEqual(t.key));
    }
}

/** A Filter that implements the array-contains operator. */ class Mt extends Nt {
    constructor(t, e) {
        super(t, kt.ARRAY_CONTAINS, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return rt(e) && H(e.arrayValue, this.value);
    }
}

/** A Filter that implements the IN operator. */ class Lt extends Nt {
    constructor(t, e) {
        super(t, kt.IN, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return null !== e && H(this.value.arrayValue, e);
    }
}

/** A Filter that implements the array-contains-any operator. */ class Ot extends Nt {
    constructor(t, e) {
        super(t, kt.ARRAY_CONTAINS_ANY, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return !(!rt(e) || !e.arrayValue.values) && e.arrayValue.values.some(t => H(this.value.arrayValue, t));
    }
}

/**
 * The direction of sorting in an order by.
 */ class xt {
    constructor(t) {
        this.name = t;
    }
    toString() {
        return this.name;
    }
}

xt.ASCENDING = new xt("asc"), xt.DESCENDING = new xt("desc");

/**
 * Represents a bound of a query.
 *
 * The bound is specified with the given components representing a position and
 * whether it's just before or just after the position (relative to whatever the
 * query order is).
 *
 * The position represents a logical index position for a query. It's a prefix
 * of values for the (potentially implicit) order by clauses of a query.
 *
 * Bound provides a function to determine whether a document comes before or
 * after a bound. This is influenced by whether the position is just before or
 * just after the provided values.
 */
class Bt {
    constructor(t, e) {
        this.position = t, this.before = e;
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        return `${this.before ? "b" : "a"}:${this.position.map(t => X(t)).join(",")}`;
    }
    /**
     * Returns true if a document sorts before a bound using the provided sort
     * order.
     */    Je(t, e) {
        let s = 0;
        for (let n = 0; n < this.position.length; n++) {
            const i = t[n], r = this.position[n];
            if (i.field.Y()) s = C.F(C.tt(r.referenceValue), e.key); else {
                s = J(r, e.field(i.field));
            }
            if (i.dir === xt.DESCENDING && (s *= -1), 0 !== s) break;
        }
        return this.before ? s <= 0 : s < 0;
    }
    isEqual(t) {
        if (null === t) return !1;
        if (this.before !== t.before || this.position.length !== t.position.length) return !1;
        for (let e = 0; e < this.position.length; e++) {
            if (!z(this.position[e], t.position[e])) return !1;
        }
        return !0;
    }
}

/**
 * An ordering on a field, in some Direction. Direction defaults to ASCENDING.
 */ class Ut {
    constructor(t, e) {
        this.field = t, void 0 === e && (e = xt.ASCENDING), this.dir = e, this.Xe = t.Y();
    }
    compare(t, e) {
        const s = this.Xe ? bt.Ee(t, e) : bt.Re(this.field, t, e);
        switch (this.dir) {
          case xt.ASCENDING:
            return s;

          case xt.DESCENDING:
            return -1 * s;

          default:
            return De("Unknown direction: " + this.dir);
        }
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        return this.field.K() + this.dir.toString();
    }
    toString() {
        return `${this.field.K()} (${this.dir})`;
    }
    isEqual(t) {
        return this.dir === t.dir && this.field.isEqual(t.field);
    }
}

const qt = new Ut(D.X(), xt.ASCENDING), Qt = new Ut(D.X(), xt.DESCENDING);

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An immutable set of metadata that the local store tracks for each target.
 */
class Wt {
    constructor(
    /** The target being listened to. */
    t, 
    /**
     * The target ID to which the target corresponds; Assigned by the
     * LocalStore for user listens and by the SyncEngine for limbo watches.
     */
    e, 
    /** The purpose of the target. */
    s, 
    /**
     * The sequence number of the last transaction during which this target data
     * was modified.
     */
    n, 
    /** The latest snapshot version seen for this target. */
    i = y.MIN
    /**
     * The maximum snapshot version at which the associated view
     * contained no limbo documents.
     */ , r = y.MIN
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */ , o = B.xt) {
        this.target = t, this.targetId = e, this.Ze = s, this.sequenceNumber = n, this.ts = i, 
        this.lastLimboFreeSnapshotVersion = r, this.resumeToken = o;
    }
    /** Creates a new target data instance with an updated sequence number. */    es(t) {
        return new Wt(this.target, this.targetId, this.Ze, t, this.ts, this.lastLimboFreeSnapshotVersion, this.resumeToken);
    }
    /**
     * Creates a new target data instance with an updated resume token and
     * snapshot version.
     */    ss(t, e) {
        return new Wt(this.target, this.targetId, this.Ze, this.sequenceNumber, e, this.lastLimboFreeSnapshotVersion, t);
    }
    /**
     * Creates a new target data instance with an updated last limbo free
     * snapshot version number.
     */    ns(t) {
        return new Wt(this.target, this.targetId, this.Ze, this.sequenceNumber, this.ts, t, this.resumeToken);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class jt {
    // TODO(b/33078163): just use simplest form of existence filter for now
    constructor(t) {
        this.count = t;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Error Codes describing the different ways GRPC can fail. These are copied
 * directly from GRPC's sources here:
 *
 * https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
 *
 * Important! The names of these identifiers matter because the string forms
 * are used for reverse lookups from the webchannel stream. Do NOT change the
 * names of these identifiers or change this into a const enum.
 */ var Kt, Gt;

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a non-write operation.
 *
 * See isPermanentWriteError for classifying write errors.
 */
function zt(t) {
    switch (t) {
      case w.OK:
        return De("Treated status OK as error");

      case w.CANCELLED:
      case w.UNKNOWN:
      case w.DEADLINE_EXCEEDED:
      case w.RESOURCE_EXHAUSTED:
      case w.INTERNAL:
      case w.UNAVAILABLE:
 // Unauthenticated means something went wrong with our token and we need
        // to retry with new credentials which will happen automatically.
              case w.UNAUTHENTICATED:
        return !1;

      case w.INVALID_ARGUMENT:
      case w.NOT_FOUND:
      case w.ALREADY_EXISTS:
      case w.PERMISSION_DENIED:
      case w.FAILED_PRECONDITION:
 // Aborted might be retried in some scenarios, but that is dependant on
        // the context and should handled individually by the calling code.
        // See https://cloud.google.com/apis/design/errors.
              case w.ABORTED:
      case w.OUT_OF_RANGE:
      case w.UNIMPLEMENTED:
      case w.DATA_LOSS:
        return !0;

      default:
        return De("Unknown status code: " + t);
    }
}

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a write operation.
 *
 * Write operations must be handled specially because as of b/119437764, ABORTED
 * errors on the write stream should be retried too (even though ABORTED errors
 * are not generally retryable).
 *
 * Note that during the initial handshake on the write stream an ABORTED error
 * signals that we should discard our stream token (i.e. it is permanent). This
 * means a handshake error should be classified with isPermanentError, above.
 */
/**
 * Maps an error Code from GRPC status code number, like 0, 1, or 14. These
 * are not the same as HTTP status codes.
 *
 * @returns The Code equivalent to the given GRPC status code. Fails if there
 *     is no match.
 */
function Ht(t) {
    if (void 0 === t) 
    // This shouldn't normally happen, but in certain error cases (like trying
    // to send invalid proto messages) we may get an error with no GRPC code.
    return ve("GRPC error has no .code"), w.UNKNOWN;
    switch (t) {
      case Kt.OK:
        return w.OK;

      case Kt.CANCELLED:
        return w.CANCELLED;

      case Kt.UNKNOWN:
        return w.UNKNOWN;

      case Kt.DEADLINE_EXCEEDED:
        return w.DEADLINE_EXCEEDED;

      case Kt.RESOURCE_EXHAUSTED:
        return w.RESOURCE_EXHAUSTED;

      case Kt.INTERNAL:
        return w.INTERNAL;

      case Kt.UNAVAILABLE:
        return w.UNAVAILABLE;

      case Kt.UNAUTHENTICATED:
        return w.UNAUTHENTICATED;

      case Kt.INVALID_ARGUMENT:
        return w.INVALID_ARGUMENT;

      case Kt.NOT_FOUND:
        return w.NOT_FOUND;

      case Kt.ALREADY_EXISTS:
        return w.ALREADY_EXISTS;

      case Kt.PERMISSION_DENIED:
        return w.PERMISSION_DENIED;

      case Kt.FAILED_PRECONDITION:
        return w.FAILED_PRECONDITION;

      case Kt.ABORTED:
        return w.ABORTED;

      case Kt.OUT_OF_RANGE:
        return w.OUT_OF_RANGE;

      case Kt.UNIMPLEMENTED:
        return w.UNIMPLEMENTED;

      case Kt.DATA_LOSS:
        return w.DATA_LOSS;

      default:
        return De("Unknown status code: " + t);
    }
}

/**
 * Converts an HTTP response's error status to the equivalent error code.
 *
 * @param status An HTTP error response status ("FAILED_PRECONDITION",
 * "UNKNOWN", etc.)
 * @returns The equivalent Code. Non-matching responses are mapped to
 *     Code.UNKNOWN.
 */ (Gt = Kt || (Kt = {}))[Gt.OK = 0] = "OK", Gt[Gt.CANCELLED = 1] = "CANCELLED", 
Gt[Gt.UNKNOWN = 2] = "UNKNOWN", Gt[Gt.INVALID_ARGUMENT = 3] = "INVALID_ARGUMENT", 
Gt[Gt.DEADLINE_EXCEEDED = 4] = "DEADLINE_EXCEEDED", Gt[Gt.NOT_FOUND = 5] = "NOT_FOUND", 
Gt[Gt.ALREADY_EXISTS = 6] = "ALREADY_EXISTS", Gt[Gt.PERMISSION_DENIED = 7] = "PERMISSION_DENIED", 
Gt[Gt.UNAUTHENTICATED = 16] = "UNAUTHENTICATED", Gt[Gt.RESOURCE_EXHAUSTED = 8] = "RESOURCE_EXHAUSTED", 
Gt[Gt.FAILED_PRECONDITION = 9] = "FAILED_PRECONDITION", Gt[Gt.ABORTED = 10] = "ABORTED", 
Gt[Gt.OUT_OF_RANGE = 11] = "OUT_OF_RANGE", Gt[Gt.UNIMPLEMENTED = 12] = "UNIMPLEMENTED", 
Gt[Gt.INTERNAL = 13] = "INTERNAL", Gt[Gt.UNAVAILABLE = 14] = "UNAVAILABLE", Gt[Gt.DATA_LOSS = 15] = "DATA_LOSS";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Jt = new k(C.F);

function Yt() {
    return Jt;
}

function Xt() {
    return Yt();
}

const Zt = new k(C.F);

function te() {
    return Zt;
}

const ee = new k(C.F);

function se() {
    return ee;
}

const ne = new $(C.F);

function ie(...t) {
    let e = ne;
    for (const s of t) e = e.add(s);
    return e;
}

const re = new $(Ne);

function oe() {
    return re;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentSet is an immutable (copy-on-write) collection that holds documents
 * in order specified by the provided comparator. We always add a document key
 * comparator on top of what is provided to guarantee document equality based on
 * the key.
 */ class he {
    /** The default ordering is by key if the comparator is omitted */
    constructor(t) {
        // We are adding document key comparator to the end as it's the only
        // guaranteed unique property of a document.
        this.F = t ? (e, s) => t(e, s) || C.F(e.key, s.key) : (t, e) => C.F(t.key, e.key), 
        this.rs = te(), this.os = new k(this.F);
    }
    /**
     * Returns an empty copy of the existing DocumentSet, using the same
     * comparator.
     */    static hs(t) {
        return new he(t.F);
    }
    has(t) {
        return null != this.rs.get(t);
    }
    get(t) {
        return this.rs.get(t);
    }
    first() {
        return this.os.ht();
    }
    last() {
        return this.os.at();
    }
    U() {
        return this.os.U();
    }
    /**
     * Returns the index of the provided key in the document set, or -1 if the
     * document key is not present in the set;
     */    indexOf(t) {
        const e = this.rs.get(t);
        return e ? this.os.indexOf(e) : -1;
    }
    get size() {
        return this.os.size;
    }
    /** Iterates documents in order defined by "comparator" */    forEach(t) {
        this.os.ut((e, s) => (t(e), !1));
    }
    /** Inserts or updates a document with the same key */    add(t) {
        // First remove the element if we have it.
        const e = this.delete(t.key);
        return e.rt(e.rs.it(t.key, t), e.os.it(t, null));
    }
    /** Deletes a document with a given key */    delete(t) {
        const e = this.get(t);
        return e ? this.rt(this.rs.remove(t), this.os.remove(e)) : this;
    }
    isEqual(t) {
        if (!(t instanceof he)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.os._t(), s = t.os._t();
        for (;e.It(); ) {
            const t = e.wt().key, n = s.wt().key;
            if (!t.isEqual(n)) return !1;
        }
        return !0;
    }
    toString() {
        const t = [];
        return this.forEach(e => {
            t.push(e.toString());
        }), 0 === t.length ? "DocumentSet ()" : "DocumentSet (\n  " + t.join("  \n") + "\n)";
    }
    rt(t, e) {
        const s = new he;
        return s.F = this.F, s.rs = t, s.os = e, s;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentChangeSet keeps track of a set of changes to docs in a query, merging
 * duplicate events for the same doc.
 */ class ae {
    constructor() {
        this.as = new k(C.F);
    }
    track(t) {
        const e = t.doc.key, s = this.as.get(e);
        s ? 
        // Merge the new change with the existing change.
        0 /* Added */ !== t.type && 3 /* Metadata */ === s.type ? this.as = this.as.it(e, t) : 3 /* Metadata */ === t.type && 1 /* Removed */ !== s.type ? this.as = this.as.it(e, {
            type: s.type,
            doc: t.doc
        }) : 2 /* Modified */ === t.type && 2 /* Modified */ === s.type ? this.as = this.as.it(e, {
            type: 2 /* Modified */ ,
            doc: t.doc
        }) : 2 /* Modified */ === t.type && 0 /* Added */ === s.type ? this.as = this.as.it(e, {
            type: 0 /* Added */ ,
            doc: t.doc
        }) : 1 /* Removed */ === t.type && 0 /* Added */ === s.type ? this.as = this.as.remove(e) : 1 /* Removed */ === t.type && 2 /* Modified */ === s.type ? this.as = this.as.it(e, {
            type: 1 /* Removed */ ,
            doc: s.doc
        }) : 0 /* Added */ === t.type && 1 /* Removed */ === s.type ? this.as = this.as.it(e, {
            type: 2 /* Modified */ ,
            doc: t.doc
        }) : 
        // This includes these cases, which don't make sense:
        // Added->Added
        // Removed->Removed
        // Modified->Added
        // Removed->Modified
        // Metadata->Added
        // Removed->Metadata
        De("unsupported combination of changes: " + JSON.stringify(t) + " after " + JSON.stringify(s)) : this.as = this.as.it(e, t);
    }
    us() {
        const t = [];
        return this.as.ut((e, s) => {
            t.push(s);
        }), t;
    }
}

class ue {
    constructor(t, e, s, n, i, r, o, h) {
        this.query = t, this.docs = e, this.cs = s, this.docChanges = n, this._s = i, this.fromCache = r, 
        this.ls = o, this.ds = h;
    }
    /** Returns a view snapshot as if all documents in the snapshot were added. */    static fs(t, e, s, n) {
        const i = [];
        return e.forEach(t => {
            i.push({
                type: 0 /* Added */ ,
                doc: t
            });
        }), new ue(t, e, he.hs(e), i, s, n, 
        /* syncStateChanged= */ !0, 
        /* excludesMetadataChanges= */ !1);
    }
    get hasPendingWrites() {
        return !this._s.U();
    }
    isEqual(t) {
        if (!(this.fromCache === t.fromCache && this.ls === t.ls && this._s.isEqual(t._s) && this.query.isEqual(t.query) && this.docs.isEqual(t.docs) && this.cs.isEqual(t.cs))) return !1;
        const e = this.docChanges, s = t.docChanges;
        if (e.length !== s.length) return !1;
        for (let t = 0; t < e.length; t++) if (e[t].type !== s[t].type || !e[t].doc.isEqual(s[t].doc)) return !1;
        return !0;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An event from the RemoteStore. It is split into targetChanges (changes to the
 * state or the set of documents in our watched targets) and documentUpdates
 * (changes to the actual documents).
 */ class ce {
    constructor(
    /**
     * The snapshot version this event brings us up to, or MIN if not set.
     */
    t, 
    /**
     * A map from target to changes to the target. See TargetChange.
     */
    e, 
    /**
     * A set of targets that is known to be inconsistent. Listens for these
     * targets should be re-established without resume tokens.
     */
    s, 
    /**
     * A set of which documents have changed or been deleted, along with the
     * doc's new values (if not deleted).
     */
    n, 
    /**
     * A set of which document updates are due only to limbo resolution targets.
     */
    i) {
        this.ts = t, this.Ts = e, this.ms = s, this.Es = n, this.ws = i;
    }
    /**
     * HACK: Views require RemoteEvents in order to determine whether the view is
     * CURRENT, but secondary tabs don't receive remote events. So this method is
     * used to create a synthesized RemoteEvent that can be used to apply a
     * CURRENT status change to a View, for queries executed in a different tab.
     */
    // PORTING NOTE: Multi-tab only
    static Is(t, e) {
        const s = new Map;
        return s.set(t, _e.Rs(t, e)), new ce(y.MIN, s, oe(), Yt(), ie());
    }
}

/**
 * A TargetChange specifies the set of changes for a specific target as part of
 * a RemoteEvent. These changes track which documents are added, modified or
 * removed, as well as the target's resume token and whether the target is
 * marked CURRENT.
 * The actual changes *to* documents are not part of the TargetChange since
 * documents may be part of multiple targets.
 */ class _e {
    constructor(
    /**
     * An opaque, server-assigned token that allows watching a query to be resumed
     * after disconnecting without retransmitting all the data that matches the
     * query. The resume token essentially identifies a point in time from which
     * the server should resume sending results.
     */
    t, 
    /**
     * The "current" (synced) status of this target. Note that "current"
     * has special meaning in the RPC protocol that implies that a target is
     * both up-to-date and consistent with the rest of the watch stream.
     */
    e, 
    /**
     * The set of documents that were newly assigned to this target as part of
     * this remote event.
     */
    s, 
    /**
     * The set of documents that were already assigned to this target but received
     * an update during this remote event.
     */
    n, 
    /**
     * The set of documents that were removed from this target as part of this
     * remote event.
     */
    i) {
        this.resumeToken = t, this.As = e, this.Ps = s, this.Vs = n, this.gs = i;
    }
    /**
     * This method is used to create a synthesized TargetChanges that can be used to
     * apply a CURRENT status change to a View (for queries executed in a different
     * tab) or for new queries (to raise snapshots with correct CURRENT status).
     */    static Rs(t, e) {
        return new _e(B.xt, e, ie(), ie(), ie());
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents a changed document and a list of target ids to which this change
 * applies.
 *
 * If document has been deleted NoDocument will be provided.
 */ class le {
    constructor(
    /** The new document applies to all of these targets. */
    t, 
    /** The new document is removed from all of these targets. */
    e, 
    /** The key of the document for this change. */
    s, 
    /**
     * The new document or NoDocument if it was deleted. Is null if the
     * document went out of view without the server sending a new document.
     */
    n) {
        this.ps = t, this.removedTargetIds = e, this.key = s, this.ys = n;
    }
}

class de {
    constructor(t, e) {
        this.targetId = t, this.bs = e;
    }
}

class fe {
    constructor(
    /** What kind of change occurred to the watch target. */
    t, 
    /** The target IDs that were added/removed/set. */
    e, 
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */
    s = B.xt
    /** An RPC error indicating why the watch failed. */ , n = null) {
        this.state = t, this.targetIds = e, this.resumeToken = s, this.cause = n;
    }
}

/** Tracks the internal state of a Watch target. */ class Te {
    constructor() {
        /**
         * The number of pending responses (adds or removes) that we are waiting on.
         * We only consider targets active that have no pending responses.
         */
        this.vs = 0, 
        /**
         * Keeps track of the document changes since the last raised snapshot.
         *
         * These changes are continuously updated as we receive document updates and
         * always reflect the current set of changes against the last issued snapshot.
         */
        this.Ss = we(), 
        /** See public getters for explanations of these fields. */
        this.Ds = B.xt, this.Cs = !1, 
        /**
         * Whether this target state should be included in the next snapshot. We
         * initialize to true so that newly-added targets are included in the next
         * RemoteEvent.
         */
        this.ks = !0;
    }
    /**
     * Whether this target has been marked 'current'.
     *
     * 'Current' has special meaning in the RPC protocol: It implies that the
     * Watch backend has sent us all changes up to the point at which the target
     * was added and that the target is consistent with the rest of the watch
     * stream.
     */    get As() {
        return this.Cs;
    }
    /** The last resume token sent to us for this target. */    get resumeToken() {
        return this.Ds;
    }
    /** Whether this target has pending target adds or target removes. */    get Ns() {
        return 0 !== this.vs;
    }
    /** Whether we have modified any state that should trigger a snapshot. */    get Fs() {
        return this.ks;
    }
    /**
     * Applies the resume token to the TargetChange, but only when it has a new
     * value. Empty resumeTokens are discarded.
     */    $s(t) {
        t.Ot() > 0 && (this.ks = !0, this.Ds = t);
    }
    /**
     * Creates a target change from the current set of changes.
     *
     * To reset the document changes after raising this snapshot, call
     * `clearPendingChanges()`.
     */    Ms() {
        let t = ie(), e = ie(), s = ie();
        return this.Ss.forEach((n, i) => {
            switch (i) {
              case 0 /* Added */ :
                t = t.add(n);
                break;

              case 2 /* Modified */ :
                e = e.add(n);
                break;

              case 1 /* Removed */ :
                s = s.add(n);
                break;

              default:
                De("Encountered invalid change type: " + i);
            }
        }), new _e(this.Ds, this.Cs, t, e, s);
    }
    /**
     * Resets the document changes and sets `hasPendingChanges` to false.
     */    Ls() {
        this.ks = !1, this.Ss = we();
    }
    Os(t, e) {
        this.ks = !0, this.Ss = this.Ss.it(t, e);
    }
    xs(t) {
        this.ks = !0, this.Ss = this.Ss.remove(t);
    }
    Bs() {
        this.vs += 1;
    }
    Us() {
        this.vs -= 1;
    }
    qs() {
        this.ks = !0, this.Cs = !0;
    }
}

/**
 * A helper class to accumulate watch changes into a RemoteEvent.
 */
class me {
    constructor(t) {
        this.Qs = t, 
        /** The internal state of all tracked targets. */
        this.Ws = new Map, 
        /** Keeps track of the documents to update since the last raised snapshot. */
        this.js = Yt(), 
        /** A mapping of document keys to their set of target IDs. */
        this.Ks = Ee(), 
        /**
         * A list of targets with existence filter mismatches. These targets are
         * known to be inconsistent and their listens needs to be re-established by
         * RemoteStore.
         */
        this.Gs = new $(Ne);
    }
    /**
     * Processes and adds the DocumentWatchChange to the current set of changes.
     */    zs(t) {
        for (const e of t.ps) t.ys instanceof bt ? this.Hs(e, t.ys) : t.ys instanceof vt && this.Js(e, t.key, t.ys);
        for (const e of t.removedTargetIds) this.Js(e, t.key, t.ys);
    }
    /** Processes and adds the WatchTargetChange to the current set of changes. */    Ys(t) {
        this.Xs(t, e => {
            const s = this.Zs(e);
            switch (t.state) {
              case 0 /* NoChange */ :
                this.tn(e) && s.$s(t.resumeToken);
                break;

              case 1 /* Added */ :
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Us(), s.Ns || 
                // We have a freshly added target, so we need to reset any state
                // that we had previously. This can happen e.g. when remove and add
                // back a target for existence filter mismatches.
                s.Ls(), s.$s(t.resumeToken);
                break;

              case 2 /* Removed */ :
                // We need to keep track of removed targets to we can post-filter and
                // remove any target changes.
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Us(), s.Ns || this.removeTarget(e);
                break;

              case 3 /* Current */ :
                this.tn(e) && (s.qs(), s.$s(t.resumeToken));
                break;

              case 4 /* Reset */ :
                this.tn(e) && (
                // Reset the target and synthesizes removes for all existing
                // documents. The backend will re-add any documents that still
                // match the target before it sends the next global snapshot.
                this.en(e), s.$s(t.resumeToken));
                break;

              default:
                De("Unknown target watch change state: " + t.state);
            }
        });
    }
    /**
     * Iterates over all targetIds that the watch change applies to: either the
     * targetIds explicitly listed in the change or the targetIds of all currently
     * active targets.
     */    Xs(t, e) {
        t.targetIds.length > 0 ? t.targetIds.forEach(e) : this.Ws.forEach((t, s) => {
            this.tn(s) && e(s);
        });
    }
    /**
     * Handles existence filters and synthesizes deletes for filter mismatches.
     * Targets that are invalidated by filter mismatches are added to
     * `pendingTargetResets`.
     */    sn(t) {
        const e = t.targetId, s = t.bs.count, n = this.nn(e);
        if (n) {
            const t = n.target;
            if (t.Pe()) if (0 === s) {
                // The existence filter told us the document does not exist. We deduce
                // that this document does not exist and apply a deleted document to
                // our updates. Without applying this deleted document there might be
                // another query that will raise this document as part of a snapshot
                // until it is resolved, essentially exposing inconsistency between
                // queries.
                const s = new C(t.path);
                this.Js(e, s, new vt(s, y.S()));
            } else Ce(1 === s, "Single document existence filter with count: " + s); else {
                this.in(e) !== s && (
                // Existence filter mismatch: We reset the mapping and raise a new
                // snapshot with `isFromCache:true`.
                this.en(e), this.Gs = this.Gs.add(e));
            }
        }
    }
    /**
     * Converts the currently accumulated state into a remote event at the
     * provided snapshot version. Resets the accumulated changes before returning.
     */    rn(t) {
        const e = new Map;
        this.Ws.forEach((s, n) => {
            const i = this.nn(n);
            if (i) {
                if (s.As && i.target.Pe()) {
                    // Document queries for document that don't exist can produce an empty
                    // result set. To update our local cache, we synthesize a document
                    // delete if we have not previously received the document. This
                    // resolves the limbo state of the document, removing it from
                    // limboDocumentRefs.
                    // TODO(dimond): Ideally we would have an explicit lookup target
                    // instead resulting in an explicit delete message and we could
                    // remove this special logic.
                    const e = new C(i.target.path);
                    null !== this.js.get(e) || this.on(n, e) || this.Js(n, e, new vt(e, t));
                }
                s.Fs && (e.set(n, s.Ms()), s.Ls());
            }
        });
        let s = ie();
        // We extract the set of limbo-only document updates as the GC logic
        // special-cases documents that do not appear in the target cache.
        
        // TODO(gsoltis): Expand on this comment once GC is available in the JS
        // client.
                this.Ks.forEach((t, e) => {
            let n = !0;
            e.kt(t => {
                const e = this.nn(t);
                return !e || 2 /* LimboResolution */ === e.Ze || (n = !1, !1);
            }), n && (s = s.add(t));
        });
        const n = new ce(t, e, this.Gs, this.js, s);
        return this.js = Yt(), this.Ks = Ee(), this.Gs = new $(Ne), n;
    }
    /**
     * Adds the provided document to the internal list of document updates and
     * its document key to the given target's mapping.
     */
    // Visible for testing.
    Hs(t, e) {
        if (!this.tn(t)) return;
        const s = this.on(t, e.key) ? 2 /* Modified */ : 0 /* Added */;
        this.Zs(t).Os(e.key, s), this.js = this.js.it(e.key, e), this.Ks = this.Ks.it(e.key, this.hn(e.key).add(t));
    }
    /**
     * Removes the provided document from the target mapping. If the
     * document no longer matches the target, but the document's state is still
     * known (e.g. we know that the document was deleted or we received the change
     * that caused the filter mismatch), the new document can be provided
     * to update the remote document cache.
     */
    // Visible for testing.
    Js(t, e, s) {
        if (!this.tn(t)) return;
        const n = this.Zs(t);
        this.on(t, e) ? n.Os(e, 1 /* Removed */) : 
        // The document may have entered and left the target before we raised a
        // snapshot, so we can just ignore the change.
        n.xs(e), this.Ks = this.Ks.it(e, this.hn(e).delete(t)), s && (this.js = this.js.it(e, s));
    }
    removeTarget(t) {
        this.Ws.delete(t);
    }
    /**
     * Returns the current count of documents in the target. This includes both
     * the number of documents that the LocalStore considers to be part of the
     * target as well as any accumulated changes.
     */    in(t) {
        const e = this.Zs(t).Ms();
        return this.Qs.an(t).size + e.Ps.size - e.gs.size;
    }
    /**
     * Increment the number of acks needed from watch before we can consider the
     * server to be 'in-sync' with the client's active targets.
     */    Bs(t) {
        this.Zs(t).Bs();
    }
    Zs(t) {
        let e = this.Ws.get(t);
        return e || (e = new Te, this.Ws.set(t, e)), e;
    }
    hn(t) {
        let e = this.Ks.get(t);
        return e || (e = new $(Ne), this.Ks = this.Ks.it(t, e)), e;
    }
    /**
     * Verifies that the user is still interested in this target (by calling
     * `getTargetDataForTarget()`) and that we are not waiting for pending ADDs
     * from watch.
     */    tn(t) {
        const e = null !== this.nn(t);
        return e || be("WatchChangeAggregator", "Detected inactive target", t), e;
    }
    /**
     * Returns the TargetData for an active target (i.e. a target that the user
     * is still interested in that has no outstanding target change requests).
     */    nn(t) {
        const e = this.Ws.get(t);
        return e && e.Ns ? null : this.Qs.un(t);
    }
    /**
     * Resets the state of a Watch target to its initial state (e.g. sets
     * 'current' to false, clears the resume token and removes its target mapping
     * from all documents).
     */    en(t) {
        this.Ws.set(t, new Te), this.Qs.an(t).forEach(e => {
            this.Js(t, e, /*updatedDocument=*/ null);
        });
    }
    /**
     * Returns whether the LocalStore considers the document to be part of the
     * specified target.
     */    on(t, e) {
        return this.Qs.an(t).has(e);
    }
}

function Ee() {
    return new k(C.F);
}

function we() {
    return new k(C.F);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Ie = (() => {
    const t = {};
    return t[xt.ASCENDING.name] = "ASCENDING", t[xt.DESCENDING.name] = "DESCENDING", 
    t;
})(), Re = (() => {
    const t = {};
    return t[kt.LESS_THAN.name] = "LESS_THAN", t[kt.LESS_THAN_OR_EQUAL.name] = "LESS_THAN_OR_EQUAL", 
    t[kt.GREATER_THAN.name] = "GREATER_THAN", t[kt.GREATER_THAN_OR_EQUAL.name] = "GREATER_THAN_OR_EQUAL", 
    t[kt.EQUAL.name] = "EQUAL", t[kt.ARRAY_CONTAINS.name] = "ARRAY_CONTAINS", t[kt.IN.name] = "IN", 
    t[kt.ARRAY_CONTAINS_ANY.name] = "ARRAY_CONTAINS_ANY", t;
})();

/**
 * Generates JsonObject values for the Datastore API suitable for sending to
 * either GRPC stub methods or via the JSON/HTTP REST API.
 * TODO(klimt): We can remove the databaseId argument if we keep the full
 * resource name in documents.
 */
class Ae {
    constructor(t, e) {
        this.cn = t, this.options = e;
    }
    _n(t) {
        const e = void 0 === t.code ? w.UNKNOWN : Ht(t.code);
        return new I(e, t.message || "");
    }
    /**
     * Returns a value for a number (or null) that's appropriate to put into
     * a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "number" because that's what
     * our generated proto interfaces say Int32Value must be. But GRPC actually
     * expects a { value: <number> } struct.
     */    ln(t) {
        return this.options.dn || U(t) ? t : {
            value: t
        };
    }
    /**
     * Returns a number (or null) from a google.protobuf.Int32Value proto.
     */    fn(t) {
        let e;
        return e = "object" == typeof t ? t.value : t, U(e) ? null : e;
    }
    /**
     * Returns an IntegerValue for `value`.
     */    Wt(t) {
        return {
            integerValue: "" + t
        };
    }
    /**
     * Returns an DoubleValue for `value` that is encoded based the serializer's
     * `useProto3Json` setting.
     */    jt(t) {
        if (this.options.dn) {
            if (isNaN(t)) return {
                doubleValue: "NaN"
            };
            if (t === 1 / 0) return {
                doubleValue: "Infinity"
            };
            if (t === -1 / 0) return {
                doubleValue: "-Infinity"
            };
        }
        return {
            doubleValue: q(t) ? "-0" : t
        };
    }
    /**
     * Returns a value for a number that's appropriate to put into a proto.
     * The return value is an IntegerValue if it can safely represent the value,
     * otherwise a DoubleValue is returned.
     */    Tn(t) {
        return Q(t) ? this.Wt(t) : this.jt(t);
    }
    /**
     * Returns a value for a Date that's appropriate to put into a proto.
     */    k(t) {
        if (this.options.dn) {
            return `${new Date(1e3 * t.seconds).toISOString().replace(/\.\d*/, "").replace("Z", "")}.${("000000000" + t.nanoseconds).slice(-9)}Z`;
        }
        return {
            seconds: "" + t.seconds,
            nanos: t.nanoseconds
        };
    }
    v(t) {
        const e = tt(t);
        return new p(e.seconds, e.nanos);
    }
    /**
     * Returns a value for bytes that's appropriate to put in a proto.
     *
     * Visible for testing.
     */    mn(t) {
        return this.options.dn ? t.toBase64() : t.toUint8Array();
    }
    /**
     * Returns a ByteString based on the proto string value.
     */    En(t) {
        return this.options.dn ? (Ce(void 0 === t || "string" == typeof t, "value must be undefined or a string when using proto3 Json"), 
        B.fromBase64String(t || "")) : (Ce(void 0 === t || t instanceof Uint8Array, "value must be undefined or Uint8Array"), 
        B.fromUint8Array(t || new Uint8Array));
    }
    toVersion(t) {
        return this.k(t.k());
    }
    fromVersion(t) {
        return Ce(!!t, "Trying to deserialize version that isn't set"), y.v(this.v(t));
    }
    wn(t, e) {
        return this.In(e || this.cn).child("documents").child(t).K();
    }
    Rn(t) {
        const e = v.G(t);
        return Ce(Pe(e), "Tried to deserialize invalid key " + e.toString()), e;
    }
    An(t) {
        return this.wn(t.path);
    }
    tt(t) {
        const e = this.Rn(t);
        return Ce(e.get(1) === this.cn.projectId, "Tried to deserialize key from different project: " + e.get(1) + " vs " + this.cn.projectId), 
        Ce(!e.get(3) && !this.cn.database || e.get(3) === this.cn.database, "Tried to deserialize key from different database: " + e.get(3) + " vs " + this.cn.database), 
        new C(this.Pn(e));
    }
    Vn(t) {
        return this.wn(t);
    }
    gn(t) {
        const e = this.Rn(t);
        // In v1beta1 queries for collections at the root did not have a trailing
        // "/documents". In v1 all resource paths contain "/documents". Preserve the
        // ability to read the v1beta1 form for compatibility with queries persisted
        // in the local target cache.
                return 4 === e.length ? v.H : this.Pn(e);
    }
    get pn() {
        return new v([ "projects", this.cn.projectId, "databases", this.cn.database ]).K();
    }
    In(t) {
        return new v([ "projects", t.projectId, "databases", t.database ]);
    }
    Pn(t) {
        return Ce(t.length > 4 && "documents" === t.get(4), "tried to deserialize invalid key " + t.toString()), 
        t.M(5);
    }
    /** Creates an api.Document from key and fields (but no create/update time) */    yn(t, e) {
        return {
            name: this.An(t),
            fields: e.proto.mapValue.fields
        };
    }
    bn(t) {
        return {
            name: this.An(t.key),
            fields: t.Ie().mapValue.fields,
            updateTime: this.k(t.version.k())
        };
    }
    vn(t, e) {
        const s = this.tt(t.name), n = this.fromVersion(t.updateTime), i = new gt({
            mapValue: {
                fields: t.fields
            }
        });
        return new bt(s, n, i, {
            hasCommittedMutations: !!e
        });
    }
    Sn(t) {
        Ce(!!t.found, "Tried to deserialize a found document from a missing document."), 
        t.found.name, t.found.updateTime;
        const e = this.tt(t.found.name), s = this.fromVersion(t.found.updateTime), n = new gt({
            mapValue: {
                fields: t.found.fields
            }
        });
        return new bt(e, s, n, {});
    }
    Dn(t) {
        Ce(!!t.missing, "Tried to deserialize a missing document from a found document."), 
        Ce(!!t.readTime, "Tried to deserialize a missing document without a read time.");
        const e = this.tt(t.missing), s = this.fromVersion(t.readTime);
        return new vt(e, s);
    }
    Cn(t) {
        return "found" in t ? this.Sn(t) : "missing" in t ? this.Dn(t) : De("invalid batch get response: " + JSON.stringify(t));
    }
    kn(t) {
        let e;
        if ("targetChange" in t) {
            t.targetChange;
            // proto3 default value is unset in JSON (undefined), so use 'NO_CHANGE'
            // if unset
            const s = this.Nn(t.targetChange.targetChangeType || "NO_CHANGE"), n = t.targetChange.targetIds || [], i = this.En(t.targetChange.resumeToken), r = t.targetChange.cause, o = r && this._n(r);
            e = new fe(s, n, i, o || null);
        } else if ("documentChange" in t) {
            t.documentChange;
            const s = t.documentChange;
            s.document, s.document.name, s.document.updateTime;
            const n = this.tt(s.document.name), i = this.fromVersion(s.document.updateTime), r = new gt({
                mapValue: {
                    fields: s.document.fields
                }
            }), o = new bt(n, i, r, {}), h = s.targetIds || [], a = s.removedTargetIds || [];
            e = new le(h, a, o.key, o);
        } else if ("documentDelete" in t) {
            t.documentDelete;
            const s = t.documentDelete;
            s.document;
            const n = this.tt(s.document), i = s.readTime ? this.fromVersion(s.readTime) : y.S(), r = new vt(n, i), o = s.removedTargetIds || [];
            e = new le([], o, r.key, r);
        } else if ("documentRemove" in t) {
            t.documentRemove;
            const s = t.documentRemove;
            s.document;
            const n = this.tt(s.document), i = s.removedTargetIds || [];
            e = new le([], i, n, null);
        } else {
            if (!("filter" in t)) return De("Unknown change type " + JSON.stringify(t));
            {
                t.filter;
                const s = t.filter;
                s.targetId;
                const n = s.count || 0, i = new jt(n), r = s.targetId;
                e = new de(r, i);
            }
        }
        return e;
    }
    Nn(t) {
        return "NO_CHANGE" === t ? 0 /* NoChange */ : "ADD" === t ? 1 /* Added */ : "REMOVE" === t ? 2 /* Removed */ : "CURRENT" === t ? 3 /* Current */ : "RESET" === t ? 4 /* Reset */ : De("Got unexpected TargetChange.state: " + t);
    }
    Fn(t) {
        // We have only reached a consistent snapshot for the entire stream if there
        // is a read_time set and it applies to all targets (i.e. the list of
        // targets is empty). The backend is guaranteed to send such responses.
        if (!("targetChange" in t)) return y.MIN;
        const e = t.targetChange;
        return e.targetIds && e.targetIds.length ? y.MIN : e.readTime ? this.fromVersion(e.readTime) : y.MIN;
    }
    $n(t) {
        let e;
        if (t instanceof It) e = {
            update: this.yn(t.key, t.value)
        }; else if (t instanceof Pt) e = {
            delete: this.An(t.key)
        }; else if (t instanceof Rt) e = {
            update: this.yn(t.key, t.data),
            updateMask: this.Mn(t.se)
        }; else if (t instanceof At) e = {
            transform: {
                document: this.An(t.key),
                fieldTransforms: t.fieldTransforms.map(t => this.Ln(t))
            }
        }; else {
            if (!(t instanceof Vt)) return De("Unknown mutation type " + t.type);
            e = {
                verify: this.An(t.key)
            };
        }
        return t.Zt.Ht || (e.currentDocument = this.On(t.Zt)), e;
    }
    xn(t) {
        const e = t.currentDocument ? this.Bn(t.currentDocument) : Et.NONE;
        if (t.update) {
            t.update.name;
            const s = this.tt(t.update.name), n = new gt({
                mapValue: {
                    fields: t.update.fields
                }
            });
            if (t.updateMask) {
                const i = this.Un(t.updateMask);
                return new Rt(s, n, i, e);
            }
            return new It(s, n, e);
        }
        if (t.delete) {
            const s = this.tt(t.delete);
            return new Pt(s, e);
        }
        if (t.transform) {
            const s = this.tt(t.transform.document), n = t.transform.fieldTransforms.map(t => this.qn(t));
            return Ce(!0 === e.exists, 'Transforms only support precondition "exists == true"'), 
            new At(s, n);
        }
        if (t.verify) {
            const s = this.tt(t.verify);
            return new Vt(s, e);
        }
        return De("unknown mutation proto: " + JSON.stringify(t));
    }
    On(t) {
        return void 0 !== t.updateTime ? {
            updateTime: this.toVersion(t.updateTime)
        } : void 0 !== t.exists ? {
            exists: t.exists
        } : De("Unknown precondition");
    }
    Bn(t) {
        return void 0 !== t.updateTime ? Et.updateTime(this.fromVersion(t.updateTime)) : void 0 !== t.exists ? Et.exists(t.exists) : Et.NONE;
    }
    Qn(t, e) {
        // NOTE: Deletes don't have an updateTime.
        let s = t.updateTime ? this.fromVersion(t.updateTime) : this.fromVersion(e);
        s.isEqual(y.MIN) && (
        // The Firestore Emulator currently returns an update time of 0 for
        // deletes of non-existing documents (rather than null). This breaks the
        // test "get deleted doc while offline with source=cache" as NoDocuments
        // with version 0 are filtered by IndexedDb's RemoteDocumentCache.
        // TODO(#2149): Remove this when Emulator is fixed
        s = this.fromVersion(e));
        let n = null;
        return t.transformResults && t.transformResults.length > 0 && (n = t.transformResults), 
        new mt(s, n);
    }
    Wn(t, e) {
        return t && t.length > 0 ? (Ce(void 0 !== e, "Received a write result without a commit time"), 
        t.map(t => this.Qn(t, e))) : [];
    }
    Ln(t) {
        const e = t.transform;
        if (e instanceof ut) return {
            fieldPath: t.field.K(),
            setToServerValue: "REQUEST_TIME"
        };
        if (e instanceof ct) return {
            fieldPath: t.field.K(),
            appendMissingElements: {
                values: e.elements
            }
        };
        if (e instanceof _t) return {
            fieldPath: t.field.K(),
            removeAllFromArray: {
                values: e.elements
            }
        };
        if (e instanceof lt) return {
            fieldPath: t.field.K(),
            increment: e.Qt
        };
        throw De("Unknown transform: " + t.transform);
    }
    qn(t) {
        let e = null;
        if ("setToServerValue" in t) Ce("REQUEST_TIME" === t.setToServerValue, "Unknown server value transform proto: " + JSON.stringify(t)), 
        e = ut.instance; else if ("appendMissingElements" in t) {
            const s = t.appendMissingElements.values || [];
            e = new ct(s);
        } else if ("removeAllFromArray" in t) {
            const s = t.removeAllFromArray.values || [];
            e = new _t(s);
        } else "increment" in t ? e = new lt(this, t.increment) : De("Unknown transform proto: " + JSON.stringify(t));
        const s = D.Z(t.fieldPath);
        return new Tt(s, e);
    }
    jn(t) {
        return {
            documents: [ this.Vn(t.path) ]
        };
    }
    Kn(t) {
        const e = t.documents.length;
        Ce(1 === e, "DocumentsTarget contained other than 1 document: " + e);
        const s = t.documents[0];
        return Ct.ve(this.gn(s)).xe();
    }
    Gn(t) {
        // Dissect the path into parent, collectionId, and optional key filter.
        const e = {
            structuredQuery: {}
        }, s = t.path;
        null !== t.collectionGroup ? (e.parent = this.Vn(s), e.structuredQuery.from = [ {
            collectionId: t.collectionGroup,
            allDescendants: !0
        } ]) : (e.parent = this.Vn(s.L()), e.structuredQuery.from = [ {
            collectionId: s.B()
        } ]);
        const n = this.zn(t.filters);
        n && (e.structuredQuery.where = n);
        const i = this.Hn(t.orderBy);
        i && (e.structuredQuery.orderBy = i);
        const r = this.ln(t.limit);
        return null !== r && (e.structuredQuery.limit = r), t.startAt && (e.structuredQuery.startAt = this.Jn(t.startAt)), 
        t.endAt && (e.structuredQuery.endAt = this.Jn(t.endAt)), e;
    }
    Yn(t) {
        let e = this.gn(t.parent);
        const s = t.structuredQuery, n = s.from ? s.from.length : 0;
        let i = null;
        if (n > 0) {
            Ce(1 === n, "StructuredQuery.from with more than one collection is not supported.");
            const t = s.from[0];
            t.allDescendants ? i = t.collectionId : e = e.child(t.collectionId);
        }
        let r = [];
        s.where && (r = this.Xn(s.where));
        let o = [];
        s.orderBy && (o = this.Zn(s.orderBy));
        let h = null;
        s.limit && (h = this.fn(s.limit));
        let a = null;
        s.startAt && (a = this.ti(s.startAt));
        let u = null;
        return s.endAt && (u = this.ti(s.endAt)), new Ct(e, i, o, r, h, "F" /* First */ , a, u).xe();
    }
    ei(t) {
        const e = this.si(t.Ze);
        return null == e ? null : {
            "goog-listen-tags": e
        };
    }
    si(t) {
        switch (t) {
          case 0 /* Listen */ :
            return null;

          case 1 /* ExistenceFilterMismatch */ :
            return "existence-filter-mismatch";

          case 2 /* LimboResolution */ :
            return "limbo-document";

          default:
            return De("Unrecognized query purpose: " + t);
        }
    }
    xe(t) {
        let e;
        const s = t.target;
        return e = s.Pe() ? {
            documents: this.jn(s)
        } : {
            query: this.Gn(s)
        }, e.targetId = t.targetId, t.resumeToken.Ot() > 0 && (e.resumeToken = this.mn(t.resumeToken)), 
        e;
    }
    zn(t) {
        if (0 === t.length) return;
        const e = t.map(t => t instanceof Nt ? this.ni(t) : De("Unrecognized filter: " + JSON.stringify(t)));
        return 1 === e.length ? e[0] : {
            compositeFilter: {
                op: "AND",
                filters: e
            }
        };
    }
    Xn(t) {
        return t ? void 0 !== t.unaryFilter ? [ this.ii(t) ] : void 0 !== t.fieldFilter ? [ this.ri(t) ] : void 0 !== t.compositeFilter ? t.compositeFilter.filters.map(t => this.Xn(t)).reduce((t, e) => t.concat(e)) : De("Unknown filter: " + JSON.stringify(t)) : [];
    }
    Hn(t) {
        if (0 !== t.length) return t.map(t => this.oi(t));
    }
    Zn(t) {
        return t.map(t => this.hi(t));
    }
    Jn(t) {
        return {
            before: t.before,
            values: t.position
        };
    }
    ti(t) {
        const e = !!t.before, s = t.values || [];
        return new Bt(s, e);
    }
    // visible for testing
    ai(t) {
        return Ie[t.name];
    }
    // visible for testing
    ui(t) {
        switch (t) {
          case "ASCENDING":
            return xt.ASCENDING;

          case "DESCENDING":
            return xt.DESCENDING;

          default:
            return;
        }
    }
    // visible for testing
    ci(t) {
        return Re[t.name];
    }
    _i(t) {
        switch (t) {
          case "EQUAL":
            return kt.EQUAL;

          case "GREATER_THAN":
            return kt.GREATER_THAN;

          case "GREATER_THAN_OR_EQUAL":
            return kt.GREATER_THAN_OR_EQUAL;

          case "LESS_THAN":
            return kt.LESS_THAN;

          case "LESS_THAN_OR_EQUAL":
            return kt.LESS_THAN_OR_EQUAL;

          case "ARRAY_CONTAINS":
            return kt.ARRAY_CONTAINS;

          case "IN":
            return kt.IN;

          case "ARRAY_CONTAINS_ANY":
            return kt.ARRAY_CONTAINS_ANY;

          case "OPERATOR_UNSPECIFIED":
            return De("Unspecified operator");

          default:
            return De("Unknown operator");
        }
    }
    li(t) {
        return {
            fieldPath: t.K()
        };
    }
    di(t) {
        return D.Z(t.fieldPath);
    }
    // visible for testing
    oi(t) {
        return {
            field: this.li(t.field),
            direction: this.ai(t.dir)
        };
    }
    hi(t) {
        return new Ut(this.di(t.field), this.ui(t.direction));
    }
    ri(t) {
        return Nt.create(this.di(t.fieldFilter.field), this._i(t.fieldFilter.op), t.fieldFilter.value);
    }
    // visible for testing
    ni(t) {
        if (t.op === kt.EQUAL) {
            if (ht(t.value)) return {
                unaryFilter: {
                    field: this.li(t.field),
                    op: "IS_NAN"
                }
            };
            if (ot(t.value)) return {
                unaryFilter: {
                    field: this.li(t.field),
                    op: "IS_NULL"
                }
            };
        }
        return {
            fieldFilter: {
                field: this.li(t.field),
                op: this.ci(t.op),
                value: t.value
            }
        };
    }
    ii(t) {
        switch (t.unaryFilter.op) {
          case "IS_NAN":
            const e = this.di(t.unaryFilter.field);
            return Nt.create(e, kt.EQUAL, {
                doubleValue: NaN
            });

          case "IS_NULL":
            const s = this.di(t.unaryFilter.field);
            return Nt.create(s, kt.EQUAL, {
                nullValue: "NULL_VALUE"
            });

          case "OPERATOR_UNSPECIFIED":
            return De("Unspecified filter");

          default:
            return De("Unknown filter");
        }
    }
    Mn(t) {
        const e = [];
        return t.fields.forEach(t => e.push(t.K())), {
            fieldPaths: e
        };
    }
    Un(t) {
        const e = (t.fieldPaths || []).map(t => D.Z(t));
        return ft.Gt(e);
    }
}

function Pe(t) {
    // Resource names have at least 4 components (project ID, database ID)
    return t.length >= 4 && "projects" === t.get(0) && "databases" === t.get(2);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides singleton helpers where setup code can inject a platform at runtime.
 * setPlatform needs to be set before Firestore is used and must be set exactly
 * once.
 */ class Ve {
    static fi(t) {
        Ve.platform && De("Platform already defined"), Ve.platform = t;
    }
    static Lt() {
        return Ve.platform || De("Platform not set"), Ve.platform;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const ge = new e("@firebase/firestore");

// Helper methods are needed because variables can't be exported as read/write
function pe() {
    return ge.logLevel;
}

function ye(t) {
    ge.logLevel = t;
}

function be(t, ...e) {
    if (ge.logLevel <= s.DEBUG) {
        const s = e.map(Se);
        ge.debug(`Firestore (${m}): ${t}`, ...s);
    }
}

function ve(t, ...e) {
    if (ge.logLevel <= s.ERROR) {
        const s = e.map(Se);
        ge.error(`Firestore (${m}): ${t}`, ...s);
    }
}

/**
 * Converts an additional log parameter to a string representation.
 */ function Se(t) {
    if ("string" == typeof t) return t;
    {
        const e = Ve.Lt();
        try {
            return e.Ti(t);
        } catch (e) {
            // Converting to JSON failed, just log the object directly
            return t;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Unconditionally fails, throwing an Error with the given message.
 *
 * Returns `never` and can be used in expressions:
 * @example
 * let futureVar = fail('not implemented yet');
 */ function De(t) {
    // Log the failure in addition to throw an exception, just in case the
    // exception is swallowed.
    const e = `FIRESTORE (${m}) INTERNAL ASSERTION FAILED: ` + t;
    // NOTE: We don't use FirestoreError here because these are internal failures
    // that cannot be handled by the user. (Also it would create a circular
    // dependency between the error and assert modules which doesn't work.)
    throw ve(e), new Error(e);
}

/**
 * Fails if the given assertion condition is false, throwing an Error with the
 * given message if it did.
 */ function Ce(t, e) {
    t || De(e);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class ke {
    static mi() {
        // Alphanumeric characters
        const t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        let e = "";
        for (let s = 0; s < 20; s++) e += t.charAt(Math.floor(Math.random() * t.length));
        return e;
    }
}

function Ne(t, e) {
    return t < e ? -1 : t > e ? 1 : 0;
}

/** Helper to compare arrays using isEqual(). */ function Fe(t, e, s) {
    return t.length === e.length && t.every((t, n) => s(t, e[n]));
}

/**
 * Returns the immediate lexicographically-following string. This is useful to
 * construct an inclusive range for indexeddb iterators.
 */ function $e(t) {
    // Return the input string, with an additional NUL byte appended.
    return t + "\0";
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Me {
    /**
     * Constructs a DatabaseInfo using the provided host, databaseId and
     * persistenceKey.
     *
     * @param databaseId The database to use.
     * @param persistenceKey A unique identifier for this Firestore's local
     * storage (used in conjunction with the databaseId).
     * @param host The Firestore backend host to connect to.
     * @param ssl Whether to use SSL when connecting.
     * @param forceLongPolling Whether to use the forceLongPolling option
     * when using WebChannel as the network transport.
     */
    constructor(t, e, s, n, i) {
        this.cn = t, this.persistenceKey = e, this.host = s, this.ssl = n, this.forceLongPolling = i;
    }
}

/** The default database name for a project. */
/** Represents the database ID a Firestore client is associated with. */
class Le {
    constructor(t, e) {
        this.projectId = t, this.database = e || "(default)";
    }
    get Ei() {
        return "(default)" === this.database;
    }
    isEqual(t) {
        return t instanceof Le && t.projectId === this.projectId && t.database === this.database;
    }
    D(t) {
        return Ne(this.projectId, t.projectId) || Ne(this.database, t.database);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A map implementation that uses objects as keys. Objects must implement the
 * Equatable interface and must be immutable. Entries in the map are stored
 * together with the key being produced from the mapKeyFn. This map
 * automatically handles collisions of keys.
 */ class Oe {
    constructor(t) {
        this.wi = t, 
        /**
         * The inner map for a key -> value pair. Due to the possibility of
         * collisions we keep a list of entries that we do a linear search through
         * to find an actual match. Note that collisions should be rare, so we still
         * expect near constant time lookups in practice.
         */
        this.Ii = {};
    }
    /** Get a value for this key, or undefined if it does not exist. */    get(t) {
        const e = this.wi(t), s = this.Ii[e];
        if (void 0 !== s) for (const [e, n] of s) if (e.isEqual(t)) return n;
    }
    has(t) {
        return void 0 !== this.get(t);
    }
    /** Put this key and value in the map. */    set(t, e) {
        const s = this.wi(t), n = this.Ii[s];
        if (void 0 !== n) {
            for (let s = 0; s < n.length; s++) if (n[s][0].isEqual(t)) return void (n[s] = [ t, e ]);
            n.push([ t, e ]);
        } else this.Ii[s] = [ [ t, e ] ];
    }
    /**
     * Remove this key from the map. Returns a boolean if anything was deleted.
     */    delete(t) {
        const e = this.wi(t), s = this.Ii[e];
        if (void 0 === s) return !1;
        for (let n = 0; n < s.length; n++) if (s[n][0].isEqual(t)) return 1 === s.length ? delete this.Ii[e] : s.splice(n, 1), 
        !0;
        return !1;
    }
    forEach(t) {
        O(this.Ii, (e, s) => {
            for (const [e, n] of s) t(e, n);
        });
    }
    U() {
        return x(this.Ii);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A batch of mutations that will be sent as one unit to the backend.
 */
class xe {
    /**
     * @param batchId The unique ID of this mutation batch.
     * @param localWriteTime The original write time of this mutation.
     * @param baseMutations Mutations that are used to populate the base
     * values when this mutation is applied locally. This can be used to locally
     * overwrite values that are persisted in the remote document cache. Base
     * mutations are never sent to the backend.
     * @param mutations The user-provided mutations in this mutation batch.
     * User-provided mutations are applied both locally and remotely on the
     * backend.
     */
    constructor(t, e, s, n) {
        this.batchId = t, this.Ri = e, this.baseMutations = s, this.mutations = n;
    }
    /**
     * Applies all the mutations in this MutationBatch to the specified document
     * to create a new remote document
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     * @param batchResult The result of applying the MutationBatch to the
     * backend.
     */    Ut(t, e, s) {
        const n = s.Ai;
        for (let s = 0; s < this.mutations.length; s++) {
            const i = this.mutations[s];
            if (i.key.isEqual(t)) {
                const t = n[s];
                e = i.Ut(e, t);
            }
        }
        return e;
    }
    /**
     * Computes the local view of a document given all the mutations in this
     * batch.
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     */    Bt(t, e) {
        // First, apply the base state. This allows us to apply non-idempotent
        // transform against a consistent set of values.
        for (const s of this.baseMutations) s.key.isEqual(t) && (e = s.Bt(e, e, this.Ri));
        const s = e;
        // Second, apply all user-provided mutations.
                for (const n of this.mutations) n.key.isEqual(t) && (e = n.Bt(e, s, this.Ri));
        return e;
    }
    /**
     * Computes the local view for all provided documents given the mutations in
     * this batch.
     */    Pi(t) {
        // TODO(mrschmidt): This implementation is O(n^2). If we apply the mutations
        // directly (as done in `applyToLocalView()`), we can reduce the complexity
        // to O(n).
        let e = t;
        return this.mutations.forEach(s => {
            const n = this.Bt(s.key, t.get(s.key));
            n && (e = e.it(s.key, n));
        }), e;
    }
    keys() {
        return this.mutations.reduce((t, e) => t.add(e.key), ie());
    }
    isEqual(t) {
        return this.batchId === t.batchId && Fe(this.mutations, t.mutations, (t, e) => t.isEqual(e)) && Fe(this.baseMutations, t.baseMutations, (t, e) => t.isEqual(e));
    }
}

/** The result of applying a mutation batch to the backend. */ class Be {
    constructor(t, e, s, n, 
    /**
     * A pre-computed mapping from each mutated document to the resulting
     * version.
     */
    i) {
        this.batch = t, this.Vi = e, this.Ai = s, this.streamToken = n, this.gi = i;
    }
    /**
     * Creates a new MutationBatchResult for the given batch and results. There
     * must be one result for each mutation in the batch. This static factory
     * caches a document=>version mapping (docVersions).
     */    static from(t, e, s, n) {
        Ce(t.mutations.length === s.length, "Mutations sent " + t.mutations.length + " must equal results received " + s.length);
        let i = se();
        const r = t.mutations;
        for (let t = 0; t < r.length; t++) i = i.it(r[t].key, s[t].version);
        return new Be(t, e, s, n, i);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A collection of references to a document from some kind of numbered entity
 * (either a target ID or batch ID). As references are added to or removed from
 * the set corresponding events are emitted to a registered garbage collector.
 *
 * Each reference is represented by a DocumentReference object. Each of them
 * contains enough information to uniquely identify the reference. They are all
 * stored primarily in a set sorted by key. A document is considered garbage if
 * there's no references in that set (this can be efficiently checked thanks to
 * sorting by key).
 *
 * ReferenceSet also keeps a secondary set that contains references sorted by
 * IDs. This one is used to efficiently implement removal of all references by
 * some target ID.
 */ class Ue {
    constructor() {
        // A set of outstanding references to a document sorted by key.
        this.pi = new $(qe.Ee), 
        // A set of outstanding references to a document sorted by target id.
        this.yi = new $(qe.bi);
    }
    /** Returns true if the reference set contains no references. */    U() {
        return this.pi.U();
    }
    /** Adds a reference to the given document key for the given ID. */    vi(t, e) {
        const s = new qe(t, e);
        this.pi = this.pi.add(s), this.yi = this.yi.add(s);
    }
    /** Add references to the given document keys for the given ID. */    Si(t, e) {
        t.forEach(t => this.vi(t, e));
    }
    /**
     * Removes a reference to the given document key for the given
     * ID.
     */    Di(t, e) {
        this.Ci(new qe(t, e));
    }
    ki(t, e) {
        t.forEach(t => this.Di(t, e));
    }
    /**
     * Clears all references with a given ID. Calls removeRef() for each key
     * removed.
     */    Ni(t) {
        const e = C.EMPTY, s = new qe(e, t), n = new qe(e, t + 1), i = [];
        return this.yi.Ct([ s, n ], t => {
            this.Ci(t), i.push(t.key);
        }), i;
    }
    Fi() {
        this.pi.forEach(t => this.Ci(t));
    }
    Ci(t) {
        this.pi = this.pi.delete(t), this.yi = this.yi.delete(t);
    }
    $i(t) {
        const e = C.EMPTY, s = new qe(e, t), n = new qe(e, t + 1);
        let i = ie();
        return this.yi.Ct([ s, n ], t => {
            i = i.add(t.key);
        }), i;
    }
    Mi(t) {
        const e = new qe(t, 0), s = this.pi.Nt(e);
        return null !== s && t.isEqual(s.key);
    }
}

class qe {
    constructor(t, e) {
        this.key = t, this.Li = e;
    }
    /** Compare by key then by ID */    static Ee(t, e) {
        return C.F(t.key, e.key) || Ne(t.Li, e.Li);
    }
    /** Compare by ID then by key */    static bi(t, e) {
        return Ne(t.Li, e.Li) || C.F(t.key, e.key);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * PersistencePromise<> is essentially a re-implementation of Promise<> except
 * it has a .next() method instead of .then() and .next() and .catch() callbacks
 * are executed synchronously when a PersistencePromise resolves rather than
 * asynchronously (Promise<> implementations use setImmediate() or similar).
 *
 * This is necessary to interoperate with IndexedDB which will automatically
 * commit transactions if control is returned to the event loop without
 * synchronously initiating another operation on the transaction.
 *
 * NOTE: .then() and .catch() only allow a single consumer, unlike normal
 * Promises.
 */ class Qe {
    constructor(t) {
        // NOTE: next/catchCallback will always point to our own wrapper functions,
        // not the user's raw next() or catch() callbacks.
        this.Oi = null, this.xi = null, 
        // When the operation resolves, we'll set result or error and mark isDone.
        this.result = void 0, this.error = void 0, this.Bi = !1, 
        // Set to true when .then() or .catch() are called and prevents additional
        // chaining.
        this.Ui = !1, t(t => {
            this.Bi = !0, this.result = t, this.Oi && 
            // value should be defined unless T is Void, but we can't express
            // that in the type system.
            this.Oi(t);
        }, t => {
            this.Bi = !0, this.error = t, this.xi && this.xi(t);
        });
    }
    catch(t) {
        return this.next(void 0, t);
    }
    next(t, e) {
        return this.Ui && De("Called next() or catch() twice for PersistencePromise"), this.Ui = !0, 
        this.Bi ? this.error ? this.qi(e, this.error) : this.Qi(t, this.result) : new Qe((s, n) => {
            this.Oi = e => {
                this.Qi(t, e).next(s, n);
            }, this.xi = t => {
                this.qi(e, t).next(s, n);
            };
        });
    }
    Wi() {
        return new Promise((t, e) => {
            this.next(t, e);
        });
    }
    ji(t) {
        try {
            const e = t();
            return e instanceof Qe ? e : Qe.resolve(e);
        } catch (t) {
            return Qe.reject(t);
        }
    }
    Qi(t, e) {
        return t ? this.ji(() => t(e)) : Qe.resolve(e);
    }
    qi(t, e) {
        return t ? this.ji(() => t(e)) : Qe.reject(e);
    }
    static resolve(t) {
        return new Qe((e, s) => {
            e(t);
        });
    }
    static reject(t) {
        return new Qe((e, s) => {
            s(t);
        });
    }
    static Ki(
    // Accept all Promise types in waitFor().
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    t) {
        return new Qe((e, s) => {
            let n = 0, i = 0, r = !1;
            t.forEach(t => {
                ++n, t.next(() => {
                    ++i, r && i === n && e();
                }, t => s(t));
            }), r = !0, i === n && e();
        });
    }
    /**
     * Given an array of predicate functions that asynchronously evaluate to a
     * boolean, implements a short-circuiting `or` between the results. Predicates
     * will be evaluated until one of them returns `true`, then stop. The final
     * result will be whether any of them returned `true`.
     */    static Gi(t) {
        let e = Qe.resolve(!1);
        for (const s of t) e = e.next(t => t ? Qe.resolve(t) : s());
        return e;
    }
    static forEach(t, e) {
        const s = [];
        return t.forEach((t, n) => {
            s.push(e.call(this, t, n));
        }), this.Ki(s);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory buffer of entries to be written to a RemoteDocumentCache.
 * It can be used to batch up a set of changes to be written to the cache, but
 * additionally supports reading entries back with the `getEntry()` method,
 * falling back to the underlying RemoteDocumentCache if no entry is
 * buffered.
 *
 * Entries added to the cache *must* be read first. This is to facilitate
 * calculating the size delta of the pending changes.
 *
 * PORTING NOTE: This class was implemented then removed from other platforms.
 * If byte-counting ends up being needed on the other platforms, consider
 * porting this class as part of that implementation work.
 */ class We {
    constructor() {
        // A mapping of document key to the new cache entry that should be written (or null if any
        // existing cache entry should be removed).
        this.zi = new Oe(t => t.toString()), this.Hi = !1;
    }
    set readTime(t) {
        this.Ji = t;
    }
    get readTime() {
        return this.Ji;
    }
    /**
     * Buffers a `RemoteDocumentCache.addEntry()` call.
     *
     * You can only modify documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Yi(t, e) {
        this.Xi(), this.readTime = e, this.zi.set(t.key, t);
    }
    /**
     * Buffers a `RemoteDocumentCache.removeEntry()` call.
     *
     * You can only remove documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Zi(t, e) {
        this.Xi(), e && (this.readTime = e), this.zi.set(t, null);
    }
    /**
     * Looks up an entry in the cache. The buffered changes will first be checked,
     * and if no buffered change applies, this will forward to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKey The key of the entry to look up.
     * @return The cached Document or NoDocument entry, or null if we have nothing
     * cached.
     */    tr(t, e) {
        this.Xi();
        const s = this.zi.get(e);
        return void 0 !== s ? Qe.resolve(s) : this.er(t, e);
    }
    /**
     * Looks up several entries in the cache, forwarding to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKeys The keys of the entries to look up.
     * @return A map of cached `Document`s or `NoDocument`s, indexed by key. If an
     *     entry cannot be found, the corresponding key will be mapped to a null
     *     value.
     */    getEntries(t, e) {
        return this.sr(t, e);
    }
    /**
     * Applies buffered changes to the underlying RemoteDocumentCache, using
     * the provided transaction.
     */    apply(t) {
        return this.Xi(), this.Hi = !0, this.nr(t);
    }
    /** Helper to assert this.changes is not null  */    Xi() {}
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const je = "The current tab is not in the required state to perform this operation. It might be necessary to refresh the browser tab.";

/**
 * A base class representing a persistence transaction, encapsulating both the
 * transaction's sequence numbers as well as a list of onCommitted listeners.
 *
 * When you call Persistence.runTransaction(), it will create a transaction and
 * pass it to your callback. You then pass it to any method that operates
 * on persistence.
 */ class Ke {
    constructor() {
        this.ir = [];
    }
    rr(t) {
        this.ir.push(t);
    }
    or() {
        this.ir.forEach(t => t());
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A readonly view of the local state of all documents we're tracking (i.e. we
 * have a cached version in remoteDocumentCache or local mutations for the
 * document). The view is computed by applying the mutations in the
 * MutationQueue to the RemoteDocumentCache.
 */ class Ge {
    constructor(t, e, s) {
        this.hr = t, this.ar = e, this.ur = s;
    }
    /**
     * Get the local view of the document identified by `key`.
     *
     * @return Local view of the document or null if we don't have any cached
     * state for it.
     */    cr(t, e) {
        return this.ar._r(t, e).next(s => this.lr(t, e, s));
    }
    /** Internal version of `getDocument` that allows reusing batches. */    lr(t, e, s) {
        return this.hr.tr(t, e).next(t => {
            for (const n of s) t = n.Bt(e, t);
            return t;
        });
    }
    // Returns the view of the given `docs` as they would appear after applying
    // all mutations in the given `batches`.
    dr(t, e, s) {
        let n = Xt();
        return e.forEach((t, e) => {
            for (const n of s) e = n.Bt(t, e);
            n = n.it(t, e);
        }), n;
    }
    /**
     * Gets the local view of the documents identified by `keys`.
     *
     * If we don't have cached state for a document in `keys`, a NoDocument will
     * be stored for that key in the resulting set.
     */    Tr(t, e) {
        return this.hr.getEntries(t, e).next(e => this.mr(t, e));
    }
    /**
     * Similar to `getDocuments`, but creates the local view from the given
     * `baseDocs` without retrieving documents from the local store.
     */    mr(t, e) {
        return this.ar.Er(t, e).next(s => {
            const n = this.dr(t, e, s);
            let i = Yt();
            return n.forEach((t, e) => {
                // TODO(http://b/32275378): Don't conflate missing / deleted.
                e || (e = new vt(t, y.S())), i = i.it(t, e);
            }), i;
        });
    }
    /**
     * Performs a query against the local view of all documents.
     *
     * @param transaction The persistence transaction.
     * @param query The query to match documents against.
     * @param sinceReadTime If not set to SnapshotVersion.MIN, return only
     *     documents that have been read since this snapshot version (exclusive).
     */    wr(t, e, s) {
        return e.Pe() ? this.Ir(t, e.path) : e.He() ? this.Rr(t, e, s) : this.Ar(t, e, s);
    }
    Ir(t, e) {
        // Just do a simple document lookup.
        return this.cr(t, new C(e)).next(t => {
            let e = te();
            return t instanceof bt && (e = e.it(t.key, t)), e;
        });
    }
    Rr(t, e, s) {
        const n = e.collectionGroup;
        let i = te();
        return this.ur.Pr(t, n).next(r => Qe.forEach(r, r => {
            const o = e.Le(r.child(n));
            return this.Ar(t, o, s).next(t => {
                t.forEach((t, e) => {
                    i = i.it(t, e);
                });
            });
        }).next(() => i));
    }
    Ar(t, e, s) {
        // Query the remote documents and overlay mutations.
        let n, i;
        return this.hr.wr(t, e, s).next(s => (n = s, this.ar.Vr(t, e))).next(e => (i = e, 
        this.gr(t, i, n).next(t => {
            n = t;
            for (const t of i) for (const e of t.mutations) {
                const s = e.key, i = n.get(s), r = e.Bt(i, i, t.Ri);
                n = r instanceof bt ? n.it(s, r) : n.remove(s);
            }
        }))).next(() => (
        // Finally, filter out any documents that don't actually match
        // the query.
        n.forEach((t, s) => {
            e.matches(s) || (n = n.remove(t));
        }), n));
    }
    gr(t, e, s) {
        let n = ie();
        for (const t of e) for (const e of t.mutations) e instanceof Rt && null === s.get(e.key) && (n = n.add(e.key));
        let i = s;
        return this.hr.getEntries(t, n).next(t => (t.forEach((t, e) => {
            null !== e && e instanceof bt && (i = i.it(t, e));
        }), i));
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A set of changes to what documents are currently in view and out of view for
 * a given query. These changes are sent to the LocalStore by the View (via
 * the SyncEngine) and are used to pin / unpin documents as appropriate.
 */ class ze {
    constructor(t, e, s, n) {
        this.targetId = t, this.fromCache = e, this.pr = s, this.yr = n;
    }
    static br(t, e) {
        let s = ie(), n = ie();
        for (const t of e.docChanges) switch (t.type) {
          case 0 /* Added */ :
            s = s.add(t.doc.key);
            break;

          case 1 /* Removed */ :
            n = n.add(t.doc.key);
 // do nothing
                }
        return new ze(t, e.fromCache, s, n);
    }
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `ListenSequence` is a monotonic sequence. It is initialized with a minimum value to
 * exceed. All subsequent calls to next will return increasing values. If provided with a
 * `SequenceNumberSyncer`, it will additionally bump its next value when told of a new value, as
 * well as write out sequence numbers that it produces via `next()`.
 */ class He {
    constructor(t, e) {
        this.previousValue = t, e && (e.vr = t => this.Sr(t), this.Dr = t => e.Cr(t));
    }
    Sr(t) {
        return this.previousValue = Math.max(t, this.previousValue), this.previousValue;
    }
    next() {
        const t = ++this.previousValue;
        return this.Dr && this.Dr(t), t;
    }
}

He.kr = -1;

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Je {
    constructor() {
        this.promise = new Promise((t, e) => {
            this.resolve = t, this.reject = e;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents an operation scheduled to be run in the future on an AsyncQueue.
 *
 * It is created via DelayedOperation.createAndSchedule().
 *
 * Supports cancellation (via cancel()) and early execution (via skipDelay()).
 */ class Ye {
    constructor(t, e, s, n, i) {
        this.Nr = t, this.Fr = e, this.$r = s, this.op = n, this.Mr = i, this.Lr = new Je, 
        this.then = this.Lr.promise.then.bind(this.Lr.promise), this.catch = this.Lr.promise.catch.bind(this.Lr.promise), 
        // It's normal for the deferred promise to be canceled (due to cancellation)
        // and so we attach a dummy catch callback to avoid
        // 'UnhandledPromiseRejectionWarning' log spam.
        this.Lr.promise.catch(t => {});
    }
    /**
     * Creates and returns a DelayedOperation that has been scheduled to be
     * executed on the provided asyncQueue after the provided delayMs.
     *
     * @param asyncQueue The queue to schedule the operation on.
     * @param id A Timer ID identifying the type of operation this is.
     * @param delayMs The delay (ms) before the operation should be scheduled.
     * @param op The operation to run.
     * @param removalCallback A callback to be called synchronously once the
     *   operation is executed or canceled, notifying the AsyncQueue to remove it
     *   from its delayedOperations list.
     *   PORTING NOTE: This exists to prevent making removeDelayedOperation() and
     *   the DelayedOperation class public.
     */    static Or(t, e, s, n, i) {
        const r = Date.now() + s, o = new Ye(t, e, r, n, i);
        return o.start(s), o;
    }
    /**
     * Starts the timer. This is called immediately after construction by
     * createAndSchedule().
     */    start(t) {
        this.xr = setTimeout(() => this.Br(), t);
    }
    /**
     * Queues the operation to run immediately (if it hasn't already been run or
     * canceled).
     */    Ur() {
        return this.Br();
    }
    /**
     * Cancels the operation if it hasn't already been executed or canceled. The
     * promise will be rejected.
     *
     * As long as the operation has not yet been run, calling cancel() provides a
     * guarantee that the operation will not be run.
     */    cancel(t) {
        null !== this.xr && (this.clearTimeout(), this.Lr.reject(new I(w.CANCELLED, "Operation cancelled" + (t ? ": " + t : ""))));
    }
    Br() {
        this.Nr.qr(() => null !== this.xr ? (this.clearTimeout(), this.op().then(t => this.Lr.resolve(t))) : Promise.resolve());
    }
    clearTimeout() {
        null !== this.xr && (this.Mr(this), clearTimeout(this.xr), this.xr = null);
    }
}

class Xe {
    constructor() {
        // The last promise in the queue.
        this.Qr = Promise.resolve(), 
        // Is this AsyncQueue being shut down? Once it is set to true, it will not
        // be changed again.
        this.Wr = !1, 
        // Operations scheduled to be queued in the future. Operations are
        // automatically removed after they are run or canceled.
        this.jr = [], 
        // visible for testing
        this.Kr = null, 
        // Flag set while there's an outstanding AsyncQueue operation, used for
        // assertion sanity-checks.
        this.Gr = !1, 
        // List of TimerIds to fast-forward delays for.
        this.zr = [];
    }
    // Is this AsyncQueue being shut down? If true, this instance will not enqueue
    // any new operations, Promises from enqueue requests will not resolve.
    get Hr() {
        return this.Wr;
    }
    /**
     * Adds a new operation to the queue without waiting for it to complete (i.e.
     * we ignore the Promise result).
     */    qr(t) {
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.enqueue(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue without waiting for it to complete (i.e. we ignore the Promise result).
     */    Jr(t) {
        this.Yr(), 
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.Xr(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue.
     */    Zr(t) {
        return this.Yr(), this.Xr(t);
    }
    /**
     * Adds a new operation to the queue and initialize the shut down of this queue.
     * Returns a promise that will be resolved when the promise returned by the new
     * operation is (with its value).
     * Once this method is called, the only possible way to request running an operation
     * is through `enqueueAndForgetEvenAfterShutdown`.
     */    async to(t) {
        this.Yr(), this.Wr || (this.Wr = !0, await this.Zr(t));
    }
    /**
     * Adds a new operation to the queue. Returns a promise that will be resolved
     * when the promise returned by the new operation is (with its value).
     */    enqueue(t) {
        return this.Yr(), this.Wr ? new Promise(t => {}) : this.Xr(t);
    }
    Xr(t) {
        const e = this.Qr.then(() => (this.Gr = !0, t().catch(t => {
            // Re-throw the error so that this.tail becomes a rejected Promise and
            // all further attempts to chain (via .then) will just short-circuit
            // and return the rejected Promise.
            throw this.Kr = t, this.Gr = !1, ve("INTERNAL UNHANDLED ERROR: ", t.stack || t.message || ""), 
            t;
        }).then(t => (this.Gr = !1, t))));
        return this.Qr = e, e;
    }
    /**
     * Schedules an operation to be queued on the AsyncQueue once the specified
     * `delayMs` has elapsed. The returned CancelablePromise can be used to cancel
     * the operation prior to its running.
     */    eo(t, e, s) {
        this.Yr(), 
        // Fast-forward delays for timerIds that have been overriden.
        this.zr.indexOf(t) > -1 && (e = 0);
        const n = Ye.Or(this, t, e, s, t => this.so(t));
        return this.jr.push(n), n;
    }
    Yr() {
        this.Kr && De("AsyncQueue is already failed: " + (this.Kr.stack || this.Kr.message));
    }
    /**
     * Verifies there's an operation currently in-progress on the AsyncQueue.
     * Unfortunately we can't verify that the running code is in the promise chain
     * of that operation, so this isn't a foolproof check, but it should be enough
     * to catch some bugs.
     */    no() {}
    /**
     * Waits until all currently queued tasks are finished executing. Delayed
     * operations are not run.
     */    async io() {
        // Operations in the queue prior to draining may have enqueued additional
        // operations. Keep draining the queue until the tail is no longer advanced,
        // which indicates that no more new operations were enqueued and that all
        // operations were executed.
        let t;
        do {
            t = this.Qr, await t;
        } while (t !== this.Qr);
    }
    /**
     * For Tests: Determine if a delayed operation with a particular TimerId
     * exists.
     */    ro(t) {
        for (const e of this.jr) if (e.Fr === t) return !0;
        return !1;
    }
    /**
     * For Tests: Runs some or all delayed operations early.
     *
     * @param lastTimerId Delayed operations up to and including this TimerId will
     *  be drained. Throws if no such operation exists. Pass TimerId.All to run
     *  all delayed operations.
     * @returns a Promise that resolves once all operations have been run.
     */    oo(t) {
        // Note that draining may generate more delayed ops, so we do that first.
        return this.io().then(() => {
            // Run ops in the same order they'd run if they ran naturally.
            this.jr.sort((t, e) => t.$r - e.$r);
            for (const e of this.jr) if (e.Ur(), "all" /* All */ !== t && e.Fr === t) break;
            return this.io();
        });
    }
    /**
     * For Tests: Skip all subsequent delays for a timer id.
     */    ho(t) {
        this.zr.push(t);
    }
    /** Called once a DelayedOperation is run or canceled. */    so(t) {
        // NOTE: indexOf / slice are O(n), but delayedOperations is expected to be small.
        const e = this.jr.indexOf(t);
        this.jr.splice(e, 1);
    }
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function Ze([t, e], [s, n]) {
    const i = Ne(t, s);
    return 0 === i ? Ne(e, n) : i;
}

/**
 * Used to calculate the nth sequence number. Keeps a rolling buffer of the
 * lowest n values passed to `addElement`, and finally reports the largest of
 * them in `maxValue`.
 */ class ts {
    constructor(t) {
        this.ao = t, this.buffer = new $(Ze), this.uo = 0;
    }
    co() {
        return ++this.uo;
    }
    _o(t) {
        const e = [ t, this.co() ];
        if (this.buffer.size < this.ao) this.buffer = this.buffer.add(e); else {
            const t = this.buffer.last();
            Ze(e, t) < 0 && (this.buffer = this.buffer.delete(t).add(e));
        }
    }
    get maxValue() {
        // Guaranteed to be non-empty. If we decide we are not collecting any
        // sequence numbers, nthSequenceNumber below short-circuits. If we have
        // decided that we are collecting n sequence numbers, it's because n is some
        // percentage of the existing sequence numbers. That means we should never
        // be in a situation where we are collecting sequence numbers but don't
        // actually have any.
        return this.buffer.last()[0];
    }
}

const es = {
    lo: !1,
    do: 0,
    fo: 0,
    To: 0
};

class ss {
    constructor(
    // When we attempt to collect, we will only do so if the cache size is greater than this
    // threshold. Passing `COLLECTION_DISABLED` here will cause collection to always be skipped.
    t, 
    // The percentage of sequence numbers that we will attempt to collect
    e, 
    // A cap on the total number of sequence numbers that will be collected. This prevents
    // us from collecting a huge number of sequence numbers if the cache has grown very large.
    s) {
        this.mo = t, this.Eo = e, this.wo = s;
    }
    static Io(t) {
        return new ss(t, ss.Ro, ss.Ao);
    }
}

ss.Po = -1, ss.Vo = 1048576, ss.po = 41943040, ss.Ro = 10, ss.Ao = 1e3, ss.yo = new ss(ss.po, ss.Ro, ss.Ao), 
ss.DISABLED = new ss(ss.Po, 0, 0);

/**
 * This class is responsible for the scheduling of LRU garbage collection. It handles checking
 * whether or not GC is enabled, as well as which delay to use before the next run.
 */
class ns {
    constructor(t, e) {
        this.bo = t, this.Nr = e, this.vo = !1, this.So = null;
    }
    start(t) {
        this.bo.Do.mo !== ss.Po && this.Co(t);
    }
    stop() {
        this.So && (this.So.cancel(), this.So = null);
    }
    get ko() {
        return null !== this.So;
    }
    Co(t) {
        const e = this.vo ? 3e5 : 6e4;
        be("LruGarbageCollector", `Garbage collection scheduled in ${e}ms`), this.So = this.Nr.eo("lru_garbage_collection" /* LruGarbageCollection */ , e, () => (this.So = null, 
        this.vo = !0, t.No(this.bo).then(() => this.Co(t)).catch(os)));
    }
}

/** Implements the steps for LRU garbage collection. */ class is {
    constructor(t, e) {
        this.Fo = t, this.Do = e;
    }
    /** Given a percentile of target to collect, returns the number of targets to collect. */    $o(t, e) {
        return this.Fo.Mo(t).next(t => Math.floor(e / 100 * t));
    }
    /** Returns the nth sequence number, counting in order from the smallest. */    Lo(t, e) {
        if (0 === e) return Qe.resolve(He.kr);
        const s = new ts(e);
        return this.Fo.Xs(t, t => s._o(t.sequenceNumber)).next(() => this.Fo.Oo(t, t => s._o(t))).next(() => s.maxValue);
    }
    /**
     * Removes targets with a sequence number equal to or less than the given upper bound, and removes
     * document associations with those targets.
     */    xo(t, e, s) {
        return this.Fo.xo(t, e, s);
    }
    /**
     * Removes documents that have a sequence number equal to or less than the upper bound and are not
     * otherwise pinned.
     */    Bo(t, e) {
        return this.Fo.Bo(t, e);
    }
    Uo(t, e) {
        return this.Do.mo === ss.Po ? (be("LruGarbageCollector", "Garbage collection skipped; disabled"), 
        Qe.resolve(es)) : this.qo(t).next(s => s < this.Do.mo ? (be("LruGarbageCollector", `Garbage collection skipped; Cache size ${s} ` + `is lower than threshold ${this.Do.mo}`), 
        es) : this.Qo(t, e));
    }
    qo(t) {
        return this.Fo.qo(t);
    }
    Qo(t, e) {
        let n, i, r, o, h, a, u;
        const c = Date.now();
        return this.$o(t, this.Do.Eo).next(e => (
        // Cap at the configured max
        e > this.Do.wo ? (be("LruGarbageCollector", "Capping sequence numbers to collect down " + `to the maximum of ${this.Do.wo} ` + `from ${e}`), 
        i = this.Do.wo) : i = e, o = Date.now(), this.Lo(t, i))).next(s => (n = s, h = Date.now(), 
        this.xo(t, n, e))).next(e => (r = e, a = Date.now(), this.Bo(t, n))).next(t => {
            if (u = Date.now(), pe() <= s.DEBUG) {
                be("LruGarbageCollector", "LRU Garbage Collection\n" + `\tCounted targets in ${o - c}ms\n` + `\tDetermined least recently used ${i} in ` + `${h - o}ms\n` + `\tRemoved ${r} targets in ` + `${a - h}ms\n` + `\tRemoved ${t} documents in ` + `${u - a}ms\n` + `Total Duration: ${u - c}ms`);
            }
            return Qe.resolve({
                lo: !0,
                do: i,
                fo: r,
                To: t
            });
        });
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Local storage in the Firestore client. Coordinates persistence components
 * like the mutation queue and remote document cache to present a
 * latency-compensated view of stored data.
 *
 * The LocalStore is responsible for accepting mutations from the Sync Engine.
 * Writes from the client are put into a queue as provisional Mutations until
 * they are processed by the RemoteStore and confirmed as having been written
 * to the server.
 *
 * The local store provides the local version of documents that have been
 * modified locally. It maintains the constraint:
 *
 *   LocalDocument = RemoteDocument + Active(LocalMutations)
 *
 * (Active mutations are those that are enqueued and have not been previously
 * acknowledged or rejected).
 *
 * The RemoteDocument ("ground truth") state is provided via the
 * applyChangeBatch method. It will be some version of a server-provided
 * document OR will be a server-provided document PLUS acknowledged mutations:
 *
 *   RemoteDocument' = RemoteDocument + Acknowledged(LocalMutations)
 *
 * Note that this "dirty" version of a RemoteDocument will not be identical to a
 * server base version, since it has LocalMutations added to it pending getting
 * an authoritative copy from the server.
 *
 * Since LocalMutations can be rejected by the server, we have to be able to
 * revert a LocalMutation that has already been applied to the LocalDocument
 * (typically done by replaying all remaining LocalMutations to the
 * RemoteDocument to re-apply).
 *
 * The LocalStore is responsible for the garbage collection of the documents it
 * contains. For now, it every doc referenced by a view, the mutation queue, or
 * the RemoteStore.
 *
 * It also maintains the persistence of mapping queries to resume tokens and
 * target ids. It needs to know this data about queries to properly know what
 * docs it would be allowed to garbage collect.
 *
 * The LocalStore must be able to efficiently execute queries against its local
 * cache of the documents, to provide the initial set of results before any
 * remote changes have been received.
 *
 * Note: In TypeScript, most methods return Promises since the implementation
 * may rely on fetching data from IndexedDB which is async.
 * These Promises will only be rejected on an I/O error or other internal
 * (unexpected) failure (e.g. failed assert) and always represent an
 * unrecoverable error (should be caught / reported by the async_queue).
 */
class rs {
    constructor(
    /** Manages our in-memory or durable persistence. */
    t, e, s) {
        this.persistence = t, this.Wo = e, 
        /**
         * The set of document references maintained by any local views.
         */
        this.jo = new Ue, 
        /**
         * Maps a targetID to data about its target.
         *
         * PORTING NOTE: We are using an immutable data structure on Web to make re-runs
         * of `applyRemoteEvent()` idempotent.
         */
        this.Ko = new k(Ne), 
        /** Maps a target to its targetID. */
        // TODO(wuandy): Evaluate if TargetId can be part of Target.
        this.Go = new Oe(t => t.canonicalId()), 
        /**
         * The read time of the last entry processed by `getNewDocumentChanges()`.
         *
         * PORTING NOTE: This is only used for multi-tab synchronization.
         */
        this.zo = y.MIN, this.persistence.Jo.Ho(this.jo), this.ar = t.Yo(s), this.Xo = t.Zo(), 
        this.th = t.eh(), this.sh = new Ge(this.Xo, this.ar, this.persistence.nh()), this.Wo.ih(this.sh);
    }
    /** Starts the LocalStore. */    start() {
        return this.rh();
    }
    /**
     * Tells the LocalStore that the currently authenticated user has changed.
     *
     * In response the local store switches the mutation queue to the new user and
     * returns any resulting document changes.
     */
    // PORTING NOTE: Android and iOS only return the documents affected by the
    // change.
    async oh(t) {
        let e = this.ar, s = this.sh;
        const n = await this.persistence.runTransaction("Handle user change", "readonly", n => {
            // Swap out the mutation queue, grabbing the pending mutation batches
            // before and after.
            let i;
            return this.ar.hh(n).next(r => (i = r, e = this.persistence.Yo(t), 
            // Recreate our LocalDocumentsView using the new
            // MutationQueue.
            s = new Ge(this.Xo, e, this.persistence.nh()), e.hh(n))).next(t => {
                const e = [], r = [];
                // Union the old/new changed keys.
                let o = ie();
                for (const t of i) {
                    e.push(t.batchId);
                    for (const e of t.mutations) o = o.add(e.key);
                }
                for (const e of t) {
                    r.push(e.batchId);
                    for (const t of e.mutations) o = o.add(t.key);
                }
                // Return the set of all (potentially) changed documents and the list
                // of mutation batch IDs that were affected by change.
                                return s.Tr(n, o).next(t => ({
                    ah: t,
                    uh: e,
                    _h: r
                }));
            });
        });
        return this.ar = e, this.sh = s, this.Wo.ih(this.sh), n;
    }
    /* Accept locally generated Mutations and commit them to storage. */    lh(t) {
        const e = p.now(), s = t.reduce((t, e) => t.add(e.key), ie());
        let n;
        return this.persistence.runTransaction("Locally write mutations", "readwrite", i => this.sh.Tr(i, s).next(s => {
            n = s;
            // For non-idempotent mutations (such as `FieldValue.increment()`),
            // we record the base state in a separate patch mutation. This is
            // later used to guarantee consistent values and prevents flicker
            // even if the backend sends us an update that already includes our
            // transform.
            const r = [];
            for (const e of t) {
                const t = e.ee(n.get(e.key));
                null != t && 
                // NOTE: The base state should only be applied if there's some
                // existing document to override, so use a Precondition of
                // exists=true
                r.push(new Rt(e.key, t, t.se(), Et.exists(!0)));
            }
            return this.ar.dh(i, e, r, t);
        })).then(t => {
            const e = t.Pi(n);
            return {
                batchId: t.batchId,
                zi: e
            };
        });
    }
    /** Returns the local view of the documents affected by a mutation batch. */
    // PORTING NOTE: Multi-tab only.
    fh(t) {
        return this.persistence.runTransaction("Lookup mutation documents", "readonly", e => this.ar.Th(e, t).next(t => t ? this.sh.Tr(e, t) : Qe.resolve(null)));
    }
    /**
     * Acknowledge the given batch.
     *
     * On the happy path when a batch is acknowledged, the local store will
     *
     *  + remove the batch from the mutation queue;
     *  + apply the changes to the remote document cache;
     *  + recalculate the latency compensated view implied by those changes (there
     *    may be mutations in the queue that affect the documents but haven't been
     *    acknowledged yet); and
     *  + give the changed documents back the sync engine
     *
     * @returns The resulting (modified) documents.
     */    mh(t) {
        return this.persistence.runTransaction("Acknowledge batch", "readwrite-primary", e => {
            const s = t.batch.keys(), n = this.Xo.Eh({
                wh: !0
            });
            return this.ar.mh(e, t.batch, t.streamToken).next(() => this.Ih(e, t, n)).next(() => n.apply(e)).next(() => this.ar.Rh(e)).next(() => this.sh.Tr(e, s));
        });
    }
    /**
     * Remove mutations from the MutationQueue for the specified batch;
     * LocalDocuments will be recalculated.
     *
     * @returns The resulting modified documents.
     */    Ah(t) {
        return this.persistence.runTransaction("Reject batch", "readwrite-primary", e => {
            let s;
            return this.ar.Ph(e, t).next(t => (Ce(null !== t, "Attempt to reject nonexistent batch!"), 
            s = t.keys(), this.ar.Vh(e, t))).next(() => this.ar.Rh(e)).next(() => this.sh.Tr(e, s));
        });
    }
    /**
     * Returns the largest (latest) batch id in mutation queue that is pending server response.
     * Returns `BATCHID_UNKNOWN` if the queue is empty.
     */    gh() {
        return this.persistence.runTransaction("Get highest unacknowledged batch id", "readonly", t => this.ar.gh(t));
    }
    /** Returns the last recorded stream token for the current user. */    ph() {
        return this.persistence.runTransaction("Get last stream token", "readonly", t => this.ar.ph(t));
    }
    /**
     * Sets the stream token for the current user without acknowledging any
     * mutation batch. This is usually only useful after a stream handshake or in
     * response to an error that requires clearing the stream token.
     */    yh(t) {
        return this.persistence.runTransaction("Set last stream token", "readwrite-primary", e => this.ar.yh(e, t));
    }
    /**
     * Returns the last consistent snapshot processed (used by the RemoteStore to
     * determine whether to buffer incoming snapshots from the backend).
     */    bh() {
        return this.persistence.runTransaction("Get last remote snapshot version", "readonly", t => this.th.bh(t));
    }
    /**
     * Update the "ground-state" (remote) documents. We assume that the remote
     * event reflects any write batches that have been acknowledged or rejected
     * (i.e. we do not re-apply local mutations to updates from this event).
     *
     * LocalDocuments are re-calculated if there are remaining mutations in the
     * queue.
     */    vh(t) {
        const e = t.ts;
        let s = this.Ko;
        return this.persistence.runTransaction("Apply remote event", "readwrite-primary", n => {
            const i = this.Xo.Eh({
                wh: !0
            });
            // Reset newTargetDataByTargetMap in case this transaction gets re-run.
                        s = this.Ko;
            const r = [];
            t.Ts.forEach((t, i) => {
                const o = s.get(i);
                if (!o) return;
                // Only update the remote keys if the target is still active. This
                // ensures that we can persist the updated target data along with
                // the updated assignment.
                                r.push(this.th.Sh(n, t.gs, i).next(() => this.th.Dh(n, t.Ps, i)));
                const h = t.resumeToken;
                // Update the resume token if the change includes one.
                                if (h.Ot() > 0) {
                    const a = o.ss(h, e).es(n.Ch);
                    s = s.it(i, a), 
                    // Update the target data if there are target changes (or if
                    // sufficient time has passed since the last update).
                    rs.kh(o, a, t) && r.push(this.th.Nh(n, a));
                }
            });
            let o = Yt(), h = ie();
            // HACK: The only reason we allow a null snapshot version is so that we
            // can synthesize remote events when we get permission denied errors while
            // trying to resolve the state of a locally cached document that is in
            // limbo.
            if (t.Es.forEach((t, e) => {
                h = h.add(t);
            }), 
            // Each loop iteration only affects its "own" doc, so it's safe to get all the remote
            // documents in advance in a single call.
            r.push(i.getEntries(n, h).next(s => {
                t.Es.forEach((h, a) => {
                    const u = s.get(h);
                    // Note: The order of the steps below is important, since we want
                    // to ensure that rejected limbo resolutions (which fabricate
                    // NoDocuments with SnapshotVersion.MIN) never add documents to
                    // cache.
                                        a instanceof vt && a.version.isEqual(y.MIN) ? (
                    // NoDocuments with SnapshotVersion.MIN are used in manufactured
                    // events. We remove these documents from cache since we lost
                    // access.
                    i.Zi(h, e), o = o.it(h, a)) : null == u || a.version.D(u.version) > 0 || 0 === a.version.D(u.version) && u.hasPendingWrites ? (i.Yi(a, e), 
                    o = o.it(h, a)) : be("LocalStore", "Ignoring outdated watch update for ", h, ". Current version:", u.version, " Watch version:", a.version), 
                    t.ws.has(h) && r.push(this.persistence.Jo.Fh(n, h));
                });
            })), !e.isEqual(y.MIN)) {
                const t = this.th.bh(n).next(t => this.th.$h(n, n.Ch, e));
                r.push(t);
            }
            return Qe.Ki(r).next(() => i.apply(n)).next(() => this.sh.mr(n, o));
        }).then(t => (this.Ko = s, t));
    }
    /**
     * Returns true if the newTargetData should be persisted during an update of
     * an active target. TargetData should always be persisted when a target is
     * being released and should not call this function.
     *
     * While the target is active, TargetData updates can be omitted when nothing
     * about the target has changed except metadata like the resume token or
     * snapshot version. Occasionally it's worth the extra write to prevent these
     * values from getting too stale after a crash, but this doesn't have to be
     * too frequent.
     */    static kh(t, e, s) {
        // Always persist target data if we don't already have a resume token.
        if (Ce(e.resumeToken.Ot() > 0, "Attempted to persist target data with no resume token"), 
        0 === t.resumeToken.Ot()) return !0;
        // Don't allow resume token changes to be buffered indefinitely. This
        // allows us to be reasonably up-to-date after a crash and avoids needing
        // to loop over all active queries on shutdown. Especially in the browser
        // we may not get time to do anything interesting while the current tab is
        // closing.
                return e.ts.C() - t.ts.C() >= this.Mh || s.Ps.size + s.Vs.size + s.gs.size > 0;
        // Otherwise if the only thing that has changed about a target is its resume
        // token it's not worth persisting. Note that the RemoteStore keeps an
        // in-memory view of the currently active targets which includes the current
        // resume token, so stream failure or user changes will still use an
        // up-to-date resume token regardless of what we do here.
        }
    /**
     * Notify local store of the changed views to locally pin documents.
     */    Lh(t) {
        for (const e of t) {
            const t = e.targetId;
            if (this.jo.Si(e.pr, t), this.jo.ki(e.yr, t), !e.fromCache) {
                const e = this.Ko.get(t), s = e.ts, n = e.ns(s);
                // Advance the last limbo free snapshot version
                                this.Ko = this.Ko.it(t, n);
            }
        }
        return this.persistence.runTransaction("notifyLocalViewChanges", "readwrite", e => Qe.forEach(t, t => Qe.forEach(t.yr, t => this.persistence.Jo.Di(e, t))));
    }
    /**
     * Gets the mutation batch after the passed in batchId in the mutation queue
     * or null if empty.
     * @param afterBatchId If provided, the batch to search after.
     * @returns The next mutation or null if there wasn't one.
     */    Oh(t) {
        return this.persistence.runTransaction("Get next mutation batch", "readonly", e => (void 0 === t && (t = -1), 
        this.ar.xh(e, t)));
    }
    /**
     * Read the current value of a Document with a given key or null if not
     * found - used for testing.
     */    Bh(t) {
        return this.persistence.runTransaction("read document", "readonly", e => this.sh.cr(e, t));
    }
    /**
     * Assigns the given target an internal ID so that its results can be pinned so
     * they don't get GC'd. A target must be allocated in the local store before
     * the store can be used to manage its view.
     *
     * Allocating an already allocated `Target` will return the existing `TargetData`
     * for that `Target`.
     */    Uh(t) {
        return this.persistence.runTransaction("Allocate target", "readwrite", e => {
            let s;
            return this.th.qh(e, t).next(n => n ? (
            // This target has been listened to previously, so reuse the
            // previous targetID.
            // TODO(mcg): freshen last accessed date?
            s = n, Qe.resolve(s)) : this.th.Qh(e).next(n => (s = new Wt(t, n, 0 /* Listen */ , e.Ch), 
            this.th.Wh(e, s).next(() => s))));
        }).then(e => (null === this.Ko.get(e.targetId) && (this.Ko = this.Ko.it(e.targetId, e), 
        this.Go.set(t, e.targetId)), e));
    }
    /**
     * Returns the TargetData as seen by the LocalStore, including updates that may
     * have not yet been persisted to the TargetCache.
     */
    // Visible for testing.
    qh(t, e) {
        const s = this.Go.get(e);
        return void 0 !== s ? Qe.resolve(this.Ko.get(s)) : this.th.qh(t, e);
    }
    /**
     * Unpin all the documents associated with the given target. If
     * `keepPersistedTargetData` is set to false and Eager GC enabled, the method
     * directly removes the associated target data from the target cache.
     *
     * Releasing a non-existing `Target` is a no-op.
     */
    // PORTING NOTE: `keepPersistedTargetData` is multi-tab only.
    jh(t, e) {
        const s = this.Ko.get(t), n = e ? "readwrite" : "readwrite-primary";
        return this.persistence.runTransaction("Release target", n, n => {
            // References for documents sent via Watch are automatically removed
            // when we delete a target's data from the reference delegate.
            // Since this does not remove references for locally mutated documents,
            // we have to remove the target associations for these documents
            // manually.
            // This operation needs to be run inside the transaction since EagerGC
            // uses the local view references during the transaction's commit.
            // Fortunately, the operation is safe to be re-run in case the
            // transaction fails since there are no side effects if the target has
            // already been removed.
            const i = this.jo.Ni(t);
            return e ? Qe.resolve() : Qe.forEach(i, t => this.persistence.Jo.Di(n, t)).next(() => {
                this.persistence.Jo.removeTarget(n, s);
            });
        }).then(() => {
            this.Ko = this.Ko.remove(t), this.Go.delete(s.target);
        });
    }
    /**
     * Runs the specified query against the local store and returns the results,
     * potentially taking advantage of query data from previous executions (such
     * as the set of remote keys).
     *
     * @param usePreviousResults Whether results from previous executions can
     * be used to optimize this query execution.
     */    Kh(t, e) {
        let s = y.MIN, n = ie();
        return this.persistence.runTransaction("Execute query", "readonly", i => this.qh(i, t.xe()).next(t => {
            if (t) return s = t.lastLimboFreeSnapshotVersion, this.th.Gh(i, t.targetId).next(t => {
                n = t;
            });
        }).next(() => this.Wo.wr(i, t, e ? s : y.MIN, e ? n : ie())).next(t => ({
            documents: t,
            zh: n
        })));
    }
    /**
     * Returns the keys of the documents that are associated with the given
     * target id in the remote table.
     */    Hh(t) {
        return this.persistence.runTransaction("Remote document keys", "readonly", e => this.th.Gh(e, t));
    }
    // PORTING NOTE: Multi-tab only.
    Jh() {
        return this.persistence.Jh();
    }
    // PORTING NOTE: Multi-tab only.
    Yh(t) {
        this.ar.Xh(t);
    }
    // PORTING NOTE: Multi-tab only.
    Zh(t) {
        this.persistence.Zh(t);
    }
    Ih(t, e, s) {
        const n = e.batch, i = n.keys();
        let r = Qe.resolve();
        return i.forEach(i => {
            r = r.next(() => s.tr(t, i)).next(t => {
                let r = t;
                const o = e.gi.get(i);
                Ce(null !== o, "ackVersions should contain every doc in the write."), (!r || r.version.D(o) < 0) && (r = n.Ut(i, r, e), 
                r && 
                // We use the commitVersion as the readTime rather than the
                // document's updateTime since the updateTime is not advanced
                // for updates that do not modify the underlying document.
                s.Yi(r, e.Vi));
            });
        }), r.next(() => this.ar.Vh(t, n));
    }
    No(t) {
        return this.persistence.runTransaction("Collect garbage", "readwrite-primary", e => t.Uo(e, this.Ko));
    }
    // PORTING NOTE: Multi-tab only.
    ta(t) {
        const e = this.Ko.get(t);
        return e ? Promise.resolve(e.target) : this.persistence.runTransaction("Get target data", "readonly", e => this.th.un(e, t).next(t => t ? t.target : null));
    }
    /**
     * Returns the set of documents that have been updated since the last call.
     * If this is the first call, returns the set of changes since client
     * initialization. Further invocations will return document changes since
     * the point of rejection.
     */
    // PORTING NOTE: Multi-tab only.
    ea() {
        return this.persistence.runTransaction("Get new document changes", "readonly", t => this.Xo.ea(t, this.zo)).then(({sa: t, readTime: e}) => (this.zo = e, 
        t));
    }
    /**
     * Reads the newest document change from persistence and forwards the internal
     * synchronization marker so that calls to `getNewDocumentChanges()`
     * only return changes that happened after client initialization.
     */
    // PORTING NOTE: Multi-tab only.
    async rh() {
        this.zo = await this.persistence.runTransaction("Synchronize last document change read time", "readonly", t => this.Xo.na(t));
    }
}

/**
 * The maximum time to leave a resume token buffered without writing it out.
 * This value is arbitrary: it's long enough to avoid several writes
 * (possibly indefinitely if updates come more frequently than this) but
 * short enough that restarting after crashing will still have a pretty
 * recent resume token.
 */
/**
 * Verifies the error thrown by a LocalStore operation. If a LocalStore
 * operation fails because the primary lease has been taken by another client,
 * we ignore the error (the persistence layer will immediately call
 * `applyPrimaryLease` to propagate the primary state change). All other errors
 * are re-thrown.
 *
 * @param err An error returned by a LocalStore operation.
 * @return A Promise that resolves after we recovered, or the original error.
 */
async function os(t) {
    if (t.code !== w.FAILED_PRECONDITION || t.message !== je) throw t;
    be("LocalStore", "Unexpectedly lost primary lease");
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Validates that no arguments were passed in the invocation of functionName.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateNoArgs('myFunction', arguments);
 */ function hs(t, e) {
    if (0 !== e.length) throw new I(w.INVALID_ARGUMENT, `Function ${t}() does not support arguments, ` + "but was called with " + ps(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has the exact number of arguments.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateExactNumberOfArgs('myFunction', arguments, 2);
 */ function as(t, e, s) {
    if (e.length !== s) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires ` + ps(s, "argument") + ", but was called with " + ps(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has at least the provided number of
 * arguments (but can have many more).
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateAtLeastNumberOfArgs('myFunction', arguments, 2);
 */ function us(t, e, s) {
    if (e.length < s) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires at least ` + ps(s, "argument") + ", but was called with " + ps(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has number of arguments between
 * the values provided.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateBetweenNumberOfArgs('myFunction', arguments, 2, 3);
 */ function cs(t, e, s, n) {
    if (e.length < s || e.length > n) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires between ${s} and ` + `${n} arguments, but was called with ` + ps(e.length, "argument") + ".");
}

/**
 * Validates the provided argument is an array and has as least the expected
 * number of elements.
 */
/**
 * Validates the provided positional argument has the native JavaScript type
 * using typeof checks.
 */
function _s(t, e, s, n) {
    Es(t, e, `${gs(s)} argument`, n);
}

/**
 * Validates the provided argument has the native JavaScript type using
 * typeof checks or is undefined.
 */ function ls(t, e, s, n) {
    void 0 !== n && _s(t, e, s, n);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks.
 */ function ds(t, e, s, n) {
    Es(t, e, `${s} option`, n);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks or is undefined.
 */ function fs(t, e, s, n) {
    void 0 !== n && ds(t, e, s, n);
}

function Ts(t, e, s, n, i) {
    void 0 !== n && function(t, e, s, n, i) {
        if (!(n instanceof Array)) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires its ${e} ` + `option to be an array, but it was: ${Is(n)}`);
        for (let r = 0; r < n.length; ++r) if (!i(n[r])) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires all ${e} ` + `elements to be ${s}, but the value at index ${r} ` + `was: ${Is(n[r])}`);
    }(t, e, s, n, i);
}

/**
 * Validates that the provided named option equals one of the expected values.
 */
/**
 * Validates that the provided named option equals one of the expected values or
 * is undefined.
 */
function ms(t, e, s, n, i) {
    void 0 !== n && function(t, e, s, n, i) {
        const r = [];
        for (const t of i) {
            if (t === n) return;
            r.push(Is(t));
        }
        const o = Is(n);
        throw new I(w.INVALID_ARGUMENT, `Invalid value ${o} provided to function ${t}() for option ` + `"${s}". Acceptable values: ${r.join(", ")}`);
    }(t, 0, s, n, i);
}

/**
 * Validates that the provided argument is a valid enum.
 *
 * @param functionName Function making the validation call.
 * @param enums Array containing all possible values for the enum.
 * @param position Position of the argument in `functionName`.
 * @param argument Arugment to validate.
 */
/** Helper to validate the type of a provided input. */
function Es(t, e, s, n) {
    let i = !1;
    if (i = "object" === e ? ws(n) : "non-empty string" === e ? "string" == typeof n && "" !== n : typeof n === e, 
    !i) {
        const i = Is(n);
        throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires its ${s} ` + `to be of type ${e}, but it was: ${i}`);
    }
}

/**
 * Returns true if it's a non-null object without a custom prototype
 * (i.e. excludes Array, Date, etc.).
 */ function ws(t) {
    return "object" == typeof t && null !== t && (Object.getPrototypeOf(t) === Object.prototype || null === Object.getPrototypeOf(t));
}

/** Returns a string describing the type / value of the provided input. */ function Is(t) {
    if (void 0 === t) return "undefined";
    if (null === t) return "null";
    if ("string" == typeof t) return t.length > 20 && (t = `${t.substring(0, 20)}...`), 
    JSON.stringify(t);
    if ("number" == typeof t || "boolean" == typeof t) return "" + t;
    if ("object" == typeof t) {
        if (t instanceof Array) return "an array";
        {
            const e = 
            /** Hacky method to try to get the constructor name for an object. */
            function(t) {
                if (t.constructor) {
                    const e = /function\s+([^\s(]+)\s*\(/.exec(t.constructor.toString());
                    if (e && e.length > 1) return e[1];
                }
                return null;
            }
            /** Validates the provided argument is defined. */ (t);
            return e ? `a custom ${e} object` : "an object";
        }
    }
    return "function" == typeof t ? "a function" : De("Unknown wrong type: " + typeof t);
}

function Rs(t, e, s) {
    if (void 0 === s) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires a valid ${gs(e)} ` + "argument, but it was undefined.");
}

/**
 * Validates the provided positional argument is an object, and its keys and
 * values match the expected keys and types provided in optionTypes.
 */ function As(t, e, s) {
    O(e, (e, n) => {
        if (s.indexOf(e) < 0) throw new I(w.INVALID_ARGUMENT, `Unknown option '${e}' passed to function ${t}(). ` + "Available options: " + s.join(", "));
    });
}

/**
 * Helper method to throw an error that the provided argument did not pass
 * an instanceof check.
 */ function Ps(t, e, s, n) {
    const i = Is(n);
    return new I(w.INVALID_ARGUMENT, `Function ${t}() requires its ${gs(s)} ` + `argument to be a ${e}, but it was: ${i}`);
}

function Vs(t, e, s) {
    if (s <= 0) throw new I(w.INVALID_ARGUMENT, `Function "${t}()" requires its ${gs(e)} argument to be a positive number, but it was: ${s}.`);
}

/** Converts a number to its english word representation */ function gs(t) {
    switch (t) {
      case 1:
        return "first";

      case 2:
        return "second";

      case 3:
        return "third";

      default:
        return t + "th";
    }
}

/**
 * Formats the given word as plural conditionally given the preceding number.
 */ function ps(t, e) {
    return `${t} ${e}` + (1 === t ? "" : "s");
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Helper function to prevent instantiation through the constructor.
 *
 * This method creates a new constructor that throws when it's invoked.
 * The prototype of that constructor is then set to the prototype of the hidden
 * "class" to expose all the prototype methods and allow for instanceof
 * checks.
 *
 * To also make all the static methods available, all properties of the
 * original constructor are copied to the new constructor.
 */ function ys(t, e) {
    function s() {
        let t = "This constructor is private.";
        throw e && (t += " ", t += e), new I(w.INVALID_ARGUMENT, t);
    }
    // Make sure instanceof checks work and all methods are exposed on the public
    // constructor
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return s.prototype = t.prototype, 
    // Copy any static methods/members
    Object.assign(s, t), s;
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Helper function to assert Uint8Array is available at runtime. */ function bs() {
    if ("undefined" == typeof Uint8Array) throw new I(w.UNIMPLEMENTED, "Uint8Arrays are not available in this environment.");
}

/** Helper function to assert Base64 functions are available at runtime. */ function vs() {
    if (!Ve.Lt().ia) throw new I(w.UNIMPLEMENTED, "Blobs are unavailable in Firestore in this environment.");
}

/**
 * Immutable class holding a blob (binary data).
 * This class is directly exposed in the public API.
 *
 * Note that while you can't hide the constructor in JavaScript code, we are
 * using the hack above to make sure no-one outside this module can call it.
 */ rs.Mh = 3e8;

class Ss {
    constructor(t) {
        vs(), this.ra = t;
    }
    static fromBase64String(t) {
        as("Blob.fromBase64String", arguments, 1), _s("Blob.fromBase64String", "string", 1, t), 
        vs();
        try {
            return new Ss(B.fromBase64String(t));
        } catch (t) {
            throw new I(w.INVALID_ARGUMENT, "Failed to construct Blob from Base64 string: " + t);
        }
    }
    static fromUint8Array(t) {
        if (as("Blob.fromUint8Array", arguments, 1), bs(), !(t instanceof Uint8Array)) throw Ps("Blob.fromUint8Array", "Uint8Array", 1, t);
        return new Ss(B.fromUint8Array(t));
    }
    toBase64() {
        return as("Blob.toBase64", arguments, 0), vs(), this.ra.toBase64();
    }
    toUint8Array() {
        return as("Blob.toUint8Array", arguments, 0), bs(), this.ra.toUint8Array();
    }
    toString() {
        return "Blob(base64: " + this.toBase64() + ")";
    }
    isEqual(t) {
        return this.ra.isEqual(t.ra);
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting Blob on firebase.firestore.Blob and will be called Blob
// publicly. Internally we still use Blob which has a type checked private
// constructor. Note that Blob and PublicBlob can be used interchangeably in
// instanceof checks.
// For our internal TypeScript code PublicBlob doesn't exist as a type, and so
// we need to use Blob as type and export it too.
const Ds = ys(Ss, "Use Blob.fromUint8Array() or Blob.fromBase64String() instead.");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// The objects that are a part of this API are exposed to third-parties as
// compiled javascript so we want to flag our private members with a leading
// underscore to discourage their use.
/**
 * A FieldPath refers to a field in a document. The path may consist of a single
 * field name (referring to a top-level field in the document), or a list of
 * field names (referring to a nested field in the document).
 */ class Cs {
    /**
     * Creates a FieldPath from the provided field names. If more than one field
     * name is provided, the path will point to a nested field in a document.
     *
     * @param fieldNames A list of field names.
     */
    constructor(...t) {
        !function(t, e, s, n) {
            if (!(e instanceof Array) || e.length < n) throw new I(w.INVALID_ARGUMENT, `Function ${t}() requires its ${s} argument to be an ` + "array with at least " + `${ps(n, "element")}.`);
        }("FieldPath", t, "fieldNames", 1);
        for (let e = 0; e < t.length; ++e) if (_s("FieldPath", "string", e, t[e]), 0 === t[e].length) throw new I(w.INVALID_ARGUMENT, "Invalid field name at argument $(i + 1). Field names must not be empty.");
        this.oa = new D(t);
    }
    static documentId() {
        return Cs.ha;
    }
    isEqual(t) {
        if (!(t instanceof Cs)) throw Ps("isEqual", "FieldPath", 1, t);
        return this.oa.isEqual(t.oa);
    }
}

/**
 * Internal Note: The backend doesn't technically support querying by
 * document ID. Instead it queries by the entire document name (full path
 * included), but in the cases we currently support documentId(), the net
 * effect is the same.
 */ Cs.ha = new Cs(D.X().K());

/**
 * Matches any characters in a field path string that are reserved.
 */
const ks = new RegExp("[~\\*/\\[\\]]");

/**
 * Parses a field path string into a FieldPath, treating dots as separators.
 */
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An opaque base class for FieldValue sentinel objects in our public API,
 * with public static methods for creating said sentinel objects.
 */
class Ns {
    constructor(t) {
        this.aa = t;
    }
    static delete() {
        return hs("FieldValue.delete", arguments), Fs.instance;
    }
    static serverTimestamp() {
        return hs("FieldValue.serverTimestamp", arguments), $s.instance;
    }
    static arrayUnion(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return us("FieldValue.arrayUnion", arguments, 1), new Ms(t);
    }
    static arrayRemove(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return us("FieldValue.arrayRemove", arguments, 1), new Ls(t);
    }
    static increment(t) {
        return _s("FieldValue.increment", "number", 1, t), as("FieldValue.increment", arguments, 1), 
        new Os(t);
    }
    isEqual(t) {
        return this === t;
    }
}

class Fs extends Ns {
    constructor() {
        super("FieldValue.delete");
    }
}

/** Singleton instance. */ Fs.instance = new Fs;

class $s extends Ns {
    constructor() {
        super("FieldValue.serverTimestamp");
    }
}

/** Singleton instance. */ $s.instance = new $s;

class Ms extends Ns {
    constructor(t) {
        super("FieldValue.arrayUnion"), this.ua = t;
    }
}

class Ls extends Ns {
    constructor(t) {
        super("FieldValue.arrayRemove"), this.ua = t;
    }
}

class Os extends Ns {
    constructor(t) {
        super("FieldValue.increment"), this.ca = t;
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting FieldValueImpl on firebase.firestore.FieldValue and will
// be called FieldValue publicly. Internally we still use FieldValueImpl which
// has a type-checked private constructor. Note that FieldValueImpl and
// PublicFieldValue can be used interchangeably in instanceof checks.
// For our internal TypeScript code PublicFieldValue doesn't exist as a type,
// and so we need to use FieldValueImpl as type and export it too.
const xs = ys(Ns, "Use FieldValue.<field>() instead.");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class representing a geo point as latitude-longitude pair.
 * This class is directly exposed in the public API, including its constructor.
 */ class Bs {
    constructor(t, e) {
        if (as("GeoPoint", arguments, 2), _s("GeoPoint", "number", 1, t), _s("GeoPoint", "number", 2, e), 
        !isFinite(t) || t < -90 || t > 90) throw new I(w.INVALID_ARGUMENT, "Latitude must be a number between -90 and 90, but was: " + t);
        if (!isFinite(e) || e < -180 || e > 180) throw new I(w.INVALID_ARGUMENT, "Longitude must be a number between -180 and 180, but was: " + e);
        this._a = t, this.la = e;
    }
    /**
     * Returns the latitude of this geo point, a number between -90 and 90.
     */    get latitude() {
        return this._a;
    }
    /**
     * Returns the longitude of this geo point, a number between -180 and 180.
     */    get longitude() {
        return this.la;
    }
    isEqual(t) {
        return this._a === t._a && this.la === t.la;
    }
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */    p(t) {
        return Ne(this._a, t._a) || Ne(this.la, t.la);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Us = /^__.*__$/;

/** The result of parsing document data (e.g. for a setData call). */ class qs {
    constructor(t, e, s) {
        this.data = t, this.se = e, this.fieldTransforms = s;
    }
    da(t, e) {
        const s = [];
        return null !== this.se ? s.push(new Rt(t, this.data, this.se, e)) : s.push(new It(t, this.data, e)), 
        this.fieldTransforms.length > 0 && s.push(new At(t, this.fieldTransforms)), s;
    }
}

/** The result of parsing "update" data (i.e. for an updateData call). */ class Qs {
    constructor(t, e, s) {
        this.data = t, this.se = e, this.fieldTransforms = s;
    }
    da(t, e) {
        const s = [ new Rt(t, this.data, this.se, e) ];
        return this.fieldTransforms.length > 0 && s.push(new At(t, this.fieldTransforms)), 
        s;
    }
}

function Ws(t) {
    switch (t) {
      case 0 /* Set */ :
 // fall through
              case 2 /* MergeSet */ :
 // fall through
              case 1 /* Update */ :
        return !0;

      case 3 /* Argument */ :
      case 4 /* ArrayArgument */ :
        return !1;

      default:
        throw De(`Unexpected case for UserDataSource: ${t}`);
    }
}

/** A "context" object passed around while parsing user data. */ class js {
    /**
     * Initializes a ParseContext with the given source and path.
     *
     * @param dataSource Indicates what kind of API method this data came from.
     * @param methodName The name of the method the user called to create this
     *     ParseContext.
     * @param path A path within the object being parsed. This could be an empty
     *     path (in which case the context represents the root of the data being
     *     parsed), or a nonempty path (indicating the context represents a nested
     *     location within the data).
     * @param arrayElement Whether or not this context corresponds to an element
     *     of an array.
     * @param fieldTransforms A mutable list of field transforms encountered while
     *     parsing the data.
     * @param fieldMask A mutable list of field paths encountered while parsing
     *     the data.
     *
     * TODO(b/34871131): We don't support array paths right now, so path can be
     * null to indicate the context represents any location within an array (in
     * which case certain features will not work and errors will be somewhat
     * compromised).
     */
    constructor(t, e, s, n, i, r) {
        this.fa = t, this.methodName = e, this.path = s, this.Ta = n, 
        // Minor hack: If fieldTransforms is undefined, we assume this is an
        // external call and we need to validate the entire path.
        void 0 === i && this.ma(), this.Ta = void 0 !== n && n, this.fieldTransforms = i || [], 
        this.se = r || [];
    }
    Ea(t) {
        const e = null == this.path ? null : this.path.child(t), s = new js(this.fa, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.se);
        return s.wa(t), s;
    }
    Ia(t) {
        const e = null == this.path ? null : this.path.child(t), s = new js(this.fa, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.se);
        return s.ma(), s;
    }
    Ra(t) {
        // TODO(b/34871131): We don't support array paths right now; so make path
        // null.
        return new js(this.fa, this.methodName, 
        /*path=*/ null, 
        /*arrayElement=*/ !0, this.fieldTransforms, this.se);
    }
    Aa(t) {
        const e = null === this.path || this.path.U() ? "" : ` (found in field ${this.path.toString()})`;
        return new I(w.INVALID_ARGUMENT, `Function ${this.methodName}() called with invalid data. ` + t + e);
    }
    /** Returns 'true' if 'fieldPath' was traversed when creating this context. */    contains(t) {
        return void 0 !== this.se.find(e => t.q(e)) || void 0 !== this.fieldTransforms.find(e => t.q(e.field));
    }
    ma() {
        // TODO(b/34871131): Remove null check once we have proper paths for fields
        // within arrays.
        if (null !== this.path) for (let t = 0; t < this.path.length; t++) this.wa(this.path.get(t));
    }
    wa(t) {
        if (0 === t.length) throw this.Aa("Document fields must not be empty");
        if (Ws(this.fa) && Us.test(t)) throw this.Aa('Document fields cannot begin and end with "__"');
    }
}

/**
 * A placeholder object for DocumentReferences in this file, in order to
 * avoid a circular dependency. See the comments for `DataPreConverter` for
 * the full context.
 */ class Ks {
    constructor(t, e) {
        this.cn = t, this.key = e;
    }
}

/**
 * Helper for parsing raw user input (provided via the API) into internal model
 * classes.
 */ class Gs {
    constructor(t, e) {
        this.serializer = t, this.Pa = e;
    }
    /** Parse document data from a non-merge set() call. */    Va(t, e) {
        const s = new js(0 /* Set */ , t, D.H);
        Hs("Data must be an object, but it was:", s, e);
        const n = this.ga(e, s);
        return new qs(new gt(n), 
        /* fieldMask= */ null, s.fieldTransforms);
    }
    /** Parse document data from a set() call with '{merge:true}'. */    pa(t, e, s) {
        const n = new js(2 /* MergeSet */ , t, D.H);
        Hs("Data must be an object, but it was:", n, e);
        const i = this.ga(e, n);
        let r, o;
        if (s) {
            let e = new $(D.F);
            for (const i of s) {
                let s;
                if (i instanceof Cs) s = i.oa; else {
                    if ("string" != typeof i) throw De("Expected stringOrFieldPath to be a string or a FieldPath");
                    s = Ys(t, i);
                }
                if (!n.contains(s)) throw new I(w.INVALID_ARGUMENT, `Field '${s}' is specified in your field mask but missing from your input data.`);
                e = e.add(s);
            }
            r = ft.Kt(e), o = n.fieldTransforms.filter(t => r.zt(t.field));
        } else r = ft.Gt(n.se), o = n.fieldTransforms;
        return new qs(new gt(i), r, o);
    }
    /** Parse update data from an update() call. */    ya(t, e) {
        const s = new js(1 /* Update */ , t, D.H);
        Hs("Data must be an object, but it was:", s, e);
        let n = new $(D.F);
        const i = gt._e();
        O(e, (e, r) => {
            const o = Ys(t, e), h = s.Ia(o);
            if ((r = this.ba(r, h)) instanceof Fs) 
            // Add it to the field mask, but don't add anything to updateData.
            n = n.add(o); else {
                const t = this.va(r, h);
                null != t && (n = n.add(o), i.set(o, t));
            }
        });
        const r = ft.Kt(n);
        return new Qs(i.oe(), r, s.fieldTransforms);
    }
    /** Parse update data from a list of field/value arguments. */    Sa(t, e, s, n) {
        const i = new js(1 /* Update */ , t, D.H), r = [ Js(t, e) ], o = [ s ];
        if (n.length % 2 != 0) throw new I(w.INVALID_ARGUMENT, `Function ${t}() needs to be called with an even number ` + "of arguments that alternate between field names and values.");
        for (let e = 0; e < n.length; e += 2) r.push(Js(t, n[e])), o.push(n[e + 1]);
        let h = new $(D.F);
        const a = gt._e();
        for (let t = 0; t < r.length; ++t) {
            const e = r[t], s = i.Ia(e), n = this.ba(o[t], s);
            if (n instanceof Fs) 
            // Add it to the field mask, but don't add anything to updateData.
            h = h.add(e); else {
                const t = this.va(n, s);
                null != t && (h = h.add(e), a.set(e, t));
            }
        }
        const u = ft.Kt(h);
        return new Qs(a.oe(), u, i.fieldTransforms);
    }
    /**
     * Parse a "query value" (e.g. value in a where filter or a value in a cursor
     * bound).
     *
     * @param allowArrays Whether the query value is an array that may directly
     * contain additional arrays (e.g. the operand of an `in` query).
     */    Da(t, e, s = !1) {
        const n = new js(s ? 4 /* ArrayArgument */ : 3 /* Argument */ , t, D.H);
        return this.va(e, n);
    }
    /** Sends data through this.preConverter, handling any thrown errors. */    ba(t, e) {
        try {
            return this.Pa(t);
        } catch (t) {
            const s = Xs(t);
            throw e.Aa(s);
        }
    }
    /**
     * Internal helper for parsing user data.
     *
     * @param input Data to be parsed.
     * @param context A context object representing the current path being parsed,
     * the source of the data being parsed, etc.
     * @return The parsed value, or null if the value was a FieldValue sentinel
     * that should not be included in the resulting parsed data.
     */    va(t, e) {
        if (zs(t = this.ba(t, e))) return Hs("Unsupported field value:", e, t), this.ga(t, e);
        if (t instanceof Ns) 
        // FieldValues usually parse into transforms (except FieldValue.delete())
        // in which case we do not want to include this field in our parsed data
        // (as doing so will overwrite the field directly prior to the transform
        // trying to transform it). So we don't add this location to
        // context.fieldMask and we return null as our parsing result.
        return this.Ca(t, e), null;
        if (
        // If context.path is null we are inside an array and we don't support
        // field mask paths more granular than the top-level array.
        e.path && e.se.push(e.path), t instanceof Array) {
            // TODO(b/34871131): Include the path containing the array in the error
            // message.
            // In the case of IN queries, the parsed data is an array (representing
            // the set of values to be included for the IN query) that may directly
            // contain additional arrays (each representing an individual field
            // value), so we disable this validation.
            if (e.Ta && 4 /* ArrayArgument */ !== e.fa) throw e.Aa("Nested arrays are not supported");
            return this.ka(t, e);
        }
        return this.Na(t, e);
    }
    ga(t, e) {
        const s = {};
        return x(t) ? 
        // If we encounter an empty object, we explicitly add it to the update
        // mask to ensure that the server creates a map entry.
        e.path && e.path.length > 0 && e.se.push(e.path) : O(t, (t, n) => {
            const i = this.va(n, e.Ea(t));
            null != i && (s[t] = i);
        }), {
            mapValue: {
                fields: s
            }
        };
    }
    ka(t, e) {
        const s = [];
        let n = 0;
        for (const i of t) {
            let t = this.va(i, e.Ra(n));
            null == t && (
            // Just include nulls in the array for fields being replaced with a
            // sentinel.
            t = {
                nullValue: "NULL_VALUE"
            }), s.push(t), n++;
        }
        return {
            arrayValue: {
                values: s
            }
        };
    }
    /**
     * "Parses" the provided FieldValueImpl, adding any necessary transforms to
     * context.fieldTransforms.
     */    Ca(t, e) {
        // Sentinels are only supported with writes, and not within arrays.
        if (!Ws(e.fa)) throw e.Aa(`${t.aa}() can only be used with update() and set()`);
        if (null === e.path) throw e.Aa(`${t.aa}() is not currently supported inside arrays`);
        if (t instanceof Fs) {
            if (2 /* MergeSet */ !== e.fa) throw 1 /* Update */ === e.fa ? e.Aa("FieldValue.delete() can only appear at the top level of your update data") : e.Aa("FieldValue.delete() cannot be used with set() unless you pass {merge:true}");
            // No transform to add for a delete, but we need to add it to our
            // fieldMask so it gets deleted.
            e.se.push(e.path);
        } else if (t instanceof $s) e.fieldTransforms.push(new Tt(e.path, ut.instance)); else if (t instanceof Ms) {
            const s = this.Fa(t.aa, t.ua), n = new ct(s);
            e.fieldTransforms.push(new Tt(e.path, n));
        } else if (t instanceof Ls) {
            const s = this.Fa(t.aa, t.ua), n = new _t(s);
            e.fieldTransforms.push(new Tt(e.path, n));
        } else if (t instanceof Os) {
            const s = this.Da("FieldValue.increment", t.ca), n = new lt(this.serializer, s);
            e.fieldTransforms.push(new Tt(e.path, n));
        } else De("Unknown FieldValue type: " + t);
    }
    /**
     * Helper to parse a scalar value (i.e. not an Object, Array, or FieldValue)
     *
     * @return The parsed value
     */    Na(t, e) {
        if (null === t) return {
            nullValue: "NULL_VALUE"
        };
        if ("number" == typeof t) return this.serializer.Tn(t);
        if ("boolean" == typeof t) return {
            booleanValue: t
        };
        if ("string" == typeof t) return {
            stringValue: t
        };
        if (t instanceof Date) {
            const e = p.fromDate(t);
            return {
                timestampValue: this.serializer.k(e)
            };
        }
        if (t instanceof p) {
            // Firestore backend truncates precision down to microseconds. To ensure
            // offline mode works the same with regards to truncation, perform the
            // truncation immediately without waiting for the backend to do that.
            const e = new p(t.seconds, 1e3 * Math.floor(t.nanoseconds / 1e3));
            return {
                timestampValue: this.serializer.k(e)
            };
        }
        if (t instanceof Bs) return {
            geoPointValue: {
                latitude: t.latitude,
                longitude: t.longitude
            }
        };
        if (t instanceof Ss) return {
            bytesValue: this.serializer.mn(t)
        };
        if (t instanceof Ks) return {
            referenceValue: this.serializer.wn(t.key.path, t.cn)
        };
        throw e.Aa(`Unsupported field value: ${Is(t)}`);
    }
    Fa(t, e) {
        return e.map((e, s) => {
            // Although array transforms are used with writes, the actual elements
            // being unioned or removed are not considered writes since they cannot
            // contain any FieldValue sentinels, etc.
            const n = new js(3 /* Argument */ , t, D.H);
            return this.va(e, n.Ra(s));
        });
    }
}

/**
 * Checks whether an object looks like a JSON object that should be converted
 * into a struct. Normal class/prototype instances are considered to look like
 * JSON objects since they should be converted to a struct value. Arrays, Dates,
 * GeoPoints, etc. are not considered to look like JSON objects since they map
 * to specific FieldValue types other than ObjectValue.
 */ function zs(t) {
    return !("object" != typeof t || null === t || t instanceof Array || t instanceof Date || t instanceof p || t instanceof Bs || t instanceof Ss || t instanceof Ks || t instanceof Ns);
}

function Hs(t, e, s) {
    if (!zs(s) || !ws(s)) {
        const n = Is(s);
        throw "an object" === n ? e.Aa(t + " a custom object") : e.Aa(t + " " + n);
    }
}

/**
 * Helper that calls fromDotSeparatedString() but wraps any error thrown.
 */ function Js(t, e) {
    if (e instanceof Cs) return e.oa;
    if ("string" == typeof e) return Ys(t, e);
    throw new I(w.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${"Field path arguments must be of type string or FieldPath."}`);
}

/**
 * Wraps fromDotSeparatedString with an error message about the method that
 * was thrown.
 * @param methodName The publicly visible method name
 * @param path The dot-separated string form of a field path which will be split
 * on dots.
 */ function Ys(t, e) {
    try {
        return function(t) {
            if (t.search(ks) >= 0) throw new I(w.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not contain ` + "'~', '*', '/', '[', or ']'");
            try {
                return new Cs(...t.split("."));
            } catch (e) {
                throw new I(w.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, ` + "begin with '.', end with '.', or contain '..'");
            }
        }(e).oa;
    } catch (e) {
        const s = Xs(e);
        throw new I(w.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${s}`);
    }
}

/**
 * Extracts the message from a caught exception, which should be an Error object
 * though JS doesn't guarantee that.
 */ function Xs(t) {
    return t instanceof Error ? t.message : t.toString();
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A helper for running delayed tasks following an exponential backoff curve
 * between attempts.
 *
 * Each delay is made up of a "base" delay which follows the exponential
 * backoff curve, and a +/- 50% "jitter" that is calculated and added to the
 * base delay. This prevents clients from accidentally synchronizing their
 * delays causing spikes of load to the backend.
 */
class Zs {
    constructor(
    /**
     * The AsyncQueue to run backoff operations on.
     */
    t, 
    /**
     * The ID to use when scheduling backoff operations on the AsyncQueue.
     */
    e, 
    /**
     * The initial delay (used as the base delay on the first retry attempt).
     * Note that jitter will still be applied, so the actual delay could be as
     * little as 0.5*initialDelayMs.
     */
    s = 1e3
    /**
     * The multiplier to use to determine the extended base delay after each
     * attempt.
     */ , n = 1.5
    /**
     * The maximum base delay after which no further backoff is performed.
     * Note that jitter will still be applied, so the actual delay could be as
     * much as 1.5*maxDelayMs.
     */ , i = 6e4) {
        this.$a = t, this.Fr = e, this.Ma = s, this.La = n, this.Oa = i, this.xa = 0, this.Ba = null, 
        /** The last backoff attempt, as epoch milliseconds. */
        this.Ua = Date.now(), this.reset();
    }
    /**
     * Resets the backoff delay.
     *
     * The very next backoffAndWait() will have no delay. If it is called again
     * (i.e. due to an error), initialDelayMs (plus jitter) will be used, and
     * subsequent ones will increase according to the backoffFactor.
     */    reset() {
        this.xa = 0;
    }
    /**
     * Resets the backoff delay to the maximum delay (e.g. for use after a
     * RESOURCE_EXHAUSTED error).
     */    qa() {
        this.xa = this.Oa;
    }
    /**
     * Returns a promise that resolves after currentDelayMs, and increases the
     * delay for any subsequent attempts. If there was a pending backoff operation
     * already, it will be canceled.
     */    Qa(t) {
        // Cancel any pending backoff operation.
        this.cancel();
        // First schedule using the current base (which may be 0 and should be
        // honored as such).
        const e = Math.floor(this.xa + this.Wa()), s = Math.max(0, Date.now() - this.Ua), n = Math.max(0, e - s);
        // Guard against lastAttemptTime being in the future due to a clock change.
                this.xa > 0 && be("ExponentialBackoff", `Backing off for ${n} ms ` + `(base delay: ${this.xa} ms, ` + `delay with jitter: ${e} ms, ` + `last attempt: ${s} ms ago)`), 
        this.Ba = this.$a.eo(this.Fr, n, () => (this.Ua = Date.now(), t())), 
        // Apply backoff factor to determine next delay and ensure it is within
        // bounds.
        this.xa *= this.La, this.xa < this.Ma && (this.xa = this.Ma), this.xa > this.Oa && (this.xa = this.Oa);
    }
    cancel() {
        null !== this.Ba && (this.Ba.cancel(), this.Ba = null);
    }
    /** Returns a random value in the range [-currentBaseMs/2, currentBaseMs/2] */    Wa() {
        return (Math.random() - .5) * this.xa;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A PersistentStream is an abstract base class that represents a streaming RPC
 * to the Firestore backend. It's built on top of the connections own support
 * for streaming RPCs, and adds several critical features for our clients:
 *
 *   - Exponential backoff on failure
 *   - Authentication via CredentialsProvider
 *   - Dispatching all callbacks into the shared worker queue
 *   - Closing idle streams after 60 seconds of inactivity
 *
 * Subclasses of PersistentStream implement serialization of models to and
 * from the JSON representation of the protocol buffers for a specific
 * streaming RPC.
 *
 * ## Starting and Stopping
 *
 * Streaming RPCs are stateful and need to be start()ed before messages can
 * be sent and received. The PersistentStream will call the onOpen() function
 * of the listener once the stream is ready to accept requests.
 *
 * Should a start() fail, PersistentStream will call the registered onClose()
 * listener with a FirestoreError indicating what went wrong.
 *
 * A PersistentStream can be started and stopped repeatedly.
 *
 * Generic types:
 *  SendType: The type of the outgoing message of the underlying
 *    connection stream
 *  ReceiveType: The type of the incoming message of the underlying
 *    connection stream
 *  ListenerType: The type of the listener that will be used for callbacks
 */
class tn {
    constructor(t, e, s, n, i, r) {
        this.$a = t, this.ja = s, this.Ka = n, this.Ga = i, this.listener = r, this.state = 0 /* Initial */ , 
        /**
         * A close count that's incremented every time the stream is closed; used by
         * getCloseGuardedDispatcher() to invalidate callbacks that happen after
         * close.
         */
        this.za = 0, this.Ha = null, this.stream = null, this.Ja = new Zs(t, e);
    }
    /**
     * Returns true if start() has been called and no error has occurred. True
     * indicates the stream is open or in the process of opening (which
     * encompasses respecting backoff, getting auth tokens, and starting the
     * actual RPC). Use isOpen() to determine if the stream is open and ready for
     * outbound requests.
     */    Ya() {
        return 1 /* Starting */ === this.state || 2 /* Open */ === this.state || 4 /* Backoff */ === this.state;
    }
    /**
     * Returns true if the underlying RPC is open (the onOpen() listener has been
     * called) and the stream is ready for outbound requests.
     */    Xa() {
        return 2 /* Open */ === this.state;
    }
    /**
     * Starts the RPC. Only allowed if isStarted() returns false. The stream is
     * not immediately ready for use: onOpen() will be invoked when the RPC is
     * ready for outbound requests, at which point isOpen() will return true.
     *
     * When start returns, isStarted() will return true.
     */    start() {
        3 /* Error */ !== this.state ? this.auth() : this.Za();
    }
    /**
     * Stops the RPC. This call is idempotent and allowed regardless of the
     * current isStarted() state.
     *
     * When stop returns, isStarted() and isOpen() will both return false.
     */    async stop() {
        this.Ya() && await this.close(0 /* Initial */);
    }
    /**
     * After an error the stream will usually back off on the next attempt to
     * start it. If the error warrants an immediate restart of the stream, the
     * sender can use this to indicate that the receiver should not back off.
     *
     * Each error will call the onClose() listener. That function can decide to
     * inhibit backoff if required.
     */    tu() {
        this.state = 0 /* Initial */ , this.Ja.reset();
    }
    /**
     * Marks this stream as idle. If no further actions are performed on the
     * stream for one minute, the stream will automatically close itself and
     * notify the stream's onClose() handler with Status.OK. The stream will then
     * be in a !isStarted() state, requiring the caller to start the stream again
     * before further use.
     *
     * Only streams that are in state 'Open' can be marked idle, as all other
     * states imply pending network operations.
     */    eu() {
        // Starts the idle time if we are in state 'Open' and are not yet already
        // running a timer (in which case the previous idle timeout still applies).
        this.Xa() && null === this.Ha && (this.Ha = this.$a.eo(this.ja, 6e4, () => this.su()));
    }
    /** Sends a message to the underlying stream. */    nu(t) {
        this.iu(), this.stream.send(t);
    }
    /** Called by the idle timer when the stream should close due to inactivity. */    async su() {
        if (this.Xa()) 
        // When timing out an idle stream there's no reason to force the stream into backoff when
        // it restarts so set the stream state to Initial instead of Error.
        return this.close(0 /* Initial */);
    }
    /** Marks the stream as active again. */    iu() {
        this.Ha && (this.Ha.cancel(), this.Ha = null);
    }
    /**
     * Closes the stream and cleans up as necessary:
     *
     * * closes the underlying GRPC stream;
     * * calls the onClose handler with the given 'error';
     * * sets internal stream state to 'finalState';
     * * adjusts the backoff timer based on the error
     *
     * A new stream can be opened by calling start().
     *
     * @param finalState the intended state of the stream after closing.
     * @param error the error the connection was closed with.
     */    async close(t, e) {
        // Cancel any outstanding timers (they're guaranteed not to execute).
        this.iu(), this.Ja.cancel(), 
        // Invalidates any stream-related callbacks (e.g. from auth or the
        // underlying stream), guaranteeing they won't execute.
        this.za++, 3 /* Error */ !== t ? 
        // If this is an intentional close ensure we don't delay our next connection attempt.
        this.Ja.reset() : e && e.code === w.RESOURCE_EXHAUSTED ? (
        // Log the error. (Probably either 'quota exceeded' or 'max queue length reached'.)
        ve(e.toString()), ve("Using maximum backoff delay to prevent overloading the backend."), 
        this.Ja.qa()) : e && e.code === w.UNAUTHENTICATED && 
        // "unauthenticated" error means the token was rejected. Try force refreshing it in case it
        // just expired.
        this.Ga._(), 
        // Clean up the underlying stream because we are no longer interested in events.
        null !== this.stream && (this.ru(), this.stream.close(), this.stream = null), 
        // This state must be assigned before calling onClose() to allow the callback to
        // inhibit backoff or otherwise manipulate the state in its non-started state.
        this.state = t, 
        // Notify the listener that the stream closed.
        await this.listener.ou(e);
    }
    /**
     * Can be overridden to perform additional cleanup before the stream is closed.
     * Calling super.tearDown() is not required.
     */    ru() {}
    auth() {
        this.state = 1 /* Starting */;
        const t = this.hu(this.za), e = this.za;
        // TODO(mikelehen): Just use dispatchIfNotClosed, but see TODO below.
                this.Ga.getToken().then(t => {
            // Stream can be stopped while waiting for authentication.
            // TODO(mikelehen): We really should just use dispatchIfNotClosed
            // and let this dispatch onto the queue, but that opened a spec test can
            // of worms that I don't want to deal with in this PR.
            this.za === e && 
            // Normally we'd have to schedule the callback on the AsyncQueue.
            // However, the following calls are safe to be called outside the
            // AsyncQueue since they don't chain asynchronous calls
            this.au(t);
        }, e => {
            t(() => {
                const t = new I(w.UNKNOWN, "Fetching auth token failed: " + e.message);
                return this.uu(t);
            });
        });
    }
    au(t) {
        const e = this.hu(this.za);
        this.stream = this.cu(t), this.stream._u(() => {
            e(() => (this.state = 2 /* Open */ , this.listener._u()));
        }), this.stream.ou(t => {
            e(() => this.uu(t));
        }), this.stream.onMessage(t => {
            e(() => this.onMessage(t));
        });
    }
    Za() {
        this.state = 4 /* Backoff */ , this.Ja.Qa(async () => {
            this.state = 0 /* Initial */ , this.start();
        });
    }
    // Visible for tests
    uu(t) {
        // In theory the stream could close cleanly, however, in our current model
        // we never expect this to happen because if we stop a stream ourselves,
        // this callback will never be called. To prevent cases where we retry
        // without a backoff accidentally, we set the stream to error in all cases.
        return be("PersistentStream", `close with error: ${t}`), this.stream = null, this.close(3 /* Error */ , t);
    }
    /**
     * Returns a "dispatcher" function that dispatches operations onto the
     * AsyncQueue but only runs them if closeCount remains unchanged. This allows
     * us to turn auth / stream callbacks into no-ops if the stream is closed /
     * re-opened, etc.
     */    hu(t) {
        return e => {
            this.$a.qr(() => this.za === t ? e() : (be("PersistentStream", "stream callback skipped by getCloseGuardedDispatcher."), 
            Promise.resolve()));
        };
    }
}

/**
 * A PersistentStream that implements the Listen RPC.
 *
 * Once the Listen stream has called the onOpen() listener, any number of
 * listen() and unlisten() calls can be made to control what changes will be
 * sent from the server for ListenResponses.
 */ class en extends tn {
    constructor(t, e, s, n, i) {
        super(t, "listen_stream_connection_backoff" /* ListenStreamConnectionBackoff */ , "listen_stream_idle" /* ListenStreamIdle */ , e, s, i), 
        this.serializer = n;
    }
    cu(t) {
        return this.Ka.lu("Listen", t);
    }
    onMessage(t) {
        // A successful response means the stream is healthy
        this.Ja.reset();
        const e = this.serializer.kn(t), s = this.serializer.Fn(t);
        return this.listener.du(e, s);
    }
    /**
     * Registers interest in the results of the given target. If the target
     * includes a resumeToken it will be included in the request. Results that
     * affect the target will be streamed back as WatchChange messages that
     * reference the targetId.
     */    fu(t) {
        const e = {};
        e.database = this.serializer.pn, e.addTarget = this.serializer.xe(t);
        const s = this.serializer.ei(t);
        s && (e.labels = s), this.nu(e);
    }
    /**
     * Unregisters interest in the results of the target associated with the
     * given targetId.
     */    Tu(t) {
        const e = {};
        e.database = this.serializer.pn, e.removeTarget = t, this.nu(e);
    }
}

/**
 * A Stream that implements the Write RPC.
 *
 * The Write RPC requires the caller to maintain special streamToken
 * state in between calls, to help the server understand which responses the
 * client has processed by the time the next request is made. Every response
 * will contain a streamToken; this value must be passed to the next
 * request.
 *
 * After calling start() on this stream, the next request must be a handshake,
 * containing whatever streamToken is on hand. Once a response to this
 * request is received, all pending mutations may be submitted. When
 * submitting multiple batches of mutations at the same time, it's
 * okay to use the same streamToken for the calls to writeMutations.
 *
 * TODO(b/33271235): Use proto types
 */ class sn extends tn {
    constructor(t, e, s, n, i) {
        super(t, "write_stream_connection_backoff" /* WriteStreamConnectionBackoff */ , "write_stream_idle" /* WriteStreamIdle */ , e, s, i), 
        this.serializer = n, this.mu = !1, 
        /**
         * The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         *
         * PersistentWriteStream manages propagating this value from responses to the
         * next request.
         */
        this.lastStreamToken = B.xt;
    }
    /**
     * Tracks whether or not a handshake has been successfully exchanged and
     * the stream is ready to accept mutations.
     */    get Eu() {
        return this.mu;
    }
    // Override of PersistentStream.start
    start() {
        this.mu = !1, super.start();
    }
    ru() {
        this.mu && this.wu([]);
    }
    cu(t) {
        return this.Ka.lu("Write", t);
    }
    onMessage(t) {
        if (
        // Always capture the last stream token.
        Ce(!!t.streamToken, "Got a write response without a stream token"), this.lastStreamToken = this.serializer.En(t.streamToken), 
        this.mu) {
            // A successful first write response means the stream is healthy,
            // Note, that we could consider a successful handshake healthy, however,
            // the write itself might be causing an error we want to back off from.
            this.Ja.reset();
            const e = this.serializer.Wn(t.writeResults, t.commitTime), s = this.serializer.fromVersion(t.commitTime);
            return this.listener.Iu(s, e);
        }
        // The first response is always the handshake response
        return Ce(!t.writeResults || 0 === t.writeResults.length, "Got mutation results for handshake"), 
        this.mu = !0, this.listener.Ru();
    }
    /**
     * Sends an initial streamToken to the server, performing the handshake
     * required to make the StreamingWrite RPC work. Subsequent
     * calls should wait until onHandshakeComplete was called.
     */    Au() {
        // TODO(dimond): Support stream resumption. We intentionally do not set the
        // stream token on the handshake, ignoring any stream token we might have.
        const t = {};
        t.database = this.serializer.pn, this.nu(t);
    }
    /** Sends a group of mutations to the Firestore backend to apply. */    wu(t) {
        const e = {
            streamToken: this.serializer.mn(this.lastStreamToken),
            writes: t.map(t => this.serializer.$n(t))
        };
        this.nu(e);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Datastore is a wrapper around the external Google Cloud Datastore grpc API,
 * which provides an interface that is more convenient for the rest of the
 * client SDK architecture to consume.
 */ class nn {
    constructor(t, e, s, n) {
        this.$a = t, this.Ka = e, this.credentials = s, this.serializer = n;
    }
    Pu(t) {
        return new sn(this.$a, this.Ka, this.credentials, this.serializer, t);
    }
    Vu(t) {
        return new en(this.$a, this.Ka, this.credentials, this.serializer, t);
    }
    commit(t) {
        const e = {
            database: this.serializer.pn,
            writes: t.map(t => this.serializer.$n(t))
        };
        return this.gu("Commit", e).then(t => this.serializer.Wn(t.writeResults, t.commitTime));
    }
    pu(t) {
        const e = {
            database: this.serializer.pn,
            documents: t.map(t => this.serializer.An(t))
        };
        return this.yu("BatchGetDocuments", e).then(e => {
            let s = Yt();
            e.forEach(t => {
                const e = this.serializer.Cn(t);
                s = s.it(e.key, e);
            });
            const n = [];
            return t.forEach(t => {
                const e = s.get(t);
                Ce(!!e, "Missing entity in write response for " + t), n.push(e);
            }), n;
        });
    }
    /** Gets an auth token and invokes the provided RPC. */    gu(t, e) {
        return this.credentials.getToken().then(s => this.Ka.gu(t, e, s)).catch(t => {
            throw t.code === w.UNAUTHENTICATED && this.credentials._(), t;
        });
    }
    /** Gets an auth token and invokes the provided RPC with streamed results. */    yu(t, e) {
        return this.credentials.getToken().then(s => this.Ka.yu(t, e, s)).catch(t => {
            throw t.code === w.UNAUTHENTICATED && this.credentials._(), t;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Internal transaction object responsible for accumulating the mutations to
 * perform and the base versions for any documents read.
 */ class rn {
    constructor(t) {
        this.bu = t, 
        // The version of each document that was read during this transaction.
        this.vu = se(), this.mutations = [], this.Su = !1, 
        /**
         * A deferred usage error that occurred previously in this transaction that
         * will cause the transaction to fail once it actually commits.
         */
        this.Du = null, 
        /**
         * Set of documents that have been written in the transaction.
         *
         * When there's more than one write to the same key in a transaction, any
         * writes after the first are handled differently.
         */
        this.Cu = new Set;
    }
    async pu(t) {
        if (this.ku(), this.mutations.length > 0) throw new I(w.INVALID_ARGUMENT, "Firestore transactions require all reads to be executed before all writes.");
        const e = await this.bu.pu(t);
        return e.forEach(t => {
            t instanceof vt || t instanceof bt ? this.Nu(t) : De("Document in a transaction was a " + t.constructor.name);
        }), e;
    }
    set(t, e) {
        this.write(e.da(t, this.Zt(t))), this.Cu.add(t);
    }
    update(t, e) {
        try {
            this.write(e.da(t, this.Fu(t)));
        } catch (t) {
            this.Du = t;
        }
        this.Cu.add(t);
    }
    delete(t) {
        this.write([ new Pt(t, this.Zt(t)) ]), this.Cu.add(t);
    }
    async commit() {
        if (this.ku(), this.Du) throw this.Du;
        let t = this.vu;
        // For each mutation, note that the doc was written.
                this.mutations.forEach(e => {
            t = t.remove(e.key);
        }), 
        // For each document that was read but not written to, we want to perform
        // a `verify` operation.
        t.forEach((t, e) => {
            this.mutations.push(new Vt(t, this.Zt(t)));
        }), await this.bu.commit(this.mutations), this.Su = !0;
    }
    Nu(t) {
        let e;
        if (t instanceof bt) e = t.version; else {
            if (!(t instanceof vt)) throw De("Document in a transaction was a " + t.constructor.name);
            // For deleted docs, we must use baseVersion 0 when we overwrite them.
            e = y.S();
        }
        const s = this.vu.get(t.key);
        if (null !== s) {
            if (!e.isEqual(s)) 
            // This transaction will fail no matter what.
            throw new I(w.ABORTED, "Document version changed between two reads.");
        } else this.vu = this.vu.it(t.key, e);
    }
    /**
     * Returns the version of this document when it was read in this transaction,
     * as a precondition, or no precondition if it was not read.
     */    Zt(t) {
        const e = this.vu.get(t);
        return !this.Cu.has(t) && e ? Et.updateTime(e) : Et.NONE;
    }
    /**
     * Returns the precondition for a document if the operation is an update.
     */    Fu(t) {
        const e = this.vu.get(t);
        // The first time a document is written, we want to take into account the
        // read time and existence
                if (!this.Cu.has(t) && e) {
            if (e.isEqual(y.S())) 
            // The document doesn't exist, so fail the transaction.
            // This has to be validated locally because you can't send a
            // precondition that a document does not exist without changing the
            // semantics of the backend write to be an insert. This is the reverse
            // of what we want, since we want to assert that the document doesn't
            // exist but then send the update and have it fail. Since we can't
            // express that to the backend, we have to validate locally.
            // Note: this can change once we can send separate verify writes in the
            // transaction.
            throw new I(w.INVALID_ARGUMENT, "Can't update a document that doesn't exist.");
            // Document exists, base precondition on document update time.
                        return Et.updateTime(e);
        }
        // Document was not read, so we just use the preconditions for a blind
        // update.
        return Et.exists(!0);
    }
    write(t) {
        this.ku(), this.mutations = this.mutations.concat(t);
    }
    ku() {}
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A component used by the RemoteStore to track the OnlineState (that is,
 * whether or not the client as a whole should be considered to be online or
 * offline), implementing the appropriate heuristics.
 *
 * In particular, when the client is trying to connect to the backend, we
 * allow up to MAX_WATCH_STREAM_FAILURES within ONLINE_STATE_TIMEOUT_MS for
 * a connection to succeed. If we have too many failures or the timeout elapses,
 * then we set the OnlineState to Offline, and the client will behave as if
 * it is offline (get()s will return cached data, etc.).
 */
class on {
    constructor(t, e) {
        this.Nr = t, this.$u = e, 
        /** The current OnlineState. */
        this.state = "Unknown" /* Unknown */ , 
        /**
         * A count of consecutive failures to open the stream. If it reaches the
         * maximum defined by MAX_WATCH_STREAM_FAILURES, we'll set the OnlineState to
         * Offline.
         */
        this.Mu = 0, 
        /**
         * A timer that elapses after ONLINE_STATE_TIMEOUT_MS, at which point we
         * transition from OnlineState.Unknown to OnlineState.Offline without waiting
         * for the stream to actually fail (MAX_WATCH_STREAM_FAILURES times).
         */
        this.Lu = null, 
        /**
         * Whether the client should log a warning message if it fails to connect to
         * the backend (initially true, cleared after a successful stream, or if we've
         * logged the message already).
         */
        this.Ou = !0;
    }
    /**
     * Called by RemoteStore when a watch stream is started (including on each
     * backoff attempt).
     *
     * If this is the first attempt, it sets the OnlineState to Unknown and starts
     * the onlineStateTimer.
     */    xu() {
        0 === this.Mu && (this.Bu("Unknown" /* Unknown */), this.Lu = this.Nr.eo("online_state_timeout" /* OnlineStateTimeout */ , 1e4, () => (this.Lu = null, 
        this.Uu("Backend didn't respond within 10 seconds."), this.Bu("Offline" /* Offline */), 
        Promise.resolve())));
    }
    /**
     * Updates our OnlineState as appropriate after the watch stream reports a
     * failure. The first failure moves us to the 'Unknown' state. We then may
     * allow multiple failures (based on MAX_WATCH_STREAM_FAILURES) before we
     * actually transition to the 'Offline' state.
     */    qu(t) {
        "Online" /* Online */ === this.state ? this.Bu("Unknown" /* Unknown */) : (this.Mu++, 
        this.Mu >= 1 && (this.Qu(), this.Uu("Connection failed 1 " + `times. Most recent error: ${t.toString()}`), 
        this.Bu("Offline" /* Offline */)));
    }
    /**
     * Explicitly sets the OnlineState to the specified state.
     *
     * Note that this resets our timers / failure counters, etc. used by our
     * Offline heuristics, so must not be used in place of
     * handleWatchStreamStart() and handleWatchStreamFailure().
     */    set(t) {
        this.Qu(), this.Mu = 0, "Online" /* Online */ === t && (
        // We've connected to watch at least once. Don't warn the developer
        // about being offline going forward.
        this.Ou = !1), this.Bu(t);
    }
    Bu(t) {
        t !== this.state && (this.state = t, this.$u(t));
    }
    Uu(t) {
        const e = `Could not reach Cloud Firestore backend. ${t}\n` + "This typically indicates that your device does not have a healthy Internet connection at the moment. The client will operate in offline mode until it is able to successfully connect to the backend.";
        this.Ou ? (ve(e), this.Ou = !1) : be("OnlineStateTracker", e);
    }
    Qu() {
        null !== this.Lu && (this.Lu.cancel(), this.Lu = null);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * RemoteStore - An interface to remotely stored data, basically providing a
 * wrapper around the Datastore that is more reliable for the rest of the
 * system.
 *
 * RemoteStore is responsible for maintaining the connection to the server.
 * - maintaining a list of active listens.
 * - reconnecting when the connection is dropped.
 * - resuming all the active listens on reconnect.
 *
 * RemoteStore handles all incoming events from the Datastore.
 * - listening to the watch stream and repackaging the events as RemoteEvents
 * - notifying SyncEngine of any changes to the active listens.
 *
 * RemoteStore takes writes from other components and handles them reliably.
 * - pulling pending mutations from LocalStore and sending them to Datastore.
 * - retrying mutations that failed because of network problems.
 * - acking mutations to the SyncEngine once they are accepted or rejected.
 */
class hn {
    constructor(
    /**
     * The local store, used to fill the write pipeline with outbound mutations.
     */
    t, 
    /** The client-side proxy for interacting with the backend. */
    e, s, n, i) {
        this.Wu = t, this.bu = e, 
        /**
         * A list of up to MAX_PENDING_WRITES writes that we have fetched from the
         * LocalStore via fillWritePipeline() and have or will send to the write
         * stream.
         *
         * Whenever writePipeline.length > 0 the RemoteStore will attempt to start or
         * restart the write stream. When the stream is established the writes in the
         * pipeline will be sent in order.
         *
         * Writes remain in writePipeline until they are acknowledged by the backend
         * and thus will automatically be re-sent if the stream is interrupted /
         * restarted before they're acknowledged.
         *
         * Write responses from the backend are linked to their originating request
         * purely based on order, and so we can just shift() writes from the front of
         * the writePipeline as we receive responses.
         */
        this.ju = [], 
        /**
         * A mapping of watched targets that the client cares about tracking and the
         * user has explicitly called a 'listen' for this target.
         *
         * These targets may or may not have been sent to or acknowledged by the
         * server. On re-establishing the listen stream, these targets should be sent
         * to the server. The targets removed with unlistens are removed eagerly
         * without waiting for confirmation from the listen stream.
         */
        this.Ku = new Map, this.Gu = null, 
        /**
         * Set to true by enableNetwork() and false by disableNetwork() and indicates
         * the user-preferred network state.
         */
        this.networkEnabled = !1, this.isPrimary = !1, this.zu = i, this.zu.Hu(t => {
            s.qr(async () => {
                this.Ju() && (be("RemoteStore", "Restarting streams for network reachability change."), 
                await this.Yu());
            });
        }), this.Xu = new on(s, n), 
        // Create streams (but note they're not started yet).
        this.Zu = this.bu.Vu({
            _u: this.tc.bind(this),
            ou: this.ec.bind(this),
            du: this.sc.bind(this)
        }), this.nc = this.bu.Pu({
            _u: this.ic.bind(this),
            ou: this.rc.bind(this),
            Ru: this.oc.bind(this),
            Iu: this.Iu.bind(this)
        });
    }
    /**
     * Starts up the remote store, creating streams, restoring state from
     * LocalStore, etc.
     */    start() {
        return this.enableNetwork();
    }
    /** Re-enables the network. Idempotent. */    async enableNetwork() {
        this.networkEnabled = !0, this.Ju() && (this.nc.lastStreamToken = await this.Wu.ph(), 
        this.hc() ? this.ac() : this.Xu.set("Unknown" /* Unknown */), 
        // This will start the write stream if necessary.
        await this.uc());
    }
    /**
     * Temporarily disables the network. The network can be re-enabled using
     * enableNetwork().
     */    async disableNetwork() {
        this.networkEnabled = !1, await this.cc(), 
        // Set the OnlineState to Offline so get()s return from cache, etc.
        this.Xu.set("Offline" /* Offline */);
    }
    async cc() {
        await this.nc.stop(), await this.Zu.stop(), this.ju.length > 0 && (be("RemoteStore", `Stopping write stream with ${this.ju.length} pending writes`), 
        this.ju = []), this._c();
    }
    async lc() {
        be("RemoteStore", "RemoteStore shutting down."), this.networkEnabled = !1, await this.cc(), 
        this.zu.lc(), 
        // Set the OnlineState to Unknown (rather than Offline) to avoid potentially
        // triggering spurious listener events with cached data, etc.
        this.Xu.set("Unknown" /* Unknown */);
    }
    /**
     * Starts new listen for the given target. Uses resume token if provided. It
     * is a no-op if the target of given `TargetData` is already being listened to.
     */    listen(t) {
        this.Ku.has(t.targetId) || (
        // Mark this as something the client is currently listening for.
        this.Ku.set(t.targetId, t), this.hc() ? 
        // The listen will be sent in onWatchStreamOpen
        this.ac() : this.Zu.Xa() && this.dc(t));
    }
    /**
     * Removes the listen from server. It is a no-op if the given target id is
     * not being listened to.
     */    fc(t) {
        this.Ku.delete(t), this.Zu.Xa() && this.Tc(t), 0 === this.Ku.size && (this.Zu.Xa() ? this.Zu.eu() : this.Ju() && 
        // Revert to OnlineState.Unknown if the watch stream is not open and we
        // have no listeners, since without any listens to send we cannot
        // confirm if the stream is healthy and upgrade to OnlineState.Online.
        this.Xu.set("Unknown" /* Unknown */));
    }
    /** {@link TargetMetadataProvider.getTargetDataForTarget} */    un(t) {
        return this.Ku.get(t) || null;
    }
    /** {@link TargetMetadataProvider.getRemoteKeysForTarget} */    an(t) {
        return this.mc.an(t);
    }
    /**
     * We need to increment the the expected number of pending responses we're due
     * from watch so we wait for the ack to process any messages from this target.
     */    dc(t) {
        this.Gu.Bs(t.targetId), this.Zu.fu(t);
    }
    /**
     * We need to increment the expected number of pending responses we're due
     * from watch so we wait for the removal on the server before we process any
     * messages from this target.
     */    Tc(t) {
        this.Gu.Bs(t), this.Zu.Tu(t);
    }
    ac() {
        this.Gu = new me(this), this.Zu.start(), this.Xu.xu();
    }
    /**
     * Returns whether the watch stream should be started because it's necessary
     * and has not yet been started.
     */    hc() {
        return this.Ju() && !this.Zu.Ya() && this.Ku.size > 0;
    }
    Ju() {
        return this.isPrimary && this.networkEnabled;
    }
    _c() {
        this.Gu = null;
    }
    async tc() {
        this.Ku.forEach((t, e) => {
            this.dc(t);
        });
    }
    async ec(t) {
        this._c(), 
        // If we still need the watch stream, retry the connection.
        this.hc() ? (this.Xu.qu(t), this.ac()) : 
        // No need to restart watch stream because there are no active targets.
        // The online state is set to unknown because there is no active attempt
        // at establishing a connection
        this.Xu.set("Unknown" /* Unknown */);
    }
    async sc(t, e) {
        if (
        // Mark the client as online since we got a message from the server
        this.Xu.set("Online" /* Online */), t instanceof fe && 2 /* Removed */ === t.state && t.cause) 
        // There was an error on a target, don't wait for a consistent snapshot
        // to raise events
        return this.Ec(t);
        if (t instanceof le ? this.Gu.zs(t) : t instanceof de ? this.Gu.sn(t) : this.Gu.Ys(t), 
        !e.isEqual(y.MIN)) {
            const t = await this.Wu.bh();
            e.D(t) >= 0 && 
            // We have received a target change with a global snapshot if the snapshot
            // version is not equal to SnapshotVersion.MIN.
            await this.wc(e);
        }
    }
    /**
     * Takes a batch of changes from the Datastore, repackages them as a
     * RemoteEvent, and passes that on to the listener, which is typically the
     * SyncEngine.
     */    wc(t) {
        const e = this.Gu.rn(t);
        // Update in-memory resume tokens. LocalStore will update the
        // persistent view of these when applying the completed RemoteEvent.
                // Finally raise remote event
        return e.Ts.forEach((e, s) => {
            if (e.resumeToken.Ot() > 0) {
                const n = this.Ku.get(s);
                // A watched target might have been removed already.
                                n && this.Ku.set(s, n.ss(e.resumeToken, t));
            }
        }), 
        // Re-establish listens for the targets that have been invalidated by
        // existence filter mismatches.
        e.ms.forEach(t => {
            const e = this.Ku.get(t);
            if (!e) 
            // A watched target might have been removed already.
            return;
            // Clear the resume token for the target, since we're in a known mismatch
            // state.
                        this.Ku.set(t, e.ss(B.xt, e.ts)), 
            // Cause a hard reset by unwatching and rewatching immediately, but
            // deliberately don't send a resume token so that we get a full update.
            this.Tc(t);
            // Mark the target we send as being on behalf of an existence filter
            // mismatch, but don't actually retain that in listenTargets. This ensures
            // that we flag the first re-listen this way without impacting future
            // listens of this target (that might happen e.g. on reconnect).
            const s = new Wt(e.target, t, 1 /* ExistenceFilterMismatch */ , e.sequenceNumber);
            this.dc(s);
        }), this.mc.vh(e);
    }
    /** Handles an error on a target */    Ec(t) {
        const e = t.cause;
        let s = Promise.resolve();
        return t.targetIds.forEach(t => {
            s = s.then(async () => {
                // A watched target might have been removed already.
                if (this.Ku.has(t)) return this.Ku.delete(t), this.Gu.removeTarget(t), this.mc.Ic(t, e);
            });
        }), s;
    }
    /**
     * Attempts to fill our write pipeline with writes from the LocalStore.
     *
     * Called internally to bootstrap or refill the write pipeline and by
     * SyncEngine whenever there are new mutations to process.
     *
     * Starts the write stream if necessary.
     */    async uc() {
        if (this.Rc()) {
            const t = this.ju.length > 0 ? this.ju[this.ju.length - 1].batchId : -1, e = await this.Wu.Oh(t);
            null === e ? 0 === this.ju.length && this.nc.eu() : (this.Ac(e), await this.uc());
        }
        this.Pc() && this.Vc();
    }
    /**
     * Returns true if we can add to the write pipeline (i.e. the network is
     * enabled and the write pipeline is not full).
     */    Rc() {
        return this.Ju() && this.ju.length < 10;
    }
    // For testing
    gc() {
        return this.ju.length;
    }
    /**
     * Queues additional writes to be sent to the write stream, sending them
     * immediately if the write stream is established.
     */    Ac(t) {
        this.ju.push(t), this.nc.Xa() && this.nc.Eu && this.nc.wu(t.mutations);
    }
    Pc() {
        return this.Ju() && !this.nc.Ya() && this.ju.length > 0;
    }
    Vc() {
        this.nc.start();
    }
    async ic() {
        this.nc.Au();
    }
    oc() {
        // Record the stream token.
        return this.Wu.yh(this.nc.lastStreamToken).then(() => {
            // Send the write pipeline now that the stream is established.
            for (const t of this.ju) this.nc.wu(t.mutations);
        }).catch(os);
    }
    Iu(t, e) {
        const s = this.ju.shift(), n = Be.from(s, t, e, this.nc.lastStreamToken);
        return this.mc.pc(n).then(() => this.uc());
    }
    async rc(t) {
        // If the write stream closed due to an error, invoke the error callbacks if
        // there are pending writes.
        if (t && this.ju.length > 0) {
            // A promise that is resolved after we processed the error
            let e;
            // This error affects the actual write.
            return e = this.nc.Eu ? this.yc(t) : this.bc(t), e.then(() => {
                // The write stream might have been started by refilling the write
                // pipeline for failed writes
                this.Pc() && this.Vc();
            });
        }
        // No pending writes, nothing to do
        }
    async bc(t) {
        // Reset the token if it's a permanent error, signaling the write stream is
        // no longer valid. Note that the handshake does not count as a write: see
        // comments on isPermanentWriteError for details.
        if (zt(t.code)) return be("RemoteStore", "RemoteStore error before completed handshake; resetting stream token: ", this.nc.lastStreamToken), 
        this.nc.lastStreamToken = B.xt, this.Wu.yh(B.xt).catch(os);
    }
    async yc(t) {
        // Only handle permanent errors here. If it's transient, just let the retry
        // logic kick in.
        if (zt(e = t.code) && e !== w.ABORTED) {
            // This was a permanent error, the request itself was the problem
            // so it's not going to succeed if we resend it.
            const e = this.ju.shift();
            // In this case it's also unlikely that the server itself is melting
            // down -- this was just a bad request so inhibit backoff on the next
            // restart.
                        return this.nc.tu(), this.mc.vc(e.batchId, t).then(() => this.uc());
        }
        var e;
        /**
 * Maps an error Code from a GRPC status identifier like 'NOT_FOUND'.
 *
 * @returns The Code equivalent to the given status string or undefined if
 *     there is no match.
 */    }
    Sc() {
        return new rn(this.bu);
    }
    async Yu() {
        this.networkEnabled = !1, await this.cc(), this.Xu.set("Unknown" /* Unknown */), 
        await this.enableNetwork();
    }
    async Dc() {
        this.Ju() && (
        // Tear down and re-create our network streams. This will ensure we get a fresh auth token
        // for the new user and re-fill the write pipeline with new mutations from the LocalStore
        // (since mutations are per-user).
        be("RemoteStore", "RemoteStore restarting streams for new credential"), await this.Yu());
    }
    /**
     * Toggles the network state when the client gains or loses its primary lease.
     */    async Cc(t) {
        this.isPrimary = t, t && this.networkEnabled ? await this.enableNetwork() : t || (await this.cc(), 
        this.Xu.set("Unknown" /* Unknown */));
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// The format of the LocalStorage key that stores the client state is:
//     firestore_clients_<persistence_prefix>_<instance_key>
/** Assembles the key for a client state in WebStorage */
function an(t, e) {
    return `firestore_clients_${t}_${e}`;
}

// The format of the WebStorage key that stores the mutation state is:
//     firestore_mutations_<persistence_prefix>_<batch_id>
//     (for unauthenticated users)
// or: firestore_mutations_<persistence_prefix>_<batch_id>_<user_uid>

// 'user_uid' is last to avoid needing to escape '_' characters that it might
// contain.
/** Assembles the key for a mutation batch in WebStorage */
function un(t, e, s) {
    let n = `firestore_mutations_${t}_${s}`;
    return e.t() && (n += `_${e.uid}`), n;
}

// The format of the WebStorage key that stores a query target's metadata is:
//     firestore_targets_<persistence_prefix>_<target_id>
/** Assembles the key for a query state in WebStorage */
function cn(t, e) {
    return `firestore_targets_${t}_${e}`;
}

// The WebStorage prefix that stores the primary tab's online state. The
// format of the key is:
//     firestore_online_state_<persistence_prefix>
/**
 * Holds the state of a mutation batch, including its user ID, batch ID and
 * whether the batch is 'pending', 'acknowledged' or 'rejected'.
 */
// Visible for testing
class _n {
    constructor(t, e, s, n) {
        this.user = t, this.batchId = e, this.state = s, this.error = n;
    }
    /**
     * Parses a MutationMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static kc(t, e, s) {
        const n = JSON.parse(s);
        let i = "object" == typeof n && -1 !== [ "pending", "acknowledged", "rejected" ].indexOf(n.state) && (void 0 === n.error || "object" == typeof n.error), r = void 0;
        return i && n.error && (i = "string" == typeof n.error.message && "string" == typeof n.error.code, 
        i && (r = new I(n.error.code, n.error.message))), i ? new _n(t, e, n.state, r) : (ve("SharedClientState", `Failed to parse mutation state for ID '${e}': ${s}`), 
        null);
    }
    Nc() {
        const t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }
}

/**
 * Holds the state of a query target, including its target ID and whether the
 * target is 'not-current', 'current' or 'rejected'.
 */
// Visible for testing
class ln {
    constructor(t, e, s) {
        this.targetId = t, this.state = e, this.error = s;
    }
    /**
     * Parses a QueryTargetMetadata from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static kc(t, e) {
        const s = JSON.parse(e);
        let n = "object" == typeof s && -1 !== [ "not-current", "current", "rejected" ].indexOf(s.state) && (void 0 === s.error || "object" == typeof s.error), i = void 0;
        return n && s.error && (n = "string" == typeof s.error.message && "string" == typeof s.error.code, 
        n && (i = new I(s.error.code, s.error.message))), n ? new ln(t, s.state, i) : (ve("SharedClientState", `Failed to parse target state for ID '${t}': ${e}`), 
        null);
    }
    Nc() {
        const t = {
            state: this.state,
            updateTimeMs: Date.now()
        };
        return this.error && (t.error = {
            code: this.error.code,
            message: this.error.message
        }), JSON.stringify(t);
    }
}

/**
 * This class represents the immutable ClientState for a client read from
 * WebStorage, containing the list of active query targets.
 */ class dn {
    constructor(t, e) {
        this.clientId = t, this.activeTargetIds = e;
    }
    /**
     * Parses a RemoteClientState from the JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static kc(t, e) {
        const s = JSON.parse(e);
        let n = "object" == typeof s && s.activeTargetIds instanceof Array, i = oe();
        for (let t = 0; n && t < s.activeTargetIds.length; ++t) n = Q(s.activeTargetIds[t]), 
        i = i.add(s.activeTargetIds[t]);
        return n ? new dn(t, i) : (ve("SharedClientState", `Failed to parse client data for instance '${t}': ${e}`), 
        null);
    }
}

/**
 * This class represents the online state for all clients participating in
 * multi-tab. The online state is only written to by the primary client, and
 * used in secondary clients to update their query views.
 */ class fn {
    constructor(t, e) {
        this.clientId = t, this.onlineState = e;
    }
    /**
     * Parses a SharedOnlineState from its JSON representation in WebStorage.
     * Logs a warning and returns null if the format of the data is not valid.
     */    static kc(t) {
        const e = JSON.parse(t);
        return "object" == typeof e && -1 !== [ "Unknown", "Online", "Offline" ].indexOf(e.onlineState) && "string" == typeof e.clientId ? new fn(e.clientId, e.onlineState) : (ve("SharedClientState", `Failed to parse online state: ${t}`), 
        null);
    }
}

/**
 * Metadata state of the local client. Unlike `RemoteClientState`, this class is
 * mutable and keeps track of all pending mutations, which allows us to
 * update the range of pending mutation batch IDs as new mutations are added or
 * removed.
 *
 * The data in `LocalClientState` is not read from WebStorage and instead
 * updated via its instance methods. The updated state can be serialized via
 * `toWebStorageJSON()`.
 */
// Visible for testing.
class Tn {
    constructor() {
        this.activeTargetIds = oe();
    }
    Fc(t) {
        this.activeTargetIds = this.activeTargetIds.add(t);
    }
    $c(t) {
        this.activeTargetIds = this.activeTargetIds.delete(t);
    }
    /**
     * Converts this entry into a JSON-encoded format we can use for WebStorage.
     * Does not encode `clientId` as it is part of the key in WebStorage.
     */    Nc() {
        const t = {
            activeTargetIds: this.activeTargetIds.j(),
            updateTimeMs: Date.now()
        };
        return JSON.stringify(t);
    }
}

/**
 * `WebStorageSharedClientState` uses WebStorage (window.localStorage) as the
 * backing store for the SharedClientState. It keeps track of all active
 * clients and supports modifications of the local client's data.
 */ class mn {
    constructor(t, e, s, n, i) {
        if (this.$a = t, this.platform = e, this.persistenceKey = s, this.Mc = n, this.mc = null, 
        this.$u = null, this.vr = null, this.Lc = {}, this.Oc = this.xc.bind(this), this.ko = !1, 
        /**
         * Captures WebStorage events that occur before `start()` is called. These
         * events are replayed once `WebStorageSharedClientState` is started.
         */
        this.Bc = [], !mn.Uc(this.platform)) throw new I(w.UNIMPLEMENTED, "LocalStorage is not available on this platform.");
        // Escape the special characters mentioned here:
        // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Guide/Regular_Expressions
                const r = s.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
        this.storage = this.platform.window.localStorage, this.currentUser = i, this.qc = an(this.persistenceKey, this.Mc), 
        this.Qc = 
        /** Assembles the key for the current sequence number. */
        function(t) {
            return `firestore_sequence_number_${t}`;
        }
        /**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (this.persistenceKey), this.Lc[this.Mc] = new Tn, this.Wc = new RegExp(`^firestore_clients_${r}_([^_]*)$`), 
        this.jc = new RegExp(`^firestore_mutations_${r}_(\\d+)(?:_(.*))?$`), this.Kc = new RegExp(`^firestore_targets_${r}_(\\d+)$`), 
        this.Gc = 
        /** Assembles the key for the online state of the primary tab. */
        function(t) {
            return `firestore_online_state_${t}`;
        }
        // The WebStorage key prefix for the key that stores the last sequence number allocated. The key
        // looks like 'firestore_sequence_number_<persistence_prefix>'.
        (this.persistenceKey), 
        // Rather than adding the storage observer during start(), we add the
        // storage observer during initialization. This ensures that we collect
        // events before other components populate their initial state (during their
        // respective start() calls). Otherwise, we might for example miss a
        // mutation that is added after LocalStore's start() processed the existing
        // mutations but before we observe WebStorage events.
        this.platform.window.addEventListener("storage", this.Oc);
    }
    /** Returns 'true' if WebStorage is available in the current environment. */    static Uc(t) {
        return !(!t.window || null == t.window.localStorage);
    }
    async start() {
        // Retrieve the list of existing clients to backfill the data in
        // SharedClientState.
        const t = await this.mc.Jh();
        for (const e of t) {
            if (e === this.Mc) continue;
            const t = this.getItem(an(this.persistenceKey, e));
            if (t) {
                const s = dn.kc(e, t);
                s && (this.Lc[s.clientId] = s);
            }
        }
        this.zc();
        // Check if there is an existing online state and call the callback handler
        // if applicable.
        const e = this.storage.getItem(this.Gc);
        if (e) {
            const t = this.Hc(e);
            t && this.Jc(t);
        }
        for (const t of this.Bc) this.xc(t);
        this.Bc = [], 
        // Register a window unload hook to remove the client metadata entry from
        // WebStorage even if `shutdown()` was not called.
        this.platform.window.addEventListener("unload", () => this.lc()), this.ko = !0;
    }
    Cr(t) {
        this.setItem(this.Qc, JSON.stringify(t));
    }
    Yc() {
        let t = oe();
        return O(this.Lc, (e, s) => {
            t = t.Ft(s.activeTargetIds);
        }), t;
    }
    Xc(t) {
        // This is not using `obj.forEach` since `forEach` doesn't support early
        // return.
        for (const e in this.Lc) if (this.Lc.hasOwnProperty(e) && this.Lc[e].activeTargetIds.has(t)) return !0;
        return !1;
    }
    Zc(t) {
        this.t_(t, "pending");
    }
    e_(t, e, s) {
        this.t_(t, e, s), 
        // Once a final mutation result is observed by other clients, they no longer
        // access the mutation's metadata entry. Since WebStorage replays events
        // in order, it is safe to delete the entry right after updating it.
        this.s_(t);
    }
    n_(t) {
        let e = "not-current";
        // Lookup an existing query state if the target ID was already registered
        // by another tab
                if (this.Xc(t)) {
            const s = this.storage.getItem(cn(this.persistenceKey, t));
            if (s) {
                const n = ln.kc(t, s);
                n && (e = n.state);
            }
        }
        return this.i_.Fc(t), this.zc(), e;
    }
    r_(t) {
        this.i_.$c(t), this.zc();
    }
    o_(t) {
        return this.i_.activeTargetIds.has(t);
    }
    h_(t) {
        this.removeItem(cn(this.persistenceKey, t));
    }
    a_(t, e, s) {
        this.u_(t, e, s);
    }
    oh(t, e, s) {
        e.forEach(t => {
            this.s_(t);
        }), this.currentUser = t, s.forEach(t => {
            this.Zc(t);
        });
    }
    c_(t) {
        this.__(t);
    }
    lc() {
        this.ko && (this.platform.window.removeEventListener("storage", this.Oc), this.removeItem(this.qc), 
        this.ko = !1);
    }
    getItem(t) {
        const e = this.storage.getItem(t);
        return be("SharedClientState", "READ", t, e), e;
    }
    setItem(t, e) {
        be("SharedClientState", "SET", t, e), this.storage.setItem(t, e);
    }
    removeItem(t) {
        be("SharedClientState", "REMOVE", t), this.storage.removeItem(t);
    }
    xc(t) {
        if (t.storageArea === this.storage) {
            if (be("SharedClientState", "EVENT", t.key, t.newValue), t.key === this.qc) return void ve("Received WebStorage notification for local change. Another client might have garbage-collected our state");
            this.$a.qr(async () => {
                if (this.ko) {
                    if (null !== t.key) if (this.Wc.test(t.key)) {
                        if (null == t.newValue) {
                            const e = this.l_(t.key);
                            return this.d_(e, null);
                        }
                        {
                            const e = this.f_(t.key, t.newValue);
                            if (e) return this.d_(e.clientId, e);
                        }
                    } else if (this.jc.test(t.key)) {
                        if (null !== t.newValue) {
                            const e = this.T_(t.key, t.newValue);
                            if (e) return this.m_(e);
                        }
                    } else if (this.Kc.test(t.key)) {
                        if (null !== t.newValue) {
                            const e = this.E_(t.key, t.newValue);
                            if (e) return this.w_(e);
                        }
                    } else if (t.key === this.Gc) {
                        if (null !== t.newValue) {
                            const e = this.Hc(t.newValue);
                            if (e) return this.Jc(e);
                        }
                    } else if (t.key === this.Qc) {
                        const e = function(t) {
                            let e = He.kr;
                            if (null != t) try {
                                const s = JSON.parse(t);
                                Ce("number" == typeof s, "Found non-numeric sequence number"), e = s;
                            } catch (t) {
                                ve("SharedClientState", "Failed to read sequence number from WebStorage", t);
                            }
                            return e;
                        }
                        /**
 * `MemorySharedClientState` is a simple implementation of SharedClientState for
 * clients using memory persistence. The state in this class remains fully
 * isolated and no synchronization is performed.
 */ (t.newValue);
                        e !== He.kr && this.vr(e);
                    }
                } else this.Bc.push(t);
            });
        }
    }
    get i_() {
        return this.Lc[this.Mc];
    }
    zc() {
        this.setItem(this.qc, this.i_.Nc());
    }
    t_(t, e, s) {
        const n = new _n(this.currentUser, t, e, s), i = un(this.persistenceKey, this.currentUser, t);
        this.setItem(i, n.Nc());
    }
    s_(t) {
        const e = un(this.persistenceKey, this.currentUser, t);
        this.removeItem(e);
    }
    __(t) {
        const e = {
            clientId: this.Mc,
            onlineState: t
        };
        this.storage.setItem(this.Gc, JSON.stringify(e));
    }
    u_(t, e, s) {
        const n = cn(this.persistenceKey, t), i = new ln(t, e, s);
        this.setItem(n, i.Nc());
    }
    /**
     * Parses a client state key in WebStorage. Returns null if the key does not
     * match the expected key format.
     */    l_(t) {
        const e = this.Wc.exec(t);
        return e ? e[1] : null;
    }
    /**
     * Parses a client state in WebStorage. Returns 'null' if the value could not
     * be parsed.
     */    f_(t, e) {
        const s = this.l_(t);
        return dn.kc(s, e);
    }
    /**
     * Parses a mutation batch state in WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    T_(t, e) {
        const s = this.jc.exec(t), n = Number(s[1]), i = void 0 !== s[2] ? s[2] : null;
        return _n.kc(new E(i), n, e);
    }
    /**
     * Parses a query target state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    E_(t, e) {
        const s = this.Kc.exec(t), n = Number(s[1]);
        return ln.kc(n, e);
    }
    /**
     * Parses an online state from WebStorage. Returns 'null' if the value
     * could not be parsed.
     */    Hc(t) {
        return fn.kc(t);
    }
    async m_(t) {
        if (t.user.uid === this.currentUser.uid) return this.mc.I_(t.batchId, t.state, t.error);
        be("SharedClientState", `Ignoring mutation for non-active user ${t.user.uid}`);
    }
    w_(t) {
        return this.mc.R_(t.targetId, t.state, t.error);
    }
    d_(t, e) {
        const s = this.Yc();
        e ? this.Lc[t] = e : delete this.Lc[t];
        const n = this.Yc(), i = [], r = [];
        return n.forEach(async t => {
            s.has(t) || i.push(t);
        }), s.forEach(async t => {
            n.has(t) || r.push(t);
        }), this.mc.A_(i, r);
    }
    Jc(t) {
        // We check whether the client that wrote this online state is still active
        // by comparing its client ID to the list of clients kept active in
        // IndexedDb. If a client does not update their IndexedDb client state
        // within 5 seconds, it is considered inactive and we don't emit an online
        // state event.
        this.Lc[t.clientId] && this.$u(t.onlineState);
    }
}

class En {
    constructor() {
        this.P_ = new Tn, this.V_ = {}, this.mc = null, this.$u = null, this.vr = null;
    }
    Zc(t) {
        // No op.
    }
    e_(t, e, s) {
        // No op.
    }
    n_(t) {
        return this.P_.Fc(t), this.V_[t] || "not-current";
    }
    a_(t, e, s) {
        this.V_[t] = e;
    }
    r_(t) {
        this.P_.$c(t);
    }
    o_(t) {
        return this.P_.activeTargetIds.has(t);
    }
    h_(t) {
        delete this.V_[t];
    }
    Yc() {
        return this.P_.activeTargetIds;
    }
    Xc(t) {
        return this.P_.activeTargetIds.has(t);
    }
    start() {
        return this.P_ = new Tn, Promise.resolve();
    }
    oh(t, e, s) {
        // No op.
    }
    c_(t) {
        // No op.
    }
    lc() {}
    Cr(t) {}
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Offset to ensure non-overlapping target ids. */
/**
 * Generates monotonically increasing target IDs for sending targets to the
 * watch stream.
 *
 * The client constructs two generators, one for the target cache, and one for
 * for the sync engine (to generate limbo documents targets). These
 * generators produce non-overlapping IDs (by using even and odd IDs
 * respectively).
 *
 * By separating the target ID space, the query cache can generate target IDs
 * that persist across client restarts, while sync engine can independently
 * generate in-memory target IDs that are transient and can be reused after a
 * restart.
 */
class wn {
    constructor(t) {
        this.g_ = t;
    }
    next() {
        return this.g_ += 2, this.g_;
    }
    static p_() {
        // The target cache generator must return '2' in its first call to `next()`
        // as there is no differentiation in the protocol layer between an unset
        // number and the number '0'. If we were to sent a target with target ID
        // '0', the backend would consider it unset and replace it with its own ID.
        return new wn(0);
    }
    static y_() {
        // Sync engine assigns target IDs for limbo document detection.
        return new wn(-1);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class In {
    constructor(t) {
        this.key = t;
    }
}

class Rn {
    constructor(t) {
        this.key = t;
    }
}

/**
 * View is responsible for computing the final merged truth of what docs are in
 * a query. It gets notified of local and remote changes to docs, and applies
 * the query filters and limits to determine the most correct possible results.
 */ class An {
    constructor(t, 
    /** Documents included in the remote target */
    e) {
        this.query = t, this.b_ = e, this.v_ = null, 
        /**
         * A flag whether the view is current with the backend. A view is considered
         * current after it has seen the current flag from the backend and did not
         * lose consistency within the watch stream (e.g. because of an existence
         * filter mismatch).
         */
        this.As = !1, 
        /** Documents in the view but not in the remote target */
        this.S_ = ie(), 
        /** Document Keys that have local changes */
        this._s = ie(), this.D_ = new he(t.Be.bind(t));
    }
    /**
     * The set of remote documents that the server has told us belongs to the target associated with
     * this view.
     */    get C_() {
        return this.b_;
    }
    /**
     * Iterates over a set of doc changes, applies the query limit, and computes
     * what the new results should be, what the changes were, and whether we may
     * need to go back to the local cache for more results. Does not make any
     * changes to the view.
     * @param docChanges The doc changes to apply to this view.
     * @param previousChanges If this is being called with a refill, then start
     *        with this set of docs and changes instead of the current view.
     * @return a new set of docs, changes, and refill flag.
     */    k_(t, e) {
        const s = e ? e.N_ : new ae, n = e ? e.D_ : this.D_;
        let i = e ? e._s : this._s, r = n, o = !1;
        // Track the last doc in a (full) limit. This is necessary, because some
        // update (a delete, or an update moving a doc past the old limit) might
        // mean there is some other document in the local cache that either should
        // come (1) between the old last limit doc and the new last document, in the
        // case of updates, or (2) after the new last document, in the case of
        // deletes. So we keep this doc at the old limit to compare the updates to.
        // Note that this should never get used in a refill (when previousChanges is
        // set), because there will only be adds -- no deletes or updates.
        const h = this.query.je() && n.size === this.query.limit ? n.last() : null, a = this.query.Ke() && n.size === this.query.limit ? n.first() : null;
        // Drop documents out to meet limit/limitToLast requirement.
        if (t.ut((t, e) => {
            const u = n.get(t);
            let c = e instanceof bt ? e : null;
            c && (c = this.query.matches(c) ? c : null);
            const _ = !!u && this._s.has(u.key), l = !!c && (c.te || 
            // We only consider committed mutations for documents that were
            // mutated during the lifetime of the view.
            this._s.has(c.key) && c.hasCommittedMutations);
            let d = !1;
            // Calculate change
                        if (u && c) {
                u.data().isEqual(c.data()) ? _ !== l && (s.track({
                    type: 3 /* Metadata */ ,
                    doc: c
                }), d = !0) : this.F_(u, c) || (s.track({
                    type: 2 /* Modified */ ,
                    doc: c
                }), d = !0, (h && this.query.Be(c, h) > 0 || a && this.query.Be(c, a) < 0) && (
                // This doc moved from inside the limit to outside the limit.
                // That means there may be some other doc in the local cache
                // that should be included instead.
                o = !0));
            } else !u && c ? (s.track({
                type: 0 /* Added */ ,
                doc: c
            }), d = !0) : u && !c && (s.track({
                type: 1 /* Removed */ ,
                doc: u
            }), d = !0, (h || a) && (
            // A doc was removed from a full limit query. We'll need to
            // requery from the local cache to see if we know about some other
            // doc that should be in the results.
            o = !0));
            d && (c ? (r = r.add(c), i = l ? i.add(t) : i.delete(t)) : (r = r.delete(t), i = i.delete(t)));
        }), this.query.je() || this.query.Ke()) for (;r.size > this.query.limit; ) {
            const t = this.query.je() ? r.last() : r.first();
            r = r.delete(t.key), i = i.delete(t.key), s.track({
                type: 1 /* Removed */ ,
                doc: t
            });
        }
        return {
            D_: r,
            N_: s,
            M_: o,
            _s: i
        };
    }
    F_(t, e) {
        // We suppress the initial change event for documents that were modified as
        // part of a write acknowledgment (e.g. when the value of a server transform
        // is applied) as Watch will send us the same document again.
        // By suppressing the event, we only raise two user visible events (one with
        // `hasPendingWrites` and the final state of the document) instead of three
        // (one with `hasPendingWrites`, the modified document with
        // `hasPendingWrites` and the final state of the document).
        return t.te && e.hasCommittedMutations && !e.te;
    }
    /**
     * Updates the view with the given ViewDocumentChanges and optionally updates
     * limbo docs and sync state from the provided target change.
     * @param docChanges The set of changes to make to the view's docs.
     * @param updateLimboDocuments Whether to update limbo documents based on this
     *        change.
     * @param targetChange A target change to apply for computing limbo docs and
     *        sync state.
     * @return A new ViewChange with the given docs, changes, and sync state.
     */
    // PORTING NOTE: The iOS/Android clients always compute limbo document changes.
    nr(t, e, s) {
        const n = this.D_;
        this.D_ = t.D_, this._s = t._s;
        // Sort changes based on type and query comparator
        const i = t.N_.us();
        i.sort((t, e) => function(t, e) {
            const s = t => {
                switch (t) {
                  case 0 /* Added */ :
                    return 1;

                  case 2 /* Modified */ :
                  case 3 /* Metadata */ :
                    // A metadata change is converted to a modified change at the public
                    // api layer.  Since we sort by document key and then change type,
                    // metadata and modified changes must be sorted equivalently.
                    return 2;

                  case 1 /* Removed */ :
                    return 0;

                  default:
                    return De("Unknown ChangeType: " + t);
                }
            };
            return s(t) - s(e);
        }
        /**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (t.type, e.type) || this.query.Be(t.doc, e.doc)), this.L_(s);
        const r = e ? this.O_() : [], o = 0 === this.S_.size && this.As ? 1 /* Synced */ : 0 /* Local */ , h = o !== this.v_;
        if (this.v_ = o, 0 !== i.length || h) {
            return {
                snapshot: new ue(this.query, t.D_, n, i, t._s, 0 /* Local */ === o, h, 
                /* excludesMetadataChanges= */ !1),
                x_: r
            };
        }
        // no changes
        return {
            x_: r
        };
    }
    /**
     * Applies an OnlineState change to the view, potentially generating a
     * ViewChange if the view's syncState changes as a result.
     */    B_(t) {
        return this.As && "Offline" /* Offline */ === t ? (
        // If we're offline, set `current` to false and then call applyChanges()
        // to refresh our syncState and generate a ViewChange as appropriate. We
        // are guaranteed to get a new TargetChange that sets `current` back to
        // true once the client is back online.
        this.As = !1, this.nr({
            D_: this.D_,
            N_: new ae,
            _s: this._s,
            M_: !1
        }, 
        /* updateLimboDocuments= */ !1)) : {
            x_: []
        };
    }
    /**
     * Returns whether the doc for the given key should be in limbo.
     */    U_(t) {
        // If the remote end says it's part of this query, it's not in limbo.
        return !this.b_.has(t) && (
        // The local store doesn't think it's a result, so it shouldn't be in limbo.
        !!this.D_.has(t) && !this.D_.get(t).te);
    }
    /**
     * Updates syncedDocuments, current, and limbo docs based on the given change.
     * Returns the list of changes to which docs are in limbo.
     */    L_(t) {
        t && (t.Ps.forEach(t => this.b_ = this.b_.add(t)), t.Vs.forEach(t => {}), t.gs.forEach(t => this.b_ = this.b_.delete(t)), 
        this.As = t.As);
    }
    O_() {
        // We can only determine limbo documents when we're in-sync with the server.
        if (!this.As) return [];
        // TODO(klimt): Do this incrementally so that it's not quadratic when
        // updating many documents.
                const t = this.S_;
        this.S_ = ie(), this.D_.forEach(t => {
            this.U_(t.key) && (this.S_ = this.S_.add(t.key));
        });
        // Diff the new limbo docs with the old limbo docs.
        const e = [];
        return t.forEach(t => {
            this.S_.has(t) || e.push(new Rn(t));
        }), this.S_.forEach(s => {
            t.has(s) || e.push(new In(s));
        }), e;
    }
    /**
     * Update the in-memory state of the current view with the state read from
     * persistence.
     *
     * We update the query view whenever a client's primary status changes:
     * - When a client transitions from primary to secondary, it can miss
     *   LocalStorage updates and its query views may temporarily not be
     *   synchronized with the state on disk.
     * - For secondary to primary transitions, the client needs to update the list
     *   of `syncedDocuments` since secondary clients update their query views
     *   based purely on synthesized RemoteEvents.
     *
     * @param queryResult.documents - The documents that match the query according
     * to the LocalStore.
     * @param queryResult.remoteKeys - The keys of the documents that match the
     * query according to the backend.
     *
     * @return The ViewChange that resulted from this synchronization.
     */
    // PORTING NOTE: Multi-tab only.
    q_(t) {
        this.b_ = t.zh, this.S_ = ie();
        const e = this.k_(t.documents);
        return this.nr(e, /*updateLimboDocuments=*/ !0);
    }
    /**
     * Returns a view snapshot as if this query was just listened to. Contains
     * a document add for every existing document and the `fromCache` and
     * `hasPendingWrites` status of the already established view.
     */
    // PORTING NOTE: Multi-tab only.
    Q_() {
        return ue.fs(this.query, this.D_, this._s, 0 /* Local */ === this.v_);
    }
}

/**
 * TransactionRunner encapsulates the logic needed to run and retry transactions
 * with backoff.
 */
class Pn {
    constructor(t, e, s, n) {
        this.Nr = t, this.W_ = e, this.updateFunction = s, this.Lr = n, this.j_ = 5, this.Ja = new Zs(this.Nr, "retry_transaction" /* RetryTransaction */);
    }
    /** Runs the transaction and sets the result on deferred. */    K_() {
        this.G_();
    }
    G_() {
        this.Ja.Qa(async () => {
            const t = this.W_.Sc(), e = this.z_(t);
            e && e.then(e => {
                this.Nr.qr(() => t.commit().then(() => {
                    this.Lr.resolve(e);
                }).catch(t => {
                    this.H_(t);
                }));
            }).catch(t => {
                this.H_(t);
            });
        });
    }
    z_(t) {
        try {
            const e = this.updateFunction(t);
            return !U(e) && e.catch && e.then ? e : (this.Lr.reject(Error("Transaction callback must return a Promise")), 
            null);
        } catch (t) {
            // Do not retry errors thrown by user provided updateFunction.
            return this.Lr.reject(t), null;
        }
    }
    H_(t) {
        this.j_ > 0 && this.J_(t) ? (this.j_ -= 1, this.Nr.qr(() => (this.G_(), Promise.resolve()))) : this.Lr.reject(t);
    }
    J_(t) {
        if ("FirebaseError" === t.name) {
            // In transactions, the backend will fail outdated reads with FAILED_PRECONDITION and
            // non-matching document versions with ABORTED. These errors should be retried.
            const e = t.code;
            return "aborted" === e || "failed-precondition" === e || !zt(e);
        }
        return !1;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * QueryView contains all of the data that SyncEngine needs to keep track of for
 * a particular query.
 */
class Vn {
    constructor(
    /**
     * The query itself.
     */
    t, 
    /**
     * The target number created by the client that is used in the watch
     * stream to identify this query.
     */
    e, 
    /**
     * The view is responsible for computing the final merged truth of what
     * docs are in the query. It gets notified of local and remote changes,
     * and applies the query filters and limits to determine the most correct
     * possible results.
     */
    s) {
        this.query = t, this.targetId = e, this.view = s;
    }
}

/** Tracks a limbo resolution. */ class gn {
    constructor(t) {
        this.key = t, 
        /**
         * Set to true once we've received a document. This is used in
         * getRemoteKeysForTarget() and ultimately used by WatchChangeAggregator to
         * decide whether it needs to manufacture a delete event for the target once
         * the target is CURRENT.
         */
        this.Y_ = !1;
    }
}

/**
 * SyncEngine is the central controller in the client SDK architecture. It is
 * the glue code between the EventManager, LocalStore, and RemoteStore. Some of
 * SyncEngine's responsibilities include:
 * 1. Coordinating client requests and remote events between the EventManager
 *    and the local and remote data stores.
 * 2. Managing a View object for each query, providing the unified view between
 *    the local and remote data stores.
 * 3. Notifying the RemoteStore when the LocalStore has new mutations in its
 *    queue that need sending to the backend.
 *
 * The SyncEngine’s methods should only ever be called by methods running in the
 * global async queue.
 */ class pn {
    constructor(t, e, 
    // PORTING NOTE: Manages state synchronization in multi-tab environments.
    s, n, i) {
        this.Wu = t, this.W_ = e, this.X_ = s, this.currentUser = n, this.Z_ = i, this.tl = null, 
        this.el = new Oe(t => t.canonicalId()), this.sl = new Map, 
        /**
         * The keys of documents that are in limbo for which we haven't yet started a
         * limbo resolution query.
         */
        this.nl = [], 
        /**
         * Keeps track of the target ID for each document that is in limbo with an
         * active target.
         */
        this.il = new k(C.F), 
        /**
         * Keeps track of the information about an active limbo resolution for each
         * active target ID that was started for the purpose of limbo resolution.
         */
        this.rl = new Map, this.ol = new Ue, 
        /** Stores user completion handlers, indexed by User and BatchId. */
        this.hl = {}, 
        /** Stores user callbacks waiting for all pending writes to be acknowledged. */
        this.al = new Map, this.ul = wn.y_(), 
        // The primary state is set to `true` or `false` immediately after Firestore
        // startup. In the interim, a client should only be considered primary if
        // `isPrimary` is true.
        this.isPrimary = void 0, this.onlineState = "Unknown" /* Unknown */;
    }
    // Only used for testing.
    get cl() {
        return !0 === this.isPrimary;
    }
    /** Subscribes to SyncEngine notifications. Has to be called exactly once. */    subscribe(t) {
        this.tl = t;
    }
    /**
     * Initiates the new listen, resolves promise when listen enqueued to the
     * server. All the subsequent view snapshots or errors are sent to the
     * subscribed handlers. Returns the targetId of the query.
     */    async listen(t) {
        let e, s;
        this._l("listen()");
        const n = this.el.get(t);
        if (n) 
        // PORTING NOTE: With Multi-Tab Web, it is possible that a query view
        // already exists when EventManager calls us for the first time. This
        // happens when the primary tab is already listening to this query on
        // behalf of another tab and the user of the primary also starts listening
        // to the query. EventManager will not have an assigned target ID in this
        // case and calls `listen` to obtain this ID.
        e = n.targetId, this.X_.n_(e), s = n.view.Q_(); else {
            const n = await this.Wu.Uh(t.xe()), i = this.X_.n_(n.targetId);
            e = n.targetId, s = await this.ll(t, e, "current" === i), this.isPrimary && this.W_.listen(n);
        }
        return this.tl.du([ s ]), e;
    }
    /**
     * Registers a view for a previously unknown query and computes its initial
     * snapshot.
     */    async ll(t, e, s) {
        const n = await this.Wu.Kh(t, 
        /* usePreviousResults= */ !0), i = new An(t, n.zh), r = i.k_(n.documents), o = _e.Rs(e, s && "Offline" /* Offline */ !== this.onlineState), h = i.nr(r, 
        /* updateLimboDocuments= */ !0 === this.isPrimary, o), a = new Vn(t, e, i);
        return this.el.set(t, a), this.sl.has(e) ? this.sl.get(e).push(t) : this.sl.set(e, [ t ]), 
        h.snapshot;
    }
    /**
     * Reconcile the list of synced documents in an existing view with those
     * from persistence.
     */
    // PORTING NOTE: Multi-tab only.
    async dl(t) {
        const e = await this.Wu.Kh(t.query, 
        /* usePreviousResults= */ !0), s = t.view.q_(e);
        return this.isPrimary && this.fl(t.targetId, s.x_), s;
    }
    /** Stops listening to the query. */    async fc(t) {
        this._l("unlisten()");
        const e = this.el.get(t), s = this.sl.get(e.targetId);
        // Only clean up the query view and target if this is the only query mapped
        // to the target.
                if (s.length > 1) return this.sl.set(e.targetId, s.filter(e => !e.isEqual(t))), 
        void this.el.delete(t);
        // No other queries are mapped to the target, clean up the query and the target.
                if (this.isPrimary) {
            // We need to remove the local query target first to allow us to verify
            // whether any other client is still interested in this target.
            this.X_.r_(e.targetId), this.X_.Xc(e.targetId) || await this.Wu.jh(e.targetId, /*keepPersistedTargetData=*/ !1).then(() => {
                this.X_.h_(e.targetId), this.W_.fc(e.targetId), this.Tl(e.targetId);
            }).catch(os);
        } else this.Tl(e.targetId), await this.Wu.jh(e.targetId, 
        /*keepPersistedTargetData=*/ !0);
    }
    /**
     * Initiates the write of local mutation batch which involves adding the
     * writes to the mutation queue, notifying the remote store about new
     * mutations and raising events for any changes this write caused.
     *
     * The promise returned by this call is resolved when the above steps
     * have completed, *not* when the write was acked by the backend. The
     * userCallback is resolved once the write was acked/rejected by the
     * backend (or failed locally for any other reason).
     */    async write(t, e) {
        this._l("write()");
        const s = await this.Wu.lh(t);
        this.X_.Zc(s.batchId), this.ml(s.batchId, e), await this.El(s.zi), await this.W_.uc();
    }
    /**
     * Takes an updateFunction in which a set of reads and writes can be performed
     * atomically. In the updateFunction, the client can read and write values
     * using the supplied transaction object. After the updateFunction, all
     * changes will be committed. If a retryable error occurs (ex: some other
     * client has changed any of the data referenced), then the updateFunction
     * will be called again after a backoff. If the updateFunction still fails
     * after all retries, then the transaction will be rejected.
     *
     * The transaction object passed to the updateFunction contains methods for
     * accessing documents and collections. Unlike other datastore access, data
     * accessed with the transaction will not reflect local changes that have not
     * been committed. For this reason, it is required that all reads are
     * performed before any writes. Transactions must be performed while online.
     *
     * The Deferred input is resolved when the transaction is fully committed.
     */    runTransaction(t, e, s) {
        new Pn(t, this.W_, e, s).K_();
    }
    async vh(t) {
        this._l("applyRemoteEvent()");
        try {
            const e = await this.Wu.vh(t);
            // Update `receivedDocument` as appropriate for any limbo targets.
                        t.Ts.forEach((t, e) => {
                const s = this.rl.get(e);
                s && (
                // Since this is a limbo resolution lookup, it's for a single document
                // and it could be added, modified, or removed, but not a combination.
                Ce(t.Ps.size + t.Vs.size + t.gs.size <= 1, "Limbo resolution for single document contains multiple changes."), 
                t.Ps.size > 0 ? s.Y_ = !0 : t.Vs.size > 0 ? Ce(s.Y_, "Received change for limbo target document without add.") : t.gs.size > 0 && (Ce(s.Y_, "Received remove for limbo target document without add."), 
                s.Y_ = !1));
            }), await this.El(e, t);
        } catch (t) {
            await os(t);
        }
    }
    /**
     * Applies an OnlineState change to the sync engine and notifies any views of
     * the change.
     */    B_(t, e) {
        // If we are the secondary client, we explicitly ignore the remote store's
        // online state (the local client may go offline, even though the primary
        // tab remains online) and only apply the primary tab's online state from
        // SharedClientState.
        if (this.isPrimary && 0 /* RemoteStore */ === e || !this.isPrimary && 1 /* SharedClientState */ === e) {
            this._l("applyOnlineStateChange()");
            const e = [];
            this.el.forEach((s, n) => {
                const i = n.view.B_(t);
                i.snapshot && e.push(i.snapshot);
            }), this.tl.wl(t), this.tl.du(e), this.onlineState = t, this.isPrimary && this.X_.c_(t);
        }
    }
    async Ic(t, e) {
        this._l("rejectListens()"), 
        // PORTING NOTE: Multi-tab only.
        this.X_.a_(t, "rejected", e);
        const s = this.rl.get(t), n = s && s.key;
        if (n) {
            // Since this query failed, we won't want to manually unlisten to it.
            // So go ahead and remove it from bookkeeping.
            this.il = this.il.remove(n), this.rl.delete(t), this.Il();
            // TODO(klimt): We really only should do the following on permission
            // denied errors, but we don't have the cause code here.
            // It's a limbo doc. Create a synthetic event saying it was deleted.
            // This is kind of a hack. Ideally, we would have a method in the local
            // store to purge a document. However, it would be tricky to keep all of
            // the local store's invariants with another method.
            let e = new k(C.F);
            e = e.it(n, new vt(n, y.S()));
            const s = ie().add(n), i = new ce(y.MIN, 
            /* targetChanges= */ new Map, 
            /* targetMismatches= */ new $(Ne), e, s);
            return this.vh(i);
        }
        await this.Wu.jh(t, /* keepPersistedTargetData */ !1).then(() => this.Tl(t, e)).catch(os);
    }
    // PORTING NOTE: Multi-tab only
    async I_(t, e, s) {
        this._l("applyBatchState()");
        const n = await this.Wu.fh(t);
        null !== n ? ("pending" === e ? 
        // If we are the primary client, we need to send this write to the
        // backend. Secondary clients will ignore these writes since their remote
        // connection is disabled.
        await this.W_.uc() : "acknowledged" === e || "rejected" === e ? (
        // NOTE: Both these methods are no-ops for batches that originated from
        // other clients.
        this.Rl(t, s || null), this.Wu.Yh(t)) : De(`Unknown batchState: ${e}`), await this.El(n)) : 
        // A throttled tab may not have seen the mutation before it was completed
        // and removed from the mutation queue, in which case we won't have cached
        // the affected documents. In this case we can safely ignore the update
        // since that means we didn't apply the mutation locally at all (if we
        // had, we would have cached the affected documents), and so we will just
        // see any resulting document changes via normal remote document updates
        // as applicable.
        be("SyncEngine", "Cannot apply mutation batch with id: " + t);
    }
    async pc(t) {
        this._l("applySuccessfulWrite()");
        const e = t.batch.batchId;
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught
        // up), so we raise user callbacks first so that they consistently happen
        // before listen events.
                this.Rl(e, /*error=*/ null), this.Al(e);
        try {
            const s = await this.Wu.mh(t);
            this.X_.e_(e, "acknowledged"), await this.El(s);
        } catch (t) {
            await os(t);
        }
    }
    async vc(t, e) {
        this._l("rejectFailedWrite()"), 
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught up),
        // so we raise user callbacks first so that they consistently happen before
        // listen events.
        this.Rl(t, e), this.Al(t);
        try {
            const s = await this.Wu.Ah(t);
            this.X_.e_(t, "rejected", e), await this.El(s);
        } catch (e) {
            await os(e);
        }
    }
    /**
     * Registers a user callback that resolves when all pending mutations at the moment of calling
     * are acknowledged .
     */    async Pl(t) {
        this.W_.Ju() || be("SyncEngine", "The network is disabled. The task returned by 'awaitPendingWrites()' will not complete until the network is enabled.");
        const e = await this.Wu.gh();
        if (-1 === e) 
        // Trigger the callback right away if there is no pending writes at the moment.
        return void t.resolve();
        const s = this.al.get(e) || [];
        s.push(t), this.al.set(e, s);
    }
    /**
     * Triggers the callbacks that are waiting for this batch id to get acknowledged by server,
     * if there are any.
     */    Al(t) {
        (this.al.get(t) || []).forEach(t => {
            t.resolve();
        }), this.al.delete(t);
    }
    /** Reject all outstanding callbacks waiting for pending writes to complete. */    Vl(t) {
        this.al.forEach(e => {
            e.forEach(e => {
                e.reject(new I(w.CANCELLED, t));
            });
        }), this.al.clear();
    }
    ml(t, e) {
        let s = this.hl[this.currentUser.s()];
        s || (s = new k(Ne)), s = s.it(t, e), this.hl[this.currentUser.s()] = s;
    }
    /**
     * Resolves or rejects the user callback for the given batch and then discards
     * it.
     */    Rl(t, e) {
        let s = this.hl[this.currentUser.s()];
        // NOTE: Mutations restored from persistence won't have callbacks, so it's
        // okay for there to be no callback for this ID.
                if (s) {
            const n = s.get(t);
            n && (e ? n.reject(e) : n.resolve(), s = s.remove(t)), this.hl[this.currentUser.s()] = s;
        }
    }
    Tl(t, e = null) {
        this.X_.r_(t);
        for (const s of this.sl.get(t)) this.el.delete(s), e && this.tl.gl(s, e);
        if (this.sl.delete(t), this.isPrimary) {
            const e = this.ol.$i(t);
            this.ol.Ni(t), e.forEach(t => {
                this.ol.Mi(t) || 
                // We removed the last reference for this key
                this.pl(t);
            });
        }
    }
    pl(t) {
        // It's possible that the target already got removed because the query failed. In that case,
        // the key won't exist in `limboTargetsByKey`. Only do the cleanup if we still have the target.
        const e = this.il.get(t);
        null !== e && (this.W_.fc(e), this.il = this.il.remove(t), this.rl.delete(e), this.Il());
    }
    fl(t, e) {
        for (const s of e) if (s instanceof In) this.ol.vi(s.key, t), this.yl(s); else if (s instanceof Rn) {
            be("SyncEngine", "Document no longer in limbo: " + s.key), this.ol.Di(s.key, t), 
            this.ol.Mi(s.key) || 
            // We removed the last reference for this key
            this.pl(s.key);
        } else De("Unknown limbo change: " + JSON.stringify(s));
    }
    yl(t) {
        const e = t.key;
        this.il.get(e) || (be("SyncEngine", "New document in limbo: " + e), this.nl.push(e), 
        this.Il());
    }
    /**
     * Starts listens for documents in limbo that are enqueued for resolution,
     * subject to a maximum number of concurrent resolutions.
     *
     * Without bounding the number of concurrent resolutions, the server can fail
     * with "resource exhausted" errors which can lead to pathological client
     * behavior as seen in https://github.com/firebase/firebase-js-sdk/issues/2683.
     */    Il() {
        for (;this.nl.length > 0 && this.il.size < this.Z_; ) {
            const t = this.nl.shift(), e = this.ul.next();
            this.rl.set(e, new gn(t)), this.il = this.il.it(t, e), this.W_.listen(new Wt(Ct.ve(t.path).xe(), e, 2 /* LimboResolution */ , He.kr));
        }
    }
    // Visible for testing
    bl() {
        return this.il;
    }
    // Visible for testing
    vl() {
        return this.nl;
    }
    async El(t, e) {
        const s = [], n = [], i = [];
        this.el.forEach((r, o) => {
            i.push(Promise.resolve().then(() => {
                const e = o.view.k_(t);
                return e.M_ ? this.Wu.Kh(o.query, /* usePreviousResults= */ !1).then(({documents: t}) => o.view.k_(t, e)) : e;
                // The query has a limit and some docs were removed, so we need
                // to re-run the query against the local store to make sure we
                // didn't lose any good docs that had been past the limit.
                        }).then(t => {
                const i = e && e.Ts.get(o.targetId), r = o.view.nr(t, 
                /* updateLimboDocuments= */ !0 === this.isPrimary, i);
                if (this.fl(o.targetId, r.x_), r.snapshot) {
                    this.isPrimary && this.X_.a_(o.targetId, r.snapshot.fromCache ? "not-current" : "current"), 
                    s.push(r.snapshot);
                    const t = ze.br(o.targetId, r.snapshot);
                    n.push(t);
                }
            }));
        }), await Promise.all(i), this.tl.du(s), await this.Wu.Lh(n);
    }
    _l(t) {}
    async Dc(t) {
        const e = !this.currentUser.isEqual(t);
        if (this.currentUser = t, e) {
            // Fails tasks waiting for pending writes requested by previous user.
            this.Vl("'waitForPendingWrites' promise is rejected due to a user change.");
            const e = await this.Wu.oh(t);
            // TODO(b/114226417): Consider calling this only in the primary tab.
                        this.X_.oh(t, e.uh, e._h), await this.El(e.ah);
        }
        await this.W_.Dc();
    }
    // PORTING NOTE: Multi-tab only
    async Cc(t) {
        if (!0 === t && !0 !== this.isPrimary) {
            this.isPrimary = !0, await this.W_.Cc(!0);
            // Secondary tabs only maintain Views for their local listeners and the
            // Views internal state may not be 100% populated (in particular
            // secondary tabs don't track syncedDocuments, the set of documents the
            // server considers to be in the target). So when a secondary becomes
            // primary, we need to need to make sure that all views for all targets
            // match the state on disk.
            const t = this.X_.Yc(), e = await this.Sl(t.j());
            for (const t of e) this.W_.listen(t);
        } else if (!1 === t && !1 !== this.isPrimary) {
            this.isPrimary = !1;
            const t = [];
            let e = Promise.resolve();
            this.sl.forEach((s, n) => {
                this.X_.o_(n) ? t.push(n) : e = e.then(() => (this.Tl(n), this.Wu.jh(n, 
                /*keepPersistedTargetData=*/ !0))), this.W_.fc(n);
            }), await e, await this.Sl(t), this.Dl(), await this.W_.Cc(!1);
        }
    }
    // PORTING NOTE: Multi-tab only.
    Dl() {
        this.rl.forEach((t, e) => {
            this.W_.fc(e);
        }), this.ol.Fi(), this.rl = new Map, this.il = new k(C.F);
    }
    /**
     * Reconcile the query views of the provided query targets with the state from
     * persistence. Raises snapshots for any changes that affect the local
     * client and returns the updated state of all target's query data.
     */
    // PORTING NOTE: Multi-tab only.
    async Sl(t) {
        const e = [], s = [];
        for (const n of t) {
            let t;
            const i = this.sl.get(n);
            if (i && 0 !== i.length) {
                // For queries that have a local View, we need to update their state
                // in LocalStore (as the resume token and the snapshot version
                // might have changed) and reconcile their views with the persisted
                // state (the list of syncedDocuments may have gotten out of sync).
                await this.Wu.jh(n, 
                /*keepPersistedTargetData=*/ !0), t = await this.Wu.Uh(i[0].xe());
                for (const t of i) {
                    const e = this.el.get(t), n = await this.dl(e);
                    n.snapshot && s.push(n.snapshot);
                }
            } else {
                // For queries that never executed on this client, we need to
                // allocate the target in LocalStore and initialize a new View.
                const e = await this.Wu.ta(n);
                t = await this.Wu.Uh(e), await this.ll(this.Cl(e), n, 
                /*current=*/ !1);
            }
            e.push(t);
        }
        return this.tl.du(s), e;
    }
    /**
     * Creates a `Query` object from the specified `Target`. There is no way to
     * obtain the original `Query`, so we synthesize a `Query` from the `Target`
     * object.
     *
     * The synthesized result might be different from the original `Query`, but
     * since the synthesized `Query` should return the same results as the
     * original one (only the presentation of results might differ), the potential
     * difference will not cause issues.
     */
    // PORTING NOTE: Multi-tab only
    Cl(t) {
        return new Ct(t.path, t.collectionGroup, t.orderBy, t.filters, t.limit, "F" /* First */ , t.startAt, t.endAt);
    }
    // PORTING NOTE: Multi-tab only
    Jh() {
        return this.Wu.Jh();
    }
    // PORTING NOTE: Multi-tab only
    async R_(t, e, s) {
        if (this.isPrimary) 
        // If we receive a target state notification via WebStorage, we are
        // either already secondary or another tab has taken the primary lease.
        be("SyncEngine", "Ignoring unexpected query state notification."); else if (this.sl.has(t)) switch (e) {
          case "current":
          case "not-current":
            {
                const s = await this.Wu.ea(), n = ce.Is(t, "current" === e);
                await this.El(s, n);
                break;
            }

          case "rejected":
            await this.Wu.jh(t, 
            /* keepPersistedTargetData */ !0), this.Tl(t, s);
            break;

          default:
            De("Unexpected target state: " + e);
        }
    }
    // PORTING NOTE: Multi-tab only
    async A_(t, e) {
        if (this.isPrimary) {
            for (const e of t) {
                const t = await this.Wu.ta(e), s = await this.Wu.Uh(t);
                await this.ll(this.Cl(t), s.targetId, 
                /*current=*/ !1), this.W_.listen(s);
            }
            for (const t of e) 
            // Check that the target is still active since the target might have been
            // removed if it has been rejected by the backend.
            this.sl.has(t) && 
            // Release queries that are still active.
            await this.Wu.jh(t, /* keepPersistedTargetData */ !1).then(() => {
                this.W_.fc(t), this.Tl(t);
            }).catch(os);
        }
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    enableNetwork() {
        return this.Wu.Zh(!0), this.W_.enableNetwork();
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    disableNetwork() {
        return this.Wu.Zh(!1), this.W_.disableNetwork();
    }
    an(t) {
        const e = this.rl.get(t);
        if (e && e.Y_) return ie().add(e.key);
        {
            let e = ie();
            const s = this.sl.get(t);
            if (!s) return e;
            for (const t of s) {
                const s = this.el.get(t);
                e = e.Ft(s.view.C_);
            }
            return e;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Holds the listeners and the last received ViewSnapshot for a query being
 * tracked by EventManager.
 */ class yn {
    constructor() {
        this.kl = null, this.targetId = 0, this.Nl = [];
    }
}

/**
 * EventManager is responsible for mapping queries to query event emitters.
 * It handles "fan-out". -- Identical queries will re-use the same watch on the
 * backend.
 */ class bn {
    constructor(t) {
        this.mc = t, this.Fl = new Oe(t => t.canonicalId()), this.onlineState = "Unknown" /* Unknown */ , 
        this.$l = new Set, this.mc.subscribe(this);
    }
    listen(t) {
        const e = t.query;
        let s = !1, n = this.Fl.get(e);
        n || (s = !0, n = new yn, this.Fl.set(e, n)), n.Nl.push(t);
        // Run global snapshot listeners if a consistent snapshot has been emitted.
        t.B_(this.onlineState);
        if (n.kl) {
            t.Ml(n.kl) && this.Ll();
        }
        return s ? this.mc.listen(e).then(t => (n.targetId = t, t)) : Promise.resolve(n.targetId);
    }
    async fc(t) {
        const e = t.query;
        let s = !1;
        const n = this.Fl.get(e);
        if (n) {
            const e = n.Nl.indexOf(t);
            e >= 0 && (n.Nl.splice(e, 1), s = 0 === n.Nl.length);
        }
        if (s) return this.Fl.delete(e), this.mc.fc(e);
    }
    du(t) {
        let e = !1;
        for (const s of t) {
            const t = s.query, n = this.Fl.get(t);
            if (n) {
                for (const t of n.Nl) t.Ml(s) && (e = !0);
                n.kl = s;
            }
        }
        e && this.Ll();
    }
    gl(t, e) {
        const s = this.Fl.get(t);
        if (s) for (const t of s.Nl) t.onError(e);
        // Remove all listeners. NOTE: We don't need to call syncEngine.unlisten()
        // after an error.
                this.Fl.delete(t);
    }
    wl(t) {
        this.onlineState = t;
        let e = !1;
        this.Fl.forEach((s, n) => {
            for (const s of n.Nl) 
            // Run global snapshot listeners if a consistent snapshot has been emitted.
            s.B_(t) && (e = !0);
        }), e && this.Ll();
    }
    Ol(t) {
        this.$l.add(t), 
        // Immediately fire an initial event, indicating all existing listeners
        // are in-sync.
        t.next();
    }
    xl(t) {
        this.$l.delete(t);
    }
    // Call all global snapshot listeners that have been set.
    Ll() {
        this.$l.forEach(t => {
            t.next();
        });
    }
}

/**
 * QueryListener takes a series of internal view snapshots and determines
 * when to raise the event.
 *
 * It uses an Observer to dispatch events.
 */ class vn {
    constructor(t, e, s) {
        this.query = t, this.Bl = e, 
        /**
         * Initial snapshots (e.g. from cache) may not be propagated to the wrapped
         * observer. This flag is set to true once we've actually raised an event.
         */
        this.Ul = !1, this.ql = null, this.onlineState = "Unknown" /* Unknown */ , this.options = s || {};
    }
    /**
     * Applies the new ViewSnapshot to this listener, raising a user-facing event
     * if applicable (depending on what changed, whether the user has opted into
     * metadata-only changes, etc.). Returns true if a user-facing event was
     * indeed raised.
     */    Ml(t) {
        if (!this.options.includeMetadataChanges) {
            // Remove the metadata only changes.
            const e = [];
            for (const s of t.docChanges) 3 /* Metadata */ !== s.type && e.push(s);
            t = new ue(t.query, t.docs, t.cs, e, t._s, t.fromCache, t.ls, 
            /* excludesMetadataChanges= */ !0);
        }
        let e = !1;
        return this.Ul ? this.Ql(t) && (this.Bl.next(t), e = !0) : this.Wl(t, this.onlineState) && (this.jl(t), 
        e = !0), this.ql = t, e;
    }
    onError(t) {
        this.Bl.error(t);
    }
    /** Returns whether a snapshot was raised. */    B_(t) {
        this.onlineState = t;
        let e = !1;
        return this.ql && !this.Ul && this.Wl(this.ql, t) && (this.jl(this.ql), e = !0), 
        e;
    }
    Wl(t, e) {
        // Always raise the first event when we're synced
        if (!t.fromCache) return !0;
        // NOTE: We consider OnlineState.Unknown as online (it should become Offline
        // or Online if we wait long enough).
                const s = "Offline" /* Offline */ !== e;
        // Don't raise the event if we're online, aren't synced yet (checked
        // above) and are waiting for a sync.
                return (!this.options.Kl || !s) && (!t.docs.U() || "Offline" /* Offline */ === e);
        // Raise data from cache if we have any documents or we are offline
        }
    Ql(t) {
        // We don't need to handle includeDocumentMetadataChanges here because
        // the Metadata only changes have already been stripped out if needed.
        // At this point the only changes we will see are the ones we should
        // propagate.
        if (t.docChanges.length > 0) return !0;
        const e = this.ql && this.ql.hasPendingWrites !== t.hasPendingWrites;
        return !(!t.ls && !e) && !0 === this.options.includeMetadataChanges;
        // Generally we should have hit one of the cases above, but it's possible
        // to get here if there were only metadata docChanges and they got
        // stripped out.
        }
    jl(t) {
        t = ue.fs(t.query, t.docs, t._s, t.fromCache), this.Ul = !0, this.Bl.next(t);
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// TOOD(b/140938512): Drop SimpleQueryEngine and rename IndexFreeQueryEngine.
/**
 * A query engine that takes advantage of the target document mapping in the
 * QueryCache. The IndexFreeQueryEngine optimizes query execution by only
 * reading the documents that previously matched a query plus any documents that were
 * edited after the query was last listened to.
 *
 * There are some cases where Index-Free queries are not guaranteed to produce
 * the same results as full collection scans. In these cases, the
 * IndexFreeQueryEngine falls back to full query processing. These cases are:
 *
 * - Limit queries where a document that matched the query previously no longer
 *   matches the query.
 *
 * - Limit queries where a document edit may cause the document to sort below
 *   another document that is in the local cache.
 *
 * - Queries that have never been CURRENT or free of Limbo documents.
 */ class Sn {
    ih(t) {
        this.Gl = t;
    }
    wr(t, e, n, i) {
        // Queries that match all documents don't benefit from using
        // IndexFreeQueries. It is more efficient to scan all documents in a
        // collection, rather than to perform individual lookups.
        return e.Oe() || n.isEqual(y.MIN) ? this.zl(t, e) : this.Gl.Tr(t, i).next(r => {
            const o = this.Hl(e, r);
            return (e.je() || e.Ke()) && this.M_(e.ge, o, i, n) ? this.zl(t, e) : (pe() <= s.DEBUG && be("IndexFreeQueryEngine", "Re-using previous result from %s to execute query: %s", n.toString(), e.toString()), 
            this.Gl.wr(t, e, n).next(t => (
            // We merge `previousResults` into `updateResults`, since
            // `updateResults` is already a DocumentMap. If a document is
            // contained in both lists, then its contents are the same.
            o.forEach(e => {
                t = t.it(e.key, e);
            }), t)));
        });
        // Queries that have never seen a snapshot without limbo free documents
        // should also be run as a full collection scan.
        }
    /** Applies the query filter and sorting to the provided documents.  */    Hl(t, e) {
        // Sort the documents and re-apply the query filter since previously
        // matching documents do not necessarily still match the query.
        let s = new $((e, s) => t.Be(e, s));
        return e.forEach((e, n) => {
            n instanceof bt && t.matches(n) && (s = s.add(n));
        }), s;
    }
    /**
     * Determines if a limit query needs to be refilled from cache, making it
     * ineligible for index-free execution.
     *
     * @param sortedPreviousResults The documents that matched the query when it
     * was last synchronized, sorted by the query's comparator.
     * @param remoteKeys The document keys that matched the query at the last
     * snapshot.
     * @param limboFreeSnapshotVersion The version of the snapshot when the query
     * was last synchronized.
     */    M_(t, e, s, n) {
        // The query needs to be refilled if a previously matching document no
        // longer matches.
        if (s.size !== e.size) return !0;
        // Limit queries are not eligible for index-free query execution if there is
        // a potential that an older document from cache now sorts before a document
        // that was previously part of the limit. This, however, can only happen if
        // the document at the edge of the limit goes out of limit.
        // If a document that is not the limit boundary sorts differently,
        // the boundary of the limit itself did not change and documents from cache
        // will continue to be "rejected" by this boundary. Therefore, we can ignore
        // any modifications that don't affect the last document.
                const i = "F" /* First */ === t ? e.last() : e.first();
        return !!i && (i.hasPendingWrites || i.version.D(n) > 0);
    }
    zl(t, e) {
        return pe() <= s.DEBUG && be("IndexFreeQueryEngine", "Using full collection scan to execute query: %s", e.toString()), 
        this.Gl.wr(t, e, y.MIN);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Encodes a resource path into a IndexedDb-compatible string form.
 */
function Dn(t) {
    let e = "";
    for (let s = 0; s < t.length; s++) e.length > 0 && (e = kn(e)), e = Cn(t.get(s), e);
    return kn(e);
}

/** Encodes a single segment of a resource path into the given result */ function Cn(t, e) {
    let s = e;
    const n = t.length;
    for (let e = 0; e < n; e++) {
        const n = t.charAt(e);
        switch (n) {
          case "\0":
            s += "";
            break;

          case "":
            s += "";
            break;

          default:
            s += n;
        }
    }
    return s;
}

/** Encodes a path separator into the given result */ function kn(t) {
    return t + "";
}

/**
 * Decodes the given IndexedDb-compatible string form of a resource path into
 * a ResourcePath instance. Note that this method is not suitable for use with
 * decoding resource names from the server; those are One Platform format
 * strings.
 */ function Nn(t) {
    // Event the empty path must encode as a path of at least length 2. A path
    // with exactly 2 must be the empty path.
    const e = t.length;
    if (Ce(e >= 2, "Invalid path " + t), 2 === e) return Ce("" === t.charAt(0) && "" === t.charAt(1), "Non-empty path " + t + " had length 2"), 
    v.H;
    // Escape characters cannot exist past the second-to-last position in the
    // source value.
        const s = e - 2, n = [];
    let i = "";
    for (let r = 0; r < e; ) {
        // The last two characters of a valid encoded path must be a separator, so
        // there must be an end to this segment.
        const e = t.indexOf("", r);
        switch ((e < 0 || e > s) && De('Invalid encoded resource path: "' + t + '"'), t.charAt(e + 1)) {
          case "":
            const s = t.substring(r, e);
            let o;
            0 === i.length ? 
            // Avoid copying for the common case of a segment that excludes \0
            // and \001
            o = s : (i += s, o = i, i = ""), n.push(o);
            break;

          case "":
            i += t.substring(r, e), i += "\0";
            break;

          case "":
            // The escape character can be used in the output to encode itself.
            i += t.substring(r, e + 1);
            break;

          default:
            De('Invalid encoded resource path: "' + t + '"');
        }
        r = e + 2;
    }
    return new v(n);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a wrapper around IndexedDb with a simplified interface that uses
 * Promise-like return values to chain operations. Real promises cannot be used
 * since .then() continuations are executed asynchronously (e.g. via
 * .setImmediate), which would cause IndexedDB to end the transaction.
 * See PersistencePromise for more details.
 */
class Fn {
    constructor(t) {
        this.db = t, 
        // NOTE: According to https://bugs.webkit.org/show_bug.cgi?id=197050, the
        // bug we're checking for should exist in iOS >= 12.2 and < 13, but for
        // whatever reason it's much harder to hit after 12.2 so we only proactively
        // log on 12.2.
        12.2 === Fn.Jl(n()) && ve("Firestore persistence suffers from a bug in iOS 12.2 Safari that may cause your app to stop working. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
    }
    /**
     * Opens the specified database, creating or upgrading it if necessary.
     *
     * Note that `version` must not be a downgrade. IndexedDB does not support downgrading the schema
     * version. We currently do not support any way to do versioning outside of IndexedDB's versioning
     * mechanism, as only version-upgrade transactions are allowed to do things like create
     * objectstores.
     */    static Yl(t, e, s) {
        return be("SimpleDb", "Opening database:", t), new Qe((n, i) => {
            // TODO(mikelehen): Investigate browser compatibility.
            // https://developer.mozilla.org/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB
            // suggests IE9 and older WebKit browsers handle upgrade
            // differently. They expect setVersion, as described here:
            // https://developer.mozilla.org/en-US/docs/Web/API/IDBVersionChangeRequest/setVersion
            const r = window.indexedDB.open(t, e);
            r.onsuccess = t => {
                const e = t.target.result;
                n(new Fn(e));
            }, r.onblocked = () => {
                i(new I(w.FAILED_PRECONDITION, "Cannot upgrade IndexedDB schema while another tab is open. Close all tabs that access Firestore and reload this page to proceed."));
            }, r.onerror = t => {
                const e = t.target.error;
                "VersionError" === e.name ? i(new I(w.FAILED_PRECONDITION, "A newer version of the Firestore SDK was previously used and so the persisted data is not compatible with the version of the SDK you are now using. The SDK will operate with persistence disabled. If you need persistence, please re-upgrade to a newer version of the SDK or else clear the persisted IndexedDB data for your app to start fresh.")) : i(e);
            }, r.onupgradeneeded = e => {
                be("SimpleDb", 'Database "' + t + '" requires upgrade from version:', e.oldVersion);
                const n = e.target.result;
                s.createOrUpgrade(n, r.transaction, e.oldVersion, ri).next(() => {
                    be("SimpleDb", "Database upgrade to version " + ri + " complete");
                });
            };
        }).Wi();
    }
    /** Deletes the specified database. */    static delete(t) {
        return be("SimpleDb", "Removing database:", t), On(window.indexedDB.deleteDatabase(t)).Wi();
    }
    /** Returns true if IndexedDB is available in the current environment. */    static Uc() {
        if ("undefined" == typeof window || null == window.indexedDB) return !1;
        if (Fn.Xl()) return !0;
        // In some Node environments, `window` is defined, but `window.navigator` is
        // not. We don't support IndexedDB persistence in Node if the
        // isMockPersistence() check above returns false.
                if (void 0 === window.navigator) return !1;
        // We extensively use indexed array values and compound keys,
        // which IE and Edge do not support. However, they still have indexedDB
        // defined on the window, so we need to check for them here and make sure
        // to return that persistence is not enabled for those browsers.
        // For tracking support of this feature, see here:
        // https://developer.microsoft.com/en-us/microsoft-edge/platform/status/indexeddbarraysandmultientrysupport/
        // Check the UA string to find out the browser.
                const t = n(), e = Fn.Jl(t), s = 0 < e && e < 10, i = Fn.Zl(t), r = 0 < i && i < 4.5;
        // IE 10
        // ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';
        // IE 11
        // ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';
        // Edge
        // ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML,
        // like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';
        // iOS Safari: Disable for users running iOS version < 10.
                return !(t.indexOf("MSIE ") > 0 || t.indexOf("Trident/") > 0 || t.indexOf("Edge/") > 0 || s || r);
    }
    /**
     * Returns true if the backing IndexedDB store is the Node IndexedDBShim
     * (see https://github.com/axemclion/IndexedDBShim).
     */    static Xl() {
        var t;
        return "undefined" != typeof __PRIVATE_process && "YES" === (null === (t = __PRIVATE_process.__PRIVATE_env) || void 0 === t ? void 0 : t.td);
    }
    /** Helper to get a typed SimpleDbStore from a transaction. */    static ed(t, e) {
        return t.store(e);
    }
    // visible for testing
    /** Parse User Agent to determine iOS version. Returns -1 if not found. */
    static Jl(t) {
        const e = t.match(/i(?:phone|pad|pod) os ([\d_]+)/i), s = e ? e[1].split("_").slice(0, 2).join(".") : "-1";
        return Number(s);
    }
    // visible for testing
    /** Parse User Agent to determine Android version. Returns -1 if not found. */
    static Zl(t) {
        const e = t.match(/Android ([\d.]+)/i), s = e ? e[1].split(".").slice(0, 2).join(".") : "-1";
        return Number(s);
    }
    sd(t) {
        this.db.onversionchange = e => t(e);
    }
    async runTransaction(t, e, s) {
        const n = "readonly" === t;
        let i = 0;
        for (;;) {
            ++i;
            const t = Mn.open(this.db, n ? "readonly" : "readwrite", e);
            try {
                const e = s(t).catch(e => (
                // Abort the transaction if there was an error.
                t.abort(e), Qe.reject(e))).Wi();
                // As noted above, errors are propagated by aborting the transaction. So
                // we swallow any error here to avoid the browser logging it as unhandled.
                                return e.catch(() => {}), 
                // Wait for the transaction to complete (i.e. IndexedDb's onsuccess event to
                // fire), but still return the original transactionFnResult back to the
                // caller.
                await t.nd, e;
            } catch (t) {
                // TODO(schmidt-sebastian): We could probably be smarter about this and
                // not retry exceptions that are likely unrecoverable (such as quota
                // exceeded errors).
                // Note: We cannot use an instanceof check for FirestoreException, since the
                // exception is wrapped in a generic error by our async/await handling.
                const e = "FirebaseError" !== t.name && i < 3;
                if (be("SimpleDb", "Transaction failed with error: %s. Retrying: %s.", t.message, e), 
                !e) return Promise.reject(t);
            }
        }
    }
    close() {
        this.db.close();
    }
}

/**
 * A controller for iterating over a key range or index. It allows an iterate
 * callback to delete the currently-referenced object, or jump to a new key
 * within the key range or index.
 */ class $n {
    constructor(t) {
        this.rd = t, this.od = !1, this.hd = null;
    }
    get Bi() {
        return this.od;
    }
    get ad() {
        return this.hd;
    }
    set cursor(t) {
        this.rd = t;
    }
    /**
     * This function can be called to stop iteration at any point.
     */    done() {
        this.od = !0;
    }
    /**
     * This function can be called to skip to that next key, which could be
     * an index or a primary key.
     */    ud(t) {
        this.hd = t;
    }
    /**
     * Delete the current cursor value from the object store.
     *
     * NOTE: You CANNOT do this with a keysOnly query.
     */    delete() {
        return On(this.rd.delete());
    }
}

/**
 * Wraps an IDBTransaction and exposes a store() method to get a handle to a
 * specific object store.
 */ class Mn {
    constructor(t) {
        this.transaction = t, this.aborted = !1, 
        /**
         * A promise that resolves with the result of the IndexedDb transaction.
         */
        this._d = new Je, this.transaction.oncomplete = () => {
            this._d.resolve();
        }, this.transaction.onabort = () => {
            t.error ? this._d.reject(t.error) : this._d.resolve();
        }, this.transaction.onerror = t => {
            const e = Bn(t.target.error);
            this._d.reject(e);
        };
    }
    static open(t, e, s) {
        return new Mn(t.transaction(s, e));
    }
    get nd() {
        return this._d.promise;
    }
    abort(t) {
        t && this._d.reject(t), this.aborted || (be("SimpleDb", "Aborting transaction:", t ? t.message : "Client-initiated abort"), 
        this.aborted = !0, this.transaction.abort());
    }
    /**
     * Returns a SimpleDbStore<KeyType, ValueType> for the specified store. All
     * operations performed on the SimpleDbStore happen within the context of this
     * transaction and it cannot be used anymore once the transaction is
     * completed.
     *
     * Note that we can't actually enforce that the KeyType and ValueType are
     * correct, but they allow type safety through the rest of the consuming code.
     */    store(t) {
        const e = this.transaction.objectStore(t);
        return new Ln(e);
    }
}

/**
 * A wrapper around an IDBObjectStore providing an API that:
 *
 * 1) Has generic KeyType / ValueType parameters to provide strongly-typed
 * methods for acting against the object store.
 * 2) Deals with IndexedDB's onsuccess / onerror event callbacks, making every
 * method return a PersistencePromise instead.
 * 3) Provides a higher-level API to avoid needing to do excessive wrapping of
 * intermediate IndexedDB types (IDBCursorWithValue, etc.)
 */ class Ln {
    constructor(t) {
        this.store = t;
    }
    put(t, e) {
        let s;
        return void 0 !== e ? (be("SimpleDb", "PUT", this.store.name, t, e), s = this.store.put(e, t)) : (be("SimpleDb", "PUT", this.store.name, "<auto-key>", t), 
        s = this.store.put(t)), On(s);
    }
    /**
     * Adds a new value into an Object Store and returns the new key. Similar to
     * IndexedDb's `add()`, this method will fail on primary key collisions.
     *
     * @param value The object to write.
     * @return The key of the value to add.
     */    add(t) {
        return be("SimpleDb", "ADD", this.store.name, t, t), On(this.store.add(t));
    }
    /**
     * Gets the object with the specified key from the specified store, or null
     * if no object exists with the specified key.
     *
     * @key The key of the object to get.
     * @return The object with the specified key or null if no object exists.
     */    get(t) {
        // We're doing an unsafe cast to ValueType.
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return On(this.store.get(t)).next(e => (
        // Normalize nonexistence to null.
        void 0 === e && (e = null), be("SimpleDb", "GET", this.store.name, t, e), e));
    }
    delete(t) {
        return be("SimpleDb", "DELETE", this.store.name, t), On(this.store.delete(t));
    }
    /**
     * If we ever need more of the count variants, we can add overloads. For now,
     * all we need is to count everything in a store.
     *
     * Returns the number of rows in the store.
     */    count() {
        return be("SimpleDb", "COUNT", this.store.name), On(this.store.count());
    }
    ld(t, e) {
        const s = this.cursor(this.options(t, e)), n = [];
        return this.dd(s, (t, e) => {
            n.push(e);
        }).next(() => n);
    }
    fd(t, e) {
        be("SimpleDb", "DELETE ALL", this.store.name);
        const s = this.options(t, e);
        s.Td = !1;
        const n = this.cursor(s);
        return this.dd(n, (t, e, s) => s.delete());
    }
    md(t, e) {
        let s;
        e ? s = t : (s = {}, e = t);
        const n = this.cursor(s);
        return this.dd(n, e);
    }
    /**
     * Iterates over a store, but waits for the given callback to complete for
     * each entry before iterating the next entry. This allows the callback to do
     * asynchronous work to determine if this iteration should continue.
     *
     * The provided callback should return `true` to continue iteration, and
     * `false` otherwise.
     */    Ed(t) {
        const e = this.cursor({});
        return new Qe((s, n) => {
            e.onerror = t => {
                const e = Bn(t.target.error);
                n(e);
            }, e.onsuccess = e => {
                const n = e.target.result;
                n ? t(n.primaryKey, n.value).next(t => {
                    t ? n.continue() : s();
                }) : s();
            };
        });
    }
    dd(t, e) {
        const s = [];
        return new Qe((n, i) => {
            t.onerror = t => {
                i(t.target.error);
            }, t.onsuccess = t => {
                const i = t.target.result;
                if (!i) return void n();
                const r = new $n(i), o = e(i.primaryKey, i.value, r);
                if (o instanceof Qe) {
                    const t = o.catch(t => (r.done(), Qe.reject(t)));
                    s.push(t);
                }
                r.Bi ? n() : null === r.ad ? i.continue() : i.continue(r.ad);
            };
        }).next(() => Qe.Ki(s));
    }
    options(t, e) {
        let s = void 0;
        return void 0 !== t && ("string" == typeof t ? s = t : e = t), {
            index: s,
            range: e
        };
    }
    cursor(t) {
        let e = "next";
        if (t.reverse && (e = "prev"), t.index) {
            const s = this.store.index(t.index);
            return t.Td ? s.openKeyCursor(t.range, e) : s.openCursor(t.range, e);
        }
        return this.store.openCursor(t.range, e);
    }
}

/**
 * Wraps an IDBRequest in a PersistencePromise, using the onsuccess / onerror
 * handlers to resolve / reject the PersistencePromise as appropriate.
 */ function On(t) {
    return new Qe((e, s) => {
        t.onsuccess = t => {
            const s = t.target.result;
            e(s);
        }, t.onerror = t => {
            const e = Bn(t.target.error);
            s(e);
        };
    });
}

// Guard so we only report the error once.
let xn = !1;

function Bn(t) {
    const e = Fn.Jl(n());
    if (e >= 12.2 && e < 13) {
        const e = "An internal error was encountered in the Indexed Database server";
        if (t.message.indexOf(e) >= 0) {
            // Wrap error in a more descriptive one.
            const t = new I("internal", `IOS_INDEXEDDB_BUG1: IndexedDb has thrown '${e}'. This is likely ` + "due to an unavoidable bug in iOS. See https://stackoverflow.com/q/56496296/110915 for details and a potential workaround.");
            return xn || (xn = !0, 
            // Throw a global exception outside of this promise chain, for the user to
            // potentially catch.
            setTimeout(() => {
                throw t;
            }, 0)), t;
        }
    }
    return t;
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** A mutation queue for a specific user, backed by IndexedDB. */ class Un {
    constructor(
    /**
     * The normalized userId (e.g. null UID => "" userId) used to store /
     * retrieve mutations.
     */
    t, e, s, n) {
        this.userId = t, this.serializer = e, this.ur = s, this.Jo = n, 
        /**
         * Caches the document keys for pending mutation batches. If the mutation
         * has been removed from IndexedDb, the cached value may continue to
         * be used to retrieve the batch's document keys. To remove a cached value
         * locally, `removeCachedMutationKeys()` should be invoked either directly
         * or through `removeMutationBatches()`.
         *
         * With multi-tab, when the primary client acknowledges or rejects a mutation,
         * this cache is used by secondary clients to invalidate the local
         * view of the documents that were previously affected by the mutation.
         */
        // PORTING NOTE: Multi-tab only.
        this.wd = {};
    }
    /**
     * Creates a new mutation queue for the given user.
     * @param user The user for which to create a mutation queue.
     * @param serializer The serializer to use when persisting to IndexedDb.
     */    static Id(t, e, s, n) {
        // TODO(mcg): Figure out what constraints there are on userIDs
        // In particular, are there any reserved characters? are empty ids allowed?
        // For the moment store these together in the same mutations table assuming
        // that empty userIDs aren't allowed.
        Ce("" !== t.uid, "UserID must not be an empty string.");
        const i = t.t() ? t.uid : "";
        return new Un(i, e, s, n);
    }
    Rd(t) {
        let e = !0;
        const s = IDBKeyRange.bound([ this.userId, Number.NEGATIVE_INFINITY ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return Wn(t).md({
            index: ci.userMutationsIndex,
            range: s
        }, (t, s, n) => {
            e = !1, n.done();
        }).next(() => e);
    }
    mh(t, e, s) {
        return this.Ad(t).next(e => (
        // We can't store the resumeToken as a ByteString in IndexedDB, so we
        // convert it to a Base64 string for storage.
        e.lastStreamToken = s.toBase64(), Kn(t).put(e)));
    }
    ph(t) {
        return this.Ad(t).next(t => B.fromBase64String(t.lastStreamToken));
    }
    yh(t, e) {
        return this.Ad(t).next(s => (
        // We can't store the resumeToken as a ByteString in IndexedDB, so we
        // convert it to a Base64 string for storage.
        s.lastStreamToken = e.toBase64(), Kn(t).put(s)));
    }
    dh(t, e, s, n) {
        const i = jn(t), r = Wn(t);
        // The IndexedDb implementation in Chrome (and Firefox) does not handle
        // compound indices that include auto-generated keys correctly. To ensure
        // that the index entry is added correctly in all browsers, we perform two
        // writes: The first write is used to retrieve the next auto-generated Batch
        // ID, and the second write populates the index and stores the actual
        // mutation batch.
        // See: https://bugs.chromium.org/p/chromium/issues/detail?id=701972
        // We write an empty object to obtain key
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
        return r.add({}).next(o => {
            Ce("number" == typeof o, "Auto-generated key is not a number");
            const h = new xe(o, e, s, n), a = this.serializer.Pd(this.userId, h), u = [];
            let c = new $((t, e) => Ne(t.K(), e.K()));
            for (const t of n) {
                const e = _i.key(this.userId, t.key.path, o);
                c = c.add(t.key.path.L()), u.push(r.put(a)), u.push(i.put(e, _i.PLACEHOLDER));
            }
            return c.forEach(e => {
                u.push(this.ur.Vd(t, e));
            }), t.rr(() => {
                this.wd[o] = h.keys();
            }), Qe.Ki(u).next(() => h);
        });
    }
    Ph(t, e) {
        return Wn(t).get(e).next(t => t ? (Ce(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${e}`), 
        this.serializer.gd(t)) : null);
    }
    Th(t, e) {
        return this.wd[e] ? Qe.resolve(this.wd[e]) : this.Ph(t, e).next(t => {
            if (t) {
                const s = t.keys();
                return this.wd[e] = s, s;
            }
            return null;
        });
    }
    xh(t, e) {
        const s = e + 1, n = IDBKeyRange.lowerBound([ this.userId, s ]);
        let i = null;
        return Wn(t).md({
            index: ci.userMutationsIndex,
            range: n
        }, (t, e, n) => {
            e.userId === this.userId && (Ce(e.batchId >= s, "Should have found mutation after " + s), 
            i = this.serializer.gd(e)), n.done();
        }).next(() => i);
    }
    gh(t) {
        const e = IDBKeyRange.upperBound([ this.userId, Number.POSITIVE_INFINITY ]);
        let s = -1;
        return Wn(t).md({
            index: ci.userMutationsIndex,
            range: e,
            reverse: !0
        }, (t, e, n) => {
            s = e.batchId, n.done();
        }).next(() => s);
    }
    hh(t) {
        const e = IDBKeyRange.bound([ this.userId, -1 ], [ this.userId, Number.POSITIVE_INFINITY ]);
        return Wn(t).ld(ci.userMutationsIndex, e).next(t => t.map(t => this.serializer.gd(t)));
    }
    _r(t, e) {
        // Scan the document-mutation index starting with a prefix starting with
        // the given documentKey.
        const s = _i.prefixForPath(this.userId, e.path), n = IDBKeyRange.lowerBound(s), i = [];
        return jn(t).md({
            range: n
        }, (s, n, r) => {
            const [o, h, a] = s, u = Nn(h);
            // Only consider rows matching exactly the specific key of
            // interest. Note that because we order by path first, and we
            // order terminators before path separators, we'll encounter all
            // the index rows for documentKey contiguously. In particular, all
            // the rows for documentKey will occur before any rows for
            // documents nested in a subcollection beneath documentKey so we
            // can stop as soon as we hit any such row.
                        if (o === this.userId && e.path.isEqual(u)) 
            // Look up the mutation batch in the store.
            return Wn(t).get(a).next(t => {
                if (!t) throw De("Dangling document-mutation reference found: " + s + " which points to " + a);
                Ce(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${a}`), 
                i.push(this.serializer.gd(t));
            });
            r.done();
        }).next(() => i);
    }
    Er(t, e) {
        let s = new $(Ne);
        const n = [];
        return e.forEach(e => {
            const i = _i.prefixForPath(this.userId, e.path), r = IDBKeyRange.lowerBound(i), o = jn(t).md({
                range: r
            }, (t, n, i) => {
                const [r, o, h] = t, a = Nn(o);
                // Only consider rows matching exactly the specific key of
                // interest. Note that because we order by path first, and we
                // order terminators before path separators, we'll encounter all
                // the index rows for documentKey contiguously. In particular, all
                // the rows for documentKey will occur before any rows for
                // documents nested in a subcollection beneath documentKey so we
                // can stop as soon as we hit any such row.
                                r === this.userId && e.path.isEqual(a) ? s = s.add(h) : i.done();
            });
            n.push(o);
        }), Qe.Ki(n).next(() => this.pd(t, s));
    }
    Vr(t, e) {
        const s = e.path, n = s.length + 1, i = _i.prefixForPath(this.userId, s), r = IDBKeyRange.lowerBound(i);
        // Collect up unique batchIDs encountered during a scan of the index. Use a
        // SortedSet to accumulate batch IDs so they can be traversed in order in a
        // scan of the main table.
        let o = new $(Ne);
        return jn(t).md({
            range: r
        }, (t, e, i) => {
            const [r, h, a] = t, u = Nn(h);
            r === this.userId && s.q(u) ? 
            // Rows with document keys more than one segment longer than the
            // query path can't be matches. For example, a query on 'rooms'
            // can't match the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            u.length === n && (o = o.add(a)) : i.done();
        }).next(() => this.pd(t, o));
    }
    pd(t, e) {
        const s = [], n = [];
        // TODO(rockwood): Implement this using iterate.
        return e.forEach(e => {
            n.push(Wn(t).get(e).next(t => {
                if (null === t) throw De("Dangling document-mutation reference found, which points to " + e);
                Ce(t.userId === this.userId, `Unexpected user '${t.userId}' for mutation batch ${e}`), 
                s.push(this.serializer.gd(t));
            }));
        }), Qe.Ki(n).next(() => s);
    }
    Vh(t, e) {
        return Qn(t.yd, this.userId, e).next(s => (t.rr(() => {
            this.Xh(e.batchId);
        }), Qe.forEach(s, e => this.Jo.bd(t, e))));
    }
    Xh(t) {
        delete this.wd[t];
    }
    Rh(t) {
        return this.Rd(t).next(e => {
            if (!e) return Qe.resolve();
            // Verify that there are no entries in the documentMutations index if
            // the queue is empty.
                        const s = IDBKeyRange.lowerBound(_i.prefixForUser(this.userId)), n = [];
            return jn(t).md({
                range: s
            }, (t, e, s) => {
                if (t[0] === this.userId) {
                    const e = Nn(t[1]);
                    n.push(e);
                } else s.done();
            }).next(() => {
                Ce(0 === n.length, "Document leak -- detected dangling mutation references when queue is empty. Dangling keys: " + n.map(t => t.K()));
            });
        });
    }
    Mi(t, e) {
        return qn(t, this.userId, e);
    }
    // PORTING NOTE: Multi-tab only (state is held in memory in other clients).
    /** Returns the mutation queue's metadata from IndexedDb. */
    Ad(t) {
        return Kn(t).get(this.userId).next(t => t || new ui(this.userId, -1, 
        /*lastStreamToken=*/ ""));
    }
}

/**
 * @return true if the mutation queue for the given user contains a pending
 *         mutation for the given key.
 */ function qn(t, e, s) {
    const n = _i.prefixForPath(e, s.path), i = n[1], r = IDBKeyRange.lowerBound(n);
    let o = !1;
    return jn(t).md({
        range: r,
        Td: !0
    }, (t, s, n) => {
        const [r, h, /*batchID*/ a] = t;
        r === e && h === i && (o = !0), n.done();
    }).next(() => o);
}

/** Returns true if any mutation queue contains the given document. */
/**
 * Delete a mutation batch and the associated document mutations.
 * @return A PersistencePromise of the document mutations that were removed.
 */
function Qn(t, e, s) {
    const n = t.store(ci.store), i = t.store(_i.store), r = [], o = IDBKeyRange.only(s.batchId);
    let h = 0;
    const a = n.md({
        range: o
    }, (t, e, s) => (h++, s.delete()));
    r.push(a.next(() => {
        Ce(1 === h, "Dangling document-mutation reference found: Missing batch " + s.batchId);
    }));
    const u = [];
    for (const t of s.mutations) {
        const n = _i.key(e, t.key.path, s.batchId);
        r.push(i.delete(n)), u.push(t.key);
    }
    return Qe.Ki(r).next(() => u);
}

/**
 * Helper to get a typed SimpleDbStore for the mutations object store.
 */ function Wn(t) {
    return vi.ed(t, ci.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function jn(t) {
    return vi.ed(t, _i.store);
}

/**
 * Helper to get a typed SimpleDbStore for the mutationQueues object store.
 */ function Kn(t) {
    return vi.ed(t, ui.store);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Gn {
    constructor(t, e) {
        this.Jo = t, this.serializer = e;
    }
    // PORTING NOTE: We don't cache global metadata for the target cache, since
    // some of it (in particular `highestTargetId`) can be modified by secondary
    // tabs. We could perhaps be more granular (and e.g. still cache
    // `lastRemoteSnapshotVersion` in memory) but for simplicity we currently go
    // to IndexedDb whenever we need to read metadata. We can revisit if it turns
    // out to have a meaningful performance impact.
    Qh(t) {
        return this.vd(t).next(e => {
            const s = new wn(e.highestTargetId);
            return e.highestTargetId = s.next(), this.Sd(t, e).next(() => e.highestTargetId);
        });
    }
    bh(t) {
        return this.vd(t).next(t => y.v(new p(t.lastRemoteSnapshotVersion.seconds, t.lastRemoteSnapshotVersion.nanoseconds)));
    }
    Dd(t) {
        return Jn(t.yd);
    }
    $h(t, e, s) {
        return this.vd(t).next(n => (n.highestListenSequenceNumber = e, s && (n.lastRemoteSnapshotVersion = s.k()), 
        e > n.highestListenSequenceNumber && (n.highestListenSequenceNumber = e), this.Sd(t, n)));
    }
    Wh(t, e) {
        return this.Cd(t, e).next(() => this.vd(t).next(s => (s.targetCount += 1, this.kd(e, s), 
        this.Sd(t, s))));
    }
    Nh(t, e) {
        return this.Cd(t, e);
    }
    Nd(t, e) {
        return this.Fd(t, e.targetId).next(() => zn(t).delete(e.targetId)).next(() => this.vd(t)).next(e => (Ce(e.targetCount > 0, "Removing from an empty target cache"), 
        e.targetCount -= 1, this.Sd(t, e)));
    }
    /**
     * Drops any targets with sequence number less than or equal to the upper bound, excepting those
     * present in `activeTargetIds`. Document associations for the removed targets are also removed.
     * Returns the number of targets removed.
     */    xo(t, e, s) {
        let n = 0;
        const i = [];
        return zn(t).md((r, o) => {
            const h = this.serializer.$d(o);
            h.sequenceNumber <= e && null === s.get(h.targetId) && (n++, i.push(this.Nd(t, h)));
        }).next(() => Qe.Ki(i)).next(() => n);
    }
    /**
     * Call provided function with each `TargetData` that we have cached.
     */    Xs(t, e) {
        return zn(t).md((t, s) => {
            const n = this.serializer.$d(s);
            e(n);
        });
    }
    vd(t) {
        return Hn(t.yd);
    }
    Sd(t, e) {
        return (s = t, vi.ed(s, wi.store)).put(wi.key, e);
        /**
 * Helper to get a typed SimpleDbStore for the target globals object store.
 */
        var s;
    }
    Cd(t, e) {
        return zn(t).put(this.serializer.Md(e));
    }
    /**
     * In-place updates the provided metadata to account for values in the given
     * TargetData. Saving is done separately. Returns true if there were any
     * changes to the metadata.
     */    kd(t, e) {
        let s = !1;
        return t.targetId > e.highestTargetId && (e.highestTargetId = t.targetId, s = !0), 
        t.sequenceNumber > e.highestListenSequenceNumber && (e.highestListenSequenceNumber = t.sequenceNumber, 
        s = !0), s;
    }
    Ld(t) {
        return this.vd(t).next(t => t.targetCount);
    }
    qh(t, e) {
        // Iterating by the canonicalId may yield more than one result because
        // canonicalId values are not required to be unique per target. This query
        // depends on the queryTargets index to be efficient.
        const s = e.canonicalId(), n = IDBKeyRange.bound([ s, Number.NEGATIVE_INFINITY ], [ s, Number.POSITIVE_INFINITY ]);
        let i = null;
        return zn(t).md({
            range: n,
            index: mi.queryTargetsIndexName
        }, (t, s, n) => {
            const r = this.serializer.$d(s);
            // After finding a potential match, check that the target is
            // actually equal to the requested target.
                        e.isEqual(r.target) && (i = r, n.done());
        }).next(() => i);
    }
    Dh(t, e, s) {
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
        const n = [], i = Yn(t);
        return e.forEach(e => {
            const r = Dn(e.path);
            n.push(i.put(new Ei(s, r))), n.push(this.Jo.vi(t, e));
        }), Qe.Ki(n);
    }
    Sh(t, e, s) {
        // PORTING NOTE: The reverse index (documentsTargets) is maintained by
        // IndexedDb.
        const n = Yn(t);
        return Qe.forEach(e, e => {
            const i = Dn(e.path);
            return Qe.Ki([ n.delete([ s, i ]), this.Jo.Di(t, e) ]);
        });
    }
    Fd(t, e) {
        const s = Yn(t), n = IDBKeyRange.bound([ e ], [ e + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return s.delete(n);
    }
    Gh(t, e) {
        const s = IDBKeyRange.bound([ e ], [ e + 1 ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0), n = Yn(t);
        let i = ie();
        return n.md({
            range: s,
            Td: !0
        }, (t, e, s) => {
            const n = Nn(t[1]), r = new C(n);
            i = i.add(r);
        }).next(() => i);
    }
    Mi(t, e) {
        const s = Dn(e.path), n = IDBKeyRange.bound([ s ], [ $e(s) ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        let i = 0;
        return Yn(t).md({
            index: Ei.documentTargetsIndex,
            Td: !0,
            range: n
        }, ([t, e], s, n) => {
            // Having a sentinel row for a document does not count as containing that document;
            // For the target cache, containing the document means the document is part of some
            // target.
            0 !== t && (i++, n.done());
        }).next(() => i > 0);
    }
    un(t, e) {
        return zn(t).get(e).next(t => t ? this.serializer.$d(t) : null);
    }
}

/**
 * Helper to get a typed SimpleDbStore for the queries object store.
 */ function zn(t) {
    return vi.ed(t, mi.store);
}

function Hn(t) {
    return Fn.ed(t, wi.store).get(wi.key).next(t => (Ce(null !== t, "Missing metadata row."), 
    t));
}

function Jn(t) {
    return Hn(t).next(t => t.highestListenSequenceNumber);
}

/**
 * Helper to get a typed SimpleDbStore for the document target object store.
 */ function Yn(t) {
    return vi.ed(t, Ei.store);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Xn {
    /**
     * @param {LocalSerializer} serializer The document serializer.
     * @param {IndexManager} indexManager The query indexes that need to be maintained.
     */
    constructor(t, e) {
        this.serializer = t, this.ur = e;
    }
    /**
     * Adds the supplied entries to the cache.
     *
     * All calls of `addEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */    Yi(t, e, s) {
        return ti(t).put(ei(e), s);
    }
    /**
     * Removes a document from the cache.
     *
     * All calls of `removeEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()` to ensure proper accounting of metadata.
     */    Zi(t, e) {
        const s = ti(t), n = ei(e);
        return s.delete(n);
    }
    /**
     * Updates the current cache size.
     *
     * Callers to `addEntry()` and `removeEntry()` *must* call this afterwards to update the
     * cache's metadata.
     */    updateMetadata(t, e) {
        return this.getMetadata(t).next(s => (s.byteSize += e, this.Od(t, s)));
    }
    tr(t, e) {
        return ti(t).get(ei(e)).next(t => this.xd(t));
    }
    /**
     * Looks up an entry in the cache.
     *
     * @param documentKey The key of the entry to look up.
     * @return The cached MaybeDocument entry and its size, or null if we have nothing cached.
     */    Bd(t, e) {
        return ti(t).get(ei(e)).next(t => {
            const e = this.xd(t);
            return e ? {
                Ud: e,
                size: si(t)
            } : null;
        });
    }
    getEntries(t, e) {
        let s = Xt();
        return this.qd(t, e, (t, e) => {
            const n = this.xd(e);
            s = s.it(t, n);
        }).next(() => s);
    }
    /**
     * Looks up several entries in the cache.
     *
     * @param documentKeys The set of keys entries to look up.
     * @return A map of MaybeDocuments indexed by key (if a document cannot be
     *     found, the key will be mapped to null) and a map of sizes indexed by
     *     key (zero if the key cannot be found).
     */    Qd(t, e) {
        let s = Xt(), n = new k(C.F);
        return this.qd(t, e, (t, e) => {
            const i = this.xd(e);
            i ? (s = s.it(t, i), n = n.it(t, si(e))) : (s = s.it(t, null), n = n.it(t, 0));
        }).next(() => ({
            Wd: s,
            jd: n
        }));
    }
    qd(t, e, s) {
        if (e.U()) return Qe.resolve();
        const n = IDBKeyRange.bound(e.first().path.j(), e.last().path.j()), i = e._t();
        let r = i.wt();
        return ti(t).md({
            range: n
        }, (t, e, n) => {
            const o = C.nt(t);
            // Go through keys not found in cache.
                        for (;r && C.F(r, o) < 0; ) s(r, null), r = i.wt();
            r && r.isEqual(o) && (
            // Key found in cache.
            s(r, e), r = i.It() ? i.wt() : null), 
            // Skip to the next key (if there is one).
            r ? n.ud(r.path.j()) : n.done();
        }).next(() => {
            // The rest of the keys are not in the cache. One case where `iterate`
            // above won't go through them is when the cache is empty.
            for (;r; ) s(r, null), r = i.It() ? i.wt() : null;
        });
    }
    wr(t, e, s) {
        let n = te();
        const i = e.path.length + 1, r = {};
        if (s.isEqual(y.MIN)) {
            // Documents are ordered by key, so we can use a prefix scan to narrow
            // down the documents we need to match the query against.
            const t = e.path.j();
            r.range = IDBKeyRange.lowerBound(t);
        } else {
            // Execute an index-free query and filter by read time. This is safe
            // since all document changes to queries that have a
            // lastLimboFreeSnapshotVersion (`sinceReadTime`) have a read time set.
            const t = e.path.j(), n = this.serializer.Kd(s);
            r.range = IDBKeyRange.lowerBound([ t, n ], 
            /* open= */ !0), r.index = fi.collectionReadTimeIndex;
        }
        return ti(t).md(r, (t, s, r) => {
            // The query is actually returning any path that starts with the query
            // path prefix which may include documents in subcollections. For
            // example, a query on 'rooms' will return rooms/abc/messages/xyx but we
            // shouldn't match it. Fix this by discarding rows with document keys
            // more than one segment longer than the query path.
            if (t.length !== i) return;
            const o = this.serializer.Gd(s);
            e.path.q(o.key.path) ? o instanceof bt && e.matches(o) && (n = n.it(o.key, o)) : r.done();
        }).next(() => n);
    }
    ea(t, e) {
        let s = Yt(), n = this.serializer.Kd(e);
        const i = ti(t), r = IDBKeyRange.lowerBound(n, !0);
        return i.md({
            index: fi.readTimeIndex,
            range: r
        }, (t, e) => {
            // Unlike `getEntry()` and others, `getNewDocumentChanges()` parses
            // the documents directly since we want to keep sentinel deletes.
            const i = this.serializer.Gd(e);
            s = s.it(i.key, i), n = e.readTime;
        }).next(() => ({
            sa: s,
            readTime: this.serializer.zd(n)
        }));
    }
    na(t) {
        const e = ti(t);
        // If there are no existing entries, we return SnapshotVersion.MIN.
                let s = y.MIN;
        return e.md({
            index: fi.readTimeIndex,
            reverse: !0
        }, (t, e, n) => {
            e.readTime && (s = this.serializer.zd(e.readTime)), n.done();
        }).next(() => s);
    }
    Eh(t) {
        return new Xn.Hd(this, !!t && t.wh);
    }
    Jd(t) {
        return this.getMetadata(t).next(t => t.byteSize);
    }
    getMetadata(t) {
        return Zn(t).get(Ti.key).next(t => (Ce(!!t, "Missing document cache metadata"), 
        t));
    }
    Od(t, e) {
        return Zn(t).put(Ti.key, e);
    }
    /**
     * Decodes `remoteDoc` and returns the document (or null, if the document
     * corresponds to the format used for sentinel deletes).
     */    xd(t) {
        if (t) {
            const e = this.serializer.Gd(t);
            return e instanceof vt && e.version.isEqual(y.S()) ? null : e;
        }
        return null;
    }
}

/**
 * Handles the details of adding and updating documents in the IndexedDbRemoteDocumentCache.
 *
 * Unlike the MemoryRemoteDocumentChangeBuffer, the IndexedDb implementation computes the size
 * delta for all submitted changes. This avoids having to re-read all documents from IndexedDb
 * when we apply the changes.
 */ function Zn(t) {
    return vi.ed(t, Ti.store);
}

/**
 * Helper to get a typed SimpleDbStore for the remoteDocuments object store.
 */ function ti(t) {
    return vi.ed(t, fi.store);
}

function ei(t) {
    return t.path.j();
}

/**
 * Retrusn an approximate size for the given document.
 */ function si(t) {
    let e;
    if (t.document) e = t.document; else if (t.unknownDocument) e = t.unknownDocument; else {
        if (!t.noDocument) throw De("Unknown remote document type");
        e = t.noDocument;
    }
    return JSON.stringify(e).length;
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory implementation of IndexManager.
 */ Xn.Hd = class extends We {
    /**
     * @param documentCache The IndexedDbRemoteDocumentCache to apply the changes to.
     * @param trackRemovals Whether to create sentinel deletes that can be tracked by
     * `getNewDocumentChanges()`.
     */
    constructor(t, e) {
        super(), this.Yd = t, this.wh = e, 
        // A map of document sizes prior to applying the changes in this buffer.
        this.Xd = new Oe(t => t.toString());
    }
    nr(t) {
        const e = [];
        let s = 0, n = new $((t, e) => Ne(t.K(), e.K()));
        return this.zi.forEach((i, r) => {
            const o = this.Xd.get(i);
            if (r) {
                const h = this.Yd.serializer.Zd(r, this.readTime);
                n = n.add(i.path.L());
                const a = si(h);
                s += a - o, e.push(this.Yd.Yi(t, i, h));
            } else if (s -= o, this.wh) {
                // In order to track removals, we store a "sentinel delete" in the
                // RemoteDocumentCache. This entry is represented by a NoDocument
                // with a version of 0 and ignored by `maybeDecodeDocument()` but
                // preserved in `getNewDocumentChanges()`.
                const s = this.Yd.serializer.Zd(new vt(i, y.S()), this.readTime);
                e.push(this.Yd.Yi(t, i, s));
            } else e.push(this.Yd.Zi(t, i));
        }), n.forEach(s => {
            e.push(this.Yd.ur.Vd(t, s));
        }), e.push(this.Yd.updateMetadata(t, s)), Qe.Ki(e);
    }
    er(t, e) {
        // Record the size of everything we load from the cache so we can compute a delta later.
        return this.Yd.Bd(t, e).next(t => null === t ? (this.Xd.set(e, 0), null) : (this.Xd.set(e, t.size), 
        t.Ud));
    }
    sr(t, e) {
        // Record the size of everything we load from the cache so we can compute
        // a delta later.
        return this.Yd.Qd(t, e).next(({Wd: t, jd: e}) => (
        // Note: `getAllFromCache` returns two maps instead of a single map from
        // keys to `DocumentSizeEntry`s. This is to allow returning the
        // `NullableMaybeDocumentMap` directly, without a conversion.
        e.forEach((t, e) => {
            this.Xd.set(t, e);
        }), t));
    }
};

class ni {
    constructor() {
        this.tf = new ii;
    }
    Vd(t, e) {
        return this.tf.add(e), Qe.resolve();
    }
    Pr(t, e) {
        return Qe.resolve(this.tf.getEntries(e));
    }
}

/**
 * Internal implementation of the collection-parent index exposed by MemoryIndexManager.
 * Also used for in-memory caching by IndexedDbIndexManager and initial index population
 * in indexeddb_schema.ts
 */ class ii {
    constructor() {
        this.index = {};
    }
    // Returns false if the entry already existed.
    add(t) {
        const e = t.B(), s = t.L(), n = this.index[e] || new $(v.F), i = !n.has(s);
        return this.index[e] = n.add(s), i;
    }
    has(t) {
        const e = t.B(), s = t.L(), n = this.index[e];
        return n && n.has(s);
    }
    getEntries(t) {
        return (this.index[t] || new $(v.F)).j();
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Schema Version for the Web client:
 * 1.  Initial version including Mutation Queue, Query Cache, and Remote
 *     Document Cache
 * 2.  Used to ensure a targetGlobal object exists and add targetCount to it. No
 *     longer required because migration 3 unconditionally clears it.
 * 3.  Dropped and re-created Query Cache to deal with cache corruption related
 *     to limbo resolution. Addresses
 *     https://github.com/firebase/firebase-ios-sdk/issues/1548
 * 4.  Multi-Tab Support.
 * 5.  Removal of held write acks.
 * 6.  Create document global for tracking document cache size.
 * 7.  Ensure every cached document has a sentinel row with a sequence number.
 * 8.  Add collection-parent index for Collection Group queries.
 * 9.  Change RemoteDocumentChanges store to be keyed by readTime rather than
 *     an auto-incrementing ID. This is required for Index-Free queries.
 * 10. Rewrite the canonical IDs to the explicit Protobuf-based format.
 */ const ri = 10;

/** Performs database creation and schema upgrades. */ class oi {
    constructor(t) {
        this.serializer = t;
    }
    /**
     * Performs database creation and schema upgrades.
     *
     * Note that in production, this method is only ever used to upgrade the schema
     * to SCHEMA_VERSION. Different values of toVersion are only used for testing
     * and local feature development.
     */    createOrUpgrade(t, e, s, n) {
        Ce(s < n && s >= 0 && n <= ri, `Unexpected schema upgrade from v${s} to v${n}.`);
        const i = new Mn(e);
        s < 1 && n >= 1 && (function(t) {
            t.createObjectStore(ai.store);
        }
        /**
 * An object to be stored in the 'mutationQueues' store in IndexedDb.
 *
 * Each user gets a single queue of MutationBatches to apply to the server.
 * DbMutationQueue tracks the metadata about the queue.
 */ (t), function(t) {
            t.createObjectStore(ui.store, {
                keyPath: ui.keyPath
            }), t.createObjectStore(ci.store, {
                keyPath: ci.keyPath,
                autoIncrement: !0
            }).createIndex(ci.userMutationsIndex, ci.userMutationsKeyPath, {
                unique: !0
            }), t.createObjectStore(_i.store);
        }
        /**
 * Upgrade function to migrate the 'mutations' store from V1 to V3. Loads
 * and rewrites all data.
 */ (t), Ri(t), function(t) {
            t.createObjectStore(fi.store);
        }
        /**
 * Represents the known absence of a document at a particular version.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ (t));
        // Migration 2 to populate the targetGlobal object no longer needed since
        // migration 3 unconditionally clears it.
                let r = Qe.resolve();
        return s < 3 && n >= 3 && (
        // Brand new clients don't need to drop and recreate--only clients that
        // potentially have corrupt data.
        0 !== s && (!function(t) {
            t.deleteObjectStore(Ei.store), t.deleteObjectStore(mi.store), t.deleteObjectStore(wi.store);
        }(t), Ri(t)), r = r.next(() => 
        /**
 * Creates the target global singleton row.
 *
 * @param {IDBTransaction} txn The version upgrade transaction for indexeddb
 */
        function(t) {
            const e = t.store(wi.store), s = new wi(
            /*highestTargetId=*/ 0, 
            /*lastListenSequenceNumber=*/ 0, y.MIN.k(), 
            /*targetCount=*/ 0);
            return e.put(wi.key, s);
        }
        /**
 * Creates indices on the RemoteDocuments store used for both multi-tab
 * and Index-Free queries.
 */ (i))), s < 4 && n >= 4 && (0 !== s && (
        // Schema version 3 uses auto-generated keys to generate globally unique
        // mutation batch IDs (this was previously ensured internally by the
        // client). To migrate to the new schema, we have to read all mutations
        // and write them back out. We preserve the existing batch IDs to guarantee
        // consistency with other object stores. Any further mutation batch IDs will
        // be auto-generated.
        r = r.next(() => function(t, e) {
            return e.store(ci.store).ld().next(s => {
                t.deleteObjectStore(ci.store), t.createObjectStore(ci.store, {
                    keyPath: ci.keyPath,
                    autoIncrement: !0
                }).createIndex(ci.userMutationsIndex, ci.userMutationsKeyPath, {
                    unique: !0
                });
                const n = e.store(ci.store), i = s.map(t => n.put(t));
                return Qe.Ki(i);
            });
        }
        /**
 * An object to be stored in the 'documentMutations' store in IndexedDb.
 *
 * A manually maintained index of all the mutation batches that affect a given
 * document key. The rows in this table are references based on the contents of
 * DbMutationBatch.mutations.
 */ (t, i))), r = r.next(() => {
            !function(t) {
                t.createObjectStore(Ai.store, {
                    keyPath: Ai.keyPath
                });
            }
            // Visible for testing
            (t);
        })), s < 5 && n >= 5 && (r = r.next(() => this.removeAcknowledgedMutations(i))), 
        s < 6 && n >= 6 && (r = r.next(() => (function(t) {
            t.createObjectStore(Ti.store);
        }
        /**
 * An object to be stored in the 'targets' store in IndexedDb.
 *
 * This is based on and should be kept in sync with the proto used in the iOS
 * client.
 *
 * Each query the client listens to against the server is tracked on disk so
 * that the query can be efficiently resumed on restart.
 */ (t), this.addDocumentGlobal(i)))), s < 7 && n >= 7 && (r = r.next(() => this.ensureSequenceNumbers(i))), 
        s < 8 && n >= 8 && (r = r.next(() => this.createCollectionParentIndex(t, i))), s < 9 && n >= 9 && (r = r.next(() => {
            // Multi-Tab used to manage its own changelog, but this has been moved
            // to the DbRemoteDocument object store itself. Since the previous change
            // log only contained transient data, we can drop its object store.
            !function(t) {
                t.objectStoreNames.contains("remoteDocumentChanges") && t.deleteObjectStore("remoteDocumentChanges");
            }(t), function(t) {
                const e = t.objectStore(fi.store);
                e.createIndex(fi.readTimeIndex, fi.readTimeIndexPath, {
                    unique: !1
                }), e.createIndex(fi.collectionReadTimeIndex, fi.collectionReadTimeIndexPath, {
                    unique: !1
                });
            }
            /**
 * A record of the metadata state of each client.
 *
 * PORTING NOTE: This is used to synchronize multi-tab state and does not need
 * to be ported to iOS or Android.
 */ (e);
        })), s < 10 && n >= 10 && (r = r.next(() => this.rewriteCanonicalIds(i))), r;
    }
    addDocumentGlobal(t) {
        let e = 0;
        return t.store(fi.store).md((t, s) => {
            e += si(s);
        }).next(() => {
            const s = new Ti(e);
            return t.store(Ti.store).put(Ti.key, s);
        });
    }
    removeAcknowledgedMutations(t) {
        const e = t.store(ui.store), s = t.store(ci.store);
        return e.ld().next(e => Qe.forEach(e, e => {
            const n = IDBKeyRange.bound([ e.userId, -1 ], [ e.userId, e.lastAcknowledgedBatchId ]);
            return s.ld(ci.userMutationsIndex, n).next(s => Qe.forEach(s, s => {
                Ce(s.userId === e.userId, `Cannot process batch ${s.batchId} from unexpected user`);
                const n = this.serializer.gd(s);
                return Qn(t, e.userId, n).next(() => {});
            }));
        }));
    }
    /**
     * Ensures that every document in the remote document cache has a corresponding sentinel row
     * with a sequence number. Missing rows are given the most recently used sequence number.
     */    ensureSequenceNumbers(t) {
        const e = t.store(Ei.store), s = t.store(fi.store);
        return Jn(t).next(t => {
            const n = [];
            return s.md((s, i) => {
                const r = new v(s), o = function(t) {
                    return [ 0, Dn(t) ];
                }
                /**
 * Wrapper class to store timestamps (seconds and nanos) in IndexedDb objects.
 */ (r);
                n.push(e.get(o).next(s => s ? Qe.resolve() : (s => e.put(new Ei(0, Dn(s), t)))(r)));
            }).next(() => Qe.Ki(n));
        });
    }
    createCollectionParentIndex(t, e) {
        // Create the index.
        t.createObjectStore(Ii.store, {
            keyPath: Ii.keyPath
        });
        const s = e.store(Ii.store), n = new ii, i = t => {
            if (n.add(t)) {
                const e = t.B(), n = t.L();
                return s.put({
                    collectionId: e,
                    parent: Dn(n)
                });
            }
        };
        // Helper to add an index entry iff we haven't already written it.
                // Index existing remote documents.
        return e.store(fi.store).md({
            Td: !0
        }, (t, e) => {
            const s = new v(t);
            return i(s.L());
        }).next(() => e.store(_i.store).md({
            Td: !0
        }, ([t, e, s], n) => {
            const r = Nn(e);
            return i(r.L());
        }));
    }
    rewriteCanonicalIds(t) {
        const e = t.store(mi.store);
        return e.md((t, s) => {
            const n = this.serializer.$d(s), i = this.serializer.Md(n);
            return e.put(i);
        });
    }
}

class hi {
    constructor(t, e) {
        this.seconds = t, this.nanoseconds = e;
    }
}

/**
 * A singleton object to be stored in the 'owner' store in IndexedDb.
 *
 * A given database can have a single primary tab assigned at a given time. That
 * tab must validate that it is still holding the primary lease before every
 * operation that requires locked access. The primary tab should regularly
 * write an updated timestamp to this lease to prevent other tabs from
 * "stealing" the primary lease
 */ class ai {
    constructor(t, 
    /** Whether to allow shared access from multiple tabs. */
    e, s) {
        this.ownerId = t, this.allowTabSynchronization = e, this.leaseTimestampMs = s;
    }
}

/**
 * Name of the IndexedDb object store.
 *
 * Note that the name 'owner' is chosen to ensure backwards compatibility with
 * older clients that only supported single locked access to the persistence
 * layer.
 */ ai.store = "owner", 
/**
 * The key string used for the single object that exists in the
 * DbPrimaryClient store.
 */
ai.key = "owner";

class ui {
    constructor(
    /**
     * The normalized user ID to which this queue belongs.
     */
    t, 
    /**
     * An identifier for the highest numbered batch that has been acknowledged
     * by the server. All MutationBatches in this queue with batchIds less
     * than or equal to this value are considered to have been acknowledged by
     * the server.
     *
     * NOTE: this is deprecated and no longer used by the code.
     */
    e, 
    /**
     * A stream token that was previously sent by the server.
     *
     * See StreamingWriteRequest in datastore.proto for more details about
     * usage.
     *
     * After sending this token, earlier tokens may not be used anymore so
     * only a single stream token is retained.
     */
    s) {
        this.userId = t, this.lastAcknowledgedBatchId = e, this.lastStreamToken = s;
    }
}

/** Name of the IndexedDb object store.  */ ui.store = "mutationQueues", 
/** Keys are automatically assigned via the userId property. */
ui.keyPath = "userId";

/**
 * An object to be stored in the 'mutations' store in IndexedDb.
 *
 * Represents a batch of user-level mutations intended to be sent to the server
 * in a single write. Each user-level batch gets a separate DbMutationBatch
 * with a new batchId.
 */
class ci {
    constructor(
    /**
     * The normalized user ID to which this batch belongs.
     */
    t, 
    /**
     * An identifier for this batch, allocated using an auto-generated key.
     */
    e, 
    /**
     * The local write time of the batch, stored as milliseconds since the
     * epoch.
     */
    s, 
    /**
     * A list of "mutations" that represent a partial base state from when this
     * write batch was initially created. During local application of the write
     * batch, these baseMutations are applied prior to the real writes in order
     * to override certain document fields from the remote document cache. This
     * is necessary in the case of non-idempotent writes (e.g. `increment()`
     * transforms) to make sure that the local view of the modified documents
     * doesn't flicker if the remote document cache receives the result of the
     * non-idempotent write before the write is removed from the queue.
     *
     * These mutations are never sent to the backend.
     */
    n, 
    /**
     * A list of mutations to apply. All mutations will be applied atomically.
     *
     * Mutations are serialized via JsonProtoSerializer.toMutation().
     */
    i) {
        this.userId = t, this.batchId = e, this.localWriteTimeMs = s, this.baseMutations = n, 
        this.mutations = i;
    }
}

/** Name of the IndexedDb object store.  */ ci.store = "mutations", 
/** Keys are automatically assigned via the userId, batchId properties. */
ci.keyPath = "batchId", 
/** The index name for lookup of mutations by user. */
ci.userMutationsIndex = "userMutationsIndex", 
/** The user mutations index is keyed by [userId, batchId] pairs. */
ci.userMutationsKeyPath = [ "userId", "batchId" ];

class _i {
    constructor() {}
    /**
     * Creates a [userId] key for use in the DbDocumentMutations index to iterate
     * over all of a user's document mutations.
     */    static prefixForUser(t) {
        return [ t ];
    }
    /**
     * Creates a [userId, encodedPath] key for use in the DbDocumentMutations
     * index to iterate over all at document mutations for a given path or lower.
     */    static prefixForPath(t, e) {
        return [ t, Dn(e) ];
    }
    /**
     * Creates a full index key of [userId, encodedPath, batchId] for inserting
     * and deleting into the DbDocumentMutations index.
     */    static key(t, e, s) {
        return [ t, Dn(e), s ];
    }
}

_i.store = "documentMutations", 
/**
 * Because we store all the useful information for this store in the key,
 * there is no useful information to store as the value. The raw (unencoded)
 * path cannot be stored because IndexedDb doesn't store prototype
 * information.
 */
_i.PLACEHOLDER = new _i;

class li {
    constructor(t, e) {
        this.path = t, this.readTime = e;
    }
}

/**
 * Represents a document that is known to exist but whose data is unknown.
 * Stored in IndexedDb as part of a DbRemoteDocument object.
 */ class di {
    constructor(t, e) {
        this.path = t, this.version = e;
    }
}

/**
 * An object to be stored in the 'remoteDocuments' store in IndexedDb.
 * It represents either:
 *
 * - A complete document.
 * - A "no document" representing a document that is known not to exist (at
 * some version).
 * - An "unknown document" representing a document that is known to exist (at
 * some version) but whose contents are unknown.
 *
 * Note: This is the persisted equivalent of a MaybeDocument and could perhaps
 * be made more general if necessary.
 */ class fi {
    // TODO: We are currently storing full document keys almost three times
    // (once as part of the primary key, once - partly - as `parentPath` and once
    // inside the encoded documents). During our next migration, we should
    // rewrite the primary key as parentPath + document ID which would allow us
    // to drop one value.
    constructor(
    /**
     * Set to an instance of DbUnknownDocument if the data for a document is
     * not known, but it is known that a document exists at the specified
     * version (e.g. it had a successful update applied to it)
     */
    t, 
    /**
     * Set to an instance of a DbNoDocument if it is known that no document
     * exists.
     */
    e, 
    /**
     * Set to an instance of a Document if there's a cached version of the
     * document.
     */
    s, 
    /**
     * Documents that were written to the remote document store based on
     * a write acknowledgment are marked with `hasCommittedMutations`. These
     * documents are potentially inconsistent with the backend's copy and use
     * the write's commit version as their document version.
     */
    n, 
    /**
     * When the document was read from the backend. Undefined for data written
     * prior to schema version 9.
     */
    i, 
    /**
     * The path of the collection this document is part of. Undefined for data
     * written prior to schema version 9.
     */
    r) {
        this.unknownDocument = t, this.noDocument = e, this.document = s, this.hasCommittedMutations = n, 
        this.readTime = i, this.parentPath = r;
    }
}

fi.store = "remoteDocuments", 
/**
 * An index that provides access to all entries sorted by read time (which
 * corresponds to the last modification time of each row).
 *
 * This index is used to provide a changelog for Multi-Tab.
 */
fi.readTimeIndex = "readTimeIndex", fi.readTimeIndexPath = "readTime", 
/**
 * An index that provides access to documents in a collection sorted by read
 * time.
 *
 * This index is used to allow the RemoteDocumentCache to fetch newly changed
 * documents in a collection.
 */
fi.collectionReadTimeIndex = "collectionReadTimeIndex", fi.collectionReadTimeIndexPath = [ "parentPath", "readTime" ];

/**
 * Contains a single entry that has metadata about the remote document cache.
 */
class Ti {
    /**
     * @param byteSize Approximately the total size in bytes of all the documents in the document
     * cache.
     */
    constructor(t) {
        this.byteSize = t;
    }
}

Ti.store = "remoteDocumentGlobal", Ti.key = "remoteDocumentGlobalKey";

class mi {
    constructor(
    /**
     * An auto-generated sequential numeric identifier for the query.
     *
     * Queries are stored using their canonicalId as the key, but these
     * canonicalIds can be quite long so we additionally assign a unique
     * queryId which can be used by referenced data structures (e.g.
     * indexes) to minimize the on-disk cost.
     */
    t, 
    /**
     * The canonical string representing this query. This is not unique.
     */
    e, 
    /**
     * The last readTime received from the Watch Service for this query.
     *
     * This is the same value as TargetChange.read_time in the protos.
     */
    s, 
    /**
     * An opaque, server-assigned token that allows watching a query to be
     * resumed after disconnecting without retransmitting all the data
     * that matches the query. The resume token essentially identifies a
     * point in time from which the server should resume sending results.
     *
     * This is related to the snapshotVersion in that the resumeToken
     * effectively also encodes that value, but the resumeToken is opaque
     * and sometimes encodes additional information.
     *
     * A consequence of this is that the resumeToken should be used when
     * asking the server to reason about where this client is in the watch
     * stream, but the client should use the snapshotVersion for its own
     * purposes.
     *
     * This is the same value as TargetChange.resume_token in the protos.
     */
    n, 
    /**
     * A sequence number representing the last time this query was
     * listened to, used for garbage collection purposes.
     *
     * Conventionally this would be a timestamp value, but device-local
     * clocks are unreliable and they must be able to create new listens
     * even while disconnected. Instead this should be a monotonically
     * increasing number that's incremented on each listen call.
     *
     * This is different from the queryId since the queryId is an
     * immutable identifier assigned to the Query on first use while
     * lastListenSequenceNumber is updated every time the query is
     * listened to.
     */
    i, 
    /**
     * Denotes the maximum snapshot version at which the associated query view
     * contained no limbo documents.  Undefined for data written prior to
     * schema version 9.
     */
    r, 
    /**
     * The query for this target.
     *
     * Because canonical ids are not unique we must store the actual query. We
     * use the proto to have an object we can persist without having to
     * duplicate translation logic to and from a `Query` object.
     */
    o) {
        this.targetId = t, this.canonicalId = e, this.readTime = s, this.resumeToken = n, 
        this.lastListenSequenceNumber = i, this.lastLimboFreeSnapshotVersion = r, this.query = o;
    }
}

mi.store = "targets", 
/** Keys are automatically assigned via the targetId property. */
mi.keyPath = "targetId", 
/** The name of the queryTargets index. */
mi.queryTargetsIndexName = "queryTargetsIndex", 
/**
 * The index of all canonicalIds to the targets that they match. This is not
 * a unique mapping because canonicalId does not promise a unique name for all
 * possible queries, so we append the targetId to make the mapping unique.
 */
mi.queryTargetsKeyPath = [ "canonicalId", "targetId" ];

/**
 * An object representing an association between a target and a document, or a
 * sentinel row marking the last sequence number at which a document was used.
 * Each document cached must have a corresponding sentinel row before lru
 * garbage collection is enabled.
 *
 * The target associations and sentinel rows are co-located so that orphaned
 * documents and their sequence numbers can be identified efficiently via a scan
 * of this store.
 */
class Ei {
    constructor(
    /**
     * The targetId identifying a target or 0 for a sentinel row.
     */
    t, 
    /**
     * The path to the document, as encoded in the key.
     */
    e, 
    /**
     * If this is a sentinel row, this should be the sequence number of the last
     * time the document specified by `path` was used. Otherwise, it should be
     * `undefined`.
     */
    s) {
        this.targetId = t, this.path = e, this.sequenceNumber = s;
    }
}

/** Name of the IndexedDb object store.  */ Ei.store = "targetDocuments", 
/** Keys are automatically assigned via the targetId, path properties. */
Ei.keyPath = [ "targetId", "path" ], 
/** The index name for the reverse index. */
Ei.documentTargetsIndex = "documentTargetsIndex", 
/** We also need to create the reverse index for these properties. */
Ei.documentTargetsKeyPath = [ "path", "targetId" ];

/**
 * A record of global state tracked across all Targets, tracked separately
 * to avoid the need for extra indexes.
 *
 * This should be kept in-sync with the proto used in the iOS client.
 */
class wi {
    constructor(
    /**
     * The highest numbered target id across all targets.
     *
     * See DbTarget.targetId.
     */
    t, 
    /**
     * The highest numbered lastListenSequenceNumber across all targets.
     *
     * See DbTarget.lastListenSequenceNumber.
     */
    e, 
    /**
     * A global snapshot version representing the last consistent snapshot we
     * received from the backend. This is monotonically increasing and any
     * snapshots received from the backend prior to this version (e.g. for
     * targets resumed with a resumeToken) should be suppressed (buffered)
     * until the backend has caught up to this snapshot version again. This
     * prevents our cache from ever going backwards in time.
     */
    s, 
    /**
     * The number of targets persisted.
     */
    n) {
        this.highestTargetId = t, this.highestListenSequenceNumber = e, this.lastRemoteSnapshotVersion = s, 
        this.targetCount = n;
    }
}

/**
 * The key string used for the single object that exists in the
 * DbTargetGlobal store.
 */ wi.key = "targetGlobalKey", wi.store = "targetGlobal";

/**
 * An object representing an association between a Collection id (e.g. 'messages')
 * to a parent path (e.g. '/chats/123') that contains it as a (sub)collection.
 * This is used to efficiently find all collections to query when performing
 * a Collection Group query.
 */
class Ii {
    constructor(
    /**
     * The collectionId (e.g. 'messages')
     */
    t, 
    /**
     * The path to the parent (either a document location or an empty path for
     * a root-level collection).
     */
    e) {
        this.collectionId = t, this.parent = e;
    }
}

/** Name of the IndexedDb object store. */ function Ri(t) {
    t.createObjectStore(Ei.store, {
        keyPath: Ei.keyPath
    }).createIndex(Ei.documentTargetsIndex, Ei.documentTargetsKeyPath, {
        unique: !0
    }), 
    // NOTE: This is unique only because the TargetId is the suffix.
    t.createObjectStore(mi.store, {
        keyPath: mi.keyPath
    }).createIndex(mi.queryTargetsIndexName, mi.queryTargetsKeyPath, {
        unique: !0
    }), t.createObjectStore(wi.store);
}

Ii.store = "collectionParents", 
/** Keys are automatically assigned via the collectionId, parent properties. */
Ii.keyPath = [ "collectionId", "parent" ];

class Ai {
    constructor(
    // Note: Previous schema versions included a field
    // "lastProcessedDocumentChangeId". Don't use anymore.
    /** The auto-generated client id assigned at client startup. */
    t, 
    /** The last time this state was updated. */
    e, 
    /** Whether the client's network connection is enabled. */
    s, 
    /** Whether this client is running in a foreground tab. */
    n) {
        this.clientId = t, this.updateTimeMs = e, this.networkEnabled = s, this.inForeground = n;
    }
}

/** Name of the IndexedDb object store. */ Ai.store = "clientMetadata", 
/** Keys are automatically assigned via the clientId properties. */
Ai.keyPath = "clientId";

const Pi = [ ...[ ...[ ...[ ui.store, ci.store, _i.store, fi.store, mi.store, ai.store, wi.store, Ei.store ], Ai.store ], Ti.store ], Ii.store ];

// V2 is no longer usable (see comment at top of file)
// Visible for testing
/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A persisted implementation of IndexManager.
 */
class Vi {
    constructor() {
        /**
         * An in-memory copy of the index entries we've already written since the SDK
         * launched. Used to avoid re-writing the same entry repeatedly.
         *
         * This is *NOT* a complete cache of what's in persistence and so can never be used to
         * satisfy reads.
         */
        this.ef = new ii;
    }
    /**
     * Adds a new entry to the collection parent index.
     *
     * Repeated calls for the same collectionPath should be avoided within a
     * transaction as IndexedDbIndexManager only caches writes once a transaction
     * has been committed.
     */    Vd(t, e) {
        if (!this.ef.has(e)) {
            const s = e.B(), n = e.L();
            t.rr(() => {
                // Add the collection to the in memory cache only if the transaction was
                // successfully committed.
                this.ef.add(e);
            });
            const i = {
                collectionId: s,
                parent: Dn(n)
            };
            return gi(t).put(i);
        }
        return Qe.resolve();
    }
    Pr(t, e) {
        const s = [], n = IDBKeyRange.bound([ e, "" ], [ $e(e), "" ], 
        /*lowerOpen=*/ !1, 
        /*upperOpen=*/ !0);
        return gi(t).ld(n).next(t => {
            for (const n of t) {
                // This collectionId guard shouldn't be necessary (and isn't as long
                // as we're running in a real browser), but there's a bug in
                // indexeddbshim that breaks our range in our tests running in node:
                // https://github.com/axemclion/IndexedDBShim/issues/334
                if (n.collectionId !== e) break;
                s.push(Nn(n.parent));
            }
            return s;
        });
    }
}

/**
 * Helper to get a typed SimpleDbStore for the collectionParents
 * document store.
 */ function gi(t) {
    return vi.ed(t, Ii.store);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Serializer for values stored in the LocalStore. */ class pi {
    constructor(t) {
        this.sf = t;
    }
    /** Decodes a remote document from storage locally to a Document. */    Gd(t) {
        if (t.document) return this.sf.vn(t.document, !!t.hasCommittedMutations);
        if (t.noDocument) {
            const e = C.nt(t.noDocument.path), s = this.nf(t.noDocument.readTime);
            return new vt(e, s, {
                hasCommittedMutations: !!t.hasCommittedMutations
            });
        }
        if (t.unknownDocument) {
            const e = C.nt(t.unknownDocument.path), s = this.nf(t.unknownDocument.version);
            return new St(e, s);
        }
        return De("Unexpected DbRemoteDocument");
    }
    /** Encodes a document for storage locally. */    Zd(t, e) {
        const s = this.Kd(e), n = t.key.path.L().j();
        if (t instanceof bt) {
            const e = this.sf.bn(t), i = t.hasCommittedMutations;
            return new fi(
            /* unknownDocument= */ null, 
            /* noDocument= */ null, e, i, s, n);
        }
        if (t instanceof vt) {
            const e = t.key.path.j(), i = this.if(t.version), r = t.hasCommittedMutations;
            return new fi(
            /* unknownDocument= */ null, new li(e, i), 
            /* document= */ null, r, s, n);
        }
        if (t instanceof St) {
            const e = t.key.path.j(), i = this.if(t.version);
            return new fi(new di(e, i), 
            /* noDocument= */ null, 
            /* document= */ null, 
            /* hasCommittedMutations= */ !0, s, n);
        }
        return De("Unexpected MaybeDocument");
    }
    Kd(t) {
        const e = t.k();
        return [ e.seconds, e.nanoseconds ];
    }
    zd(t) {
        const e = new p(t[0], t[1]);
        return y.v(e);
    }
    if(t) {
        const e = t.k();
        return new hi(e.seconds, e.nanoseconds);
    }
    nf(t) {
        const e = new p(t.seconds, t.nanoseconds);
        return y.v(e);
    }
    /** Encodes a batch of mutations into a DbMutationBatch for local storage. */    Pd(t, e) {
        const s = e.baseMutations.map(t => this.sf.$n(t)), n = e.mutations.map(t => this.sf.$n(t));
        return new ci(t, e.batchId, e.Ri.toMillis(), s, n);
    }
    /** Decodes a DbMutationBatch into a MutationBatch */    gd(t) {
        const e = (t.baseMutations || []).map(t => this.sf.xn(t)), s = t.mutations.map(t => this.sf.xn(t)), n = p.fromMillis(t.localWriteTimeMs);
        return new xe(t.batchId, n, e, s);
    }
    /** Decodes a DbTarget into TargetData */    $d(t) {
        const e = this.nf(t.readTime), s = void 0 !== t.lastLimboFreeSnapshotVersion ? this.nf(t.lastLimboFreeSnapshotVersion) : y.MIN;
        let n;
        return n = void 0 !== t.query.documents ? this.sf.Kn(t.query) : this.sf.Yn(t.query), 
        new Wt(n, t.targetId, 0 /* Listen */ , t.lastListenSequenceNumber, e, s, B.fromBase64String(t.resumeToken));
    }
    /** Encodes TargetData into a DbTarget for storage locally. */    Md(t) {
        const e = this.if(t.ts), s = this.if(t.lastLimboFreeSnapshotVersion);
        let n;
        n = t.target.Pe() ? this.sf.jn(t.target) : this.sf.Gn(t.target);
        // We can't store the resumeToken as a ByteString in IndexedDb, so we
        // convert it to a base64 string for storage.
                const i = t.resumeToken.toBase64();
        // lastListenSequenceNumber is always 0 until we do real GC.
                return new mi(t.targetId, t.target.canonicalId(), e, i, t.sequenceNumber, s, n);
    }
}

/**
 * A helper function for figuring out what kind of query has been stored.
 */
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const yi = "Another tab has exclusive access to the persistence layer. To allow shared access, make sure to invoke `enablePersistence()` with `synchronizeTabs:true` in all tabs.";

/**
 * Oldest acceptable age in milliseconds for client metadata before the client
 * is considered inactive and its associated data is garbage collected.
 */ class bi extends Ke {
    constructor(t, e) {
        super(), this.yd = t, this.Ch = e;
    }
}

/**
 * An IndexedDB-backed instance of Persistence. Data is stored persistently
 * across sessions.
 *
 * On Web only, the Firestore SDKs support shared access to its persistence
 * layer. This allows multiple browser tabs to read and write to IndexedDb and
 * to synchronize state even without network connectivity. Shared access is
 * currently optional and not enabled unless all clients invoke
 * `enablePersistence()` with `{synchronizeTabs:true}`.
 *
 * In multi-tab mode, if multiple clients are active at the same time, the SDK
 * will designate one client as the “primary client”. An effort is made to pick
 * a visible, network-connected and active client, and this client is
 * responsible for letting other clients know about its presence. The primary
 * client writes a unique client-generated identifier (the client ID) to
 * IndexedDb’s “owner” store every 4 seconds. If the primary client fails to
 * update this entry, another client can acquire the lease and take over as
 * primary.
 *
 * Some persistence operations in the SDK are designated as primary-client only
 * operations. This includes the acknowledgment of mutations and all updates of
 * remote documents. The effects of these operations are written to persistence
 * and then broadcast to other tabs via LocalStorage (see
 * `WebStorageSharedClientState`), which then refresh their state from
 * persistence.
 *
 * Similarly, the primary client listens to notifications sent by secondary
 * clients to discover persistence changes written by secondary clients, such as
 * the addition of new mutations and query targets.
 *
 * If multi-tab is not enabled and another tab already obtained the primary
 * lease, IndexedDbPersistence enters a failed state and all subsequent
 * operations will automatically fail.
 *
 * Additionally, there is an optimization so that when a tab is closed, the
 * primary lease is released immediately (this is especially important to make
 * sure that a refreshed tab is able to immediately re-acquire the primary
 * lease). Unfortunately, IndexedDB cannot be reliably used in window.unload
 * since it is an asynchronous API. So in addition to attempting to give up the
 * lease, the leaseholder writes its client ID to a "zombiedClient" entry in
 * LocalStorage which acts as an indicator that another tab should go ahead and
 * take the primary lease immediately regardless of the current lease timestamp.
 *
 * TODO(b/114226234): Remove `synchronizeTabs` section when multi-tab is no
 * longer optional.
 */ class vi {
    constructor(t, e, s, n, i, r, o, h) {
        if (this.allowTabSynchronization = t, this.persistenceKey = e, this.clientId = s, 
        this.$a = r, this.rf = h, this.hf = !1, this.isPrimary = !1, this.networkEnabled = !0, 
        /** Our window.unload handler, if registered. */
        this.af = null, this.inForeground = !1, 
        /** Our 'visibilitychange' listener if registered. */
        this.uf = null, 
        /** The client metadata refresh task. */
        this.cf = null, 
        /** The last time we garbage collected the client metadata object store. */
        this._f = Number.NEGATIVE_INFINITY, 
        /** A listener to notify on primary state changes. */
        this.lf = t => Promise.resolve(), this.Jo = new Ci(this, i), this.df = e + vi.ff, 
        this.serializer = new pi(o), this.document = n.document, this.th = new Gn(this.Jo, this.serializer), 
        this.ur = new Vi, this.hr = new Xn(this.serializer, this.ur), !n.window || !n.window.localStorage) throw new I(w.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
        this.window = n.window, this.Tf = this.window.localStorage;
    }
    static ed(t, e) {
        if (t instanceof bi) return Fn.ed(t.yd, e);
        throw De("IndexedDbPersistence must use instances of IndexedDbTransaction");
    }
    static mf(t) {
        if (!vi.Uc()) throw new I(w.UNIMPLEMENTED, "This platform is either missing IndexedDB or is known to have an incomplete implementation. Offline persistence has been disabled.");
        return new vi(t.allowTabSynchronization, t.persistenceKey, t.clientId, t.platform, t.Ef, t.$a, t.serializer, t.rf);
    }
    /**
     * Attempt to start IndexedDb persistence.
     *
     * @return {Promise<void>} Whether persistence was enabled.
     */    start() {
        return Fn.Yl(this.df, ri, new oi(this.serializer)).then(t => (this.wf = t, this.If())).then(() => (this.Rf(), 
        this.Af(), this.Pf(), this.wf.runTransaction("readonly", [ wi.store ], t => Jn(t)))).then(t => {
            this.Vf = new He(t, this.rf);
        }).then(() => {
            this.hf = !0;
        }).catch(t => (this.wf && this.wf.close(), Promise.reject(t)));
    }
    gf(t) {
        return this.lf = async e => {
            if (this.ko) return t(e);
        }, t(this.isPrimary);
    }
    pf(t) {
        this.wf.sd(async e => {
            // Check if an attempt is made to delete IndexedDB.
            null === e.newVersion && await t();
        });
    }
    Zh(t) {
        this.networkEnabled !== t && (this.networkEnabled = t, 
        // Schedule a primary lease refresh for immediate execution. The eventual
        // lease update will be propagated via `primaryStateListener`.
        this.$a.qr(async () => {
            this.ko && await this.If();
        }));
    }
    /**
     * Updates the client metadata in IndexedDb and attempts to either obtain or
     * extend the primary lease for the local client. Asynchronously notifies the
     * primary state listener if the client either newly obtained or released its
     * primary lease.
     */    If() {
        return this.wf.runTransaction("readwrite", Pi, t => Di(t).put(new Ai(this.clientId, Date.now(), this.networkEnabled, this.inForeground)).next(() => {
            if (this.isPrimary) return this.yf(t).next(t => {
                t || (this.isPrimary = !1, this.$a.qr(() => this.lf(!1)));
            });
        }).next(() => this.bf(t)).next(e => this.isPrimary && !e ? this.vf(t).next(() => !1) : !!e && this.Sf(t).next(() => !0))).catch(t => {
            if (!this.allowTabSynchronization) throw t;
            return be("IndexedDbPersistence", "Releasing owner lease after error during lease refresh", t), 
            /* isPrimary= */ !1;
        }).then(t => {
            this.isPrimary !== t && this.$a.qr(() => this.lf(t)), this.isPrimary = t;
        });
    }
    yf(t) {
        return Si(t).get(ai.key).next(t => Qe.resolve(this.Df(t)));
    }
    Cf(t) {
        return Di(t).delete(this.clientId);
    }
    /**
     * If the garbage collection threshold has passed, prunes the
     * RemoteDocumentChanges and the ClientMetadata store based on the last update
     * time of all clients.
     */    async kf() {
        if (this.isPrimary && !this.Nf(this._f, 18e5)) {
            this._f = Date.now(), 
            // Delete potential leftover entries that may continue to mark the
            // inactive clients as zombied in LocalStorage.
            // Ideally we'd delete the IndexedDb and LocalStorage zombie entries for
            // the client atomically, but we can't. So we opt to delete the IndexedDb
            // entries first to avoid potentially reviving a zombied client.
            (await this.runTransaction("maybeGarbageCollectMultiClientState", "readwrite-primary", t => {
                const e = vi.ed(t, Ai.store);
                return e.ld().next(t => {
                    const s = this.Ff(t, 18e5), n = t.filter(t => -1 === s.indexOf(t));
                    // Delete metadata for clients that are no longer considered active.
                    return Qe.forEach(n, t => e.delete(t.clientId)).next(() => n);
                });
            }).catch(() => [])).forEach(t => {
                this.window.localStorage.removeItem(this.$f(t.clientId));
            });
        }
    }
    /**
     * Schedules a recurring timer to update the client metadata and to either
     * extend or acquire the primary lease if the client is eligible.
     */    Pf() {
        this.cf = this.$a.eo("client_metadata_refresh" /* ClientMetadataRefresh */ , 4e3, () => this.If().then(() => this.kf()).then(() => this.Pf()));
    }
    /** Checks whether `client` is the local client. */    Df(t) {
        return !!t && t.ownerId === this.clientId;
    }
    /**
     * Evaluate the state of all active clients and determine whether the local
     * client is or can act as the holder of the primary lease. Returns whether
     * the client is eligible for the lease, but does not actually acquire it.
     * May return 'false' even if there is no active leaseholder and another
     * (foreground) client should become leaseholder instead.
     */    bf(t) {
        return Si(t).get(ai.key).next(e => {
            // A client is eligible for the primary lease if:
            // - its network is enabled and the client's tab is in the foreground.
            // - its network is enabled and no other client's tab is in the
            //   foreground.
            // - every clients network is disabled and the client's tab is in the
            //   foreground.
            // - every clients network is disabled and no other client's tab is in
            //   the foreground.
            if (null !== e && this.Nf(e.leaseTimestampMs, 5e3) && !this.Mf(e.ownerId)) {
                if (this.Df(e) && this.networkEnabled) return !0;
                if (!this.Df(e)) {
                    if (!e.allowTabSynchronization) 
                    // Fail the `canActAsPrimary` check if the current leaseholder has
                    // not opted into multi-tab synchronization. If this happens at
                    // client startup, we reject the Promise returned by
                    // `enablePersistence()` and the user can continue to use Firestore
                    // with in-memory persistence.
                    // If this fails during a lease refresh, we will instead block the
                    // AsyncQueue from executing further operations. Note that this is
                    // acceptable since mixing & matching different `synchronizeTabs`
                    // settings is not supported.
                    // TODO(b/114226234): Remove this check when `synchronizeTabs` can
                    // no longer be turned off.
                    throw new I(w.FAILED_PRECONDITION, yi);
                    return !1;
                }
            }
            return !(!this.networkEnabled || !this.inForeground) || Di(t).ld().next(t => void 0 === this.Ff(t, 5e3).find(t => {
                if (this.clientId !== t.clientId) {
                    const e = !this.networkEnabled && t.networkEnabled, s = !this.inForeground && t.inForeground, n = this.networkEnabled === t.networkEnabled;
                    if (e || s && n) return !0;
                }
                return !1;
            }));
        }).next(t => (this.isPrimary !== t && be("IndexedDbPersistence", `Client ${t ? "is" : "is not"} eligible for a primary lease.`), 
        t));
    }
    async lc() {
        // The shutdown() operations are idempotent and can be called even when
        // start() aborted (e.g. because it couldn't acquire the persistence lease).
        this.hf = !1, this.Lf(), this.cf && (this.cf.cancel(), this.cf = null), this.Of(), 
        this.xf(), await this.wf.runTransaction("readwrite", [ ai.store, Ai.store ], t => this.vf(t).next(() => this.Cf(t))), 
        this.wf.close(), 
        // Remove the entry marking the client as zombied from LocalStorage since
        // we successfully deleted its metadata from IndexedDb.
        this.Bf();
    }
    /**
     * Returns clients that are not zombied and have an updateTime within the
     * provided threshold.
     */    Ff(t, e) {
        return t.filter(t => this.Nf(t.updateTimeMs, e) && !this.Mf(t.clientId));
    }
    Jh() {
        return this.wf.runTransaction("readonly", [ Ai.store ], t => Di(t).ld().next(t => this.Ff(t, 18e5).map(t => t.clientId)));
    }
    static async clearPersistence(t) {
        if (!vi.Uc()) return Promise.resolve();
        const e = t + vi.ff;
        await Fn.delete(e);
    }
    get ko() {
        return this.hf;
    }
    Yo(t) {
        return Un.Id(t, this.serializer, this.ur, this.Jo);
    }
    eh() {
        return this.th;
    }
    Zo() {
        return this.hr;
    }
    nh() {
        return this.ur;
    }
    runTransaction(t, e, s) {
        be("IndexedDbPersistence", "Starting transaction:", t);
        const n = "readonly" === e ? "readonly" : "readwrite";
        let i;
        // Do all transactions as readwrite against all object stores, since we
        // are the only reader/writer.
                return this.wf.runTransaction(n, Pi, n => (i = new bi(n, this.Vf.next()), 
        "readwrite-primary" === e ? this.yf(n).next(t => !!t || this.bf(n)).next(e => {
            if (!e) throw ve(`Failed to obtain primary lease for action '${t}'.`), this.isPrimary = !1, 
            this.$a.qr(() => this.lf(!1)), new I(w.FAILED_PRECONDITION, je);
            return s(i);
        }).next(t => this.Sf(n).next(() => t)) : this.Uf(n).next(() => s(i)))).then(t => (i.or(), 
        t));
    }
    /**
     * Verifies that the current tab is the primary leaseholder or alternatively
     * that the leaseholder has opted into multi-tab synchronization.
     */
    // TODO(b/114226234): Remove this check when `synchronizeTabs` can no longer
    // be turned off.
    Uf(t) {
        return Si(t).get(ai.key).next(t => {
            if (null !== t && this.Nf(t.leaseTimestampMs, 5e3) && !this.Mf(t.ownerId) && !this.Df(t) && !t.allowTabSynchronization) throw new I(w.FAILED_PRECONDITION, yi);
        });
    }
    /**
     * Obtains or extends the new primary lease for the local client. This
     * method does not verify that the client is eligible for this lease.
     */    Sf(t) {
        const e = new ai(this.clientId, this.allowTabSynchronization, Date.now());
        return Si(t).put(ai.key, e);
    }
    static Uc() {
        return Fn.Uc();
    }
    /**
     * Generates a string used as a prefix when storing data in IndexedDB and
     * LocalStorage.
     */    static qf(t) {
        // Use two different prefix formats:
        //   * firestore / persistenceKey / projectID . databaseID / ...
        //   * firestore / persistenceKey / projectID / ...
        // projectIDs are DNS-compatible names and cannot contain dots
        // so there's no danger of collisions.
        let e = t.cn.projectId;
        return t.cn.Ei || (e += "." + t.cn.database), "firestore/" + t.persistenceKey + "/" + e + "/";
    }
    /** Checks the primary lease and removes it if we are the current primary. */    vf(t) {
        const e = Si(t);
        return e.get(ai.key).next(t => this.Df(t) ? (be("IndexedDbPersistence", "Releasing primary lease."), 
        e.delete(ai.key)) : Qe.resolve());
    }
    /** Verifies that `updateTimeMs` is within `maxAgeMs`. */    Nf(t, e) {
        const s = Date.now();
        return !(t < s - e) && (!(t > s) || (ve(`Detected an update time that is in the future: ${t} > ${s}`), 
        !1));
    }
    Rf() {
        null !== this.document && "function" == typeof this.document.addEventListener && (this.uf = () => {
            this.$a.qr(() => (this.inForeground = "visible" === this.document.visibilityState, 
            this.If()));
        }, this.document.addEventListener("visibilitychange", this.uf), this.inForeground = "visible" === this.document.visibilityState);
    }
    Of() {
        this.uf && (this.document.removeEventListener("visibilitychange", this.uf), this.uf = null);
    }
    /**
     * Attaches a window.unload handler that will synchronously write our
     * clientId to a "zombie client id" location in LocalStorage. This can be used
     * by tabs trying to acquire the primary lease to determine that the lease
     * is no longer valid even if the timestamp is recent. This is particularly
     * important for the refresh case (so the tab correctly re-acquires the
     * primary lease). LocalStorage is used for this rather than IndexedDb because
     * it is a synchronous API and so can be used reliably from  an unload
     * handler.
     */    Af() {
        "function" == typeof this.window.addEventListener && (this.af = () => {
            // Note: In theory, this should be scheduled on the AsyncQueue since it
            // accesses internal state. We execute this code directly during shutdown
            // to make sure it gets a chance to run.
            this.Lf(), this.$a.qr(() => this.lc());
        }, this.window.addEventListener("unload", this.af));
    }
    xf() {
        this.af && (this.window.removeEventListener("unload", this.af), this.af = null);
    }
    /**
     * Returns whether a client is "zombied" based on its LocalStorage entry.
     * Clients become zombied when their tab closes without running all of the
     * cleanup logic in `shutdown()`.
     */    Mf(t) {
        try {
            const e = null !== this.Tf.getItem(this.$f(t));
            return be("IndexedDbPersistence", `Client '${t}' ${e ? "is" : "is not"} zombied in LocalStorage`), 
            e;
        } catch (t) {
            // Gracefully handle if LocalStorage isn't working.
            return ve("IndexedDbPersistence", "Failed to get zombied client id.", t), !1;
        }
    }
    /**
     * Record client as zombied (a client that had its tab closed). Zombied
     * clients are ignored during primary tab selection.
     */    Lf() {
        try {
            this.Tf.setItem(this.$f(this.clientId), String(Date.now()));
        } catch (t) {
            // Gracefully handle if LocalStorage isn't available / working.
            ve("Failed to set zombie client id.", t);
        }
    }
    /** Removes the zombied client entry if it exists. */    Bf() {
        try {
            this.Tf.removeItem(this.$f(this.clientId));
        } catch (t) {
            // Ignore
        }
    }
    $f(t) {
        return `firestore_zombie_${this.persistenceKey}_${t}`;
    }
}

/**
 * The name of the main (and currently only) IndexedDB database. this name is
 * appended to the prefix provided to the IndexedDbPersistence constructor.
 */
/**
 * Helper to get a typed SimpleDbStore for the primary client object store.
 */
function Si(t) {
    return t.store(ai.store);
}

/**
 * Helper to get a typed SimpleDbStore for the client metadata object store.
 */ function Di(t) {
    return t.store(Ai.store);
}

/** Provides LRU functionality for IndexedDB persistence. */ vi.ff = "main";

class Ci {
    constructor(t, e) {
        this.db = t, this.Qf = null, this.bo = new is(this, e);
    }
    Mo(t) {
        const e = this.Wf(t);
        return this.db.eh().Ld(t).next(t => e.next(e => t + e));
    }
    Wf(t) {
        let e = 0;
        return this.Oo(t, t => {
            e++;
        }).next(() => e);
    }
    Xs(t, e) {
        return this.db.eh().Xs(t, e);
    }
    Oo(t, e) {
        return this.jf(t, (t, s) => e(s));
    }
    Ho(t) {
        this.Qf = t;
    }
    vi(t, e) {
        return ki(t, e);
    }
    Di(t, e) {
        return ki(t, e);
    }
    xo(t, e, s) {
        return this.db.eh().xo(t, e, s);
    }
    bd(t, e) {
        return ki(t, e);
    }
    /**
     * Returns true if anything would prevent this document from being garbage
     * collected, given that the document in question is not present in any
     * targets and has a sequence number less than or equal to the upper bound for
     * the collection run.
     */    Kf(t, e) {
        return this.Qf.Mi(e) ? Qe.resolve(!0) : function(t, e) {
            let s = !1;
            return Kn(t).Ed(n => qn(t, n, e).next(t => (t && (s = !0), Qe.resolve(!t)))).next(() => s);
        }(t, e);
    }
    Bo(t, e) {
        const s = this.db.Zo().Eh(), n = [];
        let i = 0;
        return this.jf(t, (r, o) => {
            if (o <= e) {
                const e = this.Kf(t, r).next(e => {
                    if (!e) 
                    // Our size accounting requires us to read all documents before
                    // removing them.
                    return i++, s.tr(t, r).next(() => (s.Zi(r), Yn(t).delete([ 0, Dn(r.path) ])));
                });
                n.push(e);
            }
        }).next(() => Qe.Ki(n)).next(() => s.apply(t)).next(() => i);
    }
    removeTarget(t, e) {
        const s = e.es(t.Ch);
        return this.db.eh().Nh(t, s);
    }
    Fh(t, e) {
        return ki(t, e);
    }
    /**
     * Call provided function for each document in the cache that is 'orphaned'. Orphaned
     * means not a part of any target, so the only entry in the target-document index for
     * that document will be the sentinel row (targetId 0), which will also have the sequence
     * number for the last time the document was accessed.
     */    jf(t, e) {
        const s = Yn(t);
        let n, i = He.kr;
        return s.md({
            index: Ei.documentTargetsIndex
        }, ([t, s], {path: r, sequenceNumber: o}) => {
            0 === t ? (
            // if nextToReport is valid, report it, this is a new key so the
            // last one must not be a member of any targets.
            i !== He.kr && e(new C(Nn(n)), i), 
            // set nextToReport to be this sequence number. It's the next one we
            // might report, if we don't find any targets for this document.
            // Note that the sequence number must be defined when the targetId
            // is 0.
            i = o, n = r) : 
            // set nextToReport to be invalid, we know we don't need to report
            // this one since we found a target for it.
            i = He.kr;
        }).next(() => {
            // Since we report sequence numbers after getting to the next key, we
            // need to check if the last key we iterated over was an orphaned
            // document and report it.
            i !== He.kr && e(new C(Nn(n)), i);
        });
    }
    qo(t) {
        return this.db.Zo().Jd(t);
    }
}

function ki(t, e) {
    return Yn(t).put(
    /**
 * @return A value suitable for writing a sentinel row in the target-document
 * store.
 */
    function(t, e) {
        return new Ei(0, Dn(t.path), e);
    }(e, t.Ch));
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Ni {
    constructor(t, e) {
        this.ur = t, this.Jo = e, 
        /**
         * The set of all mutations that have been sent but not yet been applied to
         * the backend.
         */
        this.ar = [], 
        /** Next value to use when assigning sequential IDs to each mutation batch. */
        this.Gf = 1, 
        /** The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         */
        this.lastStreamToken = B.xt, 
        /** An ordered mapping between documents and the mutations batch IDs. */
        this.zf = new $(qe.Ee);
    }
    Rd(t) {
        return Qe.resolve(0 === this.ar.length);
    }
    mh(t, e, s) {
        const n = e.batchId, i = this.Hf(n, "acknowledged");
        Ce(0 === i, "Can only acknowledge the first batch in the mutation queue");
        // Verify that the batch in the queue is the one to be acknowledged.
        this.ar[i];
        return this.lastStreamToken = s, Qe.resolve();
    }
    ph(t) {
        return Qe.resolve(this.lastStreamToken);
    }
    yh(t, e) {
        return this.lastStreamToken = e, Qe.resolve();
    }
    dh(t, e, s, n) {
        const i = this.Gf;
        if (this.Gf++, this.ar.length > 0) {
            this.ar[this.ar.length - 1];
        }
        const r = new xe(i, e, s, n);
        this.ar.push(r);
        // Track references by document key and index collection parents.
        for (const e of n) this.zf = this.zf.add(new qe(e.key, i)), this.ur.Vd(t, e.key.path.L());
        return Qe.resolve(r);
    }
    Ph(t, e) {
        return Qe.resolve(this.Jf(e));
    }
    Th(t, e) {
        const s = this.Jf(e);
        return Qe.resolve(s.keys());
    }
    xh(t, e) {
        const s = e + 1, n = this.Yf(s), i = n < 0 ? 0 : n;
        // The requested batchId may still be out of range so normalize it to the
        // start of the queue.
                return Qe.resolve(this.ar.length > i ? this.ar[i] : null);
    }
    gh() {
        return Qe.resolve(0 === this.ar.length ? -1 : this.Gf - 1);
    }
    hh(t) {
        return Qe.resolve(this.ar.slice());
    }
    _r(t, e) {
        const s = new qe(e, 0), n = new qe(e, Number.POSITIVE_INFINITY), i = [];
        return this.zf.Ct([ s, n ], t => {
            const e = this.Jf(t.Li);
            i.push(e);
        }), Qe.resolve(i);
    }
    Er(t, e) {
        let s = new $(Ne);
        return e.forEach(t => {
            const e = new qe(t, 0), n = new qe(t, Number.POSITIVE_INFINITY);
            this.zf.Ct([ e, n ], t => {
                s = s.add(t.Li);
            });
        }), Qe.resolve(this.Xf(s));
    }
    Vr(t, e) {
        // Use the query path as a prefix for testing if a document matches the
        // query.
        const s = e.path, n = s.length + 1;
        // Construct a document reference for actually scanning the index. Unlike
        // the prefix the document key in this reference must have an even number of
        // segments. The empty segment can be used a suffix of the query path
        // because it precedes all other segments in an ordered traversal.
        let i = s;
        C.st(i) || (i = i.child(""));
        const r = new qe(new C(i), 0);
        // Find unique batchIDs referenced by all documents potentially matching the
        // query.
                let o = new $(Ne);
        return this.zf.kt(t => {
            const e = t.key.path;
            return !!s.q(e) && (
            // Rows with document keys more than one segment longer than the query
            // path can't be matches. For example, a query on 'rooms' can't match
            // the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            e.length === n && (o = o.add(t.Li)), !0);
        }, r), Qe.resolve(this.Xf(o));
    }
    Xf(t) {
        // Construct an array of matching batches, sorted by batchID to ensure that
        // multiple mutations affecting the same document key are applied in order.
        const e = [];
        return t.forEach(t => {
            const s = this.Jf(t);
            null !== s && e.push(s);
        }), e;
    }
    Vh(t, e) {
        Ce(0 === this.Hf(e.batchId, "removed"), "Can only remove the first entry of the mutation queue"), 
        this.ar.shift();
        let s = this.zf;
        return Qe.forEach(e.mutations, n => {
            const i = new qe(n.key, e.batchId);
            return s = s.delete(i), this.Jo.bd(t, n.key);
        }).next(() => {
            this.zf = s;
        });
    }
    Xh(t) {
        // No-op since the memory mutation queue does not maintain a separate cache.
    }
    Mi(t, e) {
        const s = new qe(e, 0), n = this.zf.Nt(s);
        return Qe.resolve(e.isEqual(n && n.key));
    }
    Rh(t) {
        return this.ar.length, Qe.resolve();
    }
    /**
     * Finds the index of the given batchId in the mutation queue and asserts that
     * the resulting index is within the bounds of the queue.
     *
     * @param batchId The batchId to search for
     * @param action A description of what the caller is doing, phrased in passive
     * form (e.g. "acknowledged" in a routine that acknowledges batches).
     */    Hf(t, e) {
        return this.Yf(t);
    }
    /**
     * Finds the index of the given batchId in the mutation queue. This operation
     * is O(1).
     *
     * @return The computed index of the batch with the given batchId, based on
     * the state of the queue. Note this index can be negative if the requested
     * batchId has already been remvoed from the queue or past the end of the
     * queue if the batchId is larger than the last added batch.
     */    Yf(t) {
        if (0 === this.ar.length) 
        // As an index this is past the end of the queue
        return 0;
        // Examine the front of the queue to figure out the difference between the
        // batchId and indexes in the array. Note that since the queue is ordered
        // by batchId, if the first batch has a larger batchId then the requested
        // batchId doesn't exist in the queue.
                return t - this.ar[0].batchId;
    }
    /**
     * A version of lookupMutationBatch that doesn't return a promise, this makes
     * other functions that uses this code easier to read and more efficent.
     */    Jf(t) {
        const e = this.Yf(t);
        return e < 0 || e >= this.ar.length ? null : this.ar[e];
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Fi {
    /**
     * @param sizer Used to assess the size of a document. For eager GC, this is expected to just
     * return 0 to avoid unnecessarily doing the work of calculating the size.
     */
    constructor(t, e) {
        this.ur = t, this.Zf = e, 
        /** Underlying cache of documents and their read times. */
        this.docs = new k(C.F), 
        /** Size of all cached documents. */
        this.size = 0;
    }
    /**
     * Adds the supplied entry to the cache and updates the cache size as appropriate.
     *
     * All calls of `addEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Yi(t, e, s) {
        const n = e.key, i = this.docs.get(n), r = i ? i.size : 0, o = this.Zf(e);
        return this.docs = this.docs.it(n, {
            Ud: e,
            size: o,
            readTime: s
        }), this.size += o - r, this.ur.Vd(t, n.path.L());
    }
    /**
     * Removes the specified entry from the cache and updates the cache size as appropriate.
     *
     * All calls of `removeEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Zi(t) {
        const e = this.docs.get(t);
        e && (this.docs = this.docs.remove(t), this.size -= e.size);
    }
    tr(t, e) {
        const s = this.docs.get(e);
        return Qe.resolve(s ? s.Ud : null);
    }
    getEntries(t, e) {
        let s = Xt();
        return e.forEach(t => {
            const e = this.docs.get(t);
            s = s.it(t, e ? e.Ud : null);
        }), Qe.resolve(s);
    }
    wr(t, e, s) {
        let n = te();
        // Documents are ordered by key, so we can use a prefix scan to narrow down
        // the documents we need to match the query against.
                const i = new C(e.path.child("")), r = this.docs.lt(i);
        for (;r.It(); ) {
            const {key: t, value: {Ud: i, readTime: o}} = r.wt();
            if (!e.path.q(t.path)) break;
            o.D(s) <= 0 || i instanceof bt && e.matches(i) && (n = n.it(i.key, i));
        }
        return Qe.resolve(n);
    }
    tT(t, e) {
        return Qe.forEach(this.docs, t => e(t));
    }
    ea(t, e) {
        throw new Error("getNewDocumentChanges() is not supported with MemoryPersistence");
    }
    na(t) {
        return Qe.resolve(y.MIN);
    }
    Eh(t) {
        // `trackRemovals` is ignores since the MemoryRemoteDocumentCache keeps
        // a separate changelog and does not need special handling for removals.
        return new Fi.Hd(this);
    }
    Jd(t) {
        return Qe.resolve(this.size);
    }
}

/**
 * Handles the details of adding and updating documents in the MemoryRemoteDocumentCache.
 */ Fi.Hd = class extends We {
    constructor(t) {
        super(), this.Yd = t;
    }
    nr(t) {
        const e = [];
        return this.zi.forEach((s, n) => {
            n ? e.push(this.Yd.Yi(t, n, this.readTime)) : this.Yd.Zi(s);
        }), Qe.Ki(e);
    }
    er(t, e) {
        return this.Yd.tr(t, e);
    }
    sr(t, e) {
        return this.Yd.getEntries(t, e);
    }
};

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class $i {
    constructor(t) {
        this.persistence = t, 
        /**
         * Maps a target to the data about that target
         */
        this.eT = new Oe(t => t.canonicalId()), 
        /** The last received snapshot version. */
        this.lastRemoteSnapshotVersion = y.MIN, 
        /** The highest numbered target ID encountered. */
        this.highestTargetId = 0, 
        /** The highest sequence number encountered. */
        this.sT = 0, 
        /**
         * A ordered bidirectional mapping between documents and the remote target
         * IDs.
         */
        this.nT = new Ue, this.targetCount = 0, this.iT = wn.p_();
    }
    Xs(t, e) {
        return this.eT.forEach((t, s) => e(s)), Qe.resolve();
    }
    bh(t) {
        return Qe.resolve(this.lastRemoteSnapshotVersion);
    }
    Dd(t) {
        return Qe.resolve(this.sT);
    }
    Qh(t) {
        return this.highestTargetId = this.iT.next(), Qe.resolve(this.highestTargetId);
    }
    $h(t, e, s) {
        return s && (this.lastRemoteSnapshotVersion = s), e > this.sT && (this.sT = e), 
        Qe.resolve();
    }
    Cd(t) {
        this.eT.set(t.target, t);
        const e = t.targetId;
        e > this.highestTargetId && (this.iT = new wn(e), this.highestTargetId = e), t.sequenceNumber > this.sT && (this.sT = t.sequenceNumber);
    }
    Wh(t, e) {
        return this.Cd(e), this.targetCount += 1, Qe.resolve();
    }
    Nh(t, e) {
        return this.Cd(e), Qe.resolve();
    }
    Nd(t, e) {
        return this.eT.delete(e.target), this.nT.Ni(e.targetId), this.targetCount -= 1, 
        Qe.resolve();
    }
    xo(t, e, s) {
        let n = 0;
        const i = [];
        return this.eT.forEach((r, o) => {
            o.sequenceNumber <= e && null === s.get(o.targetId) && (this.eT.delete(r), i.push(this.Fd(t, o.targetId)), 
            n++);
        }), Qe.Ki(i).next(() => n);
    }
    Ld(t) {
        return Qe.resolve(this.targetCount);
    }
    qh(t, e) {
        const s = this.eT.get(e) || null;
        return Qe.resolve(s);
    }
    un(t, e) {
        // This method is only needed for multi-tab and we can't implement it
        // efficiently without additional data structures.
        return De("Not yet implemented.");
    }
    Dh(t, e, s) {
        this.nT.Si(e, s);
        const n = this.persistence.Jo, i = [];
        return n && e.forEach(e => {
            i.push(n.vi(t, e));
        }), Qe.Ki(i);
    }
    Sh(t, e, s) {
        this.nT.ki(e, s);
        const n = this.persistence.Jo, i = [];
        return n && e.forEach(e => {
            i.push(n.Di(t, e));
        }), Qe.Ki(i);
    }
    Fd(t, e) {
        return this.nT.Ni(e), Qe.resolve();
    }
    Gh(t, e) {
        const s = this.nT.$i(e);
        return Qe.resolve(s);
    }
    Mi(t, e) {
        return Qe.resolve(this.nT.Mi(e));
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A memory-backed instance of Persistence. Data is stored only in RAM and
 * not persisted across sessions.
 */
class Mi {
    /**
     * The constructor accepts a factory for creating a reference delegate. This
     * allows both the delegate and this instance to have strong references to
     * each other without having nullable fields that would then need to be
     * checked or asserted on every access.
     */
    constructor(t, e) {
        this.clientId = t, this.rT = {}, this.Vf = new He(0), this.hf = !1, this.hf = !0, 
        this.Jo = e(this), this.th = new $i(this);
        this.ur = new ni, this.hr = new Fi(this.ur, t => this.Jo.oT(t));
    }
    start() {
        return Promise.resolve();
    }
    lc() {
        // No durable state to ensure is closed on shutdown.
        return this.hf = !1, Promise.resolve();
    }
    get ko() {
        return this.hf;
    }
    async Jh() {
        return [ this.clientId ];
    }
    gf(t) {
        // All clients using memory persistence act as primary.
        return t(!0);
    }
    pf() {
        // No op.
    }
    Zh(t) {
        // No op.
    }
    nh() {
        return this.ur;
    }
    Yo(t) {
        let e = this.rT[t.s()];
        return e || (e = new Ni(this.ur, this.Jo), this.rT[t.s()] = e), e;
    }
    eh() {
        return this.th;
    }
    Zo() {
        return this.hr;
    }
    runTransaction(t, e, s) {
        be("MemoryPersistence", "Starting transaction:", t);
        const n = new Li(this.Vf.next());
        return this.Jo.hT(), s(n).next(t => this.Jo.aT(n).next(() => t)).Wi().then(t => (n.or(), 
        t));
    }
    uT(t, e) {
        return Qe.Gi(Object.values(this.rT).map(s => () => s.Mi(t, e)));
    }
}

/**
 * Memory persistence is not actually transactional, but future implementations
 * may have transaction-scoped state.
 */ class Li extends Ke {
    constructor(t) {
        super(), this.Ch = t;
    }
}

class Oi {
    constructor(t) {
        this.persistence = t, this.Qf = null, this.cT = null;
    }
    static _T(t) {
        return new Oi(t);
    }
    get lT() {
        if (this.cT) return this.cT;
        throw De("orphanedDocuments is only valid during a transaction.");
    }
    Ho(t) {
        this.Qf = t;
    }
    vi(t, e) {
        return this.lT.delete(e), Qe.resolve();
    }
    Di(t, e) {
        return this.lT.add(e), Qe.resolve();
    }
    bd(t, e) {
        return this.lT.add(e), Qe.resolve();
    }
    removeTarget(t, e) {
        const s = this.persistence.eh();
        return s.Gh(t, e.targetId).next(t => {
            t.forEach(t => this.lT.add(t));
        }).next(() => s.Nd(t, e));
    }
    hT() {
        this.cT = new Set;
    }
    aT(t) {
        // Remove newly orphaned documents.
        const e = this.persistence.Zo().Eh();
        return Qe.forEach(this.lT, s => this.dT(t, s).next(t => {
            t || e.Zi(s);
        })).next(() => (this.cT = null, e.apply(t)));
    }
    Fh(t, e) {
        return this.dT(t, e).next(t => {
            t ? this.lT.delete(e) : this.lT.add(e);
        });
    }
    oT(t) {
        // For eager GC, we don't care about the document size, there are no size thresholds.
        return 0;
    }
    dT(t, e) {
        return Qe.Gi([ () => this.persistence.eh().Mi(t, e), () => this.persistence.uT(t, e), () => Qe.resolve(this.Qf.Mi(e)) ]);
    }
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides all components needed for Firestore with in-memory persistence.
 * Uses EagerGC garbage collection.
 */
class xi {
    async initialize(t) {
        this.X_ = this.fT(t), this.persistence = this.TT(t), await this.persistence.start(), 
        this.mT = this.ET(t), this.Wu = this.wT(t), this.W_ = this.IT(t), this.mc = this.RT(t), 
        this.AT = this.PT(t), this.X_.$u = t => this.mc.B_(t, 1 /* SharedClientState */), 
        this.W_.mc = this.mc, this.X_.mc = this.mc, await this.X_.start(), await this.W_.start(), 
        await this.Wu.start(), 
        // NOTE: This will immediately call the listener, so we make sure to
        // set it after localStore / remoteStore are started.
        await this.persistence.gf(async t => {
            await this.mc.Cc(t), this.mT && (t && !this.mT.ko ? this.mT.start(this.Wu) : t || this.mT.stop());
        });
    }
    PT(t) {
        return new bn(this.mc);
    }
    ET(t) {
        return null;
    }
    wT(t) {
        return new rs(this.persistence, new Sn, t.VT);
    }
    TT(t) {
        return new Mi(t.clientId, Oi._T);
    }
    IT(t) {
        return new hn(this.Wu, t.bu, t.Nr, t => this.mc.B_(t, 0 /* RemoteStore */), t.platform.gT());
    }
    fT(t) {
        return new En;
    }
    RT(t) {
        return new pn(this.Wu, this.W_, this.X_, t.VT, t.Z_);
    }
    clearPersistence(t) {
        throw new I(w.FAILED_PRECONDITION, "You are using the memory-only build of Firestore. Persistence support is only available via the @firebase/firestore bundle or the firebase-firestore.js build.");
    }
}

/**
 * Provides all components needed for Firestore with IndexedDB persistence.
 */ class Bi extends xi {
    ET(t) {
        const e = this.persistence.Jo.bo;
        return new ns(e, t.Nr);
    }
    TT(t) {
        const e = vi.qf(t.pT), s = t.platform.yT(t.pT.cn);
        return vi.mf({
            allowTabSynchronization: t.bT.synchronizeTabs,
            persistenceKey: e,
            clientId: t.clientId,
            platform: t.platform,
            $a: t.Nr,
            serializer: s,
            Ef: ss.Io(t.bT.cacheSizeBytes),
            rf: this.X_
        });
    }
    fT(t) {
        if (t.bT.synchronizeTabs) {
            if (!mn.Uc(t.platform)) throw new I(w.UNIMPLEMENTED, "IndexedDB persistence is only available on platforms that support LocalStorage.");
            const e = vi.qf(t.pT);
            return new mn(t.Nr, t.platform, e, t.clientId, t.VT);
        }
        return new En;
    }
    clearPersistence(t) {
        const e = vi.qf(t);
        return vi.clearPersistence(e);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * FirestoreClient is a top-level class that constructs and owns all of the
 * pieces of the client SDK architecture. It is responsible for creating the
 * async queue that is shared by all of the other components in the system.
 */
class Ui {
    constructor(t, e, s, 
    /**
     * Asynchronous queue responsible for all of our internal processing. When
     * we get incoming work from the user (via public API) or the network
     * (incoming GRPC messages), we should always schedule onto this queue.
     * This ensures all of our work is properly serialized (e.g. we don't
     * start processing a new operation while the previous one is waiting for
     * an async I/O to complete).
     */
    n) {
        this.platform = t, this.pT = e, this.credentials = s, this.Nr = n, this.clientId = ke.mi();
    }
    /**
     * Starts up the FirestoreClient, returning only whether or not enabling
     * persistence succeeded.
     *
     * The intent here is to "do the right thing" as far as users are concerned.
     * Namely, in cases where offline persistence is requested and possible,
     * enable it, but otherwise fall back to persistence disabled. For the most
     * part we expect this to succeed one way or the other so we don't expect our
     * users to actually wait on the firestore.enablePersistence Promise since
     * they generally won't care.
     *
     * Of course some users actually do care about whether or not persistence
     * was successfully enabled, so the Promise returned from this method
     * indicates this outcome.
     *
     * This presents a problem though: even before enablePersistence resolves or
     * rejects, users may have made calls to e.g. firestore.collection() which
     * means that the FirestoreClient in there will be available and will be
     * enqueuing actions on the async queue.
     *
     * Meanwhile any failure of an operation on the async queue causes it to
     * panic and reject any further work, on the premise that unhandled errors
     * are fatal.
     *
     * Consequently the fallback is handled internally here in start, and if the
     * fallback succeeds we signal success to the async queue even though the
     * start() itself signals failure.
     *
     * @param componentProvider Provider that returns all core components.
     * @param persistenceSettings Settings object to configure offline
     *     persistence.
     * @returns A deferred result indicating the user-visible result of enabling
     *     offline persistence. This method will reject this if IndexedDB fails to
     *     start for any reason. If usePersistence is false this is
     *     unconditionally resolved.
     */    start(t, e) {
        this.vT();
        // We defer our initialization until we get the current user from
        // setChangeListener(). We block the async queue until we got the initial
        // user and the initialization is completed. This will prevent any scheduled
        // work from happening before initialization is completed.
        // If initializationDone resolved then the FirestoreClient is in a usable
        // state.
        const s = new Je, n = new Je;
        // If usePersistence is true, certain classes of errors while starting are
        // recoverable but only by falling back to persistence disabled.
        
        // If there's an error in the first case but not in recovery we cannot
        // reject the promise blocking the async queue because this will cause the
        // async queue to panic.
                let i = !1;
        // Return only the result of enabling persistence. Note that this does not
        // need to await the completion of initializationDone because the result of
        // this method should not reflect any other kind of failure to start.
        return this.credentials.l(r => {
            if (!i) return i = !0, be("FirestoreClient", "Initializing. user=", r.uid), this.ST(t, e, r, n).then(s.resolve, s.reject);
            this.Nr.qr(() => this.Dc(r));
        }), 
        // Block the async queue until initialization is done
        this.Nr.qr(() => s.promise), n.promise;
    }
    /** Enables the network connection and requeues all pending operations. */    enableNetwork() {
        return this.vT(), this.Nr.enqueue(() => this.mc.enableNetwork());
    }
    /**
     * Initializes persistent storage, attempting to use IndexedDB if
     * usePersistence is true or memory-only if false.
     *
     * If IndexedDB fails because it's already open in another tab or because the
     * platform can't possibly support our implementation then this method rejects
     * the persistenceResult and falls back on memory-only persistence.
     *
     * @param componentProvider The provider that provides all core componennts
     *     for IndexedDB or memory-backed persistence
     * @param persistenceSettings Settings object to configure offline persistence
     * @param user The initial user
     * @param persistenceResult A deferred result indicating the user-visible
     *     result of enabling offline persistence. This method will reject this if
     *     IndexedDB fails to start for any reason. If usePersistence is false
     *     this is unconditionally resolved.
     * @returns a Promise indicating whether or not initialization should
     *     continue, i.e. that one of the persistence implementations actually
     *     succeeded.
     */    async ST(t, e, s, n) {
        try {
            // TODO(mrschmidt): Ideally, ComponentProvider would also initialize
            // Datastore (without duplicating the initializing logic once per
            // provider).
            const i = await this.platform.DT(this.pT), r = this.platform.yT(this.pT.cn), o = new nn(this.Nr, i, this.credentials, r);
            await t.initialize({
                Nr: this.Nr,
                pT: this.pT,
                platform: this.platform,
                bu: o,
                clientId: this.clientId,
                VT: s,
                Z_: 100,
                bT: e
            }), this.persistence = t.persistence, this.X_ = t.X_, this.Wu = t.Wu, this.W_ = t.W_, 
            this.mc = t.mc, this.mT = t.mT, this.CT = t.AT, 
            // When a user calls clearPersistence() in one client, all other clients
            // need to be terminated to allow the delete to succeed.
            this.persistence.pf(async () => {
                await this.terminate();
            }), n.resolve();
        } catch (t) {
            // An unknown failure on the first stage shuts everything down.
            if (
            // Regardless of whether or not the retry succeeds, from an user
            // perspective, offline persistence has failed.
            n.reject(t), !this.kT(t)) throw t;
            return console.warn("Error enabling offline persistence. Falling back to persistence disabled: " + t), 
            this.ST(new xi, {
                NT: !1
            }, s, n);
        }
    }
    /**
     * Decides whether the provided error allows us to gracefully disable
     * persistence (as opposed to crashing the client).
     */    kT(t) {
        return "FirebaseError" === t.name ? t.code === w.FAILED_PRECONDITION || t.code === w.UNIMPLEMENTED : !("undefined" != typeof DOMException && t instanceof DOMException) || (
        // When the browser is out of quota we could get either quota exceeded
        // or an aborted error depending on whether the error happened during
        // schema migration.
        22 === t.code || 20 === t.code || 
        // Firefox Private Browsing mode disables IndexedDb and returns
        // INVALID_STATE for any usage.
        11 === t.code);
    }
    /**
     * Checks that the client has not been terminated. Ensures that other methods on
     * this class cannot be called after the client is terminated.
     */    vT() {
        if (this.Nr.Hr) throw new I(w.FAILED_PRECONDITION, "The client has already been terminated.");
    }
    Dc(t) {
        return this.Nr.no(), be("FirestoreClient", "Credential Changed. Current user: " + t.uid), 
        this.mc.Dc(t);
    }
    /** Disables the network connection. Pending operations will not complete. */    disableNetwork() {
        return this.vT(), this.Nr.enqueue(() => this.mc.disableNetwork());
    }
    terminate() {
        return this.Nr.to(async () => {
            // PORTING NOTE: LocalStore does not need an explicit shutdown on web.
            this.mT && this.mT.stop(), await this.W_.lc(), await this.X_.lc(), await this.persistence.lc(), 
            // `removeChangeListener` must be called after shutting down the
            // RemoteStore as it will prevent the RemoteStore from retrieving
            // auth tokens.
            this.credentials.T();
        });
    }
    /**
     * Returns a Promise that resolves when all writes that were pending at the time this
     * method was called received server acknowledgement. An acknowledgement can be either acceptance
     * or rejection.
     */    waitForPendingWrites() {
        this.vT();
        const t = new Je;
        return this.Nr.qr(() => this.mc.Pl(t)), t.promise;
    }
    listen(t, e, s) {
        this.vT();
        const n = new vn(t, e, s);
        return this.Nr.qr(() => this.CT.listen(n)), n;
    }
    fc(t) {
        // Checks for termination but does not raise error, allowing unlisten after
        // termination to be a no-op.
        this.FT || this.Nr.qr(() => this.CT.fc(t));
    }
    $T(t) {
        return this.vT(), this.Nr.enqueue(() => this.Wu.Bh(t)).then(t => {
            if (t instanceof bt) return t;
            if (t instanceof vt) return null;
            throw new I(w.UNAVAILABLE, "Failed to get document from cache. (However, this document may exist on the server. Run again without setting 'source' in the GetOptions to attempt to retrieve the document from the server.)");
        });
    }
    MT(t) {
        return this.vT(), this.Nr.enqueue(async () => {
            const e = await this.Wu.Kh(t, 
            /* usePreviousResults= */ !0), s = new An(t, e.zh), n = s.k_(e.documents);
            return s.nr(n, 
            /* updateLimboDocuments= */ !1).snapshot;
        });
    }
    write(t) {
        this.vT();
        const e = new Je;
        return this.Nr.qr(() => this.mc.write(t, e)), e.promise;
    }
    cn() {
        return this.pT.cn;
    }
    Ol(t) {
        this.vT(), this.Nr.qr(() => (this.CT.Ol(t), Promise.resolve()));
    }
    xl(t) {
        // Checks for shutdown but does not raise error, allowing remove after
        // shutdown to be a no-op.
        this.FT || this.CT.xl(t);
    }
    get FT() {
        // Technically, the asyncQueue is still running, but only accepting operations
        // related to termination or supposed to be run after termination. It is effectively
        // terminated to the eyes of users.
        return this.Nr.Hr;
    }
    transaction(t) {
        this.vT();
        const e = new Je;
        return this.Nr.qr(() => (this.mc.runTransaction(this.Nr, t, e), Promise.resolve())), 
        e.promise;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * A wrapper implementation of Observer<T> that will dispatch events
 * asynchronously. To allow immediate silencing, a mute call is added which
 * causes events scheduled to no longer be raised.
 */ class qi {
    constructor(t) {
        this.observer = t, 
        /**
         * When set to true, will not raise future events. Necessary to deal with
         * async detachment of listener.
         */
        this.muted = !1;
    }
    next(t) {
        this.LT(this.observer.next, t);
    }
    error(t) {
        this.LT(this.observer.error, t);
    }
    OT() {
        this.muted = !0;
    }
    LT(t, e) {
        this.muted || setTimeout(() => {
            this.muted || t(e);
        }, 0);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function Qi(t) {
    /**
 * Returns true if obj is an object and contains at least one of the specified
 * methods.
 */
    return function(t, e) {
        if ("object" != typeof t || null === t) return !1;
        const s = t;
        for (const t of e) if (t in s && "function" == typeof s[t]) return !0;
        return !1;
    }
    /**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
    /**
 * Converts Firestore's internal types to the JavaScript types that we expose
 * to the user.
 */ (t, [ "next", "error", "complete" ]);
}

class Wi {
    constructor(t, e, s, n) {
        this.firestore = t, this.timestampsInSnapshots = e, this.xT = s, this.converter = n;
    }
    BT(t) {
        switch (G(t)) {
          case 0 /* NullValue */ :
            return null;

          case 1 /* BooleanValue */ :
            return t.booleanValue;

          case 2 /* NumberValue */ :
            return et(t.integerValue || t.doubleValue);

          case 3 /* TimestampValue */ :
            return this.UT(t.timestampValue);

          case 4 /* ServerTimestampValue */ :
            return this.qT(t);

          case 5 /* StringValue */ :
            return t.stringValue;

          case 6 /* BlobValue */ :
            return new Ss(st(t.bytesValue));

          case 7 /* RefValue */ :
            return this.QT(t.referenceValue);

          case 8 /* GeoPointValue */ :
            return new Bs(t.geoPointValue.latitude, t.geoPointValue.longitude);

          case 9 /* ArrayValue */ :
            return this.WT(t.arrayValue);

          case 10 /* ObjectValue */ :
            return this.jT(t.mapValue);

          default:
            throw De("Invalid value type: " + JSON.stringify(t));
        }
    }
    jT(t) {
        const e = {};
        return O(t.fields || {}, (t, s) => {
            e[t] = this.BT(s);
        }), e;
    }
    WT(t) {
        return (t.values || []).map(t => this.BT(t));
    }
    qT(t) {
        switch (this.xT) {
          case "previous":
            const e = function t(e) {
                const s = e.mapValue.fields.__previous_value__;
                return W(s) ? t(s) : s;
            }(t);
            return null == e ? null : this.BT(e);

          case "estimate":
            return this.UT(j(t));

          default:
            return null;
        }
    }
    UT(t) {
        const e = tt(t), s = new p(e.seconds, e.nanos);
        return this.timestampsInSnapshots ? s : s.toDate();
    }
    QT(t) {
        const e = v.G(t);
        Ce(Pe(e), "ReferenceValue is not valid " + t);
        const s = new Le(e.get(1), e.get(3)), n = new C(e.M(5));
        return s.isEqual(this.firestore.KT) || 
        // TODO(b/64130202): Somehow support foreign references.
        ve(`Document ${n} contains a document ` + "reference within a different database (" + `${s.projectId}/${s.database}) which is not ` + "supported. It will be treated as a reference in the current " + `database (${this.firestore.KT.projectId}/${this.firestore.KT.database}) ` + "instead."), 
        new Ji(n, this.firestore, this.converter);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// settings() defaults:
const ji = ss.Po;

/**
 * A concrete type describing all the values that can be applied via a
 * user-supplied firestore.Settings object. This is a separate type so that
 * defaults can be supplied and the value can be checked for equality.
 */
class Ki {
    constructor(t) {
        var e, s;
        if (void 0 === t.host) {
            if (void 0 !== t.ssl) throw new I(w.INVALID_ARGUMENT, "Can't provide ssl option if host option is not set");
            this.host = "firestore.googleapis.com", this.ssl = !0;
        } else ds("settings", "non-empty string", "host", t.host), this.host = t.host, fs("settings", "boolean", "ssl", t.ssl), 
        this.ssl = null === (e = t.ssl) || void 0 === e || e;
        if (As("settings", t, [ "host", "ssl", "credentials", "timestampsInSnapshots", "cacheSizeBytes", "experimentalForceLongPolling" ]), 
        fs("settings", "object", "credentials", t.credentials), this.credentials = t.credentials, 
        fs("settings", "boolean", "timestampsInSnapshots", t.timestampsInSnapshots), 
        // Nobody should set timestampsInSnapshots anymore, but the error depends on
        // whether they set it to true or false...
        !0 === t.timestampsInSnapshots ? ve("The setting 'timestampsInSnapshots: true' is no longer required and should be removed.") : !1 === t.timestampsInSnapshots && ve("Support for 'timestampsInSnapshots: false' will be removed soon. You must update your code to handle Timestamp objects."), 
        this.timestampsInSnapshots = null === (s = t.timestampsInSnapshots) || void 0 === s || s, 
        fs("settings", "number", "cacheSizeBytes", t.cacheSizeBytes), void 0 === t.cacheSizeBytes) this.cacheSizeBytes = ss.po; else {
            if (t.cacheSizeBytes !== ji && t.cacheSizeBytes < ss.Vo) throw new I(w.INVALID_ARGUMENT, `cacheSizeBytes must be at least ${ss.Vo}`);
            this.cacheSizeBytes = t.cacheSizeBytes;
        }
        fs("settings", "boolean", "experimentalForceLongPolling", t.experimentalForceLongPolling), 
        this.forceLongPolling = void 0 !== t.experimentalForceLongPolling && t.experimentalForceLongPolling;
    }
    isEqual(t) {
        return this.host === t.host && this.ssl === t.ssl && this.timestampsInSnapshots === t.timestampsInSnapshots && this.credentials === t.credentials && this.cacheSizeBytes === t.cacheSizeBytes && this.forceLongPolling === t.forceLongPolling;
    }
}

/**
 * The root reference to the database.
 */ class Gi {
    // Note: We are using `MemoryComponentProvider` as a default
    // ComponentProvider to ensure backwards compatibility with the format
    // expected by the console build.
    constructor(t, e, s = new xi) {
        if (this.GT = null, 
        // Public for use in tests.
        // TODO(mikelehen): Use modularized initialization instead.
        this.zT = new Xe, this.INTERNAL = {
            delete: async () => {
                // The client must be initalized to ensure that all subsequent API usage
                // throws an exception.
                this.HT(), await this.JT.terminate();
            }
        }, "object" == typeof t.options) {
            // This is very likely a Firebase app object
            // TODO(b/34177605): Can we somehow use instanceof?
            const s = t;
            this.GT = s, this.KT = Gi.YT(s), this.XT = s.name, this.ZT = new P(e);
        } else {
            const e = t;
            if (!e.projectId) throw new I(w.INVALID_ARGUMENT, "Must provide projectId");
            this.KT = new Le(e.projectId, e.database), 
            // Use a default persistenceKey that lines up with FirebaseApp.
            this.XT = "[DEFAULT]", this.ZT = new A;
        }
        this.tm = s, this.em = new Ki({}), this.sm = this.nm(this.KT);
    }
    settings(t) {
        as("Firestore.settings", arguments, 1), _s("Firestore.settings", "object", 1, t);
        const e = new Ki(t);
        if (this.JT && !this.em.isEqual(e)) throw new I(w.FAILED_PRECONDITION, "Firestore has already been started and its settings can no longer be changed. You can only call settings() before calling any other methods on a Firestore object.");
        this.em = e, void 0 !== e.credentials && (this.ZT = function(t) {
            if (!t) return new A;
            switch (t.type) {
              case "gapi":
                const e = t.im;
                // Make sure this really is a Gapi client.
                                return Ce(!("object" != typeof e || null === e || !e.auth || !e.auth.getAuthHeaderValueForFirstParty), "unexpected gapi interface"), 
                new g(e, t.V || "0");

              case "provider":
                return t.im;

              default:
                throw new I(w.INVALID_ARGUMENT, "makeCredentialsProvider failed due to invalid credential type");
            }
        }
        /**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
        // The earlist date supported by Firestore timestamps (0001-01-01T00:00:00Z).
        (e.credentials));
    }
    enableNetwork() {
        return this.HT(), this.JT.enableNetwork();
    }
    disableNetwork() {
        return this.HT(), this.JT.disableNetwork();
    }
    enablePersistence(t) {
        var e, s;
        if (this.JT) throw new I(w.FAILED_PRECONDITION, "Firestore has already been started and persistence can no longer be enabled. You can only call enablePersistence() before calling any other methods on a Firestore object.");
        let n = !1;
        return t && (void 0 !== t.experimentalTabSynchronization && ve("The 'experimentalTabSynchronization' setting will be removed. Use 'synchronizeTabs' instead."), 
        n = null !== (s = null !== (e = t.synchronizeTabs) && void 0 !== e ? e : t.experimentalTabSynchronization) && void 0 !== s && s), 
        this.rm(this.tm, {
            NT: !0,
            cacheSizeBytes: this.em.cacheSizeBytes,
            synchronizeTabs: n
        });
    }
    async clearPersistence() {
        if (void 0 !== this.JT && !this.JT.FT) throw new I(w.FAILED_PRECONDITION, "Persistence cannot be cleared after this Firestore instance is initialized.");
        const t = new Je;
        return this.zT.Jr(async () => {
            try {
                const e = this.om();
                await this.tm.clearPersistence(e), t.resolve();
            } catch (e) {
                t.reject(e);
            }
        }), t.promise;
    }
    terminate() {
        return this.app._removeServiceInstance("firestore"), this.INTERNAL.delete();
    }
    get hm() {
        return this.HT(), this.JT.FT;
    }
    waitForPendingWrites() {
        return this.HT(), this.JT.waitForPendingWrites();
    }
    onSnapshotsInSync(t) {
        if (this.HT(), Qi(t)) return this.am(t);
        {
            _s("Firestore.onSnapshotsInSync", "function", 1, t);
            const e = {
                next: t
            };
            return this.am(e);
        }
    }
    am(t) {
        const e = new qi({
            next: () => {
                t.next && t.next();
            },
            error: t => {
                throw De("Uncaught Error in onSnapshotsInSync");
            }
        });
        return this.JT.Ol(e), () => {
            e.OT(), this.JT.xl(e);
        };
    }
    HT() {
        return this.JT || 
        // Kick off starting the client but don't actually wait for it.
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.rm(new xi, {
            NT: !1
        }), this.JT;
    }
    om() {
        return new Me(this.KT, this.XT, this.em.host, this.em.ssl, this.em.forceLongPolling);
    }
    rm(t, e) {
        const s = this.om();
        return this.JT = new Ui(Ve.Lt(), s, this.ZT, this.zT), this.JT.start(t, e);
    }
    nm(t) {
        const e = new Ae(t, {
            dn: Ve.Lt().dn
        });
        return new Gs(e, e => {
            if (e instanceof Ji) {
                const s = t, n = e.firestore.KT;
                if (!n.isEqual(s)) throw new I(w.INVALID_ARGUMENT, "Document reference is for database " + `${n.projectId}/${n.database} but should be ` + `for database ${s.projectId}/${s.database}`);
                return new Ks(t, e.um);
            }
            return e;
        });
    }
    static YT(t) {
        if (e = t.options, s = "projectId", !Object.prototype.hasOwnProperty.call(e, s)) throw new I(w.INVALID_ARGUMENT, '"projectId" not provided in firebase.initializeApp.');
        var e, s;
        // Export the classes with a private constructor (it will fail if invoked
        // at runtime). Note that this still allows instanceof checks.
        // We're treating the variables as class names, so disable checking for lower
        // case variable names.
                const n = t.options.projectId;
        if (!n || "string" != typeof n) throw new I(w.INVALID_ARGUMENT, "projectId must be a string in FirebaseApp.options");
        return new Le(n);
    }
    get app() {
        if (!this.GT) throw new I(w.FAILED_PRECONDITION, "Firestore was not initialized using the Firebase SDK. 'app' is not available");
        return this.GT;
    }
    collection(t) {
        return as("Firestore.collection", arguments, 1), _s("Firestore.collection", "non-empty string", 1, t), 
        this.HT(), new sr(v.G(t), this);
    }
    doc(t) {
        return as("Firestore.doc", arguments, 1), _s("Firestore.doc", "non-empty string", 1, t), 
        this.HT(), Ji.cm(v.G(t), this);
    }
    collectionGroup(t) {
        if (as("Firestore.collectionGroup", arguments, 1), _s("Firestore.collectionGroup", "non-empty string", 1, t), 
        t.indexOf("/") >= 0) throw new I(w.INVALID_ARGUMENT, `Invalid collection ID '${t}' passed to function ` + "Firestore.collectionGroup(). Collection IDs must not contain '/'.");
        return this.HT(), new tr(new Ct(v.H, t), this);
    }
    runTransaction(t) {
        return as("Firestore.runTransaction", arguments, 1), _s("Firestore.runTransaction", "function", 1, t), 
        this.HT().transaction(e => t(new zi(this, e)));
    }
    batch() {
        return this.HT(), new Hi(this);
    }
    static get logLevel() {
        switch (pe()) {
          case s.DEBUG:
            return "debug";

          case s.SILENT:
            return "silent";

          default:
            // The default log level is error
            return "error";
        }
    }
    static setLogLevel(t) {
        switch (as("Firestore.setLogLevel", arguments, 1), _s("Firestore.setLogLevel", "non-empty string", 1, t), 
        t) {
          case "debug":
            ye(s.DEBUG);
            break;

          case "error":
            ye(s.ERROR);
            break;

          case "silent":
            ye(s.SILENT);
            break;

          default:
            throw new I(w.INVALID_ARGUMENT, "Invalid log level: " + t);
        }
    }
    // Note: this is not a property because the minifier can't work correctly with
    // the way TypeScript compiler outputs properties.
    _m() {
        return this.em.timestampsInSnapshots;
    }
}

/**
 * A reference to a transaction.
 */ class zi {
    constructor(t, e) {
        this.lm = t, this.dm = e;
    }
    get(t) {
        as("Transaction.get", arguments, 1);
        const e = or("Transaction.get", t, this.lm);
        return this.dm.pu([ e.um ]).then(t => {
            if (!t || 1 !== t.length) return De("Mismatch in docs returned from document lookup.");
            const s = t[0];
            if (s instanceof vt) return new Xi(this.lm, e.um, null, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.fm);
            if (s instanceof bt) return new Xi(this.lm, e.um, s, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.fm);
            throw De(`BatchGetDocumentsRequest returned unexpected document type: ${s.constructor.name}`);
        });
    }
    set(t, e, s) {
        cs("Transaction.set", arguments, 2, 3);
        const n = or("Transaction.set", t, this.lm);
        s = nr("Transaction.set", s);
        const [i, r] = ar(n.fm, e, "Transaction.set"), o = s.merge || s.mergeFields ? this.lm.sm.pa(r, i, s.mergeFields) : this.lm.sm.Va(r, i);
        return this.dm.set(n.um, o), this;
    }
    update(t, e, s, ...n) {
        let i, r;
        return "string" == typeof e || e instanceof Cs ? (us("Transaction.update", arguments, 3), 
        i = or("Transaction.update", t, this.lm), r = this.lm.sm.Sa("Transaction.update", e, s, n)) : (as("Transaction.update", arguments, 2), 
        i = or("Transaction.update", t, this.lm), r = this.lm.sm.ya("Transaction.update", e)), 
        this.dm.update(i.um, r), this;
    }
    delete(t) {
        as("Transaction.delete", arguments, 1);
        const e = or("Transaction.delete", t, this.lm);
        return this.dm.delete(e.um), this;
    }
}

class Hi {
    constructor(t) {
        this.lm = t, this.Tm = [], this.mm = !1;
    }
    set(t, e, s) {
        cs("WriteBatch.set", arguments, 2, 3), this.Em();
        const n = or("WriteBatch.set", t, this.lm);
        s = nr("WriteBatch.set", s);
        const [i, r] = ar(n.fm, e, "WriteBatch.set"), o = s.merge || s.mergeFields ? this.lm.sm.pa(r, i, s.mergeFields) : this.lm.sm.Va(r, i);
        return this.Tm = this.Tm.concat(o.da(n.um, Et.NONE)), this;
    }
    update(t, e, s, ...n) {
        let i, r;
        return this.Em(), "string" == typeof e || e instanceof Cs ? (us("WriteBatch.update", arguments, 3), 
        i = or("WriteBatch.update", t, this.lm), r = this.lm.sm.Sa("WriteBatch.update", e, s, n)) : (as("WriteBatch.update", arguments, 2), 
        i = or("WriteBatch.update", t, this.lm), r = this.lm.sm.ya("WriteBatch.update", e)), 
        this.Tm = this.Tm.concat(r.da(i.um, Et.exists(!0))), this;
    }
    delete(t) {
        as("WriteBatch.delete", arguments, 1), this.Em();
        const e = or("WriteBatch.delete", t, this.lm);
        return this.Tm = this.Tm.concat(new Pt(e.um, Et.NONE)), this;
    }
    commit() {
        return this.Em(), this.mm = !0, this.Tm.length > 0 ? this.lm.HT().write(this.Tm) : Promise.resolve();
    }
    Em() {
        if (this.mm) throw new I(w.FAILED_PRECONDITION, "A write batch can no longer be used after commit() has been called.");
    }
}

/**
 * A reference to a particular document in a collection in the database.
 */ class Ji {
    constructor(t, e, s) {
        this.um = t, this.firestore = e, this.fm = s, this.JT = this.firestore.HT();
    }
    static cm(t, e, s) {
        if (t.length % 2 != 0) throw new I(w.INVALID_ARGUMENT, "Invalid document reference. Document references must have an even number of segments, but " + `${t.K()} has ${t.length}`);
        return new Ji(new C(t), e, s);
    }
    get id() {
        return this.um.path.B();
    }
    get parent() {
        return new sr(this.um.path.L(), this.firestore, this.fm);
    }
    get path() {
        return this.um.path.K();
    }
    collection(t) {
        if (as("DocumentReference.collection", arguments, 1), _s("DocumentReference.collection", "non-empty string", 1, t), 
        !t) throw new I(w.INVALID_ARGUMENT, "Must provide a non-empty collection name to collection()");
        const e = v.G(t);
        return new sr(this.um.path.child(e), this.firestore);
    }
    isEqual(t) {
        if (!(t instanceof Ji)) throw Ps("isEqual", "DocumentReference", 1, t);
        return this.firestore === t.firestore && this.um.isEqual(t.um) && this.fm === t.fm;
    }
    set(t, e) {
        cs("DocumentReference.set", arguments, 1, 2), e = nr("DocumentReference.set", e);
        const [s, n] = ar(this.fm, t, "DocumentReference.set"), i = e.merge || e.mergeFields ? this.firestore.sm.pa(n, s, e.mergeFields) : this.firestore.sm.Va(n, s);
        return this.JT.write(i.da(this.um, Et.NONE));
    }
    update(t, e, ...s) {
        let n;
        return "string" == typeof t || t instanceof Cs ? (us("DocumentReference.update", arguments, 2), 
        n = this.firestore.sm.Sa("DocumentReference.update", t, e, s)) : (as("DocumentReference.update", arguments, 1), 
        n = this.firestore.sm.ya("DocumentReference.update", t)), this.JT.write(n.da(this.um, Et.exists(!0)));
    }
    delete() {
        return as("DocumentReference.delete", arguments, 0), this.JT.write([ new Pt(this.um, Et.NONE) ]);
    }
    onSnapshot(...t) {
        cs("DocumentReference.onSnapshot", arguments, 1, 4);
        let e, s = {
            includeMetadataChanges: !1
        }, n = 0;
        "object" != typeof t[n] || Qi(t[n]) || (s = t[n], As("DocumentReference.onSnapshot", s, [ "includeMetadataChanges" ]), 
        fs("DocumentReference.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        n++);
        const i = {
            includeMetadataChanges: s.includeMetadataChanges
        };
        return Qi(t[n]) ? e = t[n] : (_s("DocumentReference.onSnapshot", "function", n, t[n]), 
        ls("DocumentReference.onSnapshot", "function", n + 1, t[n + 1]), ls("DocumentReference.onSnapshot", "function", n + 2, t[n + 2]), 
        e = {
            next: t[n],
            error: t[n + 1],
            complete: t[n + 2]
        }), this.wm(i, e);
    }
    wm(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const n = new qi({
            next: t => {
                if (e.next) {
                    const s = t.docs.get(this.um);
                    e.next(new Xi(this.firestore, this.um, s, t.fromCache, t.hasPendingWrites, this.fm));
                }
            },
            error: s
        }), i = this.JT.listen(Ct.ve(this.um.path), n, t);
        return () => {
            n.OT(), this.JT.fc(i);
        };
    }
    get(t) {
        return cs("DocumentReference.get", arguments, 0, 1), rr("DocumentReference.get", t), 
        new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.HT().$T(this.um).then(t => {
                e(new Xi(this.firestore, this.um, t, 
                /*fromCache=*/ !0, t instanceof bt && t.te, this.fm));
            }, s) : this.Im(e, s, t);
        });
    }
    Im(t, e, s) {
        const n = this.wm({
            includeMetadataChanges: !0,
            Kl: !0
        }, {
            next: i => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                n(), !i.exists && i.metadata.fromCache ? 
                // TODO(dimond): If we're online and the document doesn't
                // exist then we resolve with a doc.exists set to false. If
                // we're offline however, we reject the Promise in this
                // case. Two options: 1) Cache the negative response from
                // the server so we can deliver that even when you're
                // offline 2) Actually reject the Promise in the online case
                // if the document doesn't exist.
                e(new I(w.UNAVAILABLE, "Failed to get document because the client is offline.")) : i.exists && i.metadata.fromCache && s && "server" === s.source ? e(new I(w.UNAVAILABLE, 'Failed to get document from server. (However, this document does exist in the local cache. Run again without setting source to "server" to retrieve the cached document.)')) : t(i);
            },
            error: e
        });
    }
    withConverter(t) {
        return new Ji(this.um, this.firestore, t);
    }
}

class Yi {
    constructor(t, e) {
        this.hasPendingWrites = t, this.fromCache = e;
    }
    isEqual(t) {
        return this.hasPendingWrites === t.hasPendingWrites && this.fromCache === t.fromCache;
    }
}

class Xi {
    constructor(t, e, s, n, i, r) {
        this.lm = t, this.um = e, this.Rm = s, this.Am = n, this.Pm = i, this.fm = r;
    }
    data(t) {
        if (cs("DocumentSnapshot.data", arguments, 0, 1), t = ir("DocumentSnapshot.data", t), 
        this.Rm) {
            // We only want to use the converter and create a new DocumentSnapshot
            // if a converter has been provided.
            if (this.fm) {
                const e = new Zi(this.lm, this.um, this.Rm, this.Am, this.Pm);
                return this.fm.fromFirestore(e, t);
            }
            return new Wi(this.lm, this.lm._m(), t.serverTimestamps, 
            /* converter= */ void 0).BT(this.Rm.Ie());
        }
    }
    get(t, e) {
        if (cs("DocumentSnapshot.get", arguments, 1, 2), e = ir("DocumentSnapshot.get", e), 
        this.Rm) {
            const s = this.Rm.data().field(Js("DocumentSnapshot.get", t));
            if (null !== s) {
                return new Wi(this.lm, this.lm._m(), e.serverTimestamps, this.fm).BT(s);
            }
        }
    }
    get id() {
        return this.um.path.B();
    }
    get ref() {
        return new Ji(this.um, this.lm, this.fm);
    }
    get exists() {
        return null !== this.Rm;
    }
    get metadata() {
        return new Yi(this.Pm, this.Am);
    }
    isEqual(t) {
        if (!(t instanceof Xi)) throw Ps("isEqual", "DocumentSnapshot", 1, t);
        return this.lm === t.lm && this.Am === t.Am && this.um.isEqual(t.um) && (null === this.Rm ? null === t.Rm : this.Rm.isEqual(t.Rm)) && this.fm === t.fm;
    }
}

class Zi extends Xi {
    data(t) {
        return super.data(t);
    }
}

class tr {
    constructor(t, e, s) {
        this.Vm = t, this.firestore = e, this.fm = s;
    }
    where(t, e, s) {
        as("Query.where", arguments, 3), Rs("Query.where", 3, s);
        let n;
        !function(t, e, s, n) {
            if (!e.some(t => t === n)) throw new I(w.INVALID_ARGUMENT, `Invalid value ${Is(n)} provided to function ` + `${t}() for its ${gs(s)} argument. Acceptable ` + `values: ${e.join(", ")}`);
        }("Query.where", [ "<", "<=", "==", ">=", ">", "array-contains", "in", "array-contains-any" ], 2, e);
        const i = Js("Query.where", t), r = kt.G(e);
        if (i.Y()) {
            if (r === kt.ARRAY_CONTAINS || r === kt.ARRAY_CONTAINS_ANY) throw new I(w.INVALID_ARGUMENT, `Invalid Query. You can't perform '${r.toString()}' ` + "queries on FieldPath.documentId().");
            if (r === kt.IN) {
                this.gm(s, r);
                const t = [];
                for (const e of s) t.push(this.pm(e));
                n = {
                    arrayValue: {
                        values: t
                    }
                };
            } else n = this.pm(s);
        } else r !== kt.IN && r !== kt.ARRAY_CONTAINS_ANY || this.gm(s, r), n = this.firestore.sm.Da("Query.where", s, 
        // We only allow nested arrays for IN queries.
        /** allowArrays = */ r === kt.IN);
        const o = Nt.create(i, r, n);
        return this.ym(o), new tr(this.Vm.Ce(o), this.firestore, this.fm);
    }
    orderBy(t, e) {
        let s;
        if (cs("Query.orderBy", arguments, 1, 2), ls("Query.orderBy", "non-empty string", 2, e), 
        void 0 === e || "asc" === e) s = xt.ASCENDING; else {
            if ("desc" !== e) throw new I(w.INVALID_ARGUMENT, `Function Query.orderBy() has unknown direction '${e}', ` + "expected 'asc' or 'desc'.");
            s = xt.DESCENDING;
        }
        if (null !== this.Vm.startAt) throw new I(w.INVALID_ARGUMENT, "Invalid query. You must not call Query.startAt() or Query.startAfter() before calling Query.orderBy().");
        if (null !== this.Vm.endAt) throw new I(w.INVALID_ARGUMENT, "Invalid query. You must not call Query.endAt() or Query.endBefore() before calling Query.orderBy().");
        const n = Js("Query.orderBy", t), i = new Ut(n, s);
        return this.bm(i), new tr(this.Vm.ke(i), this.firestore, this.fm);
    }
    limit(t) {
        return as("Query.limit", arguments, 1), _s("Query.limit", "number", 1, t), Vs("Query.limit", 1, t), 
        new tr(this.Vm.Ne(t), this.firestore, this.fm);
    }
    limitToLast(t) {
        return as("Query.limitToLast", arguments, 1), _s("Query.limitToLast", "number", 1, t), 
        Vs("Query.limitToLast", 1, t), new tr(this.Vm.Fe(t), this.firestore, this.fm);
    }
    startAt(t, ...e) {
        us("Query.startAt", arguments, 1);
        const s = this.vm("Query.startAt", t, e, 
        /*before=*/ !0);
        return new tr(this.Vm.$e(s), this.firestore, this.fm);
    }
    startAfter(t, ...e) {
        us("Query.startAfter", arguments, 1);
        const s = this.vm("Query.startAfter", t, e, 
        /*before=*/ !1);
        return new tr(this.Vm.$e(s), this.firestore, this.fm);
    }
    endBefore(t, ...e) {
        us("Query.endBefore", arguments, 1);
        const s = this.vm("Query.endBefore", t, e, 
        /*before=*/ !0);
        return new tr(this.Vm.Me(s), this.firestore, this.fm);
    }
    endAt(t, ...e) {
        us("Query.endAt", arguments, 1);
        const s = this.vm("Query.endAt", t, e, 
        /*before=*/ !1);
        return new tr(this.Vm.Me(s), this.firestore, this.fm);
    }
    isEqual(t) {
        if (!(t instanceof tr)) throw Ps("isEqual", "Query", 1, t);
        return this.firestore === t.firestore && this.Vm.isEqual(t.Vm);
    }
    withConverter(t) {
        return new tr(this.Vm, this.firestore, t);
    }
    /** Helper function to create a bound from a document or fields */    vm(t, e, s, n) {
        if (Rs(t, 1, e), e instanceof Xi) {
            if (s.length > 0) throw new I(w.INVALID_ARGUMENT, `Too many arguments provided to ${t}().`);
            const i = e;
            if (!i.exists) throw new I(w.NOT_FOUND, "Can't use a DocumentSnapshot that doesn't exist for " + `${t}().`);
            return this.Sm(i.Rm, n);
        }
        {
            const i = [ e ].concat(s);
            return this.Dm(t, i, n);
        }
    }
    /**
     * Create a Bound from a query and a document.
     *
     * Note that the Bound will always include the key of the document
     * and so only the provided document will compare equal to the returned
     * position.
     *
     * Will throw if the document does not contain all fields of the order by
     * of the query or if any of the fields in the order by are an uncommitted
     * server timestamp.
     */    Sm(t, e) {
        const s = [];
        // Because people expect to continue/end a query at the exact document
        // provided, we need to use the implicit sort order rather than the explicit
        // sort order, because it's guaranteed to contain the document key. That way
        // the position becomes unambiguous and the query continues/ends exactly at
        // the provided document. Without the key (by using the explicit sort
        // orders), multiple documents could match the position, yielding duplicate
        // results.
                for (const e of this.Vm.orderBy) if (e.field.Y()) s.push(nt(this.firestore.KT, t.key)); else {
            const n = t.field(e.field);
            if (W(n)) throw new I(w.INVALID_ARGUMENT, 'Invalid query. You are trying to start or end a query using a document for which the field "' + e.field + '" is an uncommitted server timestamp. (Since the value of this field is unknown, you cannot start/end a query with it.)');
            if (null === n) {
                const t = e.field.K();
                throw new I(w.INVALID_ARGUMENT, "Invalid query. You are trying to start or end a query using a " + `document for which the field '${t}' (used as the ` + "orderBy) does not exist.");
            }
            s.push(n);
        }
        return new Bt(s, e);
    }
    /**
     * Converts a list of field values to a Bound for the given query.
     */    Dm(t, e, s) {
        // Use explicit order by's because it has to match the query the user made
        const n = this.Vm.Ve;
        if (e.length > n.length) throw new I(w.INVALID_ARGUMENT, `Too many arguments provided to ${t}(). ` + "The number of arguments must be less than or equal to the number of Query.orderBy() clauses");
        const i = [];
        for (let s = 0; s < e.length; s++) {
            const r = e[s];
            if (n[s].field.Y()) {
                if ("string" != typeof r) throw new I(w.INVALID_ARGUMENT, "Invalid query. Expected a string for document ID in " + `${t}(), but got a ${typeof r}`);
                if (!this.Vm.He() && -1 !== r.indexOf("/")) throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying a collection and ordering by FieldPath.documentId(), " + `the value passed to ${t}() must be a plain document ID, but ` + `'${r}' contains a slash.`);
                const e = this.Vm.path.child(v.G(r));
                if (!C.st(e)) throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying a collection group and ordering by " + `FieldPath.documentId(), the value passed to ${t}() must result in a ` + `valid document path, but '${e}' is not because it contains an odd number ` + "of segments.");
                const s = new C(e);
                i.push(nt(this.firestore.KT, s));
            } else {
                const e = this.firestore.sm.Da(t, r);
                i.push(e);
            }
        }
        return new Bt(i, s);
    }
    onSnapshot(...t) {
        cs("Query.onSnapshot", arguments, 1, 4);
        let e, s = {}, n = 0;
        return "object" != typeof t[n] || Qi(t[n]) || (s = t[n], As("Query.onSnapshot", s, [ "includeMetadataChanges" ]), 
        fs("Query.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        n++), Qi(t[n]) ? e = t[n] : (_s("Query.onSnapshot", "function", n, t[n]), ls("Query.onSnapshot", "function", n + 1, t[n + 1]), 
        ls("Query.onSnapshot", "function", n + 2, t[n + 2]), e = {
            next: t[n],
            error: t[n + 1],
            complete: t[n + 2]
        }), this.Cm(this.Vm), this.wm(s, e);
    }
    wm(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const n = new qi({
            next: t => {
                e.next && e.next(new er(this.firestore, this.Vm, t, this.fm));
            },
            error: s
        }), i = this.firestore.HT(), r = i.listen(this.Vm, n, t);
        return () => {
            n.OT(), i.fc(r);
        };
    }
    Cm(t) {
        if (t.Ke() && 0 === t.Ve.length) throw new I(w.UNIMPLEMENTED, "limitToLast() queries require specifying at least one orderBy() clause");
    }
    get(t) {
        return cs("Query.get", arguments, 0, 1), rr("Query.get", t), this.Cm(this.Vm), new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.HT().MT(this.Vm).then(t => {
                e(new er(this.firestore, this.Vm, t, this.fm));
            }, s) : this.Im(e, s, t);
        });
    }
    Im(t, e, s) {
        const n = this.wm({
            includeMetadataChanges: !0,
            Kl: !0
        }, {
            next: i => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                n(), i.metadata.fromCache && s && "server" === s.source ? e(new I(w.UNAVAILABLE, 'Failed to get documents from server. (However, these documents may exist in the local cache. Run again without setting source to "server" to retrieve the cached documents.)')) : t(i);
            },
            error: e
        });
    }
    /**
     * Parses the given documentIdValue into a ReferenceValue, throwing
     * appropriate errors if the value is anything other than a DocumentReference
     * or String, or if the string is malformed.
     */    pm(t) {
        if ("string" == typeof t) {
            if ("" === t) throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid document ID, but it was an empty string.");
            if (!this.Vm.He() && -1 !== t.indexOf("/")) throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying a collection by FieldPath.documentId(), you must provide a plain document ID, but " + `'${t}' contains a '/' character.`);
            const e = this.Vm.path.child(v.G(t));
            if (!C.st(e)) throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying a collection group by FieldPath.documentId(), the value provided must result in a valid document path, " + `but '${e}' is not because it has an odd number of segments (${e.length}).`);
            return nt(this.firestore.KT, new C(e));
        }
        if (t instanceof Ji) {
            const e = t;
            return nt(this.firestore.KT, e.um);
        }
        throw new I(w.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid string or a DocumentReference, but it was: " + `${Is(t)}.`);
    }
    /**
     * Validates that the value passed into a disjunctrive filter satisfies all
     * array requirements.
     */    gm(t, e) {
        if (!Array.isArray(t) || 0 === t.length) throw new I(w.INVALID_ARGUMENT, "Invalid Query. A non-empty array is required for " + `'${e.toString()}' filters.`);
        if (t.length > 10) throw new I(w.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters support a ` + "maximum of 10 elements in the value array.");
        if (t.indexOf(null) >= 0) throw new I(w.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'null' ` + "in the value array.");
        if (t.filter(t => Number.isNaN(t)).length > 0) throw new I(w.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'NaN' ` + "in the value array.");
    }
    ym(t) {
        if (t instanceof Nt) {
            const e = [ kt.ARRAY_CONTAINS, kt.ARRAY_CONTAINS_ANY ], s = [ kt.IN, kt.ARRAY_CONTAINS_ANY ], n = e.indexOf(t.op) >= 0, i = s.indexOf(t.op) >= 0;
            if (t.Ge()) {
                const e = this.Vm.Se();
                if (null !== e && !e.isEqual(t.field)) throw new I(w.INVALID_ARGUMENT, "Invalid query. All where filters with an inequality (<, <=, >, or >=) must be on the same field. But you have" + ` inequality filters on '${e.toString()}'` + ` and '${t.field.toString()}'`);
                const s = this.Vm.De();
                null !== s && this.km(t.field, s);
            } else if (i || n) {
                // You can have at most 1 disjunctive filter and 1 array filter. Check if
                // the new filter conflicts with an existing one.
                let r = null;
                if (i && (r = this.Vm.ze(s)), null === r && n && (r = this.Vm.ze(e)), null != r) 
                // We special case when it's a duplicate op to give a slightly clearer error message.
                throw r === t.op ? new I(w.INVALID_ARGUMENT, "Invalid query. You cannot use more than one " + `'${t.op.toString()}' filter.`) : new I(w.INVALID_ARGUMENT, `Invalid query. You cannot use '${t.op.toString()}' filters ` + `with '${r.toString()}' filters.`);
            }
        }
    }
    bm(t) {
        if (null === this.Vm.De()) {
            // This is the first order by. It must match any inequality.
            const e = this.Vm.Se();
            null !== e && this.km(e, t.field);
        }
    }
    km(t, e) {
        if (!e.isEqual(t)) throw new I(w.INVALID_ARGUMENT, "Invalid query. You have a where filter with an inequality " + `(<, <=, >, or >=) on field '${t.toString()}' ` + `and so you must also use '${t.toString()}' ` + "as your first Query.orderBy(), but your first Query.orderBy() " + `is on field '${e.toString()}' instead.`);
    }
}

class er {
    constructor(t, e, s, n) {
        this.lm = t, this.Nm = e, this.Fm = s, this.fm = n, this.$m = null, this.Mm = null, 
        this.metadata = new Yi(s.hasPendingWrites, s.fromCache);
    }
    get docs() {
        const t = [];
        return this.forEach(e => t.push(e)), t;
    }
    get empty() {
        return this.Fm.docs.U();
    }
    get size() {
        return this.Fm.docs.size;
    }
    forEach(t, e) {
        cs("QuerySnapshot.forEach", arguments, 1, 2), _s("QuerySnapshot.forEach", "function", 1, t), 
        this.Fm.docs.forEach(s => {
            t.call(e, this.Lm(s));
        });
    }
    get query() {
        return new tr(this.Nm, this.lm, this.fm);
    }
    docChanges(t) {
        t && (As("QuerySnapshot.docChanges", t, [ "includeMetadataChanges" ]), fs("QuerySnapshot.docChanges", "boolean", "includeMetadataChanges", t.includeMetadataChanges));
        const e = !(!t || !t.includeMetadataChanges);
        if (e && this.Fm.ds) throw new I(w.INVALID_ARGUMENT, "To include metadata changes with your document changes, you must also pass { includeMetadataChanges:true } to onSnapshot().");
        return this.$m && this.Mm === e || (this.$m = 
        /**
 * Calculates the array of firestore.DocumentChange's for a given ViewSnapshot.
 *
 * Exported for testing.
 */
        function(t, e, s, n) {
            if (s.cs.U()) {
                // Special case the first snapshot because index calculation is easy and
                // fast
                let e, i = 0;
                return s.docChanges.map(r => {
                    const o = new Zi(t, r.doc.key, r.doc, s.fromCache, s._s.has(r.doc.key), n);
                    return e = r.doc, {
                        type: "added",
                        doc: o,
                        oldIndex: -1,
                        newIndex: i++
                    };
                });
            }
            {
                // A DocumentSet that is updated incrementally as changes are applied to use
                // to lookup the index of a document.
                let i = s.cs;
                return s.docChanges.filter(t => e || 3 /* Metadata */ !== t.type).map(e => {
                    const r = new Zi(t, e.doc.key, e.doc, s.fromCache, s._s.has(e.doc.key), n);
                    let o = -1, h = -1;
                    return 0 /* Added */ !== e.type && (o = i.indexOf(e.doc.key), i = i.delete(e.doc.key)), 
                    1 /* Removed */ !== e.type && (i = i.add(e.doc), h = i.indexOf(e.doc.key)), {
                        type: hr(e.type),
                        doc: r,
                        oldIndex: o,
                        newIndex: h
                    };
                });
            }
        }(this.lm, e, this.Fm, this.fm), this.Mm = e), this.$m;
    }
    /** Check the equality. The call can be very expensive. */    isEqual(t) {
        if (!(t instanceof er)) throw Ps("isEqual", "QuerySnapshot", 1, t);
        return this.lm === t.lm && this.Nm.isEqual(t.Nm) && this.Fm.isEqual(t.Fm) && this.fm === t.fm;
    }
    Lm(t) {
        return new Zi(this.lm, t.key, t, this.metadata.fromCache, this.Fm._s.has(t.key), this.fm);
    }
}

class sr extends tr {
    constructor(t, e, s) {
        if (super(Ct.ve(t), e, s), this.Om = t, t.length % 2 != 1) throw new I(w.INVALID_ARGUMENT, "Invalid collection reference. Collection references must have an odd number of segments, but " + `${t.K()} has ${t.length}`);
    }
    get id() {
        return this.Vm.path.B();
    }
    get parent() {
        const t = this.Vm.path.L();
        return t.U() ? null : new Ji(new C(t), this.firestore);
    }
    get path() {
        return this.Vm.path.K();
    }
    doc(t) {
        if (cs("CollectionReference.doc", arguments, 0, 1), 
        // We allow omission of 'pathString' but explicitly prohibit passing in both
        // 'undefined' and 'null'.
        0 === arguments.length && (t = ke.mi()), _s("CollectionReference.doc", "non-empty string", 1, t), 
        "" === t) throw new I(w.INVALID_ARGUMENT, "Document path must be a non-empty string");
        const e = v.G(t);
        return Ji.cm(this.Vm.path.child(e), this.firestore, this.fm);
    }
    add(t) {
        as("CollectionReference.add", arguments, 1), _s("CollectionReference.add", "object", 1, this.fm ? this.fm.toFirestore(t) : t);
        const e = this.doc();
        return e.set(t).then(() => e);
    }
    withConverter(t) {
        return new sr(this.Om, this.firestore, t);
    }
}

function nr(t, e) {
    if (void 0 === e) return {
        merge: !1
    };
    if (As(t, e, [ "merge", "mergeFields" ]), fs(t, "boolean", "merge", e.merge), Ts(t, "mergeFields", "a string or a FieldPath", e.mergeFields, t => "string" == typeof t || t instanceof Cs), 
    void 0 !== e.mergeFields && void 0 !== e.merge) throw new I(w.INVALID_ARGUMENT, `Invalid options passed to function ${t}(): You cannot specify both "merge" ` + 'and "mergeFields".');
    return e;
}

function ir(t, e) {
    return void 0 === e ? {} : (As(t, e, [ "serverTimestamps" ]), ms(t, 0, "serverTimestamps", e.serverTimestamps, [ "estimate", "previous", "none" ]), 
    e);
}

function rr(t, e) {
    ls(t, "object", 1, e), e && (As(t, e, [ "source" ]), ms(t, 0, "source", e.source, [ "default", "server", "cache" ]));
}

function or(t, e, s) {
    if (e instanceof Ji) {
        if (e.firestore !== s) throw new I(w.INVALID_ARGUMENT, "Provided document reference is from a different Firestore instance.");
        return e;
    }
    throw Ps(t, "DocumentReference", 1, e);
}

function hr(t) {
    switch (t) {
      case 0 /* Added */ :
        return "added";

      case 2 /* Modified */ :
      case 3 /* Metadata */ :
        return "modified";

      case 1 /* Removed */ :
        return "removed";

      default:
        return De("Unknown change type: " + t);
    }
}

/**
 * Converts custom model object of type T into DocumentData by applying the
 * converter if it exists.
 *
 * This function is used when converting user objects to DocumentData
 * because we want to provide the user with a more specific error message if
 * their set() or fails due to invalid data originating from a toFirestore()
 * call.
 */ function ar(t, e, s) {
    let n;
    return t ? (n = t.toFirestore(e), s = "toFirestore() in " + s) : n = e, [ n, s ];
}

const ur = ys(Gi, "Use firebase.firestore() instead."), cr = ys(zi, "Use firebase.firestore().runTransaction() instead."), _r = ys(Hi, "Use firebase.firestore().batch() instead."), lr = ys(Ji, "Use firebase.firestore().doc() instead."), dr = ys(Xi), fr = ys(Zi), Tr = ys(tr), mr = ys(er), Er = ys(sr, "Use firebase.firestore().collection() instead."), wr = {
    Firestore: ur,
    GeoPoint: Bs,
    Timestamp: p,
    Blob: Ds,
    Transaction: cr,
    WriteBatch: _r,
    DocumentReference: lr,
    DocumentSnapshot: dr,
    Query: Tr,
    QueryDocumentSnapshot: fr,
    QuerySnapshot: mr,
    CollectionReference: Er,
    FieldPath: Cs,
    FieldValue: xs,
    setLogLevel: Gi.setLogLevel,
    CACHE_SIZE_UNLIMITED: ji
};

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Ir {
    Hu(t) {
        // No-op.
    }
    lc() {
        // No-op.
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Browser implementation of ConnectivityMonitor.
 */
class Rr {
    constructor() {
        this.xm = () => this.Bm(), this.Um = () => this.qm(), this.Qm = [], this.Wm();
    }
    Hu(t) {
        this.Qm.push(t);
    }
    lc() {
        window.removeEventListener("online", this.xm), window.removeEventListener("offline", this.Um);
    }
    Wm() {
        window.addEventListener("online", this.xm), window.addEventListener("offline", this.Um);
    }
    Bm() {
        be("ConnectivityMonitor", "Network connectivity changed: AVAILABLE");
        for (const t of this.Qm) t(0 /* AVAILABLE */);
    }
    qm() {
        be("ConnectivityMonitor", "Network connectivity changed: UNAVAILABLE");
        for (const t of this.Qm) t(1 /* UNAVAILABLE */);
    }
    // TODO(chenbrian): Consider passing in window either into this component or
    // here for testing via FakeWindow.
    /** Checks that all used attributes of window are available. */
    static Uc() {
        return "undefined" != typeof window && void 0 !== window.addEventListener && void 0 !== window.removeEventListener;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a simple helper class that implements the Stream interface to
 * bridge to other implementations that are streams but do not implement the
 * interface. The stream callbacks are invoked with the callOn... methods.
 */ class Ar {
    constructor(t) {
        this.jm = t.jm, this.Km = t.Km;
    }
    _u(t) {
        this.Gm = t;
    }
    ou(t) {
        this.zm = t;
    }
    onMessage(t) {
        this.Hm = t;
    }
    close() {
        this.Km();
    }
    send(t) {
        this.jm(t);
    }
    Jm() {
        this.Gm();
    }
    Ym(t) {
        this.zm(t);
    }
    Xm(t) {
        this.Hm(t);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Pr = {
    BatchGetDocuments: "batchGet",
    Commit: "commit"
}, Vr = "gl-js/ fire/" + m;

class gr {
    constructor(t) {
        this.cn = t.cn;
        const e = t.ssl ? "https" : "http";
        this.Zm = e + "://" + t.host, this.forceLongPolling = t.forceLongPolling;
    }
    /**
     * Modifies the headers for a request, adding any authorization token if
     * present and any additional headers for the request.
     */    tE(t, e) {
        if (e) for (const s in e.h) e.h.hasOwnProperty(s) && (t[s] = e.h[s]);
        t["X-Goog-Api-Client"] = Vr;
    }
    gu(t, e, s) {
        const n = this.eE(t);
        return new Promise((i, r) => {
            const o = new _;
            o.listenOnce(l.COMPLETE, () => {
                try {
                    switch (o.getLastErrorCode()) {
                      case d.NO_ERROR:
                        const e = o.getResponseJson();
                        be("Connection", "XHR received:", JSON.stringify(e)), i(e);
                        break;

                      case d.TIMEOUT:
                        be("Connection", 'RPC "' + t + '" timed out'), r(new I(w.DEADLINE_EXCEEDED, "Request time out"));
                        break;

                      case d.HTTP_ERROR:
                        const s = o.getStatus();
                        if (be("Connection", 'RPC "' + t + '" failed with status:', s, "response text:", o.getResponseText()), 
                        s > 0) {
                            const t = o.getResponseJson().error;
                            if (t && t.status && t.message) {
                                const e = function(t) {
                                    const e = t.toLowerCase().replace("_", "-");
                                    return Object.values(w).indexOf(e) >= 0 ? e : w.UNKNOWN;
                                }(t.status);
                                r(new I(e, t.message));
                            } else r(new I(w.UNKNOWN, "Server responded with status " + o.getStatus()));
                        } else 
                        // If we received an HTTP_ERROR but there's no status code,
                        // it's most probably a connection issue
                        be("Connection", 'RPC "' + t + '" failed'), r(new I(w.UNAVAILABLE, "Connection failed."));
                        break;

                      default:
                        De('RPC "' + t + '" failed with unanticipated webchannel error ' + o.getLastErrorCode() + ": " + o.getLastError() + ", giving up.");
                    }
                } finally {
                    be("Connection", 'RPC "' + t + '" completed.');
                }
            });
            // The database field is already encoded in URL. Specifying it again in
            // the body is not necessary in production, and will cause duplicate field
            // errors in the Firestore Emulator. Let's remove it.
            const h = Object.assign({}, e);
            delete h.database;
            const a = JSON.stringify(h);
            be("Connection", "XHR sending: ", n + " " + a);
            // Content-Type: text/plain will avoid preflight requests which might
            // mess with CORS and redirects by proxies. If we add custom headers
            // we will need to change this code to potentially use the
            // $httpOverwrite parameter supported by ESF to avoid
            // triggering preflight requests.
            const u = {
                "Content-Type": "text/plain"
            };
            this.tE(u, s), o.send(n, "POST", a, u, 15);
        });
    }
    yu(t, e, s) {
        // The REST API automatically aggregates all of the streamed results, so we
        // can just use the normal invoke() method.
        return this.gu(t, e, s);
    }
    lu(t, e) {
        const s = [ this.Zm, "/", "google.firestore.v1.Firestore", "/", t, "/channel" ], n = f(), c = {
            // Required for backend stickiness, routing behavior is based on this
            // parameter.
            httpSessionIdParam: "gsessionid",
            initMessageHeaders: {},
            messageUrlParams: {
                // This param is used to improve routing and project isolation by the
                // backend and must be included in every request.
                database: `projects/${this.cn.projectId}/databases/${this.cn.database}`
            },
            sendRawJson: !0,
            supportsCrossDomainXhr: !0,
            internalChannelParams: {
                // Override the default timeout (randomized between 10-20 seconds) since
                // a large write batch on a slow internet connection may take a long
                // time to send to the backend. Rather than have WebChannel impose a
                // tight timeout which could lead to infinite timeouts and retries, we
                // set it very large (5-10 minutes) and rely on the browser's builtin
                // timeouts to kick in if the request isn't working.
                forwardChannelRequestTimeoutMs: 6e5
            },
            forceLongPolling: this.forceLongPolling
        };
        this.tE(c.initMessageHeaders, e), 
        // Sending the custom headers we just added to request.initMessageHeaders
        // (Authorization, etc.) will trigger the browser to make a CORS preflight
        // request because the XHR will no longer meet the criteria for a "simple"
        // CORS request:
        // https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Simple_requests
        // Therefore to avoid the CORS preflight request (an extra network
        // roundtrip), we use the httpHeadersOverwriteParam option to specify that
        // the headers should instead be encoded into a special "$httpHeaders" query
        // parameter, which is recognized by the webchannel backend. This is
        // formally defined here:
        // https://github.com/google/closure-library/blob/b0e1815b13fb92a46d7c9b3c30de5d6a396a3245/closure/goog/net/rpc/httpcors.js#L32
        // TODO(b/145624756): There is a backend bug where $httpHeaders isn't respected if the request
        // doesn't have an Origin header. So we have to exclude a few browser environments that are
        // known to (sometimes) not include an Origin. See
        // https://github.com/firebase/firebase-js-sdk/issues/1491.
        i() || r() || o() || h() || a() || u() || (c.httpHeadersOverwriteParam = "$httpHeaders");
        const _ = s.join("");
        be("Connection", "Creating WebChannel: " + _ + " " + c);
        const l = n.createWebChannel(_, c);
        // WebChannel supports sending the first message with the handshake - saving
        // a network round trip. However, it will have to call send in the same
        // JS event loop as open. In order to enforce this, we delay actually
        // opening the WebChannel until send is called. Whether we have called
        // open is tracked with this variable.
                let d = !1, m = !1;
        // A flag to determine whether the stream was closed (by us or through an
        // error/close event) to avoid delivering multiple close events or sending
        // on a closed stream
                const E = new Ar({
            jm: t => {
                m ? be("Connection", "Not sending because WebChannel is closed:", t) : (d || (be("Connection", "Opening WebChannel transport."), 
                l.open(), d = !0), be("Connection", "WebChannel sending:", t), l.send(t));
            },
            Km: () => l.close()
        }), R = (t, e) => {
            // TODO(dimond): closure typing seems broken because WebChannel does
            // not implement goog.events.Listenable
            l.listen(t, t => {
                try {
                    e(t);
                } catch (t) {
                    setTimeout(() => {
                        throw t;
                    }, 0);
                }
            });
        };
        // Closure events are guarded and exceptions are swallowed, so catch any
        // exception and rethrow using a setTimeout so they become visible again.
        // Note that eventually this function could go away if we are confident
        // enough the code is exception free.
                return R(T.EventType.OPEN, () => {
            m || be("Connection", "WebChannel transport opened.");
        }), R(T.EventType.CLOSE, () => {
            m || (m = !0, be("Connection", "WebChannel transport closed"), E.Ym());
        }), R(T.EventType.ERROR, t => {
            m || (m = !0, be("Connection", "WebChannel transport errored:", t), E.Ym(new I(w.UNAVAILABLE, "The operation could not be completed")));
        }), R(T.EventType.MESSAGE, t => {
            var e;
            if (!m) {
                const s = t.data[0];
                Ce(!!s, "Got a webchannel message without data.");
                // TODO(b/35143891): There is a bug in One Platform that caused errors
                // (and only errors) to be wrapped in an extra array. To be forward
                // compatible with the bug we need to check either condition. The latter
                // can be removed once the fix has been rolled out.
                // Use any because msgData.error is not typed.
                const n = s, i = n.error || (null === (e = n[0]) || void 0 === e ? void 0 : e.error);
                if (i) {
                    be("Connection", "WebChannel received error:", i);
                    // error.status will be a string like 'OK' or 'NOT_FOUND'.
                    const t = i.status;
                    let e = function(t) {
                        // lookup by string
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        const e = Kt[t];
                        if (void 0 !== e) return Ht(e);
                    }(t), s = i.message;
                    void 0 === e && (e = w.INTERNAL, s = "Unknown error status: " + t + " with message " + i.message), 
                    // Mark closed so no further events are propagated
                    m = !0, E.Ym(new I(e, s)), l.close();
                } else be("Connection", "WebChannel received:", s), E.Xm(s);
            }
        }), setTimeout(() => {
            // Technically we could/should wait for the WebChannel opened event,
            // but because we want to send the first message with the WebChannel
            // handshake we pretend the channel opened here (asynchronously), and
            // then delay the actual open until the first message is sent.
            E.Jm();
        }, 0), E;
    }
    // visible for testing
    eE(t) {
        const e = Pr[t];
        return this.Zm + "/v1/projects/" + this.cn.projectId + "/databases/" + this.cn.database + "/documents:" + e;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Registers the main Firestore build with the components framework.
 * Persistence can be enabled via `firebase.firestore().enablePersistence()`.
 */
function pr(t) {
    !
    /**
 * Configures Firestore as part of the Firebase SDK by calling registerService.
 *
 * @param firebase The FirebaseNamespace to register Firestore with
 * @param firestoreFactory A factory function that returns a new Firestore
 *    instance.
 */
    function(t, e) {
        t.INTERNAL.registerComponent(new c("firestore", t => {
            const s = t.getProvider("app").getImmediate();
            return e(s, t.getProvider("auth-internal"));
        }, "PUBLIC" /* PUBLIC */).setServiceProps(Object.assign({}, wr)));
    }(t, (t, e) => new Gi(t, e, new Bi)), t.registerVersion("@firebase/firestore", "1.14.1");
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * This code needs to run before Firestore is used. This can be achieved in
 * several ways:
 *   1) Through the JSCompiler compiling this code and then (automatically)
 *      executing it before exporting the Firestore symbols.
 *   2) Through importing this module first in a Firestore main module
 */
Ve.fi(new class {
    constructor() {
        this.dn = !0, this.ia = "undefined" != typeof atob;
    }
    get document() {
        return "undefined" != typeof document ? document : null;
    }
    get window() {
        return "undefined" != typeof window ? window : null;
    }
    DT(t) {
        return Promise.resolve(new gr(t));
    }
    gT() {
        return Rr.Uc() ? new Rr : new Ir;
    }
    yT(t) {
        return new Ae(t, {
            dn: !0
        });
    }
    Ti(t) {
        return JSON.stringify(t);
    }
    atob(t) {
        return atob(t);
    }
    btoa(t) {
        return btoa(t);
    }
}), pr(t);

export { pr as __PRIVATE_registerFirestore };
//# sourceMappingURL=index.esm2017.js.map
