import t from "@firebase/app";

import { Logger as e, LogLevel as s } from "@firebase/logger";

import { isMobileCordova as i, isReactNative as n, isElectron as r, isIE as h, isUWP as o, isBrowserExtension as a } from "@firebase/util";

import { Component as u } from "@firebase/component";

import { XhrIo as c, EventType as l, ErrorCode as _, createWebChannelTransport as d, WebChannel as f } from "@firebase/webchannel-wrapper";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** The semver (www.semver.org) version of the SDK. */ const w = t.SDK_VERSION;

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Simple wrapper around a nullable UID. Mostly exists to make code more
 * readable.
 */ class T {
    constructor(t) {
        this.uid = t;
    }
    t() {
        return null != this.uid;
    }
    /**
     * Returns a key representing this user, suitable for inclusion in a
     * dictionary.
     */    s() {
        return this.t() ? "uid:" + this.uid : "anonymous-user";
    }
    isEqual(t) {
        return t.uid === this.uid;
    }
}

/** A user with a null UID. */ T.UNAUTHENTICATED = new T(null), 
// TODO(mikelehen): Look into getting a proper uid-equivalent for
// non-FirebaseAuth providers.
T.i = new T("google-credentials-uid"), T.h = new T("first-party-uid");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const m = {
    // Causes are copied from:
    // https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
    /** Not an error; returned on success. */
    OK: "ok",
    /** The operation was cancelled (typically by the caller). */
    CANCELLED: "cancelled",
    /** Unknown error or an error from a different error domain. */
    UNKNOWN: "unknown",
    /**
     * Client specified an invalid argument. Note that this differs from
     * FAILED_PRECONDITION. INVALID_ARGUMENT indicates arguments that are
     * problematic regardless of the state of the system (e.g., a malformed file
     * name).
     */
    INVALID_ARGUMENT: "invalid-argument",
    /**
     * Deadline expired before operation could complete. For operations that
     * change the state of the system, this error may be returned even if the
     * operation has completed successfully. For example, a successful response
     * from a server could have been delayed long enough for the deadline to
     * expire.
     */
    DEADLINE_EXCEEDED: "deadline-exceeded",
    /** Some requested entity (e.g., file or directory) was not found. */
    NOT_FOUND: "not-found",
    /**
     * Some entity that we attempted to create (e.g., file or directory) already
     * exists.
     */
    ALREADY_EXISTS: "already-exists",
    /**
     * The caller does not have permission to execute the specified operation.
     * PERMISSION_DENIED must not be used for rejections caused by exhausting
     * some resource (use RESOURCE_EXHAUSTED instead for those errors).
     * PERMISSION_DENIED must not be used if the caller can not be identified
     * (use UNAUTHENTICATED instead for those errors).
     */
    PERMISSION_DENIED: "permission-denied",
    /**
     * The request does not have valid authentication credentials for the
     * operation.
     */
    UNAUTHENTICATED: "unauthenticated",
    /**
     * Some resource has been exhausted, perhaps a per-user quota, or perhaps the
     * entire file system is out of space.
     */
    RESOURCE_EXHAUSTED: "resource-exhausted",
    /**
     * Operation was rejected because the system is not in a state required for
     * the operation's execution. For example, directory to be deleted may be
     * non-empty, an rmdir operation is applied to a non-directory, etc.
     *
     * A litmus test that may help a service implementor in deciding
     * between FAILED_PRECONDITION, ABORTED, and UNAVAILABLE:
     *  (a) Use UNAVAILABLE if the client can retry just the failing call.
     *  (b) Use ABORTED if the client should retry at a higher-level
     *      (e.g., restarting a read-modify-write sequence).
     *  (c) Use FAILED_PRECONDITION if the client should not retry until
     *      the system state has been explicitly fixed. E.g., if an "rmdir"
     *      fails because the directory is non-empty, FAILED_PRECONDITION
     *      should be returned since the client should not retry unless
     *      they have first fixed up the directory by deleting files from it.
     *  (d) Use FAILED_PRECONDITION if the client performs conditional
     *      REST Get/Update/Delete on a resource and the resource on the
     *      server does not match the condition. E.g., conflicting
     *      read-modify-write on the same resource.
     */
    FAILED_PRECONDITION: "failed-precondition",
    /**
     * The operation was aborted, typically due to a concurrency issue like
     * sequencer check failures, transaction aborts, etc.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    ABORTED: "aborted",
    /**
     * Operation was attempted past the valid range. E.g., seeking or reading
     * past end of file.
     *
     * Unlike INVALID_ARGUMENT, this error indicates a problem that may be fixed
     * if the system state changes. For example, a 32-bit file system will
     * generate INVALID_ARGUMENT if asked to read at an offset that is not in the
     * range [0,2^32-1], but it will generate OUT_OF_RANGE if asked to read from
     * an offset past the current file size.
     *
     * There is a fair bit of overlap between FAILED_PRECONDITION and
     * OUT_OF_RANGE. We recommend using OUT_OF_RANGE (the more specific error)
     * when it applies so that callers who are iterating through a space can
     * easily look for an OUT_OF_RANGE error to detect when they are done.
     */
    OUT_OF_RANGE: "out-of-range",
    /** Operation is not implemented or not supported/enabled in this service. */
    UNIMPLEMENTED: "unimplemented",
    /**
     * Internal errors. Means some invariants expected by underlying System has
     * been broken. If you see one of these errors, Something is very broken.
     */
    INTERNAL: "internal",
    /**
     * The service is currently unavailable. This is a most likely a transient
     * condition and may be corrected by retrying with a backoff.
     *
     * See litmus test above for deciding between FAILED_PRECONDITION, ABORTED,
     * and UNAVAILABLE.
     */
    UNAVAILABLE: "unavailable",
    /** Unrecoverable data loss or corruption. */
    DATA_LOSS: "data-loss"
};

/**
 * An error class used for Firestore-generated errors. Ideally we should be
 * using FirebaseError, but integrating with it is overly arduous at the moment,
 * so we define our own compatible error class (with a `name` of 'FirebaseError'
 * and compatible `code` and `message` fields.)
 */ class E extends Error {
    constructor(t, e) {
        super(e), this.code = t, this.message = e, this.name = "FirebaseError", 
        // HACK: We write a toString property directly because Error is not a real
        // class and so inheritance does not work correctly. We could alternatively
        // do the same "back-door inheritance" trick that FirebaseError does.
        this.toString = () => `${this.name}: [code=${this.code}]: ${this.message}`;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class R {
    constructor(t, e) {
        this.user = e, this.type = "OAuth", this.o = {}, 
        // Set the headers using Object Literal notation to avoid minification
        this.o.Authorization = `Bearer ${t}`;
    }
}

/** A CredentialsProvider that always yields an empty token. */ class I {
    constructor() {
        /**
         * Stores the listener registered with setChangeListener()
         * This isn't actually necessary since the UID never changes, but we use this
         * to verify the listen contract is adhered to in tests.
         */
        this.u = null;
    }
    getToken() {
        return Promise.resolve(null);
    }
    l() {}
    _(t) {
        this.u = t, 
        // Fire with initial user.
        t(T.UNAUTHENTICATED);
    }
    T() {
        this.u = null;
    }
}

class A {
    constructor(t) {
        /**
         * The auth token listener registered with FirebaseApp, retained here so we
         * can unregister it.
         */
        this.m = null, 
        /** Tracks the current User. */
        this.currentUser = T.UNAUTHENTICATED, this.R = !1, 
        /**
         * Counter used to detect if the token changed while a getToken request was
         * outstanding.
         */
        this.I = 0, 
        /** The listener registered with setChangeListener(). */
        this.u = null, this.forceRefresh = !1, this.m = () => {
            this.I++, this.currentUser = this.A(), this.R = !0, this.u && this.u(this.currentUser);
        }, this.I = 0, this.auth = t.getImmediate({
            optional: !0
        }), this.auth ? this.auth.addAuthTokenListener(this.m) : (
        // if auth is not available, invoke tokenListener once with null token
        this.m(null), t.get().then(t => {
            this.auth = t, this.m && 
            // tokenListener can be removed by removeChangeListener()
            this.auth.addAuthTokenListener(this.m);
        }, () => {}));
    }
    getToken() {
        // Take note of the current value of the tokenCounter so that this method
        // can fail (with an ABORTED error) if there is a token change while the
        // request is outstanding.
        const t = this.I, e = this.forceRefresh;
        return this.forceRefresh = !1, this.auth ? this.auth.getToken(e).then(e => {
            // Cancel the request since the token changed while the request was
            // outstanding so the response is potentially for a previous user (which
            // user, we can't be sure).
            if (this.I !== t) throw new E(m.ABORTED, "getToken aborted due to token change.");
            return e ? (Se("string" == typeof e.accessToken, "Invalid tokenData returned from getToken():" + e), 
            new R(e.accessToken, this.currentUser)) : null;
        }) : Promise.resolve(null);
    }
    l() {
        this.forceRefresh = !0;
    }
    _(t) {
        this.u = t, 
        // Fire the initial event
        this.R && t(this.currentUser);
    }
    T() {
        this.auth && this.auth.removeAuthTokenListener(this.m), this.m = null, this.u = null;
    }
    // Auth.getUid() can return null even with a user logged in. It is because
    // getUid() is synchronous, but the auth code populating Uid is asynchronous.
    // This method should only be called in the AuthTokenListener callback
    // to guarantee to get the actual user.
    A() {
        const t = this.auth && this.auth.getUid();
        return Se(null === t || "string" == typeof t, "Received invalid UID: " + t), new T(t);
    }
}

/*
 * FirstPartyToken provides a fresh token each time its value
 * is requested, because if the token is too old, requests will be rejected.
 * Technically this may no longer be necessary since the SDK should gracefully
 * recover from unauthenticated errors (see b/33147818 for context), but it's
 * safer to keep the implementation as-is.
 */ class P {
    constructor(t, e) {
        this.P = t, this.V = e, this.type = "FirstParty", this.user = T.h;
    }
    get o() {
        const t = {
            "X-Goog-AuthUser": this.V
        }, e = this.P.auth.p([]);
        return e && (t.Authorization = e), t;
    }
}

/*
 * Provides user credentials required for the Firestore JavaScript SDK
 * to authenticate the user, using technique that is only available
 * to applications hosted by Google.
 */ class V {
    constructor(t, e) {
        this.P = t, this.V = e;
    }
    getToken() {
        return Promise.resolve(new P(this.P, this.V));
    }
    _(t) {
        // Fire with initial uid.
        t(T.h);
    }
    T() {}
    l() {}
}

/**
 * Builds a CredentialsProvider depending on the type of
 * the credentials passed in.
 */ class p {
    constructor(t, e) {
        if (this.seconds = t, this.nanoseconds = e, e < 0) throw new E(m.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        if (e >= 1e9) throw new E(m.INVALID_ARGUMENT, "Timestamp nanoseconds out of range: " + e);
        if (t < -62135596800) throw new E(m.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
        // This will break in the year 10,000.
                if (t >= 253402300800) throw new E(m.INVALID_ARGUMENT, "Timestamp seconds out of range: " + t);
    }
    static now() {
        return p.fromMillis(Date.now());
    }
    static fromDate(t) {
        return p.fromMillis(t.getTime());
    }
    static fromMillis(t) {
        const e = Math.floor(t / 1e3);
        return new p(e, 1e6 * (t - 1e3 * e));
    }
    toDate() {
        return new Date(this.toMillis());
    }
    toMillis() {
        return 1e3 * this.seconds + this.nanoseconds / 1e6;
    }
    g(t) {
        return this.seconds === t.seconds ? De(this.nanoseconds, t.nanoseconds) : De(this.seconds, t.seconds);
    }
    isEqual(t) {
        return t.seconds === this.seconds && t.nanoseconds === this.nanoseconds;
    }
    toString() {
        return "Timestamp(seconds=" + this.seconds + ", nanoseconds=" + this.nanoseconds + ")";
    }
    valueOf() {
        // This method returns a string of the form <seconds>.<nanoseconds> where <seconds> is
        // translated to have a non-negative value and both <seconds> and <nanoseconds> are left-padded
        // with zeroes to be a consistent length. Strings with this format then have a lexiographical
        // ordering that matches the expected ordering. The <seconds> translation is done to avoid
        // having a leading negative sign (i.e. a leading '-' character) in its string representation,
        // which would affect its lexiographical ordering.
        const t = this.seconds - -62135596800;
        // Note: Up to 12 decimal digits are required to represent all valid 'seconds' values.
                return String(t).padStart(12, "0") + "." + String(this.nanoseconds).padStart(9, "0");
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A version of a document in Firestore. This corresponds to the version
 * timestamp, such as update_time or read_time.
 */ class g {
    constructor(t) {
        this.timestamp = t;
    }
    static v(t) {
        return new g(t);
    }
    static S() {
        return g.MIN;
    }
    C(t) {
        return this.timestamp.g(t.timestamp);
    }
    isEqual(t) {
        return this.timestamp.isEqual(t.timestamp);
    }
    /** Returns a number representation of the version for use in spec tests. */    D() {
        // Convert to microseconds.
        return 1e6 * this.timestamp.seconds + this.timestamp.nanoseconds / 1e3;
    }
    toString() {
        return "SnapshotVersion(" + this.timestamp.toString() + ")";
    }
    F() {
        return this.timestamp;
    }
}

g.MIN = new g(new p(0, 0));

/**
 * Path represents an ordered sequence of string segments.
 */
class y {
    constructor(t, e, s) {
        void 0 === e ? e = 0 : e > t.length && ve("offset " + e + " out of range " + t.length), 
        void 0 === s ? s = t.length - e : s > t.length - e && ve("length " + s + " out of range " + (t.length - e)), 
        this.segments = t, this.offset = e, this.N = s;
    }
    get length() {
        return this.N;
    }
    isEqual(t) {
        return 0 === y.k(this, t);
    }
    child(t) {
        const e = this.segments.slice(this.offset, this.limit());
        return t instanceof y ? t.forEach(t => {
            e.push(t);
        }) : e.push(t), this.L(e);
    }
    /** The index of one past the last segment of the path. */    limit() {
        return this.offset + this.length;
    }
    $(t) {
        return t = void 0 === t ? 1 : t, this.L(this.segments, this.offset + t, this.length - t);
    }
    O() {
        return this.L(this.segments, this.offset, this.length - 1);
    }
    M() {
        return this.segments[this.offset];
    }
    U() {
        return this.get(this.length - 1);
    }
    get(t) {
        return this.segments[this.offset + t];
    }
    q() {
        return 0 === this.length;
    }
    B(t) {
        if (t.length < this.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    W(t) {
        if (this.length + 1 !== t.length) return !1;
        for (let e = 0; e < this.length; e++) if (this.get(e) !== t.get(e)) return !1;
        return !0;
    }
    forEach(t) {
        for (let e = this.offset, s = this.limit(); e < s; e++) t(this.segments[e]);
    }
    j() {
        return this.segments.slice(this.offset, this.limit());
    }
    static k(t, e) {
        const s = Math.min(t.length, e.length);
        for (let i = 0; i < s; i++) {
            const s = t.get(i), n = e.get(i);
            if (s < n) return -1;
            if (s > n) return 1;
        }
        return t.length < e.length ? -1 : t.length > e.length ? 1 : 0;
    }
}

/**
 * A slash-separated path for navigating resources (documents and collections)
 * within Firestore.
 */ class b extends y {
    L(t, e, s) {
        return new b(t, e, s);
    }
    G() {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        return this.j().join("/");
    }
    toString() {
        return this.G();
    }
    /**
     * Creates a resource path from the given slash-delimited string.
     */    static K(t) {
        // NOTE: The client is ignorant of any path segments containing escape
        // sequences (e.g. __id123__) and just passes them through raw (they exist
        // for legacy reasons and should not be used frequently).
        if (t.indexOf("//") >= 0) throw new E(m.INVALID_ARGUMENT, `Invalid path (${t}). Paths must not contain // in them.`);
        // We may still have an empty segment at the beginning or end if they had a
        // leading or trailing slash (which we allow).
                const e = t.split("/").filter(t => t.length > 0);
        return new b(e);
    }
}

b.H = new b([]);

const v = /^[_a-zA-Z][_a-zA-Z0-9]*$/;

/** A dot-separated path for navigating sub-objects within a document. */ class S extends y {
    L(t, e, s) {
        return new S(t, e, s);
    }
    /**
     * Returns true if the string could be used as a segment in a field path
     * without escaping.
     */    static J(t) {
        return v.test(t);
    }
    G() {
        return this.j().map(t => (t = t.replace("\\", "\\\\").replace("`", "\\`"), S.J(t) || (t = "`" + t + "`"), 
        t)).join(".");
    }
    toString() {
        return this.G();
    }
    /**
     * Returns true if this field references the key of a document.
     */    Y() {
        return 1 === this.length && "__name__" === this.get(0);
    }
    /**
     * The field designating the key of a document.
     */    static X() {
        return new S([ "__name__" ]);
    }
    /**
     * Parses a field string from the given server-formatted string.
     *
     * - Splitting the empty string is not allowed (for now at least).
     * - Empty segments within the string (e.g. if there are two consecutive
     *   separators) are not allowed.
     *
     * TODO(b/37244157): we should make this more strict. Right now, it allows
     * non-identifier path components, even if they aren't escaped.
     */    static Z(t) {
        const e = [];
        let s = "", i = 0;
        const n = () => {
            if (0 === s.length) throw new E(m.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, begin ` + "with '.', end with '.', or contain '..'");
            e.push(s), s = "";
        };
        let r = !1;
        for (;i < t.length; ) {
            const e = t[i];
            if ("\\" === e) {
                if (i + 1 === t.length) throw new E(m.INVALID_ARGUMENT, "Path has trailing escape character: " + t);
                const e = t[i + 1];
                if ("\\" !== e && "." !== e && "`" !== e) throw new E(m.INVALID_ARGUMENT, "Path has invalid escape sequence: " + t);
                s += e, i += 2;
            } else "`" === e ? (r = !r, i++) : "." !== e || r ? (s += e, i++) : (n(), i++);
        }
        if (n(), r) throw new E(m.INVALID_ARGUMENT, "Unterminated ` in path: " + t);
        return new S(e);
    }
}

S.H = new S([]);

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class C {
    constructor(t) {
        this.path = t;
    }
    static tt(t) {
        return new C(b.K(t).$(5));
    }
    /** Returns true if the document is in the specified collectionId. */    et(t) {
        return this.path.length >= 2 && this.path.get(this.path.length - 2) === t;
    }
    isEqual(t) {
        return null !== t && 0 === b.k(this.path, t.path);
    }
    toString() {
        return this.path.toString();
    }
    static k(t, e) {
        return b.k(t.path, e.path);
    }
    static st(t) {
        return t.length % 2 == 0;
    }
    /**
     * Creates and returns a new document key with the given segments.
     *
     * @param segments The segments of the path to the document
     * @return A new instance of DocumentKey
     */    static it(t) {
        return new C(new b(t.slice()));
    }
}

C.EMPTY = new C(new b([]));

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// An immutable sorted map implementation, based on a Left-leaning Red-Black
// tree.
class D {
    constructor(t, e) {
        this.k = t, this.root = e || N.EMPTY;
    }
    // Returns a copy of the map, with the specified key/value added or replaced.
    nt(t, e) {
        return new D(this.k, this.root.nt(t, e, this.k).rt(null, null, N.ht, null, null));
    }
    // Returns a copy of the map, with the specified key removed.
    remove(t) {
        return new D(this.k, this.root.remove(t, this.k).rt(null, null, N.ht, null, null));
    }
    // Returns the value of the node with the given key, or null.
    get(t) {
        let e = this.root;
        for (;!e.q(); ) {
            const s = this.k(t, e.key);
            if (0 === s) return e.value;
            s < 0 ? e = e.left : s > 0 && (e = e.right);
        }
        return null;
    }
    // Returns the index of the element in this sorted map, or -1 if it doesn't
    // exist.
    indexOf(t) {
        // Number of nodes that were pruned when descending right
        let e = 0, s = this.root;
        for (;!s.q(); ) {
            const i = this.k(t, s.key);
            if (0 === i) return e + s.left.size;
            i < 0 ? s = s.left : (
            // Count all nodes left of the node plus the node itself
            e += s.left.size + 1, s = s.right);
        }
        // Node not found
                return -1;
    }
    q() {
        return this.root.q();
    }
    // Returns the total number of nodes in the map.
    get size() {
        return this.root.size;
    }
    // Returns the minimum key in the map.
    ot() {
        return this.root.ot();
    }
    // Returns the maximum key in the map.
    at() {
        return this.root.at();
    }
    // Traverses the map in key order and calls the specified action function
    // for each key/value pair. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ut(t) {
        return this.root.ut(t);
    }
    forEach(t) {
        this.ut((e, s) => (t(e, s), !1));
    }
    toString() {
        const t = [];
        return this.ut((e, s) => (t.push(`${e}:${s}`), !1)), `{${t.join(", ")}}`;
    }
    // Traverses the map in reverse key order and calls the specified action
    // function for each key/value pair. If action returns true, traversal is
    // aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ct(t) {
        return this.root.ct(t);
    }
    // Returns an iterator over the SortedMap.
    lt() {
        return new F(this.root, null, this.k, !1);
    }
    _t(t) {
        return new F(this.root, t, this.k, !1);
    }
    dt() {
        return new F(this.root, null, this.k, !0);
    }
    ft(t) {
        return new F(this.root, t, this.k, !0);
    }
}

 // end SortedMap
// An iterator over an LLRBNode.
class F {
    constructor(t, e, s, i) {
        this.wt = i, this.Tt = [];
        let n = 1;
        for (;!t.q(); ) if (n = e ? s(t.key, e) : 1, 
        // flip the comparison if we're going in reverse
        i && (n *= -1), n < 0) 
        // This node is less than our start key. ignore it
        t = this.wt ? t.left : t.right; else {
            if (0 === n) {
                // This node is exactly equal to our start key. Push it on the stack,
                // but stop iterating;
                this.Tt.push(t);
                break;
            }
            // This node is greater than our start key, add it to the stack and move
            // to the next one
            this.Tt.push(t), t = this.wt ? t.right : t.left;
        }
    }
    Et() {
        let t = this.Tt.pop();
        const e = {
            key: t.key,
            value: t.value
        };
        if (this.wt) for (t = t.left; !t.q(); ) this.Tt.push(t), t = t.right; else for (t = t.right; !t.q(); ) this.Tt.push(t), 
        t = t.left;
        return e;
    }
    Rt() {
        return this.Tt.length > 0;
    }
    It() {
        if (0 === this.Tt.length) return null;
        const t = this.Tt[this.Tt.length - 1];
        return {
            key: t.key,
            value: t.value
        };
    }
}

 // end SortedMapIterator
// Represents a node in a Left-leaning Red-Black tree.
class N {
    constructor(t, e, s, i, n) {
        this.key = t, this.value = e, this.color = null != s ? s : N.RED, this.left = null != i ? i : N.EMPTY, 
        this.right = null != n ? n : N.EMPTY, this.size = this.left.size + 1 + this.right.size;
    }
    // Returns a copy of the current node, optionally replacing pieces of it.
    rt(t, e, s, i, n) {
        return new N(null != t ? t : this.key, null != e ? e : this.value, null != s ? s : this.color, null != i ? i : this.left, null != n ? n : this.right);
    }
    q() {
        return !1;
    }
    // Traverses the tree in key order and calls the specified action function
    // for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ut(t) {
        return this.left.ut(t) || t(this.key, this.value) || this.right.ut(t);
    }
    // Traverses the tree in reverse key order and calls the specified action
    // function for each node. If action returns true, traversal is aborted.
    // Returns the first truthy value returned by action, or the last falsey
    // value returned by action.
    ct(t) {
        return this.right.ct(t) || t(this.key, this.value) || this.left.ct(t);
    }
    // Returns the minimum node in the tree.
    min() {
        return this.left.q() ? this : this.left.min();
    }
    // Returns the maximum key in the tree.
    ot() {
        return this.min().key;
    }
    // Returns the maximum key in the tree.
    at() {
        return this.right.q() ? this.key : this.right.at();
    }
    // Returns new tree, with the key/value added.
    nt(t, e, s) {
        let i = this;
        const n = s(t, i.key);
        return i = n < 0 ? i.rt(null, null, null, i.left.nt(t, e, s), null) : 0 === n ? i.rt(null, e, null, null, null) : i.rt(null, null, null, null, i.right.nt(t, e, s)), 
        i.At();
    }
    Pt() {
        if (this.left.q()) return N.EMPTY;
        let t = this;
        return t.left.Vt() || t.left.left.Vt() || (t = t.pt()), t = t.rt(null, null, null, t.left.Pt(), null), 
        t.At();
    }
    // Returns new tree, with the specified item removed.
    remove(t, e) {
        let s, i = this;
        if (e(t, i.key) < 0) i.left.q() || i.left.Vt() || i.left.left.Vt() || (i = i.pt()), 
        i = i.rt(null, null, null, i.left.remove(t, e), null); else {
            if (i.left.Vt() && (i = i.gt()), i.right.q() || i.right.Vt() || i.right.left.Vt() || (i = i.yt()), 
            0 === e(t, i.key)) {
                if (i.right.q()) return N.EMPTY;
                s = i.right.min(), i = i.rt(s.key, s.value, null, null, i.right.Pt());
            }
            i = i.rt(null, null, null, null, i.right.remove(t, e));
        }
        return i.At();
    }
    Vt() {
        return this.color;
    }
    // Returns new tree after performing any needed rotations.
    At() {
        let t = this;
        return t.right.Vt() && !t.left.Vt() && (t = t.bt()), t.left.Vt() && t.left.left.Vt() && (t = t.gt()), 
        t.left.Vt() && t.right.Vt() && (t = t.vt()), t;
    }
    pt() {
        let t = this.vt();
        return t.right.left.Vt() && (t = t.rt(null, null, null, null, t.right.gt()), t = t.bt(), 
        t = t.vt()), t;
    }
    yt() {
        let t = this.vt();
        return t.left.left.Vt() && (t = t.gt(), t = t.vt()), t;
    }
    bt() {
        const t = this.rt(null, null, N.RED, null, this.right.left);
        return this.right.rt(null, null, this.color, t, null);
    }
    gt() {
        const t = this.rt(null, null, N.RED, this.left.right, null);
        return this.left.rt(null, null, this.color, null, t);
    }
    vt() {
        const t = this.left.rt(null, null, !this.left.color, null, null), e = this.right.rt(null, null, !this.right.color, null, null);
        return this.rt(null, null, !this.color, t, e);
    }
    // For testing.
    St() {
        const t = this.Ct();
        return Math.pow(2, t) <= this.size + 1;
    }
    // In a balanced RB tree, the black-depth (number of black nodes) from root to
    // leaves is equal on both sides.  This function verifies that or asserts.
    Ct() {
        if (this.Vt() && this.left.Vt()) throw ve("Red node has red child(" + this.key + "," + this.value + ")");
        if (this.right.Vt()) throw ve("Right child of (" + this.key + "," + this.value + ") is red");
        const t = this.left.Ct();
        if (t !== this.right.Ct()) throw ve("Black depths differ");
        return t + (this.Vt() ? 0 : 1);
    }
}

 // end LLRBNode
// Empty node is shared between all LLRB trees.
// eslint-disable-next-line @typescript-eslint/no-explicit-any
N.EMPTY = null, N.RED = !0, N.ht = !1;

// end LLRBEmptyNode
N.EMPTY = new 
// Represents an empty node (a leaf node in the Red-Black Tree).
class {
    constructor() {
        this.size = 0;
    }
    get key() {
        throw ve("LLRBEmptyNode has no key.");
    }
    get value() {
        throw ve("LLRBEmptyNode has no value.");
    }
    get color() {
        throw ve("LLRBEmptyNode has no color.");
    }
    get left() {
        throw ve("LLRBEmptyNode has no left child.");
    }
    get right() {
        throw ve("LLRBEmptyNode has no right child.");
    }
    // Returns a copy of the current node.
    rt(t, e, s, i, n) {
        return this;
    }
    // Returns a copy of the tree, with the specified key/value added.
    nt(t, e, s) {
        return new N(t, e);
    }
    // Returns a copy of the tree, with the specified key removed.
    remove(t, e) {
        return this;
    }
    q() {
        return !0;
    }
    ut(t) {
        return !1;
    }
    ct(t) {
        return !1;
    }
    ot() {
        return null;
    }
    at() {
        return null;
    }
    Vt() {
        return !1;
    }
    // For testing.
    St() {
        return !0;
    }
    Ct() {
        return 0;
    }
};

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * SortedSet is an immutable (copy-on-write) collection that holds elements
 * in order specified by the provided comparator.
 *
 * NOTE: if provided comparator returns 0 for two elements, we consider them to
 * be equal!
 */
class k {
    constructor(t) {
        this.k = t, this.data = new D(this.k);
    }
    has(t) {
        return null !== this.data.get(t);
    }
    first() {
        return this.data.ot();
    }
    last() {
        return this.data.at();
    }
    get size() {
        return this.data.size;
    }
    indexOf(t) {
        return this.data.indexOf(t);
    }
    /** Iterates elements in order defined by "comparator" */    forEach(t) {
        this.data.ut((e, s) => (t(e), !1));
    }
    /** Iterates over `elem`s such that: range[0] <= elem < range[1]. */    Dt(t, e) {
        const s = this.data._t(t[0]);
        for (;s.Rt(); ) {
            const i = s.Et();
            if (this.k(i.key, t[1]) >= 0) return;
            e(i.key);
        }
    }
    /**
     * Iterates over `elem`s such that: start <= elem until false is returned.
     */    Ft(t, e) {
        let s;
        for (s = void 0 !== e ? this.data._t(e) : this.data.lt(); s.Rt(); ) {
            if (!t(s.Et().key)) return;
        }
    }
    /** Finds the least element greater than or equal to `elem`. */    Nt(t) {
        const e = this.data._t(t);
        return e.Rt() ? e.Et().key : null;
    }
    lt() {
        return new L(this.data.lt());
    }
    _t(t) {
        return new L(this.data._t(t));
    }
    /** Inserts or updates an element */    add(t) {
        return this.rt(this.data.remove(t).nt(t, !0));
    }
    /** Deletes an element */    delete(t) {
        return this.has(t) ? this.rt(this.data.remove(t)) : this;
    }
    q() {
        return this.data.q();
    }
    kt(t) {
        let e = this;
        // Make sure `result` always refers to the larger one of the two sets.
                return e.size < t.size && (e = t, t = this), t.forEach(t => {
            e = e.add(t);
        }), e;
    }
    isEqual(t) {
        if (!(t instanceof k)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.data.lt(), s = t.data.lt();
        for (;e.Rt(); ) {
            const t = e.Et().key, i = s.Et().key;
            if (0 !== this.k(t, i)) return !1;
        }
        return !0;
    }
    j() {
        const t = [];
        return this.forEach(e => {
            t.push(e);
        }), t;
    }
    toString() {
        const t = [];
        return this.forEach(e => t.push(e)), "SortedSet(" + t.toString() + ")";
    }
    rt(t) {
        const e = new k(this.k);
        return e.data = t, e;
    }
}

class L {
    constructor(t) {
        this.Lt = t;
    }
    Et() {
        return this.Lt.Et().key;
    }
    Rt() {
        return this.Lt.Rt();
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function $(t) {
    let e = 0;
    for (const s in t) Object.prototype.hasOwnProperty.call(t, s) && e++;
    return e;
}

function O(t, e) {
    for (const s in t) Object.prototype.hasOwnProperty.call(t, s) && e(s, t[s]);
}

function M(t) {
    for (const e in t) if (Object.prototype.hasOwnProperty.call(t, e)) return !1;
    return !0;
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class that represents a "proto" byte string.
 *
 * Proto byte strings can either be Base64-encoded strings or Uint8Arrays when
 * sent on the wire. This class abstracts away this differentiation by holding
 * the proto byte string in a common class that must be converted into a string
 * before being sent as a proto.
 */ class U {
    constructor(t) {
        this.$t = t;
    }
    static fromBase64String(t) {
        const e = Ae.Ot().atob(t);
        return new U(e);
    }
    static fromUint8Array(t) {
        const e = 
        /**
 * Helper function to convert an Uint8array to a binary string.
 */
        function(t) {
            let e = "";
            for (let s = 0; s < t.length; ++s) e += String.fromCharCode(t[s]);
            return e;
        }
        /**
 * Helper function to convert a binary string to an Uint8Array.
 */ (t);
        return new U(e);
    }
    toBase64() {
        return Ae.Ot().btoa(this.$t);
    }
    toUint8Array() {
        return function(t) {
            const e = new Uint8Array(t.length);
            for (let s = 0; s < t.length; s++) e[s] = t.charCodeAt(s);
            return e;
        }
        /**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
        /**
 * Returns whether a variable is either undefined or null.
 */ (this.$t);
    }
    Mt() {
        return 2 * this.$t.length;
    }
    C(t) {
        return De(this.$t, t.$t);
    }
    isEqual(t) {
        return this.$t === t.$t;
    }
}

function q(t) {
    return null == t;
}

/** Returns whether the value represents -0. */ function B(t) {
    // Detect if the value is -0.0. Based on polyfill from
    // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
    return -0 === t && 1 / t == -1 / 0;
}

/**
 * Returns whether a value is an integer and in the safe integer range
 * @param value The value to test for being an integer and in the safe range
 */ U.Ut = new U("");

function x(t) {
    var e, s;
    return "server_timestamp" === (null === (s = ((null === (e = null == t ? void 0 : t.mapValue) || void 0 === e ? void 0 : e.fields) || {}).__type__) || void 0 === s ? void 0 : s.stringValue);
}

/**
 * Creates a new ServerTimestamp proto value (using the internal format).
 */
/**
 * Returns the local time at which this timestamp was first set.
 */
function Q(t) {
    const e = X(t.mapValue.fields.__local_write_time__.timestampValue);
    return new p(e.seconds, e.nanos);
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// A RegExp matching ISO 8601 UTC timestamps with optional fraction.
const W = new RegExp(/^\d{4}-\d\d-\d\dT\d\d:\d\d:\d\d(?:\.(\d+))?Z$/);

/** Extracts the backend's type order for the provided value. */ function j(t) {
    return "nullValue" in t ? 0 /* NullValue */ : "booleanValue" in t ? 1 /* BooleanValue */ : "integerValue" in t || "doubleValue" in t ? 2 /* NumberValue */ : "timestampValue" in t ? 3 /* TimestampValue */ : "stringValue" in t ? 5 /* StringValue */ : "bytesValue" in t ? 6 /* BlobValue */ : "referenceValue" in t ? 7 /* RefValue */ : "geoPointValue" in t ? 8 /* GeoPointValue */ : "arrayValue" in t ? 9 /* ArrayValue */ : "mapValue" in t ? x(t) ? 4 /* ServerTimestampValue */ : 10 /* ObjectValue */ : ve("Invalid value type: " + JSON.stringify(t));
}

/** Tests `left` and `right` for equality based on the backend semantics. */ function G(t, e) {
    const s = j(t);
    if (s !== j(e)) return !1;
    switch (s) {
      case 0 /* NullValue */ :
        return !0;

      case 1 /* BooleanValue */ :
        return t.booleanValue === e.booleanValue;

      case 4 /* ServerTimestampValue */ :
        return Q(t).isEqual(Q(e));

      case 3 /* TimestampValue */ :
        return function(t, e) {
            if ("string" == typeof t.timestampValue && "string" == typeof e.timestampValue && t.timestampValue.length === e.timestampValue.length) 
            // Use string equality for ISO 8601 timestamps
            return t.timestampValue === e.timestampValue;
            const s = X(t.timestampValue), i = X(e.timestampValue);
            return s.seconds === i.seconds && s.nanos === i.nanos;
        }(t, e);

      case 5 /* StringValue */ :
        return t.stringValue === e.stringValue;

      case 6 /* BlobValue */ :
        return function(t, e) {
            return tt(t.bytesValue).isEqual(tt(e.bytesValue));
        }(t, e);

      case 7 /* RefValue */ :
        return t.referenceValue === e.referenceValue;

      case 8 /* GeoPointValue */ :
        return function(t, e) {
            return Z(t.geoPointValue.latitude) === Z(e.geoPointValue.latitude) && Z(t.geoPointValue.longitude) === Z(e.geoPointValue.longitude);
        }(t, e);

      case 2 /* NumberValue */ :
        return function(t, e) {
            if ("integerValue" in t && "integerValue" in e) return Z(t.integerValue) === Z(e.integerValue);
            if ("doubleValue" in t && "doubleValue" in e) {
                const s = Z(t.doubleValue), i = Z(e.doubleValue);
                return s === i ? B(s) === B(i) : isNaN(s) && isNaN(i);
            }
            return !1;
        }(t, e);

      case 9 /* ArrayValue */ :
        return Fe(t.arrayValue.values || [], e.arrayValue.values || [], G);

      case 10 /* ObjectValue */ :
        return function(t, e) {
            const s = t.mapValue.fields || {}, i = e.mapValue.fields || {};
            if ($(s) !== $(i)) return !1;
            for (const t in s) if (s.hasOwnProperty(t) && (void 0 === i[t] || !G(s[t], i[t]))) return !1;
            return !0;
        }
        /** Returns true if the ArrayValue contains the specified element. */ (t, e);

      default:
        return ve("Unexpected value type: " + JSON.stringify(t));
    }
}

function z(t, e) {
    return void 0 !== (t.values || []).find(t => G(t, e));
}

function K(t, e) {
    const s = j(t), i = j(e);
    if (s !== i) return De(s, i);
    switch (s) {
      case 0 /* NullValue */ :
        return 0;

      case 1 /* BooleanValue */ :
        return De(t.booleanValue, e.booleanValue);

      case 2 /* NumberValue */ :
        return function(t, e) {
            const s = Z(t.integerValue || t.doubleValue), i = Z(e.integerValue || e.doubleValue);
            return s < i ? -1 : s > i ? 1 : s === i ? 0 : 
            // one or both are NaN.
            isNaN(s) ? isNaN(i) ? 0 : -1 : 1;
        }(t, e);

      case 3 /* TimestampValue */ :
        return H(t.timestampValue, e.timestampValue);

      case 4 /* ServerTimestampValue */ :
        return H(Q(t), Q(e));

      case 5 /* StringValue */ :
        return De(t.stringValue, e.stringValue);

      case 6 /* BlobValue */ :
        return function(t, e) {
            const s = tt(t), i = tt(e);
            return s.C(i);
        }(t.bytesValue, e.bytesValue);

      case 7 /* RefValue */ :
        return function(t, e) {
            const s = t.split("/"), i = e.split("/");
            for (let t = 0; t < s.length && t < i.length; t++) {
                const e = De(s[t], i[t]);
                if (0 !== e) return e;
            }
            return De(s.length, i.length);
        }(t.referenceValue, e.referenceValue);

      case 8 /* GeoPointValue */ :
        return function(t, e) {
            const s = De(Z(t.latitude), Z(e.latitude));
            if (0 !== s) return s;
            return De(Z(t.longitude), Z(e.longitude));
        }(t.geoPointValue, e.geoPointValue);

      case 9 /* ArrayValue */ :
        return function(t, e) {
            const s = t.values || [], i = e.values || [];
            for (let t = 0; t < s.length && t < i.length; ++t) {
                const e = K(s[t], i[t]);
                if (e) return e;
            }
            return De(s.length, i.length);
        }(t.arrayValue, e.arrayValue);

      case 10 /* ObjectValue */ :
        return function(t, e) {
            const s = t.fields || {}, i = Object.keys(s), n = e.fields || {}, r = Object.keys(n);
            // Even though MapValues are likely sorted correctly based on their insertion
            // order (e.g. when received from the backend), local modifications can bring
            // elements out of order. We need to re-sort the elements to ensure that
            // canonical IDs are independent of insertion order.
            i.sort(), r.sort();
            for (let t = 0; t < i.length && t < r.length; ++t) {
                const e = De(i[t], r[t]);
                if (0 !== e) return e;
                const h = K(s[i[t]], n[r[t]]);
                if (0 !== h) return h;
            }
            return De(i.length, r.length);
        }
        /**
 * Generates the canonical ID for the provided field value (as used in Target
 * serialization).
 */ (t.mapValue, e.mapValue);

      default:
        throw ve("Invalid value type: " + s);
    }
}

function H(t, e) {
    if ("string" == typeof t && "string" == typeof e && t.length === e.length) return De(t, e);
    const s = X(t), i = X(e), n = De(s.seconds, i.seconds);
    return 0 !== n ? n : De(s.nanos, i.nanos);
}

function J(t) {
    return Y(t);
}

function Y(t) {
    return "nullValue" in t ? "null" : "booleanValue" in t ? "" + t.booleanValue : "integerValue" in t ? "" + t.integerValue : "doubleValue" in t ? "" + t.doubleValue : "timestampValue" in t ? function(t) {
        const e = X(t);
        return `time(${e.seconds},${e.nanos})`;
    }(t.timestampValue) : "stringValue" in t ? t.stringValue : "bytesValue" in t ? tt(t.bytesValue).toBase64() : "referenceValue" in t ? (s = t.referenceValue, 
    C.tt(s).toString()) : "geoPointValue" in t ? `geo(${(e = t.geoPointValue).latitude},${e.longitude})` : "arrayValue" in t ? function(t) {
        let e = "[", s = !0;
        for (const i of t.values || []) s ? s = !1 : e += ",", e += Y(i);
        return e + "]";
    }
    /**
 * Converts the possible Proto values for a timestamp value into a "seconds and
 * nanos" representation.
 */ (t.arrayValue) : "mapValue" in t ? function(t) {
        // Iteration order in JavaScript is not guaranteed. To ensure that we generate
        // matching canonical IDs for identical maps, we need to sort the keys.
        const e = Object.keys(t.fields || {}).sort();
        let s = "{", i = !0;
        for (const n of e) i ? i = !1 : s += ",", s += `${n}:${Y(t.fields[n])}`;
        return s + "}";
    }(t.mapValue) : ve("Invalid value type: " + JSON.stringify(t));
    var e, s;
}

function X(t) {
    // The json interface (for the browser) will return an iso timestamp string,
    // while the proto js library (for node) will return a
    // google.protobuf.Timestamp instance.
    if (Se(!!t, "Cannot normalize null or undefined timestamp."), "string" == typeof t) {
        // The date string can have higher precision (nanos) than the Date class
        // (millis), so we do some custom parsing here.
        // Parse the nanos right out of the string.
        let e = 0;
        const s = W.exec(t);
        if (Se(!!s, "invalid timestamp: " + t), s[1]) {
            // Pad the fraction out to 9 digits (nanos).
            let t = s[1];
            t = (t + "000000000").substr(0, 9), e = Number(t);
        }
        // Parse the date to get the seconds.
                const i = new Date(t);
        return {
            seconds: Math.floor(i.getTime() / 1e3),
            nanos: e
        };
    }
    return {
        seconds: Z(t.seconds),
        nanos: Z(t.nanos)
    };
}

/**
 * Converts the possible Proto types for numbers into a JavaScript number.
 * Returns 0 if the value is not numeric.
 */ function Z(t) {
    // TODO(bjornick): Handle int64 greater than 53 bits.
    return "number" == typeof t ? t : "string" == typeof t ? Number(t) : 0;
}

/** Converts the possible Proto types for Blobs into a ByteString. */ function tt(t) {
    return "string" == typeof t ? U.fromBase64String(t) : U.fromUint8Array(t);
}

/** Returns a reference value for the provided database and key. */ function et(t, e) {
    return {
        referenceValue: `projects/${t.projectId}/databases/${t.database}/documents/${e.path.G()}`
    };
}

/** Returns true if `value` is an IntegerValue . */ function st(t) {
    return !!t && "integerValue" in t;
}

/** Returns true if `value` is a DoubleValue. */
/** Returns true if `value` is an ArrayValue. */
function it(t) {
    return !!t && "arrayValue" in t;
}

/** Returns true if `value` is a NullValue. */ function nt(t) {
    return !!t && "nullValue" in t;
}

/** Returns true if `value` is NaN. */ function rt(t) {
    return !!t && "doubleValue" in t && isNaN(Number(t.doubleValue));
}

/** Returns true if `value` is a MapValue. */ function ht(t) {
    return !!t && "mapValue" in t;
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Transforms a value into a server-generated timestamp. */ class ot {
    constructor() {}
    qt(t, e) {
        return function(t, e) {
            const s = {
                fields: {
                    __type__: {
                        stringValue: "server_timestamp"
                    },
                    __local_write_time__: {
                        timestampValue: {
                            seconds: t.seconds,
                            nanos: t.nanoseconds
                        }
                    }
                }
            };
            return e && (s.fields.__previous_value__ = e), {
                mapValue: s
            };
        }
        /**
 * Returns the value of the field before this ServerTimestamp was set.
 *
 * Preserving the previous values allows the user to display the last resoled
 * value until the backend responds with the timestamp.
 */ (e, t);
    }
    Bt(t, e) {
        return e;
    }
    xt(t) {
        return null;
 // Server timestamps are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof ot;
    }
}

ot.instance = new ot;

/** Transforms an array value via a union operation. */
class at {
    constructor(t) {
        this.elements = t;
    }
    qt(t, e) {
        return this.apply(t);
    }
    Bt(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        const e = lt(t);
        for (const t of this.elements) e.some(e => G(e, t)) || e.push(t);
        return {
            arrayValue: {
                values: e
            }
        };
    }
    xt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof at && Fe(this.elements, t.elements, G);
    }
}

/** Transforms an array value via a remove operation. */ class ut {
    constructor(t) {
        this.elements = t;
    }
    qt(t, e) {
        return this.apply(t);
    }
    Bt(t, e) {
        // The server just sends null as the transform result for array operations,
        // so we have to calculate a result the same as we do for local
        // applications.
        return this.apply(t);
    }
    apply(t) {
        let e = lt(t);
        for (const t of this.elements) e = e.filter(e => !G(e, t));
        return {
            arrayValue: {
                values: e
            }
        };
    }
    xt(t) {
        return null;
 // Array transforms are idempotent and don't require a base value.
        }
    isEqual(t) {
        return t instanceof ut && Fe(this.elements, t.elements, G);
    }
}

/**
 * Implements the backend semantics for locally computed NUMERIC_ADD (increment)
 * transforms. Converts all field values to integers or doubles, but unlike the
 * backend does not cap integer values at 2^63. Instead, JavaScript number
 * arithmetic is used and precision loss can occur for values greater than 2^53.
 */ class ct {
    constructor(t, e) {
        this.serializer = t, this.Qt = e;
    }
    qt(t, e) {
        // PORTING NOTE: Since JavaScript's integer arithmetic is limited to 53 bit
        // precision and resolves overflows by reducing precision, we do not
        // manually cap overflows at 2^63.
        const s = this.xt(t), i = this.asNumber(s) + this.asNumber(this.Qt);
        return st(s) && st(this.Qt) ? this.serializer.Wt(i) : this.serializer.jt(i);
    }
    Bt(t, e) {
        return e;
    }
    /**
     * Inspects the provided value, returning the provided value if it is already
     * a NumberValue, otherwise returning a coerced value of 0.
     */    xt(t) {
        return st(e = t) || function(t) {
            return !!t && "doubleValue" in t;
        }
        /** Returns true if `value` is either an IntegerValue or a DoubleValue. */ (e) ? t : {
            integerValue: 0
        };
        var e;
    }
    isEqual(t) {
        return t instanceof ct && G(this.Qt, t.Qt);
    }
    asNumber(t) {
        return Z(t.integerValue || t.doubleValue);
    }
}

function lt(t) {
    return it(t) && t.arrayValue.values ? t.arrayValue.values.slice() : [];
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a set of fields that can be used to partially patch a document.
 * FieldMask is used in conjunction with ObjectValue.
 * Examples:
 *   foo - Overwrites foo entirely with the provided value. If foo is not
 *         present in the companion ObjectValue, the field is deleted.
 *   foo.bar - Overwrites only the field bar of the object foo.
 *             If foo is not an object, foo is replaced with an object
 *             containing foo
 */ class _t {
    constructor(t) {
        this.fields = t;
        // TODO(dimond): validation of FieldMask
        }
    static Gt(t) {
        return new _t(t);
    }
    static zt(t) {
        let e = new k(S.k);
        return t.forEach(t => e = e.add(t)), new _t(e);
    }
    /**
     * Verifies that `fieldPath` is included by at least one field in this field
     * mask.
     *
     * This is an O(n) operation, where `n` is the size of the field mask.
     */    Kt(t) {
        let e = !1;
        return this.fields.forEach(s => {
            s.B(t) && (e = !0);
        }), e;
    }
    isEqual(t) {
        return this.fields.isEqual(t.fields);
    }
}

/** A field path and the TransformOperation to perform upon it. */ class dt {
    constructor(t, e) {
        this.field = t, this.transform = e;
    }
    isEqual(t) {
        return this.field.isEqual(t.field) && this.transform.isEqual(t.transform);
    }
}

/** The result of successfully applying a mutation to the backend. */ class ft {
    constructor(
    /**
     * The version at which the mutation was committed:
     *
     * - For most operations, this is the updateTime in the WriteResult.
     * - For deletes, the commitTime of the WriteResponse (because deletes are
     *   not stored and have no updateTime).
     *
     * Note that these versions can be different: No-op writes will not change
     * the updateTime even though the commitTime advances.
     */
    t, 
    /**
     * The resulting fields returned from the backend after a
     * TransformMutation has been committed. Contains one FieldValue for each
     * FieldTransform that was in the mutation.
     *
     * Will be null if the mutation was not a TransformMutation.
     */
    e) {
        this.version = t, this.transformResults = e;
    }
}

/**
 * Encodes a precondition for a mutation. This follows the model that the
 * backend accepts with the special case of an explicit "empty" precondition
 * (meaning no precondition).
 */ class wt {
    constructor(t, e) {
        this.updateTime = t, this.exists = e;
    }
    /** Creates a new Precondition with an exists flag. */    static exists(t) {
        return new wt(void 0, t);
    }
    /** Creates a new Precondition based on a version a document exists at. */    static updateTime(t) {
        return new wt(t);
    }
    /** Returns whether this Precondition is empty. */    get Ht() {
        return void 0 === this.updateTime && void 0 === this.exists;
    }
    /**
     * Returns true if the preconditions is valid for the given document
     * (or null if no document is available).
     */    Jt(t) {
        return void 0 !== this.updateTime ? t instanceof gt && t.version.isEqual(this.updateTime) : void 0 === this.exists || this.exists === t instanceof gt;
    }
    isEqual(t) {
        return this.exists === t.exists && (this.updateTime ? !!t.updateTime && this.updateTime.isEqual(t.updateTime) : !t.updateTime);
    }
}

wt.NONE = new wt;

/**
 * A mutation describes a self-contained change to a document. Mutations can
 * create, replace, delete, and update subsets of documents.
 *
 * Mutations not only act on the value of the document but also its version.
 *
 * For local mutations (mutations that haven't been committed yet), we preserve
 * the existing version for Set, Patch, and Transform mutations. For Delete
 * mutations, we reset the version to 0.
 *
 * Here's the expected transition table.
 *
 * MUTATION           APPLIED TO            RESULTS IN
 *
 * SetMutation        Document(v3)          Document(v3)
 * SetMutation        NoDocument(v3)        Document(v0)
 * SetMutation        null                  Document(v0)
 * PatchMutation      Document(v3)          Document(v3)
 * PatchMutation      NoDocument(v3)        NoDocument(v3)
 * PatchMutation      null                  null
 * TransformMutation  Document(v3)          Document(v3)
 * TransformMutation  NoDocument(v3)        NoDocument(v3)
 * TransformMutation  null                  null
 * DeleteMutation     Document(v3)          NoDocument(v0)
 * DeleteMutation     NoDocument(v3)        NoDocument(v0)
 * DeleteMutation     null                  NoDocument(v0)
 *
 * For acknowledged mutations, we use the updateTime of the WriteResponse as
 * the resulting version for Set, Patch, and Transform mutations. As deletes
 * have no explicit update time, we use the commitTime of the WriteResponse for
 * Delete mutations.
 *
 * If a mutation is acknowledged by the backend but fails the precondition check
 * locally, we return an `UnknownDocument` and rely on Watch to send us the
 * updated version.
 *
 * Note that TransformMutations don't create Documents (in the case of being
 * applied to a NoDocument), even though they would on the backend. This is
 * because the client always combines the TransformMutation with a SetMutation
 * or PatchMutation and we only want to apply the transform if the prior
 * mutation resulted in a Document (always true for a SetMutation, but not
 * necessarily for a PatchMutation).
 *
 * ## Subclassing Notes
 *
 * Subclasses of Mutation need to implement applyToRemoteDocument() and
 * applyToLocalView() to implement the actual behavior of applying the mutation
 * to some source document.
 */
class Tt {
    Yt(t) {}
    /**
     * Returns the version from the given document for use as the result of a
     * mutation. Mutations are defined to return the version of the base document
     * only if it is an existing document. Deleted and unknown documents have a
     * post-mutation version of SnapshotVersion.MIN.
     */    static Xt(t) {
        return t instanceof gt ? t.version : g.MIN;
    }
}

/**
 * A mutation that creates or replaces the document at the given key with the
 * object value contents.
 */ class mt extends Tt {
    constructor(t, e, s) {
        super(), this.key = t, this.value = e, this.Zt = s, this.type = 0 /* Set */;
    }
    Bt(t, e) {
        this.Yt(t);
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        const s = e.version;
        return new gt(this.key, s, this.value, {
            hasCommittedMutations: !0
        });
    }
    qt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const i = Tt.Xt(t);
        return new gt(this.key, i, this.value, {
            te: !0
        });
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof mt && this.key.isEqual(t.key) && this.value.isEqual(t.value) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * A mutation that modifies fields of the document at the given key with the
 * given values. The values are applied through a field mask:
 *
 *  * When a field is in both the mask and the values, the corresponding field
 *    is updated.
 *  * When a field is in neither the mask nor the values, the corresponding
 *    field is unmodified.
 *  * When a field is in the mask but not in the values, the corresponding field
 *    is deleted.
 *  * When a field is not in the mask but is in the values, the values map is
 *    ignored.
 */ class Et extends Tt {
    constructor(t, e, s, i) {
        super(), this.key = t, this.data = e, this.se = s, this.Zt = i, this.type = 1 /* Patch */;
    }
    Bt(t, e) {
        if (this.Yt(t), !this.Zt.Jt(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new bt(this.key, e.version);
        const s = this.ie(t);
        return new gt(this.key, e.version, s, {
            hasCommittedMutations: !0
        });
    }
    qt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const i = Tt.Xt(t), n = this.ie(t);
        return new gt(this.key, i, n, {
            te: !0
        });
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof Et && this.key.isEqual(t.key) && this.se.isEqual(t.se) && this.Zt.isEqual(t.Zt);
    }
    /**
     * Patches the data of document if available or creates a new document. Note
     * that this does not check whether or not the precondition of this patch
     * holds.
     */    ie(t) {
        let e;
        return e = t instanceof gt ? t.data() : Pt.EMPTY, this.ne(e);
    }
    ne(t) {
        const e = t.re();
        return this.se.fields.forEach(t => {
            if (!t.q()) {
                const s = this.data.field(t);
                null !== s ? e.set(t, s) : e.delete(t);
            }
        }), e.he();
    }
}

/**
 * A mutation that modifies specific fields of the document with transform
 * operations. Currently the only supported transform is a server timestamp, but
 * IP Address, increment(n), etc. could be supported in the future.
 *
 * It is somewhat similar to a PatchMutation in that it patches specific fields
 * and has no effect when applied to a null or NoDocument (see comment on
 * Mutation for rationale).
 */ class Rt extends Tt {
    constructor(t, e) {
        super(), this.key = t, this.fieldTransforms = e, this.type = 2 /* Transform */ , 
        // NOTE: We set a precondition of exists: true as a safety-check, since we
        // always combine TransformMutations with a SetMutation or PatchMutation which
        // (if successful) should end up with an existing document.
        this.Zt = wt.exists(!0);
    }
    Bt(t, e) {
        if (this.Yt(t), Se(null != e.transformResults, "Transform results missing for TransformMutation."), 
        !this.Zt.Jt(t)) 
        // Since the mutation was not rejected, we know that the  precondition
        // matched on the backend. We therefore must not have the expected version
        // of the document in our cache and return an UnknownDocument with the
        // known updateTime.
        return new bt(this.key, e.version);
        const s = this.oe(t), i = this.ae(t, e.transformResults), n = e.version, r = this.ue(s.data(), i);
        return new gt(this.key, n, r, {
            hasCommittedMutations: !0
        });
    }
    qt(t, e, s) {
        if (this.Yt(t), !this.Zt.Jt(t)) return t;
        const i = this.oe(t), n = this.ce(s, t, e), r = this.ue(i.data(), n);
        return new gt(this.key, i.version, r, {
            te: !0
        });
    }
    ee(t) {
        let e = null;
        for (const s of this.fieldTransforms) {
            const i = t instanceof gt ? t.field(s.field) : void 0, n = s.transform.xt(i || null);
            null != n && (e = null == e ? Pt.le().set(s.field, n) : e.set(s.field, n));
        }
        return e ? e.he() : null;
    }
    isEqual(t) {
        return t instanceof Rt && this.key.isEqual(t.key) && Fe(this.fieldTransforms, t.fieldTransforms, (t, e) => t.isEqual(e)) && this.Zt.isEqual(t.Zt);
    }
    /**
     * Asserts that the given MaybeDocument is actually a Document and verifies
     * that it matches the key for this mutation. Since we only support
     * transformations with precondition exists this method is guaranteed to be
     * safe.
     */    oe(t) {
        return t;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use after a
     * TransformMutation has been acknowledged by the server.
     *
     * @param baseDoc The document prior to applying this mutation batch.
     * @param serverTransformResults The transform results received by the server.
     * @return The transform results list.
     */    ae(t, e) {
        const s = [];
        Se(this.fieldTransforms.length === e.length, `server transform result count (${e.length}) ` + `should match field transform count (${this.fieldTransforms.length})`);
        for (let i = 0; i < e.length; i++) {
            const n = this.fieldTransforms[i], r = n.transform;
            let h = null;
            t instanceof gt && (h = t.field(n.field)), s.push(r.Bt(h, e[i]));
        }
        return s;
    }
    /**
     * Creates a list of "transform results" (a transform result is a field value
     * representing the result of applying a transform) for use when applying a
     * TransformMutation locally.
     *
     * @param localWriteTime The local time of the transform mutation (used to
     *     generate ServerTimestampValues).
     * @param maybeDoc The current state of the document after applying all
     *     previous mutations.
     * @param baseDoc The document prior to applying this mutation batch.
     * @return The transform results list.
     */    ce(t, e, s) {
        const i = [];
        for (const n of this.fieldTransforms) {
            const r = n.transform;
            let h = null;
            e instanceof gt && (h = e.field(n.field)), null === h && s instanceof gt && (
            // If the current document does not contain a value for the mutated
            // field, use the value that existed before applying this mutation
            // batch. This solves an edge case where a PatchMutation clears the
            // values in a nested map before the TransformMutation is applied.
            h = s.field(n.field)), i.push(r.qt(h, t));
        }
        return i;
    }
    ue(t, e) {
        const s = t.re();
        for (let t = 0; t < this.fieldTransforms.length; t++) {
            const i = this.fieldTransforms[t].field;
            s.set(i, e[t]);
        }
        return s.he();
    }
}

/** A mutation that deletes the document at the given key. */ class It extends Tt {
    constructor(t, e) {
        super(), this.key = t, this.Zt = e, this.type = 3 /* Delete */;
    }
    Bt(t, e) {
        // Unlike applyToLocalView, if we're applying a mutation to a remote
        // document the server has accepted the mutation so the precondition must
        // have held.
        return this.Yt(t), new yt(this.key, e.version, {
            hasCommittedMutations: !0
        });
    }
    qt(t, e, s) {
        return this.Yt(t), this.Zt.Jt(t) ? new yt(this.key, g.S()) : t;
    }
    ee(t) {
        return null;
    }
    isEqual(t) {
        return t instanceof It && this.key.isEqual(t.key) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * A mutation that verifies the existence of the document at the given key with
 * the provided precondition.
 *
 * The `verify` operation is only used in Transactions, and this class serves
 * primarily to facilitate serialization into protos.
 */ class At extends Tt {
    constructor(t, e) {
        super(), this.key = t, this.Zt = e, this.type = 4 /* Verify */;
    }
    Bt(t, e) {
        ve("VerifyMutation should only be used in Transactions.");
    }
    qt(t, e, s) {
        ve("VerifyMutation should only be used in Transactions.");
    }
    ee(t) {
        ve("VerifyMutation should only be used in Transactions.");
    }
    isEqual(t) {
        return t instanceof At && this.key.isEqual(t.key) && this.Zt.isEqual(t.Zt);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An ObjectValue represents a MapValue in the Firestore Proto and offers the
 * ability to add and remove fields (via the ObjectValueBuilder).
 */ class Pt {
    constructor(t) {
        this.proto = t;
    }
    /** Returns a new Builder instance that is based on an empty object. */    static le() {
        return Pt.EMPTY.re();
    }
    /**
     * Returns the value at the given path or null.
     *
     * @param path the path to search
     * @return The value at the path or if there it doesn't exist.
     */    field(t) {
        if (t.q()) return this.proto;
        {
            let e = this.proto;
            for (let s = 0; s < t.length - 1; ++s) {
                if (!e.mapValue.fields) return null;
                if (e = e.mapValue.fields[t.get(s)], !ht(e)) return null;
            }
            return e = (e.mapValue.fields || {})[t.U()], e || null;
        }
    }
    /**
     * Returns a FieldMask built from all FieldPaths starting from this
     * ObjectValue, including paths from nested objects.
     */    se() {
        return this._e(this.proto.mapValue);
    }
    _e(t) {
        let e = new k(S.k);
        return O(t.fields || {}, (t, s) => {
            const i = new S([ t ]);
            if (10 /* ObjectValue */ === j(s)) {
                const t = this._e(s.mapValue).fields;
                t.q() ? 
                // Preserve the empty map by adding it to the FieldMask.
                e = e.add(i) : 
                // For nested and non-empty ObjectValues, add the FieldPath of the
                // leaf nodes.
                t.forEach(t => {
                    e = e.add(i.child(t));
                });
            } else 
            // For nested and non-empty ObjectValues, add the FieldPath of the leaf
            // nodes.
            e = e.add(i);
        }), _t.Gt(e);
    }
    isEqual(t) {
        return G(this.proto, t.proto);
    }
    /** Creates a ObjectValueBuilder instance that is based on the current value. */    re() {
        return new Vt(this);
    }
}

Pt.EMPTY = new Pt({
    mapValue: {}
});

/**
 * An ObjectValueBuilder provides APIs to set and delete fields from an
 * ObjectValue.
 */
class Vt {
    /**
     * @param baseObject The object to mutate.
     */
    constructor(t) {
        this.de = t, 
        /** A map that contains the accumulated changes in this builder. */
        this.fe = new Map;
    }
    /**
     * Sets the field to the provided value.
     *
     * @param path The field path to set.
     * @param value The value to set.
     * @return The current Builder instance.
     */    set(t, e) {
        return this.we(t, e), this;
    }
    /**
     * Removes the field at the specified path. If there is no field at the
     * specified path, nothing is changed.
     *
     * @param path The field path to remove.
     * @return The current Builder instance.
     */    delete(t) {
        return this.we(t, null), this;
    }
    /**
     * Adds `value` to the overlay map at `path`. Creates nested map entries if
     * needed.
     */    we(t, e) {
        let s = this.fe;
        for (let e = 0; e < t.length - 1; ++e) {
            const i = t.get(e);
            let n = s.get(i);
            n instanceof Map ? 
            // Re-use a previously created map
            s = n : n && 10 /* ObjectValue */ === j(n) ? (
            // Convert the existing Protobuf MapValue into a map
            n = new Map(Object.entries(n.mapValue.fields || {})), s.set(i, n), s = n) : (
            // Create an empty map to represent the current nesting level
            n = new Map, s.set(i, n), s = n);
        }
        s.set(t.U(), e);
    }
    /** Returns an ObjectValue with all mutations applied. */    he() {
        const t = this.Te(S.H, this.fe);
        return null != t ? new Pt(t) : this.de;
    }
    /**
     * Applies any overlays from `currentOverlays` that exist at `currentPath`
     * and returns the merged data at `currentPath` (or null if there were no
     * changes).
     *
     * @param currentPath The path at the current nesting level. Can be set to
     * FieldValue.EMPTY_PATH to represent the root.
     * @param currentOverlays The overlays at the current nesting level in the
     * same format as `overlayMap`.
     * @return The merged data at `currentPath` or null if no modifications
     * were applied.
     */    Te(t, e) {
        let s = !1;
        const i = this.de.field(t), n = ht(i) ? // If there is already data at the current path, base our
        Object.assign({}, i.mapValue.fields) : {};
        return e.forEach((e, i) => {
            if (e instanceof Map) {
                const r = this.Te(t.child(i), e);
                null != r && (n[i] = r, s = !0);
            } else null !== e ? (n[i] = e, s = !0) : n.hasOwnProperty(i) && (delete n[i], s = !0);
        }), s ? {
            mapValue: {
                fields: n
            }
        } : null;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * The result of a lookup for a given path may be an existing document or a
 * marker that this document does not exist at a given version.
 */ class pt {
    constructor(t, e) {
        this.key = t, this.version = e;
    }
    static me(t, e) {
        return C.k(t.key, e.key);
    }
}

/**
 * Represents a document in Firestore with a key, version, data and whether the
 * data has local mutations applied to it.
 */ class gt extends pt {
    constructor(t, e, s, i) {
        super(t, e), this.Ee = s, this.te = !!i.te, this.hasCommittedMutations = !!i.hasCommittedMutations;
    }
    field(t) {
        return this.Ee.field(t);
    }
    data() {
        return this.Ee;
    }
    Re() {
        return this.Ee.proto;
    }
    isEqual(t) {
        return t instanceof gt && this.key.isEqual(t.key) && this.version.isEqual(t.version) && this.te === t.te && this.hasCommittedMutations === t.hasCommittedMutations && this.Ee.isEqual(t.Ee);
    }
    toString() {
        return `Document(${this.key}, ${this.version}, ${this.Ee.toString()}, ` + `{hasLocalMutations: ${this.te}}), ` + `{hasCommittedMutations: ${this.hasCommittedMutations}})`;
    }
    get hasPendingWrites() {
        return this.te || this.hasCommittedMutations;
    }
    static Ie(t, e, s) {
        const i = e.field(t), n = s.field(t);
        return null !== i && null !== n ? K(i, n) : ve("Trying to compare documents on fields that don't exist");
    }
}

/**
 * A class representing a deleted document.
 * Version is set to 0 if we don't point to any specific time, otherwise it
 * denotes time we know it didn't exist at.
 */ class yt extends pt {
    constructor(t, e, s) {
        super(t, e), this.hasCommittedMutations = !(!s || !s.hasCommittedMutations);
    }
    toString() {
        return `NoDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return this.hasCommittedMutations;
    }
    isEqual(t) {
        return t instanceof yt && t.hasCommittedMutations === this.hasCommittedMutations && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * A class representing an existing document whose data is unknown (e.g. a
 * document that was updated without a known base document).
 */ class bt extends pt {
    toString() {
        return `UnknownDocument(${this.key}, ${this.version})`;
    }
    get hasPendingWrites() {
        return !0;
    }
    isEqual(t) {
        return t instanceof bt && t.version.isEqual(this.version) && t.key.isEqual(this.key);
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A Target represents the WatchTarget representation of a Query, which is used
 * by the LocalStore and the RemoteStore to keep track of and to execute
 * backend queries. While a Query can represent multiple Targets, each Targets
 * maps to a single WatchTarget in RemoteStore and a single TargetData entry
 * in persistence.
 */ class vt {
    /**
     * Initializes a Target with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     *
     * NOTE: you should always construct `Target` from `Query.toTarget` instead of
     * using this constructor, because `Query` provides an implicit `orderBy`
     * property.
     */
    constructor(t, e = null, s = [], i = [], n = null, r = null, h = null) {
        this.path = t, this.collectionGroup = e, this.orderBy = s, this.filters = i, this.limit = n, 
        this.startAt = r, this.endAt = h, this.Ae = null;
    }
    canonicalId() {
        if (null === this.Ae) {
            let t = this.path.G();
            null !== this.collectionGroup && (t += "|cg:" + this.collectionGroup), t += "|f:", 
            t += this.filters.map(t => t.canonicalId()).join(","), t += "|ob:", t += this.orderBy.map(t => t.canonicalId()).join(","), 
            q(this.limit) || (t += "|l:", t += this.limit), this.startAt && (t += "|lb:", t += this.startAt.canonicalId()), 
            this.endAt && (t += "|ub:", t += this.endAt.canonicalId()), this.Ae = t;
        }
        return this.Ae;
    }
    toString() {
        let t = this.path.G();
        return null !== this.collectionGroup && (t += " collectionGroup=" + this.collectionGroup), 
        this.filters.length > 0 && (t += `, filters: [${this.filters.join(", ")}]`), q(this.limit) || (t += ", limit: " + this.limit), 
        this.orderBy.length > 0 && (t += `, orderBy: [${this.orderBy.join(", ")}]`), this.startAt && (t += ", startAt: " + this.startAt.canonicalId()), 
        this.endAt && (t += ", endAt: " + this.endAt.canonicalId()), `Target(${t})`;
    }
    isEqual(t) {
        if (this.limit !== t.limit) return !1;
        if (this.orderBy.length !== t.orderBy.length) return !1;
        for (let e = 0; e < this.orderBy.length; e++) if (!this.orderBy[e].isEqual(t.orderBy[e])) return !1;
        if (this.filters.length !== t.filters.length) return !1;
        for (let e = 0; e < this.filters.length; e++) if (!this.filters[e].isEqual(t.filters[e])) return !1;
        return this.collectionGroup === t.collectionGroup && (!!this.path.isEqual(t.path) && (!!(null !== this.startAt ? this.startAt.isEqual(t.startAt) : null === t.startAt) && (null !== this.endAt ? this.endAt.isEqual(t.endAt) : null === t.endAt)));
    }
    Pe() {
        return C.st(this.path) && null === this.collectionGroup && 0 === this.filters.length;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Query encapsulates all the query attributes we support in the SDK. It can
 * be run against the LocalStore, as well as be converted to a `Target` to
 * query the RemoteStore results.
 */ class St {
    /**
     * Initializes a Query with a path and optional additional query constraints.
     * Path must currently be empty if this is a collection group query.
     */
    constructor(t, e = null, s = [], i = [], n = null, r = "F" /* First */ , h = null, o = null) {
        this.path = t, this.collectionGroup = e, this.Ve = s, this.filters = i, this.limit = n, 
        this.pe = r, this.startAt = h, this.endAt = o, this.ge = null, 
        // The corresponding `Target` of this `Query` instance.
        this.ye = null, this.startAt && this.be(this.startAt), this.endAt && this.be(this.endAt);
    }
    static ve(t) {
        return new St(t);
    }
    get orderBy() {
        if (null === this.ge) {
            const t = this.Se(), e = this.Ce();
            if (null !== t && null === e) 
            // In order to implicitly add key ordering, we must also add the
            // inequality filter field for it to be a valid query.
            // Note that the default inequality field and key ordering is ascending.
            t.Y() ? this.ge = [ qt ] : this.ge = [ new Ut(t), qt ]; else {
                this.ge = [];
                let t = !1;
                for (const e of this.Ve) this.ge.push(e), e.field.Y() && (t = !0);
                if (!t) {
                    // The order of the implicit key ordering always matches the last
                    // explicit order by
                    const t = this.Ve.length > 0 ? this.Ve[this.Ve.length - 1].dir : Ot.ASCENDING;
                    this.ge.push(t === Ot.ASCENDING ? qt : Bt);
                }
            }
        }
        return this.ge;
    }
    De(t) {
        const e = this.filters.concat([ t ]);
        return new St(this.path, this.collectionGroup, this.Ve.slice(), e, this.limit, this.pe, this.startAt, this.endAt);
    }
    Fe(t) {
        // TODO(dimond): validate that orderBy does not list the same key twice.
        const e = this.Ve.concat([ t ]);
        return new St(this.path, this.collectionGroup, e, this.filters.slice(), this.limit, this.pe, this.startAt, this.endAt);
    }
    Ne(t) {
        return new St(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), t, "F" /* First */ , this.startAt, this.endAt);
    }
    ke(t) {
        return new St(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), t, "L" /* Last */ , this.startAt, this.endAt);
    }
    Le(t) {
        return new St(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), this.limit, this.pe, t, this.endAt);
    }
    $e(t) {
        return new St(this.path, this.collectionGroup, this.Ve.slice(), this.filters.slice(), this.limit, this.pe, this.startAt, t);
    }
    /**
     * Helper to convert a collection group query into a collection query at a
     * specific path. This is used when executing collection group queries, since
     * we have to split the query into a set of collection queries at multiple
     * paths.
     */    Oe(t) {
        return new St(t, 
        /*collectionGroup=*/ null, this.Ve.slice(), this.filters.slice(), this.limit, this.pe, this.startAt, this.endAt);
    }
    /**
     * Returns true if this query does not specify any query constraints that
     * could remove results.
     */    Me() {
        return 0 === this.filters.length && null === this.limit && null == this.startAt && null == this.endAt && (0 === this.Ve.length || 1 === this.Ve.length && this.Ve[0].field.Y());
    }
    // TODO(b/29183165): This is used to get a unique string from a query to, for
    // example, use as a dictionary key, but the implementation is subject to
    // collisions. Make it collision-free.
    canonicalId() {
        return `${this.Ue().canonicalId()}|lt:${this.pe}`;
    }
    toString() {
        return `Query(target=${this.Ue().toString()}; limitType=${this.pe})`;
    }
    isEqual(t) {
        return this.Ue().isEqual(t.Ue()) && this.pe === t.pe;
    }
    qe(t, e) {
        let s = !1;
        for (const i of this.orderBy) {
            const n = i.compare(t, e);
            if (0 !== n) return n;
            s = s || i.field.Y();
        }
        return 0;
    }
    matches(t) {
        return this.Be(t) && this.xe(t) && this.Qe(t) && this.We(t);
    }
    je() {
        return !q(this.limit) && "F" /* First */ === this.pe;
    }
    Ge() {
        return !q(this.limit) && "L" /* Last */ === this.pe;
    }
    Ce() {
        return this.Ve.length > 0 ? this.Ve[0].field : null;
    }
    Se() {
        for (const t of this.filters) if (t instanceof Dt && t.ze()) return t.field;
        return null;
    }
    // Checks if any of the provided Operators are included in the query and
    // returns the first one that is, or null if none are.
    Ke(t) {
        for (const e of this.filters) if (e instanceof Dt && t.indexOf(e.op) >= 0) return e.op;
        return null;
    }
    Pe() {
        return this.Ue().Pe();
    }
    He() {
        return null !== this.collectionGroup;
    }
    /**
     * Converts this `Query` instance to it's corresponding `Target`
     * representation.
     */    Ue() {
        if (!this.ye) if ("F" /* First */ === this.pe) this.ye = new vt(this.path, this.collectionGroup, this.orderBy, this.filters, this.limit, this.startAt, this.endAt); else {
            // Flip the orderBy directions since we want the last results
            const t = [];
            for (const e of this.orderBy) {
                const s = e.dir === Ot.DESCENDING ? Ot.ASCENDING : Ot.DESCENDING;
                t.push(new Ut(e.field, s));
            }
            // We need to swap the cursors to match the now-flipped query ordering.
                        const e = this.endAt ? new Mt(this.endAt.position, !this.endAt.before) : null, s = this.startAt ? new Mt(this.startAt.position, !this.startAt.before) : null;
            // Now return as a LimitType.First query.
            this.ye = new vt(this.path, this.collectionGroup, t, this.filters, this.limit, e, s);
        }
        return this.ye;
    }
    Be(t) {
        const e = t.key.path;
        return null !== this.collectionGroup ? t.key.et(this.collectionGroup) && this.path.B(e) : C.st(this.path) ? this.path.isEqual(e) : this.path.W(e);
    }
    /**
     * A document must have a value for every ordering clause in order to show up
     * in the results.
     */    xe(t) {
        for (const e of this.Ve) 
        // order by key always matches
        if (!e.field.Y() && null === t.field(e.field)) return !1;
        return !0;
    }
    Qe(t) {
        for (const e of this.filters) if (!e.matches(t)) return !1;
        return !0;
    }
    /**
     * Makes sure a document is within the bounds, if provided.
     */    We(t) {
        return !(this.startAt && !this.startAt.Je(this.orderBy, t)) && (!this.endAt || !this.endAt.Je(this.orderBy, t));
    }
    be(t) {}
}

class Ct {
    constructor(t) {
        this.name = t;
    }
    static K(t) {
        switch (t) {
          case "<":
            return Ct.LESS_THAN;

          case "<=":
            return Ct.LESS_THAN_OR_EQUAL;

          case "==":
            return Ct.EQUAL;

          case ">=":
            return Ct.GREATER_THAN_OR_EQUAL;

          case ">":
            return Ct.GREATER_THAN;

          case "array-contains":
            return Ct.ARRAY_CONTAINS;

          case "in":
            return Ct.IN;

          case "array-contains-any":
            return Ct.ARRAY_CONTAINS_ANY;

          default:
            return ve("Unknown FieldFilter operator: " + t);
        }
    }
    toString() {
        return this.name;
    }
    isEqual(t) {
        return this.name === t.name;
    }
}

Ct.LESS_THAN = new Ct("<"), Ct.LESS_THAN_OR_EQUAL = new Ct("<="), Ct.EQUAL = new Ct("=="), 
Ct.GREATER_THAN = new Ct(">"), Ct.GREATER_THAN_OR_EQUAL = new Ct(">="), Ct.ARRAY_CONTAINS = new Ct("array-contains"), 
Ct.IN = new Ct("in"), Ct.ARRAY_CONTAINS_ANY = new Ct("array-contains-any");

class Dt extends class {} {
    constructor(t, e, s) {
        super(), this.field = t, this.op = e, this.value = s;
    }
    /**
     * Creates a filter based on the provided arguments.
     */    static create(t, e, s) {
        if (t.Y()) return e === Ct.IN ? new Nt(t, s) : new Ft(t, e, s);
        if (nt(s)) {
            if (e !== Ct.EQUAL) throw new E(m.INVALID_ARGUMENT, "Invalid query. Null supports only equality comparisons.");
            return new Dt(t, e, s);
        }
        if (rt(s)) {
            if (e !== Ct.EQUAL) throw new E(m.INVALID_ARGUMENT, "Invalid query. NaN supports only equality comparisons.");
            return new Dt(t, e, s);
        }
        return e === Ct.ARRAY_CONTAINS ? new kt(t, s) : e === Ct.IN ? new Lt(t, s) : e === Ct.ARRAY_CONTAINS_ANY ? new $t(t, s) : new Dt(t, e, s);
    }
    matches(t) {
        const e = t.field(this.field);
        // Only compare types with matching backend order (such as double and int).
                return null !== e && j(this.value) === j(e) && this.Ye(K(e, this.value));
    }
    Ye(t) {
        switch (this.op) {
          case Ct.LESS_THAN:
            return t < 0;

          case Ct.LESS_THAN_OR_EQUAL:
            return t <= 0;

          case Ct.EQUAL:
            return 0 === t;

          case Ct.GREATER_THAN:
            return t > 0;

          case Ct.GREATER_THAN_OR_EQUAL:
            return t >= 0;

          default:
            return ve("Unknown FieldFilter operator: " + this.op);
        }
    }
    ze() {
        return [ Ct.LESS_THAN, Ct.LESS_THAN_OR_EQUAL, Ct.GREATER_THAN, Ct.GREATER_THAN_OR_EQUAL ].indexOf(this.op) >= 0;
    }
    canonicalId() {
        // TODO(b/29183165): Technically, this won't be unique if two values have
        // the same description, such as the int 3 and the string "3". So we should
        // add the types in here somehow, too.
        return this.field.G() + this.op.toString() + J(this.value);
    }
    isEqual(t) {
        return t instanceof Dt && (this.op.isEqual(t.op) && this.field.isEqual(t.field) && G(this.value, t.value));
    }
    toString() {
        return `${this.field.G()} ${this.op} ${J(this.value)}`;
    }
}

/** Filter that matches on key fields (i.e. '__name__'). */ class Ft extends Dt {
    constructor(t, e, s) {
        super(t, e, s), this.key = C.tt(s.referenceValue);
    }
    matches(t) {
        const e = C.k(t.key, this.key);
        return this.Ye(e);
    }
}

/** Filter that matches on key fields within an array. */ class Nt extends Dt {
    constructor(t, e) {
        super(t, Ct.IN, e), this.keys = (e.arrayValue.values || []).map(t => C.tt(t.referenceValue));
    }
    matches(t) {
        return this.keys.some(e => e.isEqual(t.key));
    }
}

/** A Filter that implements the array-contains operator. */ class kt extends Dt {
    constructor(t, e) {
        super(t, Ct.ARRAY_CONTAINS, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return it(e) && z(e.arrayValue, this.value);
    }
}

/** A Filter that implements the IN operator. */ class Lt extends Dt {
    constructor(t, e) {
        super(t, Ct.IN, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return null !== e && z(this.value.arrayValue, e);
    }
}

/** A Filter that implements the array-contains-any operator. */ class $t extends Dt {
    constructor(t, e) {
        super(t, Ct.ARRAY_CONTAINS_ANY, e);
    }
    matches(t) {
        const e = t.field(this.field);
        return !(!it(e) || !e.arrayValue.values) && e.arrayValue.values.some(t => z(this.value.arrayValue, t));
    }
}

/**
 * The direction of sorting in an order by.
 */ class Ot {
    constructor(t) {
        this.name = t;
    }
    toString() {
        return this.name;
    }
}

Ot.ASCENDING = new Ot("asc"), Ot.DESCENDING = new Ot("desc");

/**
 * Represents a bound of a query.
 *
 * The bound is specified with the given components representing a position and
 * whether it's just before or just after the position (relative to whatever the
 * query order is).
 *
 * The position represents a logical index position for a query. It's a prefix
 * of values for the (potentially implicit) order by clauses of a query.
 *
 * Bound provides a function to determine whether a document comes before or
 * after a bound. This is influenced by whether the position is just before or
 * just after the provided values.
 */
class Mt {
    constructor(t, e) {
        this.position = t, this.before = e;
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        return `${this.before ? "b" : "a"}:${this.position.map(t => J(t)).join(",")}`;
    }
    /**
     * Returns true if a document sorts before a bound using the provided sort
     * order.
     */    Je(t, e) {
        let s = 0;
        for (let i = 0; i < this.position.length; i++) {
            const n = t[i], r = this.position[i];
            if (n.field.Y()) s = C.k(C.tt(r.referenceValue), e.key); else {
                s = K(r, e.field(n.field));
            }
            if (n.dir === Ot.DESCENDING && (s *= -1), 0 !== s) break;
        }
        return this.before ? s <= 0 : s < 0;
    }
    isEqual(t) {
        if (null === t) return !1;
        if (this.before !== t.before || this.position.length !== t.position.length) return !1;
        for (let e = 0; e < this.position.length; e++) {
            if (!G(this.position[e], t.position[e])) return !1;
        }
        return !0;
    }
}

/**
 * An ordering on a field, in some Direction. Direction defaults to ASCENDING.
 */ class Ut {
    constructor(t, e) {
        this.field = t, void 0 === e && (e = Ot.ASCENDING), this.dir = e, this.Xe = t.Y();
    }
    compare(t, e) {
        const s = this.Xe ? gt.me(t, e) : gt.Ie(this.field, t, e);
        switch (this.dir) {
          case Ot.ASCENDING:
            return s;

          case Ot.DESCENDING:
            return -1 * s;

          default:
            return ve("Unknown direction: " + this.dir);
        }
    }
    canonicalId() {
        // TODO(b/29183165): Make this collision robust.
        return this.field.G() + this.dir.toString();
    }
    toString() {
        return `${this.field.G()} (${this.dir})`;
    }
    isEqual(t) {
        return this.dir === t.dir && this.field.isEqual(t.field);
    }
}

const qt = new Ut(S.X(), Ot.ASCENDING), Bt = new Ut(S.X(), Ot.DESCENDING);

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An immutable set of metadata that the local store tracks for each target.
 */
class xt {
    constructor(
    /** The target being listened to. */
    t, 
    /**
     * The target ID to which the target corresponds; Assigned by the
     * LocalStore for user listens and by the SyncEngine for limbo watches.
     */
    e, 
    /** The purpose of the target. */
    s, 
    /**
     * The sequence number of the last transaction during which this target data
     * was modified.
     */
    i, 
    /** The latest snapshot version seen for this target. */
    n = g.MIN
    /**
     * The maximum snapshot version at which the associated view
     * contained no limbo documents.
     */ , r = g.MIN
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */ , h = U.Ut) {
        this.target = t, this.targetId = e, this.Ze = s, this.sequenceNumber = i, this.ts = n, 
        this.lastLimboFreeSnapshotVersion = r, this.resumeToken = h;
    }
    /** Creates a new target data instance with an updated sequence number. */    es(t) {
        return new xt(this.target, this.targetId, this.Ze, t, this.ts, this.lastLimboFreeSnapshotVersion, this.resumeToken);
    }
    /**
     * Creates a new target data instance with an updated resume token and
     * snapshot version.
     */    ss(t, e) {
        return new xt(this.target, this.targetId, this.Ze, this.sequenceNumber, e, this.lastLimboFreeSnapshotVersion, t);
    }
    /**
     * Creates a new target data instance with an updated last limbo free
     * snapshot version number.
     */    ns(t) {
        return new xt(this.target, this.targetId, this.Ze, this.sequenceNumber, this.ts, t, this.resumeToken);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Qt {
    // TODO(b/33078163): just use simplest form of existence filter for now
    constructor(t) {
        this.count = t;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Error Codes describing the different ways GRPC can fail. These are copied
 * directly from GRPC's sources here:
 *
 * https://github.com/grpc/grpc/blob/bceec94ea4fc5f0085d81235d8e1c06798dc341a/include/grpc%2B%2B/impl/codegen/status_code_enum.h
 *
 * Important! The names of these identifiers matter because the string forms
 * are used for reverse lookups from the webchannel stream. Do NOT change the
 * names of these identifiers or change this into a const enum.
 */ var Wt, jt;

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a non-write operation.
 *
 * See isPermanentWriteError for classifying write errors.
 */
function Gt(t) {
    switch (t) {
      case m.OK:
        return ve("Treated status OK as error");

      case m.CANCELLED:
      case m.UNKNOWN:
      case m.DEADLINE_EXCEEDED:
      case m.RESOURCE_EXHAUSTED:
      case m.INTERNAL:
      case m.UNAVAILABLE:
 // Unauthenticated means something went wrong with our token and we need
        // to retry with new credentials which will happen automatically.
              case m.UNAUTHENTICATED:
        return !1;

      case m.INVALID_ARGUMENT:
      case m.NOT_FOUND:
      case m.ALREADY_EXISTS:
      case m.PERMISSION_DENIED:
      case m.FAILED_PRECONDITION:
 // Aborted might be retried in some scenarios, but that is dependant on
        // the context and should handled individually by the calling code.
        // See https://cloud.google.com/apis/design/errors.
              case m.ABORTED:
      case m.OUT_OF_RANGE:
      case m.UNIMPLEMENTED:
      case m.DATA_LOSS:
        return !0;

      default:
        return ve("Unknown status code: " + t);
    }
}

/**
 * Determines whether an error code represents a permanent error when received
 * in response to a write operation.
 *
 * Write operations must be handled specially because as of b/119437764, ABORTED
 * errors on the write stream should be retried too (even though ABORTED errors
 * are not generally retryable).
 *
 * Note that during the initial handshake on the write stream an ABORTED error
 * signals that we should discard our stream token (i.e. it is permanent). This
 * means a handshake error should be classified with isPermanentError, above.
 */
/**
 * Maps an error Code from GRPC status code number, like 0, 1, or 14. These
 * are not the same as HTTP status codes.
 *
 * @returns The Code equivalent to the given GRPC status code. Fails if there
 *     is no match.
 */
function zt(t) {
    if (void 0 === t) 
    // This shouldn't normally happen, but in certain error cases (like trying
    // to send invalid proto messages) we may get an error with no GRPC code.
    return ye("GRPC error has no .code"), m.UNKNOWN;
    switch (t) {
      case Wt.OK:
        return m.OK;

      case Wt.CANCELLED:
        return m.CANCELLED;

      case Wt.UNKNOWN:
        return m.UNKNOWN;

      case Wt.DEADLINE_EXCEEDED:
        return m.DEADLINE_EXCEEDED;

      case Wt.RESOURCE_EXHAUSTED:
        return m.RESOURCE_EXHAUSTED;

      case Wt.INTERNAL:
        return m.INTERNAL;

      case Wt.UNAVAILABLE:
        return m.UNAVAILABLE;

      case Wt.UNAUTHENTICATED:
        return m.UNAUTHENTICATED;

      case Wt.INVALID_ARGUMENT:
        return m.INVALID_ARGUMENT;

      case Wt.NOT_FOUND:
        return m.NOT_FOUND;

      case Wt.ALREADY_EXISTS:
        return m.ALREADY_EXISTS;

      case Wt.PERMISSION_DENIED:
        return m.PERMISSION_DENIED;

      case Wt.FAILED_PRECONDITION:
        return m.FAILED_PRECONDITION;

      case Wt.ABORTED:
        return m.ABORTED;

      case Wt.OUT_OF_RANGE:
        return m.OUT_OF_RANGE;

      case Wt.UNIMPLEMENTED:
        return m.UNIMPLEMENTED;

      case Wt.DATA_LOSS:
        return m.DATA_LOSS;

      default:
        return ve("Unknown status code: " + t);
    }
}

/**
 * Converts an HTTP response's error status to the equivalent error code.
 *
 * @param status An HTTP error response status ("FAILED_PRECONDITION",
 * "UNKNOWN", etc.)
 * @returns The equivalent Code. Non-matching responses are mapped to
 *     Code.UNKNOWN.
 */ (jt = Wt || (Wt = {}))[jt.OK = 0] = "OK", jt[jt.CANCELLED = 1] = "CANCELLED", 
jt[jt.UNKNOWN = 2] = "UNKNOWN", jt[jt.INVALID_ARGUMENT = 3] = "INVALID_ARGUMENT", 
jt[jt.DEADLINE_EXCEEDED = 4] = "DEADLINE_EXCEEDED", jt[jt.NOT_FOUND = 5] = "NOT_FOUND", 
jt[jt.ALREADY_EXISTS = 6] = "ALREADY_EXISTS", jt[jt.PERMISSION_DENIED = 7] = "PERMISSION_DENIED", 
jt[jt.UNAUTHENTICATED = 16] = "UNAUTHENTICATED", jt[jt.RESOURCE_EXHAUSTED = 8] = "RESOURCE_EXHAUSTED", 
jt[jt.FAILED_PRECONDITION = 9] = "FAILED_PRECONDITION", jt[jt.ABORTED = 10] = "ABORTED", 
jt[jt.OUT_OF_RANGE = 11] = "OUT_OF_RANGE", jt[jt.UNIMPLEMENTED = 12] = "UNIMPLEMENTED", 
jt[jt.INTERNAL = 13] = "INTERNAL", jt[jt.UNAVAILABLE = 14] = "UNAVAILABLE", jt[jt.DATA_LOSS = 15] = "DATA_LOSS";

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const Kt = new D(C.k);

function Ht() {
    return Kt;
}

function Jt() {
    return Ht();
}

const Yt = new D(C.k);

function Xt() {
    return Yt;
}

const Zt = new D(C.k);

function te() {
    return Zt;
}

const ee = new k(C.k);

function se(...t) {
    let e = ee;
    for (const s of t) e = e.add(s);
    return e;
}

const ie = new k(De);

function ne() {
    return ie;
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentSet is an immutable (copy-on-write) collection that holds documents
 * in order specified by the provided comparator. We always add a document key
 * comparator on top of what is provided to guarantee document equality based on
 * the key.
 */ class re {
    /** The default ordering is by key if the comparator is omitted */
    constructor(t) {
        // We are adding document key comparator to the end as it's the only
        // guaranteed unique property of a document.
        this.k = t ? (e, s) => t(e, s) || C.k(e.key, s.key) : (t, e) => C.k(t.key, e.key), 
        this.rs = Xt(), this.hs = new D(this.k);
    }
    /**
     * Returns an empty copy of the existing DocumentSet, using the same
     * comparator.
     */    static os(t) {
        return new re(t.k);
    }
    has(t) {
        return null != this.rs.get(t);
    }
    get(t) {
        return this.rs.get(t);
    }
    first() {
        return this.hs.ot();
    }
    last() {
        return this.hs.at();
    }
    q() {
        return this.hs.q();
    }
    /**
     * Returns the index of the provided key in the document set, or -1 if the
     * document key is not present in the set;
     */    indexOf(t) {
        const e = this.rs.get(t);
        return e ? this.hs.indexOf(e) : -1;
    }
    get size() {
        return this.hs.size;
    }
    /** Iterates documents in order defined by "comparator" */    forEach(t) {
        this.hs.ut((e, s) => (t(e), !1));
    }
    /** Inserts or updates a document with the same key */    add(t) {
        // First remove the element if we have it.
        const e = this.delete(t.key);
        return e.rt(e.rs.nt(t.key, t), e.hs.nt(t, null));
    }
    /** Deletes a document with a given key */    delete(t) {
        const e = this.get(t);
        return e ? this.rt(this.rs.remove(t), this.hs.remove(e)) : this;
    }
    isEqual(t) {
        if (!(t instanceof re)) return !1;
        if (this.size !== t.size) return !1;
        const e = this.hs.lt(), s = t.hs.lt();
        for (;e.Rt(); ) {
            const t = e.Et().key, i = s.Et().key;
            if (!t.isEqual(i)) return !1;
        }
        return !0;
    }
    toString() {
        const t = [];
        return this.forEach(e => {
            t.push(e.toString());
        }), 0 === t.length ? "DocumentSet ()" : "DocumentSet (\n  " + t.join("  \n") + "\n)";
    }
    rt(t, e) {
        const s = new re;
        return s.k = this.k, s.rs = t, s.hs = e, s;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * DocumentChangeSet keeps track of a set of changes to docs in a query, merging
 * duplicate events for the same doc.
 */ class he {
    constructor() {
        this.as = new D(C.k);
    }
    track(t) {
        const e = t.doc.key, s = this.as.get(e);
        s ? 
        // Merge the new change with the existing change.
        0 /* Added */ !== t.type && 3 /* Metadata */ === s.type ? this.as = this.as.nt(e, t) : 3 /* Metadata */ === t.type && 1 /* Removed */ !== s.type ? this.as = this.as.nt(e, {
            type: s.type,
            doc: t.doc
        }) : 2 /* Modified */ === t.type && 2 /* Modified */ === s.type ? this.as = this.as.nt(e, {
            type: 2 /* Modified */ ,
            doc: t.doc
        }) : 2 /* Modified */ === t.type && 0 /* Added */ === s.type ? this.as = this.as.nt(e, {
            type: 0 /* Added */ ,
            doc: t.doc
        }) : 1 /* Removed */ === t.type && 0 /* Added */ === s.type ? this.as = this.as.remove(e) : 1 /* Removed */ === t.type && 2 /* Modified */ === s.type ? this.as = this.as.nt(e, {
            type: 1 /* Removed */ ,
            doc: s.doc
        }) : 0 /* Added */ === t.type && 1 /* Removed */ === s.type ? this.as = this.as.nt(e, {
            type: 2 /* Modified */ ,
            doc: t.doc
        }) : 
        // This includes these cases, which don't make sense:
        // Added->Added
        // Removed->Removed
        // Modified->Added
        // Removed->Modified
        // Metadata->Added
        // Removed->Metadata
        ve("unsupported combination of changes: " + JSON.stringify(t) + " after " + JSON.stringify(s)) : this.as = this.as.nt(e, t);
    }
    us() {
        const t = [];
        return this.as.ut((e, s) => {
            t.push(s);
        }), t;
    }
}

class oe {
    constructor(t, e, s, i, n, r, h, o) {
        this.query = t, this.docs = e, this.cs = s, this.docChanges = i, this.ls = n, this.fromCache = r, 
        this._s = h, this.ds = o;
    }
    /** Returns a view snapshot as if all documents in the snapshot were added. */    static fs(t, e, s, i) {
        const n = [];
        return e.forEach(t => {
            n.push({
                type: 0 /* Added */ ,
                doc: t
            });
        }), new oe(t, e, re.os(e), n, s, i, 
        /* syncStateChanged= */ !0, 
        /* excludesMetadataChanges= */ !1);
    }
    get hasPendingWrites() {
        return !this.ls.q();
    }
    isEqual(t) {
        if (!(this.fromCache === t.fromCache && this._s === t._s && this.ls.isEqual(t.ls) && this.query.isEqual(t.query) && this.docs.isEqual(t.docs) && this.cs.isEqual(t.cs))) return !1;
        const e = this.docChanges, s = t.docChanges;
        if (e.length !== s.length) return !1;
        for (let t = 0; t < e.length; t++) if (e[t].type !== s[t].type || !e[t].doc.isEqual(s[t].doc)) return !1;
        return !0;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An event from the RemoteStore. It is split into targetChanges (changes to the
 * state or the set of documents in our watched targets) and documentUpdates
 * (changes to the actual documents).
 */ class ae {
    constructor(
    /**
     * The snapshot version this event brings us up to, or MIN if not set.
     */
    t, 
    /**
     * A map from target to changes to the target. See TargetChange.
     */
    e, 
    /**
     * A set of targets that is known to be inconsistent. Listens for these
     * targets should be re-established without resume tokens.
     */
    s, 
    /**
     * A set of which documents have changed or been deleted, along with the
     * doc's new values (if not deleted).
     */
    i, 
    /**
     * A set of which document updates are due only to limbo resolution targets.
     */
    n) {
        this.ts = t, this.ws = e, this.Ts = s, this.ms = i, this.Es = n;
    }
    /**
     * HACK: Views require RemoteEvents in order to determine whether the view is
     * CURRENT, but secondary tabs don't receive remote events. So this method is
     * used to create a synthesized RemoteEvent that can be used to apply a
     * CURRENT status change to a View, for queries executed in a different tab.
     */
    // PORTING NOTE: Multi-tab only
    static Rs(t, e) {
        const s = new Map;
        return s.set(t, ue.Is(t, e)), new ae(g.MIN, s, ne(), Ht(), se());
    }
}

/**
 * A TargetChange specifies the set of changes for a specific target as part of
 * a RemoteEvent. These changes track which documents are added, modified or
 * removed, as well as the target's resume token and whether the target is
 * marked CURRENT.
 * The actual changes *to* documents are not part of the TargetChange since
 * documents may be part of multiple targets.
 */ class ue {
    constructor(
    /**
     * An opaque, server-assigned token that allows watching a query to be resumed
     * after disconnecting without retransmitting all the data that matches the
     * query. The resume token essentially identifies a point in time from which
     * the server should resume sending results.
     */
    t, 
    /**
     * The "current" (synced) status of this target. Note that "current"
     * has special meaning in the RPC protocol that implies that a target is
     * both up-to-date and consistent with the rest of the watch stream.
     */
    e, 
    /**
     * The set of documents that were newly assigned to this target as part of
     * this remote event.
     */
    s, 
    /**
     * The set of documents that were already assigned to this target but received
     * an update during this remote event.
     */
    i, 
    /**
     * The set of documents that were removed from this target as part of this
     * remote event.
     */
    n) {
        this.resumeToken = t, this.As = e, this.Ps = s, this.Vs = i, this.ps = n;
    }
    /**
     * This method is used to create a synthesized TargetChanges that can be used to
     * apply a CURRENT status change to a View (for queries executed in a different
     * tab) or for new queries (to raise snapshots with correct CURRENT status).
     */    static Is(t, e) {
        return new ue(U.Ut, e, se(), se(), se());
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents a changed document and a list of target ids to which this change
 * applies.
 *
 * If document has been deleted NoDocument will be provided.
 */ class ce {
    constructor(
    /** The new document applies to all of these targets. */
    t, 
    /** The new document is removed from all of these targets. */
    e, 
    /** The key of the document for this change. */
    s, 
    /**
     * The new document or NoDocument if it was deleted. Is null if the
     * document went out of view without the server sending a new document.
     */
    i) {
        this.gs = t, this.removedTargetIds = e, this.key = s, this.ys = i;
    }
}

class le {
    constructor(t, e) {
        this.targetId = t, this.bs = e;
    }
}

class _e {
    constructor(
    /** What kind of change occurred to the watch target. */
    t, 
    /** The target IDs that were added/removed/set. */
    e, 
    /**
     * An opaque, server-assigned token that allows watching a target to be
     * resumed after disconnecting without retransmitting all the data that
     * matches the target. The resume token essentially identifies a point in
     * time from which the server should resume sending results.
     */
    s = U.Ut
    /** An RPC error indicating why the watch failed. */ , i = null) {
        this.state = t, this.targetIds = e, this.resumeToken = s, this.cause = i;
    }
}

/** Tracks the internal state of a Watch target. */ class de {
    constructor() {
        /**
         * The number of pending responses (adds or removes) that we are waiting on.
         * We only consider targets active that have no pending responses.
         */
        this.vs = 0, 
        /**
         * Keeps track of the document changes since the last raised snapshot.
         *
         * These changes are continuously updated as we receive document updates and
         * always reflect the current set of changes against the last issued snapshot.
         */
        this.Ss = Te(), 
        /** See public getters for explanations of these fields. */
        this.Cs = U.Ut, this.Ds = !1, 
        /**
         * Whether this target state should be included in the next snapshot. We
         * initialize to true so that newly-added targets are included in the next
         * RemoteEvent.
         */
        this.Fs = !0;
    }
    /**
     * Whether this target has been marked 'current'.
     *
     * 'Current' has special meaning in the RPC protocol: It implies that the
     * Watch backend has sent us all changes up to the point at which the target
     * was added and that the target is consistent with the rest of the watch
     * stream.
     */    get As() {
        return this.Ds;
    }
    /** The last resume token sent to us for this target. */    get resumeToken() {
        return this.Cs;
    }
    /** Whether this target has pending target adds or target removes. */    get Ns() {
        return 0 !== this.vs;
    }
    /** Whether we have modified any state that should trigger a snapshot. */    get ks() {
        return this.Fs;
    }
    /**
     * Applies the resume token to the TargetChange, but only when it has a new
     * value. Empty resumeTokens are discarded.
     */    Ls(t) {
        t.Mt() > 0 && (this.Fs = !0, this.Cs = t);
    }
    /**
     * Creates a target change from the current set of changes.
     *
     * To reset the document changes after raising this snapshot, call
     * `clearPendingChanges()`.
     */    $s() {
        let t = se(), e = se(), s = se();
        return this.Ss.forEach((i, n) => {
            switch (n) {
              case 0 /* Added */ :
                t = t.add(i);
                break;

              case 2 /* Modified */ :
                e = e.add(i);
                break;

              case 1 /* Removed */ :
                s = s.add(i);
                break;

              default:
                ve("Encountered invalid change type: " + n);
            }
        }), new ue(this.Cs, this.Ds, t, e, s);
    }
    /**
     * Resets the document changes and sets `hasPendingChanges` to false.
     */    Os() {
        this.Fs = !1, this.Ss = Te();
    }
    Ms(t, e) {
        this.Fs = !0, this.Ss = this.Ss.nt(t, e);
    }
    Us(t) {
        this.Fs = !0, this.Ss = this.Ss.remove(t);
    }
    qs() {
        this.vs += 1;
    }
    Bs() {
        this.vs -= 1;
    }
    xs() {
        this.Fs = !0, this.Ds = !0;
    }
}

/**
 * A helper class to accumulate watch changes into a RemoteEvent.
 */
class fe {
    constructor(t) {
        this.Qs = t, 
        /** The internal state of all tracked targets. */
        this.Ws = new Map, 
        /** Keeps track of the documents to update since the last raised snapshot. */
        this.js = Ht(), 
        /** A mapping of document keys to their set of target IDs. */
        this.Gs = we(), 
        /**
         * A list of targets with existence filter mismatches. These targets are
         * known to be inconsistent and their listens needs to be re-established by
         * RemoteStore.
         */
        this.zs = new k(De);
    }
    /**
     * Processes and adds the DocumentWatchChange to the current set of changes.
     */    Ks(t) {
        for (const e of t.gs) t.ys instanceof gt ? this.Hs(e, t.ys) : t.ys instanceof yt && this.Js(e, t.key, t.ys);
        for (const e of t.removedTargetIds) this.Js(e, t.key, t.ys);
    }
    /** Processes and adds the WatchTargetChange to the current set of changes. */    Ys(t) {
        this.Xs(t, e => {
            const s = this.Zs(e);
            switch (t.state) {
              case 0 /* NoChange */ :
                this.ti(e) && s.Ls(t.resumeToken);
                break;

              case 1 /* Added */ :
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Bs(), s.Ns || 
                // We have a freshly added target, so we need to reset any state
                // that we had previously. This can happen e.g. when remove and add
                // back a target for existence filter mismatches.
                s.Os(), s.Ls(t.resumeToken);
                break;

              case 2 /* Removed */ :
                // We need to keep track of removed targets to we can post-filter and
                // remove any target changes.
                // We need to decrement the number of pending acks needed from watch
                // for this targetId.
                s.Bs(), s.Ns || this.removeTarget(e);
                break;

              case 3 /* Current */ :
                this.ti(e) && (s.xs(), s.Ls(t.resumeToken));
                break;

              case 4 /* Reset */ :
                this.ti(e) && (
                // Reset the target and synthesizes removes for all existing
                // documents. The backend will re-add any documents that still
                // match the target before it sends the next global snapshot.
                this.ei(e), s.Ls(t.resumeToken));
                break;

              default:
                ve("Unknown target watch change state: " + t.state);
            }
        });
    }
    /**
     * Iterates over all targetIds that the watch change applies to: either the
     * targetIds explicitly listed in the change or the targetIds of all currently
     * active targets.
     */    Xs(t, e) {
        t.targetIds.length > 0 ? t.targetIds.forEach(e) : this.Ws.forEach((t, s) => {
            this.ti(s) && e(s);
        });
    }
    /**
     * Handles existence filters and synthesizes deletes for filter mismatches.
     * Targets that are invalidated by filter mismatches are added to
     * `pendingTargetResets`.
     */    si(t) {
        const e = t.targetId, s = t.bs.count, i = this.ii(e);
        if (i) {
            const t = i.target;
            if (t.Pe()) if (0 === s) {
                // The existence filter told us the document does not exist. We deduce
                // that this document does not exist and apply a deleted document to
                // our updates. Without applying this deleted document there might be
                // another query that will raise this document as part of a snapshot
                // until it is resolved, essentially exposing inconsistency between
                // queries.
                const s = new C(t.path);
                this.Js(e, s, new yt(s, g.S()));
            } else Se(1 === s, "Single document existence filter with count: " + s); else {
                this.ni(e) !== s && (
                // Existence filter mismatch: We reset the mapping and raise a new
                // snapshot with `isFromCache:true`.
                this.ei(e), this.zs = this.zs.add(e));
            }
        }
    }
    /**
     * Converts the currently accumulated state into a remote event at the
     * provided snapshot version. Resets the accumulated changes before returning.
     */    ri(t) {
        const e = new Map;
        this.Ws.forEach((s, i) => {
            const n = this.ii(i);
            if (n) {
                if (s.As && n.target.Pe()) {
                    // Document queries for document that don't exist can produce an empty
                    // result set. To update our local cache, we synthesize a document
                    // delete if we have not previously received the document. This
                    // resolves the limbo state of the document, removing it from
                    // limboDocumentRefs.
                    // TODO(dimond): Ideally we would have an explicit lookup target
                    // instead resulting in an explicit delete message and we could
                    // remove this special logic.
                    const e = new C(n.target.path);
                    null !== this.js.get(e) || this.hi(i, e) || this.Js(i, e, new yt(e, t));
                }
                s.ks && (e.set(i, s.$s()), s.Os());
            }
        });
        let s = se();
        // We extract the set of limbo-only document updates as the GC logic
        // special-cases documents that do not appear in the target cache.
        
        // TODO(gsoltis): Expand on this comment once GC is available in the JS
        // client.
                this.Gs.forEach((t, e) => {
            let i = !0;
            e.Ft(t => {
                const e = this.ii(t);
                return !e || 2 /* LimboResolution */ === e.Ze || (i = !1, !1);
            }), i && (s = s.add(t));
        });
        const i = new ae(t, e, this.zs, this.js, s);
        return this.js = Ht(), this.Gs = we(), this.zs = new k(De), i;
    }
    /**
     * Adds the provided document to the internal list of document updates and
     * its document key to the given target's mapping.
     */
    // Visible for testing.
    Hs(t, e) {
        if (!this.ti(t)) return;
        const s = this.hi(t, e.key) ? 2 /* Modified */ : 0 /* Added */;
        this.Zs(t).Ms(e.key, s), this.js = this.js.nt(e.key, e), this.Gs = this.Gs.nt(e.key, this.oi(e.key).add(t));
    }
    /**
     * Removes the provided document from the target mapping. If the
     * document no longer matches the target, but the document's state is still
     * known (e.g. we know that the document was deleted or we received the change
     * that caused the filter mismatch), the new document can be provided
     * to update the remote document cache.
     */
    // Visible for testing.
    Js(t, e, s) {
        if (!this.ti(t)) return;
        const i = this.Zs(t);
        this.hi(t, e) ? i.Ms(e, 1 /* Removed */) : 
        // The document may have entered and left the target before we raised a
        // snapshot, so we can just ignore the change.
        i.Us(e), this.Gs = this.Gs.nt(e, this.oi(e).delete(t)), s && (this.js = this.js.nt(e, s));
    }
    removeTarget(t) {
        this.Ws.delete(t);
    }
    /**
     * Returns the current count of documents in the target. This includes both
     * the number of documents that the LocalStore considers to be part of the
     * target as well as any accumulated changes.
     */    ni(t) {
        const e = this.Zs(t).$s();
        return this.Qs.ai(t).size + e.Ps.size - e.ps.size;
    }
    /**
     * Increment the number of acks needed from watch before we can consider the
     * server to be 'in-sync' with the client's active targets.
     */    qs(t) {
        this.Zs(t).qs();
    }
    Zs(t) {
        let e = this.Ws.get(t);
        return e || (e = new de, this.Ws.set(t, e)), e;
    }
    oi(t) {
        let e = this.Gs.get(t);
        return e || (e = new k(De), this.Gs = this.Gs.nt(t, e)), e;
    }
    /**
     * Verifies that the user is still interested in this target (by calling
     * `getTargetDataForTarget()`) and that we are not waiting for pending ADDs
     * from watch.
     */    ti(t) {
        const e = null !== this.ii(t);
        return e || ge("WatchChangeAggregator", "Detected inactive target", t), e;
    }
    /**
     * Returns the TargetData for an active target (i.e. a target that the user
     * is still interested in that has no outstanding target change requests).
     */    ii(t) {
        const e = this.Ws.get(t);
        return e && e.Ns ? null : this.Qs.ui(t);
    }
    /**
     * Resets the state of a Watch target to its initial state (e.g. sets
     * 'current' to false, clears the resume token and removes its target mapping
     * from all documents).
     */    ei(t) {
        this.Ws.set(t, new de), this.Qs.ai(t).forEach(e => {
            this.Js(t, e, /*updatedDocument=*/ null);
        });
    }
    /**
     * Returns whether the LocalStore considers the document to be part of the
     * specified target.
     */    hi(t, e) {
        return this.Qs.ai(t).has(e);
    }
}

function we() {
    return new D(C.k);
}

function Te() {
    return new D(C.k);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const me = (() => {
    const t = {};
    return t[Ot.ASCENDING.name] = "ASCENDING", t[Ot.DESCENDING.name] = "DESCENDING", 
    t;
})(), Ee = (() => {
    const t = {};
    return t[Ct.LESS_THAN.name] = "LESS_THAN", t[Ct.LESS_THAN_OR_EQUAL.name] = "LESS_THAN_OR_EQUAL", 
    t[Ct.GREATER_THAN.name] = "GREATER_THAN", t[Ct.GREATER_THAN_OR_EQUAL.name] = "GREATER_THAN_OR_EQUAL", 
    t[Ct.EQUAL.name] = "EQUAL", t[Ct.ARRAY_CONTAINS.name] = "ARRAY_CONTAINS", t[Ct.IN.name] = "IN", 
    t[Ct.ARRAY_CONTAINS_ANY.name] = "ARRAY_CONTAINS_ANY", t;
})();

/**
 * Generates JsonObject values for the Datastore API suitable for sending to
 * either GRPC stub methods or via the JSON/HTTP REST API.
 * TODO(klimt): We can remove the databaseId argument if we keep the full
 * resource name in documents.
 */
class Re {
    constructor(t, e) {
        this.ci = t, this.options = e;
    }
    li(t) {
        const e = void 0 === t.code ? m.UNKNOWN : zt(t.code);
        return new E(e, t.message || "");
    }
    /**
     * Returns a value for a number (or null) that's appropriate to put into
     * a google.protobuf.Int32Value proto.
     * DO NOT USE THIS FOR ANYTHING ELSE.
     * This method cheats. It's typed as returning "number" because that's what
     * our generated proto interfaces say Int32Value must be. But GRPC actually
     * expects a { value: <number> } struct.
     */    _i(t) {
        return this.options.di || q(t) ? t : {
            value: t
        };
    }
    /**
     * Returns a number (or null) from a google.protobuf.Int32Value proto.
     */    fi(t) {
        let e;
        return e = "object" == typeof t ? t.value : t, q(e) ? null : e;
    }
    /**
     * Returns an IntegerValue for `value`.
     */    Wt(t) {
        return {
            integerValue: "" + t
        };
    }
    /**
     * Returns an DoubleValue for `value` that is encoded based the serializer's
     * `useProto3Json` setting.
     */    jt(t) {
        if (this.options.di) {
            if (isNaN(t)) return {
                doubleValue: "NaN"
            };
            if (t === 1 / 0) return {
                doubleValue: "Infinity"
            };
            if (t === -1 / 0) return {
                doubleValue: "-Infinity"
            };
        }
        return {
            doubleValue: B(t) ? "-0" : t
        };
    }
    /**
     * Returns a value for a number that's appropriate to put into a proto.
     * The return value is an IntegerValue if it can safely represent the value,
     * otherwise a DoubleValue is returned.
     */    wi(t) {
        return function(t) {
            return "number" == typeof t && Number.isInteger(t) && !B(t) && t <= Number.MAX_SAFE_INTEGER && t >= Number.MIN_SAFE_INTEGER;
        }
        /**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
        /**
 * Represents a locally-applied ServerTimestamp.
 *
 * Server Timestamps are backed by MapValues that contain an internal field
 * `__type__` with a value of `server_timestamp`. The previous value and local
 * write time are stored in its `__previous_value__` and `__local_write_time__`
 * fields respectively.
 *
 * Notes:
 * - ServerTimestampValue instances are created as the result of applying a
 *   TransformMutation (see TransformMutation.applyTo()). They can only exist in
 *   the local view of a document. Therefore they do not need to be parsed or
 *   serialized.
 * - When evaluated locally (e.g. for snapshot.data()), they by default
 *   evaluate to `null`. This behavior can be configured by passing custom
 *   FieldValueOptions to value().
 * - With respect to other ServerTimestampValues, they sort by their
 *   localWriteTime.
 */ (t) ? this.Wt(t) : this.jt(t);
    }
    /**
     * Returns a value for a Date that's appropriate to put into a proto.
     */    F(t) {
        if (this.options.di) {
            return `${new Date(1e3 * t.seconds).toISOString().replace(/\.\d*/, "").replace("Z", "")}.${("000000000" + t.nanoseconds).slice(-9)}Z`;
        }
        return {
            seconds: "" + t.seconds,
            nanos: t.nanoseconds
        };
    }
    v(t) {
        const e = X(t);
        return new p(e.seconds, e.nanos);
    }
    /**
     * Returns a value for bytes that's appropriate to put in a proto.
     *
     * Visible for testing.
     */    Ti(t) {
        return this.options.di ? t.toBase64() : t.toUint8Array();
    }
    /**
     * Returns a ByteString based on the proto string value.
     */    mi(t) {
        return this.options.di ? (Se(void 0 === t || "string" == typeof t, "value must be undefined or a string when using proto3 Json"), 
        U.fromBase64String(t || "")) : (Se(void 0 === t || t instanceof Uint8Array, "value must be undefined or Uint8Array"), 
        U.fromUint8Array(t || new Uint8Array));
    }
    toVersion(t) {
        return this.F(t.F());
    }
    fromVersion(t) {
        return Se(!!t, "Trying to deserialize version that isn't set"), g.v(this.v(t));
    }
    Ei(t, e) {
        return this.Ri(e || this.ci).child("documents").child(t).G();
    }
    Ii(t) {
        const e = b.K(t);
        return Se(Ie(e), "Tried to deserialize invalid key " + e.toString()), e;
    }
    Ai(t) {
        return this.Ei(t.path);
    }
    tt(t) {
        const e = this.Ii(t);
        return Se(e.get(1) === this.ci.projectId, "Tried to deserialize key from different project: " + e.get(1) + " vs " + this.ci.projectId), 
        Se(!e.get(3) && !this.ci.database || e.get(3) === this.ci.database, "Tried to deserialize key from different database: " + e.get(3) + " vs " + this.ci.database), 
        new C(this.Pi(e));
    }
    Vi(t) {
        return this.Ei(t);
    }
    pi(t) {
        const e = this.Ii(t);
        // In v1beta1 queries for collections at the root did not have a trailing
        // "/documents". In v1 all resource paths contain "/documents". Preserve the
        // ability to read the v1beta1 form for compatibility with queries persisted
        // in the local target cache.
                return 4 === e.length ? b.H : this.Pi(e);
    }
    get gi() {
        return new b([ "projects", this.ci.projectId, "databases", this.ci.database ]).G();
    }
    Ri(t) {
        return new b([ "projects", t.projectId, "databases", t.database ]);
    }
    Pi(t) {
        return Se(t.length > 4 && "documents" === t.get(4), "tried to deserialize invalid key " + t.toString()), 
        t.$(5);
    }
    /** Creates an api.Document from key and fields (but no create/update time) */    yi(t, e) {
        return {
            name: this.Ai(t),
            fields: e.proto.mapValue.fields
        };
    }
    bi(t) {
        return {
            name: this.Ai(t.key),
            fields: t.Re().mapValue.fields,
            updateTime: this.F(t.version.F())
        };
    }
    vi(t, e) {
        const s = this.tt(t.name), i = this.fromVersion(t.updateTime), n = new Pt({
            mapValue: {
                fields: t.fields
            }
        });
        return new gt(s, i, n, {
            hasCommittedMutations: !!e
        });
    }
    Si(t) {
        Se(!!t.found, "Tried to deserialize a found document from a missing document."), 
        t.found.name, t.found.updateTime;
        const e = this.tt(t.found.name), s = this.fromVersion(t.found.updateTime), i = new Pt({
            mapValue: {
                fields: t.found.fields
            }
        });
        return new gt(e, s, i, {});
    }
    Ci(t) {
        Se(!!t.missing, "Tried to deserialize a missing document from a found document."), 
        Se(!!t.readTime, "Tried to deserialize a missing document without a read time.");
        const e = this.tt(t.missing), s = this.fromVersion(t.readTime);
        return new yt(e, s);
    }
    Di(t) {
        return "found" in t ? this.Si(t) : "missing" in t ? this.Ci(t) : ve("invalid batch get response: " + JSON.stringify(t));
    }
    Fi(t) {
        let e;
        if ("targetChange" in t) {
            t.targetChange;
            // proto3 default value is unset in JSON (undefined), so use 'NO_CHANGE'
            // if unset
            const s = this.Ni(t.targetChange.targetChangeType || "NO_CHANGE"), i = t.targetChange.targetIds || [], n = this.mi(t.targetChange.resumeToken), r = t.targetChange.cause, h = r && this.li(r);
            e = new _e(s, i, n, h || null);
        } else if ("documentChange" in t) {
            t.documentChange;
            const s = t.documentChange;
            s.document, s.document.name, s.document.updateTime;
            const i = this.tt(s.document.name), n = this.fromVersion(s.document.updateTime), r = new Pt({
                mapValue: {
                    fields: s.document.fields
                }
            }), h = new gt(i, n, r, {}), o = s.targetIds || [], a = s.removedTargetIds || [];
            e = new ce(o, a, h.key, h);
        } else if ("documentDelete" in t) {
            t.documentDelete;
            const s = t.documentDelete;
            s.document;
            const i = this.tt(s.document), n = s.readTime ? this.fromVersion(s.readTime) : g.S(), r = new yt(i, n), h = s.removedTargetIds || [];
            e = new ce([], h, r.key, r);
        } else if ("documentRemove" in t) {
            t.documentRemove;
            const s = t.documentRemove;
            s.document;
            const i = this.tt(s.document), n = s.removedTargetIds || [];
            e = new ce([], n, i, null);
        } else {
            if (!("filter" in t)) return ve("Unknown change type " + JSON.stringify(t));
            {
                t.filter;
                const s = t.filter;
                s.targetId;
                const i = s.count || 0, n = new Qt(i), r = s.targetId;
                e = new le(r, n);
            }
        }
        return e;
    }
    Ni(t) {
        return "NO_CHANGE" === t ? 0 /* NoChange */ : "ADD" === t ? 1 /* Added */ : "REMOVE" === t ? 2 /* Removed */ : "CURRENT" === t ? 3 /* Current */ : "RESET" === t ? 4 /* Reset */ : ve("Got unexpected TargetChange.state: " + t);
    }
    ki(t) {
        // We have only reached a consistent snapshot for the entire stream if there
        // is a read_time set and it applies to all targets (i.e. the list of
        // targets is empty). The backend is guaranteed to send such responses.
        if (!("targetChange" in t)) return g.MIN;
        const e = t.targetChange;
        return e.targetIds && e.targetIds.length ? g.MIN : e.readTime ? this.fromVersion(e.readTime) : g.MIN;
    }
    Li(t) {
        let e;
        if (t instanceof mt) e = {
            update: this.yi(t.key, t.value)
        }; else if (t instanceof It) e = {
            delete: this.Ai(t.key)
        }; else if (t instanceof Et) e = {
            update: this.yi(t.key, t.data),
            updateMask: this.$i(t.se)
        }; else if (t instanceof Rt) e = {
            transform: {
                document: this.Ai(t.key),
                fieldTransforms: t.fieldTransforms.map(t => this.Oi(t))
            }
        }; else {
            if (!(t instanceof At)) return ve("Unknown mutation type " + t.type);
            e = {
                verify: this.Ai(t.key)
            };
        }
        return t.Zt.Ht || (e.currentDocument = this.Mi(t.Zt)), e;
    }
    Ui(t) {
        const e = t.currentDocument ? this.qi(t.currentDocument) : wt.NONE;
        if (t.update) {
            t.update.name;
            const s = this.tt(t.update.name), i = new Pt({
                mapValue: {
                    fields: t.update.fields
                }
            });
            if (t.updateMask) {
                const n = this.Bi(t.updateMask);
                return new Et(s, i, n, e);
            }
            return new mt(s, i, e);
        }
        if (t.delete) {
            const s = this.tt(t.delete);
            return new It(s, e);
        }
        if (t.transform) {
            const s = this.tt(t.transform.document), i = t.transform.fieldTransforms.map(t => this.xi(t));
            return Se(!0 === e.exists, 'Transforms only support precondition "exists == true"'), 
            new Rt(s, i);
        }
        if (t.verify) {
            const s = this.tt(t.verify);
            return new At(s, e);
        }
        return ve("unknown mutation proto: " + JSON.stringify(t));
    }
    Mi(t) {
        return void 0 !== t.updateTime ? {
            updateTime: this.toVersion(t.updateTime)
        } : void 0 !== t.exists ? {
            exists: t.exists
        } : ve("Unknown precondition");
    }
    qi(t) {
        return void 0 !== t.updateTime ? wt.updateTime(this.fromVersion(t.updateTime)) : void 0 !== t.exists ? wt.exists(t.exists) : wt.NONE;
    }
    Qi(t, e) {
        // NOTE: Deletes don't have an updateTime.
        let s = t.updateTime ? this.fromVersion(t.updateTime) : this.fromVersion(e);
        s.isEqual(g.MIN) && (
        // The Firestore Emulator currently returns an update time of 0 for
        // deletes of non-existing documents (rather than null). This breaks the
        // test "get deleted doc while offline with source=cache" as NoDocuments
        // with version 0 are filtered by IndexedDb's RemoteDocumentCache.
        // TODO(#2149): Remove this when Emulator is fixed
        s = this.fromVersion(e));
        let i = null;
        return t.transformResults && t.transformResults.length > 0 && (i = t.transformResults), 
        new ft(s, i);
    }
    Wi(t, e) {
        return t && t.length > 0 ? (Se(void 0 !== e, "Received a write result without a commit time"), 
        t.map(t => this.Qi(t, e))) : [];
    }
    Oi(t) {
        const e = t.transform;
        if (e instanceof ot) return {
            fieldPath: t.field.G(),
            setToServerValue: "REQUEST_TIME"
        };
        if (e instanceof at) return {
            fieldPath: t.field.G(),
            appendMissingElements: {
                values: e.elements
            }
        };
        if (e instanceof ut) return {
            fieldPath: t.field.G(),
            removeAllFromArray: {
                values: e.elements
            }
        };
        if (e instanceof ct) return {
            fieldPath: t.field.G(),
            increment: e.Qt
        };
        throw ve("Unknown transform: " + t.transform);
    }
    xi(t) {
        let e = null;
        if ("setToServerValue" in t) Se("REQUEST_TIME" === t.setToServerValue, "Unknown server value transform proto: " + JSON.stringify(t)), 
        e = ot.instance; else if ("appendMissingElements" in t) {
            const s = t.appendMissingElements.values || [];
            e = new at(s);
        } else if ("removeAllFromArray" in t) {
            const s = t.removeAllFromArray.values || [];
            e = new ut(s);
        } else "increment" in t ? e = new ct(this, t.increment) : ve("Unknown transform proto: " + JSON.stringify(t));
        const s = S.Z(t.fieldPath);
        return new dt(s, e);
    }
    ji(t) {
        return {
            documents: [ this.Vi(t.path) ]
        };
    }
    Gi(t) {
        const e = t.documents.length;
        Se(1 === e, "DocumentsTarget contained other than 1 document: " + e);
        const s = t.documents[0];
        return St.ve(this.pi(s)).Ue();
    }
    zi(t) {
        // Dissect the path into parent, collectionId, and optional key filter.
        const e = {
            structuredQuery: {}
        }, s = t.path;
        null !== t.collectionGroup ? (e.parent = this.Vi(s), e.structuredQuery.from = [ {
            collectionId: t.collectionGroup,
            allDescendants: !0
        } ]) : (e.parent = this.Vi(s.O()), e.structuredQuery.from = [ {
            collectionId: s.U()
        } ]);
        const i = this.Ki(t.filters);
        i && (e.structuredQuery.where = i);
        const n = this.Hi(t.orderBy);
        n && (e.structuredQuery.orderBy = n);
        const r = this._i(t.limit);
        return null !== r && (e.structuredQuery.limit = r), t.startAt && (e.structuredQuery.startAt = this.Ji(t.startAt)), 
        t.endAt && (e.structuredQuery.endAt = this.Ji(t.endAt)), e;
    }
    Yi(t) {
        let e = this.pi(t.parent);
        const s = t.structuredQuery, i = s.from ? s.from.length : 0;
        let n = null;
        if (i > 0) {
            Se(1 === i, "StructuredQuery.from with more than one collection is not supported.");
            const t = s.from[0];
            t.allDescendants ? n = t.collectionId : e = e.child(t.collectionId);
        }
        let r = [];
        s.where && (r = this.Xi(s.where));
        let h = [];
        s.orderBy && (h = this.Zi(s.orderBy));
        let o = null;
        s.limit && (o = this.fi(s.limit));
        let a = null;
        s.startAt && (a = this.tn(s.startAt));
        let u = null;
        return s.endAt && (u = this.tn(s.endAt)), new St(e, n, h, r, o, "F" /* First */ , a, u).Ue();
    }
    en(t) {
        const e = this.sn(t.Ze);
        return null == e ? null : {
            "goog-listen-tags": e
        };
    }
    sn(t) {
        switch (t) {
          case 0 /* Listen */ :
            return null;

          case 1 /* ExistenceFilterMismatch */ :
            return "existence-filter-mismatch";

          case 2 /* LimboResolution */ :
            return "limbo-document";

          default:
            return ve("Unrecognized query purpose: " + t);
        }
    }
    Ue(t) {
        let e;
        const s = t.target;
        return e = s.Pe() ? {
            documents: this.ji(s)
        } : {
            query: this.zi(s)
        }, e.targetId = t.targetId, t.resumeToken.Mt() > 0 && (e.resumeToken = this.Ti(t.resumeToken)), 
        e;
    }
    Ki(t) {
        if (0 === t.length) return;
        const e = t.map(t => t instanceof Dt ? this.in(t) : ve("Unrecognized filter: " + JSON.stringify(t)));
        return 1 === e.length ? e[0] : {
            compositeFilter: {
                op: "AND",
                filters: e
            }
        };
    }
    Xi(t) {
        return t ? void 0 !== t.unaryFilter ? [ this.nn(t) ] : void 0 !== t.fieldFilter ? [ this.rn(t) ] : void 0 !== t.compositeFilter ? t.compositeFilter.filters.map(t => this.Xi(t)).reduce((t, e) => t.concat(e)) : ve("Unknown filter: " + JSON.stringify(t)) : [];
    }
    Hi(t) {
        if (0 !== t.length) return t.map(t => this.hn(t));
    }
    Zi(t) {
        return t.map(t => this.on(t));
    }
    Ji(t) {
        return {
            before: t.before,
            values: t.position
        };
    }
    tn(t) {
        const e = !!t.before, s = t.values || [];
        return new Mt(s, e);
    }
    // visible for testing
    an(t) {
        return me[t.name];
    }
    // visible for testing
    un(t) {
        switch (t) {
          case "ASCENDING":
            return Ot.ASCENDING;

          case "DESCENDING":
            return Ot.DESCENDING;

          default:
            return;
        }
    }
    // visible for testing
    cn(t) {
        return Ee[t.name];
    }
    ln(t) {
        switch (t) {
          case "EQUAL":
            return Ct.EQUAL;

          case "GREATER_THAN":
            return Ct.GREATER_THAN;

          case "GREATER_THAN_OR_EQUAL":
            return Ct.GREATER_THAN_OR_EQUAL;

          case "LESS_THAN":
            return Ct.LESS_THAN;

          case "LESS_THAN_OR_EQUAL":
            return Ct.LESS_THAN_OR_EQUAL;

          case "ARRAY_CONTAINS":
            return Ct.ARRAY_CONTAINS;

          case "IN":
            return Ct.IN;

          case "ARRAY_CONTAINS_ANY":
            return Ct.ARRAY_CONTAINS_ANY;

          case "OPERATOR_UNSPECIFIED":
            return ve("Unspecified operator");

          default:
            return ve("Unknown operator");
        }
    }
    _n(t) {
        return {
            fieldPath: t.G()
        };
    }
    dn(t) {
        return S.Z(t.fieldPath);
    }
    // visible for testing
    hn(t) {
        return {
            field: this._n(t.field),
            direction: this.an(t.dir)
        };
    }
    on(t) {
        return new Ut(this.dn(t.field), this.un(t.direction));
    }
    rn(t) {
        return Dt.create(this.dn(t.fieldFilter.field), this.ln(t.fieldFilter.op), t.fieldFilter.value);
    }
    // visible for testing
    in(t) {
        if (t.op === Ct.EQUAL) {
            if (rt(t.value)) return {
                unaryFilter: {
                    field: this._n(t.field),
                    op: "IS_NAN"
                }
            };
            if (nt(t.value)) return {
                unaryFilter: {
                    field: this._n(t.field),
                    op: "IS_NULL"
                }
            };
        }
        return {
            fieldFilter: {
                field: this._n(t.field),
                op: this.cn(t.op),
                value: t.value
            }
        };
    }
    nn(t) {
        switch (t.unaryFilter.op) {
          case "IS_NAN":
            const e = this.dn(t.unaryFilter.field);
            return Dt.create(e, Ct.EQUAL, {
                doubleValue: NaN
            });

          case "IS_NULL":
            const s = this.dn(t.unaryFilter.field);
            return Dt.create(s, Ct.EQUAL, {
                nullValue: "NULL_VALUE"
            });

          case "OPERATOR_UNSPECIFIED":
            return ve("Unspecified filter");

          default:
            return ve("Unknown filter");
        }
    }
    $i(t) {
        const e = [];
        return t.fields.forEach(t => e.push(t.G())), {
            fieldPaths: e
        };
    }
    Bi(t) {
        const e = (t.fieldPaths || []).map(t => S.Z(t));
        return _t.zt(e);
    }
}

function Ie(t) {
    // Resource names have at least 4 components (project ID, database ID)
    return t.length >= 4 && "projects" === t.get(0) && "databases" === t.get(2);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides singleton helpers where setup code can inject a platform at runtime.
 * setPlatform needs to be set before Firestore is used and must be set exactly
 * once.
 */ class Ae {
    static fn(t) {
        Ae.platform && ve("Platform already defined"), Ae.platform = t;
    }
    static Ot() {
        return Ae.platform || ve("Platform not set"), Ae.platform;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Pe = new e("@firebase/firestore");

// Helper methods are needed because variables can't be exported as read/write
function Ve() {
    return Pe.logLevel;
}

function pe(t) {
    Pe.logLevel = t;
}

function ge(t, ...e) {
    if (Pe.logLevel <= s.DEBUG) {
        const s = e.map(be);
        Pe.debug(`Firestore (${w}): ${t}`, ...s);
    }
}

function ye(t, ...e) {
    if (Pe.logLevel <= s.ERROR) {
        const s = e.map(be);
        Pe.error(`Firestore (${w}): ${t}`, ...s);
    }
}

/**
 * Converts an additional log parameter to a string representation.
 */ function be(t) {
    if ("string" == typeof t) return t;
    {
        const e = Ae.Ot();
        try {
            return e.wn(t);
        } catch (e) {
            // Converting to JSON failed, just log the object directly
            return t;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Unconditionally fails, throwing an Error with the given message.
 *
 * Returns `never` and can be used in expressions:
 * @example
 * let futureVar = fail('not implemented yet');
 */ function ve(t) {
    // Log the failure in addition to throw an exception, just in case the
    // exception is swallowed.
    const e = `FIRESTORE (${w}) INTERNAL ASSERTION FAILED: ` + t;
    // NOTE: We don't use FirestoreError here because these are internal failures
    // that cannot be handled by the user. (Also it would create a circular
    // dependency between the error and assert modules which doesn't work.)
    throw ye(e), new Error(e);
}

/**
 * Fails if the given assertion condition is false, throwing an Error with the
 * given message if it did.
 */ function Se(t, e) {
    t || ve(e);
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Ce {
    static Tn() {
        // Alphanumeric characters
        const t = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
        let e = "";
        for (let s = 0; s < 20; s++) e += t.charAt(Math.floor(Math.random() * t.length));
        return e;
    }
}

function De(t, e) {
    return t < e ? -1 : t > e ? 1 : 0;
}

/** Helper to compare arrays using isEqual(). */ function Fe(t, e, s) {
    return t.length === e.length && t.every((t, i) => s(t, e[i]));
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Ne {
    /**
     * Constructs a DatabaseInfo using the provided host, databaseId and
     * persistenceKey.
     *
     * @param databaseId The database to use.
     * @param persistenceKey A unique identifier for this Firestore's local
     * storage (used in conjunction with the databaseId).
     * @param host The Firestore backend host to connect to.
     * @param ssl Whether to use SSL when connecting.
     * @param forceLongPolling Whether to use the forceLongPolling option
     * when using WebChannel as the network transport.
     */
    constructor(t, e, s, i, n) {
        this.ci = t, this.persistenceKey = e, this.host = s, this.ssl = i, this.forceLongPolling = n;
    }
}

/** The default database name for a project. */
/** Represents the database ID a Firestore client is associated with. */
class ke {
    constructor(t, e) {
        this.projectId = t, this.database = e || "(default)";
    }
    get mn() {
        return "(default)" === this.database;
    }
    isEqual(t) {
        return t instanceof ke && t.projectId === this.projectId && t.database === this.database;
    }
    C(t) {
        return De(this.projectId, t.projectId) || De(this.database, t.database);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A map implementation that uses objects as keys. Objects must implement the
 * Equatable interface and must be immutable. Entries in the map are stored
 * together with the key being produced from the mapKeyFn. This map
 * automatically handles collisions of keys.
 */ class Le {
    constructor(t) {
        this.En = t, 
        /**
         * The inner map for a key -> value pair. Due to the possibility of
         * collisions we keep a list of entries that we do a linear search through
         * to find an actual match. Note that collisions should be rare, so we still
         * expect near constant time lookups in practice.
         */
        this.Rn = {};
    }
    /** Get a value for this key, or undefined if it does not exist. */    get(t) {
        const e = this.En(t), s = this.Rn[e];
        if (void 0 !== s) for (const [e, i] of s) if (e.isEqual(t)) return i;
    }
    has(t) {
        return void 0 !== this.get(t);
    }
    /** Put this key and value in the map. */    set(t, e) {
        const s = this.En(t), i = this.Rn[s];
        if (void 0 !== i) {
            for (let s = 0; s < i.length; s++) if (i[s][0].isEqual(t)) return void (i[s] = [ t, e ]);
            i.push([ t, e ]);
        } else this.Rn[s] = [ [ t, e ] ];
    }
    /**
     * Remove this key from the map. Returns a boolean if anything was deleted.
     */    delete(t) {
        const e = this.En(t), s = this.Rn[e];
        if (void 0 === s) return !1;
        for (let i = 0; i < s.length; i++) if (s[i][0].isEqual(t)) return 1 === s.length ? delete this.Rn[e] : s.splice(i, 1), 
        !0;
        return !1;
    }
    forEach(t) {
        O(this.Rn, (e, s) => {
            for (const [e, i] of s) t(e, i);
        });
    }
    q() {
        return M(this.Rn);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A batch of mutations that will be sent as one unit to the backend.
 */
class $e {
    /**
     * @param batchId The unique ID of this mutation batch.
     * @param localWriteTime The original write time of this mutation.
     * @param baseMutations Mutations that are used to populate the base
     * values when this mutation is applied locally. This can be used to locally
     * overwrite values that are persisted in the remote document cache. Base
     * mutations are never sent to the backend.
     * @param mutations The user-provided mutations in this mutation batch.
     * User-provided mutations are applied both locally and remotely on the
     * backend.
     */
    constructor(t, e, s, i) {
        this.batchId = t, this.In = e, this.baseMutations = s, this.mutations = i;
    }
    /**
     * Applies all the mutations in this MutationBatch to the specified document
     * to create a new remote document
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     * @param batchResult The result of applying the MutationBatch to the
     * backend.
     */    Bt(t, e, s) {
        const i = s.An;
        for (let s = 0; s < this.mutations.length; s++) {
            const n = this.mutations[s];
            if (n.key.isEqual(t)) {
                const t = i[s];
                e = n.Bt(e, t);
            }
        }
        return e;
    }
    /**
     * Computes the local view of a document given all the mutations in this
     * batch.
     *
     * @param docKey The key of the document to apply mutations to.
     * @param maybeDoc The document to apply mutations to.
     */    qt(t, e) {
        // First, apply the base state. This allows us to apply non-idempotent
        // transform against a consistent set of values.
        for (const s of this.baseMutations) s.key.isEqual(t) && (e = s.qt(e, e, this.In));
        const s = e;
        // Second, apply all user-provided mutations.
                for (const i of this.mutations) i.key.isEqual(t) && (e = i.qt(e, s, this.In));
        return e;
    }
    /**
     * Computes the local view for all provided documents given the mutations in
     * this batch.
     */    Pn(t) {
        // TODO(mrschmidt): This implementation is O(n^2). If we apply the mutations
        // directly (as done in `applyToLocalView()`), we can reduce the complexity
        // to O(n).
        let e = t;
        return this.mutations.forEach(s => {
            const i = this.qt(s.key, t.get(s.key));
            i && (e = e.nt(s.key, i));
        }), e;
    }
    keys() {
        return this.mutations.reduce((t, e) => t.add(e.key), se());
    }
    isEqual(t) {
        return this.batchId === t.batchId && Fe(this.mutations, t.mutations, (t, e) => t.isEqual(e)) && Fe(this.baseMutations, t.baseMutations, (t, e) => t.isEqual(e));
    }
}

/** The result of applying a mutation batch to the backend. */ class Oe {
    constructor(t, e, s, i, 
    /**
     * A pre-computed mapping from each mutated document to the resulting
     * version.
     */
    n) {
        this.batch = t, this.Vn = e, this.An = s, this.streamToken = i, this.pn = n;
    }
    /**
     * Creates a new MutationBatchResult for the given batch and results. There
     * must be one result for each mutation in the batch. This static factory
     * caches a document=>version mapping (docVersions).
     */    static from(t, e, s, i) {
        Se(t.mutations.length === s.length, "Mutations sent " + t.mutations.length + " must equal results received " + s.length);
        let n = te();
        const r = t.mutations;
        for (let t = 0; t < r.length; t++) n = n.nt(r[t].key, s[t].version);
        return new Oe(t, e, s, i, n);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A collection of references to a document from some kind of numbered entity
 * (either a target ID or batch ID). As references are added to or removed from
 * the set corresponding events are emitted to a registered garbage collector.
 *
 * Each reference is represented by a DocumentReference object. Each of them
 * contains enough information to uniquely identify the reference. They are all
 * stored primarily in a set sorted by key. A document is considered garbage if
 * there's no references in that set (this can be efficiently checked thanks to
 * sorting by key).
 *
 * ReferenceSet also keeps a secondary set that contains references sorted by
 * IDs. This one is used to efficiently implement removal of all references by
 * some target ID.
 */ class Me {
    constructor() {
        // A set of outstanding references to a document sorted by key.
        this.gn = new k(Ue.me), 
        // A set of outstanding references to a document sorted by target id.
        this.yn = new k(Ue.bn);
    }
    /** Returns true if the reference set contains no references. */    q() {
        return this.gn.q();
    }
    /** Adds a reference to the given document key for the given ID. */    vn(t, e) {
        const s = new Ue(t, e);
        this.gn = this.gn.add(s), this.yn = this.yn.add(s);
    }
    /** Add references to the given document keys for the given ID. */    Sn(t, e) {
        t.forEach(t => this.vn(t, e));
    }
    /**
     * Removes a reference to the given document key for the given
     * ID.
     */    Cn(t, e) {
        this.Dn(new Ue(t, e));
    }
    Fn(t, e) {
        t.forEach(t => this.Cn(t, e));
    }
    /**
     * Clears all references with a given ID. Calls removeRef() for each key
     * removed.
     */    Nn(t) {
        const e = C.EMPTY, s = new Ue(e, t), i = new Ue(e, t + 1), n = [];
        return this.yn.Dt([ s, i ], t => {
            this.Dn(t), n.push(t.key);
        }), n;
    }
    kn() {
        this.gn.forEach(t => this.Dn(t));
    }
    Dn(t) {
        this.gn = this.gn.delete(t), this.yn = this.yn.delete(t);
    }
    Ln(t) {
        const e = C.EMPTY, s = new Ue(e, t), i = new Ue(e, t + 1);
        let n = se();
        return this.yn.Dt([ s, i ], t => {
            n = n.add(t.key);
        }), n;
    }
    $n(t) {
        const e = new Ue(t, 0), s = this.gn.Nt(e);
        return null !== s && t.isEqual(s.key);
    }
}

class Ue {
    constructor(t, e) {
        this.key = t, this.On = e;
    }
    /** Compare by key then by ID */    static me(t, e) {
        return C.k(t.key, e.key) || De(t.On, e.On);
    }
    /** Compare by ID then by key */    static bn(t, e) {
        return De(t.On, e.On) || C.k(t.key, e.key);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * PersistencePromise<> is essentially a re-implementation of Promise<> except
 * it has a .next() method instead of .then() and .next() and .catch() callbacks
 * are executed synchronously when a PersistencePromise resolves rather than
 * asynchronously (Promise<> implementations use setImmediate() or similar).
 *
 * This is necessary to interoperate with IndexedDB which will automatically
 * commit transactions if control is returned to the event loop without
 * synchronously initiating another operation on the transaction.
 *
 * NOTE: .then() and .catch() only allow a single consumer, unlike normal
 * Promises.
 */ class qe {
    constructor(t) {
        // NOTE: next/catchCallback will always point to our own wrapper functions,
        // not the user's raw next() or catch() callbacks.
        this.Mn = null, this.Un = null, 
        // When the operation resolves, we'll set result or error and mark isDone.
        this.result = void 0, this.error = void 0, this.qn = !1, 
        // Set to true when .then() or .catch() are called and prevents additional
        // chaining.
        this.Bn = !1, t(t => {
            this.qn = !0, this.result = t, this.Mn && 
            // value should be defined unless T is Void, but we can't express
            // that in the type system.
            this.Mn(t);
        }, t => {
            this.qn = !0, this.error = t, this.Un && this.Un(t);
        });
    }
    catch(t) {
        return this.next(void 0, t);
    }
    next(t, e) {
        return this.Bn && ve("Called next() or catch() twice for PersistencePromise"), this.Bn = !0, 
        this.qn ? this.error ? this.xn(e, this.error) : this.Qn(t, this.result) : new qe((s, i) => {
            this.Mn = e => {
                this.Qn(t, e).next(s, i);
            }, this.Un = t => {
                this.xn(e, t).next(s, i);
            };
        });
    }
    Wn() {
        return new Promise((t, e) => {
            this.next(t, e);
        });
    }
    jn(t) {
        try {
            const e = t();
            return e instanceof qe ? e : qe.resolve(e);
        } catch (t) {
            return qe.reject(t);
        }
    }
    Qn(t, e) {
        return t ? this.jn(() => t(e)) : qe.resolve(e);
    }
    xn(t, e) {
        return t ? this.jn(() => t(e)) : qe.reject(e);
    }
    static resolve(t) {
        return new qe((e, s) => {
            e(t);
        });
    }
    static reject(t) {
        return new qe((e, s) => {
            s(t);
        });
    }
    static Gn(
    // Accept all Promise types in waitFor().
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    t) {
        return new qe((e, s) => {
            let i = 0, n = 0, r = !1;
            t.forEach(t => {
                ++i, t.next(() => {
                    ++n, r && n === i && e();
                }, t => s(t));
            }), r = !0, n === i && e();
        });
    }
    /**
     * Given an array of predicate functions that asynchronously evaluate to a
     * boolean, implements a short-circuiting `or` between the results. Predicates
     * will be evaluated until one of them returns `true`, then stop. The final
     * result will be whether any of them returned `true`.
     */    static zn(t) {
        let e = qe.resolve(!1);
        for (const s of t) e = e.next(t => t ? qe.resolve(t) : s());
        return e;
    }
    static forEach(t, e) {
        const s = [];
        return t.forEach((t, i) => {
            s.push(e.call(this, t, i));
        }), this.Gn(s);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory buffer of entries to be written to a RemoteDocumentCache.
 * It can be used to batch up a set of changes to be written to the cache, but
 * additionally supports reading entries back with the `getEntry()` method,
 * falling back to the underlying RemoteDocumentCache if no entry is
 * buffered.
 *
 * Entries added to the cache *must* be read first. This is to facilitate
 * calculating the size delta of the pending changes.
 *
 * PORTING NOTE: This class was implemented then removed from other platforms.
 * If byte-counting ends up being needed on the other platforms, consider
 * porting this class as part of that implementation work.
 */
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A readonly view of the local state of all documents we're tracking (i.e. we
 * have a cached version in remoteDocumentCache or local mutations for the
 * document). The view is computed by applying the mutations in the
 * MutationQueue to the RemoteDocumentCache.
 */
class Be {
    constructor(t, e, s) {
        this.Kn = t, this.Hn = e, this.Jn = s;
    }
    /**
     * Get the local view of the document identified by `key`.
     *
     * @return Local view of the document or null if we don't have any cached
     * state for it.
     */    Yn(t, e) {
        return this.Hn.Xn(t, e).next(s => this.Zn(t, e, s));
    }
    /** Internal version of `getDocument` that allows reusing batches. */    Zn(t, e, s) {
        return this.Kn.tr(t, e).next(t => {
            for (const i of s) t = i.qt(e, t);
            return t;
        });
    }
    // Returns the view of the given `docs` as they would appear after applying
    // all mutations in the given `batches`.
    er(t, e, s) {
        let i = Jt();
        return e.forEach((t, e) => {
            for (const i of s) e = i.qt(t, e);
            i = i.nt(t, e);
        }), i;
    }
    /**
     * Gets the local view of the documents identified by `keys`.
     *
     * If we don't have cached state for a document in `keys`, a NoDocument will
     * be stored for that key in the resulting set.
     */    sr(t, e) {
        return this.Kn.getEntries(t, e).next(e => this.ir(t, e));
    }
    /**
     * Similar to `getDocuments`, but creates the local view from the given
     * `baseDocs` without retrieving documents from the local store.
     */    ir(t, e) {
        return this.Hn.nr(t, e).next(s => {
            const i = this.er(t, e, s);
            let n = Ht();
            return i.forEach((t, e) => {
                // TODO(http://b/32275378): Don't conflate missing / deleted.
                e || (e = new yt(t, g.S())), n = n.nt(t, e);
            }), n;
        });
    }
    /**
     * Performs a query against the local view of all documents.
     *
     * @param transaction The persistence transaction.
     * @param query The query to match documents against.
     * @param sinceReadTime If not set to SnapshotVersion.MIN, return only
     *     documents that have been read since this snapshot version (exclusive).
     */    rr(t, e, s) {
        return e.Pe() ? this.hr(t, e.path) : e.He() ? this.or(t, e, s) : this.ar(t, e, s);
    }
    hr(t, e) {
        // Just do a simple document lookup.
        return this.Yn(t, new C(e)).next(t => {
            let e = Xt();
            return t instanceof gt && (e = e.nt(t.key, t)), e;
        });
    }
    or(t, e, s) {
        const i = e.collectionGroup;
        let n = Xt();
        return this.Jn.ur(t, i).next(r => qe.forEach(r, r => {
            const h = e.Oe(r.child(i));
            return this.ar(t, h, s).next(t => {
                t.forEach((t, e) => {
                    n = n.nt(t, e);
                });
            });
        }).next(() => n));
    }
    ar(t, e, s) {
        // Query the remote documents and overlay mutations.
        let i, n;
        return this.Kn.rr(t, e, s).next(s => (i = s, this.Hn.cr(t, e))).next(e => (n = e, 
        this.lr(t, n, i).next(t => {
            i = t;
            for (const t of n) for (const e of t.mutations) {
                const s = e.key, n = i.get(s), r = e.qt(n, n, t.In);
                i = r instanceof gt ? i.nt(s, r) : i.remove(s);
            }
        }))).next(() => (
        // Finally, filter out any documents that don't actually match
        // the query.
        i.forEach((t, s) => {
            e.matches(s) || (i = i.remove(t));
        }), i));
    }
    lr(t, e, s) {
        let i = se();
        for (const t of e) for (const e of t.mutations) e instanceof Et && null === s.get(e.key) && (i = i.add(e.key));
        let n = s;
        return this.Kn.getEntries(t, i).next(t => (t.forEach((t, e) => {
            null !== e && e instanceof gt && (n = n.nt(t, e));
        }), n));
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A set of changes to what documents are currently in view and out of view for
 * a given query. These changes are sent to the LocalStore by the View (via
 * the SyncEngine) and are used to pin / unpin documents as appropriate.
 */ class xe {
    constructor(t, e, s, i) {
        this.targetId = t, this.fromCache = e, this._r = s, this.dr = i;
    }
    static wr(t, e) {
        let s = se(), i = se();
        for (const t of e.docChanges) switch (t.type) {
          case 0 /* Added */ :
            s = s.add(t.doc.key);
            break;

          case 1 /* Removed */ :
            i = i.add(t.doc.key);
 // do nothing
                }
        return new xe(t, e.fromCache, s, i);
    }
}

/**
 * @license
 * Copyright 2018 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * `ListenSequence` is a monotonic sequence. It is initialized with a minimum value to
 * exceed. All subsequent calls to next will return increasing values. If provided with a
 * `SequenceNumberSyncer`, it will additionally bump its next value when told of a new value, as
 * well as write out sequence numbers that it produces via `next()`.
 */ class Qe {
    constructor(t, e) {
        this.previousValue = t, e && (e.Tr = t => this.mr(t), this.Er = t => e.Rr(t));
    }
    mr(t) {
        return this.previousValue = Math.max(t, this.previousValue), this.previousValue;
    }
    next() {
        const t = ++this.previousValue;
        return this.Er && this.Er(t), t;
    }
}

Qe.Ir = -1;

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class We {
    constructor() {
        this.promise = new Promise((t, e) => {
            this.resolve = t, this.reject = e;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Represents an operation scheduled to be run in the future on an AsyncQueue.
 *
 * It is created via DelayedOperation.createAndSchedule().
 *
 * Supports cancellation (via cancel()) and early execution (via skipDelay()).
 */ class je {
    constructor(t, e, s, i, n) {
        this.Ar = t, this.Pr = e, this.Vr = s, this.op = i, this.pr = n, this.gr = new We, 
        this.then = this.gr.promise.then.bind(this.gr.promise), this.catch = this.gr.promise.catch.bind(this.gr.promise), 
        // It's normal for the deferred promise to be canceled (due to cancellation)
        // and so we attach a dummy catch callback to avoid
        // 'UnhandledPromiseRejectionWarning' log spam.
        this.gr.promise.catch(t => {});
    }
    /**
     * Creates and returns a DelayedOperation that has been scheduled to be
     * executed on the provided asyncQueue after the provided delayMs.
     *
     * @param asyncQueue The queue to schedule the operation on.
     * @param id A Timer ID identifying the type of operation this is.
     * @param delayMs The delay (ms) before the operation should be scheduled.
     * @param op The operation to run.
     * @param removalCallback A callback to be called synchronously once the
     *   operation is executed or canceled, notifying the AsyncQueue to remove it
     *   from its delayedOperations list.
     *   PORTING NOTE: This exists to prevent making removeDelayedOperation() and
     *   the DelayedOperation class public.
     */    static yr(t, e, s, i, n) {
        const r = Date.now() + s, h = new je(t, e, r, i, n);
        return h.start(s), h;
    }
    /**
     * Starts the timer. This is called immediately after construction by
     * createAndSchedule().
     */    start(t) {
        this.br = setTimeout(() => this.vr(), t);
    }
    /**
     * Queues the operation to run immediately (if it hasn't already been run or
     * canceled).
     */    Sr() {
        return this.vr();
    }
    /**
     * Cancels the operation if it hasn't already been executed or canceled. The
     * promise will be rejected.
     *
     * As long as the operation has not yet been run, calling cancel() provides a
     * guarantee that the operation will not be run.
     */    cancel(t) {
        null !== this.br && (this.clearTimeout(), this.gr.reject(new E(m.CANCELLED, "Operation cancelled" + (t ? ": " + t : ""))));
    }
    vr() {
        this.Ar.Cr(() => null !== this.br ? (this.clearTimeout(), this.op().then(t => this.gr.resolve(t))) : Promise.resolve());
    }
    clearTimeout() {
        null !== this.br && (this.pr(this), clearTimeout(this.br), this.br = null);
    }
}

class Ge {
    constructor() {
        // The last promise in the queue.
        this.Dr = Promise.resolve(), 
        // Is this AsyncQueue being shut down? Once it is set to true, it will not
        // be changed again.
        this.Fr = !1, 
        // Operations scheduled to be queued in the future. Operations are
        // automatically removed after they are run or canceled.
        this.Nr = [], 
        // visible for testing
        this.kr = null, 
        // Flag set while there's an outstanding AsyncQueue operation, used for
        // assertion sanity-checks.
        this.Lr = !1, 
        // List of TimerIds to fast-forward delays for.
        this.$r = [];
    }
    // Is this AsyncQueue being shut down? If true, this instance will not enqueue
    // any new operations, Promises from enqueue requests will not resolve.
    get Or() {
        return this.Fr;
    }
    /**
     * Adds a new operation to the queue without waiting for it to complete (i.e.
     * we ignore the Promise result).
     */    Cr(t) {
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.enqueue(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue without waiting for it to complete (i.e. we ignore the Promise result).
     */    Mr(t) {
        this.Ur(), 
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.qr(t);
    }
    /**
     * Regardless if the queue has initialized shutdown, adds a new operation to the
     * queue.
     */    Br(t) {
        return this.Ur(), this.qr(t);
    }
    /**
     * Adds a new operation to the queue and initialize the shut down of this queue.
     * Returns a promise that will be resolved when the promise returned by the new
     * operation is (with its value).
     * Once this method is called, the only possible way to request running an operation
     * is through `enqueueAndForgetEvenAfterShutdown`.
     */    async xr(t) {
        this.Ur(), this.Fr || (this.Fr = !0, await this.Br(t));
    }
    /**
     * Adds a new operation to the queue. Returns a promise that will be resolved
     * when the promise returned by the new operation is (with its value).
     */    enqueue(t) {
        return this.Ur(), this.Fr ? new Promise(t => {}) : this.qr(t);
    }
    qr(t) {
        const e = this.Dr.then(() => (this.Lr = !0, t().catch(t => {
            // Re-throw the error so that this.tail becomes a rejected Promise and
            // all further attempts to chain (via .then) will just short-circuit
            // and return the rejected Promise.
            throw this.kr = t, this.Lr = !1, ye("INTERNAL UNHANDLED ERROR: ", t.stack || t.message || ""), 
            t;
        }).then(t => (this.Lr = !1, t))));
        return this.Dr = e, e;
    }
    /**
     * Schedules an operation to be queued on the AsyncQueue once the specified
     * `delayMs` has elapsed. The returned CancelablePromise can be used to cancel
     * the operation prior to its running.
     */    Qr(t, e, s) {
        this.Ur(), 
        // Fast-forward delays for timerIds that have been overriden.
        this.$r.indexOf(t) > -1 && (e = 0);
        const i = je.yr(this, t, e, s, t => this.Wr(t));
        return this.Nr.push(i), i;
    }
    Ur() {
        this.kr && ve("AsyncQueue is already failed: " + (this.kr.stack || this.kr.message));
    }
    /**
     * Verifies there's an operation currently in-progress on the AsyncQueue.
     * Unfortunately we can't verify that the running code is in the promise chain
     * of that operation, so this isn't a foolproof check, but it should be enough
     * to catch some bugs.
     */    jr() {}
    /**
     * Waits until all currently queued tasks are finished executing. Delayed
     * operations are not run.
     */    async Gr() {
        // Operations in the queue prior to draining may have enqueued additional
        // operations. Keep draining the queue until the tail is no longer advanced,
        // which indicates that no more new operations were enqueued and that all
        // operations were executed.
        let t;
        do {
            t = this.Dr, await t;
        } while (t !== this.Dr);
    }
    /**
     * For Tests: Determine if a delayed operation with a particular TimerId
     * exists.
     */    zr(t) {
        for (const e of this.Nr) if (e.Pr === t) return !0;
        return !1;
    }
    /**
     * For Tests: Runs some or all delayed operations early.
     *
     * @param lastTimerId Delayed operations up to and including this TimerId will
     *  be drained. Throws if no such operation exists. Pass TimerId.All to run
     *  all delayed operations.
     * @returns a Promise that resolves once all operations have been run.
     */    Kr(t) {
        // Note that draining may generate more delayed ops, so we do that first.
        return this.Gr().then(() => {
            // Run ops in the same order they'd run if they ran naturally.
            this.Nr.sort((t, e) => t.Vr - e.Vr);
            for (const e of this.Nr) if (e.Sr(), "all" /* All */ !== t && e.Pr === t) break;
            return this.Gr();
        });
    }
    /**
     * For Tests: Skip all subsequent delays for a timer id.
     */    Hr(t) {
        this.$r.push(t);
    }
    /** Called once a DelayedOperation is run or canceled. */    Wr(t) {
        // NOTE: indexOf / slice are O(n), but delayedOperations is expected to be small.
        const e = this.Nr.indexOf(t);
        this.Nr.splice(e, 1);
    }
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class ze {
    constructor(
    // When we attempt to collect, we will only do so if the cache size is greater than this
    // threshold. Passing `COLLECTION_DISABLED` here will cause collection to always be skipped.
    t, 
    // The percentage of sequence numbers that we will attempt to collect
    e, 
    // A cap on the total number of sequence numbers that will be collected. This prevents
    // us from collecting a huge number of sequence numbers if the cache has grown very large.
    s) {
        this.Jr = t, this.Yr = e, this.Xr = s;
    }
    static Zr(t) {
        return new ze(t, ze.th, ze.eh);
    }
}

ze.sh = -1, ze.ih = 1048576, ze.nh = 41943040, ze.th = 10, ze.eh = 1e3, ze.rh = new ze(ze.nh, ze.th, ze.eh), 
ze.DISABLED = new ze(ze.sh, 0, 0);

/**
 * Local storage in the Firestore client. Coordinates persistence components
 * like the mutation queue and remote document cache to present a
 * latency-compensated view of stored data.
 *
 * The LocalStore is responsible for accepting mutations from the Sync Engine.
 * Writes from the client are put into a queue as provisional Mutations until
 * they are processed by the RemoteStore and confirmed as having been written
 * to the server.
 *
 * The local store provides the local version of documents that have been
 * modified locally. It maintains the constraint:
 *
 *   LocalDocument = RemoteDocument + Active(LocalMutations)
 *
 * (Active mutations are those that are enqueued and have not been previously
 * acknowledged or rejected).
 *
 * The RemoteDocument ("ground truth") state is provided via the
 * applyChangeBatch method. It will be some version of a server-provided
 * document OR will be a server-provided document PLUS acknowledged mutations:
 *
 *   RemoteDocument' = RemoteDocument + Acknowledged(LocalMutations)
 *
 * Note that this "dirty" version of a RemoteDocument will not be identical to a
 * server base version, since it has LocalMutations added to it pending getting
 * an authoritative copy from the server.
 *
 * Since LocalMutations can be rejected by the server, we have to be able to
 * revert a LocalMutation that has already been applied to the LocalDocument
 * (typically done by replaying all remaining LocalMutations to the
 * RemoteDocument to re-apply).
 *
 * The LocalStore is responsible for the garbage collection of the documents it
 * contains. For now, it every doc referenced by a view, the mutation queue, or
 * the RemoteStore.
 *
 * It also maintains the persistence of mapping queries to resume tokens and
 * target ids. It needs to know this data about queries to properly know what
 * docs it would be allowed to garbage collect.
 *
 * The LocalStore must be able to efficiently execute queries against its local
 * cache of the documents, to provide the initial set of results before any
 * remote changes have been received.
 *
 * Note: In TypeScript, most methods return Promises since the implementation
 * may rely on fetching data from IndexedDB which is async.
 * These Promises will only be rejected on an I/O error or other internal
 * (unexpected) failure (e.g. failed assert) and always represent an
 * unrecoverable error (should be caught / reported by the async_queue).
 */
class Ke {
    constructor(
    /** Manages our in-memory or durable persistence. */
    t, e, s) {
        this.persistence = t, this.hh = e, 
        /**
         * The set of document references maintained by any local views.
         */
        this.oh = new Me, 
        /**
         * Maps a targetID to data about its target.
         *
         * PORTING NOTE: We are using an immutable data structure on Web to make re-runs
         * of `applyRemoteEvent()` idempotent.
         */
        this.ah = new D(De), 
        /** Maps a target to its targetID. */
        // TODO(wuandy): Evaluate if TargetId can be part of Target.
        this.uh = new Le(t => t.canonicalId()), 
        /**
         * The read time of the last entry processed by `getNewDocumentChanges()`.
         *
         * PORTING NOTE: This is only used for multi-tab synchronization.
         */
        this.lh = g.MIN, this.persistence.dh._h(this.oh), this.Hn = t.fh(s), this.wh = t.Th(), 
        this.mh = t.Eh(), this.Rh = new Be(this.wh, this.Hn, this.persistence.Ih()), this.hh.Ah(this.Rh);
    }
    /** Starts the LocalStore. */    start() {
        return this.Ph();
    }
    /**
     * Tells the LocalStore that the currently authenticated user has changed.
     *
     * In response the local store switches the mutation queue to the new user and
     * returns any resulting document changes.
     */
    // PORTING NOTE: Android and iOS only return the documents affected by the
    // change.
    async Vh(t) {
        let e = this.Hn, s = this.Rh;
        const i = await this.persistence.runTransaction("Handle user change", "readonly", i => {
            // Swap out the mutation queue, grabbing the pending mutation batches
            // before and after.
            let n;
            return this.Hn.ph(i).next(r => (n = r, e = this.persistence.fh(t), 
            // Recreate our LocalDocumentsView using the new
            // MutationQueue.
            s = new Be(this.wh, e, this.persistence.Ih()), e.ph(i))).next(t => {
                const e = [], r = [];
                // Union the old/new changed keys.
                let h = se();
                for (const t of n) {
                    e.push(t.batchId);
                    for (const e of t.mutations) h = h.add(e.key);
                }
                for (const e of t) {
                    r.push(e.batchId);
                    for (const t of e.mutations) h = h.add(t.key);
                }
                // Return the set of all (potentially) changed documents and the list
                // of mutation batch IDs that were affected by change.
                                return s.sr(i, h).next(t => ({
                    gh: t,
                    yh: e,
                    bh: r
                }));
            });
        });
        return this.Hn = e, this.Rh = s, this.hh.Ah(this.Rh), i;
    }
    /* Accept locally generated Mutations and commit them to storage. */    vh(t) {
        const e = p.now(), s = t.reduce((t, e) => t.add(e.key), se());
        let i;
        return this.persistence.runTransaction("Locally write mutations", "readwrite", n => this.Rh.sr(n, s).next(s => {
            i = s;
            // For non-idempotent mutations (such as `FieldValue.increment()`),
            // we record the base state in a separate patch mutation. This is
            // later used to guarantee consistent values and prevents flicker
            // even if the backend sends us an update that already includes our
            // transform.
            const r = [];
            for (const e of t) {
                const t = e.ee(i.get(e.key));
                null != t && 
                // NOTE: The base state should only be applied if there's some
                // existing document to override, so use a Precondition of
                // exists=true
                r.push(new Et(e.key, t, t.se(), wt.exists(!0)));
            }
            return this.Hn.Sh(n, e, r, t);
        })).then(t => {
            const e = t.Pn(i);
            return {
                batchId: t.batchId,
                Ch: e
            };
        });
    }
    /** Returns the local view of the documents affected by a mutation batch. */
    // PORTING NOTE: Multi-tab only.
    Dh(t) {
        return this.persistence.runTransaction("Lookup mutation documents", "readonly", e => this.Hn.Fh(e, t).next(t => t ? this.Rh.sr(e, t) : qe.resolve(null)));
    }
    /**
     * Acknowledge the given batch.
     *
     * On the happy path when a batch is acknowledged, the local store will
     *
     *  + remove the batch from the mutation queue;
     *  + apply the changes to the remote document cache;
     *  + recalculate the latency compensated view implied by those changes (there
     *    may be mutations in the queue that affect the documents but haven't been
     *    acknowledged yet); and
     *  + give the changed documents back the sync engine
     *
     * @returns The resulting (modified) documents.
     */    Nh(t) {
        return this.persistence.runTransaction("Acknowledge batch", "readwrite-primary", e => {
            const s = t.batch.keys(), i = this.wh.kh({
                Lh: !0
            });
            return this.Hn.Nh(e, t.batch, t.streamToken).next(() => this.$h(e, t, i)).next(() => i.apply(e)).next(() => this.Hn.Oh(e)).next(() => this.Rh.sr(e, s));
        });
    }
    /**
     * Remove mutations from the MutationQueue for the specified batch;
     * LocalDocuments will be recalculated.
     *
     * @returns The resulting modified documents.
     */    Mh(t) {
        return this.persistence.runTransaction("Reject batch", "readwrite-primary", e => {
            let s;
            return this.Hn.Uh(e, t).next(t => (Se(null !== t, "Attempt to reject nonexistent batch!"), 
            s = t.keys(), this.Hn.qh(e, t))).next(() => this.Hn.Oh(e)).next(() => this.Rh.sr(e, s));
        });
    }
    /**
     * Returns the largest (latest) batch id in mutation queue that is pending server response.
     * Returns `BATCHID_UNKNOWN` if the queue is empty.
     */    Bh() {
        return this.persistence.runTransaction("Get highest unacknowledged batch id", "readonly", t => this.Hn.Bh(t));
    }
    /** Returns the last recorded stream token for the current user. */    xh() {
        return this.persistence.runTransaction("Get last stream token", "readonly", t => this.Hn.xh(t));
    }
    /**
     * Sets the stream token for the current user without acknowledging any
     * mutation batch. This is usually only useful after a stream handshake or in
     * response to an error that requires clearing the stream token.
     */    Qh(t) {
        return this.persistence.runTransaction("Set last stream token", "readwrite-primary", e => this.Hn.Qh(e, t));
    }
    /**
     * Returns the last consistent snapshot processed (used by the RemoteStore to
     * determine whether to buffer incoming snapshots from the backend).
     */    Wh() {
        return this.persistence.runTransaction("Get last remote snapshot version", "readonly", t => this.mh.Wh(t));
    }
    /**
     * Update the "ground-state" (remote) documents. We assume that the remote
     * event reflects any write batches that have been acknowledged or rejected
     * (i.e. we do not re-apply local mutations to updates from this event).
     *
     * LocalDocuments are re-calculated if there are remaining mutations in the
     * queue.
     */    jh(t) {
        const e = t.ts;
        let s = this.ah;
        return this.persistence.runTransaction("Apply remote event", "readwrite-primary", i => {
            const n = this.wh.kh({
                Lh: !0
            });
            // Reset newTargetDataByTargetMap in case this transaction gets re-run.
                        s = this.ah;
            const r = [];
            t.ws.forEach((t, n) => {
                const h = s.get(n);
                if (!h) return;
                // Only update the remote keys if the target is still active. This
                // ensures that we can persist the updated target data along with
                // the updated assignment.
                                r.push(this.mh.Gh(i, t.ps, n).next(() => this.mh.zh(i, t.Ps, n)));
                const o = t.resumeToken;
                // Update the resume token if the change includes one.
                                if (o.Mt() > 0) {
                    const a = h.ss(o, e).es(i.Kh);
                    s = s.nt(n, a), 
                    // Update the target data if there are target changes (or if
                    // sufficient time has passed since the last update).
                    Ke.Hh(h, a, t) && r.push(this.mh.Jh(i, a));
                }
            });
            let h = Ht(), o = se();
            // HACK: The only reason we allow a null snapshot version is so that we
            // can synthesize remote events when we get permission denied errors while
            // trying to resolve the state of a locally cached document that is in
            // limbo.
            if (t.ms.forEach((t, e) => {
                o = o.add(t);
            }), 
            // Each loop iteration only affects its "own" doc, so it's safe to get all the remote
            // documents in advance in a single call.
            r.push(n.getEntries(i, o).next(s => {
                t.ms.forEach((o, a) => {
                    const u = s.get(o);
                    // Note: The order of the steps below is important, since we want
                    // to ensure that rejected limbo resolutions (which fabricate
                    // NoDocuments with SnapshotVersion.MIN) never add documents to
                    // cache.
                                        a instanceof yt && a.version.isEqual(g.MIN) ? (
                    // NoDocuments with SnapshotVersion.MIN are used in manufactured
                    // events. We remove these documents from cache since we lost
                    // access.
                    n.Yh(o, e), h = h.nt(o, a)) : null == u || a.version.C(u.version) > 0 || 0 === a.version.C(u.version) && u.hasPendingWrites ? (n.Xh(a, e), 
                    h = h.nt(o, a)) : ge("LocalStore", "Ignoring outdated watch update for ", o, ". Current version:", u.version, " Watch version:", a.version), 
                    t.Es.has(o) && r.push(this.persistence.dh.Zh(i, o));
                });
            })), !e.isEqual(g.MIN)) {
                const t = this.mh.Wh(i).next(t => this.mh.to(i, i.Kh, e));
                r.push(t);
            }
            return qe.Gn(r).next(() => n.apply(i)).next(() => this.Rh.ir(i, h));
        }).then(t => (this.ah = s, t));
    }
    /**
     * Returns true if the newTargetData should be persisted during an update of
     * an active target. TargetData should always be persisted when a target is
     * being released and should not call this function.
     *
     * While the target is active, TargetData updates can be omitted when nothing
     * about the target has changed except metadata like the resume token or
     * snapshot version. Occasionally it's worth the extra write to prevent these
     * values from getting too stale after a crash, but this doesn't have to be
     * too frequent.
     */    static Hh(t, e, s) {
        // Always persist target data if we don't already have a resume token.
        if (Se(e.resumeToken.Mt() > 0, "Attempted to persist target data with no resume token"), 
        0 === t.resumeToken.Mt()) return !0;
        // Don't allow resume token changes to be buffered indefinitely. This
        // allows us to be reasonably up-to-date after a crash and avoids needing
        // to loop over all active queries on shutdown. Especially in the browser
        // we may not get time to do anything interesting while the current tab is
        // closing.
                return e.ts.D() - t.ts.D() >= this.eo || s.Ps.size + s.Vs.size + s.ps.size > 0;
        // Otherwise if the only thing that has changed about a target is its resume
        // token it's not worth persisting. Note that the RemoteStore keeps an
        // in-memory view of the currently active targets which includes the current
        // resume token, so stream failure or user changes will still use an
        // up-to-date resume token regardless of what we do here.
        }
    /**
     * Notify local store of the changed views to locally pin documents.
     */    so(t) {
        for (const e of t) {
            const t = e.targetId;
            if (this.oh.Sn(e._r, t), this.oh.Fn(e.dr, t), !e.fromCache) {
                const e = this.ah.get(t), s = e.ts, i = e.ns(s);
                // Advance the last limbo free snapshot version
                                this.ah = this.ah.nt(t, i);
            }
        }
        return this.persistence.runTransaction("notifyLocalViewChanges", "readwrite", e => qe.forEach(t, t => qe.forEach(t.dr, t => this.persistence.dh.Cn(e, t))));
    }
    /**
     * Gets the mutation batch after the passed in batchId in the mutation queue
     * or null if empty.
     * @param afterBatchId If provided, the batch to search after.
     * @returns The next mutation or null if there wasn't one.
     */    io(t) {
        return this.persistence.runTransaction("Get next mutation batch", "readonly", e => (void 0 === t && (t = -1), 
        this.Hn.no(e, t)));
    }
    /**
     * Read the current value of a Document with a given key or null if not
     * found - used for testing.
     */    ro(t) {
        return this.persistence.runTransaction("read document", "readonly", e => this.Rh.Yn(e, t));
    }
    /**
     * Assigns the given target an internal ID so that its results can be pinned so
     * they don't get GC'd. A target must be allocated in the local store before
     * the store can be used to manage its view.
     *
     * Allocating an already allocated `Target` will return the existing `TargetData`
     * for that `Target`.
     */    ho(t) {
        return this.persistence.runTransaction("Allocate target", "readwrite", e => {
            let s;
            return this.mh.oo(e, t).next(i => i ? (
            // This target has been listened to previously, so reuse the
            // previous targetID.
            // TODO(mcg): freshen last accessed date?
            s = i, qe.resolve(s)) : this.mh.ao(e).next(i => (s = new xt(t, i, 0 /* Listen */ , e.Kh), 
            this.mh.uo(e, s).next(() => s))));
        }).then(e => (null === this.ah.get(e.targetId) && (this.ah = this.ah.nt(e.targetId, e), 
        this.uh.set(t, e.targetId)), e));
    }
    /**
     * Returns the TargetData as seen by the LocalStore, including updates that may
     * have not yet been persisted to the TargetCache.
     */
    // Visible for testing.
    oo(t, e) {
        const s = this.uh.get(e);
        return void 0 !== s ? qe.resolve(this.ah.get(s)) : this.mh.oo(t, e);
    }
    /**
     * Unpin all the documents associated with the given target. If
     * `keepPersistedTargetData` is set to false and Eager GC enabled, the method
     * directly removes the associated target data from the target cache.
     *
     * Releasing a non-existing `Target` is a no-op.
     */
    // PORTING NOTE: `keepPersistedTargetData` is multi-tab only.
    co(t, e) {
        const s = this.ah.get(t), i = e ? "readwrite" : "readwrite-primary";
        return this.persistence.runTransaction("Release target", i, i => {
            // References for documents sent via Watch are automatically removed
            // when we delete a target's data from the reference delegate.
            // Since this does not remove references for locally mutated documents,
            // we have to remove the target associations for these documents
            // manually.
            // This operation needs to be run inside the transaction since EagerGC
            // uses the local view references during the transaction's commit.
            // Fortunately, the operation is safe to be re-run in case the
            // transaction fails since there are no side effects if the target has
            // already been removed.
            const n = this.oh.Nn(t);
            return e ? qe.resolve() : qe.forEach(n, t => this.persistence.dh.Cn(i, t)).next(() => {
                this.persistence.dh.removeTarget(i, s);
            });
        }).then(() => {
            this.ah = this.ah.remove(t), this.uh.delete(s.target);
        });
    }
    /**
     * Runs the specified query against the local store and returns the results,
     * potentially taking advantage of query data from previous executions (such
     * as the set of remote keys).
     *
     * @param usePreviousResults Whether results from previous executions can
     * be used to optimize this query execution.
     */    lo(t, e) {
        let s = g.MIN, i = se();
        return this.persistence.runTransaction("Execute query", "readonly", n => this.oo(n, t.Ue()).next(t => {
            if (t) return s = t.lastLimboFreeSnapshotVersion, this.mh._o(n, t.targetId).next(t => {
                i = t;
            });
        }).next(() => this.hh.rr(n, t, e ? s : g.MIN, e ? i : se())).next(t => ({
            documents: t,
            do: i
        })));
    }
    /**
     * Returns the keys of the documents that are associated with the given
     * target id in the remote table.
     */    fo(t) {
        return this.persistence.runTransaction("Remote document keys", "readonly", e => this.mh._o(e, t));
    }
    // PORTING NOTE: Multi-tab only.
    wo() {
        return this.persistence.wo();
    }
    // PORTING NOTE: Multi-tab only.
    To(t) {
        this.Hn.mo(t);
    }
    // PORTING NOTE: Multi-tab only.
    Eo(t) {
        this.persistence.Eo(t);
    }
    $h(t, e, s) {
        const i = e.batch, n = i.keys();
        let r = qe.resolve();
        return n.forEach(n => {
            r = r.next(() => s.tr(t, n)).next(t => {
                let r = t;
                const h = e.pn.get(n);
                Se(null !== h, "ackVersions should contain every doc in the write."), (!r || r.version.C(h) < 0) && (r = i.Bt(n, r, e), 
                r && 
                // We use the commitVersion as the readTime rather than the
                // document's updateTime since the updateTime is not advanced
                // for updates that do not modify the underlying document.
                s.Xh(r, e.Vn));
            });
        }), r.next(() => this.Hn.qh(t, i));
    }
    Ro(t) {
        return this.persistence.runTransaction("Collect garbage", "readwrite-primary", e => t.Io(e, this.ah));
    }
    // PORTING NOTE: Multi-tab only.
    Ao(t) {
        const e = this.ah.get(t);
        return e ? Promise.resolve(e.target) : this.persistence.runTransaction("Get target data", "readonly", e => this.mh.ui(e, t).next(t => t ? t.target : null));
    }
    /**
     * Returns the set of documents that have been updated since the last call.
     * If this is the first call, returns the set of changes since client
     * initialization. Further invocations will return document changes since
     * the point of rejection.
     */
    // PORTING NOTE: Multi-tab only.
    Po() {
        return this.persistence.runTransaction("Get new document changes", "readonly", t => this.wh.Po(t, this.lh)).then(({Vo: t, readTime: e}) => (this.lh = e, 
        t));
    }
    /**
     * Reads the newest document change from persistence and forwards the internal
     * synchronization marker so that calls to `getNewDocumentChanges()`
     * only return changes that happened after client initialization.
     */
    // PORTING NOTE: Multi-tab only.
    async Ph() {
        this.lh = await this.persistence.runTransaction("Synchronize last document change read time", "readonly", t => this.wh.po(t));
    }
}

/**
 * The maximum time to leave a resume token buffered without writing it out.
 * This value is arbitrary: it's long enough to avoid several writes
 * (possibly indefinitely if updates come more frequently than this) but
 * short enough that restarting after crashing will still have a pretty
 * recent resume token.
 */
/**
 * Verifies the error thrown by a LocalStore operation. If a LocalStore
 * operation fails because the primary lease has been taken by another client,
 * we ignore the error (the persistence layer will immediately call
 * `applyPrimaryLease` to propagate the primary state change). All other errors
 * are re-thrown.
 *
 * @param err An error returned by a LocalStore operation.
 * @return A Promise that resolves after we recovered, or the original error.
 */
async function He(t) {
    if (t.code !== m.FAILED_PRECONDITION || "The current tab is not in the required state to perform this operation. It might be necessary to refresh the browser tab." !== t.message) throw t;
    ge("LocalStore", "Unexpectedly lost primary lease");
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Validates that no arguments were passed in the invocation of functionName.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateNoArgs('myFunction', arguments);
 */ function Je(t, e) {
    if (0 !== e.length) throw new E(m.INVALID_ARGUMENT, `Function ${t}() does not support arguments, ` + "but was called with " + fs(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has the exact number of arguments.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateExactNumberOfArgs('myFunction', arguments, 2);
 */ function Ye(t, e, s) {
    if (e.length !== s) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires ` + fs(s, "argument") + ", but was called with " + fs(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has at least the provided number of
 * arguments (but can have many more).
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateAtLeastNumberOfArgs('myFunction', arguments, 2);
 */ function Xe(t, e, s) {
    if (e.length < s) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires at least ` + fs(s, "argument") + ", but was called with " + fs(e.length, "argument") + ".");
}

/**
 * Validates the invocation of functionName has number of arguments between
 * the values provided.
 *
 * Forward the magic "arguments" variable as second parameter on which the
 * parameter validation is performed:
 * validateBetweenNumberOfArgs('myFunction', arguments, 2, 3);
 */ function Ze(t, e, s, i) {
    if (e.length < s || e.length > i) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires between ${s} and ` + `${i} arguments, but was called with ` + fs(e.length, "argument") + ".");
}

/**
 * Validates the provided argument is an array and has as least the expected
 * number of elements.
 */
/**
 * Validates the provided positional argument has the native JavaScript type
 * using typeof checks.
 */
function ts(t, e, s, i) {
    hs(t, e, `${ds(s)} argument`, i);
}

/**
 * Validates the provided argument has the native JavaScript type using
 * typeof checks or is undefined.
 */ function es(t, e, s, i) {
    void 0 !== i && ts(t, e, s, i);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks.
 */ function ss(t, e, s, i) {
    hs(t, e, `${s} option`, i);
}

/**
 * Validates the provided named option has the native JavaScript type using
 * typeof checks or is undefined.
 */ function is(t, e, s, i) {
    void 0 !== i && ss(t, e, s, i);
}

function ns(t, e, s, i, n) {
    void 0 !== i && function(t, e, s, i, n) {
        if (!(i instanceof Array)) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires its ${e} ` + `option to be an array, but it was: ${as(i)}`);
        for (let r = 0; r < i.length; ++r) if (!n(i[r])) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires all ${e} ` + `elements to be ${s}, but the value at index ${r} ` + `was: ${as(i[r])}`);
    }(t, e, s, i, n);
}

/**
 * Validates that the provided named option equals one of the expected values.
 */
/**
 * Validates that the provided named option equals one of the expected values or
 * is undefined.
 */
function rs(t, e, s, i, n) {
    void 0 !== i && function(t, e, s, i, n) {
        const r = [];
        for (const t of n) {
            if (t === i) return;
            r.push(as(t));
        }
        const h = as(i);
        throw new E(m.INVALID_ARGUMENT, `Invalid value ${h} provided to function ${t}() for option ` + `"${s}". Acceptable values: ${r.join(", ")}`);
    }(t, 0, s, i, n);
}

/**
 * Validates that the provided argument is a valid enum.
 *
 * @param functionName Function making the validation call.
 * @param enums Array containing all possible values for the enum.
 * @param position Position of the argument in `functionName`.
 * @param argument Arugment to validate.
 */
/** Helper to validate the type of a provided input. */
function hs(t, e, s, i) {
    let n = !1;
    if (n = "object" === e ? os(i) : "non-empty string" === e ? "string" == typeof i && "" !== i : typeof i === e, 
    !n) {
        const n = as(i);
        throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires its ${s} ` + `to be of type ${e}, but it was: ${n}`);
    }
}

/**
 * Returns true if it's a non-null object without a custom prototype
 * (i.e. excludes Array, Date, etc.).
 */ function os(t) {
    return "object" == typeof t && null !== t && (Object.getPrototypeOf(t) === Object.prototype || null === Object.getPrototypeOf(t));
}

/** Returns a string describing the type / value of the provided input. */ function as(t) {
    if (void 0 === t) return "undefined";
    if (null === t) return "null";
    if ("string" == typeof t) return t.length > 20 && (t = `${t.substring(0, 20)}...`), 
    JSON.stringify(t);
    if ("number" == typeof t || "boolean" == typeof t) return "" + t;
    if ("object" == typeof t) {
        if (t instanceof Array) return "an array";
        {
            const e = 
            /** Hacky method to try to get the constructor name for an object. */
            function(t) {
                if (t.constructor) {
                    const e = /function\s+([^\s(]+)\s*\(/.exec(t.constructor.toString());
                    if (e && e.length > 1) return e[1];
                }
                return null;
            }
            /** Validates the provided argument is defined. */ (t);
            return e ? `a custom ${e} object` : "an object";
        }
    }
    return "function" == typeof t ? "a function" : ve("Unknown wrong type: " + typeof t);
}

function us(t, e, s) {
    if (void 0 === s) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires a valid ${ds(e)} ` + "argument, but it was undefined.");
}

/**
 * Validates the provided positional argument is an object, and its keys and
 * values match the expected keys and types provided in optionTypes.
 */ function cs(t, e, s) {
    O(e, (e, i) => {
        if (s.indexOf(e) < 0) throw new E(m.INVALID_ARGUMENT, `Unknown option '${e}' passed to function ${t}(). ` + "Available options: " + s.join(", "));
    });
}

/**
 * Helper method to throw an error that the provided argument did not pass
 * an instanceof check.
 */ function ls(t, e, s, i) {
    const n = as(i);
    return new E(m.INVALID_ARGUMENT, `Function ${t}() requires its ${ds(s)} ` + `argument to be a ${e}, but it was: ${n}`);
}

function _s(t, e, s) {
    if (s <= 0) throw new E(m.INVALID_ARGUMENT, `Function "${t}()" requires its ${ds(e)} argument to be a positive number, but it was: ${s}.`);
}

/** Converts a number to its english word representation */ function ds(t) {
    switch (t) {
      case 1:
        return "first";

      case 2:
        return "second";

      case 3:
        return "third";

      default:
        return t + "th";
    }
}

/**
 * Formats the given word as plural conditionally given the preceding number.
 */ function fs(t, e) {
    return `${t} ${e}` + (1 === t ? "" : "s");
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Helper function to prevent instantiation through the constructor.
 *
 * This method creates a new constructor that throws when it's invoked.
 * The prototype of that constructor is then set to the prototype of the hidden
 * "class" to expose all the prototype methods and allow for instanceof
 * checks.
 *
 * To also make all the static methods available, all properties of the
 * original constructor are copied to the new constructor.
 */ function ws(t, e) {
    function s() {
        let t = "This constructor is private.";
        throw e && (t += " ", t += e), new E(m.INVALID_ARGUMENT, t);
    }
    // Make sure instanceof checks work and all methods are exposed on the public
    // constructor
        // eslint-disable-next-line @typescript-eslint/no-explicit-any
    return s.prototype = t.prototype, 
    // Copy any static methods/members
    Object.assign(s, t), s;
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Helper function to assert Uint8Array is available at runtime. */ function Ts() {
    if ("undefined" == typeof Uint8Array) throw new E(m.UNIMPLEMENTED, "Uint8Arrays are not available in this environment.");
}

/** Helper function to assert Base64 functions are available at runtime. */ function ms() {
    if (!Ae.Ot().yo) throw new E(m.UNIMPLEMENTED, "Blobs are unavailable in Firestore in this environment.");
}

/**
 * Immutable class holding a blob (binary data).
 * This class is directly exposed in the public API.
 *
 * Note that while you can't hide the constructor in JavaScript code, we are
 * using the hack above to make sure no-one outside this module can call it.
 */ Ke.eo = 3e8;

class Es {
    constructor(t) {
        ms(), this.bo = t;
    }
    static fromBase64String(t) {
        Ye("Blob.fromBase64String", arguments, 1), ts("Blob.fromBase64String", "string", 1, t), 
        ms();
        try {
            return new Es(U.fromBase64String(t));
        } catch (t) {
            throw new E(m.INVALID_ARGUMENT, "Failed to construct Blob from Base64 string: " + t);
        }
    }
    static fromUint8Array(t) {
        if (Ye("Blob.fromUint8Array", arguments, 1), Ts(), !(t instanceof Uint8Array)) throw ls("Blob.fromUint8Array", "Uint8Array", 1, t);
        return new Es(U.fromUint8Array(t));
    }
    toBase64() {
        return Ye("Blob.toBase64", arguments, 0), ms(), this.bo.toBase64();
    }
    toUint8Array() {
        return Ye("Blob.toUint8Array", arguments, 0), Ts(), this.bo.toUint8Array();
    }
    toString() {
        return "Blob(base64: " + this.toBase64() + ")";
    }
    isEqual(t) {
        return this.bo.isEqual(t.bo);
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting Blob on firebase.firestore.Blob and will be called Blob
// publicly. Internally we still use Blob which has a type checked private
// constructor. Note that Blob and PublicBlob can be used interchangeably in
// instanceof checks.
// For our internal TypeScript code PublicBlob doesn't exist as a type, and so
// we need to use Blob as type and export it too.
const Rs = ws(Es, "Use Blob.fromUint8Array() or Blob.fromBase64String() instead.");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// The objects that are a part of this API are exposed to third-parties as
// compiled javascript so we want to flag our private members with a leading
// underscore to discourage their use.
/**
 * A FieldPath refers to a field in a document. The path may consist of a single
 * field name (referring to a top-level field in the document), or a list of
 * field names (referring to a nested field in the document).
 */ class Is {
    /**
     * Creates a FieldPath from the provided field names. If more than one field
     * name is provided, the path will point to a nested field in a document.
     *
     * @param fieldNames A list of field names.
     */
    constructor(...t) {
        !function(t, e, s, i) {
            if (!(e instanceof Array) || e.length < i) throw new E(m.INVALID_ARGUMENT, `Function ${t}() requires its ${s} argument to be an ` + "array with at least " + `${fs(i, "element")}.`);
        }("FieldPath", t, "fieldNames", 1);
        for (let e = 0; e < t.length; ++e) if (ts("FieldPath", "string", e, t[e]), 0 === t[e].length) throw new E(m.INVALID_ARGUMENT, "Invalid field name at argument $(i + 1). Field names must not be empty.");
        this.vo = new S(t);
    }
    static documentId() {
        return Is.So;
    }
    isEqual(t) {
        if (!(t instanceof Is)) throw ls("isEqual", "FieldPath", 1, t);
        return this.vo.isEqual(t.vo);
    }
}

/**
 * Internal Note: The backend doesn't technically support querying by
 * document ID. Instead it queries by the entire document name (full path
 * included), but in the cases we currently support documentId(), the net
 * effect is the same.
 */ Is.So = new Is(S.X().G());

/**
 * Matches any characters in a field path string that are reserved.
 */
const As = new RegExp("[~\\*/\\[\\]]");

/**
 * Parses a field path string into a FieldPath, treating dots as separators.
 */
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An opaque base class for FieldValue sentinel objects in our public API,
 * with public static methods for creating said sentinel objects.
 */
class Ps {
    constructor(t) {
        this.Co = t;
    }
    static delete() {
        return Je("FieldValue.delete", arguments), Vs.instance;
    }
    static serverTimestamp() {
        return Je("FieldValue.serverTimestamp", arguments), ps.instance;
    }
    static arrayUnion(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return Xe("FieldValue.arrayUnion", arguments, 1), new gs(t);
    }
    static arrayRemove(...t) {
        // NOTE: We don't actually parse the data until it's used in set() or
        // update() since we need access to the Firestore instance.
        return Xe("FieldValue.arrayRemove", arguments, 1), new ys(t);
    }
    static increment(t) {
        return ts("FieldValue.increment", "number", 1, t), Ye("FieldValue.increment", arguments, 1), 
        new bs(t);
    }
    isEqual(t) {
        return this === t;
    }
}

class Vs extends Ps {
    constructor() {
        super("FieldValue.delete");
    }
}

/** Singleton instance. */ Vs.instance = new Vs;

class ps extends Ps {
    constructor() {
        super("FieldValue.serverTimestamp");
    }
}

/** Singleton instance. */ ps.instance = new ps;

class gs extends Ps {
    constructor(t) {
        super("FieldValue.arrayUnion"), this.Do = t;
    }
}

class ys extends Ps {
    constructor(t) {
        super("FieldValue.arrayRemove"), this.Do = t;
    }
}

class bs extends Ps {
    constructor(t) {
        super("FieldValue.increment"), this.Fo = t;
    }
}

// Public instance that disallows construction at runtime. This constructor is
// used when exporting FieldValueImpl on firebase.firestore.FieldValue and will
// be called FieldValue publicly. Internally we still use FieldValueImpl which
// has a type-checked private constructor. Note that FieldValueImpl and
// PublicFieldValue can be used interchangeably in instanceof checks.
// For our internal TypeScript code PublicFieldValue doesn't exist as a type,
// and so we need to use FieldValueImpl as type and export it too.
const vs = ws(Ps, "Use FieldValue.<field>() instead.");

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Immutable class representing a geo point as latitude-longitude pair.
 * This class is directly exposed in the public API, including its constructor.
 */ class Ss {
    constructor(t, e) {
        if (Ye("GeoPoint", arguments, 2), ts("GeoPoint", "number", 1, t), ts("GeoPoint", "number", 2, e), 
        !isFinite(t) || t < -90 || t > 90) throw new E(m.INVALID_ARGUMENT, "Latitude must be a number between -90 and 90, but was: " + t);
        if (!isFinite(e) || e < -180 || e > 180) throw new E(m.INVALID_ARGUMENT, "Longitude must be a number between -180 and 180, but was: " + e);
        this.No = t, this.ko = e;
    }
    /**
     * Returns the latitude of this geo point, a number between -90 and 90.
     */    get latitude() {
        return this.No;
    }
    /**
     * Returns the longitude of this geo point, a number between -180 and 180.
     */    get longitude() {
        return this.ko;
    }
    isEqual(t) {
        return this.No === t.No && this.ko === t.ko;
    }
    /**
     * Actually private to JS consumers of our API, so this function is prefixed
     * with an underscore.
     */    g(t) {
        return De(this.No, t.No) || De(this.ko, t.ko);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const Cs = /^__.*__$/;

/** The result of parsing document data (e.g. for a setData call). */ class Ds {
    constructor(t, e, s) {
        this.data = t, this.se = e, this.fieldTransforms = s;
    }
    Lo(t, e) {
        const s = [];
        return null !== this.se ? s.push(new Et(t, this.data, this.se, e)) : s.push(new mt(t, this.data, e)), 
        this.fieldTransforms.length > 0 && s.push(new Rt(t, this.fieldTransforms)), s;
    }
}

/** The result of parsing "update" data (i.e. for an updateData call). */ class Fs {
    constructor(t, e, s) {
        this.data = t, this.se = e, this.fieldTransforms = s;
    }
    Lo(t, e) {
        const s = [ new Et(t, this.data, this.se, e) ];
        return this.fieldTransforms.length > 0 && s.push(new Rt(t, this.fieldTransforms)), 
        s;
    }
}

function Ns(t) {
    switch (t) {
      case 0 /* Set */ :
 // fall through
              case 2 /* MergeSet */ :
 // fall through
              case 1 /* Update */ :
        return !0;

      case 3 /* Argument */ :
      case 4 /* ArrayArgument */ :
        return !1;

      default:
        throw ve(`Unexpected case for UserDataSource: ${t}`);
    }
}

/** A "context" object passed around while parsing user data. */ class ks {
    /**
     * Initializes a ParseContext with the given source and path.
     *
     * @param dataSource Indicates what kind of API method this data came from.
     * @param methodName The name of the method the user called to create this
     *     ParseContext.
     * @param path A path within the object being parsed. This could be an empty
     *     path (in which case the context represents the root of the data being
     *     parsed), or a nonempty path (indicating the context represents a nested
     *     location within the data).
     * @param arrayElement Whether or not this context corresponds to an element
     *     of an array.
     * @param fieldTransforms A mutable list of field transforms encountered while
     *     parsing the data.
     * @param fieldMask A mutable list of field paths encountered while parsing
     *     the data.
     *
     * TODO(b/34871131): We don't support array paths right now, so path can be
     * null to indicate the context represents any location within an array (in
     * which case certain features will not work and errors will be somewhat
     * compromised).
     */
    constructor(t, e, s, i, n, r) {
        this.$o = t, this.methodName = e, this.path = s, this.Oo = i, 
        // Minor hack: If fieldTransforms is undefined, we assume this is an
        // external call and we need to validate the entire path.
        void 0 === n && this.Mo(), this.Oo = void 0 !== i && i, this.fieldTransforms = n || [], 
        this.se = r || [];
    }
    Uo(t) {
        const e = null == this.path ? null : this.path.child(t), s = new ks(this.$o, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.se);
        return s.qo(t), s;
    }
    Bo(t) {
        const e = null == this.path ? null : this.path.child(t), s = new ks(this.$o, this.methodName, e, 
        /*arrayElement=*/ !1, this.fieldTransforms, this.se);
        return s.Mo(), s;
    }
    xo(t) {
        // TODO(b/34871131): We don't support array paths right now; so make path
        // null.
        return new ks(this.$o, this.methodName, 
        /*path=*/ null, 
        /*arrayElement=*/ !0, this.fieldTransforms, this.se);
    }
    Qo(t) {
        const e = null === this.path || this.path.q() ? "" : ` (found in field ${this.path.toString()})`;
        return new E(m.INVALID_ARGUMENT, `Function ${this.methodName}() called with invalid data. ` + t + e);
    }
    /** Returns 'true' if 'fieldPath' was traversed when creating this context. */    contains(t) {
        return void 0 !== this.se.find(e => t.B(e)) || void 0 !== this.fieldTransforms.find(e => t.B(e.field));
    }
    Mo() {
        // TODO(b/34871131): Remove null check once we have proper paths for fields
        // within arrays.
        if (null !== this.path) for (let t = 0; t < this.path.length; t++) this.qo(this.path.get(t));
    }
    qo(t) {
        if (0 === t.length) throw this.Qo("Document fields must not be empty");
        if (Ns(this.$o) && Cs.test(t)) throw this.Qo('Document fields cannot begin and end with "__"');
    }
}

/**
 * A placeholder object for DocumentReferences in this file, in order to
 * avoid a circular dependency. See the comments for `DataPreConverter` for
 * the full context.
 */ class Ls {
    constructor(t, e) {
        this.ci = t, this.key = e;
    }
}

/**
 * Helper for parsing raw user input (provided via the API) into internal model
 * classes.
 */ class $s {
    constructor(t, e) {
        this.serializer = t, this.Wo = e;
    }
    /** Parse document data from a non-merge set() call. */    jo(t, e) {
        const s = new ks(0 /* Set */ , t, S.H);
        Ms("Data must be an object, but it was:", s, e);
        const i = this.Go(e, s);
        return new Ds(new Pt(i), 
        /* fieldMask= */ null, s.fieldTransforms);
    }
    /** Parse document data from a set() call with '{merge:true}'. */    zo(t, e, s) {
        const i = new ks(2 /* MergeSet */ , t, S.H);
        Ms("Data must be an object, but it was:", i, e);
        const n = this.Go(e, i);
        let r, h;
        if (s) {
            let e = new k(S.k);
            for (const n of s) {
                let s;
                if (n instanceof Is) s = n.vo; else {
                    if ("string" != typeof n) throw ve("Expected stringOrFieldPath to be a string or a FieldPath");
                    s = qs(t, n);
                }
                if (!i.contains(s)) throw new E(m.INVALID_ARGUMENT, `Field '${s}' is specified in your field mask but missing from your input data.`);
                e = e.add(s);
            }
            r = _t.Gt(e), h = i.fieldTransforms.filter(t => r.Kt(t.field));
        } else r = _t.zt(i.se), h = i.fieldTransforms;
        return new Ds(new Pt(n), r, h);
    }
    /** Parse update data from an update() call. */    Ko(t, e) {
        const s = new ks(1 /* Update */ , t, S.H);
        Ms("Data must be an object, but it was:", s, e);
        let i = new k(S.k);
        const n = Pt.le();
        O(e, (e, r) => {
            const h = qs(t, e), o = s.Bo(h);
            if ((r = this.Ho(r, o)) instanceof Vs) 
            // Add it to the field mask, but don't add anything to updateData.
            i = i.add(h); else {
                const t = this.Jo(r, o);
                null != t && (i = i.add(h), n.set(h, t));
            }
        });
        const r = _t.Gt(i);
        return new Fs(n.he(), r, s.fieldTransforms);
    }
    /** Parse update data from a list of field/value arguments. */    Yo(t, e, s, i) {
        const n = new ks(1 /* Update */ , t, S.H), r = [ Us(t, e) ], h = [ s ];
        if (i.length % 2 != 0) throw new E(m.INVALID_ARGUMENT, `Function ${t}() needs to be called with an even number ` + "of arguments that alternate between field names and values.");
        for (let e = 0; e < i.length; e += 2) r.push(Us(t, i[e])), h.push(i[e + 1]);
        let o = new k(S.k);
        const a = Pt.le();
        for (let t = 0; t < r.length; ++t) {
            const e = r[t], s = n.Bo(e), i = this.Ho(h[t], s);
            if (i instanceof Vs) 
            // Add it to the field mask, but don't add anything to updateData.
            o = o.add(e); else {
                const t = this.Jo(i, s);
                null != t && (o = o.add(e), a.set(e, t));
            }
        }
        const u = _t.Gt(o);
        return new Fs(a.he(), u, n.fieldTransforms);
    }
    /**
     * Parse a "query value" (e.g. value in a where filter or a value in a cursor
     * bound).
     *
     * @param allowArrays Whether the query value is an array that may directly
     * contain additional arrays (e.g. the operand of an `in` query).
     */    Xo(t, e, s = !1) {
        const i = new ks(s ? 4 /* ArrayArgument */ : 3 /* Argument */ , t, S.H);
        return this.Jo(e, i);
    }
    /** Sends data through this.preConverter, handling any thrown errors. */    Ho(t, e) {
        try {
            return this.Wo(t);
        } catch (t) {
            const s = Bs(t);
            throw e.Qo(s);
        }
    }
    /**
     * Internal helper for parsing user data.
     *
     * @param input Data to be parsed.
     * @param context A context object representing the current path being parsed,
     * the source of the data being parsed, etc.
     * @return The parsed value, or null if the value was a FieldValue sentinel
     * that should not be included in the resulting parsed data.
     */    Jo(t, e) {
        if (Os(t = this.Ho(t, e))) return Ms("Unsupported field value:", e, t), this.Go(t, e);
        if (t instanceof Ps) 
        // FieldValues usually parse into transforms (except FieldValue.delete())
        // in which case we do not want to include this field in our parsed data
        // (as doing so will overwrite the field directly prior to the transform
        // trying to transform it). So we don't add this location to
        // context.fieldMask and we return null as our parsing result.
        return this.Zo(t, e), null;
        if (
        // If context.path is null we are inside an array and we don't support
        // field mask paths more granular than the top-level array.
        e.path && e.se.push(e.path), t instanceof Array) {
            // TODO(b/34871131): Include the path containing the array in the error
            // message.
            // In the case of IN queries, the parsed data is an array (representing
            // the set of values to be included for the IN query) that may directly
            // contain additional arrays (each representing an individual field
            // value), so we disable this validation.
            if (e.Oo && 4 /* ArrayArgument */ !== e.$o) throw e.Qo("Nested arrays are not supported");
            return this.ta(t, e);
        }
        return this.ea(t, e);
    }
    Go(t, e) {
        const s = {};
        return M(t) ? 
        // If we encounter an empty object, we explicitly add it to the update
        // mask to ensure that the server creates a map entry.
        e.path && e.path.length > 0 && e.se.push(e.path) : O(t, (t, i) => {
            const n = this.Jo(i, e.Uo(t));
            null != n && (s[t] = n);
        }), {
            mapValue: {
                fields: s
            }
        };
    }
    ta(t, e) {
        const s = [];
        let i = 0;
        for (const n of t) {
            let t = this.Jo(n, e.xo(i));
            null == t && (
            // Just include nulls in the array for fields being replaced with a
            // sentinel.
            t = {
                nullValue: "NULL_VALUE"
            }), s.push(t), i++;
        }
        return {
            arrayValue: {
                values: s
            }
        };
    }
    /**
     * "Parses" the provided FieldValueImpl, adding any necessary transforms to
     * context.fieldTransforms.
     */    Zo(t, e) {
        // Sentinels are only supported with writes, and not within arrays.
        if (!Ns(e.$o)) throw e.Qo(`${t.Co}() can only be used with update() and set()`);
        if (null === e.path) throw e.Qo(`${t.Co}() is not currently supported inside arrays`);
        if (t instanceof Vs) {
            if (2 /* MergeSet */ !== e.$o) throw 1 /* Update */ === e.$o ? e.Qo("FieldValue.delete() can only appear at the top level of your update data") : e.Qo("FieldValue.delete() cannot be used with set() unless you pass {merge:true}");
            // No transform to add for a delete, but we need to add it to our
            // fieldMask so it gets deleted.
            e.se.push(e.path);
        } else if (t instanceof ps) e.fieldTransforms.push(new dt(e.path, ot.instance)); else if (t instanceof gs) {
            const s = this.sa(t.Co, t.Do), i = new at(s);
            e.fieldTransforms.push(new dt(e.path, i));
        } else if (t instanceof ys) {
            const s = this.sa(t.Co, t.Do), i = new ut(s);
            e.fieldTransforms.push(new dt(e.path, i));
        } else if (t instanceof bs) {
            const s = this.Xo("FieldValue.increment", t.Fo), i = new ct(this.serializer, s);
            e.fieldTransforms.push(new dt(e.path, i));
        } else ve("Unknown FieldValue type: " + t);
    }
    /**
     * Helper to parse a scalar value (i.e. not an Object, Array, or FieldValue)
     *
     * @return The parsed value
     */    ea(t, e) {
        if (null === t) return {
            nullValue: "NULL_VALUE"
        };
        if ("number" == typeof t) return this.serializer.wi(t);
        if ("boolean" == typeof t) return {
            booleanValue: t
        };
        if ("string" == typeof t) return {
            stringValue: t
        };
        if (t instanceof Date) {
            const e = p.fromDate(t);
            return {
                timestampValue: this.serializer.F(e)
            };
        }
        if (t instanceof p) {
            // Firestore backend truncates precision down to microseconds. To ensure
            // offline mode works the same with regards to truncation, perform the
            // truncation immediately without waiting for the backend to do that.
            const e = new p(t.seconds, 1e3 * Math.floor(t.nanoseconds / 1e3));
            return {
                timestampValue: this.serializer.F(e)
            };
        }
        if (t instanceof Ss) return {
            geoPointValue: {
                latitude: t.latitude,
                longitude: t.longitude
            }
        };
        if (t instanceof Es) return {
            bytesValue: this.serializer.Ti(t)
        };
        if (t instanceof Ls) return {
            referenceValue: this.serializer.Ei(t.key.path, t.ci)
        };
        throw e.Qo(`Unsupported field value: ${as(t)}`);
    }
    sa(t, e) {
        return e.map((e, s) => {
            // Although array transforms are used with writes, the actual elements
            // being unioned or removed are not considered writes since they cannot
            // contain any FieldValue sentinels, etc.
            const i = new ks(3 /* Argument */ , t, S.H);
            return this.Jo(e, i.xo(s));
        });
    }
}

/**
 * Checks whether an object looks like a JSON object that should be converted
 * into a struct. Normal class/prototype instances are considered to look like
 * JSON objects since they should be converted to a struct value. Arrays, Dates,
 * GeoPoints, etc. are not considered to look like JSON objects since they map
 * to specific FieldValue types other than ObjectValue.
 */ function Os(t) {
    return !("object" != typeof t || null === t || t instanceof Array || t instanceof Date || t instanceof p || t instanceof Ss || t instanceof Es || t instanceof Ls || t instanceof Ps);
}

function Ms(t, e, s) {
    if (!Os(s) || !os(s)) {
        const i = as(s);
        throw "an object" === i ? e.Qo(t + " a custom object") : e.Qo(t + " " + i);
    }
}

/**
 * Helper that calls fromDotSeparatedString() but wraps any error thrown.
 */ function Us(t, e) {
    if (e instanceof Is) return e.vo;
    if ("string" == typeof e) return qs(t, e);
    throw new E(m.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${"Field path arguments must be of type string or FieldPath."}`);
}

/**
 * Wraps fromDotSeparatedString with an error message about the method that
 * was thrown.
 * @param methodName The publicly visible method name
 * @param path The dot-separated string form of a field path which will be split
 * on dots.
 */ function qs(t, e) {
    try {
        return function(t) {
            if (t.search(As) >= 0) throw new E(m.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not contain ` + "'~', '*', '/', '[', or ']'");
            try {
                return new Is(...t.split("."));
            } catch (e) {
                throw new E(m.INVALID_ARGUMENT, `Invalid field path (${t}). Paths must not be empty, ` + "begin with '.', end with '.', or contain '..'");
            }
        }(e).vo;
    } catch (e) {
        const s = Bs(e);
        throw new E(m.INVALID_ARGUMENT, `Function ${t}() called with invalid data. ${s}`);
    }
}

/**
 * Extracts the message from a caught exception, which should be an Error object
 * though JS doesn't guarantee that.
 */ function Bs(t) {
    return t instanceof Error ? t.message : t.toString();
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A helper for running delayed tasks following an exponential backoff curve
 * between attempts.
 *
 * Each delay is made up of a "base" delay which follows the exponential
 * backoff curve, and a +/- 50% "jitter" that is calculated and added to the
 * base delay. This prevents clients from accidentally synchronizing their
 * delays causing spikes of load to the backend.
 */
class xs {
    constructor(
    /**
     * The AsyncQueue to run backoff operations on.
     */
    t, 
    /**
     * The ID to use when scheduling backoff operations on the AsyncQueue.
     */
    e, 
    /**
     * The initial delay (used as the base delay on the first retry attempt).
     * Note that jitter will still be applied, so the actual delay could be as
     * little as 0.5*initialDelayMs.
     */
    s = 1e3
    /**
     * The multiplier to use to determine the extended base delay after each
     * attempt.
     */ , i = 1.5
    /**
     * The maximum base delay after which no further backoff is performed.
     * Note that jitter will still be applied, so the actual delay could be as
     * much as 1.5*maxDelayMs.
     */ , n = 6e4) {
        this.ia = t, this.Pr = e, this.na = s, this.ra = i, this.ha = n, this.oa = 0, this.aa = null, 
        /** The last backoff attempt, as epoch milliseconds. */
        this.ua = Date.now(), this.reset();
    }
    /**
     * Resets the backoff delay.
     *
     * The very next backoffAndWait() will have no delay. If it is called again
     * (i.e. due to an error), initialDelayMs (plus jitter) will be used, and
     * subsequent ones will increase according to the backoffFactor.
     */    reset() {
        this.oa = 0;
    }
    /**
     * Resets the backoff delay to the maximum delay (e.g. for use after a
     * RESOURCE_EXHAUSTED error).
     */    ca() {
        this.oa = this.ha;
    }
    /**
     * Returns a promise that resolves after currentDelayMs, and increases the
     * delay for any subsequent attempts. If there was a pending backoff operation
     * already, it will be canceled.
     */    la(t) {
        // Cancel any pending backoff operation.
        this.cancel();
        // First schedule using the current base (which may be 0 and should be
        // honored as such).
        const e = Math.floor(this.oa + this._a()), s = Math.max(0, Date.now() - this.ua), i = Math.max(0, e - s);
        // Guard against lastAttemptTime being in the future due to a clock change.
                this.oa > 0 && ge("ExponentialBackoff", `Backing off for ${i} ms ` + `(base delay: ${this.oa} ms, ` + `delay with jitter: ${e} ms, ` + `last attempt: ${s} ms ago)`), 
        this.aa = this.ia.Qr(this.Pr, i, () => (this.ua = Date.now(), t())), 
        // Apply backoff factor to determine next delay and ensure it is within
        // bounds.
        this.oa *= this.ra, this.oa < this.na && (this.oa = this.na), this.oa > this.ha && (this.oa = this.ha);
    }
    cancel() {
        null !== this.aa && (this.aa.cancel(), this.aa = null);
    }
    /** Returns a random value in the range [-currentBaseMs/2, currentBaseMs/2] */    _a() {
        return (Math.random() - .5) * this.oa;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A PersistentStream is an abstract base class that represents a streaming RPC
 * to the Firestore backend. It's built on top of the connections own support
 * for streaming RPCs, and adds several critical features for our clients:
 *
 *   - Exponential backoff on failure
 *   - Authentication via CredentialsProvider
 *   - Dispatching all callbacks into the shared worker queue
 *   - Closing idle streams after 60 seconds of inactivity
 *
 * Subclasses of PersistentStream implement serialization of models to and
 * from the JSON representation of the protocol buffers for a specific
 * streaming RPC.
 *
 * ## Starting and Stopping
 *
 * Streaming RPCs are stateful and need to be start()ed before messages can
 * be sent and received. The PersistentStream will call the onOpen() function
 * of the listener once the stream is ready to accept requests.
 *
 * Should a start() fail, PersistentStream will call the registered onClose()
 * listener with a FirestoreError indicating what went wrong.
 *
 * A PersistentStream can be started and stopped repeatedly.
 *
 * Generic types:
 *  SendType: The type of the outgoing message of the underlying
 *    connection stream
 *  ReceiveType: The type of the incoming message of the underlying
 *    connection stream
 *  ListenerType: The type of the listener that will be used for callbacks
 */
class Qs {
    constructor(t, e, s, i, n, r) {
        this.ia = t, this.da = s, this.fa = i, this.wa = n, this.listener = r, this.state = 0 /* Initial */ , 
        /**
         * A close count that's incremented every time the stream is closed; used by
         * getCloseGuardedDispatcher() to invalidate callbacks that happen after
         * close.
         */
        this.Ta = 0, this.ma = null, this.stream = null, this.Ea = new xs(t, e);
    }
    /**
     * Returns true if start() has been called and no error has occurred. True
     * indicates the stream is open or in the process of opening (which
     * encompasses respecting backoff, getting auth tokens, and starting the
     * actual RPC). Use isOpen() to determine if the stream is open and ready for
     * outbound requests.
     */    Ra() {
        return 1 /* Starting */ === this.state || 2 /* Open */ === this.state || 4 /* Backoff */ === this.state;
    }
    /**
     * Returns true if the underlying RPC is open (the onOpen() listener has been
     * called) and the stream is ready for outbound requests.
     */    Ia() {
        return 2 /* Open */ === this.state;
    }
    /**
     * Starts the RPC. Only allowed if isStarted() returns false. The stream is
     * not immediately ready for use: onOpen() will be invoked when the RPC is
     * ready for outbound requests, at which point isOpen() will return true.
     *
     * When start returns, isStarted() will return true.
     */    start() {
        3 /* Error */ !== this.state ? this.auth() : this.Aa();
    }
    /**
     * Stops the RPC. This call is idempotent and allowed regardless of the
     * current isStarted() state.
     *
     * When stop returns, isStarted() and isOpen() will both return false.
     */    async stop() {
        this.Ra() && await this.close(0 /* Initial */);
    }
    /**
     * After an error the stream will usually back off on the next attempt to
     * start it. If the error warrants an immediate restart of the stream, the
     * sender can use this to indicate that the receiver should not back off.
     *
     * Each error will call the onClose() listener. That function can decide to
     * inhibit backoff if required.
     */    Pa() {
        this.state = 0 /* Initial */ , this.Ea.reset();
    }
    /**
     * Marks this stream as idle. If no further actions are performed on the
     * stream for one minute, the stream will automatically close itself and
     * notify the stream's onClose() handler with Status.OK. The stream will then
     * be in a !isStarted() state, requiring the caller to start the stream again
     * before further use.
     *
     * Only streams that are in state 'Open' can be marked idle, as all other
     * states imply pending network operations.
     */    Va() {
        // Starts the idle time if we are in state 'Open' and are not yet already
        // running a timer (in which case the previous idle timeout still applies).
        this.Ia() && null === this.ma && (this.ma = this.ia.Qr(this.da, 6e4, () => this.pa()));
    }
    /** Sends a message to the underlying stream. */    ga(t) {
        this.ya(), this.stream.send(t);
    }
    /** Called by the idle timer when the stream should close due to inactivity. */    async pa() {
        if (this.Ia()) 
        // When timing out an idle stream there's no reason to force the stream into backoff when
        // it restarts so set the stream state to Initial instead of Error.
        return this.close(0 /* Initial */);
    }
    /** Marks the stream as active again. */    ya() {
        this.ma && (this.ma.cancel(), this.ma = null);
    }
    /**
     * Closes the stream and cleans up as necessary:
     *
     * * closes the underlying GRPC stream;
     * * calls the onClose handler with the given 'error';
     * * sets internal stream state to 'finalState';
     * * adjusts the backoff timer based on the error
     *
     * A new stream can be opened by calling start().
     *
     * @param finalState the intended state of the stream after closing.
     * @param error the error the connection was closed with.
     */    async close(t, e) {
        // Cancel any outstanding timers (they're guaranteed not to execute).
        this.ya(), this.Ea.cancel(), 
        // Invalidates any stream-related callbacks (e.g. from auth or the
        // underlying stream), guaranteeing they won't execute.
        this.Ta++, 3 /* Error */ !== t ? 
        // If this is an intentional close ensure we don't delay our next connection attempt.
        this.Ea.reset() : e && e.code === m.RESOURCE_EXHAUSTED ? (
        // Log the error. (Probably either 'quota exceeded' or 'max queue length reached'.)
        ye(e.toString()), ye("Using maximum backoff delay to prevent overloading the backend."), 
        this.Ea.ca()) : e && e.code === m.UNAUTHENTICATED && 
        // "unauthenticated" error means the token was rejected. Try force refreshing it in case it
        // just expired.
        this.wa.l(), 
        // Clean up the underlying stream because we are no longer interested in events.
        null !== this.stream && (this.ba(), this.stream.close(), this.stream = null), 
        // This state must be assigned before calling onClose() to allow the callback to
        // inhibit backoff or otherwise manipulate the state in its non-started state.
        this.state = t, 
        // Notify the listener that the stream closed.
        await this.listener.va(e);
    }
    /**
     * Can be overridden to perform additional cleanup before the stream is closed.
     * Calling super.tearDown() is not required.
     */    ba() {}
    auth() {
        this.state = 1 /* Starting */;
        const t = this.Sa(this.Ta), e = this.Ta;
        // TODO(mikelehen): Just use dispatchIfNotClosed, but see TODO below.
                this.wa.getToken().then(t => {
            // Stream can be stopped while waiting for authentication.
            // TODO(mikelehen): We really should just use dispatchIfNotClosed
            // and let this dispatch onto the queue, but that opened a spec test can
            // of worms that I don't want to deal with in this PR.
            this.Ta === e && 
            // Normally we'd have to schedule the callback on the AsyncQueue.
            // However, the following calls are safe to be called outside the
            // AsyncQueue since they don't chain asynchronous calls
            this.Ca(t);
        }, e => {
            t(() => {
                const t = new E(m.UNKNOWN, "Fetching auth token failed: " + e.message);
                return this.Da(t);
            });
        });
    }
    Ca(t) {
        const e = this.Sa(this.Ta);
        this.stream = this.Fa(t), this.stream.Na(() => {
            e(() => (this.state = 2 /* Open */ , this.listener.Na()));
        }), this.stream.va(t => {
            e(() => this.Da(t));
        }), this.stream.onMessage(t => {
            e(() => this.onMessage(t));
        });
    }
    Aa() {
        this.state = 4 /* Backoff */ , this.Ea.la(async () => {
            this.state = 0 /* Initial */ , this.start();
        });
    }
    // Visible for tests
    Da(t) {
        // In theory the stream could close cleanly, however, in our current model
        // we never expect this to happen because if we stop a stream ourselves,
        // this callback will never be called. To prevent cases where we retry
        // without a backoff accidentally, we set the stream to error in all cases.
        return ge("PersistentStream", `close with error: ${t}`), this.stream = null, this.close(3 /* Error */ , t);
    }
    /**
     * Returns a "dispatcher" function that dispatches operations onto the
     * AsyncQueue but only runs them if closeCount remains unchanged. This allows
     * us to turn auth / stream callbacks into no-ops if the stream is closed /
     * re-opened, etc.
     */    Sa(t) {
        return e => {
            this.ia.Cr(() => this.Ta === t ? e() : (ge("PersistentStream", "stream callback skipped by getCloseGuardedDispatcher."), 
            Promise.resolve()));
        };
    }
}

/**
 * A PersistentStream that implements the Listen RPC.
 *
 * Once the Listen stream has called the onOpen() listener, any number of
 * listen() and unlisten() calls can be made to control what changes will be
 * sent from the server for ListenResponses.
 */ class Ws extends Qs {
    constructor(t, e, s, i, n) {
        super(t, "listen_stream_connection_backoff" /* ListenStreamConnectionBackoff */ , "listen_stream_idle" /* ListenStreamIdle */ , e, s, n), 
        this.serializer = i;
    }
    Fa(t) {
        return this.fa.ka("Listen", t);
    }
    onMessage(t) {
        // A successful response means the stream is healthy
        this.Ea.reset();
        const e = this.serializer.Fi(t), s = this.serializer.ki(t);
        return this.listener.La(e, s);
    }
    /**
     * Registers interest in the results of the given target. If the target
     * includes a resumeToken it will be included in the request. Results that
     * affect the target will be streamed back as WatchChange messages that
     * reference the targetId.
     */    $a(t) {
        const e = {};
        e.database = this.serializer.gi, e.addTarget = this.serializer.Ue(t);
        const s = this.serializer.en(t);
        s && (e.labels = s), this.ga(e);
    }
    /**
     * Unregisters interest in the results of the target associated with the
     * given targetId.
     */    Oa(t) {
        const e = {};
        e.database = this.serializer.gi, e.removeTarget = t, this.ga(e);
    }
}

/**
 * A Stream that implements the Write RPC.
 *
 * The Write RPC requires the caller to maintain special streamToken
 * state in between calls, to help the server understand which responses the
 * client has processed by the time the next request is made. Every response
 * will contain a streamToken; this value must be passed to the next
 * request.
 *
 * After calling start() on this stream, the next request must be a handshake,
 * containing whatever streamToken is on hand. Once a response to this
 * request is received, all pending mutations may be submitted. When
 * submitting multiple batches of mutations at the same time, it's
 * okay to use the same streamToken for the calls to writeMutations.
 *
 * TODO(b/33271235): Use proto types
 */ class js extends Qs {
    constructor(t, e, s, i, n) {
        super(t, "write_stream_connection_backoff" /* WriteStreamConnectionBackoff */ , "write_stream_idle" /* WriteStreamIdle */ , e, s, n), 
        this.serializer = i, this.Ma = !1, 
        /**
         * The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         *
         * PersistentWriteStream manages propagating this value from responses to the
         * next request.
         */
        this.lastStreamToken = U.Ut;
    }
    /**
     * Tracks whether or not a handshake has been successfully exchanged and
     * the stream is ready to accept mutations.
     */    get Ua() {
        return this.Ma;
    }
    // Override of PersistentStream.start
    start() {
        this.Ma = !1, super.start();
    }
    ba() {
        this.Ma && this.qa([]);
    }
    Fa(t) {
        return this.fa.ka("Write", t);
    }
    onMessage(t) {
        if (
        // Always capture the last stream token.
        Se(!!t.streamToken, "Got a write response without a stream token"), this.lastStreamToken = this.serializer.mi(t.streamToken), 
        this.Ma) {
            // A successful first write response means the stream is healthy,
            // Note, that we could consider a successful handshake healthy, however,
            // the write itself might be causing an error we want to back off from.
            this.Ea.reset();
            const e = this.serializer.Wi(t.writeResults, t.commitTime), s = this.serializer.fromVersion(t.commitTime);
            return this.listener.Ba(s, e);
        }
        // The first response is always the handshake response
        return Se(!t.writeResults || 0 === t.writeResults.length, "Got mutation results for handshake"), 
        this.Ma = !0, this.listener.xa();
    }
    /**
     * Sends an initial streamToken to the server, performing the handshake
     * required to make the StreamingWrite RPC work. Subsequent
     * calls should wait until onHandshakeComplete was called.
     */    Qa() {
        // TODO(dimond): Support stream resumption. We intentionally do not set the
        // stream token on the handshake, ignoring any stream token we might have.
        const t = {};
        t.database = this.serializer.gi, this.ga(t);
    }
    /** Sends a group of mutations to the Firestore backend to apply. */    qa(t) {
        const e = {
            streamToken: this.serializer.Ti(this.lastStreamToken),
            writes: t.map(t => this.serializer.Li(t))
        };
        this.ga(e);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Datastore is a wrapper around the external Google Cloud Datastore grpc API,
 * which provides an interface that is more convenient for the rest of the
 * client SDK architecture to consume.
 */ class Gs {
    constructor(t, e, s, i) {
        this.ia = t, this.fa = e, this.credentials = s, this.serializer = i;
    }
    Wa(t) {
        return new js(this.ia, this.fa, this.credentials, this.serializer, t);
    }
    ja(t) {
        return new Ws(this.ia, this.fa, this.credentials, this.serializer, t);
    }
    commit(t) {
        const e = {
            database: this.serializer.gi,
            writes: t.map(t => this.serializer.Li(t))
        };
        return this.Ga("Commit", e).then(t => this.serializer.Wi(t.writeResults, t.commitTime));
    }
    za(t) {
        const e = {
            database: this.serializer.gi,
            documents: t.map(t => this.serializer.Ai(t))
        };
        return this.Ka("BatchGetDocuments", e).then(e => {
            let s = Ht();
            e.forEach(t => {
                const e = this.serializer.Di(t);
                s = s.nt(e.key, e);
            });
            const i = [];
            return t.forEach(t => {
                const e = s.get(t);
                Se(!!e, "Missing entity in write response for " + t), i.push(e);
            }), i;
        });
    }
    /** Gets an auth token and invokes the provided RPC. */    Ga(t, e) {
        return this.credentials.getToken().then(s => this.fa.Ga(t, e, s)).catch(t => {
            throw t.code === m.UNAUTHENTICATED && this.credentials.l(), t;
        });
    }
    /** Gets an auth token and invokes the provided RPC with streamed results. */    Ka(t, e) {
        return this.credentials.getToken().then(s => this.fa.Ka(t, e, s)).catch(t => {
            throw t.code === m.UNAUTHENTICATED && this.credentials.l(), t;
        });
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Internal transaction object responsible for accumulating the mutations to
 * perform and the base versions for any documents read.
 */ class zs {
    constructor(t) {
        this.Ha = t, 
        // The version of each document that was read during this transaction.
        this.Ja = te(), this.mutations = [], this.Ya = !1, 
        /**
         * A deferred usage error that occurred previously in this transaction that
         * will cause the transaction to fail once it actually commits.
         */
        this.Xa = null, 
        /**
         * Set of documents that have been written in the transaction.
         *
         * When there's more than one write to the same key in a transaction, any
         * writes after the first are handled differently.
         */
        this.Za = new Set;
    }
    async za(t) {
        if (this.tu(), this.mutations.length > 0) throw new E(m.INVALID_ARGUMENT, "Firestore transactions require all reads to be executed before all writes.");
        const e = await this.Ha.za(t);
        return e.forEach(t => {
            t instanceof yt || t instanceof gt ? this.eu(t) : ve("Document in a transaction was a " + t.constructor.name);
        }), e;
    }
    set(t, e) {
        this.write(e.Lo(t, this.Zt(t))), this.Za.add(t);
    }
    update(t, e) {
        try {
            this.write(e.Lo(t, this.su(t)));
        } catch (t) {
            this.Xa = t;
        }
        this.Za.add(t);
    }
    delete(t) {
        this.write([ new It(t, this.Zt(t)) ]), this.Za.add(t);
    }
    async commit() {
        if (this.tu(), this.Xa) throw this.Xa;
        let t = this.Ja;
        // For each mutation, note that the doc was written.
                this.mutations.forEach(e => {
            t = t.remove(e.key);
        }), 
        // For each document that was read but not written to, we want to perform
        // a `verify` operation.
        t.forEach((t, e) => {
            this.mutations.push(new At(t, this.Zt(t)));
        }), await this.Ha.commit(this.mutations), this.Ya = !0;
    }
    eu(t) {
        let e;
        if (t instanceof gt) e = t.version; else {
            if (!(t instanceof yt)) throw ve("Document in a transaction was a " + t.constructor.name);
            // For deleted docs, we must use baseVersion 0 when we overwrite them.
            e = g.S();
        }
        const s = this.Ja.get(t.key);
        if (null !== s) {
            if (!e.isEqual(s)) 
            // This transaction will fail no matter what.
            throw new E(m.ABORTED, "Document version changed between two reads.");
        } else this.Ja = this.Ja.nt(t.key, e);
    }
    /**
     * Returns the version of this document when it was read in this transaction,
     * as a precondition, or no precondition if it was not read.
     */    Zt(t) {
        const e = this.Ja.get(t);
        return !this.Za.has(t) && e ? wt.updateTime(e) : wt.NONE;
    }
    /**
     * Returns the precondition for a document if the operation is an update.
     */    su(t) {
        const e = this.Ja.get(t);
        // The first time a document is written, we want to take into account the
        // read time and existence
                if (!this.Za.has(t) && e) {
            if (e.isEqual(g.S())) 
            // The document doesn't exist, so fail the transaction.
            // This has to be validated locally because you can't send a
            // precondition that a document does not exist without changing the
            // semantics of the backend write to be an insert. This is the reverse
            // of what we want, since we want to assert that the document doesn't
            // exist but then send the update and have it fail. Since we can't
            // express that to the backend, we have to validate locally.
            // Note: this can change once we can send separate verify writes in the
            // transaction.
            throw new E(m.INVALID_ARGUMENT, "Can't update a document that doesn't exist.");
            // Document exists, base precondition on document update time.
                        return wt.updateTime(e);
        }
        // Document was not read, so we just use the preconditions for a blind
        // update.
        return wt.exists(!0);
    }
    write(t) {
        this.tu(), this.mutations = this.mutations.concat(t);
    }
    tu() {}
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A component used by the RemoteStore to track the OnlineState (that is,
 * whether or not the client as a whole should be considered to be online or
 * offline), implementing the appropriate heuristics.
 *
 * In particular, when the client is trying to connect to the backend, we
 * allow up to MAX_WATCH_STREAM_FAILURES within ONLINE_STATE_TIMEOUT_MS for
 * a connection to succeed. If we have too many failures or the timeout elapses,
 * then we set the OnlineState to Offline, and the client will behave as if
 * it is offline (get()s will return cached data, etc.).
 */
class Ks {
    constructor(t, e) {
        this.Ar = t, this.iu = e, 
        /** The current OnlineState. */
        this.state = "Unknown" /* Unknown */ , 
        /**
         * A count of consecutive failures to open the stream. If it reaches the
         * maximum defined by MAX_WATCH_STREAM_FAILURES, we'll set the OnlineState to
         * Offline.
         */
        this.nu = 0, 
        /**
         * A timer that elapses after ONLINE_STATE_TIMEOUT_MS, at which point we
         * transition from OnlineState.Unknown to OnlineState.Offline without waiting
         * for the stream to actually fail (MAX_WATCH_STREAM_FAILURES times).
         */
        this.ru = null, 
        /**
         * Whether the client should log a warning message if it fails to connect to
         * the backend (initially true, cleared after a successful stream, or if we've
         * logged the message already).
         */
        this.hu = !0;
    }
    /**
     * Called by RemoteStore when a watch stream is started (including on each
     * backoff attempt).
     *
     * If this is the first attempt, it sets the OnlineState to Unknown and starts
     * the onlineStateTimer.
     */    ou() {
        0 === this.nu && (this.au("Unknown" /* Unknown */), this.ru = this.Ar.Qr("online_state_timeout" /* OnlineStateTimeout */ , 1e4, () => (this.ru = null, 
        this.uu("Backend didn't respond within 10 seconds."), this.au("Offline" /* Offline */), 
        Promise.resolve())));
    }
    /**
     * Updates our OnlineState as appropriate after the watch stream reports a
     * failure. The first failure moves us to the 'Unknown' state. We then may
     * allow multiple failures (based on MAX_WATCH_STREAM_FAILURES) before we
     * actually transition to the 'Offline' state.
     */    cu(t) {
        "Online" /* Online */ === this.state ? this.au("Unknown" /* Unknown */) : (this.nu++, 
        this.nu >= 1 && (this.lu(), this.uu("Connection failed 1 " + `times. Most recent error: ${t.toString()}`), 
        this.au("Offline" /* Offline */)));
    }
    /**
     * Explicitly sets the OnlineState to the specified state.
     *
     * Note that this resets our timers / failure counters, etc. used by our
     * Offline heuristics, so must not be used in place of
     * handleWatchStreamStart() and handleWatchStreamFailure().
     */    set(t) {
        this.lu(), this.nu = 0, "Online" /* Online */ === t && (
        // We've connected to watch at least once. Don't warn the developer
        // about being offline going forward.
        this.hu = !1), this.au(t);
    }
    au(t) {
        t !== this.state && (this.state = t, this.iu(t));
    }
    uu(t) {
        const e = `Could not reach Cloud Firestore backend. ${t}\n` + "This typically indicates that your device does not have a healthy Internet connection at the moment. The client will operate in offline mode until it is able to successfully connect to the backend.";
        this.hu ? (ye(e), this.hu = !1) : ge("OnlineStateTracker", e);
    }
    lu() {
        null !== this.ru && (this.ru.cancel(), this.ru = null);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * RemoteStore - An interface to remotely stored data, basically providing a
 * wrapper around the Datastore that is more reliable for the rest of the
 * system.
 *
 * RemoteStore is responsible for maintaining the connection to the server.
 * - maintaining a list of active listens.
 * - reconnecting when the connection is dropped.
 * - resuming all the active listens on reconnect.
 *
 * RemoteStore handles all incoming events from the Datastore.
 * - listening to the watch stream and repackaging the events as RemoteEvents
 * - notifying SyncEngine of any changes to the active listens.
 *
 * RemoteStore takes writes from other components and handles them reliably.
 * - pulling pending mutations from LocalStore and sending them to Datastore.
 * - retrying mutations that failed because of network problems.
 * - acking mutations to the SyncEngine once they are accepted or rejected.
 */
class Hs {
    constructor(
    /**
     * The local store, used to fill the write pipeline with outbound mutations.
     */
    t, 
    /** The client-side proxy for interacting with the backend. */
    e, s, i, n) {
        this._u = t, this.Ha = e, 
        /**
         * A list of up to MAX_PENDING_WRITES writes that we have fetched from the
         * LocalStore via fillWritePipeline() and have or will send to the write
         * stream.
         *
         * Whenever writePipeline.length > 0 the RemoteStore will attempt to start or
         * restart the write stream. When the stream is established the writes in the
         * pipeline will be sent in order.
         *
         * Writes remain in writePipeline until they are acknowledged by the backend
         * and thus will automatically be re-sent if the stream is interrupted /
         * restarted before they're acknowledged.
         *
         * Write responses from the backend are linked to their originating request
         * purely based on order, and so we can just shift() writes from the front of
         * the writePipeline as we receive responses.
         */
        this.du = [], 
        /**
         * A mapping of watched targets that the client cares about tracking and the
         * user has explicitly called a 'listen' for this target.
         *
         * These targets may or may not have been sent to or acknowledged by the
         * server. On re-establishing the listen stream, these targets should be sent
         * to the server. The targets removed with unlistens are removed eagerly
         * without waiting for confirmation from the listen stream.
         */
        this.fu = new Map, this.wu = null, 
        /**
         * Set to true by enableNetwork() and false by disableNetwork() and indicates
         * the user-preferred network state.
         */
        this.networkEnabled = !1, this.isPrimary = !1, this.Tu = n, this.Tu.mu(t => {
            s.Cr(async () => {
                this.Eu() && (ge("RemoteStore", "Restarting streams for network reachability change."), 
                await this.Ru());
            });
        }), this.Iu = new Ks(s, i), 
        // Create streams (but note they're not started yet).
        this.Au = this.Ha.ja({
            Na: this.Pu.bind(this),
            va: this.Vu.bind(this),
            La: this.pu.bind(this)
        }), this.gu = this.Ha.Wa({
            Na: this.yu.bind(this),
            va: this.bu.bind(this),
            xa: this.vu.bind(this),
            Ba: this.Ba.bind(this)
        });
    }
    /**
     * Starts up the remote store, creating streams, restoring state from
     * LocalStore, etc.
     */    start() {
        return this.enableNetwork();
    }
    /** Re-enables the network. Idempotent. */    async enableNetwork() {
        this.networkEnabled = !0, this.Eu() && (this.gu.lastStreamToken = await this._u.xh(), 
        this.Su() ? this.Cu() : this.Iu.set("Unknown" /* Unknown */), 
        // This will start the write stream if necessary.
        await this.Du());
    }
    /**
     * Temporarily disables the network. The network can be re-enabled using
     * enableNetwork().
     */    async disableNetwork() {
        this.networkEnabled = !1, await this.Fu(), 
        // Set the OnlineState to Offline so get()s return from cache, etc.
        this.Iu.set("Offline" /* Offline */);
    }
    async Fu() {
        await this.gu.stop(), await this.Au.stop(), this.du.length > 0 && (ge("RemoteStore", `Stopping write stream with ${this.du.length} pending writes`), 
        this.du = []), this.Nu();
    }
    async ku() {
        ge("RemoteStore", "RemoteStore shutting down."), this.networkEnabled = !1, await this.Fu(), 
        this.Tu.ku(), 
        // Set the OnlineState to Unknown (rather than Offline) to avoid potentially
        // triggering spurious listener events with cached data, etc.
        this.Iu.set("Unknown" /* Unknown */);
    }
    /**
     * Starts new listen for the given target. Uses resume token if provided. It
     * is a no-op if the target of given `TargetData` is already being listened to.
     */    listen(t) {
        this.fu.has(t.targetId) || (
        // Mark this as something the client is currently listening for.
        this.fu.set(t.targetId, t), this.Su() ? 
        // The listen will be sent in onWatchStreamOpen
        this.Cu() : this.Au.Ia() && this.Lu(t));
    }
    /**
     * Removes the listen from server. It is a no-op if the given target id is
     * not being listened to.
     */    $u(t) {
        this.fu.delete(t), this.Au.Ia() && this.Ou(t), 0 === this.fu.size && (this.Au.Ia() ? this.Au.Va() : this.Eu() && 
        // Revert to OnlineState.Unknown if the watch stream is not open and we
        // have no listeners, since without any listens to send we cannot
        // confirm if the stream is healthy and upgrade to OnlineState.Online.
        this.Iu.set("Unknown" /* Unknown */));
    }
    /** {@link TargetMetadataProvider.getTargetDataForTarget} */    ui(t) {
        return this.fu.get(t) || null;
    }
    /** {@link TargetMetadataProvider.getRemoteKeysForTarget} */    ai(t) {
        return this.Mu.ai(t);
    }
    /**
     * We need to increment the the expected number of pending responses we're due
     * from watch so we wait for the ack to process any messages from this target.
     */    Lu(t) {
        this.wu.qs(t.targetId), this.Au.$a(t);
    }
    /**
     * We need to increment the expected number of pending responses we're due
     * from watch so we wait for the removal on the server before we process any
     * messages from this target.
     */    Ou(t) {
        this.wu.qs(t), this.Au.Oa(t);
    }
    Cu() {
        this.wu = new fe(this), this.Au.start(), this.Iu.ou();
    }
    /**
     * Returns whether the watch stream should be started because it's necessary
     * and has not yet been started.
     */    Su() {
        return this.Eu() && !this.Au.Ra() && this.fu.size > 0;
    }
    Eu() {
        return this.isPrimary && this.networkEnabled;
    }
    Nu() {
        this.wu = null;
    }
    async Pu() {
        this.fu.forEach((t, e) => {
            this.Lu(t);
        });
    }
    async Vu(t) {
        this.Nu(), 
        // If we still need the watch stream, retry the connection.
        this.Su() ? (this.Iu.cu(t), this.Cu()) : 
        // No need to restart watch stream because there are no active targets.
        // The online state is set to unknown because there is no active attempt
        // at establishing a connection
        this.Iu.set("Unknown" /* Unknown */);
    }
    async pu(t, e) {
        if (
        // Mark the client as online since we got a message from the server
        this.Iu.set("Online" /* Online */), t instanceof _e && 2 /* Removed */ === t.state && t.cause) 
        // There was an error on a target, don't wait for a consistent snapshot
        // to raise events
        return this.Uu(t);
        if (t instanceof ce ? this.wu.Ks(t) : t instanceof le ? this.wu.si(t) : this.wu.Ys(t), 
        !e.isEqual(g.MIN)) {
            const t = await this._u.Wh();
            e.C(t) >= 0 && 
            // We have received a target change with a global snapshot if the snapshot
            // version is not equal to SnapshotVersion.MIN.
            await this.qu(e);
        }
    }
    /**
     * Takes a batch of changes from the Datastore, repackages them as a
     * RemoteEvent, and passes that on to the listener, which is typically the
     * SyncEngine.
     */    qu(t) {
        const e = this.wu.ri(t);
        // Update in-memory resume tokens. LocalStore will update the
        // persistent view of these when applying the completed RemoteEvent.
                // Finally raise remote event
        return e.ws.forEach((e, s) => {
            if (e.resumeToken.Mt() > 0) {
                const i = this.fu.get(s);
                // A watched target might have been removed already.
                                i && this.fu.set(s, i.ss(e.resumeToken, t));
            }
        }), 
        // Re-establish listens for the targets that have been invalidated by
        // existence filter mismatches.
        e.Ts.forEach(t => {
            const e = this.fu.get(t);
            if (!e) 
            // A watched target might have been removed already.
            return;
            // Clear the resume token for the target, since we're in a known mismatch
            // state.
                        this.fu.set(t, e.ss(U.Ut, e.ts)), 
            // Cause a hard reset by unwatching and rewatching immediately, but
            // deliberately don't send a resume token so that we get a full update.
            this.Ou(t);
            // Mark the target we send as being on behalf of an existence filter
            // mismatch, but don't actually retain that in listenTargets. This ensures
            // that we flag the first re-listen this way without impacting future
            // listens of this target (that might happen e.g. on reconnect).
            const s = new xt(e.target, t, 1 /* ExistenceFilterMismatch */ , e.sequenceNumber);
            this.Lu(s);
        }), this.Mu.jh(e);
    }
    /** Handles an error on a target */    Uu(t) {
        const e = t.cause;
        let s = Promise.resolve();
        return t.targetIds.forEach(t => {
            s = s.then(async () => {
                // A watched target might have been removed already.
                if (this.fu.has(t)) return this.fu.delete(t), this.wu.removeTarget(t), this.Mu.Bu(t, e);
            });
        }), s;
    }
    /**
     * Attempts to fill our write pipeline with writes from the LocalStore.
     *
     * Called internally to bootstrap or refill the write pipeline and by
     * SyncEngine whenever there are new mutations to process.
     *
     * Starts the write stream if necessary.
     */    async Du() {
        if (this.xu()) {
            const t = this.du.length > 0 ? this.du[this.du.length - 1].batchId : -1, e = await this._u.io(t);
            null === e ? 0 === this.du.length && this.gu.Va() : (this.Qu(e), await this.Du());
        }
        this.Wu() && this.ju();
    }
    /**
     * Returns true if we can add to the write pipeline (i.e. the network is
     * enabled and the write pipeline is not full).
     */    xu() {
        return this.Eu() && this.du.length < 10;
    }
    // For testing
    Gu() {
        return this.du.length;
    }
    /**
     * Queues additional writes to be sent to the write stream, sending them
     * immediately if the write stream is established.
     */    Qu(t) {
        this.du.push(t), this.gu.Ia() && this.gu.Ua && this.gu.qa(t.mutations);
    }
    Wu() {
        return this.Eu() && !this.gu.Ra() && this.du.length > 0;
    }
    ju() {
        this.gu.start();
    }
    async yu() {
        this.gu.Qa();
    }
    vu() {
        // Record the stream token.
        return this._u.Qh(this.gu.lastStreamToken).then(() => {
            // Send the write pipeline now that the stream is established.
            for (const t of this.du) this.gu.qa(t.mutations);
        }).catch(He);
    }
    Ba(t, e) {
        const s = this.du.shift(), i = Oe.from(s, t, e, this.gu.lastStreamToken);
        return this.Mu.zu(i).then(() => this.Du());
    }
    async bu(t) {
        // If the write stream closed due to an error, invoke the error callbacks if
        // there are pending writes.
        if (t && this.du.length > 0) {
            // A promise that is resolved after we processed the error
            let e;
            // This error affects the actual write.
            return e = this.gu.Ua ? this.Ku(t) : this.Hu(t), e.then(() => {
                // The write stream might have been started by refilling the write
                // pipeline for failed writes
                this.Wu() && this.ju();
            });
        }
        // No pending writes, nothing to do
        }
    async Hu(t) {
        // Reset the token if it's a permanent error, signaling the write stream is
        // no longer valid. Note that the handshake does not count as a write: see
        // comments on isPermanentWriteError for details.
        if (Gt(t.code)) return ge("RemoteStore", "RemoteStore error before completed handshake; resetting stream token: ", this.gu.lastStreamToken), 
        this.gu.lastStreamToken = U.Ut, this._u.Qh(U.Ut).catch(He);
    }
    async Ku(t) {
        // Only handle permanent errors here. If it's transient, just let the retry
        // logic kick in.
        if (Gt(e = t.code) && e !== m.ABORTED) {
            // This was a permanent error, the request itself was the problem
            // so it's not going to succeed if we resend it.
            const e = this.du.shift();
            // In this case it's also unlikely that the server itself is melting
            // down -- this was just a bad request so inhibit backoff on the next
            // restart.
                        return this.gu.Pa(), this.Mu.Ju(e.batchId, t).then(() => this.Du());
        }
        var e;
        /**
 * Maps an error Code from a GRPC status identifier like 'NOT_FOUND'.
 *
 * @returns The Code equivalent to the given status string or undefined if
 *     there is no match.
 */    }
    Yu() {
        return new zs(this.Ha);
    }
    async Ru() {
        this.networkEnabled = !1, await this.Fu(), this.Iu.set("Unknown" /* Unknown */), 
        await this.enableNetwork();
    }
    async Xu() {
        this.Eu() && (
        // Tear down and re-create our network streams. This will ensure we get a fresh auth token
        // for the new user and re-fill the write pipeline with new mutations from the LocalStore
        // (since mutations are per-user).
        ge("RemoteStore", "RemoteStore restarting streams for new credential"), await this.Ru());
    }
    /**
     * Toggles the network state when the client gains or loses its primary lease.
     */    async Zu(t) {
        this.isPrimary = t, t && this.networkEnabled ? await this.enableNetwork() : t || (await this.Fu(), 
        this.Iu.set("Unknown" /* Unknown */));
    }
}

/**
 * @license
 * Copyright 2018 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Metadata state of the local client. Unlike `RemoteClientState`, this class is
 * mutable and keeps track of all pending mutations, which allows us to
 * update the range of pending mutation batch IDs as new mutations are added or
 * removed.
 *
 * The data in `LocalClientState` is not read from WebStorage and instead
 * updated via its instance methods. The updated state can be serialized via
 * `toWebStorageJSON()`.
 */
// Visible for testing.
class Js {
    constructor() {
        this.activeTargetIds = ne();
    }
    tc(t) {
        this.activeTargetIds = this.activeTargetIds.add(t);
    }
    ec(t) {
        this.activeTargetIds = this.activeTargetIds.delete(t);
    }
    /**
     * Converts this entry into a JSON-encoded format we can use for WebStorage.
     * Does not encode `clientId` as it is part of the key in WebStorage.
     */    sc() {
        const t = {
            activeTargetIds: this.activeTargetIds.j(),
            updateTimeMs: Date.now()
        };
        return JSON.stringify(t);
    }
}

/**
 * `MemorySharedClientState` is a simple implementation of SharedClientState for
 * clients using memory persistence. The state in this class remains fully
 * isolated and no synchronization is performed.
 */ class Ys {
    constructor() {
        this.ic = new Js, this.nc = {}, this.Mu = null, this.iu = null, this.Tr = null;
    }
    rc(t) {
        // No op.
    }
    hc(t, e, s) {
        // No op.
    }
    oc(t) {
        return this.ic.tc(t), this.nc[t] || "not-current";
    }
    ac(t, e, s) {
        this.nc[t] = e;
    }
    uc(t) {
        this.ic.ec(t);
    }
    cc(t) {
        return this.ic.activeTargetIds.has(t);
    }
    lc(t) {
        delete this.nc[t];
    }
    _c() {
        return this.ic.activeTargetIds;
    }
    dc(t) {
        return this.ic.activeTargetIds.has(t);
    }
    start() {
        return this.ic = new Js, Promise.resolve();
    }
    Vh(t, e, s) {
        // No op.
    }
    fc(t) {
        // No op.
    }
    ku() {}
    Rr(t) {}
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/** Offset to ensure non-overlapping target ids. */
/**
 * Generates monotonically increasing target IDs for sending targets to the
 * watch stream.
 *
 * The client constructs two generators, one for the target cache, and one for
 * for the sync engine (to generate limbo documents targets). These
 * generators produce non-overlapping IDs (by using even and odd IDs
 * respectively).
 *
 * By separating the target ID space, the query cache can generate target IDs
 * that persist across client restarts, while sync engine can independently
 * generate in-memory target IDs that are transient and can be reused after a
 * restart.
 */
class Xs {
    constructor(t) {
        this.wc = t;
    }
    next() {
        return this.wc += 2, this.wc;
    }
    static Tc() {
        // The target cache generator must return '2' in its first call to `next()`
        // as there is no differentiation in the protocol layer between an unset
        // number and the number '0'. If we were to sent a target with target ID
        // '0', the backend would consider it unset and replace it with its own ID.
        return new Xs(0);
    }
    static mc() {
        // Sync engine assigns target IDs for limbo document detection.
        return new Xs(-1);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class Zs {
    constructor(t) {
        this.key = t;
    }
}

class ti {
    constructor(t) {
        this.key = t;
    }
}

/**
 * View is responsible for computing the final merged truth of what docs are in
 * a query. It gets notified of local and remote changes to docs, and applies
 * the query filters and limits to determine the most correct possible results.
 */ class ei {
    constructor(t, 
    /** Documents included in the remote target */
    e) {
        this.query = t, this.Ec = e, this.Rc = null, 
        /**
         * A flag whether the view is current with the backend. A view is considered
         * current after it has seen the current flag from the backend and did not
         * lose consistency within the watch stream (e.g. because of an existence
         * filter mismatch).
         */
        this.As = !1, 
        /** Documents in the view but not in the remote target */
        this.Ic = se(), 
        /** Document Keys that have local changes */
        this.ls = se(), this.Ac = new re(t.qe.bind(t));
    }
    /**
     * The set of remote documents that the server has told us belongs to the target associated with
     * this view.
     */    get Pc() {
        return this.Ec;
    }
    /**
     * Iterates over a set of doc changes, applies the query limit, and computes
     * what the new results should be, what the changes were, and whether we may
     * need to go back to the local cache for more results. Does not make any
     * changes to the view.
     * @param docChanges The doc changes to apply to this view.
     * @param previousChanges If this is being called with a refill, then start
     *        with this set of docs and changes instead of the current view.
     * @return a new set of docs, changes, and refill flag.
     */    Vc(t, e) {
        const s = e ? e.pc : new he, i = e ? e.Ac : this.Ac;
        let n = e ? e.ls : this.ls, r = i, h = !1;
        // Track the last doc in a (full) limit. This is necessary, because some
        // update (a delete, or an update moving a doc past the old limit) might
        // mean there is some other document in the local cache that either should
        // come (1) between the old last limit doc and the new last document, in the
        // case of updates, or (2) after the new last document, in the case of
        // deletes. So we keep this doc at the old limit to compare the updates to.
        // Note that this should never get used in a refill (when previousChanges is
        // set), because there will only be adds -- no deletes or updates.
        const o = this.query.je() && i.size === this.query.limit ? i.last() : null, a = this.query.Ge() && i.size === this.query.limit ? i.first() : null;
        // Drop documents out to meet limit/limitToLast requirement.
        if (t.ut((t, e) => {
            const u = i.get(t);
            let c = e instanceof gt ? e : null;
            c && (c = this.query.matches(c) ? c : null);
            const l = !!u && this.ls.has(u.key), _ = !!c && (c.te || 
            // We only consider committed mutations for documents that were
            // mutated during the lifetime of the view.
            this.ls.has(c.key) && c.hasCommittedMutations);
            let d = !1;
            // Calculate change
                        if (u && c) {
                u.data().isEqual(c.data()) ? l !== _ && (s.track({
                    type: 3 /* Metadata */ ,
                    doc: c
                }), d = !0) : this.gc(u, c) || (s.track({
                    type: 2 /* Modified */ ,
                    doc: c
                }), d = !0, (o && this.query.qe(c, o) > 0 || a && this.query.qe(c, a) < 0) && (
                // This doc moved from inside the limit to outside the limit.
                // That means there may be some other doc in the local cache
                // that should be included instead.
                h = !0));
            } else !u && c ? (s.track({
                type: 0 /* Added */ ,
                doc: c
            }), d = !0) : u && !c && (s.track({
                type: 1 /* Removed */ ,
                doc: u
            }), d = !0, (o || a) && (
            // A doc was removed from a full limit query. We'll need to
            // requery from the local cache to see if we know about some other
            // doc that should be in the results.
            h = !0));
            d && (c ? (r = r.add(c), n = _ ? n.add(t) : n.delete(t)) : (r = r.delete(t), n = n.delete(t)));
        }), this.query.je() || this.query.Ge()) for (;r.size > this.query.limit; ) {
            const t = this.query.je() ? r.last() : r.first();
            r = r.delete(t.key), n = n.delete(t.key), s.track({
                type: 1 /* Removed */ ,
                doc: t
            });
        }
        return {
            Ac: r,
            pc: s,
            yc: h,
            ls: n
        };
    }
    gc(t, e) {
        // We suppress the initial change event for documents that were modified as
        // part of a write acknowledgment (e.g. when the value of a server transform
        // is applied) as Watch will send us the same document again.
        // By suppressing the event, we only raise two user visible events (one with
        // `hasPendingWrites` and the final state of the document) instead of three
        // (one with `hasPendingWrites`, the modified document with
        // `hasPendingWrites` and the final state of the document).
        return t.te && e.hasCommittedMutations && !e.te;
    }
    /**
     * Updates the view with the given ViewDocumentChanges and optionally updates
     * limbo docs and sync state from the provided target change.
     * @param docChanges The set of changes to make to the view's docs.
     * @param updateLimboDocuments Whether to update limbo documents based on this
     *        change.
     * @param targetChange A target change to apply for computing limbo docs and
     *        sync state.
     * @return A new ViewChange with the given docs, changes, and sync state.
     */
    // PORTING NOTE: The iOS/Android clients always compute limbo document changes.
    bc(t, e, s) {
        const i = this.Ac;
        this.Ac = t.Ac, this.ls = t.ls;
        // Sort changes based on type and query comparator
        const n = t.pc.us();
        n.sort((t, e) => function(t, e) {
            const s = t => {
                switch (t) {
                  case 0 /* Added */ :
                    return 1;

                  case 2 /* Modified */ :
                  case 3 /* Metadata */ :
                    // A metadata change is converted to a modified change at the public
                    // api layer.  Since we sort by document key and then change type,
                    // metadata and modified changes must be sorted equivalently.
                    return 2;

                  case 1 /* Removed */ :
                    return 0;

                  default:
                    return ve("Unknown ChangeType: " + t);
                }
            };
            return s(t) - s(e);
        }
        /**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ (t.type, e.type) || this.query.qe(t.doc, e.doc)), this.vc(s);
        const r = e ? this.Sc() : [], h = 0 === this.Ic.size && this.As ? 1 /* Synced */ : 0 /* Local */ , o = h !== this.Rc;
        if (this.Rc = h, 0 !== n.length || o) {
            return {
                snapshot: new oe(this.query, t.Ac, i, n, t.ls, 0 /* Local */ === h, o, 
                /* excludesMetadataChanges= */ !1),
                Cc: r
            };
        }
        // no changes
        return {
            Cc: r
        };
    }
    /**
     * Applies an OnlineState change to the view, potentially generating a
     * ViewChange if the view's syncState changes as a result.
     */    Dc(t) {
        return this.As && "Offline" /* Offline */ === t ? (
        // If we're offline, set `current` to false and then call applyChanges()
        // to refresh our syncState and generate a ViewChange as appropriate. We
        // are guaranteed to get a new TargetChange that sets `current` back to
        // true once the client is back online.
        this.As = !1, this.bc({
            Ac: this.Ac,
            pc: new he,
            ls: this.ls,
            yc: !1
        }, 
        /* updateLimboDocuments= */ !1)) : {
            Cc: []
        };
    }
    /**
     * Returns whether the doc for the given key should be in limbo.
     */    Fc(t) {
        // If the remote end says it's part of this query, it's not in limbo.
        return !this.Ec.has(t) && (
        // The local store doesn't think it's a result, so it shouldn't be in limbo.
        !!this.Ac.has(t) && !this.Ac.get(t).te);
    }
    /**
     * Updates syncedDocuments, current, and limbo docs based on the given change.
     * Returns the list of changes to which docs are in limbo.
     */    vc(t) {
        t && (t.Ps.forEach(t => this.Ec = this.Ec.add(t)), t.Vs.forEach(t => {}), t.ps.forEach(t => this.Ec = this.Ec.delete(t)), 
        this.As = t.As);
    }
    Sc() {
        // We can only determine limbo documents when we're in-sync with the server.
        if (!this.As) return [];
        // TODO(klimt): Do this incrementally so that it's not quadratic when
        // updating many documents.
                const t = this.Ic;
        this.Ic = se(), this.Ac.forEach(t => {
            this.Fc(t.key) && (this.Ic = this.Ic.add(t.key));
        });
        // Diff the new limbo docs with the old limbo docs.
        const e = [];
        return t.forEach(t => {
            this.Ic.has(t) || e.push(new ti(t));
        }), this.Ic.forEach(s => {
            t.has(s) || e.push(new Zs(s));
        }), e;
    }
    /**
     * Update the in-memory state of the current view with the state read from
     * persistence.
     *
     * We update the query view whenever a client's primary status changes:
     * - When a client transitions from primary to secondary, it can miss
     *   LocalStorage updates and its query views may temporarily not be
     *   synchronized with the state on disk.
     * - For secondary to primary transitions, the client needs to update the list
     *   of `syncedDocuments` since secondary clients update their query views
     *   based purely on synthesized RemoteEvents.
     *
     * @param queryResult.documents - The documents that match the query according
     * to the LocalStore.
     * @param queryResult.remoteKeys - The keys of the documents that match the
     * query according to the backend.
     *
     * @return The ViewChange that resulted from this synchronization.
     */
    // PORTING NOTE: Multi-tab only.
    Nc(t) {
        this.Ec = t.do, this.Ic = se();
        const e = this.Vc(t.documents);
        return this.bc(e, /*updateLimboDocuments=*/ !0);
    }
    /**
     * Returns a view snapshot as if this query was just listened to. Contains
     * a document add for every existing document and the `fromCache` and
     * `hasPendingWrites` status of the already established view.
     */
    // PORTING NOTE: Multi-tab only.
    kc() {
        return oe.fs(this.query, this.Ac, this.ls, 0 /* Local */ === this.Rc);
    }
}

/**
 * TransactionRunner encapsulates the logic needed to run and retry transactions
 * with backoff.
 */
class si {
    constructor(t, e, s, i) {
        this.Ar = t, this.Lc = e, this.updateFunction = s, this.gr = i, this.$c = 5, this.Ea = new xs(this.Ar, "retry_transaction" /* RetryTransaction */);
    }
    /** Runs the transaction and sets the result on deferred. */    Oc() {
        this.Mc();
    }
    Mc() {
        this.Ea.la(async () => {
            const t = this.Lc.Yu(), e = this.Uc(t);
            e && e.then(e => {
                this.Ar.Cr(() => t.commit().then(() => {
                    this.gr.resolve(e);
                }).catch(t => {
                    this.qc(t);
                }));
            }).catch(t => {
                this.qc(t);
            });
        });
    }
    Uc(t) {
        try {
            const e = this.updateFunction(t);
            return !q(e) && e.catch && e.then ? e : (this.gr.reject(Error("Transaction callback must return a Promise")), 
            null);
        } catch (t) {
            // Do not retry errors thrown by user provided updateFunction.
            return this.gr.reject(t), null;
        }
    }
    qc(t) {
        this.$c > 0 && this.Bc(t) ? (this.$c -= 1, this.Ar.Cr(() => (this.Mc(), Promise.resolve()))) : this.gr.reject(t);
    }
    Bc(t) {
        if ("FirebaseError" === t.name) {
            // In transactions, the backend will fail outdated reads with FAILED_PRECONDITION and
            // non-matching document versions with ABORTED. These errors should be retried.
            const e = t.code;
            return "aborted" === e || "failed-precondition" === e || !Gt(e);
        }
        return !1;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * QueryView contains all of the data that SyncEngine needs to keep track of for
 * a particular query.
 */
class ii {
    constructor(
    /**
     * The query itself.
     */
    t, 
    /**
     * The target number created by the client that is used in the watch
     * stream to identify this query.
     */
    e, 
    /**
     * The view is responsible for computing the final merged truth of what
     * docs are in the query. It gets notified of local and remote changes,
     * and applies the query filters and limits to determine the most correct
     * possible results.
     */
    s) {
        this.query = t, this.targetId = e, this.view = s;
    }
}

/** Tracks a limbo resolution. */ class ni {
    constructor(t) {
        this.key = t, 
        /**
         * Set to true once we've received a document. This is used in
         * getRemoteKeysForTarget() and ultimately used by WatchChangeAggregator to
         * decide whether it needs to manufacture a delete event for the target once
         * the target is CURRENT.
         */
        this.xc = !1;
    }
}

/**
 * SyncEngine is the central controller in the client SDK architecture. It is
 * the glue code between the EventManager, LocalStore, and RemoteStore. Some of
 * SyncEngine's responsibilities include:
 * 1. Coordinating client requests and remote events between the EventManager
 *    and the local and remote data stores.
 * 2. Managing a View object for each query, providing the unified view between
 *    the local and remote data stores.
 * 3. Notifying the RemoteStore when the LocalStore has new mutations in its
 *    queue that need sending to the backend.
 *
 * The SyncEngine’s methods should only ever be called by methods running in the
 * global async queue.
 */ class ri {
    constructor(t, e, 
    // PORTING NOTE: Manages state synchronization in multi-tab environments.
    s, i, n) {
        this._u = t, this.Lc = e, this.Qc = s, this.currentUser = i, this.Wc = n, this.jc = null, 
        this.Gc = new Le(t => t.canonicalId()), this.zc = new Map, 
        /**
         * The keys of documents that are in limbo for which we haven't yet started a
         * limbo resolution query.
         */
        this.Kc = [], 
        /**
         * Keeps track of the target ID for each document that is in limbo with an
         * active target.
         */
        this.Hc = new D(C.k), 
        /**
         * Keeps track of the information about an active limbo resolution for each
         * active target ID that was started for the purpose of limbo resolution.
         */
        this.Jc = new Map, this.Yc = new Me, 
        /** Stores user completion handlers, indexed by User and BatchId. */
        this.Xc = {}, 
        /** Stores user callbacks waiting for all pending writes to be acknowledged. */
        this.Zc = new Map, this.tl = Xs.mc(), 
        // The primary state is set to `true` or `false` immediately after Firestore
        // startup. In the interim, a client should only be considered primary if
        // `isPrimary` is true.
        this.isPrimary = void 0, this.onlineState = "Unknown" /* Unknown */;
    }
    // Only used for testing.
    get el() {
        return !0 === this.isPrimary;
    }
    /** Subscribes to SyncEngine notifications. Has to be called exactly once. */    subscribe(t) {
        this.jc = t;
    }
    /**
     * Initiates the new listen, resolves promise when listen enqueued to the
     * server. All the subsequent view snapshots or errors are sent to the
     * subscribed handlers. Returns the targetId of the query.
     */    async listen(t) {
        let e, s;
        this.sl("listen()");
        const i = this.Gc.get(t);
        if (i) 
        // PORTING NOTE: With Multi-Tab Web, it is possible that a query view
        // already exists when EventManager calls us for the first time. This
        // happens when the primary tab is already listening to this query on
        // behalf of another tab and the user of the primary also starts listening
        // to the query. EventManager will not have an assigned target ID in this
        // case and calls `listen` to obtain this ID.
        e = i.targetId, this.Qc.oc(e), s = i.view.kc(); else {
            const i = await this._u.ho(t.Ue()), n = this.Qc.oc(i.targetId);
            e = i.targetId, s = await this.il(t, e, "current" === n), this.isPrimary && this.Lc.listen(i);
        }
        return this.jc.La([ s ]), e;
    }
    /**
     * Registers a view for a previously unknown query and computes its initial
     * snapshot.
     */    async il(t, e, s) {
        const i = await this._u.lo(t, 
        /* usePreviousResults= */ !0), n = new ei(t, i.do), r = n.Vc(i.documents), h = ue.Is(e, s && "Offline" /* Offline */ !== this.onlineState), o = n.bc(r, 
        /* updateLimboDocuments= */ !0 === this.isPrimary, h), a = new ii(t, e, n);
        return this.Gc.set(t, a), this.zc.has(e) ? this.zc.get(e).push(t) : this.zc.set(e, [ t ]), 
        o.snapshot;
    }
    /**
     * Reconcile the list of synced documents in an existing view with those
     * from persistence.
     */
    // PORTING NOTE: Multi-tab only.
    async nl(t) {
        const e = await this._u.lo(t.query, 
        /* usePreviousResults= */ !0), s = t.view.Nc(e);
        return this.isPrimary && this.rl(t.targetId, s.Cc), s;
    }
    /** Stops listening to the query. */    async $u(t) {
        this.sl("unlisten()");
        const e = this.Gc.get(t), s = this.zc.get(e.targetId);
        // Only clean up the query view and target if this is the only query mapped
        // to the target.
                if (s.length > 1) return this.zc.set(e.targetId, s.filter(e => !e.isEqual(t))), 
        void this.Gc.delete(t);
        // No other queries are mapped to the target, clean up the query and the target.
                if (this.isPrimary) {
            // We need to remove the local query target first to allow us to verify
            // whether any other client is still interested in this target.
            this.Qc.uc(e.targetId), this.Qc.dc(e.targetId) || await this._u.co(e.targetId, /*keepPersistedTargetData=*/ !1).then(() => {
                this.Qc.lc(e.targetId), this.Lc.$u(e.targetId), this.hl(e.targetId);
            }).catch(He);
        } else this.hl(e.targetId), await this._u.co(e.targetId, 
        /*keepPersistedTargetData=*/ !0);
    }
    /**
     * Initiates the write of local mutation batch which involves adding the
     * writes to the mutation queue, notifying the remote store about new
     * mutations and raising events for any changes this write caused.
     *
     * The promise returned by this call is resolved when the above steps
     * have completed, *not* when the write was acked by the backend. The
     * userCallback is resolved once the write was acked/rejected by the
     * backend (or failed locally for any other reason).
     */    async write(t, e) {
        this.sl("write()");
        const s = await this._u.vh(t);
        this.Qc.rc(s.batchId), this.ol(s.batchId, e), await this.al(s.Ch), await this.Lc.Du();
    }
    /**
     * Takes an updateFunction in which a set of reads and writes can be performed
     * atomically. In the updateFunction, the client can read and write values
     * using the supplied transaction object. After the updateFunction, all
     * changes will be committed. If a retryable error occurs (ex: some other
     * client has changed any of the data referenced), then the updateFunction
     * will be called again after a backoff. If the updateFunction still fails
     * after all retries, then the transaction will be rejected.
     *
     * The transaction object passed to the updateFunction contains methods for
     * accessing documents and collections. Unlike other datastore access, data
     * accessed with the transaction will not reflect local changes that have not
     * been committed. For this reason, it is required that all reads are
     * performed before any writes. Transactions must be performed while online.
     *
     * The Deferred input is resolved when the transaction is fully committed.
     */    runTransaction(t, e, s) {
        new si(t, this.Lc, e, s).Oc();
    }
    async jh(t) {
        this.sl("applyRemoteEvent()");
        try {
            const e = await this._u.jh(t);
            // Update `receivedDocument` as appropriate for any limbo targets.
                        t.ws.forEach((t, e) => {
                const s = this.Jc.get(e);
                s && (
                // Since this is a limbo resolution lookup, it's for a single document
                // and it could be added, modified, or removed, but not a combination.
                Se(t.Ps.size + t.Vs.size + t.ps.size <= 1, "Limbo resolution for single document contains multiple changes."), 
                t.Ps.size > 0 ? s.xc = !0 : t.Vs.size > 0 ? Se(s.xc, "Received change for limbo target document without add.") : t.ps.size > 0 && (Se(s.xc, "Received remove for limbo target document without add."), 
                s.xc = !1));
            }), await this.al(e, t);
        } catch (t) {
            await He(t);
        }
    }
    /**
     * Applies an OnlineState change to the sync engine and notifies any views of
     * the change.
     */    Dc(t, e) {
        // If we are the secondary client, we explicitly ignore the remote store's
        // online state (the local client may go offline, even though the primary
        // tab remains online) and only apply the primary tab's online state from
        // SharedClientState.
        if (this.isPrimary && 0 /* RemoteStore */ === e || !this.isPrimary && 1 /* SharedClientState */ === e) {
            this.sl("applyOnlineStateChange()");
            const e = [];
            this.Gc.forEach((s, i) => {
                const n = i.view.Dc(t);
                n.snapshot && e.push(n.snapshot);
            }), this.jc.ul(t), this.jc.La(e), this.onlineState = t, this.isPrimary && this.Qc.fc(t);
        }
    }
    async Bu(t, e) {
        this.sl("rejectListens()"), 
        // PORTING NOTE: Multi-tab only.
        this.Qc.ac(t, "rejected", e);
        const s = this.Jc.get(t), i = s && s.key;
        if (i) {
            // Since this query failed, we won't want to manually unlisten to it.
            // So go ahead and remove it from bookkeeping.
            this.Hc = this.Hc.remove(i), this.Jc.delete(t), this.cl();
            // TODO(klimt): We really only should do the following on permission
            // denied errors, but we don't have the cause code here.
            // It's a limbo doc. Create a synthetic event saying it was deleted.
            // This is kind of a hack. Ideally, we would have a method in the local
            // store to purge a document. However, it would be tricky to keep all of
            // the local store's invariants with another method.
            let e = new D(C.k);
            e = e.nt(i, new yt(i, g.S()));
            const s = se().add(i), n = new ae(g.MIN, 
            /* targetChanges= */ new Map, 
            /* targetMismatches= */ new k(De), e, s);
            return this.jh(n);
        }
        await this._u.co(t, /* keepPersistedTargetData */ !1).then(() => this.hl(t, e)).catch(He);
    }
    // PORTING NOTE: Multi-tab only
    async ll(t, e, s) {
        this.sl("applyBatchState()");
        const i = await this._u.Dh(t);
        null !== i ? ("pending" === e ? 
        // If we are the primary client, we need to send this write to the
        // backend. Secondary clients will ignore these writes since their remote
        // connection is disabled.
        await this.Lc.Du() : "acknowledged" === e || "rejected" === e ? (
        // NOTE: Both these methods are no-ops for batches that originated from
        // other clients.
        this._l(t, s || null), this._u.To(t)) : ve(`Unknown batchState: ${e}`), await this.al(i)) : 
        // A throttled tab may not have seen the mutation before it was completed
        // and removed from the mutation queue, in which case we won't have cached
        // the affected documents. In this case we can safely ignore the update
        // since that means we didn't apply the mutation locally at all (if we
        // had, we would have cached the affected documents), and so we will just
        // see any resulting document changes via normal remote document updates
        // as applicable.
        ge("SyncEngine", "Cannot apply mutation batch with id: " + t);
    }
    async zu(t) {
        this.sl("applySuccessfulWrite()");
        const e = t.batch.batchId;
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught
        // up), so we raise user callbacks first so that they consistently happen
        // before listen events.
                this._l(e, /*error=*/ null), this.dl(e);
        try {
            const s = await this._u.Nh(t);
            this.Qc.hc(e, "acknowledged"), await this.al(s);
        } catch (t) {
            await He(t);
        }
    }
    async Ju(t, e) {
        this.sl("rejectFailedWrite()"), 
        // The local store may or may not be able to apply the write result and
        // raise events immediately (depending on whether the watcher is caught up),
        // so we raise user callbacks first so that they consistently happen before
        // listen events.
        this._l(t, e), this.dl(t);
        try {
            const s = await this._u.Mh(t);
            this.Qc.hc(t, "rejected", e), await this.al(s);
        } catch (e) {
            await He(e);
        }
    }
    /**
     * Registers a user callback that resolves when all pending mutations at the moment of calling
     * are acknowledged .
     */    async fl(t) {
        this.Lc.Eu() || ge("SyncEngine", "The network is disabled. The task returned by 'awaitPendingWrites()' will not complete until the network is enabled.");
        const e = await this._u.Bh();
        if (-1 === e) 
        // Trigger the callback right away if there is no pending writes at the moment.
        return void t.resolve();
        const s = this.Zc.get(e) || [];
        s.push(t), this.Zc.set(e, s);
    }
    /**
     * Triggers the callbacks that are waiting for this batch id to get acknowledged by server,
     * if there are any.
     */    dl(t) {
        (this.Zc.get(t) || []).forEach(t => {
            t.resolve();
        }), this.Zc.delete(t);
    }
    /** Reject all outstanding callbacks waiting for pending writes to complete. */    wl(t) {
        this.Zc.forEach(e => {
            e.forEach(e => {
                e.reject(new E(m.CANCELLED, t));
            });
        }), this.Zc.clear();
    }
    ol(t, e) {
        let s = this.Xc[this.currentUser.s()];
        s || (s = new D(De)), s = s.nt(t, e), this.Xc[this.currentUser.s()] = s;
    }
    /**
     * Resolves or rejects the user callback for the given batch and then discards
     * it.
     */    _l(t, e) {
        let s = this.Xc[this.currentUser.s()];
        // NOTE: Mutations restored from persistence won't have callbacks, so it's
        // okay for there to be no callback for this ID.
                if (s) {
            const i = s.get(t);
            i && (e ? i.reject(e) : i.resolve(), s = s.remove(t)), this.Xc[this.currentUser.s()] = s;
        }
    }
    hl(t, e = null) {
        this.Qc.uc(t);
        for (const s of this.zc.get(t)) this.Gc.delete(s), e && this.jc.Tl(s, e);
        if (this.zc.delete(t), this.isPrimary) {
            const e = this.Yc.Ln(t);
            this.Yc.Nn(t), e.forEach(t => {
                this.Yc.$n(t) || 
                // We removed the last reference for this key
                this.ml(t);
            });
        }
    }
    ml(t) {
        // It's possible that the target already got removed because the query failed. In that case,
        // the key won't exist in `limboTargetsByKey`. Only do the cleanup if we still have the target.
        const e = this.Hc.get(t);
        null !== e && (this.Lc.$u(e), this.Hc = this.Hc.remove(t), this.Jc.delete(e), this.cl());
    }
    rl(t, e) {
        for (const s of e) if (s instanceof Zs) this.Yc.vn(s.key, t), this.El(s); else if (s instanceof ti) {
            ge("SyncEngine", "Document no longer in limbo: " + s.key), this.Yc.Cn(s.key, t), 
            this.Yc.$n(s.key) || 
            // We removed the last reference for this key
            this.ml(s.key);
        } else ve("Unknown limbo change: " + JSON.stringify(s));
    }
    El(t) {
        const e = t.key;
        this.Hc.get(e) || (ge("SyncEngine", "New document in limbo: " + e), this.Kc.push(e), 
        this.cl());
    }
    /**
     * Starts listens for documents in limbo that are enqueued for resolution,
     * subject to a maximum number of concurrent resolutions.
     *
     * Without bounding the number of concurrent resolutions, the server can fail
     * with "resource exhausted" errors which can lead to pathological client
     * behavior as seen in https://github.com/firebase/firebase-js-sdk/issues/2683.
     */    cl() {
        for (;this.Kc.length > 0 && this.Hc.size < this.Wc; ) {
            const t = this.Kc.shift(), e = this.tl.next();
            this.Jc.set(e, new ni(t)), this.Hc = this.Hc.nt(t, e), this.Lc.listen(new xt(St.ve(t.path).Ue(), e, 2 /* LimboResolution */ , Qe.Ir));
        }
    }
    // Visible for testing
    Rl() {
        return this.Hc;
    }
    // Visible for testing
    Il() {
        return this.Kc;
    }
    async al(t, e) {
        const s = [], i = [], n = [];
        this.Gc.forEach((r, h) => {
            n.push(Promise.resolve().then(() => {
                const e = h.view.Vc(t);
                return e.yc ? this._u.lo(h.query, /* usePreviousResults= */ !1).then(({documents: t}) => h.view.Vc(t, e)) : e;
                // The query has a limit and some docs were removed, so we need
                // to re-run the query against the local store to make sure we
                // didn't lose any good docs that had been past the limit.
                        }).then(t => {
                const n = e && e.ws.get(h.targetId), r = h.view.bc(t, 
                /* updateLimboDocuments= */ !0 === this.isPrimary, n);
                if (this.rl(h.targetId, r.Cc), r.snapshot) {
                    this.isPrimary && this.Qc.ac(h.targetId, r.snapshot.fromCache ? "not-current" : "current"), 
                    s.push(r.snapshot);
                    const t = xe.wr(h.targetId, r.snapshot);
                    i.push(t);
                }
            }));
        }), await Promise.all(n), this.jc.La(s), await this._u.so(i);
    }
    sl(t) {}
    async Xu(t) {
        const e = !this.currentUser.isEqual(t);
        if (this.currentUser = t, e) {
            // Fails tasks waiting for pending writes requested by previous user.
            this.wl("'waitForPendingWrites' promise is rejected due to a user change.");
            const e = await this._u.Vh(t);
            // TODO(b/114226417): Consider calling this only in the primary tab.
                        this.Qc.Vh(t, e.yh, e.bh), await this.al(e.gh);
        }
        await this.Lc.Xu();
    }
    // PORTING NOTE: Multi-tab only
    async Zu(t) {
        if (!0 === t && !0 !== this.isPrimary) {
            this.isPrimary = !0, await this.Lc.Zu(!0);
            // Secondary tabs only maintain Views for their local listeners and the
            // Views internal state may not be 100% populated (in particular
            // secondary tabs don't track syncedDocuments, the set of documents the
            // server considers to be in the target). So when a secondary becomes
            // primary, we need to need to make sure that all views for all targets
            // match the state on disk.
            const t = this.Qc._c(), e = await this.Al(t.j());
            for (const t of e) this.Lc.listen(t);
        } else if (!1 === t && !1 !== this.isPrimary) {
            this.isPrimary = !1;
            const t = [];
            let e = Promise.resolve();
            this.zc.forEach((s, i) => {
                this.Qc.cc(i) ? t.push(i) : e = e.then(() => (this.hl(i), this._u.co(i, 
                /*keepPersistedTargetData=*/ !0))), this.Lc.$u(i);
            }), await e, await this.Al(t), this.Pl(), await this.Lc.Zu(!1);
        }
    }
    // PORTING NOTE: Multi-tab only.
    Pl() {
        this.Jc.forEach((t, e) => {
            this.Lc.$u(e);
        }), this.Yc.kn(), this.Jc = new Map, this.Hc = new D(C.k);
    }
    /**
     * Reconcile the query views of the provided query targets with the state from
     * persistence. Raises snapshots for any changes that affect the local
     * client and returns the updated state of all target's query data.
     */
    // PORTING NOTE: Multi-tab only.
    async Al(t) {
        const e = [], s = [];
        for (const i of t) {
            let t;
            const n = this.zc.get(i);
            if (n && 0 !== n.length) {
                // For queries that have a local View, we need to update their state
                // in LocalStore (as the resume token and the snapshot version
                // might have changed) and reconcile their views with the persisted
                // state (the list of syncedDocuments may have gotten out of sync).
                await this._u.co(i, 
                /*keepPersistedTargetData=*/ !0), t = await this._u.ho(n[0].Ue());
                for (const t of n) {
                    const e = this.Gc.get(t), i = await this.nl(e);
                    i.snapshot && s.push(i.snapshot);
                }
            } else {
                // For queries that never executed on this client, we need to
                // allocate the target in LocalStore and initialize a new View.
                const e = await this._u.Ao(i);
                t = await this._u.ho(e), await this.il(this.Vl(e), i, 
                /*current=*/ !1);
            }
            e.push(t);
        }
        return this.jc.La(s), e;
    }
    /**
     * Creates a `Query` object from the specified `Target`. There is no way to
     * obtain the original `Query`, so we synthesize a `Query` from the `Target`
     * object.
     *
     * The synthesized result might be different from the original `Query`, but
     * since the synthesized `Query` should return the same results as the
     * original one (only the presentation of results might differ), the potential
     * difference will not cause issues.
     */
    // PORTING NOTE: Multi-tab only
    Vl(t) {
        return new St(t.path, t.collectionGroup, t.orderBy, t.filters, t.limit, "F" /* First */ , t.startAt, t.endAt);
    }
    // PORTING NOTE: Multi-tab only
    wo() {
        return this._u.wo();
    }
    // PORTING NOTE: Multi-tab only
    async pl(t, e, s) {
        if (this.isPrimary) 
        // If we receive a target state notification via WebStorage, we are
        // either already secondary or another tab has taken the primary lease.
        ge("SyncEngine", "Ignoring unexpected query state notification."); else if (this.zc.has(t)) switch (e) {
          case "current":
          case "not-current":
            {
                const s = await this._u.Po(), i = ae.Rs(t, "current" === e);
                await this.al(s, i);
                break;
            }

          case "rejected":
            await this._u.co(t, 
            /* keepPersistedTargetData */ !0), this.hl(t, s);
            break;

          default:
            ve("Unexpected target state: " + e);
        }
    }
    // PORTING NOTE: Multi-tab only
    async gl(t, e) {
        if (this.isPrimary) {
            for (const e of t) {
                const t = await this._u.Ao(e), s = await this._u.ho(t);
                await this.il(this.Vl(t), s.targetId, 
                /*current=*/ !1), this.Lc.listen(s);
            }
            for (const t of e) 
            // Check that the target is still active since the target might have been
            // removed if it has been rejected by the backend.
            this.zc.has(t) && 
            // Release queries that are still active.
            await this._u.co(t, /* keepPersistedTargetData */ !1).then(() => {
                this.Lc.$u(t), this.hl(t);
            }).catch(He);
        }
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    enableNetwork() {
        return this._u.Eo(!0), this.Lc.enableNetwork();
    }
    // PORTING NOTE: Multi-tab only. In other clients, LocalStore is unaware of
    // the online state.
    disableNetwork() {
        return this._u.Eo(!1), this.Lc.disableNetwork();
    }
    ai(t) {
        const e = this.Jc.get(t);
        if (e && e.xc) return se().add(e.key);
        {
            let e = se();
            const s = this.zc.get(t);
            if (!s) return e;
            for (const t of s) {
                const s = this.Gc.get(t);
                e = e.kt(s.view.Pc);
            }
            return e;
        }
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Holds the listeners and the last received ViewSnapshot for a query being
 * tracked by EventManager.
 */ class hi {
    constructor() {
        this.yl = null, this.targetId = 0, this.bl = [];
    }
}

/**
 * EventManager is responsible for mapping queries to query event emitters.
 * It handles "fan-out". -- Identical queries will re-use the same watch on the
 * backend.
 */ class oi {
    constructor(t) {
        this.Mu = t, this.vl = new Le(t => t.canonicalId()), this.onlineState = "Unknown" /* Unknown */ , 
        this.Sl = new Set, this.Mu.subscribe(this);
    }
    listen(t) {
        const e = t.query;
        let s = !1, i = this.vl.get(e);
        i || (s = !0, i = new hi, this.vl.set(e, i)), i.bl.push(t);
        // Run global snapshot listeners if a consistent snapshot has been emitted.
        t.Dc(this.onlineState);
        if (i.yl) {
            t.Cl(i.yl) && this.Dl();
        }
        return s ? this.Mu.listen(e).then(t => (i.targetId = t, t)) : Promise.resolve(i.targetId);
    }
    async $u(t) {
        const e = t.query;
        let s = !1;
        const i = this.vl.get(e);
        if (i) {
            const e = i.bl.indexOf(t);
            e >= 0 && (i.bl.splice(e, 1), s = 0 === i.bl.length);
        }
        if (s) return this.vl.delete(e), this.Mu.$u(e);
    }
    La(t) {
        let e = !1;
        for (const s of t) {
            const t = s.query, i = this.vl.get(t);
            if (i) {
                for (const t of i.bl) t.Cl(s) && (e = !0);
                i.yl = s;
            }
        }
        e && this.Dl();
    }
    Tl(t, e) {
        const s = this.vl.get(t);
        if (s) for (const t of s.bl) t.onError(e);
        // Remove all listeners. NOTE: We don't need to call syncEngine.unlisten()
        // after an error.
                this.vl.delete(t);
    }
    ul(t) {
        this.onlineState = t;
        let e = !1;
        this.vl.forEach((s, i) => {
            for (const s of i.bl) 
            // Run global snapshot listeners if a consistent snapshot has been emitted.
            s.Dc(t) && (e = !0);
        }), e && this.Dl();
    }
    Fl(t) {
        this.Sl.add(t), 
        // Immediately fire an initial event, indicating all existing listeners
        // are in-sync.
        t.next();
    }
    Nl(t) {
        this.Sl.delete(t);
    }
    // Call all global snapshot listeners that have been set.
    Dl() {
        this.Sl.forEach(t => {
            t.next();
        });
    }
}

/**
 * QueryListener takes a series of internal view snapshots and determines
 * when to raise the event.
 *
 * It uses an Observer to dispatch events.
 */ class ai {
    constructor(t, e, s) {
        this.query = t, this.kl = e, 
        /**
         * Initial snapshots (e.g. from cache) may not be propagated to the wrapped
         * observer. This flag is set to true once we've actually raised an event.
         */
        this.Ll = !1, this.$l = null, this.onlineState = "Unknown" /* Unknown */ , this.options = s || {};
    }
    /**
     * Applies the new ViewSnapshot to this listener, raising a user-facing event
     * if applicable (depending on what changed, whether the user has opted into
     * metadata-only changes, etc.). Returns true if a user-facing event was
     * indeed raised.
     */    Cl(t) {
        if (!this.options.includeMetadataChanges) {
            // Remove the metadata only changes.
            const e = [];
            for (const s of t.docChanges) 3 /* Metadata */ !== s.type && e.push(s);
            t = new oe(t.query, t.docs, t.cs, e, t.ls, t.fromCache, t._s, 
            /* excludesMetadataChanges= */ !0);
        }
        let e = !1;
        return this.Ll ? this.Ol(t) && (this.kl.next(t), e = !0) : this.Ml(t, this.onlineState) && (this.Ul(t), 
        e = !0), this.$l = t, e;
    }
    onError(t) {
        this.kl.error(t);
    }
    /** Returns whether a snapshot was raised. */    Dc(t) {
        this.onlineState = t;
        let e = !1;
        return this.$l && !this.Ll && this.Ml(this.$l, t) && (this.Ul(this.$l), e = !0), 
        e;
    }
    Ml(t, e) {
        // Always raise the first event when we're synced
        if (!t.fromCache) return !0;
        // NOTE: We consider OnlineState.Unknown as online (it should become Offline
        // or Online if we wait long enough).
                const s = "Offline" /* Offline */ !== e;
        // Don't raise the event if we're online, aren't synced yet (checked
        // above) and are waiting for a sync.
                return (!this.options.ql || !s) && (!t.docs.q() || "Offline" /* Offline */ === e);
        // Raise data from cache if we have any documents or we are offline
        }
    Ol(t) {
        // We don't need to handle includeDocumentMetadataChanges here because
        // the Metadata only changes have already been stripped out if needed.
        // At this point the only changes we will see are the ones we should
        // propagate.
        if (t.docChanges.length > 0) return !0;
        const e = this.$l && this.$l.hasPendingWrites !== t.hasPendingWrites;
        return !(!t._s && !e) && !0 === this.options.includeMetadataChanges;
        // Generally we should have hit one of the cases above, but it's possible
        // to get here if there were only metadata docChanges and they got
        // stripped out.
        }
    Ul(t) {
        t = oe.fs(t.query, t.docs, t.ls, t.fromCache), this.Ll = !0, this.kl.next(t);
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// TOOD(b/140938512): Drop SimpleQueryEngine and rename IndexFreeQueryEngine.
/**
 * A query engine that takes advantage of the target document mapping in the
 * QueryCache. The IndexFreeQueryEngine optimizes query execution by only
 * reading the documents that previously matched a query plus any documents that were
 * edited after the query was last listened to.
 *
 * There are some cases where Index-Free queries are not guaranteed to produce
 * the same results as full collection scans. In these cases, the
 * IndexFreeQueryEngine falls back to full query processing. These cases are:
 *
 * - Limit queries where a document that matched the query previously no longer
 *   matches the query.
 *
 * - Limit queries where a document edit may cause the document to sort below
 *   another document that is in the local cache.
 *
 * - Queries that have never been CURRENT or free of Limbo documents.
 */ class ui {
    Ah(t) {
        this.Bl = t;
    }
    rr(t, e, i, n) {
        // Queries that match all documents don't benefit from using
        // IndexFreeQueries. It is more efficient to scan all documents in a
        // collection, rather than to perform individual lookups.
        return e.Me() || i.isEqual(g.MIN) ? this.xl(t, e) : this.Bl.sr(t, n).next(r => {
            const h = this.Ql(e, r);
            return (e.je() || e.Ge()) && this.yc(e.pe, h, n, i) ? this.xl(t, e) : (Ve() <= s.DEBUG && ge("IndexFreeQueryEngine", "Re-using previous result from %s to execute query: %s", i.toString(), e.toString()), 
            this.Bl.rr(t, e, i).next(t => (
            // We merge `previousResults` into `updateResults`, since
            // `updateResults` is already a DocumentMap. If a document is
            // contained in both lists, then its contents are the same.
            h.forEach(e => {
                t = t.nt(e.key, e);
            }), t)));
        });
        // Queries that have never seen a snapshot without limbo free documents
        // should also be run as a full collection scan.
        }
    /** Applies the query filter and sorting to the provided documents.  */    Ql(t, e) {
        // Sort the documents and re-apply the query filter since previously
        // matching documents do not necessarily still match the query.
        let s = new k((e, s) => t.qe(e, s));
        return e.forEach((e, i) => {
            i instanceof gt && t.matches(i) && (s = s.add(i));
        }), s;
    }
    /**
     * Determines if a limit query needs to be refilled from cache, making it
     * ineligible for index-free execution.
     *
     * @param sortedPreviousResults The documents that matched the query when it
     * was last synchronized, sorted by the query's comparator.
     * @param remoteKeys The document keys that matched the query at the last
     * snapshot.
     * @param limboFreeSnapshotVersion The version of the snapshot when the query
     * was last synchronized.
     */    yc(t, e, s, i) {
        // The query needs to be refilled if a previously matching document no
        // longer matches.
        if (s.size !== e.size) return !0;
        // Limit queries are not eligible for index-free query execution if there is
        // a potential that an older document from cache now sorts before a document
        // that was previously part of the limit. This, however, can only happen if
        // the document at the edge of the limit goes out of limit.
        // If a document that is not the limit boundary sorts differently,
        // the boundary of the limit itself did not change and documents from cache
        // will continue to be "rejected" by this boundary. Therefore, we can ignore
        // any modifications that don't affect the last document.
                const n = "F" /* First */ === t ? e.last() : e.first();
        return !!n && (n.hasPendingWrites || n.version.C(i) > 0);
    }
    xl(t, e) {
        return Ve() <= s.DEBUG && ge("IndexFreeQueryEngine", "Using full collection scan to execute query: %s", e.toString()), 
        this.Bl.rr(t, e, g.MIN);
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * An in-memory implementation of IndexManager.
 */ class ci {
    constructor() {
        this.Wl = new li;
    }
    jl(t, e) {
        return this.Wl.add(e), qe.resolve();
    }
    ur(t, e) {
        return qe.resolve(this.Wl.getEntries(e));
    }
}

/**
 * Internal implementation of the collection-parent index exposed by MemoryIndexManager.
 * Also used for in-memory caching by IndexedDbIndexManager and initial index population
 * in indexeddb_schema.ts
 */ class li {
    constructor() {
        this.index = {};
    }
    // Returns false if the entry already existed.
    add(t) {
        const e = t.U(), s = t.O(), i = this.index[e] || new k(b.k), n = !i.has(s);
        return this.index[e] = i.add(s), n;
    }
    has(t) {
        const e = t.U(), s = t.O(), i = this.index[e];
        return i && i.has(s);
    }
    getEntries(t) {
        return (this.index[t] || new k(b.k)).j();
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class _i {
    constructor(t, e) {
        this.Jn = t, this.dh = e, 
        /**
         * The set of all mutations that have been sent but not yet been applied to
         * the backend.
         */
        this.Hn = [], 
        /** Next value to use when assigning sequential IDs to each mutation batch. */
        this.Gl = 1, 
        /** The last received stream token from the server, used to acknowledge which
         * responses the client has processed. Stream tokens are opaque checkpoint
         * markers whose only real value is their inclusion in the next request.
         */
        this.lastStreamToken = U.Ut, 
        /** An ordered mapping between documents and the mutations batch IDs. */
        this.zl = new k(Ue.me);
    }
    Kl(t) {
        return qe.resolve(0 === this.Hn.length);
    }
    Nh(t, e, s) {
        const i = e.batchId, n = this.Hl(i, "acknowledged");
        Se(0 === n, "Can only acknowledge the first batch in the mutation queue");
        // Verify that the batch in the queue is the one to be acknowledged.
        this.Hn[n];
        return this.lastStreamToken = s, qe.resolve();
    }
    xh(t) {
        return qe.resolve(this.lastStreamToken);
    }
    Qh(t, e) {
        return this.lastStreamToken = e, qe.resolve();
    }
    Sh(t, e, s, i) {
        const n = this.Gl;
        if (this.Gl++, this.Hn.length > 0) {
            this.Hn[this.Hn.length - 1];
        }
        const r = new $e(n, e, s, i);
        this.Hn.push(r);
        // Track references by document key and index collection parents.
        for (const e of i) this.zl = this.zl.add(new Ue(e.key, n)), this.Jn.jl(t, e.key.path.O());
        return qe.resolve(r);
    }
    Uh(t, e) {
        return qe.resolve(this.Jl(e));
    }
    Fh(t, e) {
        const s = this.Jl(e);
        return qe.resolve(s.keys());
    }
    no(t, e) {
        const s = e + 1, i = this.Yl(s), n = i < 0 ? 0 : i;
        // The requested batchId may still be out of range so normalize it to the
        // start of the queue.
                return qe.resolve(this.Hn.length > n ? this.Hn[n] : null);
    }
    Bh() {
        return qe.resolve(0 === this.Hn.length ? -1 : this.Gl - 1);
    }
    ph(t) {
        return qe.resolve(this.Hn.slice());
    }
    Xn(t, e) {
        const s = new Ue(e, 0), i = new Ue(e, Number.POSITIVE_INFINITY), n = [];
        return this.zl.Dt([ s, i ], t => {
            const e = this.Jl(t.On);
            n.push(e);
        }), qe.resolve(n);
    }
    nr(t, e) {
        let s = new k(De);
        return e.forEach(t => {
            const e = new Ue(t, 0), i = new Ue(t, Number.POSITIVE_INFINITY);
            this.zl.Dt([ e, i ], t => {
                s = s.add(t.On);
            });
        }), qe.resolve(this.Xl(s));
    }
    cr(t, e) {
        // Use the query path as a prefix for testing if a document matches the
        // query.
        const s = e.path, i = s.length + 1;
        // Construct a document reference for actually scanning the index. Unlike
        // the prefix the document key in this reference must have an even number of
        // segments. The empty segment can be used a suffix of the query path
        // because it precedes all other segments in an ordered traversal.
        let n = s;
        C.st(n) || (n = n.child(""));
        const r = new Ue(new C(n), 0);
        // Find unique batchIDs referenced by all documents potentially matching the
        // query.
                let h = new k(De);
        return this.zl.Ft(t => {
            const e = t.key.path;
            return !!s.B(e) && (
            // Rows with document keys more than one segment longer than the query
            // path can't be matches. For example, a query on 'rooms' can't match
            // the document /rooms/abc/messages/xyx.
            // TODO(mcg): we'll need a different scanner when we implement
            // ancestor queries.
            e.length === i && (h = h.add(t.On)), !0);
        }, r), qe.resolve(this.Xl(h));
    }
    Xl(t) {
        // Construct an array of matching batches, sorted by batchID to ensure that
        // multiple mutations affecting the same document key are applied in order.
        const e = [];
        return t.forEach(t => {
            const s = this.Jl(t);
            null !== s && e.push(s);
        }), e;
    }
    qh(t, e) {
        Se(0 === this.Hl(e.batchId, "removed"), "Can only remove the first entry of the mutation queue"), 
        this.Hn.shift();
        let s = this.zl;
        return qe.forEach(e.mutations, i => {
            const n = new Ue(i.key, e.batchId);
            return s = s.delete(n), this.dh.Zl(t, i.key);
        }).next(() => {
            this.zl = s;
        });
    }
    mo(t) {
        // No-op since the memory mutation queue does not maintain a separate cache.
    }
    $n(t, e) {
        const s = new Ue(e, 0), i = this.zl.Nt(s);
        return qe.resolve(e.isEqual(i && i.key));
    }
    Oh(t) {
        return this.Hn.length, qe.resolve();
    }
    /**
     * Finds the index of the given batchId in the mutation queue and asserts that
     * the resulting index is within the bounds of the queue.
     *
     * @param batchId The batchId to search for
     * @param action A description of what the caller is doing, phrased in passive
     * form (e.g. "acknowledged" in a routine that acknowledges batches).
     */    Hl(t, e) {
        return this.Yl(t);
    }
    /**
     * Finds the index of the given batchId in the mutation queue. This operation
     * is O(1).
     *
     * @return The computed index of the batch with the given batchId, based on
     * the state of the queue. Note this index can be negative if the requested
     * batchId has already been remvoed from the queue or past the end of the
     * queue if the batchId is larger than the last added batch.
     */    Yl(t) {
        if (0 === this.Hn.length) 
        // As an index this is past the end of the queue
        return 0;
        // Examine the front of the queue to figure out the difference between the
        // batchId and indexes in the array. Note that since the queue is ordered
        // by batchId, if the first batch has a larger batchId then the requested
        // batchId doesn't exist in the queue.
                return t - this.Hn[0].batchId;
    }
    /**
     * A version of lookupMutationBatch that doesn't return a promise, this makes
     * other functions that uses this code easier to read and more efficent.
     */    Jl(t) {
        const e = this.Yl(t);
        return e < 0 || e >= this.Hn.length ? null : this.Hn[e];
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ class di {
    /**
     * @param sizer Used to assess the size of a document. For eager GC, this is expected to just
     * return 0 to avoid unnecessarily doing the work of calculating the size.
     */
    constructor(t, e) {
        this.Jn = t, this.t_ = e, 
        /** Underlying cache of documents and their read times. */
        this.docs = new D(C.k), 
        /** Size of all cached documents. */
        this.size = 0;
    }
    /**
     * Adds the supplied entry to the cache and updates the cache size as appropriate.
     *
     * All calls of `addEntry`  are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Xh(t, e, s) {
        const i = e.key, n = this.docs.get(i), r = n ? n.size : 0, h = this.t_(e);
        return this.docs = this.docs.nt(i, {
            e_: e,
            size: h,
            readTime: s
        }), this.size += h - r, this.Jn.jl(t, i.path.O());
    }
    /**
     * Removes the specified entry from the cache and updates the cache size as appropriate.
     *
     * All calls of `removeEntry` are required to go through the RemoteDocumentChangeBuffer
     * returned by `newChangeBuffer()`.
     */    Yh(t) {
        const e = this.docs.get(t);
        e && (this.docs = this.docs.remove(t), this.size -= e.size);
    }
    tr(t, e) {
        const s = this.docs.get(e);
        return qe.resolve(s ? s.e_ : null);
    }
    getEntries(t, e) {
        let s = Jt();
        return e.forEach(t => {
            const e = this.docs.get(t);
            s = s.nt(t, e ? e.e_ : null);
        }), qe.resolve(s);
    }
    rr(t, e, s) {
        let i = Xt();
        // Documents are ordered by key, so we can use a prefix scan to narrow down
        // the documents we need to match the query against.
                const n = new C(e.path.child("")), r = this.docs._t(n);
        for (;r.Rt(); ) {
            const {key: t, value: {e_: n, readTime: h}} = r.Et();
            if (!e.path.B(t.path)) break;
            h.C(s) <= 0 || n instanceof gt && e.matches(n) && (i = i.nt(n.key, n));
        }
        return qe.resolve(i);
    }
    s_(t, e) {
        return qe.forEach(this.docs, t => e(t));
    }
    Po(t, e) {
        throw new Error("getNewDocumentChanges() is not supported with MemoryPersistence");
    }
    po(t) {
        return qe.resolve(g.MIN);
    }
    kh(t) {
        // `trackRemovals` is ignores since the MemoryRemoteDocumentCache keeps
        // a separate changelog and does not need special handling for removals.
        return new di.i_(this);
    }
    n_(t) {
        return qe.resolve(this.size);
    }
}

/**
 * Handles the details of adding and updating documents in the MemoryRemoteDocumentCache.
 */ di.i_ = class extends class {
    constructor() {
        // A mapping of document key to the new cache entry that should be written (or null if any
        // existing cache entry should be removed).
        this.Ch = new Le(t => t.toString()), this.r_ = !1;
    }
    set readTime(t) {
        this.h_ = t;
    }
    get readTime() {
        return this.h_;
    }
    /**
     * Buffers a `RemoteDocumentCache.addEntry()` call.
     *
     * You can only modify documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Xh(t, e) {
        this.o_(), this.readTime = e, this.Ch.set(t.key, t);
    }
    /**
     * Buffers a `RemoteDocumentCache.removeEntry()` call.
     *
     * You can only remove documents that have already been retrieved via
     * `getEntry()/getEntries()` (enforced via IndexedDbs `apply()`).
     */    Yh(t, e) {
        this.o_(), e && (this.readTime = e), this.Ch.set(t, null);
    }
    /**
     * Looks up an entry in the cache. The buffered changes will first be checked,
     * and if no buffered change applies, this will forward to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKey The key of the entry to look up.
     * @return The cached Document or NoDocument entry, or null if we have nothing
     * cached.
     */    tr(t, e) {
        this.o_();
        const s = this.Ch.get(e);
        return void 0 !== s ? qe.resolve(s) : this.a_(t, e);
    }
    /**
     * Looks up several entries in the cache, forwarding to
     * `RemoteDocumentCache.getEntry()`.
     *
     * @param transaction The transaction in which to perform any persistence
     *     operations.
     * @param documentKeys The keys of the entries to look up.
     * @return A map of cached `Document`s or `NoDocument`s, indexed by key. If an
     *     entry cannot be found, the corresponding key will be mapped to a null
     *     value.
     */    getEntries(t, e) {
        return this.u_(t, e);
    }
    /**
     * Applies buffered changes to the underlying RemoteDocumentCache, using
     * the provided transaction.
     */    apply(t) {
        return this.o_(), this.r_ = !0, this.bc(t);
    }
    /** Helper to assert this.changes is not null  */    o_() {}
}
/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ {
    constructor(t) {
        super(), this.c_ = t;
    }
    bc(t) {
        const e = [];
        return this.Ch.forEach((s, i) => {
            i ? e.push(this.c_.Xh(t, i, this.readTime)) : this.c_.Yh(s);
        }), qe.Gn(e);
    }
    a_(t, e) {
        return this.c_.tr(t, e);
    }
    u_(t, e) {
        return this.c_.getEntries(t, e);
    }
};

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class fi {
    constructor(t) {
        this.persistence = t, 
        /**
         * Maps a target to the data about that target
         */
        this.l_ = new Le(t => t.canonicalId()), 
        /** The last received snapshot version. */
        this.lastRemoteSnapshotVersion = g.MIN, 
        /** The highest numbered target ID encountered. */
        this.highestTargetId = 0, 
        /** The highest sequence number encountered. */
        this.__ = 0, 
        /**
         * A ordered bidirectional mapping between documents and the remote target
         * IDs.
         */
        this.d_ = new Me, this.targetCount = 0, this.f_ = Xs.Tc();
    }
    Xs(t, e) {
        return this.l_.forEach((t, s) => e(s)), qe.resolve();
    }
    Wh(t) {
        return qe.resolve(this.lastRemoteSnapshotVersion);
    }
    w_(t) {
        return qe.resolve(this.__);
    }
    ao(t) {
        return this.highestTargetId = this.f_.next(), qe.resolve(this.highestTargetId);
    }
    to(t, e, s) {
        return s && (this.lastRemoteSnapshotVersion = s), e > this.__ && (this.__ = e), 
        qe.resolve();
    }
    T_(t) {
        this.l_.set(t.target, t);
        const e = t.targetId;
        e > this.highestTargetId && (this.f_ = new Xs(e), this.highestTargetId = e), t.sequenceNumber > this.__ && (this.__ = t.sequenceNumber);
    }
    uo(t, e) {
        return this.T_(e), this.targetCount += 1, qe.resolve();
    }
    Jh(t, e) {
        return this.T_(e), qe.resolve();
    }
    m_(t, e) {
        return this.l_.delete(e.target), this.d_.Nn(e.targetId), this.targetCount -= 1, 
        qe.resolve();
    }
    E_(t, e, s) {
        let i = 0;
        const n = [];
        return this.l_.forEach((r, h) => {
            h.sequenceNumber <= e && null === s.get(h.targetId) && (this.l_.delete(r), n.push(this.R_(t, h.targetId)), 
            i++);
        }), qe.Gn(n).next(() => i);
    }
    I_(t) {
        return qe.resolve(this.targetCount);
    }
    oo(t, e) {
        const s = this.l_.get(e) || null;
        return qe.resolve(s);
    }
    ui(t, e) {
        // This method is only needed for multi-tab and we can't implement it
        // efficiently without additional data structures.
        return ve("Not yet implemented.");
    }
    zh(t, e, s) {
        this.d_.Sn(e, s);
        const i = this.persistence.dh, n = [];
        return i && e.forEach(e => {
            n.push(i.vn(t, e));
        }), qe.Gn(n);
    }
    Gh(t, e, s) {
        this.d_.Fn(e, s);
        const i = this.persistence.dh, n = [];
        return i && e.forEach(e => {
            n.push(i.Cn(t, e));
        }), qe.Gn(n);
    }
    R_(t, e) {
        return this.d_.Nn(e), qe.resolve();
    }
    _o(t, e) {
        const s = this.d_.Ln(e);
        return qe.resolve(s);
    }
    $n(t, e) {
        return qe.resolve(this.d_.$n(e));
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * A memory-backed instance of Persistence. Data is stored only in RAM and
 * not persisted across sessions.
 */
class wi {
    /**
     * The constructor accepts a factory for creating a reference delegate. This
     * allows both the delegate and this instance to have strong references to
     * each other without having nullable fields that would then need to be
     * checked or asserted on every access.
     */
    constructor(t, e) {
        this.clientId = t, this.A_ = {}, this.P_ = new Qe(0), this.V_ = !1, this.V_ = !0, 
        this.dh = e(this), this.mh = new fi(this);
        this.Jn = new ci, this.Kn = new di(this.Jn, t => this.dh.p_(t));
    }
    start() {
        return Promise.resolve();
    }
    ku() {
        // No durable state to ensure is closed on shutdown.
        return this.V_ = !1, Promise.resolve();
    }
    get g_() {
        return this.V_;
    }
    async wo() {
        return [ this.clientId ];
    }
    y_(t) {
        // All clients using memory persistence act as primary.
        return t(!0);
    }
    b_() {
        // No op.
    }
    Eo(t) {
        // No op.
    }
    Ih() {
        return this.Jn;
    }
    fh(t) {
        let e = this.A_[t.s()];
        return e || (e = new _i(this.Jn, this.dh), this.A_[t.s()] = e), e;
    }
    Eh() {
        return this.mh;
    }
    Th() {
        return this.Kn;
    }
    runTransaction(t, e, s) {
        ge("MemoryPersistence", "Starting transaction:", t);
        const i = new Ti(this.P_.next());
        return this.dh.v_(), s(i).next(t => this.dh.S_(i).next(() => t)).Wn().then(t => (i.C_(), 
        t));
    }
    D_(t, e) {
        return qe.zn(Object.values(this.A_).map(s => () => s.$n(t, e)));
    }
}

/**
 * Memory persistence is not actually transactional, but future implementations
 * may have transaction-scoped state.
 */ class Ti extends 
/**
 * A base class representing a persistence transaction, encapsulating both the
 * transaction's sequence numbers as well as a list of onCommitted listeners.
 *
 * When you call Persistence.runTransaction(), it will create a transaction and
 * pass it to your callback. You then pass it to any method that operates
 * on persistence.
 */
class {
    constructor() {
        this.F_ = [];
    }
    N_(t) {
        this.F_.push(t);
    }
    C_() {
        this.F_.forEach(t => t());
    }
} {
    constructor(t) {
        super(), this.Kh = t;
    }
}

class mi {
    constructor(t) {
        this.persistence = t, this.k_ = null, this.L_ = null;
    }
    static O_(t) {
        return new mi(t);
    }
    get M_() {
        if (this.L_) return this.L_;
        throw ve("orphanedDocuments is only valid during a transaction.");
    }
    _h(t) {
        this.k_ = t;
    }
    vn(t, e) {
        return this.M_.delete(e), qe.resolve();
    }
    Cn(t, e) {
        return this.M_.add(e), qe.resolve();
    }
    Zl(t, e) {
        return this.M_.add(e), qe.resolve();
    }
    removeTarget(t, e) {
        const s = this.persistence.Eh();
        return s._o(t, e.targetId).next(t => {
            t.forEach(t => this.M_.add(t));
        }).next(() => s.m_(t, e));
    }
    v_() {
        this.L_ = new Set;
    }
    S_(t) {
        // Remove newly orphaned documents.
        const e = this.persistence.Th().kh();
        return qe.forEach(this.M_, s => this.U_(t, s).next(t => {
            t || e.Yh(s);
        })).next(() => (this.L_ = null, e.apply(t)));
    }
    Zh(t, e) {
        return this.U_(t, e).next(t => {
            t ? this.M_.delete(e) : this.M_.add(e);
        });
    }
    p_(t) {
        // For eager GC, we don't care about the document size, there are no size thresholds.
        return 0;
    }
    U_(t, e) {
        return qe.zn([ () => this.persistence.Eh().$n(t, e), () => this.persistence.D_(t, e), () => qe.resolve(this.k_.$n(e)) ]);
    }
}

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides all components needed for Firestore with in-memory persistence.
 * Uses EagerGC garbage collection.
 */
class Ei {
    async initialize(t) {
        this.Qc = this.q_(t), this.persistence = this.B_(t), await this.persistence.start(), 
        this.x_ = this.Q_(t), this._u = this.W_(t), this.Lc = this.j_(t), this.Mu = this.G_(t), 
        this.z_ = this.K_(t), this.Qc.iu = t => this.Mu.Dc(t, 1 /* SharedClientState */), 
        this.Lc.Mu = this.Mu, this.Qc.Mu = this.Mu, await this.Qc.start(), await this.Lc.start(), 
        await this._u.start(), 
        // NOTE: This will immediately call the listener, so we make sure to
        // set it after localStore / remoteStore are started.
        await this.persistence.y_(async t => {
            await this.Mu.Zu(t), this.x_ && (t && !this.x_.g_ ? this.x_.start(this._u) : t || this.x_.stop());
        });
    }
    K_(t) {
        return new oi(this.Mu);
    }
    Q_(t) {
        return null;
    }
    W_(t) {
        return new Ke(this.persistence, new ui, t.H_);
    }
    B_(t) {
        return new wi(t.clientId, mi.O_);
    }
    j_(t) {
        return new Hs(this._u, t.Ha, t.Ar, t => this.Mu.Dc(t, 0 /* RemoteStore */), t.platform.J_());
    }
    q_(t) {
        return new Ys;
    }
    G_(t) {
        return new ri(this._u, this.Lc, this.Qc, t.H_, t.Wc);
    }
    clearPersistence(t) {
        throw new E(m.FAILED_PRECONDITION, "You are using the memory-only build of Firestore. Persistence support is only available via the @firebase/firestore bundle or the firebase-firestore.js build.");
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * FirestoreClient is a top-level class that constructs and owns all of the
 * pieces of the client SDK architecture. It is responsible for creating the
 * async queue that is shared by all of the other components in the system.
 */
class Ri {
    constructor(t, e, s, 
    /**
     * Asynchronous queue responsible for all of our internal processing. When
     * we get incoming work from the user (via public API) or the network
     * (incoming GRPC messages), we should always schedule onto this queue.
     * This ensures all of our work is properly serialized (e.g. we don't
     * start processing a new operation while the previous one is waiting for
     * an async I/O to complete).
     */
    i) {
        this.platform = t, this.Y_ = e, this.credentials = s, this.Ar = i, this.clientId = Ce.Tn();
    }
    /**
     * Starts up the FirestoreClient, returning only whether or not enabling
     * persistence succeeded.
     *
     * The intent here is to "do the right thing" as far as users are concerned.
     * Namely, in cases where offline persistence is requested and possible,
     * enable it, but otherwise fall back to persistence disabled. For the most
     * part we expect this to succeed one way or the other so we don't expect our
     * users to actually wait on the firestore.enablePersistence Promise since
     * they generally won't care.
     *
     * Of course some users actually do care about whether or not persistence
     * was successfully enabled, so the Promise returned from this method
     * indicates this outcome.
     *
     * This presents a problem though: even before enablePersistence resolves or
     * rejects, users may have made calls to e.g. firestore.collection() which
     * means that the FirestoreClient in there will be available and will be
     * enqueuing actions on the async queue.
     *
     * Meanwhile any failure of an operation on the async queue causes it to
     * panic and reject any further work, on the premise that unhandled errors
     * are fatal.
     *
     * Consequently the fallback is handled internally here in start, and if the
     * fallback succeeds we signal success to the async queue even though the
     * start() itself signals failure.
     *
     * @param componentProvider Provider that returns all core components.
     * @param persistenceSettings Settings object to configure offline
     *     persistence.
     * @returns A deferred result indicating the user-visible result of enabling
     *     offline persistence. This method will reject this if IndexedDB fails to
     *     start for any reason. If usePersistence is false this is
     *     unconditionally resolved.
     */    start(t, e) {
        this.X_();
        // We defer our initialization until we get the current user from
        // setChangeListener(). We block the async queue until we got the initial
        // user and the initialization is completed. This will prevent any scheduled
        // work from happening before initialization is completed.
        // If initializationDone resolved then the FirestoreClient is in a usable
        // state.
        const s = new We, i = new We;
        // If usePersistence is true, certain classes of errors while starting are
        // recoverable but only by falling back to persistence disabled.
        
        // If there's an error in the first case but not in recovery we cannot
        // reject the promise blocking the async queue because this will cause the
        // async queue to panic.
                let n = !1;
        // Return only the result of enabling persistence. Note that this does not
        // need to await the completion of initializationDone because the result of
        // this method should not reflect any other kind of failure to start.
        return this.credentials._(r => {
            if (!n) return n = !0, ge("FirestoreClient", "Initializing. user=", r.uid), this.Z_(t, e, r, i).then(s.resolve, s.reject);
            this.Ar.Cr(() => this.Xu(r));
        }), 
        // Block the async queue until initialization is done
        this.Ar.Cr(() => s.promise), i.promise;
    }
    /** Enables the network connection and requeues all pending operations. */    enableNetwork() {
        return this.X_(), this.Ar.enqueue(() => this.Mu.enableNetwork());
    }
    /**
     * Initializes persistent storage, attempting to use IndexedDB if
     * usePersistence is true or memory-only if false.
     *
     * If IndexedDB fails because it's already open in another tab or because the
     * platform can't possibly support our implementation then this method rejects
     * the persistenceResult and falls back on memory-only persistence.
     *
     * @param componentProvider The provider that provides all core componennts
     *     for IndexedDB or memory-backed persistence
     * @param persistenceSettings Settings object to configure offline persistence
     * @param user The initial user
     * @param persistenceResult A deferred result indicating the user-visible
     *     result of enabling offline persistence. This method will reject this if
     *     IndexedDB fails to start for any reason. If usePersistence is false
     *     this is unconditionally resolved.
     * @returns a Promise indicating whether or not initialization should
     *     continue, i.e. that one of the persistence implementations actually
     *     succeeded.
     */    async Z_(t, e, s, i) {
        try {
            // TODO(mrschmidt): Ideally, ComponentProvider would also initialize
            // Datastore (without duplicating the initializing logic once per
            // provider).
            const n = await this.platform.td(this.Y_), r = this.platform.ed(this.Y_.ci), h = new Gs(this.Ar, n, this.credentials, r);
            await t.initialize({
                Ar: this.Ar,
                Y_: this.Y_,
                platform: this.platform,
                Ha: h,
                clientId: this.clientId,
                H_: s,
                Wc: 100,
                sd: e
            }), this.persistence = t.persistence, this.Qc = t.Qc, this._u = t._u, this.Lc = t.Lc, 
            this.Mu = t.Mu, this.x_ = t.x_, this.nd = t.z_, 
            // When a user calls clearPersistence() in one client, all other clients
            // need to be terminated to allow the delete to succeed.
            this.persistence.b_(async () => {
                await this.terminate();
            }), i.resolve();
        } catch (t) {
            // An unknown failure on the first stage shuts everything down.
            if (
            // Regardless of whether or not the retry succeeds, from an user
            // perspective, offline persistence has failed.
            i.reject(t), !this.rd(t)) throw t;
            return console.warn("Error enabling offline persistence. Falling back to persistence disabled: " + t), 
            this.Z_(new Ei, {
                hd: !1
            }, s, i);
        }
    }
    /**
     * Decides whether the provided error allows us to gracefully disable
     * persistence (as opposed to crashing the client).
     */    rd(t) {
        return "FirebaseError" === t.name ? t.code === m.FAILED_PRECONDITION || t.code === m.UNIMPLEMENTED : !("undefined" != typeof DOMException && t instanceof DOMException) || (
        // When the browser is out of quota we could get either quota exceeded
        // or an aborted error depending on whether the error happened during
        // schema migration.
        22 === t.code || 20 === t.code || 
        // Firefox Private Browsing mode disables IndexedDb and returns
        // INVALID_STATE for any usage.
        11 === t.code);
    }
    /**
     * Checks that the client has not been terminated. Ensures that other methods on
     * this class cannot be called after the client is terminated.
     */    X_() {
        if (this.Ar.Or) throw new E(m.FAILED_PRECONDITION, "The client has already been terminated.");
    }
    Xu(t) {
        return this.Ar.jr(), ge("FirestoreClient", "Credential Changed. Current user: " + t.uid), 
        this.Mu.Xu(t);
    }
    /** Disables the network connection. Pending operations will not complete. */    disableNetwork() {
        return this.X_(), this.Ar.enqueue(() => this.Mu.disableNetwork());
    }
    terminate() {
        return this.Ar.xr(async () => {
            // PORTING NOTE: LocalStore does not need an explicit shutdown on web.
            this.x_ && this.x_.stop(), await this.Lc.ku(), await this.Qc.ku(), await this.persistence.ku(), 
            // `removeChangeListener` must be called after shutting down the
            // RemoteStore as it will prevent the RemoteStore from retrieving
            // auth tokens.
            this.credentials.T();
        });
    }
    /**
     * Returns a Promise that resolves when all writes that were pending at the time this
     * method was called received server acknowledgement. An acknowledgement can be either acceptance
     * or rejection.
     */    waitForPendingWrites() {
        this.X_();
        const t = new We;
        return this.Ar.Cr(() => this.Mu.fl(t)), t.promise;
    }
    listen(t, e, s) {
        this.X_();
        const i = new ai(t, e, s);
        return this.Ar.Cr(() => this.nd.listen(i)), i;
    }
    $u(t) {
        // Checks for termination but does not raise error, allowing unlisten after
        // termination to be a no-op.
        this.od || this.Ar.Cr(() => this.nd.$u(t));
    }
    ad(t) {
        return this.X_(), this.Ar.enqueue(() => this._u.ro(t)).then(t => {
            if (t instanceof gt) return t;
            if (t instanceof yt) return null;
            throw new E(m.UNAVAILABLE, "Failed to get document from cache. (However, this document may exist on the server. Run again without setting 'source' in the GetOptions to attempt to retrieve the document from the server.)");
        });
    }
    ud(t) {
        return this.X_(), this.Ar.enqueue(async () => {
            const e = await this._u.lo(t, 
            /* usePreviousResults= */ !0), s = new ei(t, e.do), i = s.Vc(e.documents);
            return s.bc(i, 
            /* updateLimboDocuments= */ !1).snapshot;
        });
    }
    write(t) {
        this.X_();
        const e = new We;
        return this.Ar.Cr(() => this.Mu.write(t, e)), e.promise;
    }
    ci() {
        return this.Y_.ci;
    }
    Fl(t) {
        this.X_(), this.Ar.Cr(() => (this.nd.Fl(t), Promise.resolve()));
    }
    Nl(t) {
        // Checks for shutdown but does not raise error, allowing remove after
        // shutdown to be a no-op.
        this.od || this.nd.Nl(t);
    }
    get od() {
        // Technically, the asyncQueue is still running, but only accepting operations
        // related to termination or supposed to be run after termination. It is effectively
        // terminated to the eyes of users.
        return this.Ar.Or;
    }
    transaction(t) {
        this.X_();
        const e = new We;
        return this.Ar.Cr(() => (this.Mu.runTransaction(this.Ar, t, e), Promise.resolve())), 
        e.promise;
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * A wrapper implementation of Observer<T> that will dispatch events
 * asynchronously. To allow immediate silencing, a mute call is added which
 * causes events scheduled to no longer be raised.
 */ class Ii {
    constructor(t) {
        this.observer = t, 
        /**
         * When set to true, will not raise future events. Necessary to deal with
         * async detachment of listener.
         */
        this.muted = !1;
    }
    next(t) {
        this.ld(this.observer.next, t);
    }
    error(t) {
        this.ld(this.observer.error, t);
    }
    _d() {
        this.muted = !0;
    }
    ld(t, e) {
        this.muted || setTimeout(() => {
            this.muted || t(e);
        }, 0);
    }
}

/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ function Ai(t) {
    /**
 * Returns true if obj is an object and contains at least one of the specified
 * methods.
 */
    return function(t, e) {
        if ("object" != typeof t || null === t) return !1;
        const s = t;
        for (const t of e) if (t in s && "function" == typeof s[t]) return !0;
        return !1;
    }
    /**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
    /**
 * Converts Firestore's internal types to the JavaScript types that we expose
 * to the user.
 */ (t, [ "next", "error", "complete" ]);
}

class Pi {
    constructor(t, e, s, i) {
        this.firestore = t, this.timestampsInSnapshots = e, this.dd = s, this.converter = i;
    }
    fd(t) {
        switch (j(t)) {
          case 0 /* NullValue */ :
            return null;

          case 1 /* BooleanValue */ :
            return t.booleanValue;

          case 2 /* NumberValue */ :
            return Z(t.integerValue || t.doubleValue);

          case 3 /* TimestampValue */ :
            return this.wd(t.timestampValue);

          case 4 /* ServerTimestampValue */ :
            return this.Td(t);

          case 5 /* StringValue */ :
            return t.stringValue;

          case 6 /* BlobValue */ :
            return new Es(tt(t.bytesValue));

          case 7 /* RefValue */ :
            return this.md(t.referenceValue);

          case 8 /* GeoPointValue */ :
            return new Ss(t.geoPointValue.latitude, t.geoPointValue.longitude);

          case 9 /* ArrayValue */ :
            return this.Ed(t.arrayValue);

          case 10 /* ObjectValue */ :
            return this.Rd(t.mapValue);

          default:
            throw ve("Invalid value type: " + JSON.stringify(t));
        }
    }
    Rd(t) {
        const e = {};
        return O(t.fields || {}, (t, s) => {
            e[t] = this.fd(s);
        }), e;
    }
    Ed(t) {
        return (t.values || []).map(t => this.fd(t));
    }
    Td(t) {
        switch (this.dd) {
          case "previous":
            const e = function t(e) {
                const s = e.mapValue.fields.__previous_value__;
                return x(s) ? t(s) : s;
            }(t);
            return null == e ? null : this.fd(e);

          case "estimate":
            return this.wd(Q(t));

          default:
            return null;
        }
    }
    wd(t) {
        const e = X(t), s = new p(e.seconds, e.nanos);
        return this.timestampsInSnapshots ? s : s.toDate();
    }
    md(t) {
        const e = b.K(t);
        Se(Ie(e), "ReferenceValue is not valid " + t);
        const s = new ke(e.get(1), e.get(3)), i = new C(e.$(5));
        return s.isEqual(this.firestore.Id) || 
        // TODO(b/64130202): Somehow support foreign references.
        ye(`Document ${i} contains a document ` + "reference within a different database (" + `${s.projectId}/${s.database}) which is not ` + "supported. It will be treated as a reference in the current " + `database (${this.firestore.Id.projectId}/${this.firestore.Id.database}) ` + "instead."), 
        new vi(i, this.firestore, this.converter);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// settings() defaults:
const Vi = ze.sh;

/**
 * A concrete type describing all the values that can be applied via a
 * user-supplied firestore.Settings object. This is a separate type so that
 * defaults can be supplied and the value can be checked for equality.
 */
class pi {
    constructor(t) {
        var e, s;
        if (void 0 === t.host) {
            if (void 0 !== t.ssl) throw new E(m.INVALID_ARGUMENT, "Can't provide ssl option if host option is not set");
            this.host = "firestore.googleapis.com", this.ssl = !0;
        } else ss("settings", "non-empty string", "host", t.host), this.host = t.host, is("settings", "boolean", "ssl", t.ssl), 
        this.ssl = null === (e = t.ssl) || void 0 === e || e;
        if (cs("settings", t, [ "host", "ssl", "credentials", "timestampsInSnapshots", "cacheSizeBytes", "experimentalForceLongPolling" ]), 
        is("settings", "object", "credentials", t.credentials), this.credentials = t.credentials, 
        is("settings", "boolean", "timestampsInSnapshots", t.timestampsInSnapshots), 
        // Nobody should set timestampsInSnapshots anymore, but the error depends on
        // whether they set it to true or false...
        !0 === t.timestampsInSnapshots ? ye("The setting 'timestampsInSnapshots: true' is no longer required and should be removed.") : !1 === t.timestampsInSnapshots && ye("Support for 'timestampsInSnapshots: false' will be removed soon. You must update your code to handle Timestamp objects."), 
        this.timestampsInSnapshots = null === (s = t.timestampsInSnapshots) || void 0 === s || s, 
        is("settings", "number", "cacheSizeBytes", t.cacheSizeBytes), void 0 === t.cacheSizeBytes) this.cacheSizeBytes = ze.nh; else {
            if (t.cacheSizeBytes !== Vi && t.cacheSizeBytes < ze.ih) throw new E(m.INVALID_ARGUMENT, `cacheSizeBytes must be at least ${ze.ih}`);
            this.cacheSizeBytes = t.cacheSizeBytes;
        }
        is("settings", "boolean", "experimentalForceLongPolling", t.experimentalForceLongPolling), 
        this.forceLongPolling = void 0 !== t.experimentalForceLongPolling && t.experimentalForceLongPolling;
    }
    isEqual(t) {
        return this.host === t.host && this.ssl === t.ssl && this.timestampsInSnapshots === t.timestampsInSnapshots && this.credentials === t.credentials && this.cacheSizeBytes === t.cacheSizeBytes && this.forceLongPolling === t.forceLongPolling;
    }
}

/**
 * The root reference to the database.
 */ class gi {
    // Note: We are using `MemoryComponentProvider` as a default
    // ComponentProvider to ensure backwards compatibility with the format
    // expected by the console build.
    constructor(t, e, s = new Ei) {
        if (this.Ad = null, 
        // Public for use in tests.
        // TODO(mikelehen): Use modularized initialization instead.
        this.Pd = new Ge, this.INTERNAL = {
            delete: async () => {
                // The client must be initalized to ensure that all subsequent API usage
                // throws an exception.
                this.Vd(), await this.pd.terminate();
            }
        }, "object" == typeof t.options) {
            // This is very likely a Firebase app object
            // TODO(b/34177605): Can we somehow use instanceof?
            const s = t;
            this.Ad = s, this.Id = gi.gd(s), this.yd = s.name, this.bd = new A(e);
        } else {
            const e = t;
            if (!e.projectId) throw new E(m.INVALID_ARGUMENT, "Must provide projectId");
            this.Id = new ke(e.projectId, e.database), 
            // Use a default persistenceKey that lines up with FirebaseApp.
            this.yd = "[DEFAULT]", this.bd = new I;
        }
        this.vd = s, this.Sd = new pi({}), this.Cd = this.Dd(this.Id);
    }
    settings(t) {
        Ye("Firestore.settings", arguments, 1), ts("Firestore.settings", "object", 1, t);
        const e = new pi(t);
        if (this.pd && !this.Sd.isEqual(e)) throw new E(m.FAILED_PRECONDITION, "Firestore has already been started and its settings can no longer be changed. You can only call settings() before calling any other methods on a Firestore object.");
        this.Sd = e, void 0 !== e.credentials && (this.bd = function(t) {
            if (!t) return new I;
            switch (t.type) {
              case "gapi":
                const e = t.Fd;
                // Make sure this really is a Gapi client.
                                return Se(!("object" != typeof e || null === e || !e.auth || !e.auth.getAuthHeaderValueForFirstParty), "unexpected gapi interface"), 
                new V(e, t.V || "0");

              case "provider":
                return t.Fd;

              default:
                throw new E(m.INVALID_ARGUMENT, "makeCredentialsProvider failed due to invalid credential type");
            }
        }
        /**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
        // The earlist date supported by Firestore timestamps (0001-01-01T00:00:00Z).
        (e.credentials));
    }
    enableNetwork() {
        return this.Vd(), this.pd.enableNetwork();
    }
    disableNetwork() {
        return this.Vd(), this.pd.disableNetwork();
    }
    enablePersistence(t) {
        var e, s;
        if (this.pd) throw new E(m.FAILED_PRECONDITION, "Firestore has already been started and persistence can no longer be enabled. You can only call enablePersistence() before calling any other methods on a Firestore object.");
        let i = !1;
        return t && (void 0 !== t.experimentalTabSynchronization && ye("The 'experimentalTabSynchronization' setting will be removed. Use 'synchronizeTabs' instead."), 
        i = null !== (s = null !== (e = t.synchronizeTabs) && void 0 !== e ? e : t.experimentalTabSynchronization) && void 0 !== s && s), 
        this.Nd(this.vd, {
            hd: !0,
            cacheSizeBytes: this.Sd.cacheSizeBytes,
            synchronizeTabs: i
        });
    }
    async clearPersistence() {
        if (void 0 !== this.pd && !this.pd.od) throw new E(m.FAILED_PRECONDITION, "Persistence cannot be cleared after this Firestore instance is initialized.");
        const t = new We;
        return this.Pd.Mr(async () => {
            try {
                const e = this.kd();
                await this.vd.clearPersistence(e), t.resolve();
            } catch (e) {
                t.reject(e);
            }
        }), t.promise;
    }
    terminate() {
        return this.app._removeServiceInstance("firestore"), this.INTERNAL.delete();
    }
    get Ld() {
        return this.Vd(), this.pd.od;
    }
    waitForPendingWrites() {
        return this.Vd(), this.pd.waitForPendingWrites();
    }
    onSnapshotsInSync(t) {
        if (this.Vd(), Ai(t)) return this.$d(t);
        {
            ts("Firestore.onSnapshotsInSync", "function", 1, t);
            const e = {
                next: t
            };
            return this.$d(e);
        }
    }
    $d(t) {
        const e = new Ii({
            next: () => {
                t.next && t.next();
            },
            error: t => {
                throw ve("Uncaught Error in onSnapshotsInSync");
            }
        });
        return this.pd.Fl(e), () => {
            e._d(), this.pd.Nl(e);
        };
    }
    Vd() {
        return this.pd || 
        // Kick off starting the client but don't actually wait for it.
        // eslint-disable-next-line @typescript-eslint/no-floating-promises
        this.Nd(new Ei, {
            hd: !1
        }), this.pd;
    }
    kd() {
        return new Ne(this.Id, this.yd, this.Sd.host, this.Sd.ssl, this.Sd.forceLongPolling);
    }
    Nd(t, e) {
        const s = this.kd();
        return this.pd = new Ri(Ae.Ot(), s, this.bd, this.Pd), this.pd.start(t, e);
    }
    Dd(t) {
        const e = new Re(t, {
            di: Ae.Ot().di
        });
        return new $s(e, e => {
            if (e instanceof vi) {
                const s = t, i = e.firestore.Id;
                if (!i.isEqual(s)) throw new E(m.INVALID_ARGUMENT, "Document reference is for database " + `${i.projectId}/${i.database} but should be ` + `for database ${s.projectId}/${s.database}`);
                return new Ls(t, e.Od);
            }
            return e;
        });
    }
    static gd(t) {
        if (e = t.options, s = "projectId", !Object.prototype.hasOwnProperty.call(e, s)) throw new E(m.INVALID_ARGUMENT, '"projectId" not provided in firebase.initializeApp.');
        var e, s;
        // Export the classes with a private constructor (it will fail if invoked
        // at runtime). Note that this still allows instanceof checks.
        // We're treating the variables as class names, so disable checking for lower
        // case variable names.
                const i = t.options.projectId;
        if (!i || "string" != typeof i) throw new E(m.INVALID_ARGUMENT, "projectId must be a string in FirebaseApp.options");
        return new ke(i);
    }
    get app() {
        if (!this.Ad) throw new E(m.FAILED_PRECONDITION, "Firestore was not initialized using the Firebase SDK. 'app' is not available");
        return this.Ad;
    }
    collection(t) {
        return Ye("Firestore.collection", arguments, 1), ts("Firestore.collection", "non-empty string", 1, t), 
        this.Vd(), new ki(b.K(t), this);
    }
    doc(t) {
        return Ye("Firestore.doc", arguments, 1), ts("Firestore.doc", "non-empty string", 1, t), 
        this.Vd(), vi.Md(b.K(t), this);
    }
    collectionGroup(t) {
        if (Ye("Firestore.collectionGroup", arguments, 1), ts("Firestore.collectionGroup", "non-empty string", 1, t), 
        t.indexOf("/") >= 0) throw new E(m.INVALID_ARGUMENT, `Invalid collection ID '${t}' passed to function ` + "Firestore.collectionGroup(). Collection IDs must not contain '/'.");
        return this.Vd(), new Fi(new St(b.H, t), this);
    }
    runTransaction(t) {
        return Ye("Firestore.runTransaction", arguments, 1), ts("Firestore.runTransaction", "function", 1, t), 
        this.Vd().transaction(e => t(new yi(this, e)));
    }
    batch() {
        return this.Vd(), new bi(this);
    }
    static get logLevel() {
        switch (Ve()) {
          case s.DEBUG:
            return "debug";

          case s.SILENT:
            return "silent";

          default:
            // The default log level is error
            return "error";
        }
    }
    static setLogLevel(t) {
        switch (Ye("Firestore.setLogLevel", arguments, 1), ts("Firestore.setLogLevel", "non-empty string", 1, t), 
        t) {
          case "debug":
            pe(s.DEBUG);
            break;

          case "error":
            pe(s.ERROR);
            break;

          case "silent":
            pe(s.SILENT);
            break;

          default:
            throw new E(m.INVALID_ARGUMENT, "Invalid log level: " + t);
        }
    }
    // Note: this is not a property because the minifier can't work correctly with
    // the way TypeScript compiler outputs properties.
    Ud() {
        return this.Sd.timestampsInSnapshots;
    }
}

/**
 * A reference to a transaction.
 */ class yi {
    constructor(t, e) {
        this.qd = t, this.Bd = e;
    }
    get(t) {
        Ye("Transaction.get", arguments, 1);
        const e = Mi("Transaction.get", t, this.qd);
        return this.Bd.za([ e.Od ]).then(t => {
            if (!t || 1 !== t.length) return ve("Mismatch in docs returned from document lookup.");
            const s = t[0];
            if (s instanceof yt) return new Ci(this.qd, e.Od, null, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.xd);
            if (s instanceof gt) return new Ci(this.qd, e.Od, s, 
            /* fromCache= */ !1, 
            /* hasPendingWrites= */ !1, e.xd);
            throw ve(`BatchGetDocumentsRequest returned unexpected document type: ${s.constructor.name}`);
        });
    }
    set(t, e, s) {
        Ze("Transaction.set", arguments, 2, 3);
        const i = Mi("Transaction.set", t, this.qd);
        s = Li("Transaction.set", s);
        const [n, r] = qi(i.xd, e, "Transaction.set"), h = s.merge || s.mergeFields ? this.qd.Cd.zo(r, n, s.mergeFields) : this.qd.Cd.jo(r, n);
        return this.Bd.set(i.Od, h), this;
    }
    update(t, e, s, ...i) {
        let n, r;
        return "string" == typeof e || e instanceof Is ? (Xe("Transaction.update", arguments, 3), 
        n = Mi("Transaction.update", t, this.qd), r = this.qd.Cd.Yo("Transaction.update", e, s, i)) : (Ye("Transaction.update", arguments, 2), 
        n = Mi("Transaction.update", t, this.qd), r = this.qd.Cd.Ko("Transaction.update", e)), 
        this.Bd.update(n.Od, r), this;
    }
    delete(t) {
        Ye("Transaction.delete", arguments, 1);
        const e = Mi("Transaction.delete", t, this.qd);
        return this.Bd.delete(e.Od), this;
    }
}

class bi {
    constructor(t) {
        this.qd = t, this.Qd = [], this.Wd = !1;
    }
    set(t, e, s) {
        Ze("WriteBatch.set", arguments, 2, 3), this.jd();
        const i = Mi("WriteBatch.set", t, this.qd);
        s = Li("WriteBatch.set", s);
        const [n, r] = qi(i.xd, e, "WriteBatch.set"), h = s.merge || s.mergeFields ? this.qd.Cd.zo(r, n, s.mergeFields) : this.qd.Cd.jo(r, n);
        return this.Qd = this.Qd.concat(h.Lo(i.Od, wt.NONE)), this;
    }
    update(t, e, s, ...i) {
        let n, r;
        return this.jd(), "string" == typeof e || e instanceof Is ? (Xe("WriteBatch.update", arguments, 3), 
        n = Mi("WriteBatch.update", t, this.qd), r = this.qd.Cd.Yo("WriteBatch.update", e, s, i)) : (Ye("WriteBatch.update", arguments, 2), 
        n = Mi("WriteBatch.update", t, this.qd), r = this.qd.Cd.Ko("WriteBatch.update", e)), 
        this.Qd = this.Qd.concat(r.Lo(n.Od, wt.exists(!0))), this;
    }
    delete(t) {
        Ye("WriteBatch.delete", arguments, 1), this.jd();
        const e = Mi("WriteBatch.delete", t, this.qd);
        return this.Qd = this.Qd.concat(new It(e.Od, wt.NONE)), this;
    }
    commit() {
        return this.jd(), this.Wd = !0, this.Qd.length > 0 ? this.qd.Vd().write(this.Qd) : Promise.resolve();
    }
    jd() {
        if (this.Wd) throw new E(m.FAILED_PRECONDITION, "A write batch can no longer be used after commit() has been called.");
    }
}

/**
 * A reference to a particular document in a collection in the database.
 */ class vi {
    constructor(t, e, s) {
        this.Od = t, this.firestore = e, this.xd = s, this.pd = this.firestore.Vd();
    }
    static Md(t, e, s) {
        if (t.length % 2 != 0) throw new E(m.INVALID_ARGUMENT, "Invalid document reference. Document references must have an even number of segments, but " + `${t.G()} has ${t.length}`);
        return new vi(new C(t), e, s);
    }
    get id() {
        return this.Od.path.U();
    }
    get parent() {
        return new ki(this.Od.path.O(), this.firestore, this.xd);
    }
    get path() {
        return this.Od.path.G();
    }
    collection(t) {
        if (Ye("DocumentReference.collection", arguments, 1), ts("DocumentReference.collection", "non-empty string", 1, t), 
        !t) throw new E(m.INVALID_ARGUMENT, "Must provide a non-empty collection name to collection()");
        const e = b.K(t);
        return new ki(this.Od.path.child(e), this.firestore);
    }
    isEqual(t) {
        if (!(t instanceof vi)) throw ls("isEqual", "DocumentReference", 1, t);
        return this.firestore === t.firestore && this.Od.isEqual(t.Od) && this.xd === t.xd;
    }
    set(t, e) {
        Ze("DocumentReference.set", arguments, 1, 2), e = Li("DocumentReference.set", e);
        const [s, i] = qi(this.xd, t, "DocumentReference.set"), n = e.merge || e.mergeFields ? this.firestore.Cd.zo(i, s, e.mergeFields) : this.firestore.Cd.jo(i, s);
        return this.pd.write(n.Lo(this.Od, wt.NONE));
    }
    update(t, e, ...s) {
        let i;
        return "string" == typeof t || t instanceof Is ? (Xe("DocumentReference.update", arguments, 2), 
        i = this.firestore.Cd.Yo("DocumentReference.update", t, e, s)) : (Ye("DocumentReference.update", arguments, 1), 
        i = this.firestore.Cd.Ko("DocumentReference.update", t)), this.pd.write(i.Lo(this.Od, wt.exists(!0)));
    }
    delete() {
        return Ye("DocumentReference.delete", arguments, 0), this.pd.write([ new It(this.Od, wt.NONE) ]);
    }
    onSnapshot(...t) {
        Ze("DocumentReference.onSnapshot", arguments, 1, 4);
        let e, s = {
            includeMetadataChanges: !1
        }, i = 0;
        "object" != typeof t[i] || Ai(t[i]) || (s = t[i], cs("DocumentReference.onSnapshot", s, [ "includeMetadataChanges" ]), 
        is("DocumentReference.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        i++);
        const n = {
            includeMetadataChanges: s.includeMetadataChanges
        };
        return Ai(t[i]) ? e = t[i] : (ts("DocumentReference.onSnapshot", "function", i, t[i]), 
        es("DocumentReference.onSnapshot", "function", i + 1, t[i + 1]), es("DocumentReference.onSnapshot", "function", i + 2, t[i + 2]), 
        e = {
            next: t[i],
            error: t[i + 1],
            complete: t[i + 2]
        }), this.Gd(n, e);
    }
    Gd(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const i = new Ii({
            next: t => {
                if (e.next) {
                    const s = t.docs.get(this.Od);
                    e.next(new Ci(this.firestore, this.Od, s, t.fromCache, t.hasPendingWrites, this.xd));
                }
            },
            error: s
        }), n = this.pd.listen(St.ve(this.Od.path), i, t);
        return () => {
            i._d(), this.pd.$u(n);
        };
    }
    get(t) {
        return Ze("DocumentReference.get", arguments, 0, 1), Oi("DocumentReference.get", t), 
        new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.Vd().ad(this.Od).then(t => {
                e(new Ci(this.firestore, this.Od, t, 
                /*fromCache=*/ !0, t instanceof gt && t.te, this.xd));
            }, s) : this.zd(e, s, t);
        });
    }
    zd(t, e, s) {
        const i = this.Gd({
            includeMetadataChanges: !0,
            ql: !0
        }, {
            next: n => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                i(), !n.exists && n.metadata.fromCache ? 
                // TODO(dimond): If we're online and the document doesn't
                // exist then we resolve with a doc.exists set to false. If
                // we're offline however, we reject the Promise in this
                // case. Two options: 1) Cache the negative response from
                // the server so we can deliver that even when you're
                // offline 2) Actually reject the Promise in the online case
                // if the document doesn't exist.
                e(new E(m.UNAVAILABLE, "Failed to get document because the client is offline.")) : n.exists && n.metadata.fromCache && s && "server" === s.source ? e(new E(m.UNAVAILABLE, 'Failed to get document from server. (However, this document does exist in the local cache. Run again without setting source to "server" to retrieve the cached document.)')) : t(n);
            },
            error: e
        });
    }
    withConverter(t) {
        return new vi(this.Od, this.firestore, t);
    }
}

class Si {
    constructor(t, e) {
        this.hasPendingWrites = t, this.fromCache = e;
    }
    isEqual(t) {
        return this.hasPendingWrites === t.hasPendingWrites && this.fromCache === t.fromCache;
    }
}

class Ci {
    constructor(t, e, s, i, n, r) {
        this.qd = t, this.Od = e, this.Kd = s, this.Hd = i, this.Jd = n, this.xd = r;
    }
    data(t) {
        if (Ze("DocumentSnapshot.data", arguments, 0, 1), t = $i("DocumentSnapshot.data", t), 
        this.Kd) {
            // We only want to use the converter and create a new DocumentSnapshot
            // if a converter has been provided.
            if (this.xd) {
                const e = new Di(this.qd, this.Od, this.Kd, this.Hd, this.Jd);
                return this.xd.fromFirestore(e, t);
            }
            return new Pi(this.qd, this.qd.Ud(), t.serverTimestamps, 
            /* converter= */ void 0).fd(this.Kd.Re());
        }
    }
    get(t, e) {
        if (Ze("DocumentSnapshot.get", arguments, 1, 2), e = $i("DocumentSnapshot.get", e), 
        this.Kd) {
            const s = this.Kd.data().field(Us("DocumentSnapshot.get", t));
            if (null !== s) {
                return new Pi(this.qd, this.qd.Ud(), e.serverTimestamps, this.xd).fd(s);
            }
        }
    }
    get id() {
        return this.Od.path.U();
    }
    get ref() {
        return new vi(this.Od, this.qd, this.xd);
    }
    get exists() {
        return null !== this.Kd;
    }
    get metadata() {
        return new Si(this.Jd, this.Hd);
    }
    isEqual(t) {
        if (!(t instanceof Ci)) throw ls("isEqual", "DocumentSnapshot", 1, t);
        return this.qd === t.qd && this.Hd === t.Hd && this.Od.isEqual(t.Od) && (null === this.Kd ? null === t.Kd : this.Kd.isEqual(t.Kd)) && this.xd === t.xd;
    }
}

class Di extends Ci {
    data(t) {
        return super.data(t);
    }
}

class Fi {
    constructor(t, e, s) {
        this.Yd = t, this.firestore = e, this.xd = s;
    }
    where(t, e, s) {
        Ye("Query.where", arguments, 3), us("Query.where", 3, s);
        let i;
        !function(t, e, s, i) {
            if (!e.some(t => t === i)) throw new E(m.INVALID_ARGUMENT, `Invalid value ${as(i)} provided to function ` + `${t}() for its ${ds(s)} argument. Acceptable ` + `values: ${e.join(", ")}`);
        }("Query.where", [ "<", "<=", "==", ">=", ">", "array-contains", "in", "array-contains-any" ], 2, e);
        const n = Us("Query.where", t), r = Ct.K(e);
        if (n.Y()) {
            if (r === Ct.ARRAY_CONTAINS || r === Ct.ARRAY_CONTAINS_ANY) throw new E(m.INVALID_ARGUMENT, `Invalid Query. You can't perform '${r.toString()}' ` + "queries on FieldPath.documentId().");
            if (r === Ct.IN) {
                this.Xd(s, r);
                const t = [];
                for (const e of s) t.push(this.Zd(e));
                i = {
                    arrayValue: {
                        values: t
                    }
                };
            } else i = this.Zd(s);
        } else r !== Ct.IN && r !== Ct.ARRAY_CONTAINS_ANY || this.Xd(s, r), i = this.firestore.Cd.Xo("Query.where", s, 
        // We only allow nested arrays for IN queries.
        /** allowArrays = */ r === Ct.IN);
        const h = Dt.create(n, r, i);
        return this.tf(h), new Fi(this.Yd.De(h), this.firestore, this.xd);
    }
    orderBy(t, e) {
        let s;
        if (Ze("Query.orderBy", arguments, 1, 2), es("Query.orderBy", "non-empty string", 2, e), 
        void 0 === e || "asc" === e) s = Ot.ASCENDING; else {
            if ("desc" !== e) throw new E(m.INVALID_ARGUMENT, `Function Query.orderBy() has unknown direction '${e}', ` + "expected 'asc' or 'desc'.");
            s = Ot.DESCENDING;
        }
        if (null !== this.Yd.startAt) throw new E(m.INVALID_ARGUMENT, "Invalid query. You must not call Query.startAt() or Query.startAfter() before calling Query.orderBy().");
        if (null !== this.Yd.endAt) throw new E(m.INVALID_ARGUMENT, "Invalid query. You must not call Query.endAt() or Query.endBefore() before calling Query.orderBy().");
        const i = Us("Query.orderBy", t), n = new Ut(i, s);
        return this.ef(n), new Fi(this.Yd.Fe(n), this.firestore, this.xd);
    }
    limit(t) {
        return Ye("Query.limit", arguments, 1), ts("Query.limit", "number", 1, t), _s("Query.limit", 1, t), 
        new Fi(this.Yd.Ne(t), this.firestore, this.xd);
    }
    limitToLast(t) {
        return Ye("Query.limitToLast", arguments, 1), ts("Query.limitToLast", "number", 1, t), 
        _s("Query.limitToLast", 1, t), new Fi(this.Yd.ke(t), this.firestore, this.xd);
    }
    startAt(t, ...e) {
        Xe("Query.startAt", arguments, 1);
        const s = this.sf("Query.startAt", t, e, 
        /*before=*/ !0);
        return new Fi(this.Yd.Le(s), this.firestore, this.xd);
    }
    startAfter(t, ...e) {
        Xe("Query.startAfter", arguments, 1);
        const s = this.sf("Query.startAfter", t, e, 
        /*before=*/ !1);
        return new Fi(this.Yd.Le(s), this.firestore, this.xd);
    }
    endBefore(t, ...e) {
        Xe("Query.endBefore", arguments, 1);
        const s = this.sf("Query.endBefore", t, e, 
        /*before=*/ !0);
        return new Fi(this.Yd.$e(s), this.firestore, this.xd);
    }
    endAt(t, ...e) {
        Xe("Query.endAt", arguments, 1);
        const s = this.sf("Query.endAt", t, e, 
        /*before=*/ !1);
        return new Fi(this.Yd.$e(s), this.firestore, this.xd);
    }
    isEqual(t) {
        if (!(t instanceof Fi)) throw ls("isEqual", "Query", 1, t);
        return this.firestore === t.firestore && this.Yd.isEqual(t.Yd);
    }
    withConverter(t) {
        return new Fi(this.Yd, this.firestore, t);
    }
    /** Helper function to create a bound from a document or fields */    sf(t, e, s, i) {
        if (us(t, 1, e), e instanceof Ci) {
            if (s.length > 0) throw new E(m.INVALID_ARGUMENT, `Too many arguments provided to ${t}().`);
            const n = e;
            if (!n.exists) throw new E(m.NOT_FOUND, "Can't use a DocumentSnapshot that doesn't exist for " + `${t}().`);
            return this.if(n.Kd, i);
        }
        {
            const n = [ e ].concat(s);
            return this.nf(t, n, i);
        }
    }
    /**
     * Create a Bound from a query and a document.
     *
     * Note that the Bound will always include the key of the document
     * and so only the provided document will compare equal to the returned
     * position.
     *
     * Will throw if the document does not contain all fields of the order by
     * of the query or if any of the fields in the order by are an uncommitted
     * server timestamp.
     */    if(t, e) {
        const s = [];
        // Because people expect to continue/end a query at the exact document
        // provided, we need to use the implicit sort order rather than the explicit
        // sort order, because it's guaranteed to contain the document key. That way
        // the position becomes unambiguous and the query continues/ends exactly at
        // the provided document. Without the key (by using the explicit sort
        // orders), multiple documents could match the position, yielding duplicate
        // results.
                for (const e of this.Yd.orderBy) if (e.field.Y()) s.push(et(this.firestore.Id, t.key)); else {
            const i = t.field(e.field);
            if (x(i)) throw new E(m.INVALID_ARGUMENT, 'Invalid query. You are trying to start or end a query using a document for which the field "' + e.field + '" is an uncommitted server timestamp. (Since the value of this field is unknown, you cannot start/end a query with it.)');
            if (null === i) {
                const t = e.field.G();
                throw new E(m.INVALID_ARGUMENT, "Invalid query. You are trying to start or end a query using a " + `document for which the field '${t}' (used as the ` + "orderBy) does not exist.");
            }
            s.push(i);
        }
        return new Mt(s, e);
    }
    /**
     * Converts a list of field values to a Bound for the given query.
     */    nf(t, e, s) {
        // Use explicit order by's because it has to match the query the user made
        const i = this.Yd.Ve;
        if (e.length > i.length) throw new E(m.INVALID_ARGUMENT, `Too many arguments provided to ${t}(). ` + "The number of arguments must be less than or equal to the number of Query.orderBy() clauses");
        const n = [];
        for (let s = 0; s < e.length; s++) {
            const r = e[s];
            if (i[s].field.Y()) {
                if ("string" != typeof r) throw new E(m.INVALID_ARGUMENT, "Invalid query. Expected a string for document ID in " + `${t}(), but got a ${typeof r}`);
                if (!this.Yd.He() && -1 !== r.indexOf("/")) throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying a collection and ordering by FieldPath.documentId(), " + `the value passed to ${t}() must be a plain document ID, but ` + `'${r}' contains a slash.`);
                const e = this.Yd.path.child(b.K(r));
                if (!C.st(e)) throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying a collection group and ordering by " + `FieldPath.documentId(), the value passed to ${t}() must result in a ` + `valid document path, but '${e}' is not because it contains an odd number ` + "of segments.");
                const s = new C(e);
                n.push(et(this.firestore.Id, s));
            } else {
                const e = this.firestore.Cd.Xo(t, r);
                n.push(e);
            }
        }
        return new Mt(n, s);
    }
    onSnapshot(...t) {
        Ze("Query.onSnapshot", arguments, 1, 4);
        let e, s = {}, i = 0;
        return "object" != typeof t[i] || Ai(t[i]) || (s = t[i], cs("Query.onSnapshot", s, [ "includeMetadataChanges" ]), 
        is("Query.onSnapshot", "boolean", "includeMetadataChanges", s.includeMetadataChanges), 
        i++), Ai(t[i]) ? e = t[i] : (ts("Query.onSnapshot", "function", i, t[i]), es("Query.onSnapshot", "function", i + 1, t[i + 1]), 
        es("Query.onSnapshot", "function", i + 2, t[i + 2]), e = {
            next: t[i],
            error: t[i + 1],
            complete: t[i + 2]
        }), this.rf(this.Yd), this.Gd(s, e);
    }
    Gd(t, e) {
        let s = t => {
            console.error("Uncaught Error in onSnapshot:", t);
        };
        e.error && (s = e.error.bind(e));
        const i = new Ii({
            next: t => {
                e.next && e.next(new Ni(this.firestore, this.Yd, t, this.xd));
            },
            error: s
        }), n = this.firestore.Vd(), r = n.listen(this.Yd, i, t);
        return () => {
            i._d(), n.$u(r);
        };
    }
    rf(t) {
        if (t.Ge() && 0 === t.Ve.length) throw new E(m.UNIMPLEMENTED, "limitToLast() queries require specifying at least one orderBy() clause");
    }
    get(t) {
        return Ze("Query.get", arguments, 0, 1), Oi("Query.get", t), this.rf(this.Yd), new Promise((e, s) => {
            t && "cache" === t.source ? this.firestore.Vd().ud(this.Yd).then(t => {
                e(new Ni(this.firestore, this.Yd, t, this.xd));
            }, s) : this.zd(e, s, t);
        });
    }
    zd(t, e, s) {
        const i = this.Gd({
            includeMetadataChanges: !0,
            ql: !0
        }, {
            next: n => {
                // Remove query first before passing event to user to avoid
                // user actions affecting the now stale query.
                i(), n.metadata.fromCache && s && "server" === s.source ? e(new E(m.UNAVAILABLE, 'Failed to get documents from server. (However, these documents may exist in the local cache. Run again without setting source to "server" to retrieve the cached documents.)')) : t(n);
            },
            error: e
        });
    }
    /**
     * Parses the given documentIdValue into a ReferenceValue, throwing
     * appropriate errors if the value is anything other than a DocumentReference
     * or String, or if the string is malformed.
     */    Zd(t) {
        if ("string" == typeof t) {
            if ("" === t) throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid document ID, but it was an empty string.");
            if (!this.Yd.He() && -1 !== t.indexOf("/")) throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying a collection by FieldPath.documentId(), you must provide a plain document ID, but " + `'${t}' contains a '/' character.`);
            const e = this.Yd.path.child(b.K(t));
            if (!C.st(e)) throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying a collection group by FieldPath.documentId(), the value provided must result in a valid document path, " + `but '${e}' is not because it has an odd number of segments (${e.length}).`);
            return et(this.firestore.Id, new C(e));
        }
        if (t instanceof vi) {
            const e = t;
            return et(this.firestore.Id, e.Od);
        }
        throw new E(m.INVALID_ARGUMENT, "Invalid query. When querying with FieldPath.documentId(), you must provide a valid string or a DocumentReference, but it was: " + `${as(t)}.`);
    }
    /**
     * Validates that the value passed into a disjunctrive filter satisfies all
     * array requirements.
     */    Xd(t, e) {
        if (!Array.isArray(t) || 0 === t.length) throw new E(m.INVALID_ARGUMENT, "Invalid Query. A non-empty array is required for " + `'${e.toString()}' filters.`);
        if (t.length > 10) throw new E(m.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters support a ` + "maximum of 10 elements in the value array.");
        if (t.indexOf(null) >= 0) throw new E(m.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'null' ` + "in the value array.");
        if (t.filter(t => Number.isNaN(t)).length > 0) throw new E(m.INVALID_ARGUMENT, `Invalid Query. '${e.toString()}' filters cannot contain 'NaN' ` + "in the value array.");
    }
    tf(t) {
        if (t instanceof Dt) {
            const e = [ Ct.ARRAY_CONTAINS, Ct.ARRAY_CONTAINS_ANY ], s = [ Ct.IN, Ct.ARRAY_CONTAINS_ANY ], i = e.indexOf(t.op) >= 0, n = s.indexOf(t.op) >= 0;
            if (t.ze()) {
                const e = this.Yd.Se();
                if (null !== e && !e.isEqual(t.field)) throw new E(m.INVALID_ARGUMENT, "Invalid query. All where filters with an inequality (<, <=, >, or >=) must be on the same field. But you have" + ` inequality filters on '${e.toString()}'` + ` and '${t.field.toString()}'`);
                const s = this.Yd.Ce();
                null !== s && this.hf(t.field, s);
            } else if (n || i) {
                // You can have at most 1 disjunctive filter and 1 array filter. Check if
                // the new filter conflicts with an existing one.
                let r = null;
                if (n && (r = this.Yd.Ke(s)), null === r && i && (r = this.Yd.Ke(e)), null != r) 
                // We special case when it's a duplicate op to give a slightly clearer error message.
                throw r === t.op ? new E(m.INVALID_ARGUMENT, "Invalid query. You cannot use more than one " + `'${t.op.toString()}' filter.`) : new E(m.INVALID_ARGUMENT, `Invalid query. You cannot use '${t.op.toString()}' filters ` + `with '${r.toString()}' filters.`);
            }
        }
    }
    ef(t) {
        if (null === this.Yd.Ce()) {
            // This is the first order by. It must match any inequality.
            const e = this.Yd.Se();
            null !== e && this.hf(e, t.field);
        }
    }
    hf(t, e) {
        if (!e.isEqual(t)) throw new E(m.INVALID_ARGUMENT, "Invalid query. You have a where filter with an inequality " + `(<, <=, >, or >=) on field '${t.toString()}' ` + `and so you must also use '${t.toString()}' ` + "as your first Query.orderBy(), but your first Query.orderBy() " + `is on field '${e.toString()}' instead.`);
    }
}

class Ni {
    constructor(t, e, s, i) {
        this.qd = t, this.af = e, this.uf = s, this.xd = i, this.cf = null, this.lf = null, 
        this.metadata = new Si(s.hasPendingWrites, s.fromCache);
    }
    get docs() {
        const t = [];
        return this.forEach(e => t.push(e)), t;
    }
    get empty() {
        return this.uf.docs.q();
    }
    get size() {
        return this.uf.docs.size;
    }
    forEach(t, e) {
        Ze("QuerySnapshot.forEach", arguments, 1, 2), ts("QuerySnapshot.forEach", "function", 1, t), 
        this.uf.docs.forEach(s => {
            t.call(e, this._f(s));
        });
    }
    get query() {
        return new Fi(this.af, this.qd, this.xd);
    }
    docChanges(t) {
        t && (cs("QuerySnapshot.docChanges", t, [ "includeMetadataChanges" ]), is("QuerySnapshot.docChanges", "boolean", "includeMetadataChanges", t.includeMetadataChanges));
        const e = !(!t || !t.includeMetadataChanges);
        if (e && this.uf.ds) throw new E(m.INVALID_ARGUMENT, "To include metadata changes with your document changes, you must also pass { includeMetadataChanges:true } to onSnapshot().");
        return this.cf && this.lf === e || (this.cf = 
        /**
 * Calculates the array of firestore.DocumentChange's for a given ViewSnapshot.
 *
 * Exported for testing.
 */
        function(t, e, s, i) {
            if (s.cs.q()) {
                // Special case the first snapshot because index calculation is easy and
                // fast
                let e, n = 0;
                return s.docChanges.map(r => {
                    const h = new Di(t, r.doc.key, r.doc, s.fromCache, s.ls.has(r.doc.key), i);
                    return e = r.doc, {
                        type: "added",
                        doc: h,
                        oldIndex: -1,
                        newIndex: n++
                    };
                });
            }
            {
                // A DocumentSet that is updated incrementally as changes are applied to use
                // to lookup the index of a document.
                let n = s.cs;
                return s.docChanges.filter(t => e || 3 /* Metadata */ !== t.type).map(e => {
                    const r = new Di(t, e.doc.key, e.doc, s.fromCache, s.ls.has(e.doc.key), i);
                    let h = -1, o = -1;
                    return 0 /* Added */ !== e.type && (h = n.indexOf(e.doc.key), n = n.delete(e.doc.key)), 
                    1 /* Removed */ !== e.type && (n = n.add(e.doc), o = n.indexOf(e.doc.key)), {
                        type: Ui(e.type),
                        doc: r,
                        oldIndex: h,
                        newIndex: o
                    };
                });
            }
        }(this.qd, e, this.uf, this.xd), this.lf = e), this.cf;
    }
    /** Check the equality. The call can be very expensive. */    isEqual(t) {
        if (!(t instanceof Ni)) throw ls("isEqual", "QuerySnapshot", 1, t);
        return this.qd === t.qd && this.af.isEqual(t.af) && this.uf.isEqual(t.uf) && this.xd === t.xd;
    }
    _f(t) {
        return new Di(this.qd, t.key, t, this.metadata.fromCache, this.uf.ls.has(t.key), this.xd);
    }
}

class ki extends Fi {
    constructor(t, e, s) {
        if (super(St.ve(t), e, s), this.df = t, t.length % 2 != 1) throw new E(m.INVALID_ARGUMENT, "Invalid collection reference. Collection references must have an odd number of segments, but " + `${t.G()} has ${t.length}`);
    }
    get id() {
        return this.Yd.path.U();
    }
    get parent() {
        const t = this.Yd.path.O();
        return t.q() ? null : new vi(new C(t), this.firestore);
    }
    get path() {
        return this.Yd.path.G();
    }
    doc(t) {
        if (Ze("CollectionReference.doc", arguments, 0, 1), 
        // We allow omission of 'pathString' but explicitly prohibit passing in both
        // 'undefined' and 'null'.
        0 === arguments.length && (t = Ce.Tn()), ts("CollectionReference.doc", "non-empty string", 1, t), 
        "" === t) throw new E(m.INVALID_ARGUMENT, "Document path must be a non-empty string");
        const e = b.K(t);
        return vi.Md(this.Yd.path.child(e), this.firestore, this.xd);
    }
    add(t) {
        Ye("CollectionReference.add", arguments, 1), ts("CollectionReference.add", "object", 1, this.xd ? this.xd.toFirestore(t) : t);
        const e = this.doc();
        return e.set(t).then(() => e);
    }
    withConverter(t) {
        return new ki(this.df, this.firestore, t);
    }
}

function Li(t, e) {
    if (void 0 === e) return {
        merge: !1
    };
    if (cs(t, e, [ "merge", "mergeFields" ]), is(t, "boolean", "merge", e.merge), ns(t, "mergeFields", "a string or a FieldPath", e.mergeFields, t => "string" == typeof t || t instanceof Is), 
    void 0 !== e.mergeFields && void 0 !== e.merge) throw new E(m.INVALID_ARGUMENT, `Invalid options passed to function ${t}(): You cannot specify both "merge" ` + 'and "mergeFields".');
    return e;
}

function $i(t, e) {
    return void 0 === e ? {} : (cs(t, e, [ "serverTimestamps" ]), rs(t, 0, "serverTimestamps", e.serverTimestamps, [ "estimate", "previous", "none" ]), 
    e);
}

function Oi(t, e) {
    es(t, "object", 1, e), e && (cs(t, e, [ "source" ]), rs(t, 0, "source", e.source, [ "default", "server", "cache" ]));
}

function Mi(t, e, s) {
    if (e instanceof vi) {
        if (e.firestore !== s) throw new E(m.INVALID_ARGUMENT, "Provided document reference is from a different Firestore instance.");
        return e;
    }
    throw ls(t, "DocumentReference", 1, e);
}

function Ui(t) {
    switch (t) {
      case 0 /* Added */ :
        return "added";

      case 2 /* Modified */ :
      case 3 /* Metadata */ :
        return "modified";

      case 1 /* Removed */ :
        return "removed";

      default:
        return ve("Unknown change type: " + t);
    }
}

/**
 * Converts custom model object of type T into DocumentData by applying the
 * converter if it exists.
 *
 * This function is used when converting user objects to DocumentData
 * because we want to provide the user with a more specific error message if
 * their set() or fails due to invalid data originating from a toFirestore()
 * call.
 */ function qi(t, e, s) {
    let i;
    return t ? (i = t.toFirestore(e), s = "toFirestore() in " + s) : i = e, [ i, s ];
}

const Bi = ws(gi, "Use firebase.firestore() instead."), xi = ws(yi, "Use firebase.firestore().runTransaction() instead."), Qi = ws(bi, "Use firebase.firestore().batch() instead."), Wi = ws(vi, "Use firebase.firestore().doc() instead."), ji = ws(Ci), Gi = ws(Di), zi = ws(Fi), Ki = ws(Ni), Hi = ws(ki, "Use firebase.firestore().collection() instead."), Ji = {
    Firestore: Bi,
    GeoPoint: Ss,
    Timestamp: p,
    Blob: Rs,
    Transaction: xi,
    WriteBatch: Qi,
    DocumentReference: Wi,
    DocumentSnapshot: ji,
    Query: zi,
    QueryDocumentSnapshot: Gi,
    QuerySnapshot: Ki,
    CollectionReference: Hi,
    FieldPath: Is,
    FieldValue: vs,
    setLogLevel: gi.setLogLevel,
    CACHE_SIZE_UNLIMITED: Vi
};

/**
 * @license
 * Copyright 2019 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Yi {
    mu(t) {
        // No-op.
    }
    ku() {
        // No-op.
    }
}

/**
 * @license
 * Copyright 2019 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Browser implementation of ConnectivityMonitor.
 */
class Xi {
    constructor() {
        this.ff = () => this.wf(), this.Tf = () => this.mf(), this.Ef = [], this.Rf();
    }
    mu(t) {
        this.Ef.push(t);
    }
    ku() {
        window.removeEventListener("online", this.ff), window.removeEventListener("offline", this.Tf);
    }
    Rf() {
        window.addEventListener("online", this.ff), window.addEventListener("offline", this.Tf);
    }
    wf() {
        ge("ConnectivityMonitor", "Network connectivity changed: AVAILABLE");
        for (const t of this.Ef) t(0 /* AVAILABLE */);
    }
    mf() {
        ge("ConnectivityMonitor", "Network connectivity changed: UNAVAILABLE");
        for (const t of this.Ef) t(1 /* UNAVAILABLE */);
    }
    // TODO(chenbrian): Consider passing in window either into this component or
    // here for testing via FakeWindow.
    /** Checks that all used attributes of window are available. */
    static If() {
        return "undefined" != typeof window && void 0 !== window.addEventListener && void 0 !== window.removeEventListener;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Provides a simple helper class that implements the Stream interface to
 * bridge to other implementations that are streams but do not implement the
 * interface. The stream callbacks are invoked with the callOn... methods.
 */ class Zi {
    constructor(t) {
        this.Af = t.Af, this.Pf = t.Pf;
    }
    Na(t) {
        this.Vf = t;
    }
    va(t) {
        this.pf = t;
    }
    onMessage(t) {
        this.gf = t;
    }
    close() {
        this.Pf();
    }
    send(t) {
        this.Af(t);
    }
    yf() {
        this.Vf();
    }
    bf(t) {
        this.pf(t);
    }
    vf(t) {
        this.gf(t);
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ const tn = {
    BatchGetDocuments: "batchGet",
    Commit: "commit"
}, en = "gl-js/ fire/" + w;

class sn {
    constructor(t) {
        this.ci = t.ci;
        const e = t.ssl ? "https" : "http";
        this.Sf = e + "://" + t.host, this.forceLongPolling = t.forceLongPolling;
    }
    /**
     * Modifies the headers for a request, adding any authorization token if
     * present and any additional headers for the request.
     */    Cf(t, e) {
        if (e) for (const s in e.o) e.o.hasOwnProperty(s) && (t[s] = e.o[s]);
        t["X-Goog-Api-Client"] = en;
    }
    Ga(t, e, s) {
        const i = this.Df(t);
        return new Promise((n, r) => {
            const h = new c;
            h.listenOnce(l.COMPLETE, () => {
                try {
                    switch (h.getLastErrorCode()) {
                      case _.NO_ERROR:
                        const e = h.getResponseJson();
                        ge("Connection", "XHR received:", JSON.stringify(e)), n(e);
                        break;

                      case _.TIMEOUT:
                        ge("Connection", 'RPC "' + t + '" timed out'), r(new E(m.DEADLINE_EXCEEDED, "Request time out"));
                        break;

                      case _.HTTP_ERROR:
                        const s = h.getStatus();
                        if (ge("Connection", 'RPC "' + t + '" failed with status:', s, "response text:", h.getResponseText()), 
                        s > 0) {
                            const t = h.getResponseJson().error;
                            if (t && t.status && t.message) {
                                const e = function(t) {
                                    const e = t.toLowerCase().replace("_", "-");
                                    return Object.values(m).indexOf(e) >= 0 ? e : m.UNKNOWN;
                                }(t.status);
                                r(new E(e, t.message));
                            } else r(new E(m.UNKNOWN, "Server responded with status " + h.getStatus()));
                        } else 
                        // If we received an HTTP_ERROR but there's no status code,
                        // it's most probably a connection issue
                        ge("Connection", 'RPC "' + t + '" failed'), r(new E(m.UNAVAILABLE, "Connection failed."));
                        break;

                      default:
                        ve('RPC "' + t + '" failed with unanticipated webchannel error ' + h.getLastErrorCode() + ": " + h.getLastError() + ", giving up.");
                    }
                } finally {
                    ge("Connection", 'RPC "' + t + '" completed.');
                }
            });
            // The database field is already encoded in URL. Specifying it again in
            // the body is not necessary in production, and will cause duplicate field
            // errors in the Firestore Emulator. Let's remove it.
            const o = Object.assign({}, e);
            delete o.database;
            const a = JSON.stringify(o);
            ge("Connection", "XHR sending: ", i + " " + a);
            // Content-Type: text/plain will avoid preflight requests which might
            // mess with CORS and redirects by proxies. If we add custom headers
            // we will need to change this code to potentially use the
            // $httpOverwrite parameter supported by ESF to avoid
            // triggering preflight requests.
            const u = {
                "Content-Type": "text/plain"
            };
            this.Cf(u, s), h.send(i, "POST", a, u, 15);
        });
    }
    Ka(t, e, s) {
        // The REST API automatically aggregates all of the streamed results, so we
        // can just use the normal invoke() method.
        return this.Ga(t, e, s);
    }
    ka(t, e) {
        const s = [ this.Sf, "/", "google.firestore.v1.Firestore", "/", t, "/channel" ], u = d(), c = {
            // Required for backend stickiness, routing behavior is based on this
            // parameter.
            httpSessionIdParam: "gsessionid",
            initMessageHeaders: {},
            messageUrlParams: {
                // This param is used to improve routing and project isolation by the
                // backend and must be included in every request.
                database: `projects/${this.ci.projectId}/databases/${this.ci.database}`
            },
            sendRawJson: !0,
            supportsCrossDomainXhr: !0,
            internalChannelParams: {
                // Override the default timeout (randomized between 10-20 seconds) since
                // a large write batch on a slow internet connection may take a long
                // time to send to the backend. Rather than have WebChannel impose a
                // tight timeout which could lead to infinite timeouts and retries, we
                // set it very large (5-10 minutes) and rely on the browser's builtin
                // timeouts to kick in if the request isn't working.
                forwardChannelRequestTimeoutMs: 6e5
            },
            forceLongPolling: this.forceLongPolling
        };
        this.Cf(c.initMessageHeaders, e), 
        // Sending the custom headers we just added to request.initMessageHeaders
        // (Authorization, etc.) will trigger the browser to make a CORS preflight
        // request because the XHR will no longer meet the criteria for a "simple"
        // CORS request:
        // https://developer.mozilla.org/en-US/docs/Web/HTTP/CORS#Simple_requests
        // Therefore to avoid the CORS preflight request (an extra network
        // roundtrip), we use the httpHeadersOverwriteParam option to specify that
        // the headers should instead be encoded into a special "$httpHeaders" query
        // parameter, which is recognized by the webchannel backend. This is
        // formally defined here:
        // https://github.com/google/closure-library/blob/b0e1815b13fb92a46d7c9b3c30de5d6a396a3245/closure/goog/net/rpc/httpcors.js#L32
        // TODO(b/145624756): There is a backend bug where $httpHeaders isn't respected if the request
        // doesn't have an Origin header. So we have to exclude a few browser environments that are
        // known to (sometimes) not include an Origin. See
        // https://github.com/firebase/firebase-js-sdk/issues/1491.
        i() || n() || r() || h() || o() || a() || (c.httpHeadersOverwriteParam = "$httpHeaders");
        const l = s.join("");
        ge("Connection", "Creating WebChannel: " + l + " " + c);
        const _ = u.createWebChannel(l, c);
        // WebChannel supports sending the first message with the handshake - saving
        // a network round trip. However, it will have to call send in the same
        // JS event loop as open. In order to enforce this, we delay actually
        // opening the WebChannel until send is called. Whether we have called
        // open is tracked with this variable.
                let w = !1, T = !1;
        // A flag to determine whether the stream was closed (by us or through an
        // error/close event) to avoid delivering multiple close events or sending
        // on a closed stream
                const R = new Zi({
            Af: t => {
                T ? ge("Connection", "Not sending because WebChannel is closed:", t) : (w || (ge("Connection", "Opening WebChannel transport."), 
                _.open(), w = !0), ge("Connection", "WebChannel sending:", t), _.send(t));
            },
            Pf: () => _.close()
        }), I = (t, e) => {
            // TODO(dimond): closure typing seems broken because WebChannel does
            // not implement goog.events.Listenable
            _.listen(t, t => {
                try {
                    e(t);
                } catch (t) {
                    setTimeout(() => {
                        throw t;
                    }, 0);
                }
            });
        };
        // Closure events are guarded and exceptions are swallowed, so catch any
        // exception and rethrow using a setTimeout so they become visible again.
        // Note that eventually this function could go away if we are confident
        // enough the code is exception free.
                return I(f.EventType.OPEN, () => {
            T || ge("Connection", "WebChannel transport opened.");
        }), I(f.EventType.CLOSE, () => {
            T || (T = !0, ge("Connection", "WebChannel transport closed"), R.bf());
        }), I(f.EventType.ERROR, t => {
            T || (T = !0, ge("Connection", "WebChannel transport errored:", t), R.bf(new E(m.UNAVAILABLE, "The operation could not be completed")));
        }), I(f.EventType.MESSAGE, t => {
            var e;
            if (!T) {
                const s = t.data[0];
                Se(!!s, "Got a webchannel message without data.");
                // TODO(b/35143891): There is a bug in One Platform that caused errors
                // (and only errors) to be wrapped in an extra array. To be forward
                // compatible with the bug we need to check either condition. The latter
                // can be removed once the fix has been rolled out.
                // Use any because msgData.error is not typed.
                const i = s, n = i.error || (null === (e = i[0]) || void 0 === e ? void 0 : e.error);
                if (n) {
                    ge("Connection", "WebChannel received error:", n);
                    // error.status will be a string like 'OK' or 'NOT_FOUND'.
                    const t = n.status;
                    let e = function(t) {
                        // lookup by string
                        // eslint-disable-next-line @typescript-eslint/no-explicit-any
                        const e = Wt[t];
                        if (void 0 !== e) return zt(e);
                    }(t), s = n.message;
                    void 0 === e && (e = m.INTERNAL, s = "Unknown error status: " + t + " with message " + n.message), 
                    // Mark closed so no further events are propagated
                    T = !0, R.bf(new E(e, s)), _.close();
                } else ge("Connection", "WebChannel received:", s), R.vf(s);
            }
        }), setTimeout(() => {
            // Technically we could/should wait for the WebChannel opened event,
            // but because we want to send the first message with the WebChannel
            // handshake we pretend the channel opened here (asynchronously), and
            // then delay the actual open until the first message is sent.
            R.yf();
        }, 0), R;
    }
    // visible for testing
    Df(t) {
        const e = tn[t];
        return this.Sf + "/v1/projects/" + this.ci.projectId + "/databases/" + this.ci.database + "/documents:" + e;
    }
}

/**
 * @license
 * Copyright 2017 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * @license
 * Copyright 2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * This code needs to run before Firestore is used. This can be achieved in
 * several ways:
 *   1) Through the JSCompiler compiling this code and then (automatically)
 *      executing it before exporting the Firestore symbols.
 *   2) Through importing this module first in a Firestore main module
 */
Ae.fn(new class {
    constructor() {
        this.di = !0, this.yo = "undefined" != typeof atob;
    }
    get document() {
        return "undefined" != typeof document ? document : null;
    }
    get window() {
        return "undefined" != typeof window ? window : null;
    }
    td(t) {
        return Promise.resolve(new sn(t));
    }
    J_() {
        return Xi.If() ? new Xi : new Yi;
    }
    ed(t) {
        return new Re(t, {
            di: !0
        });
    }
    wn(t) {
        return JSON.stringify(t);
    }
    atob(t) {
        return atob(t);
    }
    btoa(t) {
        return btoa(t);
    }
});

/**
 * @license
 * Copyright 2020 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Registers the memory-only Firestore build with the components framework.
 */
function nn(t) {
    !
    /**
 * Configures Firestore as part of the Firebase SDK by calling registerService.
 *
 * @param firebase The FirebaseNamespace to register Firestore with
 * @param firestoreFactory A factory function that returns a new Firestore
 *    instance.
 */
    function(t, e) {
        t.INTERNAL.registerComponent(new u("firestore", t => {
            const s = t.getProvider("app").getImmediate();
            return e(s, t.getProvider("auth-internal"));
        }, "PUBLIC" /* PUBLIC */).setServiceProps(Object.assign({}, Ji)));
    }(t, (t, e) => new gi(t, e, new Ei)), t.registerVersion("@firebase/firestore", "1.14.1");
}

nn(t);

export { nn as __PRIVATE_registerFirestore };
//# sourceMappingURL=index.memory.esm2017.js.map
